import { defineComponent as Pt, shallowRef as il, inject as op, computed as lp, toRaw as X0, onMounted as xh, watch as mt, onBeforeUnmount as D0, h as L0, ref as Se, openBlock as fe, createElementBlock as Ae, createElementVNode as D, renderSlot as cr, unref as xr, createBlock as ei, withCtx as Rt, createTextVNode as Wr, withDirectives as sn, Fragment as Bn, renderList as Vn, toDisplayString as wi, vModelSelect as I0, vModelText as wn, render as Gt, normalizeClass as Es, createVNode as Sn, mergeModels as Gs, useModel as wh, nextTick as _0, provide as q0, onBeforeMount as W0, isRef as Eu, createCommentVNode as zu, Teleport as B0 } from "vue";
class le {
  /**
  Get the line description around the given position.
  */
  lineAt(e) {
    if (e < 0 || e > this.length)
      throw new RangeError(`Invalid position ${e} in document of length ${this.length}`);
    return this.lineInner(e, !1, 1, 0);
  }
  /**
  Get the description for the given (1-based) line number.
  */
  line(e) {
    if (e < 1 || e > this.lines)
      throw new RangeError(`Invalid line number ${e} in ${this.lines}-line document`);
    return this.lineInner(e, !0, 1, 0);
  }
  /**
  Replace a range of the text with the given content.
  */
  replace(e, t, i) {
    [e, t] = Si(this, e, t);
    let r = [];
    return this.decompose(
      0,
      e,
      r,
      2
      /* Open.To */
    ), i.length && i.decompose(
      0,
      i.length,
      r,
      3
      /* Open.To */
    ), this.decompose(
      t,
      this.length,
      r,
      1
      /* Open.From */
    ), Bt.from(r, this.length - (t - e) + i.length);
  }
  /**
  Append another document to this one.
  */
  append(e) {
    return this.replace(this.length, this.length, e);
  }
  /**
  Retrieve the text between the given points.
  */
  slice(e, t = this.length) {
    [e, t] = Si(this, e, t);
    let i = [];
    return this.decompose(e, t, i, 0), Bt.from(i, t - e);
  }
  /**
  Test whether this text is equal to another instance.
  */
  eq(e) {
    if (e == this)
      return !0;
    if (e.length != this.length || e.lines != this.lines)
      return !1;
    let t = this.scanIdentical(e, 1), i = this.length - this.scanIdentical(e, -1), r = new fr(this), s = new fr(e);
    for (let o = t, l = t; ; ) {
      if (r.next(o), s.next(o), o = 0, r.lineBreak != s.lineBreak || r.done != s.done || r.value != s.value)
        return !1;
      if (l += r.value.length, r.done || l >= i)
        return !0;
    }
  }
  /**
  Iterate over the text. When `dir` is `-1`, iteration happens
  from end to start. This will return lines and the breaks between
  them as separate strings.
  */
  iter(e = 1) {
    return new fr(this, e);
  }
  /**
  Iterate over a range of the text. When `from` > `to`, the
  iterator will run in reverse.
  */
  iterRange(e, t = this.length) {
    return new ap(this, e, t);
  }
  /**
  Return a cursor that iterates over the given range of lines,
  _without_ returning the line breaks between, and yielding empty
  strings for empty lines.
  
  When `from` and `to` are given, they should be 1-based line numbers.
  */
  iterLines(e, t) {
    let i;
    if (e == null)
      i = this.iter();
    else {
      t == null && (t = this.lines + 1);
      let r = this.line(e).from;
      i = this.iterRange(r, Math.max(r, t == this.lines + 1 ? this.length : t <= 1 ? 0 : this.line(t - 1).to));
    }
    return new hp(i);
  }
  /**
  Return the document as a string, using newline characters to
  separate lines.
  */
  toString() {
    return this.sliceString(0);
  }
  /**
  Convert the document to an array of lines (which can be
  deserialized again via [`Text.of`](https://codemirror.net/6/docs/ref/#state.Text^of)).
  */
  toJSON() {
    let e = [];
    return this.flatten(e), e;
  }
  /**
  @internal
  */
  constructor() {
  }
  /**
  Create a `Text` instance for the given array of lines.
  */
  static of(e) {
    if (e.length == 0)
      throw new RangeError("A document must have at least one line");
    return e.length == 1 && !e[0] ? le.empty : e.length <= 32 ? new Pe(e) : Bt.from(Pe.split(e, []));
  }
}
class Pe extends le {
  constructor(e, t = V0(e)) {
    super(), this.text = e, this.length = t;
  }
  get lines() {
    return this.text.length;
  }
  get children() {
    return null;
  }
  lineInner(e, t, i, r) {
    for (let s = 0; ; s++) {
      let o = this.text[s], l = r + o.length;
      if ((t ? i : l) >= e)
        return new Y0(r, l, i, o);
      r = l + 1, i++;
    }
  }
  decompose(e, t, i, r) {
    let s = e <= 0 && t >= this.length ? this : new Pe(Xu(this.text, e, t), Math.min(t, this.length) - Math.max(0, e));
    if (r & 1) {
      let o = i.pop(), l = zs(s.text, o.text.slice(), 0, s.length);
      if (l.length <= 32)
        i.push(new Pe(l, o.length + s.length));
      else {
        let a = l.length >> 1;
        i.push(new Pe(l.slice(0, a)), new Pe(l.slice(a)));
      }
    } else
      i.push(s);
  }
  replace(e, t, i) {
    if (!(i instanceof Pe))
      return super.replace(e, t, i);
    [e, t] = Si(this, e, t);
    let r = zs(this.text, zs(i.text, Xu(this.text, 0, e)), t), s = this.length + i.length - (t - e);
    return r.length <= 32 ? new Pe(r, s) : Bt.from(Pe.split(r, []), s);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = Si(this, e, t);
    let r = "";
    for (let s = 0, o = 0; s <= t && o < this.text.length; o++) {
      let l = this.text[o], a = s + l.length;
      s > e && o && (r += i), e < a && t > s && (r += l.slice(Math.max(0, e - s), t - s)), s = a + 1;
    }
    return r;
  }
  flatten(e) {
    for (let t of this.text)
      e.push(t);
  }
  scanIdentical() {
    return 0;
  }
  static split(e, t) {
    let i = [], r = -1;
    for (let s of e)
      i.push(s), r += s.length + 1, i.length == 32 && (t.push(new Pe(i, r)), i = [], r = -1);
    return r > -1 && t.push(new Pe(i, r)), t;
  }
}
class Bt extends le {
  constructor(e, t) {
    super(), this.children = e, this.length = t, this.lines = 0;
    for (let i of e)
      this.lines += i.lines;
  }
  lineInner(e, t, i, r) {
    for (let s = 0; ; s++) {
      let o = this.children[s], l = r + o.length, a = i + o.lines - 1;
      if ((t ? a : l) >= e)
        return o.lineInner(e, t, i, r);
      r = l + 1, i = a + 1;
    }
  }
  decompose(e, t, i, r) {
    for (let s = 0, o = 0; o <= t && s < this.children.length; s++) {
      let l = this.children[s], a = o + l.length;
      if (e <= a && t >= o) {
        let h = r & ((o <= e ? 1 : 0) | (a >= t ? 2 : 0));
        o >= e && a <= t && !h ? i.push(l) : l.decompose(e - o, t - o, i, h);
      }
      o = a + 1;
    }
  }
  replace(e, t, i) {
    if ([e, t] = Si(this, e, t), i.lines < this.lines)
      for (let r = 0, s = 0; r < this.children.length; r++) {
        let o = this.children[r], l = s + o.length;
        if (e >= s && t <= l) {
          let a = o.replace(e - s, t - s, i), h = this.lines - o.lines + a.lines;
          if (a.lines < h >> 4 && a.lines > h >> 6) {
            let u = this.children.slice();
            return u[r] = a, new Bt(u, this.length - (t - e) + i.length);
          }
          return super.replace(s, l, a);
        }
        s = l + 1;
      }
    return super.replace(e, t, i);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = Si(this, e, t);
    let r = "";
    for (let s = 0, o = 0; s < this.children.length && o <= t; s++) {
      let l = this.children[s], a = o + l.length;
      o > e && s && (r += i), e < a && t > o && (r += l.sliceString(e - o, t - o, i)), o = a + 1;
    }
    return r;
  }
  flatten(e) {
    for (let t of this.children)
      t.flatten(e);
  }
  scanIdentical(e, t) {
    if (!(e instanceof Bt))
      return 0;
    let i = 0, [r, s, o, l] = t > 0 ? [0, 0, this.children.length, e.children.length] : [this.children.length - 1, e.children.length - 1, -1, -1];
    for (; ; r += t, s += t) {
      if (r == o || s == l)
        return i;
      let a = this.children[r], h = e.children[s];
      if (a != h)
        return i + a.scanIdentical(h, t);
      i += a.length + 1;
    }
  }
  static from(e, t = e.reduce((i, r) => i + r.length + 1, -1)) {
    let i = 0;
    for (let d of e)
      i += d.lines;
    if (i < 32) {
      let d = [];
      for (let p of e)
        p.flatten(d);
      return new Pe(d, t);
    }
    let r = Math.max(
      32,
      i >> 5
      /* Tree.BranchShift */
    ), s = r << 1, o = r >> 1, l = [], a = 0, h = -1, u = [];
    function c(d) {
      let p;
      if (d.lines > s && d instanceof Bt)
        for (let m of d.children)
          c(m);
      else
        d.lines > o && (a > o || !a) ? (f(), l.push(d)) : d instanceof Pe && a && (p = u[u.length - 1]) instanceof Pe && d.lines + p.lines <= 32 ? (a += d.lines, h += d.length + 1, u[u.length - 1] = new Pe(p.text.concat(d.text), p.length + 1 + d.length)) : (a + d.lines > r && f(), a += d.lines, h += d.length + 1, u.push(d));
    }
    function f() {
      a != 0 && (l.push(u.length == 1 ? u[0] : Bt.from(u, h)), h = -1, a = u.length = 0);
    }
    for (let d of e)
      c(d);
    return f(), l.length == 1 ? l[0] : new Bt(l, t);
  }
}
le.empty = /* @__PURE__ */ new Pe([""], 0);
function V0(n) {
  let e = -1;
  for (let t of n)
    e += t.length + 1;
  return e;
}
function zs(n, e, t = 0, i = 1e9) {
  for (let r = 0, s = 0, o = !0; s < n.length && r <= i; s++) {
    let l = n[s], a = r + l.length;
    a >= t && (a > i && (l = l.slice(0, i - r)), r < t && (l = l.slice(t - r)), o ? (e[e.length - 1] += l, o = !1) : e.push(l)), r = a + 1;
  }
  return e;
}
function Xu(n, e, t) {
  return zs(n, [""], e, t);
}
class fr {
  constructor(e, t = 1) {
    this.dir = t, this.done = !1, this.lineBreak = !1, this.value = "", this.nodes = [e], this.offsets = [t > 0 ? 1 : (e instanceof Pe ? e.text.length : e.children.length) << 1];
  }
  nextInner(e, t) {
    for (this.done = this.lineBreak = !1; ; ) {
      let i = this.nodes.length - 1, r = this.nodes[i], s = this.offsets[i], o = s >> 1, l = r instanceof Pe ? r.text.length : r.children.length;
      if (o == (t > 0 ? l : 0)) {
        if (i == 0)
          return this.done = !0, this.value = "", this;
        t > 0 && this.offsets[i - 1]++, this.nodes.pop(), this.offsets.pop();
      } else if ((s & 1) == (t > 0 ? 0 : 1)) {
        if (this.offsets[i] += t, e == 0)
          return this.lineBreak = !0, this.value = `
`, this;
        e--;
      } else if (r instanceof Pe) {
        let a = r.text[o + (t < 0 ? -1 : 0)];
        if (this.offsets[i] += t, a.length > Math.max(0, e))
          return this.value = e == 0 ? a : t > 0 ? a.slice(e) : a.slice(0, a.length - e), this;
        e -= a.length;
      } else {
        let a = r.children[o + (t < 0 ? -1 : 0)];
        e > a.length ? (e -= a.length, this.offsets[i] += t) : (t < 0 && this.offsets[i]--, this.nodes.push(a), this.offsets.push(t > 0 ? 1 : (a instanceof Pe ? a.text.length : a.children.length) << 1));
      }
    }
  }
  next(e = 0) {
    return e < 0 && (this.nextInner(-e, -this.dir), e = this.value.length), this.nextInner(e, this.dir);
  }
}
class ap {
  constructor(e, t, i) {
    this.value = "", this.done = !1, this.cursor = new fr(e, t > i ? -1 : 1), this.pos = t > i ? e.length : 0, this.from = Math.min(t, i), this.to = Math.max(t, i);
  }
  nextInner(e, t) {
    if (t < 0 ? this.pos <= this.from : this.pos >= this.to)
      return this.value = "", this.done = !0, this;
    e += Math.max(0, t < 0 ? this.pos - this.to : this.from - this.pos);
    let i = t < 0 ? this.pos - this.from : this.to - this.pos;
    e > i && (e = i), i -= e;
    let { value: r } = this.cursor.next(e);
    return this.pos += (r.length + e) * t, this.value = r.length <= i ? r : t < 0 ? r.slice(r.length - i) : r.slice(0, i), this.done = !this.value, this;
  }
  next(e = 0) {
    return e < 0 ? e = Math.max(e, this.from - this.pos) : e > 0 && (e = Math.min(e, this.to - this.pos)), this.nextInner(e, this.cursor.dir);
  }
  get lineBreak() {
    return this.cursor.lineBreak && this.value != "";
  }
}
class hp {
  constructor(e) {
    this.inner = e, this.afterBreak = !0, this.value = "", this.done = !1;
  }
  next(e = 0) {
    let { done: t, lineBreak: i, value: r } = this.inner.next(e);
    return t && this.afterBreak ? (this.value = "", this.afterBreak = !1) : t ? (this.done = !0, this.value = "") : i ? this.afterBreak ? this.value = "" : (this.afterBreak = !0, this.next()) : (this.value = r, this.afterBreak = !1), this;
  }
  get lineBreak() {
    return !1;
  }
}
typeof Symbol < "u" && (le.prototype[Symbol.iterator] = function() {
  return this.iter();
}, fr.prototype[Symbol.iterator] = ap.prototype[Symbol.iterator] = hp.prototype[Symbol.iterator] = function() {
  return this;
});
let Y0 = class {
  /**
  @internal
  */
  constructor(e, t, i, r) {
    this.from = e, this.to = t, this.number = i, this.text = r;
  }
  /**
  The length of the line (not including any line break after it).
  */
  get length() {
    return this.to - this.from;
  }
};
function Si(n, e, t) {
  return e = Math.max(0, Math.min(n.length, e)), [e, Math.max(e, Math.min(n.length, t))];
}
let di = /* @__PURE__ */ "lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map((n) => n ? parseInt(n, 36) : 1);
for (let n = 1; n < di.length; n++)
  di[n] += di[n - 1];
function j0(n) {
  for (let e = 1; e < di.length; e += 2)
    if (di[e] > n)
      return di[e - 1] <= n;
  return !1;
}
function Du(n) {
  return n >= 127462 && n <= 127487;
}
const Lu = 8205;
function Be(n, e, t = !0, i = !0) {
  return (t ? up : N0)(n, e, i);
}
function up(n, e, t) {
  if (e == n.length)
    return e;
  e && cp(n.charCodeAt(e)) && fp(n.charCodeAt(e - 1)) && e--;
  let i = Ie(n, e);
  for (e += bt(i); e < n.length; ) {
    let r = Ie(n, e);
    if (i == Lu || r == Lu || t && j0(r))
      e += bt(r), i = r;
    else if (Du(r)) {
      let s = 0, o = e - 2;
      for (; o >= 0 && Du(Ie(n, o)); )
        s++, o -= 2;
      if (s % 2 == 0)
        break;
      e += 2;
    } else
      break;
  }
  return e;
}
function N0(n, e, t) {
  for (; e > 0; ) {
    let i = up(n, e - 2, t);
    if (i < e)
      return i;
    e--;
  }
  return 0;
}
function cp(n) {
  return n >= 56320 && n < 57344;
}
function fp(n) {
  return n >= 55296 && n < 56320;
}
function Ie(n, e) {
  let t = n.charCodeAt(e);
  if (!fp(t) || e + 1 == n.length)
    return t;
  let i = n.charCodeAt(e + 1);
  return cp(i) ? (t - 55296 << 10) + (i - 56320) + 65536 : t;
}
function Sh(n) {
  return n <= 65535 ? String.fromCharCode(n) : (n -= 65536, String.fromCharCode((n >> 10) + 55296, (n & 1023) + 56320));
}
function bt(n) {
  return n < 65536 ? 1 : 2;
}
const sa = /\r\n?|\n/;
var qe = /* @__PURE__ */ function(n) {
  return n[n.Simple = 0] = "Simple", n[n.TrackDel = 1] = "TrackDel", n[n.TrackBefore = 2] = "TrackBefore", n[n.TrackAfter = 3] = "TrackAfter", n;
}(qe || (qe = {}));
class Ut {
  // Sections are encoded as pairs of integers. The first is the
  // length in the current document, and the second is -1 for
  // unaffected sections, and the length of the replacement content
  // otherwise. So an insertion would be (0, n>0), a deletion (n>0,
  // 0), and a replacement two positive numbers.
  /**
  @internal
  */
  constructor(e) {
    this.sections = e;
  }
  /**
  The length of the document before the change.
  */
  get length() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2)
      e += this.sections[t];
    return e;
  }
  /**
  The length of the document after the change.
  */
  get newLength() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t + 1];
      e += i < 0 ? this.sections[t] : i;
    }
    return e;
  }
  /**
  False when there are actual changes in this set.
  */
  get empty() {
    return this.sections.length == 0 || this.sections.length == 2 && this.sections[1] < 0;
  }
  /**
  Iterate over the unchanged parts left by these changes. `posA`
  provides the position of the range in the old document, `posB`
  the new position in the changed document.
  */
  iterGaps(e) {
    for (let t = 0, i = 0, r = 0; t < this.sections.length; ) {
      let s = this.sections[t++], o = this.sections[t++];
      o < 0 ? (e(i, r, s), r += s) : r += o, i += s;
    }
  }
  /**
  Iterate over the ranges changed by these changes. (See
  [`ChangeSet.iterChanges`](https://codemirror.net/6/docs/ref/#state.ChangeSet.iterChanges) for a
  variant that also provides you with the inserted text.)
  `fromA`/`toA` provides the extent of the change in the starting
  document, `fromB`/`toB` the extent of the replacement in the
  changed document.
  
  When `individual` is true, adjacent changes (which are kept
  separate for [position mapping](https://codemirror.net/6/docs/ref/#state.ChangeDesc.mapPos)) are
  reported separately.
  */
  iterChangedRanges(e, t = !1) {
    oa(this, e, t);
  }
  /**
  Get a description of the inverted form of these changes.
  */
  get invertedDesc() {
    let e = [];
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], r = this.sections[t++];
      r < 0 ? e.push(i, r) : e.push(r, i);
    }
    return new Ut(e);
  }
  /**
  Compute the combined effect of applying another set of changes
  after this one. The length of the document after this set should
  match the length before `other`.
  */
  composeDesc(e) {
    return this.empty ? e : e.empty ? this : dp(this, e);
  }
  /**
  Map this description, which should start with the same document
  as `other`, over another set of changes, so that it can be
  applied after it. When `before` is true, map as if the changes
  in `other` happened before the ones in `this`.
  */
  mapDesc(e, t = !1) {
    return e.empty ? this : la(this, e, t);
  }
  mapPos(e, t = -1, i = qe.Simple) {
    let r = 0, s = 0;
    for (let o = 0; o < this.sections.length; ) {
      let l = this.sections[o++], a = this.sections[o++], h = r + l;
      if (a < 0) {
        if (h > e)
          return s + (e - r);
        s += l;
      } else {
        if (i != qe.Simple && h >= e && (i == qe.TrackDel && r < e && h > e || i == qe.TrackBefore && r < e || i == qe.TrackAfter && h > e))
          return null;
        if (h > e || h == e && t < 0 && !l)
          return e == r || t < 0 ? s : s + a;
        s += a;
      }
      r = h;
    }
    if (e > r)
      throw new RangeError(`Position ${e} is out of range for changeset of length ${r}`);
    return s;
  }
  /**
  Check whether these changes touch a given range. When one of the
  changes entirely covers the range, the string `"cover"` is
  returned.
  */
  touchesRange(e, t = e) {
    for (let i = 0, r = 0; i < this.sections.length && r <= t; ) {
      let s = this.sections[i++], o = this.sections[i++], l = r + s;
      if (o >= 0 && r <= t && l >= e)
        return r < e && l > t ? "cover" : !0;
      r = l;
    }
    return !1;
  }
  /**
  @internal
  */
  toString() {
    let e = "";
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], r = this.sections[t++];
      e += (e ? " " : "") + i + (r >= 0 ? ":" + r : "");
    }
    return e;
  }
  /**
  Serialize this change desc to a JSON-representable value.
  */
  toJSON() {
    return this.sections;
  }
  /**
  Create a change desc from its JSON representation (as produced
  by [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeDesc.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e) || e.length % 2 || e.some((t) => typeof t != "number"))
      throw new RangeError("Invalid JSON representation of ChangeDesc");
    return new Ut(e);
  }
  /**
  @internal
  */
  static create(e) {
    return new Ut(e);
  }
}
class Ee extends Ut {
  constructor(e, t) {
    super(e), this.inserted = t;
  }
  /**
  Apply the changes to a document, returning the modified
  document.
  */
  apply(e) {
    if (this.length != e.length)
      throw new RangeError("Applying change set to a document with the wrong length");
    return oa(this, (t, i, r, s, o) => e = e.replace(r, r + (i - t), o), !1), e;
  }
  mapDesc(e, t = !1) {
    return la(this, e, t, !0);
  }
  /**
  Given the document as it existed _before_ the changes, return a
  change set that represents the inverse of this set, which could
  be used to go from the document created by the changes back to
  the document as it existed before the changes.
  */
  invert(e) {
    let t = this.sections.slice(), i = [];
    for (let r = 0, s = 0; r < t.length; r += 2) {
      let o = t[r], l = t[r + 1];
      if (l >= 0) {
        t[r] = l, t[r + 1] = o;
        let a = r >> 1;
        for (; i.length < a; )
          i.push(le.empty);
        i.push(o ? e.slice(s, s + o) : le.empty);
      }
      s += o;
    }
    return new Ee(t, i);
  }
  /**
  Combine two subsequent change sets into a single set. `other`
  must start in the document produced by `this`. If `this` goes
  `docA` → `docB` and `other` represents `docB` → `docC`, the
  returned value will represent the change `docA` → `docC`.
  */
  compose(e) {
    return this.empty ? e : e.empty ? this : dp(this, e, !0);
  }
  /**
  Given another change set starting in the same document, maps this
  change set over the other, producing a new change set that can be
  applied to the document produced by applying `other`. When
  `before` is `true`, order changes as if `this` comes before
  `other`, otherwise (the default) treat `other` as coming first.
  
  Given two changes `A` and `B`, `A.compose(B.map(A))` and
  `B.compose(A.map(B, true))` will produce the same document. This
  provides a basic form of [operational
  transformation](https://en.wikipedia.org/wiki/Operational_transformation),
  and can be used for collaborative editing.
  */
  map(e, t = !1) {
    return e.empty ? this : la(this, e, t, !0);
  }
  /**
  Iterate over the changed ranges in the document, calling `f` for
  each, with the range in the original document (`fromA`-`toA`)
  and the range that replaces it in the new document
  (`fromB`-`toB`).
  
  When `individual` is true, adjacent changes are reported
  separately.
  */
  iterChanges(e, t = !1) {
    oa(this, e, t);
  }
  /**
  Get a [change description](https://codemirror.net/6/docs/ref/#state.ChangeDesc) for this change
  set.
  */
  get desc() {
    return Ut.create(this.sections);
  }
  /**
  @internal
  */
  filter(e) {
    let t = [], i = [], r = [], s = new wr(this);
    e:
      for (let o = 0, l = 0; ; ) {
        let a = o == e.length ? 1e9 : e[o++];
        for (; l < a || l == a && s.len == 0; ) {
          if (s.done)
            break e;
          let u = Math.min(s.len, a - l);
          Ve(r, u, -1);
          let c = s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0;
          Ve(t, u, c), c > 0 && yn(i, t, s.text), s.forward(u), l += u;
        }
        let h = e[o++];
        for (; l < h; ) {
          if (s.done)
            break e;
          let u = Math.min(s.len, h - l);
          Ve(t, u, -1), Ve(r, u, s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0), s.forward(u), l += u;
        }
      }
    return {
      changes: new Ee(t, i),
      filtered: Ut.create(r)
    };
  }
  /**
  Serialize this change set to a JSON-representable value.
  */
  toJSON() {
    let e = [];
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t], r = this.sections[t + 1];
      r < 0 ? e.push(i) : r == 0 ? e.push([i]) : e.push([i].concat(this.inserted[t >> 1].toJSON()));
    }
    return e;
  }
  /**
  Create a change set for the given changes, for a document of the
  given length, using `lineSep` as line separator.
  */
  static of(e, t, i) {
    let r = [], s = [], o = 0, l = null;
    function a(u = !1) {
      if (!u && !r.length)
        return;
      o < t && Ve(r, t - o, -1);
      let c = new Ee(r, s);
      l = l ? l.compose(c.map(l)) : c, r = [], s = [], o = 0;
    }
    function h(u) {
      if (Array.isArray(u))
        for (let c of u)
          h(c);
      else if (u instanceof Ee) {
        if (u.length != t)
          throw new RangeError(`Mismatched change set length (got ${u.length}, expected ${t})`);
        a(), l = l ? l.compose(u.map(l)) : u;
      } else {
        let { from: c, to: f = c, insert: d } = u;
        if (c > f || c < 0 || f > t)
          throw new RangeError(`Invalid change range ${c} to ${f} (in doc of length ${t})`);
        let p = d ? typeof d == "string" ? le.of(d.split(i || sa)) : d : le.empty, m = p.length;
        if (c == f && m == 0)
          return;
        c < o && a(), c > o && Ve(r, c - o, -1), Ve(r, f - c, m), yn(s, r, p), o = f;
      }
    }
    return h(e), a(!l), l;
  }
  /**
  Create an empty changeset of the given length.
  */
  static empty(e) {
    return new Ee(e ? [e, -1] : [], []);
  }
  /**
  Create a changeset from its JSON representation (as produced by
  [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeSet.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e))
      throw new RangeError("Invalid JSON representation of ChangeSet");
    let t = [], i = [];
    for (let r = 0; r < e.length; r++) {
      let s = e[r];
      if (typeof s == "number")
        t.push(s, -1);
      else {
        if (!Array.isArray(s) || typeof s[0] != "number" || s.some((o, l) => l && typeof o != "string"))
          throw new RangeError("Invalid JSON representation of ChangeSet");
        if (s.length == 1)
          t.push(s[0], 0);
        else {
          for (; i.length < r; )
            i.push(le.empty);
          i[r] = le.of(s.slice(1)), t.push(s[0], i[r].length);
        }
      }
    }
    return new Ee(t, i);
  }
  /**
  @internal
  */
  static createSet(e, t) {
    return new Ee(e, t);
  }
}
function Ve(n, e, t, i = !1) {
  if (e == 0 && t <= 0)
    return;
  let r = n.length - 2;
  r >= 0 && t <= 0 && t == n[r + 1] ? n[r] += e : e == 0 && n[r] == 0 ? n[r + 1] += t : i ? (n[r] += e, n[r + 1] += t) : n.push(e, t);
}
function yn(n, e, t) {
  if (t.length == 0)
    return;
  let i = e.length - 2 >> 1;
  if (i < n.length)
    n[n.length - 1] = n[n.length - 1].append(t);
  else {
    for (; n.length < i; )
      n.push(le.empty);
    n.push(t);
  }
}
function oa(n, e, t) {
  let i = n.inserted;
  for (let r = 0, s = 0, o = 0; o < n.sections.length; ) {
    let l = n.sections[o++], a = n.sections[o++];
    if (a < 0)
      r += l, s += l;
    else {
      let h = r, u = s, c = le.empty;
      for (; h += l, u += a, a && i && (c = c.append(i[o - 2 >> 1])), !(t || o == n.sections.length || n.sections[o + 1] < 0); )
        l = n.sections[o++], a = n.sections[o++];
      e(r, h, s, u, c), r = h, s = u;
    }
  }
}
function la(n, e, t, i = !1) {
  let r = [], s = i ? [] : null, o = new wr(n), l = new wr(e);
  for (let a = -1; ; )
    if (o.ins == -1 && l.ins == -1) {
      let h = Math.min(o.len, l.len);
      Ve(r, h, -1), o.forward(h), l.forward(h);
    } else if (l.ins >= 0 && (o.ins < 0 || a == o.i || o.off == 0 && (l.len < o.len || l.len == o.len && !t))) {
      let h = l.len;
      for (Ve(r, l.ins, -1); h; ) {
        let u = Math.min(o.len, h);
        o.ins >= 0 && a < o.i && o.len <= u && (Ve(r, 0, o.ins), s && yn(s, r, o.text), a = o.i), o.forward(u), h -= u;
      }
      l.next();
    } else if (o.ins >= 0) {
      let h = 0, u = o.len;
      for (; u; )
        if (l.ins == -1) {
          let c = Math.min(u, l.len);
          h += c, u -= c, l.forward(c);
        } else if (l.ins == 0 && l.len < u)
          u -= l.len, l.next();
        else
          break;
      Ve(r, h, a < o.i ? o.ins : 0), s && a < o.i && yn(s, r, o.text), a = o.i, o.forward(o.len - u);
    } else {
      if (o.done && l.done)
        return s ? Ee.createSet(r, s) : Ut.create(r);
      throw new Error("Mismatched change set lengths");
    }
}
function dp(n, e, t = !1) {
  let i = [], r = t ? [] : null, s = new wr(n), o = new wr(e);
  for (let l = !1; ; ) {
    if (s.done && o.done)
      return r ? Ee.createSet(i, r) : Ut.create(i);
    if (s.ins == 0)
      Ve(i, s.len, 0, l), s.next();
    else if (o.len == 0 && !o.done)
      Ve(i, 0, o.ins, l), r && yn(r, i, o.text), o.next();
    else {
      if (s.done || o.done)
        throw new Error("Mismatched change set lengths");
      {
        let a = Math.min(s.len2, o.len), h = i.length;
        if (s.ins == -1) {
          let u = o.ins == -1 ? -1 : o.off ? 0 : o.ins;
          Ve(i, a, u, l), r && u && yn(r, i, o.text);
        } else
          o.ins == -1 ? (Ve(i, s.off ? 0 : s.len, a, l), r && yn(r, i, s.textBit(a))) : (Ve(i, s.off ? 0 : s.len, o.off ? 0 : o.ins, l), r && !o.off && yn(r, i, o.text));
        l = (s.ins > a || o.ins >= 0 && o.len > a) && (l || i.length > h), s.forward2(a), o.forward(a);
      }
    }
  }
}
class wr {
  constructor(e) {
    this.set = e, this.i = 0, this.next();
  }
  next() {
    let { sections: e } = this.set;
    this.i < e.length ? (this.len = e[this.i++], this.ins = e[this.i++]) : (this.len = 0, this.ins = -2), this.off = 0;
  }
  get done() {
    return this.ins == -2;
  }
  get len2() {
    return this.ins < 0 ? this.len : this.ins;
  }
  get text() {
    let { inserted: e } = this.set, t = this.i - 2 >> 1;
    return t >= e.length ? le.empty : e[t];
  }
  textBit(e) {
    let { inserted: t } = this.set, i = this.i - 2 >> 1;
    return i >= t.length && !e ? le.empty : t[i].slice(this.off, e == null ? void 0 : this.off + e);
  }
  forward(e) {
    e == this.len ? this.next() : (this.len -= e, this.off += e);
  }
  forward2(e) {
    this.ins == -1 ? this.forward(e) : e == this.ins ? this.next() : (this.ins -= e, this.off += e);
  }
}
class Yn {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.flags = i;
  }
  /**
  The anchor of the range—the side that doesn't move when you
  extend it.
  */
  get anchor() {
    return this.flags & 32 ? this.to : this.from;
  }
  /**
  The head of the range, which is moved when the range is
  [extended](https://codemirror.net/6/docs/ref/#state.SelectionRange.extend).
  */
  get head() {
    return this.flags & 32 ? this.from : this.to;
  }
  /**
  True when `anchor` and `head` are at the same position.
  */
  get empty() {
    return this.from == this.to;
  }
  /**
  If this is a cursor that is explicitly associated with the
  character on one of its sides, this returns the side. -1 means
  the character before its position, 1 the character after, and 0
  means no association.
  */
  get assoc() {
    return this.flags & 8 ? -1 : this.flags & 16 ? 1 : 0;
  }
  /**
  The bidirectional text level associated with this cursor, if
  any.
  */
  get bidiLevel() {
    let e = this.flags & 7;
    return e == 7 ? null : e;
  }
  /**
  The goal column (stored vertical offset) associated with a
  cursor. This is used to preserve the vertical position when
  [moving](https://codemirror.net/6/docs/ref/#view.EditorView.moveVertically) across
  lines of different length.
  */
  get goalColumn() {
    let e = this.flags >> 6;
    return e == 16777215 ? void 0 : e;
  }
  /**
  Map this range through a change, producing a valid range in the
  updated document.
  */
  map(e, t = -1) {
    let i, r;
    return this.empty ? i = r = e.mapPos(this.from, t) : (i = e.mapPos(this.from, 1), r = e.mapPos(this.to, -1)), i == this.from && r == this.to ? this : new Yn(i, r, this.flags);
  }
  /**
  Extend this range to cover at least `from` to `to`.
  */
  extend(e, t = e) {
    if (e <= this.anchor && t >= this.anchor)
      return $.range(e, t);
    let i = Math.abs(e - this.anchor) > Math.abs(t - this.anchor) ? e : t;
    return $.range(this.anchor, i);
  }
  /**
  Compare this range to another range.
  */
  eq(e, t = !1) {
    return this.anchor == e.anchor && this.head == e.head && (!t || !this.empty || this.assoc == e.assoc);
  }
  /**
  Return a JSON-serializable object representing the range.
  */
  toJSON() {
    return { anchor: this.anchor, head: this.head };
  }
  /**
  Convert a JSON representation of a range to a `SelectionRange`
  instance.
  */
  static fromJSON(e) {
    if (!e || typeof e.anchor != "number" || typeof e.head != "number")
      throw new RangeError("Invalid JSON representation for SelectionRange");
    return $.range(e.anchor, e.head);
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Yn(e, t, i);
  }
}
class $ {
  constructor(e, t) {
    this.ranges = e, this.mainIndex = t;
  }
  /**
  Map a selection through a change. Used to adjust the selection
  position for changes.
  */
  map(e, t = -1) {
    return e.empty ? this : $.create(this.ranges.map((i) => i.map(e, t)), this.mainIndex);
  }
  /**
  Compare this selection to another selection. By default, ranges
  are compared only by position. When `includeAssoc` is true,
  cursor ranges must also have the same
  [`assoc`](https://codemirror.net/6/docs/ref/#state.SelectionRange.assoc) value.
  */
  eq(e, t = !1) {
    if (this.ranges.length != e.ranges.length || this.mainIndex != e.mainIndex)
      return !1;
    for (let i = 0; i < this.ranges.length; i++)
      if (!this.ranges[i].eq(e.ranges[i], t))
        return !1;
    return !0;
  }
  /**
  Get the primary selection range. Usually, you should make sure
  your code applies to _all_ ranges, by using methods like
  [`changeByRange`](https://codemirror.net/6/docs/ref/#state.EditorState.changeByRange).
  */
  get main() {
    return this.ranges[this.mainIndex];
  }
  /**
  Make sure the selection only has one range. Returns a selection
  holding only the main range from this selection.
  */
  asSingle() {
    return this.ranges.length == 1 ? this : new $([this.main], 0);
  }
  /**
  Extend this selection with an extra range.
  */
  addRange(e, t = !0) {
    return $.create([e].concat(this.ranges), t ? 0 : this.mainIndex + 1);
  }
  /**
  Replace a given range with another range, and then normalize the
  selection to merge and sort ranges if necessary.
  */
  replaceRange(e, t = this.mainIndex) {
    let i = this.ranges.slice();
    return i[t] = e, $.create(i, this.mainIndex);
  }
  /**
  Convert this selection to an object that can be serialized to
  JSON.
  */
  toJSON() {
    return { ranges: this.ranges.map((e) => e.toJSON()), main: this.mainIndex };
  }
  /**
  Create a selection from a JSON representation.
  */
  static fromJSON(e) {
    if (!e || !Array.isArray(e.ranges) || typeof e.main != "number" || e.main >= e.ranges.length)
      throw new RangeError("Invalid JSON representation for EditorSelection");
    return new $(e.ranges.map((t) => Yn.fromJSON(t)), e.main);
  }
  /**
  Create a selection holding a single range.
  */
  static single(e, t = e) {
    return new $([$.range(e, t)], 0);
  }
  /**
  Sort and merge the given set of ranges, creating a valid
  selection.
  */
  static create(e, t = 0) {
    if (e.length == 0)
      throw new RangeError("A selection needs at least one range");
    for (let i = 0, r = 0; r < e.length; r++) {
      let s = e[r];
      if (s.empty ? s.from <= i : s.from < i)
        return $.normalized(e.slice(), t);
      i = s.to;
    }
    return new $(e, t);
  }
  /**
  Create a cursor selection range at the given position. You can
  safely ignore the optional arguments in most situations.
  */
  static cursor(e, t = 0, i, r) {
    return Yn.create(e, e, (t == 0 ? 0 : t < 0 ? 8 : 16) | (i == null ? 7 : Math.min(6, i)) | (r ?? 16777215) << 6);
  }
  /**
  Create a selection range.
  */
  static range(e, t, i, r) {
    let s = (i ?? 16777215) << 6 | (r == null ? 7 : Math.min(6, r));
    return t < e ? Yn.create(t, e, 48 | s) : Yn.create(e, t, (t > e ? 8 : 0) | s);
  }
  /**
  @internal
  */
  static normalized(e, t = 0) {
    let i = e[t];
    e.sort((r, s) => r.from - s.from), t = e.indexOf(i);
    for (let r = 1; r < e.length; r++) {
      let s = e[r], o = e[r - 1];
      if (s.empty ? s.from <= o.to : s.from < o.to) {
        let l = o.from, a = Math.max(s.to, o.to);
        r <= t && t--, e.splice(--r, 2, s.anchor > s.head ? $.range(a, l) : $.range(l, a));
      }
    }
    return new $(e, t);
  }
}
function pp(n, e) {
  for (let t of n.ranges)
    if (t.to > e)
      throw new RangeError("Selection points outside of document");
}
let vh = 0;
class B {
  constructor(e, t, i, r, s) {
    this.combine = e, this.compareInput = t, this.compare = i, this.isStatic = r, this.id = vh++, this.default = e([]), this.extensions = typeof s == "function" ? s(this) : s;
  }
  /**
  Returns a facet reader for this facet, which can be used to
  [read](https://codemirror.net/6/docs/ref/#state.EditorState.facet) it but not to define values for it.
  */
  get reader() {
    return this;
  }
  /**
  Define a new facet.
  */
  static define(e = {}) {
    return new B(e.combine || ((t) => t), e.compareInput || ((t, i) => t === i), e.compare || (e.combine ? (t, i) => t === i : Ph), !!e.static, e.enables);
  }
  /**
  Returns an extension that adds the given value to this facet.
  */
  of(e) {
    return new Xs([], this, 0, e);
  }
  /**
  Create an extension that computes a value for the facet from a
  state. You must take care to declare the parts of the state that
  this value depends on, since your function is only called again
  for a new state when one of those parts changed.
  
  In cases where your value depends only on a single field, you'll
  want to use the [`from`](https://codemirror.net/6/docs/ref/#state.Facet.from) method instead.
  */
  compute(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new Xs(e, this, 1, t);
  }
  /**
  Create an extension that computes zero or more values for this
  facet from a state.
  */
  computeN(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new Xs(e, this, 2, t);
  }
  from(e, t) {
    return t || (t = (i) => i), this.compute([e], (i) => t(i.field(e)));
  }
}
function Ph(n, e) {
  return n == e || n.length == e.length && n.every((t, i) => t === e[i]);
}
class Xs {
  constructor(e, t, i, r) {
    this.dependencies = e, this.facet = t, this.type = i, this.value = r, this.id = vh++;
  }
  dynamicSlot(e) {
    var t;
    let i = this.value, r = this.facet.compareInput, s = this.id, o = e[s] >> 1, l = this.type == 2, a = !1, h = !1, u = [];
    for (let c of this.dependencies)
      c == "doc" ? a = !0 : c == "selection" ? h = !0 : ((t = e[c.id]) !== null && t !== void 0 ? t : 1) & 1 || u.push(e[c.id]);
    return {
      create(c) {
        return c.values[o] = i(c), 1;
      },
      update(c, f) {
        if (a && f.docChanged || h && (f.docChanged || f.selection) || aa(c, u)) {
          let d = i(c);
          if (l ? !Iu(d, c.values[o], r) : !r(d, c.values[o]))
            return c.values[o] = d, 1;
        }
        return 0;
      },
      reconfigure: (c, f) => {
        let d, p = f.config.address[s];
        if (p != null) {
          let m = Ks(f, p);
          if (this.dependencies.every((O) => O instanceof B ? f.facet(O) === c.facet(O) : O instanceof De ? f.field(O, !1) == c.field(O, !1) : !0) || (l ? Iu(d = i(c), m, r) : r(d = i(c), m)))
            return c.values[o] = m, 0;
        } else
          d = i(c);
        return c.values[o] = d, 1;
      }
    };
  }
}
function Iu(n, e, t) {
  if (n.length != e.length)
    return !1;
  for (let i = 0; i < n.length; i++)
    if (!t(n[i], e[i]))
      return !1;
  return !0;
}
function aa(n, e) {
  let t = !1;
  for (let i of e)
    dr(n, i) & 1 && (t = !0);
  return t;
}
function U0(n, e, t) {
  let i = t.map((a) => n[a.id]), r = t.map((a) => a.type), s = i.filter((a) => !(a & 1)), o = n[e.id] >> 1;
  function l(a) {
    let h = [];
    for (let u = 0; u < i.length; u++) {
      let c = Ks(a, i[u]);
      if (r[u] == 2)
        for (let f of c)
          h.push(f);
      else
        h.push(c);
    }
    return e.combine(h);
  }
  return {
    create(a) {
      for (let h of i)
        dr(a, h);
      return a.values[o] = l(a), 1;
    },
    update(a, h) {
      if (!aa(a, s))
        return 0;
      let u = l(a);
      return e.compare(u, a.values[o]) ? 0 : (a.values[o] = u, 1);
    },
    reconfigure(a, h) {
      let u = aa(a, i), c = h.config.facets[e.id], f = h.facet(e);
      if (c && !u && Ph(t, c))
        return a.values[o] = f, 0;
      let d = l(a);
      return e.compare(d, f) ? (a.values[o] = f, 0) : (a.values[o] = d, 1);
    }
  };
}
const _u = /* @__PURE__ */ B.define({ static: !0 });
class De {
  constructor(e, t, i, r, s) {
    this.id = e, this.createF = t, this.updateF = i, this.compareF = r, this.spec = s, this.provides = void 0;
  }
  /**
  Define a state field.
  */
  static define(e) {
    let t = new De(vh++, e.create, e.update, e.compare || ((i, r) => i === r), e);
    return e.provide && (t.provides = e.provide(t)), t;
  }
  create(e) {
    let t = e.facet(_u).find((i) => i.field == this);
    return ((t == null ? void 0 : t.create) || this.createF)(e);
  }
  /**
  @internal
  */
  slot(e) {
    let t = e[this.id] >> 1;
    return {
      create: (i) => (i.values[t] = this.create(i), 1),
      update: (i, r) => {
        let s = i.values[t], o = this.updateF(s, r);
        return this.compareF(s, o) ? 0 : (i.values[t] = o, 1);
      },
      reconfigure: (i, r) => r.config.address[this.id] != null ? (i.values[t] = r.field(this), 0) : (i.values[t] = this.create(i), 1)
    };
  }
  /**
  Returns an extension that enables this field and overrides the
  way it is initialized. Can be useful when you need to provide a
  non-default starting value for the field.
  */
  init(e) {
    return [this, _u.of({ field: this, create: e })];
  }
  /**
  State field instances can be used as
  [`Extension`](https://codemirror.net/6/docs/ref/#state.Extension) values to enable the field in a
  given state.
  */
  get extension() {
    return this;
  }
}
const _n = { lowest: 4, low: 3, default: 2, high: 1, highest: 0 };
function Ni(n) {
  return (e) => new mp(e, n);
}
const un = {
  /**
  The highest precedence level, for extensions that should end up
  near the start of the precedence ordering.
  */
  highest: /* @__PURE__ */ Ni(_n.highest),
  /**
  A higher-than-default precedence, for extensions that should
  come before those with default precedence.
  */
  high: /* @__PURE__ */ Ni(_n.high),
  /**
  The default precedence, which is also used for extensions
  without an explicit precedence.
  */
  default: /* @__PURE__ */ Ni(_n.default),
  /**
  A lower-than-default precedence.
  */
  low: /* @__PURE__ */ Ni(_n.low),
  /**
  The lowest precedence level. Meant for things that should end up
  near the end of the extension order.
  */
  lowest: /* @__PURE__ */ Ni(_n.lowest)
};
class mp {
  constructor(e, t) {
    this.inner = e, this.prec = t;
  }
}
class Br {
  /**
  Create an instance of this compartment to add to your [state
  configuration](https://codemirror.net/6/docs/ref/#state.EditorStateConfig.extensions).
  */
  of(e) {
    return new ha(this, e);
  }
  /**
  Create an [effect](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) that
  reconfigures this compartment.
  */
  reconfigure(e) {
    return Br.reconfigure.of({ compartment: this, extension: e });
  }
  /**
  Get the current content of the compartment in the state, or
  `undefined` if it isn't present.
  */
  get(e) {
    return e.config.compartments.get(this);
  }
}
class ha {
  constructor(e, t) {
    this.compartment = e, this.inner = t;
  }
}
class Hs {
  constructor(e, t, i, r, s, o) {
    for (this.base = e, this.compartments = t, this.dynamicSlots = i, this.address = r, this.staticValues = s, this.facets = o, this.statusTemplate = []; this.statusTemplate.length < i.length; )
      this.statusTemplate.push(
        0
        /* SlotStatus.Unresolved */
      );
  }
  staticFacet(e) {
    let t = this.address[e.id];
    return t == null ? e.default : this.staticValues[t >> 1];
  }
  static resolve(e, t, i) {
    let r = [], s = /* @__PURE__ */ Object.create(null), o = /* @__PURE__ */ new Map();
    for (let f of F0(e, t, o))
      f instanceof De ? r.push(f) : (s[f.facet.id] || (s[f.facet.id] = [])).push(f);
    let l = /* @__PURE__ */ Object.create(null), a = [], h = [];
    for (let f of r)
      l[f.id] = h.length << 1, h.push((d) => f.slot(d));
    let u = i == null ? void 0 : i.config.facets;
    for (let f in s) {
      let d = s[f], p = d[0].facet, m = u && u[f] || [];
      if (d.every(
        (O) => O.type == 0
        /* Provider.Static */
      ))
        if (l[p.id] = a.length << 1 | 1, Ph(m, d))
          a.push(i.facet(p));
        else {
          let O = p.combine(d.map((g) => g.value));
          a.push(i && p.compare(O, i.facet(p)) ? i.facet(p) : O);
        }
      else {
        for (let O of d)
          O.type == 0 ? (l[O.id] = a.length << 1 | 1, a.push(O.value)) : (l[O.id] = h.length << 1, h.push((g) => O.dynamicSlot(g)));
        l[p.id] = h.length << 1, h.push((O) => U0(O, p, d));
      }
    }
    let c = h.map((f) => f(l));
    return new Hs(e, o, c, l, a, s);
  }
}
function F0(n, e, t) {
  let i = [[], [], [], [], []], r = /* @__PURE__ */ new Map();
  function s(o, l) {
    let a = r.get(o);
    if (a != null) {
      if (a <= l)
        return;
      let h = i[a].indexOf(o);
      h > -1 && i[a].splice(h, 1), o instanceof ha && t.delete(o.compartment);
    }
    if (r.set(o, l), Array.isArray(o))
      for (let h of o)
        s(h, l);
    else if (o instanceof ha) {
      if (t.has(o.compartment))
        throw new RangeError("Duplicate use of compartment in extensions");
      let h = e.get(o.compartment) || o.inner;
      t.set(o.compartment, h), s(h, l);
    } else if (o instanceof mp)
      s(o.inner, o.prec);
    else if (o instanceof De)
      i[l].push(o), o.provides && s(o.provides, l);
    else if (o instanceof Xs)
      i[l].push(o), o.facet.extensions && s(o.facet.extensions, _n.default);
    else {
      let h = o.extension;
      if (!h)
        throw new Error(`Unrecognized extension value in extension set (${o}). This sometimes happens because multiple instances of @codemirror/state are loaded, breaking instanceof checks.`);
      s(h, l);
    }
  }
  return s(n, _n.default), i.reduce((o, l) => o.concat(l));
}
function dr(n, e) {
  if (e & 1)
    return 2;
  let t = e >> 1, i = n.status[t];
  if (i == 4)
    throw new Error("Cyclic dependency between fields and/or facets");
  if (i & 2)
    return i;
  n.status[t] = 4;
  let r = n.computeSlot(n, n.config.dynamicSlots[t]);
  return n.status[t] = 2 | r;
}
function Ks(n, e) {
  return e & 1 ? n.config.staticValues[e >> 1] : n.values[e >> 1];
}
const Op = /* @__PURE__ */ B.define(), ua = /* @__PURE__ */ B.define({
  combine: (n) => n.some((e) => e),
  static: !0
}), gp = /* @__PURE__ */ B.define({
  combine: (n) => n.length ? n[0] : void 0,
  static: !0
}), bp = /* @__PURE__ */ B.define(), yp = /* @__PURE__ */ B.define(), kp = /* @__PURE__ */ B.define(), xp = /* @__PURE__ */ B.define({
  combine: (n) => n.length ? n[0] : !1
});
class cn {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Define a new type of annotation.
  */
  static define() {
    return new G0();
  }
}
class G0 {
  /**
  Create an instance of this annotation.
  */
  of(e) {
    return new cn(this, e);
  }
}
class H0 {
  /**
  @internal
  */
  constructor(e) {
    this.map = e;
  }
  /**
  Create a [state effect](https://codemirror.net/6/docs/ref/#state.StateEffect) instance of this
  type.
  */
  of(e) {
    return new K(this, e);
  }
}
class K {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Map this effect through a position mapping. Will return
  `undefined` when that ends up deleting the effect.
  */
  map(e) {
    let t = this.type.map(this.value, e);
    return t === void 0 ? void 0 : t == this.value ? this : new K(this.type, t);
  }
  /**
  Tells you whether this effect object is of a given
  [type](https://codemirror.net/6/docs/ref/#state.StateEffectType).
  */
  is(e) {
    return this.type == e;
  }
  /**
  Define a new effect type. The type parameter indicates the type
  of values that his effect holds. It should be a type that
  doesn't include `undefined`, since that is used in
  [mapping](https://codemirror.net/6/docs/ref/#state.StateEffect.map) to indicate that an effect is
  removed.
  */
  static define(e = {}) {
    return new H0(e.map || ((t) => t));
  }
  /**
  Map an array of effects through a change set.
  */
  static mapEffects(e, t) {
    if (!e.length)
      return e;
    let i = [];
    for (let r of e) {
      let s = r.map(t);
      s && i.push(s);
    }
    return i;
  }
}
K.reconfigure = /* @__PURE__ */ K.define();
K.appendConfig = /* @__PURE__ */ K.define();
class Re {
  constructor(e, t, i, r, s, o) {
    this.startState = e, this.changes = t, this.selection = i, this.effects = r, this.annotations = s, this.scrollIntoView = o, this._doc = null, this._state = null, i && pp(i, t.newLength), s.some((l) => l.type == Re.time) || (this.annotations = s.concat(Re.time.of(Date.now())));
  }
  /**
  @internal
  */
  static create(e, t, i, r, s, o) {
    return new Re(e, t, i, r, s, o);
  }
  /**
  The new document produced by the transaction. Contrary to
  [`.state`](https://codemirror.net/6/docs/ref/#state.Transaction.state)`.doc`, accessing this won't
  force the entire new state to be computed right away, so it is
  recommended that [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) use this getter
  when they need to look at the new document.
  */
  get newDoc() {
    return this._doc || (this._doc = this.changes.apply(this.startState.doc));
  }
  /**
  The new selection produced by the transaction. If
  [`this.selection`](https://codemirror.net/6/docs/ref/#state.Transaction.selection) is undefined,
  this will [map](https://codemirror.net/6/docs/ref/#state.EditorSelection.map) the start state's
  current selection through the changes made by the transaction.
  */
  get newSelection() {
    return this.selection || this.startState.selection.map(this.changes);
  }
  /**
  The new state created by the transaction. Computed on demand
  (but retained for subsequent access), so it is recommended not to
  access it in [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) when possible.
  */
  get state() {
    return this._state || this.startState.applyTransaction(this), this._state;
  }
  /**
  Get the value of the given annotation type, if any.
  */
  annotation(e) {
    for (let t of this.annotations)
      if (t.type == e)
        return t.value;
  }
  /**
  Indicates whether the transaction changed the document.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Indicates whether this transaction reconfigures the state
  (through a [configuration compartment](https://codemirror.net/6/docs/ref/#state.Compartment) or
  with a top-level configuration
  [effect](https://codemirror.net/6/docs/ref/#state.StateEffect^reconfigure).
  */
  get reconfigured() {
    return this.startState.config != this.state.config;
  }
  /**
  Returns true if the transaction has a [user
  event](https://codemirror.net/6/docs/ref/#state.Transaction^userEvent) annotation that is equal to
  or more specific than `event`. For example, if the transaction
  has `"select.pointer"` as user event, `"select"` and
  `"select.pointer"` will match it.
  */
  isUserEvent(e) {
    let t = this.annotation(Re.userEvent);
    return !!(t && (t == e || t.length > e.length && t.slice(0, e.length) == e && t[e.length] == "."));
  }
}
Re.time = /* @__PURE__ */ cn.define();
Re.userEvent = /* @__PURE__ */ cn.define();
Re.addToHistory = /* @__PURE__ */ cn.define();
Re.remote = /* @__PURE__ */ cn.define();
function K0(n, e) {
  let t = [];
  for (let i = 0, r = 0; ; ) {
    let s, o;
    if (i < n.length && (r == e.length || e[r] >= n[i]))
      s = n[i++], o = n[i++];
    else if (r < e.length)
      s = e[r++], o = e[r++];
    else
      return t;
    !t.length || t[t.length - 1] < s ? t.push(s, o) : t[t.length - 1] < o && (t[t.length - 1] = o);
  }
}
function wp(n, e, t) {
  var i;
  let r, s, o;
  return t ? (r = e.changes, s = Ee.empty(e.changes.length), o = n.changes.compose(e.changes)) : (r = e.changes.map(n.changes), s = n.changes.mapDesc(e.changes, !0), o = n.changes.compose(r)), {
    changes: o,
    selection: e.selection ? e.selection.map(s) : (i = n.selection) === null || i === void 0 ? void 0 : i.map(r),
    effects: K.mapEffects(n.effects, r).concat(K.mapEffects(e.effects, s)),
    annotations: n.annotations.length ? n.annotations.concat(e.annotations) : e.annotations,
    scrollIntoView: n.scrollIntoView || e.scrollIntoView
  };
}
function ca(n, e, t) {
  let i = e.selection, r = pi(e.annotations);
  return e.userEvent && (r = r.concat(Re.userEvent.of(e.userEvent))), {
    changes: e.changes instanceof Ee ? e.changes : Ee.of(e.changes || [], t, n.facet(gp)),
    selection: i && (i instanceof $ ? i : $.single(i.anchor, i.head)),
    effects: pi(e.effects),
    annotations: r,
    scrollIntoView: !!e.scrollIntoView
  };
}
function Sp(n, e, t) {
  let i = ca(n, e.length ? e[0] : {}, n.doc.length);
  e.length && e[0].filter === !1 && (t = !1);
  for (let s = 1; s < e.length; s++) {
    e[s].filter === !1 && (t = !1);
    let o = !!e[s].sequential;
    i = wp(i, ca(n, e[s], o ? i.changes.newLength : n.doc.length), o);
  }
  let r = Re.create(n, i.changes, i.selection, i.effects, i.annotations, i.scrollIntoView);
  return eb(t ? J0(r) : r);
}
function J0(n) {
  let e = n.startState, t = !0;
  for (let r of e.facet(bp)) {
    let s = r(n);
    if (s === !1) {
      t = !1;
      break;
    }
    Array.isArray(s) && (t = t === !0 ? s : K0(t, s));
  }
  if (t !== !0) {
    let r, s;
    if (t === !1)
      s = n.changes.invertedDesc, r = Ee.empty(e.doc.length);
    else {
      let o = n.changes.filter(t);
      r = o.changes, s = o.filtered.mapDesc(o.changes).invertedDesc;
    }
    n = Re.create(e, r, n.selection && n.selection.map(s), K.mapEffects(n.effects, s), n.annotations, n.scrollIntoView);
  }
  let i = e.facet(yp);
  for (let r = i.length - 1; r >= 0; r--) {
    let s = i[r](n);
    s instanceof Re ? n = s : Array.isArray(s) && s.length == 1 && s[0] instanceof Re ? n = s[0] : n = Sp(e, pi(s), !1);
  }
  return n;
}
function eb(n) {
  let e = n.startState, t = e.facet(kp), i = n;
  for (let r = t.length - 1; r >= 0; r--) {
    let s = t[r](n);
    s && Object.keys(s).length && (i = wp(i, ca(e, s, n.changes.newLength), !0));
  }
  return i == n ? n : Re.create(e, n.changes, n.selection, i.effects, i.annotations, i.scrollIntoView);
}
const tb = [];
function pi(n) {
  return n == null ? tb : Array.isArray(n) ? n : [n];
}
var ve = /* @__PURE__ */ function(n) {
  return n[n.Word = 0] = "Word", n[n.Space = 1] = "Space", n[n.Other = 2] = "Other", n;
}(ve || (ve = {}));
const nb = /[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;
let fa;
try {
  fa = /* @__PURE__ */ new RegExp("[\\p{Alphabetic}\\p{Number}_]", "u");
} catch {
}
function ib(n) {
  if (fa)
    return fa.test(n);
  for (let e = 0; e < n.length; e++) {
    let t = n[e];
    if (/\w/.test(t) || t > "" && (t.toUpperCase() != t.toLowerCase() || nb.test(t)))
      return !0;
  }
  return !1;
}
function rb(n) {
  return (e) => {
    if (!/\S/.test(e))
      return ve.Space;
    if (ib(e))
      return ve.Word;
    for (let t = 0; t < n.length; t++)
      if (e.indexOf(n[t]) > -1)
        return ve.Word;
    return ve.Other;
  };
}
class ee {
  constructor(e, t, i, r, s, o) {
    this.config = e, this.doc = t, this.selection = i, this.values = r, this.status = e.statusTemplate.slice(), this.computeSlot = s, o && (o._state = this);
    for (let l = 0; l < this.config.dynamicSlots.length; l++)
      dr(this, l << 1);
    this.computeSlot = null;
  }
  field(e, t = !0) {
    let i = this.config.address[e.id];
    if (i == null) {
      if (t)
        throw new RangeError("Field is not present in this state");
      return;
    }
    return dr(this, i), Ks(this, i);
  }
  /**
  Create a [transaction](https://codemirror.net/6/docs/ref/#state.Transaction) that updates this
  state. Any number of [transaction specs](https://codemirror.net/6/docs/ref/#state.TransactionSpec)
  can be passed. Unless
  [`sequential`](https://codemirror.net/6/docs/ref/#state.TransactionSpec.sequential) is set, the
  [changes](https://codemirror.net/6/docs/ref/#state.TransactionSpec.changes) (if any) of each spec
  are assumed to start in the _current_ document (not the document
  produced by previous specs), and its
  [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection) and
  [effects](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) are assumed to refer
  to the document created by its _own_ changes. The resulting
  transaction contains the combined effect of all the different
  specs. For [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection), later
  specs take precedence over earlier ones.
  */
  update(...e) {
    return Sp(this, e, !0);
  }
  /**
  @internal
  */
  applyTransaction(e) {
    let t = this.config, { base: i, compartments: r } = t;
    for (let l of e.effects)
      l.is(Br.reconfigure) ? (t && (r = /* @__PURE__ */ new Map(), t.compartments.forEach((a, h) => r.set(h, a)), t = null), r.set(l.value.compartment, l.value.extension)) : l.is(K.reconfigure) ? (t = null, i = l.value) : l.is(K.appendConfig) && (t = null, i = pi(i).concat(l.value));
    let s;
    t ? s = e.startState.values.slice() : (t = Hs.resolve(i, r, this), s = new ee(t, this.doc, this.selection, t.dynamicSlots.map(() => null), (a, h) => h.reconfigure(a, this), null).values);
    let o = e.startState.facet(ua) ? e.newSelection : e.newSelection.asSingle();
    new ee(t, e.newDoc, o, s, (l, a) => a.update(l, e), e);
  }
  /**
  Create a [transaction spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec) that
  replaces every selection range with the given content.
  */
  replaceSelection(e) {
    return typeof e == "string" && (e = this.toText(e)), this.changeByRange((t) => ({
      changes: { from: t.from, to: t.to, insert: e },
      range: $.cursor(t.from + e.length)
    }));
  }
  /**
  Create a set of changes and a new selection by running the given
  function for each range in the active selection. The function
  can return an optional set of changes (in the coordinate space
  of the start document), plus an updated range (in the coordinate
  space of the document produced by the call's own changes). This
  method will merge all the changes and ranges into a single
  changeset and selection, and return it as a [transaction
  spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec), which can be passed to
  [`update`](https://codemirror.net/6/docs/ref/#state.EditorState.update).
  */
  changeByRange(e) {
    let t = this.selection, i = e(t.ranges[0]), r = this.changes(i.changes), s = [i.range], o = pi(i.effects);
    for (let l = 1; l < t.ranges.length; l++) {
      let a = e(t.ranges[l]), h = this.changes(a.changes), u = h.map(r);
      for (let f = 0; f < l; f++)
        s[f] = s[f].map(u);
      let c = r.mapDesc(h, !0);
      s.push(a.range.map(c)), r = r.compose(u), o = K.mapEffects(o, u).concat(K.mapEffects(pi(a.effects), c));
    }
    return {
      changes: r,
      selection: $.create(s, t.mainIndex),
      effects: o
    };
  }
  /**
  Create a [change set](https://codemirror.net/6/docs/ref/#state.ChangeSet) from the given change
  description, taking the state's document length and line
  separator into account.
  */
  changes(e = []) {
    return e instanceof Ee ? e : Ee.of(e, this.doc.length, this.facet(ee.lineSeparator));
  }
  /**
  Using the state's [line
  separator](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator), create a
  [`Text`](https://codemirror.net/6/docs/ref/#state.Text) instance from the given string.
  */
  toText(e) {
    return le.of(e.split(this.facet(ee.lineSeparator) || sa));
  }
  /**
  Return the given range of the document as a string.
  */
  sliceDoc(e = 0, t = this.doc.length) {
    return this.doc.sliceString(e, t, this.lineBreak);
  }
  /**
  Get the value of a state [facet](https://codemirror.net/6/docs/ref/#state.Facet).
  */
  facet(e) {
    let t = this.config.address[e.id];
    return t == null ? e.default : (dr(this, t), Ks(this, t));
  }
  /**
  Convert this state to a JSON-serializable object. When custom
  fields should be serialized, you can pass them in as an object
  mapping property names (in the resulting object, which should
  not use `doc` or `selection`) to fields.
  */
  toJSON(e) {
    let t = {
      doc: this.sliceDoc(),
      selection: this.selection.toJSON()
    };
    if (e)
      for (let i in e) {
        let r = e[i];
        r instanceof De && this.config.address[r.id] != null && (t[i] = r.spec.toJSON(this.field(e[i]), this));
      }
    return t;
  }
  /**
  Deserialize a state from its JSON representation. When custom
  fields should be deserialized, pass the same object you passed
  to [`toJSON`](https://codemirror.net/6/docs/ref/#state.EditorState.toJSON) when serializing as
  third argument.
  */
  static fromJSON(e, t = {}, i) {
    if (!e || typeof e.doc != "string")
      throw new RangeError("Invalid JSON representation for EditorState");
    let r = [];
    if (i) {
      for (let s in i)
        if (Object.prototype.hasOwnProperty.call(e, s)) {
          let o = i[s], l = e[s];
          r.push(o.init((a) => o.spec.fromJSON(l, a)));
        }
    }
    return ee.create({
      doc: e.doc,
      selection: $.fromJSON(e.selection),
      extensions: t.extensions ? r.concat([t.extensions]) : r
    });
  }
  /**
  Create a new state. You'll usually only need this when
  initializing an editor—updated states are created by applying
  transactions.
  */
  static create(e = {}) {
    let t = Hs.resolve(e.extensions || [], /* @__PURE__ */ new Map()), i = e.doc instanceof le ? e.doc : le.of((e.doc || "").split(t.staticFacet(ee.lineSeparator) || sa)), r = e.selection ? e.selection instanceof $ ? e.selection : $.single(e.selection.anchor, e.selection.head) : $.single(0);
    return pp(r, i.length), t.staticFacet(ua) || (r = r.asSingle()), new ee(t, i, r, t.dynamicSlots.map(() => null), (s, o) => o.create(s), null);
  }
  /**
  The size (in columns) of a tab in the document, determined by
  the [`tabSize`](https://codemirror.net/6/docs/ref/#state.EditorState^tabSize) facet.
  */
  get tabSize() {
    return this.facet(ee.tabSize);
  }
  /**
  Get the proper [line-break](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator)
  string for this state.
  */
  get lineBreak() {
    return this.facet(ee.lineSeparator) || `
`;
  }
  /**
  Returns true when the editor is
  [configured](https://codemirror.net/6/docs/ref/#state.EditorState^readOnly) to be read-only.
  */
  get readOnly() {
    return this.facet(xp);
  }
  /**
  Look up a translation for the given phrase (via the
  [`phrases`](https://codemirror.net/6/docs/ref/#state.EditorState^phrases) facet), or return the
  original string if no translation is found.
  
  If additional arguments are passed, they will be inserted in
  place of markers like `$1` (for the first value) and `$2`, etc.
  A single `$` is equivalent to `$1`, and `$$` will produce a
  literal dollar sign.
  */
  phrase(e, ...t) {
    for (let i of this.facet(ee.phrases))
      if (Object.prototype.hasOwnProperty.call(i, e)) {
        e = i[e];
        break;
      }
    return t.length && (e = e.replace(/\$(\$|\d*)/g, (i, r) => {
      if (r == "$")
        return "$";
      let s = +(r || 1);
      return !s || s > t.length ? i : t[s - 1];
    })), e;
  }
  /**
  Find the values for a given language data field, provided by the
  the [`languageData`](https://codemirror.net/6/docs/ref/#state.EditorState^languageData) facet.
  
  Examples of language data fields are...
  
  - [`"commentTokens"`](https://codemirror.net/6/docs/ref/#commands.CommentTokens) for specifying
    comment syntax.
  - [`"autocomplete"`](https://codemirror.net/6/docs/ref/#autocomplete.autocompletion^config.override)
    for providing language-specific completion sources.
  - [`"wordChars"`](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) for adding
    characters that should be considered part of words in this
    language.
  - [`"closeBrackets"`](https://codemirror.net/6/docs/ref/#autocomplete.CloseBracketConfig) controls
    bracket closing behavior.
  */
  languageDataAt(e, t, i = -1) {
    let r = [];
    for (let s of this.facet(Op))
      for (let o of s(this, t, i))
        Object.prototype.hasOwnProperty.call(o, e) && r.push(o[e]);
    return r;
  }
  /**
  Return a function that can categorize strings (expected to
  represent a single [grapheme cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak))
  into one of:
  
   - Word (contains an alphanumeric character or a character
     explicitly listed in the local language's `"wordChars"`
     language data, which should be a string)
   - Space (contains only whitespace)
   - Other (anything else)
  */
  charCategorizer(e) {
    return rb(this.languageDataAt("wordChars", e).join(""));
  }
  /**
  Find the word at the given position, meaning the range
  containing all [word](https://codemirror.net/6/docs/ref/#state.CharCategory.Word) characters
  around it. If no word characters are adjacent to the position,
  this returns null.
  */
  wordAt(e) {
    let { text: t, from: i, length: r } = this.doc.lineAt(e), s = this.charCategorizer(e), o = e - i, l = e - i;
    for (; o > 0; ) {
      let a = Be(t, o, !1);
      if (s(t.slice(a, o)) != ve.Word)
        break;
      o = a;
    }
    for (; l < r; ) {
      let a = Be(t, l);
      if (s(t.slice(l, a)) != ve.Word)
        break;
      l = a;
    }
    return o == l ? null : $.range(o + i, l + i);
  }
}
ee.allowMultipleSelections = ua;
ee.tabSize = /* @__PURE__ */ B.define({
  combine: (n) => n.length ? n[0] : 4
});
ee.lineSeparator = gp;
ee.readOnly = xp;
ee.phrases = /* @__PURE__ */ B.define({
  compare(n, e) {
    let t = Object.keys(n), i = Object.keys(e);
    return t.length == i.length && t.every((r) => n[r] == e[r]);
  }
});
ee.languageData = Op;
ee.changeFilter = bp;
ee.transactionFilter = yp;
ee.transactionExtender = kp;
Br.reconfigure = /* @__PURE__ */ K.define();
function Ht(n, e, t = {}) {
  let i = {};
  for (let r of n)
    for (let s of Object.keys(r)) {
      let o = r[s], l = i[s];
      if (l === void 0)
        i[s] = o;
      else if (!(l === o || o === void 0))
        if (Object.hasOwnProperty.call(t, s))
          i[s] = t[s](l, o);
        else
          throw new Error("Config merge conflict for field " + s);
    }
  for (let r in e)
    i[r] === void 0 && (i[r] = e[r]);
  return i;
}
class Un {
  /**
  Compare this value with another value. Used when comparing
  rangesets. The default implementation compares by identity.
  Unless you are only creating a fixed number of unique instances
  of your value type, it is a good idea to implement this
  properly.
  */
  eq(e) {
    return this == e;
  }
  /**
  Create a [range](https://codemirror.net/6/docs/ref/#state.Range) with this value.
  */
  range(e, t = e) {
    return da.create(e, t, this);
  }
}
Un.prototype.startSide = Un.prototype.endSide = 0;
Un.prototype.point = !1;
Un.prototype.mapMode = qe.TrackDel;
let da = class vp {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.value = i;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new vp(e, t, i);
  }
};
function pa(n, e) {
  return n.from - e.from || n.value.startSide - e.value.startSide;
}
class Qh {
  constructor(e, t, i, r) {
    this.from = e, this.to = t, this.value = i, this.maxPoint = r;
  }
  get length() {
    return this.to[this.to.length - 1];
  }
  // Find the index of the given position and side. Use the ranges'
  // `from` pos when `end == false`, `to` when `end == true`.
  findIndex(e, t, i, r = 0) {
    let s = i ? this.to : this.from;
    for (let o = r, l = s.length; ; ) {
      if (o == l)
        return o;
      let a = o + l >> 1, h = s[a] - e || (i ? this.value[a].endSide : this.value[a].startSide) - t;
      if (a == o)
        return h >= 0 ? o : l;
      h >= 0 ? l = a : o = a + 1;
    }
  }
  between(e, t, i, r) {
    for (let s = this.findIndex(t, -1e9, !0), o = this.findIndex(i, 1e9, !1, s); s < o; s++)
      if (r(this.from[s] + e, this.to[s] + e, this.value[s]) === !1)
        return !1;
  }
  map(e, t) {
    let i = [], r = [], s = [], o = -1, l = -1;
    for (let a = 0; a < this.value.length; a++) {
      let h = this.value[a], u = this.from[a] + e, c = this.to[a] + e, f, d;
      if (u == c) {
        let p = t.mapPos(u, h.startSide, h.mapMode);
        if (p == null || (f = d = p, h.startSide != h.endSide && (d = t.mapPos(u, h.endSide), d < f)))
          continue;
      } else if (f = t.mapPos(u, h.startSide), d = t.mapPos(c, h.endSide), f > d || f == d && h.startSide > 0 && h.endSide <= 0)
        continue;
      (d - f || h.endSide - h.startSide) < 0 || (o < 0 && (o = f), h.point && (l = Math.max(l, d - f)), i.push(h), r.push(f - o), s.push(d - o));
    }
    return { mapped: i.length ? new Qh(r, s, i, l) : null, pos: o };
  }
}
class oe {
  constructor(e, t, i, r) {
    this.chunkPos = e, this.chunk = t, this.nextLayer = i, this.maxPoint = r;
  }
  /**
  @internal
  */
  static create(e, t, i, r) {
    return new oe(e, t, i, r);
  }
  /**
  @internal
  */
  get length() {
    let e = this.chunk.length - 1;
    return e < 0 ? 0 : Math.max(this.chunkEnd(e), this.nextLayer.length);
  }
  /**
  The number of ranges in the set.
  */
  get size() {
    if (this.isEmpty)
      return 0;
    let e = this.nextLayer.size;
    for (let t of this.chunk)
      e += t.value.length;
    return e;
  }
  /**
  @internal
  */
  chunkEnd(e) {
    return this.chunkPos[e] + this.chunk[e].length;
  }
  /**
  Update the range set, optionally adding new ranges or filtering
  out existing ones.
  
  (Note: The type parameter is just there as a kludge to work
  around TypeScript variance issues that prevented `RangeSet<X>`
  from being a subtype of `RangeSet<Y>` when `X` is a subtype of
  `Y`.)
  */
  update(e) {
    let { add: t = [], sort: i = !1, filterFrom: r = 0, filterTo: s = this.length } = e, o = e.filter;
    if (t.length == 0 && !o)
      return this;
    if (i && (t = t.slice().sort(pa)), this.isEmpty)
      return t.length ? oe.of(t) : this;
    let l = new Pp(this, null, -1).goto(0), a = 0, h = [], u = new $n();
    for (; l.value || a < t.length; )
      if (a < t.length && (l.from - t[a].from || l.startSide - t[a].value.startSide) >= 0) {
        let c = t[a++];
        u.addInner(c.from, c.to, c.value) || h.push(c);
      } else
        l.rangeIndex == 1 && l.chunkIndex < this.chunk.length && (a == t.length || this.chunkEnd(l.chunkIndex) < t[a].from) && (!o || r > this.chunkEnd(l.chunkIndex) || s < this.chunkPos[l.chunkIndex]) && u.addChunk(this.chunkPos[l.chunkIndex], this.chunk[l.chunkIndex]) ? l.nextChunk() : ((!o || r > l.to || s < l.from || o(l.from, l.to, l.value)) && (u.addInner(l.from, l.to, l.value) || h.push(da.create(l.from, l.to, l.value))), l.next());
    return u.finishInner(this.nextLayer.isEmpty && !h.length ? oe.empty : this.nextLayer.update({ add: h, filter: o, filterFrom: r, filterTo: s }));
  }
  /**
  Map this range set through a set of changes, return the new set.
  */
  map(e) {
    if (e.empty || this.isEmpty)
      return this;
    let t = [], i = [], r = -1;
    for (let o = 0; o < this.chunk.length; o++) {
      let l = this.chunkPos[o], a = this.chunk[o], h = e.touchesRange(l, l + a.length);
      if (h === !1)
        r = Math.max(r, a.maxPoint), t.push(a), i.push(e.mapPos(l));
      else if (h === !0) {
        let { mapped: u, pos: c } = a.map(l, e);
        u && (r = Math.max(r, u.maxPoint), t.push(u), i.push(c));
      }
    }
    let s = this.nextLayer.map(e);
    return t.length == 0 ? s : new oe(i, t, s || oe.empty, r);
  }
  /**
  Iterate over the ranges that touch the region `from` to `to`,
  calling `f` for each. There is no guarantee that the ranges will
  be reported in any specific order. When the callback returns
  `false`, iteration stops.
  */
  between(e, t, i) {
    if (!this.isEmpty) {
      for (let r = 0; r < this.chunk.length; r++) {
        let s = this.chunkPos[r], o = this.chunk[r];
        if (t >= s && e <= s + o.length && o.between(s, e - s, t - s, i) === !1)
          return;
      }
      this.nextLayer.between(e, t, i);
    }
  }
  /**
  Iterate over the ranges in this set, in order, including all
  ranges that end at or after `from`.
  */
  iter(e = 0) {
    return Sr.from([this]).goto(e);
  }
  /**
  @internal
  */
  get isEmpty() {
    return this.nextLayer == this;
  }
  /**
  Iterate over the ranges in a collection of sets, in order,
  starting from `from`.
  */
  static iter(e, t = 0) {
    return Sr.from(e).goto(t);
  }
  /**
  Iterate over two groups of sets, calling methods on `comparator`
  to notify it of possible differences.
  */
  static compare(e, t, i, r, s = -1) {
    let o = e.filter((c) => c.maxPoint > 0 || !c.isEmpty && c.maxPoint >= s), l = t.filter((c) => c.maxPoint > 0 || !c.isEmpty && c.maxPoint >= s), a = qu(o, l, i), h = new Ui(o, a, s), u = new Ui(l, a, s);
    i.iterGaps((c, f, d) => Wu(h, c, u, f, d, r)), i.empty && i.length == 0 && Wu(h, 0, u, 0, 0, r);
  }
  /**
  Compare the contents of two groups of range sets, returning true
  if they are equivalent in the given range.
  */
  static eq(e, t, i = 0, r) {
    r == null && (r = 999999999);
    let s = e.filter((u) => !u.isEmpty && t.indexOf(u) < 0), o = t.filter((u) => !u.isEmpty && e.indexOf(u) < 0);
    if (s.length != o.length)
      return !1;
    if (!s.length)
      return !0;
    let l = qu(s, o), a = new Ui(s, l, 0).goto(i), h = new Ui(o, l, 0).goto(i);
    for (; ; ) {
      if (a.to != h.to || !ma(a.active, h.active) || a.point && (!h.point || !a.point.eq(h.point)))
        return !1;
      if (a.to > r)
        return !0;
      a.next(), h.next();
    }
  }
  /**
  Iterate over a group of range sets at the same time, notifying
  the iterator about the ranges covering every given piece of
  content. Returns the open count (see
  [`SpanIterator.span`](https://codemirror.net/6/docs/ref/#state.SpanIterator.span)) at the end
  of the iteration.
  */
  static spans(e, t, i, r, s = -1) {
    let o = new Ui(e, null, s).goto(t), l = t, a = o.openStart;
    for (; ; ) {
      let h = Math.min(o.to, i);
      if (o.point) {
        let u = o.activeForPoint(o.to), c = o.pointFrom < t ? u.length + 1 : o.point.startSide < 0 ? u.length : Math.min(u.length, a);
        r.point(l, h, o.point, u, c, o.pointRank), a = Math.min(o.openEnd(h), u.length);
      } else
        h > l && (r.span(l, h, o.active, a), a = o.openEnd(h));
      if (o.to > i)
        return a + (o.point && o.to > i ? 1 : 0);
      l = o.to, o.next();
    }
  }
  /**
  Create a range set for the given range or array of ranges. By
  default, this expects the ranges to be _sorted_ (by start
  position and, if two start at the same position,
  `value.startSide`). You can pass `true` as second argument to
  cause the method to sort them.
  */
  static of(e, t = !1) {
    let i = new $n();
    for (let r of e instanceof da ? [e] : t ? sb(e) : e)
      i.add(r.from, r.to, r.value);
    return i.finish();
  }
  /**
  Join an array of range sets into a single set.
  */
  static join(e) {
    if (!e.length)
      return oe.empty;
    let t = e[e.length - 1];
    for (let i = e.length - 2; i >= 0; i--)
      for (let r = e[i]; r != oe.empty; r = r.nextLayer)
        t = new oe(r.chunkPos, r.chunk, t, Math.max(r.maxPoint, t.maxPoint));
    return t;
  }
}
oe.empty = /* @__PURE__ */ new oe([], [], null, -1);
function sb(n) {
  if (n.length > 1)
    for (let e = n[0], t = 1; t < n.length; t++) {
      let i = n[t];
      if (pa(e, i) > 0)
        return n.slice().sort(pa);
      e = i;
    }
  return n;
}
oe.empty.nextLayer = oe.empty;
class $n {
  finishChunk(e) {
    this.chunks.push(new Qh(this.from, this.to, this.value, this.maxPoint)), this.chunkPos.push(this.chunkStart), this.chunkStart = -1, this.setMaxPoint = Math.max(this.setMaxPoint, this.maxPoint), this.maxPoint = -1, e && (this.from = [], this.to = [], this.value = []);
  }
  /**
  Create an empty builder.
  */
  constructor() {
    this.chunks = [], this.chunkPos = [], this.chunkStart = -1, this.last = null, this.lastFrom = -1e9, this.lastTo = -1e9, this.from = [], this.to = [], this.value = [], this.maxPoint = -1, this.setMaxPoint = -1, this.nextLayer = null;
  }
  /**
  Add a range. Ranges should be added in sorted (by `from` and
  `value.startSide`) order.
  */
  add(e, t, i) {
    this.addInner(e, t, i) || (this.nextLayer || (this.nextLayer = new $n())).add(e, t, i);
  }
  /**
  @internal
  */
  addInner(e, t, i) {
    let r = e - this.lastTo || i.startSide - this.last.endSide;
    if (r <= 0 && (e - this.lastFrom || i.startSide - this.last.startSide) < 0)
      throw new Error("Ranges must be added sorted by `from` position and `startSide`");
    return r < 0 ? !1 : (this.from.length == 250 && this.finishChunk(!0), this.chunkStart < 0 && (this.chunkStart = e), this.from.push(e - this.chunkStart), this.to.push(t - this.chunkStart), this.last = i, this.lastFrom = e, this.lastTo = t, this.value.push(i), i.point && (this.maxPoint = Math.max(this.maxPoint, t - e)), !0);
  }
  /**
  @internal
  */
  addChunk(e, t) {
    if ((e - this.lastTo || t.value[0].startSide - this.last.endSide) < 0)
      return !1;
    this.from.length && this.finishChunk(!0), this.setMaxPoint = Math.max(this.setMaxPoint, t.maxPoint), this.chunks.push(t), this.chunkPos.push(e);
    let i = t.value.length - 1;
    return this.last = t.value[i], this.lastFrom = t.from[i] + e, this.lastTo = t.to[i] + e, !0;
  }
  /**
  Finish the range set. Returns the new set. The builder can't be
  used anymore after this has been called.
  */
  finish() {
    return this.finishInner(oe.empty);
  }
  /**
  @internal
  */
  finishInner(e) {
    if (this.from.length && this.finishChunk(!1), this.chunks.length == 0)
      return e;
    let t = oe.create(this.chunkPos, this.chunks, this.nextLayer ? this.nextLayer.finishInner(e) : e, this.setMaxPoint);
    return this.from = null, t;
  }
}
function qu(n, e, t) {
  let i = /* @__PURE__ */ new Map();
  for (let s of n)
    for (let o = 0; o < s.chunk.length; o++)
      s.chunk[o].maxPoint <= 0 && i.set(s.chunk[o], s.chunkPos[o]);
  let r = /* @__PURE__ */ new Set();
  for (let s of e)
    for (let o = 0; o < s.chunk.length; o++) {
      let l = i.get(s.chunk[o]);
      l != null && (t ? t.mapPos(l) : l) == s.chunkPos[o] && !(t != null && t.touchesRange(l, l + s.chunk[o].length)) && r.add(s.chunk[o]);
    }
  return r;
}
class Pp {
  constructor(e, t, i, r = 0) {
    this.layer = e, this.skip = t, this.minPoint = i, this.rank = r;
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  get endSide() {
    return this.value ? this.value.endSide : 0;
  }
  goto(e, t = -1e9) {
    return this.chunkIndex = this.rangeIndex = 0, this.gotoInner(e, t, !1), this;
  }
  gotoInner(e, t, i) {
    for (; this.chunkIndex < this.layer.chunk.length; ) {
      let r = this.layer.chunk[this.chunkIndex];
      if (!(this.skip && this.skip.has(r) || this.layer.chunkEnd(this.chunkIndex) < e || r.maxPoint < this.minPoint))
        break;
      this.chunkIndex++, i = !1;
    }
    if (this.chunkIndex < this.layer.chunk.length) {
      let r = this.layer.chunk[this.chunkIndex].findIndex(e - this.layer.chunkPos[this.chunkIndex], t, !0);
      (!i || this.rangeIndex < r) && this.setRangeIndex(r);
    }
    this.next();
  }
  forward(e, t) {
    (this.to - e || this.endSide - t) < 0 && this.gotoInner(e, t, !0);
  }
  next() {
    for (; ; )
      if (this.chunkIndex == this.layer.chunk.length) {
        this.from = this.to = 1e9, this.value = null;
        break;
      } else {
        let e = this.layer.chunkPos[this.chunkIndex], t = this.layer.chunk[this.chunkIndex], i = e + t.from[this.rangeIndex];
        if (this.from = i, this.to = e + t.to[this.rangeIndex], this.value = t.value[this.rangeIndex], this.setRangeIndex(this.rangeIndex + 1), this.minPoint < 0 || this.value.point && this.to - this.from >= this.minPoint)
          break;
      }
  }
  setRangeIndex(e) {
    if (e == this.layer.chunk[this.chunkIndex].value.length) {
      if (this.chunkIndex++, this.skip)
        for (; this.chunkIndex < this.layer.chunk.length && this.skip.has(this.layer.chunk[this.chunkIndex]); )
          this.chunkIndex++;
      this.rangeIndex = 0;
    } else
      this.rangeIndex = e;
  }
  nextChunk() {
    this.chunkIndex++, this.rangeIndex = 0, this.next();
  }
  compare(e) {
    return this.from - e.from || this.startSide - e.startSide || this.rank - e.rank || this.to - e.to || this.endSide - e.endSide;
  }
}
class Sr {
  constructor(e) {
    this.heap = e;
  }
  static from(e, t = null, i = -1) {
    let r = [];
    for (let s = 0; s < e.length; s++)
      for (let o = e[s]; !o.isEmpty; o = o.nextLayer)
        o.maxPoint >= i && r.push(new Pp(o, t, i, s));
    return r.length == 1 ? r[0] : new Sr(r);
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  goto(e, t = -1e9) {
    for (let i of this.heap)
      i.goto(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      rl(this.heap, i);
    return this.next(), this;
  }
  forward(e, t) {
    for (let i of this.heap)
      i.forward(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      rl(this.heap, i);
    (this.to - e || this.value.endSide - t) < 0 && this.next();
  }
  next() {
    if (this.heap.length == 0)
      this.from = this.to = 1e9, this.value = null, this.rank = -1;
    else {
      let e = this.heap[0];
      this.from = e.from, this.to = e.to, this.value = e.value, this.rank = e.rank, e.value && e.next(), rl(this.heap, 0);
    }
  }
}
function rl(n, e) {
  for (let t = n[e]; ; ) {
    let i = (e << 1) + 1;
    if (i >= n.length)
      break;
    let r = n[i];
    if (i + 1 < n.length && r.compare(n[i + 1]) >= 0 && (r = n[i + 1], i++), t.compare(r) < 0)
      break;
    n[i] = t, n[e] = r, e = i;
  }
}
class Ui {
  constructor(e, t, i) {
    this.minPoint = i, this.active = [], this.activeTo = [], this.activeRank = [], this.minActive = -1, this.point = null, this.pointFrom = 0, this.pointRank = 0, this.to = -1e9, this.endSide = 0, this.openStart = -1, this.cursor = Sr.from(e, t, i);
  }
  goto(e, t = -1e9) {
    return this.cursor.goto(e, t), this.active.length = this.activeTo.length = this.activeRank.length = 0, this.minActive = -1, this.to = e, this.endSide = t, this.openStart = -1, this.next(), this;
  }
  forward(e, t) {
    for (; this.minActive > -1 && (this.activeTo[this.minActive] - e || this.active[this.minActive].endSide - t) < 0; )
      this.removeActive(this.minActive);
    this.cursor.forward(e, t);
  }
  removeActive(e) {
    ns(this.active, e), ns(this.activeTo, e), ns(this.activeRank, e), this.minActive = Bu(this.active, this.activeTo);
  }
  addActive(e) {
    let t = 0, { value: i, to: r, rank: s } = this.cursor;
    for (; t < this.activeRank.length && (s - this.activeRank[t] || r - this.activeTo[t]) > 0; )
      t++;
    is(this.active, t, i), is(this.activeTo, t, r), is(this.activeRank, t, s), e && is(e, t, this.cursor.from), this.minActive = Bu(this.active, this.activeTo);
  }
  // After calling this, if `this.point` != null, the next range is a
  // point. Otherwise, it's a regular range, covered by `this.active`.
  next() {
    let e = this.to, t = this.point;
    this.point = null;
    let i = this.openStart < 0 ? [] : null;
    for (; ; ) {
      let r = this.minActive;
      if (r > -1 && (this.activeTo[r] - this.cursor.from || this.active[r].endSide - this.cursor.startSide) < 0) {
        if (this.activeTo[r] > e) {
          this.to = this.activeTo[r], this.endSide = this.active[r].endSide;
          break;
        }
        this.removeActive(r), i && ns(i, r);
      } else if (this.cursor.value)
        if (this.cursor.from > e) {
          this.to = this.cursor.from, this.endSide = this.cursor.startSide;
          break;
        } else {
          let s = this.cursor.value;
          if (!s.point)
            this.addActive(i), this.cursor.next();
          else if (t && this.cursor.to == this.to && this.cursor.from < this.cursor.to)
            this.cursor.next();
          else {
            this.point = s, this.pointFrom = this.cursor.from, this.pointRank = this.cursor.rank, this.to = this.cursor.to, this.endSide = s.endSide, this.cursor.next(), this.forward(this.to, this.endSide);
            break;
          }
        }
      else {
        this.to = this.endSide = 1e9;
        break;
      }
    }
    if (i) {
      this.openStart = 0;
      for (let r = i.length - 1; r >= 0 && i[r] < e; r--)
        this.openStart++;
    }
  }
  activeForPoint(e) {
    if (!this.active.length)
      return this.active;
    let t = [];
    for (let i = this.active.length - 1; i >= 0 && !(this.activeRank[i] < this.pointRank); i--)
      (this.activeTo[i] > e || this.activeTo[i] == e && this.active[i].endSide >= this.point.endSide) && t.push(this.active[i]);
    return t.reverse();
  }
  openEnd(e) {
    let t = 0;
    for (let i = this.activeTo.length - 1; i >= 0 && this.activeTo[i] > e; i--)
      t++;
    return t;
  }
}
function Wu(n, e, t, i, r, s) {
  n.goto(e), t.goto(i);
  let o = i + r, l = i, a = i - e;
  for (; ; ) {
    let h = n.to + a - t.to || n.endSide - t.endSide, u = h < 0 ? n.to + a : t.to, c = Math.min(u, o);
    if (n.point || t.point ? n.point && t.point && (n.point == t.point || n.point.eq(t.point)) && ma(n.activeForPoint(n.to), t.activeForPoint(t.to)) || s.comparePoint(l, c, n.point, t.point) : c > l && !ma(n.active, t.active) && s.compareRange(l, c, n.active, t.active), u > o)
      break;
    l = u, h <= 0 && n.next(), h >= 0 && t.next();
  }
}
function ma(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (n[t] != e[t] && !n[t].eq(e[t]))
      return !1;
  return !0;
}
function ns(n, e) {
  for (let t = e, i = n.length - 1; t < i; t++)
    n[t] = n[t + 1];
  n.pop();
}
function is(n, e, t) {
  for (let i = n.length - 1; i >= e; i--)
    n[i + 1] = n[i];
  n[e] = t;
}
function Bu(n, e) {
  let t = -1, i = 1e9;
  for (let r = 0; r < e.length; r++)
    (e[r] - i || n[r].endSide - n[t].endSide) < 0 && (t = r, i = e[r]);
  return t;
}
function Mt(n, e, t = n.length) {
  let i = 0;
  for (let r = 0; r < t; )
    n.charCodeAt(r) == 9 ? (i += e - i % e, r++) : (i++, r = Be(n, r));
  return i;
}
function Oa(n, e, t, i) {
  for (let r = 0, s = 0; ; ) {
    if (s >= e)
      return r;
    if (r == n.length)
      break;
    s += n.charCodeAt(r) == 9 ? t - s % t : 1, r = Be(n, r);
  }
  return i === !0 ? -1 : n.length;
}
const ga = "ͼ", Vu = typeof Symbol > "u" ? "__" + ga : Symbol.for(ga), ba = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), Yu = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class Cn {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(e, t) {
    this.rules = [];
    let { finish: i } = t || {};
    function r(o) {
      return /^@/.test(o) ? [o] : o.split(/,\s*/);
    }
    function s(o, l, a, h) {
      let u = [], c = /^@(\w+)\b/.exec(o[0]), f = c && c[1] == "keyframes";
      if (c && l == null)
        return a.push(o[0] + ";");
      for (let d in l) {
        let p = l[d];
        if (/&/.test(d))
          s(
            d.split(/,\s*/).map((m) => o.map((O) => m.replace(/&/, O))).reduce((m, O) => m.concat(O)),
            p,
            a
          );
        else if (p && typeof p == "object") {
          if (!c)
            throw new RangeError("The value of a property (" + d + ") should be a primitive value.");
          s(r(d), p, u, f);
        } else
          p != null && u.push(d.replace(/_.*/, "").replace(/[A-Z]/g, (m) => "-" + m.toLowerCase()) + ": " + p + ";");
      }
      (u.length || f) && a.push((i && !c && !h ? o.map(i) : o).join(", ") + " {" + u.join(" ") + "}");
    }
    for (let o in e)
      s(r(o), e[o], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let e = Yu[Vu] || 1;
    return Yu[Vu] = e + 1, ga + e.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(e, t, i) {
    let r = e[ba], s = i && i.nonce;
    r ? s && r.setNonce(s) : r = new ob(e, s), r.mount(Array.isArray(t) ? t : [t], e);
  }
}
let ju = /* @__PURE__ */ new Map();
class ob {
  constructor(e, t) {
    let i = e.ownerDocument || e, r = i.defaultView;
    if (!e.head && e.adoptedStyleSheets && r.CSSStyleSheet) {
      let s = ju.get(i);
      if (s)
        return e[ba] = s;
      this.sheet = new r.CSSStyleSheet(), ju.set(i, this);
    } else
      this.styleTag = i.createElement("style"), t && this.styleTag.setAttribute("nonce", t);
    this.modules = [], e[ba] = this;
  }
  mount(e, t) {
    let i = this.sheet, r = 0, s = 0;
    for (let o = 0; o < e.length; o++) {
      let l = e[o], a = this.modules.indexOf(l);
      if (a < s && a > -1 && (this.modules.splice(a, 1), s--, a = -1), a == -1) {
        if (this.modules.splice(s++, 0, l), i)
          for (let h = 0; h < l.rules.length; h++)
            i.insertRule(l.rules[h], r++);
      } else {
        for (; s < a; )
          r += this.modules[s++].rules.length;
        r += l.rules.length, s++;
      }
    }
    if (i)
      t.adoptedStyleSheets.indexOf(this.sheet) < 0 && (t.adoptedStyleSheets = [this.sheet, ...t.adoptedStyleSheets]);
    else {
      let o = "";
      for (let a = 0; a < this.modules.length; a++)
        o += this.modules[a].getRules() + `
`;
      this.styleTag.textContent = o;
      let l = t.head || t;
      this.styleTag.parentNode != l && l.insertBefore(this.styleTag, l.firstChild);
    }
  }
  setNonce(e) {
    this.styleTag && this.styleTag.getAttribute("nonce") != e && this.styleTag.setAttribute("nonce", e);
  }
}
var Tn = {
  8: "Backspace",
  9: "Tab",
  10: "Enter",
  12: "NumLock",
  13: "Enter",
  16: "Shift",
  17: "Control",
  18: "Alt",
  20: "CapsLock",
  27: "Escape",
  32: " ",
  33: "PageUp",
  34: "PageDown",
  35: "End",
  36: "Home",
  37: "ArrowLeft",
  38: "ArrowUp",
  39: "ArrowRight",
  40: "ArrowDown",
  44: "PrintScreen",
  45: "Insert",
  46: "Delete",
  59: ";",
  61: "=",
  91: "Meta",
  92: "Meta",
  106: "*",
  107: "+",
  108: ",",
  109: "-",
  110: ".",
  111: "/",
  144: "NumLock",
  145: "ScrollLock",
  160: "Shift",
  161: "Shift",
  162: "Control",
  163: "Control",
  164: "Alt",
  165: "Alt",
  173: "-",
  186: ";",
  187: "=",
  188: ",",
  189: "-",
  190: ".",
  191: "/",
  192: "`",
  219: "[",
  220: "\\",
  221: "]",
  222: "'"
}, vr = {
  48: ")",
  49: "!",
  50: "@",
  51: "#",
  52: "$",
  53: "%",
  54: "^",
  55: "&",
  56: "*",
  57: "(",
  59: ":",
  61: "+",
  173: "_",
  186: ":",
  187: "+",
  188: "<",
  189: "_",
  190: ">",
  191: "?",
  192: "~",
  219: "{",
  220: "|",
  221: "}",
  222: '"'
}, lb = typeof navigator < "u" && /Mac/.test(navigator.platform), ab = typeof navigator < "u" && /MSIE \d|Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent);
for (var _e = 0; _e < 10; _e++)
  Tn[48 + _e] = Tn[96 + _e] = String(_e);
for (var _e = 1; _e <= 24; _e++)
  Tn[_e + 111] = "F" + _e;
for (var _e = 65; _e <= 90; _e++)
  Tn[_e] = String.fromCharCode(_e + 32), vr[_e] = String.fromCharCode(_e);
for (var sl in Tn)
  vr.hasOwnProperty(sl) || (vr[sl] = Tn[sl]);
function hb(n) {
  var e = lb && n.metaKey && n.shiftKey && !n.ctrlKey && !n.altKey || ab && n.shiftKey && n.key && n.key.length == 1 || n.key == "Unidentified", t = !e && n.key || (n.shiftKey ? vr : Tn)[n.keyCode] || n.key || "Unidentified";
  return t == "Esc" && (t = "Escape"), t == "Del" && (t = "Delete"), t == "Left" && (t = "ArrowLeft"), t == "Up" && (t = "ArrowUp"), t == "Right" && (t = "ArrowRight"), t == "Down" && (t = "ArrowDown"), t;
}
function Js(n) {
  let e;
  return n.nodeType == 11 ? e = n.getSelection ? n : n.ownerDocument : e = n, e.getSelection();
}
function ya(n, e) {
  return e ? n == e || n.contains(e.nodeType != 1 ? e.parentNode : e) : !1;
}
function ub(n) {
  let e = n.activeElement;
  for (; e && e.shadowRoot; )
    e = e.shadowRoot.activeElement;
  return e;
}
function Ds(n, e) {
  if (!e.anchorNode)
    return !1;
  try {
    return ya(n, e.anchorNode);
  } catch {
    return !1;
  }
}
function vi(n) {
  return n.nodeType == 3 ? Gn(n, 0, n.nodeValue.length).getClientRects() : n.nodeType == 1 ? n.getClientRects() : [];
}
function pr(n, e, t, i) {
  return t ? Nu(n, e, t, i, -1) || Nu(n, e, t, i, 1) : !1;
}
function Fn(n) {
  for (var e = 0; ; e++)
    if (n = n.previousSibling, !n)
      return e;
}
function eo(n) {
  return n.nodeType == 1 && /^(DIV|P|LI|UL|OL|BLOCKQUOTE|DD|DT|H\d|SECTION|PRE)$/.test(n.nodeName);
}
function Nu(n, e, t, i, r) {
  for (; ; ) {
    if (n == t && e == i)
      return !0;
    if (e == (r < 0 ? 0 : ln(n))) {
      if (n.nodeName == "DIV")
        return !1;
      let s = n.parentNode;
      if (!s || s.nodeType != 1)
        return !1;
      e = Fn(n) + (r < 0 ? 0 : 1), n = s;
    } else if (n.nodeType == 1) {
      if (n = n.childNodes[e + (r < 0 ? -1 : 0)], n.nodeType == 1 && n.contentEditable == "false")
        return !1;
      e = r < 0 ? ln(n) : 0;
    } else
      return !1;
  }
}
function ln(n) {
  return n.nodeType == 3 ? n.nodeValue.length : n.childNodes.length;
}
function Xo(n, e) {
  let t = e ? n.left : n.right;
  return { left: t, right: t, top: n.top, bottom: n.bottom };
}
function cb(n) {
  let e = n.visualViewport;
  return e ? {
    left: 0,
    right: e.width,
    top: 0,
    bottom: e.height
  } : {
    left: 0,
    right: n.innerWidth,
    top: 0,
    bottom: n.innerHeight
  };
}
function Qp(n, e) {
  let t = e.width / n.offsetWidth, i = e.height / n.offsetHeight;
  return (t > 0.995 && t < 1.005 || !isFinite(t) || Math.abs(e.width - n.offsetWidth) < 1) && (t = 1), (i > 0.995 && i < 1.005 || !isFinite(i) || Math.abs(e.height - n.offsetHeight) < 1) && (i = 1), { scaleX: t, scaleY: i };
}
function fb(n, e, t, i, r, s, o, l) {
  let a = n.ownerDocument, h = a.defaultView || window;
  for (let u = n, c = !1; u && !c; )
    if (u.nodeType == 1) {
      let f, d = u == a.body, p = 1, m = 1;
      if (d)
        f = cb(h);
      else {
        if (/^(fixed|sticky)$/.test(getComputedStyle(u).position) && (c = !0), u.scrollHeight <= u.clientHeight && u.scrollWidth <= u.clientWidth) {
          u = u.assignedSlot || u.parentNode;
          continue;
        }
        let b = u.getBoundingClientRect();
        ({ scaleX: p, scaleY: m } = Qp(u, b)), f = {
          left: b.left,
          right: b.left + u.clientWidth * p,
          top: b.top,
          bottom: b.top + u.clientHeight * m
        };
      }
      let O = 0, g = 0;
      if (r == "nearest")
        e.top < f.top ? (g = -(f.top - e.top + o), t > 0 && e.bottom > f.bottom + g && (g = e.bottom - f.bottom + g + o)) : e.bottom > f.bottom && (g = e.bottom - f.bottom + o, t < 0 && e.top - g < f.top && (g = -(f.top + g - e.top + o)));
      else {
        let b = e.bottom - e.top, S = f.bottom - f.top;
        g = (r == "center" && b <= S ? e.top + b / 2 - S / 2 : r == "start" || r == "center" && t < 0 ? e.top - o : e.bottom - S + o) - f.top;
      }
      if (i == "nearest" ? e.left < f.left ? (O = -(f.left - e.left + s), t > 0 && e.right > f.right + O && (O = e.right - f.right + O + s)) : e.right > f.right && (O = e.right - f.right + s, t < 0 && e.left < f.left + O && (O = -(f.left + O - e.left + s))) : O = (i == "center" ? e.left + (e.right - e.left) / 2 - (f.right - f.left) / 2 : i == "start" == l ? e.left - s : e.right - (f.right - f.left) + s) - f.left, O || g)
        if (d)
          h.scrollBy(O, g);
        else {
          let b = 0, S = 0;
          if (g) {
            let Q = u.scrollTop;
            u.scrollTop += g / m, S = (u.scrollTop - Q) * m;
          }
          if (O) {
            let Q = u.scrollLeft;
            u.scrollLeft += O / p, b = (u.scrollLeft - Q) * p;
          }
          e = {
            left: e.left - b,
            top: e.top - S,
            right: e.right - b,
            bottom: e.bottom - S
          }, b && Math.abs(b - O) < 1 && (i = "nearest"), S && Math.abs(S - g) < 1 && (r = "nearest");
        }
      if (d)
        break;
      u = u.assignedSlot || u.parentNode;
    } else if (u.nodeType == 11)
      u = u.host;
    else
      break;
}
function db(n) {
  let e = n.ownerDocument;
  for (let t = n.parentNode; t && t != e.body; )
    if (t.nodeType == 1) {
      if (t.scrollHeight > t.clientHeight || t.scrollWidth > t.clientWidth)
        return t;
      t = t.assignedSlot || t.parentNode;
    } else if (t.nodeType == 11)
      t = t.host;
    else
      break;
  return null;
}
class pb {
  constructor() {
    this.anchorNode = null, this.anchorOffset = 0, this.focusNode = null, this.focusOffset = 0;
  }
  eq(e) {
    return this.anchorNode == e.anchorNode && this.anchorOffset == e.anchorOffset && this.focusNode == e.focusNode && this.focusOffset == e.focusOffset;
  }
  setRange(e) {
    let { anchorNode: t, focusNode: i } = e;
    this.set(t, Math.min(e.anchorOffset, t ? ln(t) : 0), i, Math.min(e.focusOffset, i ? ln(i) : 0));
  }
  set(e, t, i, r) {
    this.anchorNode = e, this.anchorOffset = t, this.focusNode = i, this.focusOffset = r;
  }
}
let ri = null;
function $p(n) {
  if (n.setActive)
    return n.setActive();
  if (ri)
    return n.focus(ri);
  let e = [];
  for (let t = n; t && (e.push(t, t.scrollTop, t.scrollLeft), t != t.ownerDocument); t = t.parentNode)
    ;
  if (n.focus(ri == null ? {
    get preventScroll() {
      return ri = { preventScroll: !0 }, !0;
    }
  } : void 0), !ri) {
    ri = !1;
    for (let t = 0; t < e.length; ) {
      let i = e[t++], r = e[t++], s = e[t++];
      i.scrollTop != r && (i.scrollTop = r), i.scrollLeft != s && (i.scrollLeft = s);
    }
  }
}
let Uu;
function Gn(n, e, t = e) {
  let i = Uu || (Uu = document.createRange());
  return i.setEnd(n, t), i.setStart(n, e), i;
}
function mi(n, e, t, i) {
  let r = { key: e, code: e, keyCode: t, which: t, cancelable: !0 };
  i && ({ altKey: r.altKey, ctrlKey: r.ctrlKey, shiftKey: r.shiftKey, metaKey: r.metaKey } = i);
  let s = new KeyboardEvent("keydown", r);
  s.synthetic = !0, n.dispatchEvent(s);
  let o = new KeyboardEvent("keyup", r);
  return o.synthetic = !0, n.dispatchEvent(o), s.defaultPrevented || o.defaultPrevented;
}
function mb(n) {
  for (; n; ) {
    if (n && (n.nodeType == 9 || n.nodeType == 11 && n.host))
      return n;
    n = n.assignedSlot || n.parentNode;
  }
  return null;
}
function Cp(n) {
  for (; n.attributes.length; )
    n.removeAttributeNode(n.attributes[0]);
}
function Ob(n, e) {
  let t = e.focusNode, i = e.focusOffset;
  if (!t || e.anchorNode != t || e.anchorOffset != i)
    return !1;
  for (i = Math.min(i, ln(t)); ; )
    if (i) {
      if (t.nodeType != 1)
        return !1;
      let r = t.childNodes[i - 1];
      r.contentEditable == "false" ? i-- : (t = r, i = ln(t));
    } else {
      if (t == n)
        return !0;
      i = Fn(t), t = t.parentNode;
    }
}
function Tp(n) {
  return n.scrollTop > Math.max(1, n.scrollHeight - n.clientHeight - 4);
}
function Ap(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i > 0)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i > 0) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i - 1], i = ln(t);
    } else if (t.parentNode && !eo(t))
      i = Fn(t), t = t.parentNode;
    else
      return null;
  }
}
function Rp(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i < t.nodeValue.length)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i < t.childNodes.length) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i], i = 0;
    } else if (t.parentNode && !eo(t))
      i = Fn(t) + 1, t = t.parentNode;
    else
      return null;
  }
}
class Ye {
  constructor(e, t, i = !0) {
    this.node = e, this.offset = t, this.precise = i;
  }
  static before(e, t) {
    return new Ye(e.parentNode, Fn(e), t);
  }
  static after(e, t) {
    return new Ye(e.parentNode, Fn(e) + 1, t);
  }
}
const $h = [];
class pe {
  constructor() {
    this.parent = null, this.dom = null, this.flags = 2;
  }
  get overrideDOMText() {
    return null;
  }
  get posAtStart() {
    return this.parent ? this.parent.posBefore(this) : 0;
  }
  get posAtEnd() {
    return this.posAtStart + this.length;
  }
  posBefore(e) {
    let t = this.posAtStart;
    for (let i of this.children) {
      if (i == e)
        return t;
      t += i.length + i.breakAfter;
    }
    throw new RangeError("Invalid child in posBefore");
  }
  posAfter(e) {
    return this.posBefore(e) + e.length;
  }
  sync(e, t) {
    if (this.flags & 2) {
      let i = this.dom, r = null, s;
      for (let o of this.children) {
        if (o.flags & 7) {
          if (!o.dom && (s = r ? r.nextSibling : i.firstChild)) {
            let l = pe.get(s);
            (!l || !l.parent && l.canReuseDOM(o)) && o.reuseDOM(s);
          }
          o.sync(e, t), o.flags &= -8;
        }
        if (s = r ? r.nextSibling : i.firstChild, t && !t.written && t.node == i && s != o.dom && (t.written = !0), o.dom.parentNode == i)
          for (; s && s != o.dom; )
            s = Fu(s);
        else
          i.insertBefore(o.dom, s);
        r = o.dom;
      }
      for (s = r ? r.nextSibling : i.firstChild, s && t && t.node == i && (t.written = !0); s; )
        s = Fu(s);
    } else if (this.flags & 1)
      for (let i of this.children)
        i.flags & 7 && (i.sync(e, t), i.flags &= -8);
  }
  reuseDOM(e) {
  }
  localPosFromDOM(e, t) {
    let i;
    if (e == this.dom)
      i = this.dom.childNodes[t];
    else {
      let r = ln(e) == 0 ? 0 : t == 0 ? -1 : 1;
      for (; ; ) {
        let s = e.parentNode;
        if (s == this.dom)
          break;
        r == 0 && s.firstChild != s.lastChild && (e == s.firstChild ? r = -1 : r = 1), e = s;
      }
      r < 0 ? i = e : i = e.nextSibling;
    }
    if (i == this.dom.firstChild)
      return 0;
    for (; i && !pe.get(i); )
      i = i.nextSibling;
    if (!i)
      return this.length;
    for (let r = 0, s = 0; ; r++) {
      let o = this.children[r];
      if (o.dom == i)
        return s;
      s += o.length + o.breakAfter;
    }
  }
  domBoundsAround(e, t, i = 0) {
    let r = -1, s = -1, o = -1, l = -1;
    for (let a = 0, h = i, u = i; a < this.children.length; a++) {
      let c = this.children[a], f = h + c.length;
      if (h < e && f > t)
        return c.domBoundsAround(e, t, h);
      if (f >= e && r == -1 && (r = a, s = h), h > t && c.dom.parentNode == this.dom) {
        o = a, l = u;
        break;
      }
      u = f, h = f + c.breakAfter;
    }
    return {
      from: s,
      to: l < 0 ? i + this.length : l,
      startDOM: (r ? this.children[r - 1].dom.nextSibling : null) || this.dom.firstChild,
      endDOM: o < this.children.length && o >= 0 ? this.children[o].dom : null
    };
  }
  markDirty(e = !1) {
    this.flags |= 2, this.markParentsDirty(e);
  }
  markParentsDirty(e) {
    for (let t = this.parent; t; t = t.parent) {
      if (e && (t.flags |= 2), t.flags & 1)
        return;
      t.flags |= 1, e = !1;
    }
  }
  setParent(e) {
    this.parent != e && (this.parent = e, this.flags & 7 && this.markParentsDirty(!0));
  }
  setDOM(e) {
    this.dom != e && (this.dom && (this.dom.cmView = null), this.dom = e, e.cmView = this);
  }
  get rootView() {
    for (let e = this; ; ) {
      let t = e.parent;
      if (!t)
        return e;
      e = t;
    }
  }
  replaceChildren(e, t, i = $h) {
    this.markDirty();
    for (let r = e; r < t; r++) {
      let s = this.children[r];
      s.parent == this && i.indexOf(s) < 0 && s.destroy();
    }
    this.children.splice(e, t - e, ...i);
    for (let r = 0; r < i.length; r++)
      i[r].setParent(this);
  }
  ignoreMutation(e) {
    return !1;
  }
  ignoreEvent(e) {
    return !1;
  }
  childCursor(e = this.length) {
    return new Zp(this.children, e, this.children.length);
  }
  childPos(e, t = 1) {
    return this.childCursor().findPos(e, t);
  }
  toString() {
    let e = this.constructor.name.replace("View", "");
    return e + (this.children.length ? "(" + this.children.join() + ")" : this.length ? "[" + (e == "Text" ? this.text : this.length) + "]" : "") + (this.breakAfter ? "#" : "");
  }
  static get(e) {
    return e.cmView;
  }
  get isEditable() {
    return !0;
  }
  get isWidget() {
    return !1;
  }
  get isHidden() {
    return !1;
  }
  merge(e, t, i, r, s, o) {
    return !1;
  }
  become(e) {
    return !1;
  }
  canReuseDOM(e) {
    return e.constructor == this.constructor && !((this.flags | e.flags) & 8);
  }
  // When this is a zero-length view with a side, this should return a
  // number <= 0 to indicate it is before its position, or a
  // number > 0 when after its position.
  getSide() {
    return 0;
  }
  destroy() {
    for (let e of this.children)
      e.parent == this && e.destroy();
    this.parent = null;
  }
}
pe.prototype.breakAfter = 0;
function Fu(n) {
  let e = n.nextSibling;
  return n.parentNode.removeChild(n), e;
}
class Zp {
  constructor(e, t, i) {
    this.children = e, this.pos = t, this.i = i, this.off = 0;
  }
  findPos(e, t = 1) {
    for (; ; ) {
      if (e > this.pos || e == this.pos && (t > 0 || this.i == 0 || this.children[this.i - 1].breakAfter))
        return this.off = e - this.pos, this;
      let i = this.children[--this.i];
      this.pos -= i.length + i.breakAfter;
    }
  }
}
function Mp(n, e, t, i, r, s, o, l, a) {
  let { children: h } = n, u = h.length ? h[e] : null, c = s.length ? s[s.length - 1] : null, f = c ? c.breakAfter : o;
  if (!(e == i && u && !o && !f && s.length < 2 && u.merge(t, r, s.length ? c : null, t == 0, l, a))) {
    if (i < h.length) {
      let d = h[i];
      d && (r < d.length || d.breakAfter && (c != null && c.breakAfter)) ? (e == i && (d = d.split(r), r = 0), !f && c && d.merge(0, r, c, !0, 0, a) ? s[s.length - 1] = d : ((r || d.children.length && !d.children[0].length) && d.merge(0, r, null, !1, 0, a), s.push(d))) : d != null && d.breakAfter && (c ? c.breakAfter = 1 : o = 1), i++;
    }
    for (u && (u.breakAfter = o, t > 0 && (!o && s.length && u.merge(t, u.length, s[0], !1, l, 0) ? u.breakAfter = s.shift().breakAfter : (t < u.length || u.children.length && u.children[u.children.length - 1].length == 0) && u.merge(t, u.length, null, !1, l, 0), e++)); e < i && s.length; )
      if (h[i - 1].become(s[s.length - 1]))
        i--, s.pop(), a = s.length ? 0 : l;
      else if (h[e].become(s[0]))
        e++, s.shift(), l = s.length ? 0 : a;
      else
        break;
    !s.length && e && i < h.length && !h[e - 1].breakAfter && h[i].merge(0, 0, h[e - 1], !1, l, a) && e--, (e < i || s.length) && n.replaceChildren(e, i, s);
  }
}
function Ep(n, e, t, i, r, s) {
  let o = n.childCursor(), { i: l, off: a } = o.findPos(t, 1), { i: h, off: u } = o.findPos(e, -1), c = e - t;
  for (let f of i)
    c += f.length;
  n.length += c, Mp(n, h, u, l, a, i, 0, r, s);
}
let ft = typeof navigator < "u" ? navigator : { userAgent: "", vendor: "", platform: "" }, ka = typeof document < "u" ? document : { documentElement: { style: {} } };
const xa = /* @__PURE__ */ /Edge\/(\d+)/.exec(ft.userAgent), zp = /* @__PURE__ */ /MSIE \d/.test(ft.userAgent), wa = /* @__PURE__ */ /Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(ft.userAgent), Do = !!(zp || wa || xa), Gu = !Do && /* @__PURE__ */ /gecko\/(\d+)/i.test(ft.userAgent), ol = !Do && /* @__PURE__ */ /Chrome\/(\d+)/.exec(ft.userAgent), Hu = "webkitFontSmoothing" in ka.documentElement.style, Xp = !Do && /* @__PURE__ */ /Apple Computer/.test(ft.vendor), Ku = Xp && (/* @__PURE__ */ /Mobile\/\w+/.test(ft.userAgent) || ft.maxTouchPoints > 2);
var V = {
  mac: Ku || /* @__PURE__ */ /Mac/.test(ft.platform),
  windows: /* @__PURE__ */ /Win/.test(ft.platform),
  linux: /* @__PURE__ */ /Linux|X11/.test(ft.platform),
  ie: Do,
  ie_version: zp ? ka.documentMode || 6 : wa ? +wa[1] : xa ? +xa[1] : 0,
  gecko: Gu,
  gecko_version: Gu ? +(/* @__PURE__ */ /Firefox\/(\d+)/.exec(ft.userAgent) || [0, 0])[1] : 0,
  chrome: !!ol,
  chrome_version: ol ? +ol[1] : 0,
  ios: Ku,
  android: /* @__PURE__ */ /Android\b/.test(ft.userAgent),
  webkit: Hu,
  safari: Xp,
  webkit_version: Hu ? +(/* @__PURE__ */ /\bAppleWebKit\/(\d+)/.exec(navigator.userAgent) || [0, 0])[1] : 0,
  tabSize: ka.documentElement.style.tabSize != null ? "tab-size" : "-moz-tab-size"
};
const gb = 256;
class Et extends pe {
  constructor(e) {
    super(), this.text = e;
  }
  get length() {
    return this.text.length;
  }
  createDOM(e) {
    this.setDOM(e || document.createTextNode(this.text));
  }
  sync(e, t) {
    this.dom || this.createDOM(), this.dom.nodeValue != this.text && (t && t.node == this.dom && (t.written = !0), this.dom.nodeValue = this.text);
  }
  reuseDOM(e) {
    e.nodeType == 3 && this.createDOM(e);
  }
  merge(e, t, i) {
    return this.flags & 8 || i && (!(i instanceof Et) || this.length - (t - e) + i.length > gb || i.flags & 8) ? !1 : (this.text = this.text.slice(0, e) + (i ? i.text : "") + this.text.slice(t), this.markDirty(), !0);
  }
  split(e) {
    let t = new Et(this.text.slice(e));
    return this.text = this.text.slice(0, e), this.markDirty(), t.flags |= this.flags & 8, t;
  }
  localPosFromDOM(e, t) {
    return e == this.dom ? t : t ? this.text.length : 0;
  }
  domAtPos(e) {
    return new Ye(this.dom, e);
  }
  domBoundsAround(e, t, i) {
    return { from: i, to: i + this.length, startDOM: this.dom, endDOM: this.dom.nextSibling };
  }
  coordsAt(e, t) {
    return bb(this.dom, e, t);
  }
}
class an extends pe {
  constructor(e, t = [], i = 0) {
    super(), this.mark = e, this.children = t, this.length = i;
    for (let r of t)
      r.setParent(this);
  }
  setAttrs(e) {
    if (Cp(e), this.mark.class && (e.className = this.mark.class), this.mark.attrs)
      for (let t in this.mark.attrs)
        e.setAttribute(t, this.mark.attrs[t]);
    return e;
  }
  canReuseDOM(e) {
    return super.canReuseDOM(e) && !((this.flags | e.flags) & 8);
  }
  reuseDOM(e) {
    e.nodeName == this.mark.tagName.toUpperCase() && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    this.dom ? this.flags & 4 && this.setAttrs(this.dom) : this.setDOM(this.setAttrs(document.createElement(this.mark.tagName))), super.sync(e, t);
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof an && i.mark.eq(this.mark)) || e && s <= 0 || t < this.length && o <= 0) ? !1 : (Ep(this, e, t, i ? i.children.slice() : [], s - 1, o - 1), this.markDirty(), !0);
  }
  split(e) {
    let t = [], i = 0, r = -1, s = 0;
    for (let l of this.children) {
      let a = i + l.length;
      a > e && t.push(i < e ? l.split(e - i) : l), r < 0 && i >= e && (r = s), i = a, s++;
    }
    let o = this.length - e;
    return this.length = e, r > -1 && (this.children.length = r, this.markDirty()), new an(this.mark, t, o);
  }
  domAtPos(e) {
    return Dp(this, e);
  }
  coordsAt(e, t) {
    return Ip(this, e, t);
  }
}
function bb(n, e, t) {
  let i = n.nodeValue.length;
  e > i && (e = i);
  let r = e, s = e, o = 0;
  e == 0 && t < 0 || e == i && t >= 0 ? V.chrome || V.gecko || (e ? (r--, o = 1) : s < i && (s++, o = -1)) : t < 0 ? r-- : s < i && s++;
  let l = Gn(n, r, s).getClientRects();
  if (!l.length)
    return null;
  let a = l[(o ? o < 0 : t >= 0) ? 0 : l.length - 1];
  return V.safari && !o && a.width == 0 && (a = Array.prototype.find.call(l, (h) => h.width) || a), o ? Xo(a, o < 0) : a || null;
}
class kn extends pe {
  static create(e, t, i) {
    return new kn(e, t, i);
  }
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.side = i, this.prevWidget = null;
  }
  split(e) {
    let t = kn.create(this.widget, this.length - e, this.side);
    return this.length -= e, t;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  getSide() {
    return this.side;
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof kn) || !this.widget.compare(i.widget) || e > 0 && s <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  become(e) {
    return e instanceof kn && e.side == this.side && this.widget.constructor == e.widget.constructor ? (this.widget.compare(e.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get overrideDOMText() {
    if (this.length == 0)
      return le.empty;
    let e = this;
    for (; e.parent; )
      e = e.parent;
    let { view: t } = e, i = t && t.state.doc, r = this.posAtStart;
    return i ? i.slice(r, r + this.length) : le.empty;
  }
  domAtPos(e) {
    return (this.length ? e == 0 : this.side > 0) ? Ye.before(this.dom) : Ye.after(this.dom, e == this.length);
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e, t) {
    let i = this.widget.coordsAt(this.dom, e, t);
    if (i)
      return i;
    let r = this.dom.getClientRects(), s = null;
    if (!r.length)
      return null;
    let o = this.side ? this.side < 0 : e > 0;
    for (let l = o ? r.length - 1 : 0; s = r[l], !(e > 0 ? l == 0 : l == r.length - 1 || s.top < s.bottom); l += o ? -1 : 1)
      ;
    return Xo(s, !o);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  get isHidden() {
    return this.widget.isHidden;
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
}
class Pi extends pe {
  constructor(e) {
    super(), this.side = e;
  }
  get length() {
    return 0;
  }
  merge() {
    return !1;
  }
  become(e) {
    return e instanceof Pi && e.side == this.side;
  }
  split() {
    return new Pi(this.side);
  }
  sync() {
    if (!this.dom) {
      let e = document.createElement("img");
      e.className = "cm-widgetBuffer", e.setAttribute("aria-hidden", "true"), this.setDOM(e);
    }
  }
  getSide() {
    return this.side;
  }
  domAtPos(e) {
    return this.side > 0 ? Ye.before(this.dom) : Ye.after(this.dom);
  }
  localPosFromDOM() {
    return 0;
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e) {
    return this.dom.getBoundingClientRect();
  }
  get overrideDOMText() {
    return le.empty;
  }
  get isHidden() {
    return !0;
  }
}
Et.prototype.children = kn.prototype.children = Pi.prototype.children = $h;
function Dp(n, e) {
  let t = n.dom, { children: i } = n, r = 0;
  for (let s = 0; r < i.length; r++) {
    let o = i[r], l = s + o.length;
    if (!(l == s && o.getSide() <= 0)) {
      if (e > s && e < l && o.dom.parentNode == t)
        return o.domAtPos(e - s);
      if (e <= s)
        break;
      s = l;
    }
  }
  for (let s = r; s > 0; s--) {
    let o = i[s - 1];
    if (o.dom.parentNode == t)
      return o.domAtPos(o.length);
  }
  for (let s = r; s < i.length; s++) {
    let o = i[s];
    if (o.dom.parentNode == t)
      return o.domAtPos(0);
  }
  return new Ye(t, 0);
}
function Lp(n, e, t) {
  let i, { children: r } = n;
  t > 0 && e instanceof an && r.length && (i = r[r.length - 1]) instanceof an && i.mark.eq(e.mark) ? Lp(i, e.children[0], t - 1) : (r.push(e), e.setParent(n)), n.length += e.length;
}
function Ip(n, e, t) {
  let i = null, r = -1, s = null, o = -1;
  function l(h, u) {
    for (let c = 0, f = 0; c < h.children.length && f <= u; c++) {
      let d = h.children[c], p = f + d.length;
      p >= u && (d.children.length ? l(d, u - f) : (!s || s.isHidden && t > 0) && (p > u || f == p && d.getSide() > 0) ? (s = d, o = u - f) : (f < u || f == p && d.getSide() < 0 && !d.isHidden) && (i = d, r = u - f)), f = p;
    }
  }
  l(n, e);
  let a = (t < 0 ? i : s) || i || s;
  return a ? a.coordsAt(Math.max(0, a == i ? r : o), t) : yb(n);
}
function yb(n) {
  let e = n.dom.lastChild;
  if (!e)
    return n.dom.getBoundingClientRect();
  let t = vi(e);
  return t[t.length - 1] || null;
}
function Sa(n, e) {
  for (let t in n)
    t == "class" && e.class ? e.class += " " + n.class : t == "style" && e.style ? e.style += ";" + n.style : e[t] = n[t];
  return e;
}
const Ju = /* @__PURE__ */ Object.create(null);
function Ch(n, e, t) {
  if (n == e)
    return !0;
  n || (n = Ju), e || (e = Ju);
  let i = Object.keys(n), r = Object.keys(e);
  if (i.length - (t && i.indexOf(t) > -1 ? 1 : 0) != r.length - (t && r.indexOf(t) > -1 ? 1 : 0))
    return !1;
  for (let s of i)
    if (s != t && (r.indexOf(s) == -1 || n[s] !== e[s]))
      return !1;
  return !0;
}
function va(n, e, t) {
  let i = !1;
  if (e)
    for (let r in e)
      t && r in t || (i = !0, r == "style" ? n.style.cssText = "" : n.removeAttribute(r));
  if (t)
    for (let r in t)
      e && e[r] == t[r] || (i = !0, r == "style" ? n.style.cssText = t[r] : n.setAttribute(r, t[r]));
  return i;
}
function kb(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t = 0; t < n.attributes.length; t++) {
    let i = n.attributes[t];
    e[i.name] = i.value;
  }
  return e;
}
class Me extends pe {
  constructor() {
    super(...arguments), this.children = [], this.length = 0, this.prevAttrs = void 0, this.attrs = null, this.breakAfter = 0;
  }
  // Consumes source
  merge(e, t, i, r, s, o) {
    if (i) {
      if (!(i instanceof Me))
        return !1;
      this.dom || i.transferDOM(this);
    }
    return r && this.setDeco(i ? i.attrs : null), Ep(this, e, t, i ? i.children.slice() : [], s, o), !0;
  }
  split(e) {
    let t = new Me();
    if (t.breakAfter = this.breakAfter, this.length == 0)
      return t;
    let { i, off: r } = this.childPos(e);
    r && (t.append(this.children[i].split(r), 0), this.children[i].merge(r, this.children[i].length, null, !1, 0, 0), i++);
    for (let s = i; s < this.children.length; s++)
      t.append(this.children[s], 0);
    for (; i > 0 && this.children[i - 1].length == 0; )
      this.children[--i].destroy();
    return this.children.length = i, this.markDirty(), this.length = e, t;
  }
  transferDOM(e) {
    this.dom && (this.markDirty(), e.setDOM(this.dom), e.prevAttrs = this.prevAttrs === void 0 ? this.attrs : this.prevAttrs, this.prevAttrs = void 0, this.dom = null);
  }
  setDeco(e) {
    Ch(this.attrs, e) || (this.dom && (this.prevAttrs = this.attrs, this.markDirty()), this.attrs = e);
  }
  append(e, t) {
    Lp(this, e, t);
  }
  // Only called when building a line view in ContentBuilder
  addLineDeco(e) {
    let t = e.spec.attributes, i = e.spec.class;
    t && (this.attrs = Sa(t, this.attrs || {})), i && (this.attrs = Sa({ class: i }, this.attrs || {}));
  }
  domAtPos(e) {
    return Dp(this, e);
  }
  reuseDOM(e) {
    e.nodeName == "DIV" && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    var i;
    this.dom ? this.flags & 4 && (Cp(this.dom), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0) : (this.setDOM(document.createElement("div")), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0), this.prevAttrs !== void 0 && (va(this.dom, this.prevAttrs, this.attrs), this.dom.classList.add("cm-line"), this.prevAttrs = void 0), super.sync(e, t);
    let r = this.dom.lastChild;
    for (; r && pe.get(r) instanceof an; )
      r = r.lastChild;
    if (!r || !this.length || r.nodeName != "BR" && ((i = pe.get(r)) === null || i === void 0 ? void 0 : i.isEditable) == !1 && (!V.ios || !this.children.some((s) => s instanceof Et))) {
      let s = document.createElement("BR");
      s.cmIgnore = !0, this.dom.appendChild(s);
    }
  }
  measureTextSize() {
    if (this.children.length == 0 || this.length > 20)
      return null;
    let e = 0, t;
    for (let i of this.children) {
      if (!(i instanceof Et) || /[^ -~]/.test(i.text))
        return null;
      let r = vi(i.dom);
      if (r.length != 1)
        return null;
      e += r[0].width, t = r[0].height;
    }
    return e ? {
      lineHeight: this.dom.getBoundingClientRect().height,
      charWidth: e / this.length,
      textHeight: t
    } : null;
  }
  coordsAt(e, t) {
    let i = Ip(this, e, t);
    if (!this.children.length && i && this.parent) {
      let { heightOracle: r } = this.parent.view.viewState, s = i.bottom - i.top;
      if (Math.abs(s - r.lineHeight) < 2 && r.textHeight < s) {
        let o = (s - r.textHeight) / 2;
        return { top: i.top + o, bottom: i.bottom - o, left: i.left, right: i.left };
      }
    }
    return i;
  }
  become(e) {
    return !1;
  }
  covers() {
    return !0;
  }
  static find(e, t) {
    for (let i = 0, r = 0; i < e.children.length; i++) {
      let s = e.children[i], o = r + s.length;
      if (o >= t) {
        if (s instanceof Me)
          return s;
        if (o > t)
          break;
      }
      r = o + s.breakAfter;
    }
    return null;
  }
}
class vn extends pe {
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.deco = i, this.breakAfter = 0, this.prevWidget = null;
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof vn) || !this.widget.compare(i.widget) || e > 0 && s <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  domAtPos(e) {
    return e == 0 ? Ye.before(this.dom) : Ye.after(this.dom, e == this.length);
  }
  split(e) {
    let t = this.length - e;
    this.length = e;
    let i = new vn(this.widget, t, this.deco);
    return i.breakAfter = this.breakAfter, i;
  }
  get children() {
    return $h;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  get overrideDOMText() {
    return this.parent ? this.parent.view.state.doc.slice(this.posAtStart, this.posAtEnd) : le.empty;
  }
  domBoundsAround() {
    return null;
  }
  become(e) {
    return e instanceof vn && e.widget.constructor == this.widget.constructor ? (e.widget.compare(this.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, this.deco = e.deco, this.breakAfter = e.breakAfter, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  coordsAt(e, t) {
    return this.widget.coordsAt(this.dom, e, t);
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
  covers(e) {
    let { startSide: t, endSide: i } = this.deco;
    return t == i ? !1 : e < 0 ? t < 0 : i > 0;
  }
}
class Kt {
  /**
  Compare this instance to another instance of the same type.
  (TypeScript can't express this, but only instances of the same
  specific class will be passed to this method.) This is used to
  avoid redrawing widgets when they are replaced by a new
  decoration of the same type. The default implementation just
  returns `false`, which will cause new instances of the widget to
  always be redrawn.
  */
  eq(e) {
    return !1;
  }
  /**
  Update a DOM element created by a widget of the same type (but
  different, non-`eq` content) to reflect this widget. May return
  true to indicate that it could update, false to indicate it
  couldn't (in which case the widget will be redrawn). The default
  implementation just returns false.
  */
  updateDOM(e, t) {
    return !1;
  }
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  The estimated height this widget will have, to be used when
  estimating the height of content that hasn't been drawn. May
  return -1 to indicate you don't know. The default implementation
  returns -1.
  */
  get estimatedHeight() {
    return -1;
  }
  /**
  For inline widgets that are displayed inline (as opposed to
  `inline-block`) and introduce line breaks (through `<br>` tags
  or textual newlines), this must indicate the amount of line
  breaks they introduce. Defaults to 0.
  */
  get lineBreaks() {
    return 0;
  }
  /**
  Can be used to configure which kinds of events inside the widget
  should be ignored by the editor. The default is to ignore all
  events.
  */
  ignoreEvent(e) {
    return !0;
  }
  /**
  Override the way screen coordinates for positions at/in the
  widget are found. `pos` will be the offset into the widget, and
  `side` the side of the position that is being queried—less than
  zero for before, greater than zero for after, and zero for
  directly at that position.
  */
  coordsAt(e, t, i) {
    return null;
  }
  /**
  @internal
  */
  get isHidden() {
    return !1;
  }
  /**
  @internal
  */
  get editable() {
    return !1;
  }
  /**
  This is called when the an instance of the widget is removed
  from the editor view.
  */
  destroy(e) {
  }
}
var Ke = /* @__PURE__ */ function(n) {
  return n[n.Text = 0] = "Text", n[n.WidgetBefore = 1] = "WidgetBefore", n[n.WidgetAfter = 2] = "WidgetAfter", n[n.WidgetRange = 3] = "WidgetRange", n;
}(Ke || (Ke = {}));
class j extends Un {
  constructor(e, t, i, r) {
    super(), this.startSide = e, this.endSide = t, this.widget = i, this.spec = r;
  }
  /**
  @internal
  */
  get heightRelevant() {
    return !1;
  }
  /**
  Create a mark decoration, which influences the styling of the
  content in its range. Nested mark decorations will cause nested
  DOM elements to be created. Nesting order is determined by
  precedence of the [facet](https://codemirror.net/6/docs/ref/#view.EditorView^decorations), with
  the higher-precedence decorations creating the inner DOM nodes.
  Such elements are split on line boundaries and on the boundaries
  of lower-precedence decorations.
  */
  static mark(e) {
    return new Vr(e);
  }
  /**
  Create a widget decoration, which displays a DOM element at the
  given position.
  */
  static widget(e) {
    let t = Math.max(-1e4, Math.min(1e4, e.side || 0)), i = !!e.block;
    return t += i && !e.inlineOrder ? t > 0 ? 3e8 : -4e8 : t > 0 ? 1e8 : -1e8, new An(e, t, t, i, e.widget || null, !1);
  }
  /**
  Create a replace decoration which replaces the given range with
  a widget, or simply hides it.
  */
  static replace(e) {
    let t = !!e.block, i, r;
    if (e.isBlockGap)
      i = -5e8, r = 4e8;
    else {
      let { start: s, end: o } = _p(e, t);
      i = (s ? t ? -3e8 : -1 : 5e8) - 1, r = (o ? t ? 2e8 : 1 : -6e8) + 1;
    }
    return new An(e, i, r, t, e.widget || null, !0);
  }
  /**
  Create a line decoration, which can add DOM attributes to the
  line starting at the given position.
  */
  static line(e) {
    return new Yr(e);
  }
  /**
  Build a [`DecorationSet`](https://codemirror.net/6/docs/ref/#view.DecorationSet) from the given
  decorated range or ranges. If the ranges aren't already sorted,
  pass `true` for `sort` to make the library sort them for you.
  */
  static set(e, t = !1) {
    return oe.of(e, t);
  }
  /**
  @internal
  */
  hasHeight() {
    return this.widget ? this.widget.estimatedHeight > -1 : !1;
  }
}
j.none = oe.empty;
class Vr extends j {
  constructor(e) {
    let { start: t, end: i } = _p(e);
    super(t ? -1 : 5e8, i ? 1 : -6e8, null, e), this.tagName = e.tagName || "span", this.class = e.class || "", this.attrs = e.attributes || null;
  }
  eq(e) {
    var t, i;
    return this == e || e instanceof Vr && this.tagName == e.tagName && (this.class || ((t = this.attrs) === null || t === void 0 ? void 0 : t.class)) == (e.class || ((i = e.attrs) === null || i === void 0 ? void 0 : i.class)) && Ch(this.attrs, e.attrs, "class");
  }
  range(e, t = e) {
    if (e >= t)
      throw new RangeError("Mark decorations may not be empty");
    return super.range(e, t);
  }
}
Vr.prototype.point = !1;
class Yr extends j {
  constructor(e) {
    super(-2e8, -2e8, null, e);
  }
  eq(e) {
    return e instanceof Yr && this.spec.class == e.spec.class && Ch(this.spec.attributes, e.spec.attributes);
  }
  range(e, t = e) {
    if (t != e)
      throw new RangeError("Line decoration ranges must be zero-length");
    return super.range(e, t);
  }
}
Yr.prototype.mapMode = qe.TrackBefore;
Yr.prototype.point = !0;
class An extends j {
  constructor(e, t, i, r, s, o) {
    super(t, i, s, e), this.block = r, this.isReplace = o, this.mapMode = r ? t <= 0 ? qe.TrackBefore : qe.TrackAfter : qe.TrackDel;
  }
  // Only relevant when this.block == true
  get type() {
    return this.startSide != this.endSide ? Ke.WidgetRange : this.startSide <= 0 ? Ke.WidgetBefore : Ke.WidgetAfter;
  }
  get heightRelevant() {
    return this.block || !!this.widget && (this.widget.estimatedHeight >= 5 || this.widget.lineBreaks > 0);
  }
  eq(e) {
    return e instanceof An && xb(this.widget, e.widget) && this.block == e.block && this.startSide == e.startSide && this.endSide == e.endSide;
  }
  range(e, t = e) {
    if (this.isReplace && (e > t || e == t && this.startSide > 0 && this.endSide <= 0))
      throw new RangeError("Invalid range for replacement decoration");
    if (!this.isReplace && t != e)
      throw new RangeError("Widget decorations can only have zero-length ranges");
    return super.range(e, t);
  }
}
An.prototype.point = !0;
function _p(n, e = !1) {
  let { inclusiveStart: t, inclusiveEnd: i } = n;
  return t == null && (t = n.inclusive), i == null && (i = n.inclusive), { start: t ?? e, end: i ?? e };
}
function xb(n, e) {
  return n == e || !!(n && e && n.compare(e));
}
function Pa(n, e, t, i = 0) {
  let r = t.length - 1;
  r >= 0 && t[r] + i >= n ? t[r] = Math.max(t[r], e) : t.push(n, e);
}
class mr {
  constructor(e, t, i, r) {
    this.doc = e, this.pos = t, this.end = i, this.disallowBlockEffectsFor = r, this.content = [], this.curLine = null, this.breakAtStart = 0, this.pendingBuffer = 0, this.bufferMarks = [], this.atCursorPos = !0, this.openStart = -1, this.openEnd = -1, this.text = "", this.textOff = 0, this.cursor = e.iter(), this.skip = t;
  }
  posCovered() {
    if (this.content.length == 0)
      return !this.breakAtStart && this.doc.lineAt(this.pos).from != this.pos;
    let e = this.content[this.content.length - 1];
    return !(e.breakAfter || e instanceof vn && e.deco.endSide < 0);
  }
  getLine() {
    return this.curLine || (this.content.push(this.curLine = new Me()), this.atCursorPos = !0), this.curLine;
  }
  flushBuffer(e = this.bufferMarks) {
    this.pendingBuffer && (this.curLine.append(rs(new Pi(-1), e), e.length), this.pendingBuffer = 0);
  }
  addBlockWidget(e) {
    this.flushBuffer(), this.curLine = null, this.content.push(e);
  }
  finish(e) {
    this.pendingBuffer && e <= this.bufferMarks.length ? this.flushBuffer() : this.pendingBuffer = 0, !this.posCovered() && !(e && this.content.length && this.content[this.content.length - 1] instanceof vn) && this.getLine();
  }
  buildText(e, t, i) {
    for (; e > 0; ) {
      if (this.textOff == this.text.length) {
        let { value: s, lineBreak: o, done: l } = this.cursor.next(this.skip);
        if (this.skip = 0, l)
          throw new Error("Ran out of text content when drawing inline views");
        if (o) {
          this.posCovered() || this.getLine(), this.content.length ? this.content[this.content.length - 1].breakAfter = 1 : this.breakAtStart = 1, this.flushBuffer(), this.curLine = null, this.atCursorPos = !0, e--;
          continue;
        } else
          this.text = s, this.textOff = 0;
      }
      let r = Math.min(
        this.text.length - this.textOff,
        e,
        512
        /* T.Chunk */
      );
      this.flushBuffer(t.slice(t.length - i)), this.getLine().append(rs(new Et(this.text.slice(this.textOff, this.textOff + r)), t), i), this.atCursorPos = !0, this.textOff += r, e -= r, i = 0;
    }
  }
  span(e, t, i, r) {
    this.buildText(t - e, i, r), this.pos = t, this.openStart < 0 && (this.openStart = r);
  }
  point(e, t, i, r, s, o) {
    if (this.disallowBlockEffectsFor[o] && i instanceof An) {
      if (i.block)
        throw new RangeError("Block decorations may not be specified via plugins");
      if (t > this.doc.lineAt(this.pos).to)
        throw new RangeError("Decorations that replace line breaks may not be specified via plugins");
    }
    let l = t - e;
    if (i instanceof An)
      if (i.block)
        i.startSide > 0 && !this.posCovered() && this.getLine(), this.addBlockWidget(new vn(i.widget || Qi.block, l, i));
      else {
        let a = kn.create(i.widget || Qi.inline, l, l ? 0 : i.startSide), h = this.atCursorPos && !a.isEditable && s <= r.length && (e < t || i.startSide > 0), u = !a.isEditable && (e < t || s > r.length || i.startSide <= 0), c = this.getLine();
        this.pendingBuffer == 2 && !h && !a.isEditable && (this.pendingBuffer = 0), this.flushBuffer(r), h && (c.append(rs(new Pi(1), r), s), s = r.length + Math.max(0, s - r.length)), c.append(rs(a, r), s), this.atCursorPos = u, this.pendingBuffer = u ? e < t || s > r.length ? 1 : 2 : 0, this.pendingBuffer && (this.bufferMarks = r.slice());
      }
    else
      this.doc.lineAt(this.pos).from == this.pos && this.getLine().addLineDeco(i);
    l && (this.textOff + l <= this.text.length ? this.textOff += l : (this.skip += l - (this.text.length - this.textOff), this.text = "", this.textOff = 0), this.pos = t), this.openStart < 0 && (this.openStart = s);
  }
  static build(e, t, i, r, s) {
    let o = new mr(e, t, i, s);
    return o.openEnd = oe.spans(r, t, i, o), o.openStart < 0 && (o.openStart = o.openEnd), o.finish(o.openEnd), o;
  }
}
function rs(n, e) {
  for (let t of e)
    n = new an(t, [n], n.length);
  return n;
}
class Qi extends Kt {
  constructor(e) {
    super(), this.tag = e;
  }
  eq(e) {
    return e.tag == this.tag;
  }
  toDOM() {
    return document.createElement(this.tag);
  }
  updateDOM(e) {
    return e.nodeName.toLowerCase() == this.tag;
  }
  get isHidden() {
    return !0;
  }
}
Qi.inline = /* @__PURE__ */ new Qi("span");
Qi.block = /* @__PURE__ */ new Qi("div");
var we = /* @__PURE__ */ function(n) {
  return n[n.LTR = 0] = "LTR", n[n.RTL = 1] = "RTL", n;
}(we || (we = {}));
const Hn = we.LTR, Th = we.RTL;
function qp(n) {
  let e = [];
  for (let t = 0; t < n.length; t++)
    e.push(1 << +n[t]);
  return e;
}
const wb = /* @__PURE__ */ qp("88888888888888888888888888888888888666888888787833333333337888888000000000000000000000000008888880000000000000000000000000088888888888888888888888888888888888887866668888088888663380888308888800000000000000000000000800000000000000000000000000000008"), Sb = /* @__PURE__ */ qp("4444448826627288999999999992222222222222222222222222222222222222222222222229999999999999999999994444444444644222822222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222999999949999999229989999223333333333"), Qa = /* @__PURE__ */ Object.create(null), Lt = [];
for (let n of ["()", "[]", "{}"]) {
  let e = /* @__PURE__ */ n.charCodeAt(0), t = /* @__PURE__ */ n.charCodeAt(1);
  Qa[e] = t, Qa[t] = -e;
}
function Wp(n) {
  return n <= 247 ? wb[n] : 1424 <= n && n <= 1524 ? 2 : 1536 <= n && n <= 1785 ? Sb[n - 1536] : 1774 <= n && n <= 2220 ? 4 : 8192 <= n && n <= 8204 ? 256 : 64336 <= n && n <= 65023 ? 4 : 1;
}
const vb = /[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac\ufb50-\ufdff]/;
class xn {
  /**
  The direction of this span.
  */
  get dir() {
    return this.level % 2 ? Th : Hn;
  }
  /**
  @internal
  */
  constructor(e, t, i) {
    this.from = e, this.to = t, this.level = i;
  }
  /**
  @internal
  */
  side(e, t) {
    return this.dir == t == e ? this.to : this.from;
  }
  /**
  @internal
  */
  forward(e, t) {
    return e == (this.dir == t);
  }
  /**
  @internal
  */
  static find(e, t, i, r) {
    let s = -1;
    for (let o = 0; o < e.length; o++) {
      let l = e[o];
      if (l.from <= t && l.to >= t) {
        if (l.level == i)
          return o;
        (s < 0 || (r != 0 ? r < 0 ? l.from < t : l.to > t : e[s].level > l.level)) && (s = o);
      }
    }
    if (s < 0)
      throw new RangeError("Index out of range");
    return s;
  }
}
function Bp(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++) {
    let i = n[t], r = e[t];
    if (i.from != r.from || i.to != r.to || i.direction != r.direction || !Bp(i.inner, r.inner))
      return !1;
  }
  return !0;
}
const de = [];
function Pb(n, e, t, i, r) {
  for (let s = 0; s <= i.length; s++) {
    let o = s ? i[s - 1].to : e, l = s < i.length ? i[s].from : t, a = s ? 256 : r;
    for (let h = o, u = a, c = a; h < l; h++) {
      let f = Wp(n.charCodeAt(h));
      f == 512 ? f = u : f == 8 && c == 4 && (f = 16), de[h] = f == 4 ? 2 : f, f & 7 && (c = f), u = f;
    }
    for (let h = o, u = a, c = a; h < l; h++) {
      let f = de[h];
      if (f == 128)
        h < l - 1 && u == de[h + 1] && u & 24 ? f = de[h] = u : de[h] = 256;
      else if (f == 64) {
        let d = h + 1;
        for (; d < l && de[d] == 64; )
          d++;
        let p = h && u == 8 || d < t && de[d] == 8 ? c == 1 ? 1 : 8 : 256;
        for (let m = h; m < d; m++)
          de[m] = p;
        h = d - 1;
      } else
        f == 8 && c == 1 && (de[h] = 1);
      u = f, f & 7 && (c = f);
    }
  }
}
function Qb(n, e, t, i, r) {
  let s = r == 1 ? 2 : 1;
  for (let o = 0, l = 0, a = 0; o <= i.length; o++) {
    let h = o ? i[o - 1].to : e, u = o < i.length ? i[o].from : t;
    for (let c = h, f, d, p; c < u; c++)
      if (d = Qa[f = n.charCodeAt(c)])
        if (d < 0) {
          for (let m = l - 3; m >= 0; m -= 3)
            if (Lt[m + 1] == -d) {
              let O = Lt[m + 2], g = O & 2 ? r : O & 4 ? O & 1 ? s : r : 0;
              g && (de[c] = de[Lt[m]] = g), l = m;
              break;
            }
        } else {
          if (Lt.length == 189)
            break;
          Lt[l++] = c, Lt[l++] = f, Lt[l++] = a;
        }
      else if ((p = de[c]) == 2 || p == 1) {
        let m = p == r;
        a = m ? 0 : 1;
        for (let O = l - 3; O >= 0; O -= 3) {
          let g = Lt[O + 2];
          if (g & 2)
            break;
          if (m)
            Lt[O + 2] |= 2;
          else {
            if (g & 4)
              break;
            Lt[O + 2] |= 4;
          }
        }
      }
  }
}
function $b(n, e, t, i) {
  for (let r = 0, s = i; r <= t.length; r++) {
    let o = r ? t[r - 1].to : n, l = r < t.length ? t[r].from : e;
    for (let a = o; a < l; ) {
      let h = de[a];
      if (h == 256) {
        let u = a + 1;
        for (; ; )
          if (u == l) {
            if (r == t.length)
              break;
            u = t[r++].to, l = r < t.length ? t[r].from : e;
          } else if (de[u] == 256)
            u++;
          else
            break;
        let c = s == 1, f = (u < e ? de[u] : i) == 1, d = c == f ? c ? 1 : 2 : i;
        for (let p = u, m = r, O = m ? t[m - 1].to : n; p > a; )
          p == O && (p = t[--m].from, O = m ? t[m - 1].to : n), de[--p] = d;
        a = u;
      } else
        s = h, a++;
    }
  }
}
function $a(n, e, t, i, r, s, o) {
  let l = i % 2 ? 2 : 1;
  if (i % 2 == r % 2)
    for (let a = e, h = 0; a < t; ) {
      let u = !0, c = !1;
      if (h == s.length || a < s[h].from) {
        let m = de[a];
        m != l && (u = !1, c = m == 16);
      }
      let f = !u && l == 1 ? [] : null, d = u ? i : i + 1, p = a;
      e:
        for (; ; )
          if (h < s.length && p == s[h].from) {
            if (c)
              break e;
            let m = s[h];
            if (!u)
              for (let O = m.to, g = h + 1; ; ) {
                if (O == t)
                  break e;
                if (g < s.length && s[g].from == O)
                  O = s[g++].to;
                else {
                  if (de[O] == l)
                    break e;
                  break;
                }
              }
            if (h++, f)
              f.push(m);
            else {
              m.from > a && o.push(new xn(a, m.from, d));
              let O = m.direction == Hn != !(d % 2);
              Ca(n, O ? i + 1 : i, r, m.inner, m.from, m.to, o), a = m.to;
            }
            p = m.to;
          } else {
            if (p == t || (u ? de[p] != l : de[p] == l))
              break;
            p++;
          }
      f ? $a(n, a, p, i + 1, r, f, o) : a < p && o.push(new xn(a, p, d)), a = p;
    }
  else
    for (let a = t, h = s.length; a > e; ) {
      let u = !0, c = !1;
      if (!h || a > s[h - 1].to) {
        let m = de[a - 1];
        m != l && (u = !1, c = m == 16);
      }
      let f = !u && l == 1 ? [] : null, d = u ? i : i + 1, p = a;
      e:
        for (; ; )
          if (h && p == s[h - 1].to) {
            if (c)
              break e;
            let m = s[--h];
            if (!u)
              for (let O = m.from, g = h; ; ) {
                if (O == e)
                  break e;
                if (g && s[g - 1].to == O)
                  O = s[--g].from;
                else {
                  if (de[O - 1] == l)
                    break e;
                  break;
                }
              }
            if (f)
              f.push(m);
            else {
              m.to < a && o.push(new xn(m.to, a, d));
              let O = m.direction == Hn != !(d % 2);
              Ca(n, O ? i + 1 : i, r, m.inner, m.from, m.to, o), a = m.from;
            }
            p = m.from;
          } else {
            if (p == e || (u ? de[p - 1] != l : de[p - 1] == l))
              break;
            p--;
          }
      f ? $a(n, p, a, i + 1, r, f, o) : p < a && o.push(new xn(p, a, d)), a = p;
    }
}
function Ca(n, e, t, i, r, s, o) {
  let l = e % 2 ? 2 : 1;
  Pb(n, r, s, i, l), Qb(n, r, s, i, l), $b(r, s, i, l), $a(n, r, s, e, t, i, o);
}
function Cb(n, e, t) {
  if (!n)
    return [new xn(0, 0, e == Th ? 1 : 0)];
  if (e == Hn && !t.length && !vb.test(n))
    return Vp(n.length);
  if (t.length)
    for (; n.length > de.length; )
      de[de.length] = 256;
  let i = [], r = e == Hn ? 0 : 1;
  return Ca(n, r, r, t, 0, n.length, i), i;
}
function Vp(n) {
  return [new xn(0, n, 0)];
}
let Yp = "";
function Tb(n, e, t, i, r) {
  var s;
  let o = i.head - n.from, l = xn.find(e, o, (s = i.bidiLevel) !== null && s !== void 0 ? s : -1, i.assoc), a = e[l], h = a.side(r, t);
  if (o == h) {
    let f = l += r ? 1 : -1;
    if (f < 0 || f >= e.length)
      return null;
    a = e[l = f], o = a.side(!r, t), h = a.side(r, t);
  }
  let u = Be(n.text, o, a.forward(r, t));
  (u < a.from || u > a.to) && (u = h), Yp = n.text.slice(Math.min(o, u), Math.max(o, u));
  let c = l == (r ? e.length - 1 : 0) ? null : e[l + (r ? 1 : -1)];
  return c && u == h && c.level + (r ? 0 : 1) < a.level ? $.cursor(c.side(!r, t) + n.from, c.forward(r, t) ? 1 : -1, c.level) : $.cursor(u + n.from, a.forward(r, t) ? -1 : 1, a.level);
}
function Ab(n, e, t) {
  for (let i = e; i < t; i++) {
    let r = Wp(n.charCodeAt(i));
    if (r == 1)
      return Hn;
    if (r == 2 || r == 4)
      return Th;
  }
  return Hn;
}
const jp = /* @__PURE__ */ B.define(), Np = /* @__PURE__ */ B.define(), Up = /* @__PURE__ */ B.define(), Fp = /* @__PURE__ */ B.define(), Ta = /* @__PURE__ */ B.define(), Gp = /* @__PURE__ */ B.define(), Hp = /* @__PURE__ */ B.define(), Kp = /* @__PURE__ */ B.define({
  combine: (n) => n.some((e) => e)
}), Jp = /* @__PURE__ */ B.define({
  combine: (n) => n.some((e) => e)
}), em = /* @__PURE__ */ B.define();
class Oi {
  constructor(e, t = "nearest", i = "nearest", r = 5, s = 5, o = !1) {
    this.range = e, this.y = t, this.x = i, this.yMargin = r, this.xMargin = s, this.isSnapshot = o;
  }
  map(e) {
    return e.empty ? this : new Oi(this.range.map(e), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
  clip(e) {
    return this.range.to <= e.doc.length ? this : new Oi($.cursor(e.doc.length), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
}
const ss = /* @__PURE__ */ K.define({ map: (n, e) => n.map(e) });
function it(n, e, t) {
  let i = n.facet(Fp);
  i.length ? i[0](e) : window.onerror ? window.onerror(String(e), t, void 0, void 0, e) : t ? console.error(t + ":", e) : console.error(e);
}
const Lo = /* @__PURE__ */ B.define({ combine: (n) => n.length ? n[0] : !0 });
let Rb = 0;
const sr = /* @__PURE__ */ B.define();
class Qe {
  constructor(e, t, i, r, s) {
    this.id = e, this.create = t, this.domEventHandlers = i, this.domEventObservers = r, this.extension = s(this);
  }
  /**
  Define a plugin from a constructor function that creates the
  plugin's value, given an editor view.
  */
  static define(e, t) {
    const { eventHandlers: i, eventObservers: r, provide: s, decorations: o } = t || {};
    return new Qe(Rb++, e, i, r, (l) => {
      let a = [sr.of(l)];
      return o && a.push(Pr.of((h) => {
        let u = h.plugin(l);
        return u ? o(u) : j.none;
      })), s && a.push(s(l)), a;
    });
  }
  /**
  Create a plugin for a class whose constructor takes a single
  editor view as argument.
  */
  static fromClass(e, t) {
    return Qe.define((i) => new e(i), t);
  }
}
class ll {
  constructor(e) {
    this.spec = e, this.mustUpdate = null, this.value = null;
  }
  update(e) {
    if (this.value) {
      if (this.mustUpdate) {
        let t = this.mustUpdate;
        if (this.mustUpdate = null, this.value.update)
          try {
            this.value.update(t);
          } catch (i) {
            if (it(t.state, i, "CodeMirror plugin crashed"), this.value.destroy)
              try {
                this.value.destroy();
              } catch {
              }
            this.deactivate();
          }
      }
    } else if (this.spec)
      try {
        this.value = this.spec.create(e);
      } catch (t) {
        it(e.state, t, "CodeMirror plugin crashed"), this.deactivate();
      }
    return this;
  }
  destroy(e) {
    var t;
    if (!((t = this.value) === null || t === void 0) && t.destroy)
      try {
        this.value.destroy();
      } catch (i) {
        it(e.state, i, "CodeMirror plugin crashed");
      }
  }
  deactivate() {
    this.spec = this.value = null;
  }
}
const tm = /* @__PURE__ */ B.define(), Ah = /* @__PURE__ */ B.define(), Pr = /* @__PURE__ */ B.define(), nm = /* @__PURE__ */ B.define(), Rh = /* @__PURE__ */ B.define(), im = /* @__PURE__ */ B.define();
function ec(n, e) {
  let t = n.state.facet(im);
  if (!t.length)
    return t;
  let i = t.map((s) => s instanceof Function ? s(n) : s), r = [];
  return oe.spans(i, e.from, e.to, {
    point() {
    },
    span(s, o, l, a) {
      let h = s - e.from, u = o - e.from, c = r;
      for (let f = l.length - 1; f >= 0; f--, a--) {
        let d = l[f].spec.bidiIsolate, p;
        if (d == null && (d = Ab(e.text, h, u)), a > 0 && c.length && (p = c[c.length - 1]).to == h && p.direction == d)
          p.to = u, c = p.inner;
        else {
          let m = { from: h, to: u, direction: d, inner: [] };
          c.push(m), c = m.inner;
        }
      }
    }
  }), r;
}
const rm = /* @__PURE__ */ B.define();
function sm(n) {
  let e = 0, t = 0, i = 0, r = 0;
  for (let s of n.state.facet(rm)) {
    let o = s(n);
    o && (o.left != null && (e = Math.max(e, o.left)), o.right != null && (t = Math.max(t, o.right)), o.top != null && (i = Math.max(i, o.top)), o.bottom != null && (r = Math.max(r, o.bottom)));
  }
  return { left: e, right: t, top: i, bottom: r };
}
const or = /* @__PURE__ */ B.define();
class wt {
  constructor(e, t, i, r) {
    this.fromA = e, this.toA = t, this.fromB = i, this.toB = r;
  }
  join(e) {
    return new wt(Math.min(this.fromA, e.fromA), Math.max(this.toA, e.toA), Math.min(this.fromB, e.fromB), Math.max(this.toB, e.toB));
  }
  addToSet(e) {
    let t = e.length, i = this;
    for (; t > 0; t--) {
      let r = e[t - 1];
      if (!(r.fromA > i.toA)) {
        if (r.toA < i.fromA)
          break;
        i = i.join(r), e.splice(t - 1, 1);
      }
    }
    return e.splice(t, 0, i), e;
  }
  static extendWithRanges(e, t) {
    if (t.length == 0)
      return e;
    let i = [];
    for (let r = 0, s = 0, o = 0, l = 0; ; r++) {
      let a = r == e.length ? null : e[r], h = o - l, u = a ? a.fromB : 1e9;
      for (; s < t.length && t[s] < u; ) {
        let c = t[s], f = t[s + 1], d = Math.max(l, c), p = Math.min(u, f);
        if (d <= p && new wt(d + h, p + h, d, p).addToSet(i), f > u)
          break;
        s += 2;
      }
      if (!a)
        return i;
      new wt(a.fromA, a.toA, a.fromB, a.toB).addToSet(i), o = a.toA, l = a.toB;
    }
  }
}
class to {
  constructor(e, t, i) {
    this.view = e, this.state = t, this.transactions = i, this.flags = 0, this.startState = e.state, this.changes = Ee.empty(this.startState.doc.length);
    for (let s of i)
      this.changes = this.changes.compose(s.changes);
    let r = [];
    this.changes.iterChangedRanges((s, o, l, a) => r.push(new wt(s, o, l, a))), this.changedRanges = r;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new to(e, t, i);
  }
  /**
  Tells you whether the [viewport](https://codemirror.net/6/docs/ref/#view.EditorView.viewport) or
  [visible ranges](https://codemirror.net/6/docs/ref/#view.EditorView.visibleRanges) changed in this
  update.
  */
  get viewportChanged() {
    return (this.flags & 4) > 0;
  }
  /**
  Indicates whether the height of a block element in the editor
  changed in this update.
  */
  get heightChanged() {
    return (this.flags & 2) > 0;
  }
  /**
  Returns true when the document was modified or the size of the
  editor, or elements within the editor, changed.
  */
  get geometryChanged() {
    return this.docChanged || (this.flags & 10) > 0;
  }
  /**
  True when this update indicates a focus change.
  */
  get focusChanged() {
    return (this.flags & 1) > 0;
  }
  /**
  Whether the document changed in this update.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Whether the selection was explicitly set in this update.
  */
  get selectionSet() {
    return this.transactions.some((e) => e.selection);
  }
  /**
  @internal
  */
  get empty() {
    return this.flags == 0 && this.transactions.length == 0;
  }
}
class tc extends pe {
  get length() {
    return this.view.state.doc.length;
  }
  constructor(e) {
    super(), this.view = e, this.decorations = [], this.dynamicDecorationMap = [], this.domChanged = null, this.hasComposition = null, this.markedForComposition = /* @__PURE__ */ new Set(), this.lastCompositionAfterCursor = !1, this.minWidth = 0, this.minWidthFrom = 0, this.minWidthTo = 0, this.impreciseAnchor = null, this.impreciseHead = null, this.forceSelection = !1, this.lastUpdate = Date.now(), this.setDOM(e.contentDOM), this.children = [new Me()], this.children[0].setParent(this), this.updateDeco(), this.updateInner([new wt(0, 0, 0, e.state.doc.length)], 0, null);
  }
  // Update the document view to a given state.
  update(e) {
    var t;
    let i = e.changedRanges;
    this.minWidth > 0 && i.length && (i.every(({ fromA: h, toA: u }) => u < this.minWidthFrom || h > this.minWidthTo) ? (this.minWidthFrom = e.changes.mapPos(this.minWidthFrom, 1), this.minWidthTo = e.changes.mapPos(this.minWidthTo, 1)) : this.minWidth = this.minWidthFrom = this.minWidthTo = 0);
    let r = -1;
    this.view.inputState.composing >= 0 && (!((t = this.domChanged) === null || t === void 0) && t.newSel ? r = this.domChanged.newSel.head : !Lb(e.changes, this.hasComposition) && !e.selectionSet && (r = e.state.selection.main.head));
    let s = r > -1 ? Mb(this.view, e.changes, r) : null;
    if (this.domChanged = null, this.hasComposition) {
      this.markedForComposition.clear();
      let { from: h, to: u } = this.hasComposition;
      i = new wt(h, u, e.changes.mapPos(h, -1), e.changes.mapPos(u, 1)).addToSet(i.slice());
    }
    this.hasComposition = s ? { from: s.range.fromB, to: s.range.toB } : null, (V.ie || V.chrome) && !s && e && e.state.doc.lines != e.startState.doc.lines && (this.forceSelection = !0);
    let o = this.decorations, l = this.updateDeco(), a = Xb(o, l, e.changes);
    return i = wt.extendWithRanges(i, a), !(this.flags & 7) && i.length == 0 ? !1 : (this.updateInner(i, e.startState.doc.length, s), e.transactions.length && (this.lastUpdate = Date.now()), !0);
  }
  // Used by update and the constructor do perform the actual DOM
  // update
  updateInner(e, t, i) {
    this.view.viewState.mustMeasureContent = !0, this.updateChildren(e, t, i);
    let { observer: r } = this.view;
    r.ignore(() => {
      this.dom.style.height = this.view.viewState.contentHeight / this.view.scaleY + "px", this.dom.style.flexBasis = this.minWidth ? this.minWidth + "px" : "";
      let o = V.chrome || V.ios ? { node: r.selectionRange.focusNode, written: !1 } : void 0;
      this.sync(this.view, o), this.flags &= -8, o && (o.written || r.selectionRange.focusNode != o.node) && (this.forceSelection = !0), this.dom.style.height = "";
    }), this.markedForComposition.forEach(
      (o) => o.flags &= -9
      /* ViewFlag.Composition */
    );
    let s = [];
    if (this.view.viewport.from || this.view.viewport.to < this.view.state.doc.length)
      for (let o of this.children)
        o instanceof vn && o.widget instanceof nc && s.push(o.dom);
    r.updateGaps(s);
  }
  updateChildren(e, t, i) {
    let r = i ? i.range.addToSet(e.slice()) : e, s = this.childCursor(t);
    for (let o = r.length - 1; ; o--) {
      let l = o >= 0 ? r[o] : null;
      if (!l)
        break;
      let { fromA: a, toA: h, fromB: u, toB: c } = l, f, d, p, m;
      if (i && i.range.fromB < c && i.range.toB > u) {
        let Q = mr.build(this.view.state.doc, u, i.range.fromB, this.decorations, this.dynamicDecorationMap), P = mr.build(this.view.state.doc, i.range.toB, c, this.decorations, this.dynamicDecorationMap);
        d = Q.breakAtStart, p = Q.openStart, m = P.openEnd;
        let w = this.compositionView(i);
        P.breakAtStart ? w.breakAfter = 1 : P.content.length && w.merge(w.length, w.length, P.content[0], !1, P.openStart, 0) && (w.breakAfter = P.content[0].breakAfter, P.content.shift()), Q.content.length && w.merge(0, 0, Q.content[Q.content.length - 1], !0, 0, Q.openEnd) && Q.content.pop(), f = Q.content.concat(w).concat(P.content);
      } else
        ({ content: f, breakAtStart: d, openStart: p, openEnd: m } = mr.build(this.view.state.doc, u, c, this.decorations, this.dynamicDecorationMap));
      let { i: O, off: g } = s.findPos(h, 1), { i: b, off: S } = s.findPos(a, -1);
      Mp(this, b, S, O, g, f, d, p, m);
    }
    i && this.fixCompositionDOM(i);
  }
  compositionView(e) {
    let t = new Et(e.text.nodeValue);
    t.flags |= 8;
    for (let { deco: r } of e.marks)
      t = new an(r, [t], t.length);
    let i = new Me();
    return i.append(t, 0), i;
  }
  fixCompositionDOM(e) {
    let t = (s, o) => {
      o.flags |= 8 | (o.children.some(
        (a) => a.flags & 7
        /* ViewFlag.Dirty */
      ) ? 1 : 0), this.markedForComposition.add(o);
      let l = pe.get(s);
      l && l != o && (l.dom = null), o.setDOM(s);
    }, i = this.childPos(e.range.fromB, 1), r = this.children[i.i];
    t(e.line, r);
    for (let s = e.marks.length - 1; s >= -1; s--)
      i = r.childPos(i.off, 1), r = r.children[i.i], t(s >= 0 ? e.marks[s].node : e.text, r);
  }
  // Sync the DOM selection to this.state.selection
  updateSelection(e = !1, t = !1) {
    (e || !this.view.observer.selectionRange.focusNode) && this.view.observer.readSelectionRange();
    let i = this.view.root.activeElement, r = i == this.dom, s = !r && Ds(this.dom, this.view.observer.selectionRange) && !(i && this.dom.contains(i));
    if (!(r || t || s))
      return;
    let o = this.forceSelection;
    this.forceSelection = !1;
    let l = this.view.state.selection.main, a = this.moveToLine(this.domAtPos(l.anchor)), h = l.empty ? a : this.moveToLine(this.domAtPos(l.head));
    if (V.gecko && l.empty && !this.hasComposition && Zb(a)) {
      let c = document.createTextNode("");
      this.view.observer.ignore(() => a.node.insertBefore(c, a.node.childNodes[a.offset] || null)), a = h = new Ye(c, 0), o = !0;
    }
    let u = this.view.observer.selectionRange;
    (o || !u.focusNode || (!pr(a.node, a.offset, u.anchorNode, u.anchorOffset) || !pr(h.node, h.offset, u.focusNode, u.focusOffset)) && !this.suppressWidgetCursorChange(u, l)) && (this.view.observer.ignore(() => {
      V.android && V.chrome && this.dom.contains(u.focusNode) && Db(u.focusNode, this.dom) && (this.dom.blur(), this.dom.focus({ preventScroll: !0 }));
      let c = Js(this.view.root);
      if (c)
        if (l.empty) {
          if (V.gecko) {
            let f = Eb(a.node, a.offset);
            if (f && f != 3) {
              let d = (f == 1 ? Ap : Rp)(a.node, a.offset);
              d && (a = new Ye(d.node, d.offset));
            }
          }
          c.collapse(a.node, a.offset), l.bidiLevel != null && c.caretBidiLevel !== void 0 && (c.caretBidiLevel = l.bidiLevel);
        } else if (c.extend) {
          c.collapse(a.node, a.offset);
          try {
            c.extend(h.node, h.offset);
          } catch {
          }
        } else {
          let f = document.createRange();
          l.anchor > l.head && ([a, h] = [h, a]), f.setEnd(h.node, h.offset), f.setStart(a.node, a.offset), c.removeAllRanges(), c.addRange(f);
        }
      s && this.view.root.activeElement == this.dom && (this.dom.blur(), i && i.focus());
    }), this.view.observer.setSelectionRange(a, h)), this.impreciseAnchor = a.precise ? null : new Ye(u.anchorNode, u.anchorOffset), this.impreciseHead = h.precise ? null : new Ye(u.focusNode, u.focusOffset);
  }
  // If a zero-length widget is inserted next to the cursor during
  // composition, avoid moving it across it and disrupting the
  // composition.
  suppressWidgetCursorChange(e, t) {
    return this.hasComposition && t.empty && pr(e.focusNode, e.focusOffset, e.anchorNode, e.anchorOffset) && this.posFromDOM(e.focusNode, e.focusOffset) == t.head;
  }
  enforceCursorAssoc() {
    if (this.hasComposition)
      return;
    let { view: e } = this, t = e.state.selection.main, i = Js(e.root), { anchorNode: r, anchorOffset: s } = e.observer.selectionRange;
    if (!i || !t.empty || !t.assoc || !i.modify)
      return;
    let o = Me.find(this, t.head);
    if (!o)
      return;
    let l = o.posAtStart;
    if (t.head == l || t.head == l + o.length)
      return;
    let a = this.coordsAt(t.head, -1), h = this.coordsAt(t.head, 1);
    if (!a || !h || a.bottom > h.top)
      return;
    let u = this.domAtPos(t.head + t.assoc);
    i.collapse(u.node, u.offset), i.modify("move", t.assoc < 0 ? "forward" : "backward", "lineboundary"), e.observer.readSelectionRange();
    let c = e.observer.selectionRange;
    e.docView.posFromDOM(c.anchorNode, c.anchorOffset) != t.from && i.collapse(r, s);
  }
  // If a position is in/near a block widget, move it to a nearby text
  // line, since we don't want the cursor inside a block widget.
  moveToLine(e) {
    let t = this.dom, i;
    if (e.node != t)
      return e;
    for (let r = e.offset; !i && r < t.childNodes.length; r++) {
      let s = pe.get(t.childNodes[r]);
      s instanceof Me && (i = s.domAtPos(0));
    }
    for (let r = e.offset - 1; !i && r >= 0; r--) {
      let s = pe.get(t.childNodes[r]);
      s instanceof Me && (i = s.domAtPos(s.length));
    }
    return i ? new Ye(i.node, i.offset, !0) : e;
  }
  nearest(e) {
    for (let t = e; t; ) {
      let i = pe.get(t);
      if (i && i.rootView == this)
        return i;
      t = t.parentNode;
    }
    return null;
  }
  posFromDOM(e, t) {
    let i = this.nearest(e);
    if (!i)
      throw new RangeError("Trying to find position for a DOM position outside of the document");
    return i.localPosFromDOM(e, t) + i.posAtStart;
  }
  domAtPos(e) {
    let { i: t, off: i } = this.childCursor().findPos(e, -1);
    for (; t < this.children.length - 1; ) {
      let r = this.children[t];
      if (i < r.length || r instanceof Me)
        break;
      t++, i = 0;
    }
    return this.children[t].domAtPos(i);
  }
  coordsAt(e, t) {
    let i = null, r = 0;
    for (let s = this.length, o = this.children.length - 1; o >= 0; o--) {
      let l = this.children[o], a = s - l.breakAfter, h = a - l.length;
      if (a < e)
        break;
      h <= e && (h < e || l.covers(-1)) && (a > e || l.covers(1)) && (!i || l instanceof Me && !(i instanceof Me && t >= 0)) && (i = l, r = h), s = h;
    }
    return i ? i.coordsAt(e - r, t) : null;
  }
  coordsForChar(e) {
    let { i: t, off: i } = this.childPos(e, 1), r = this.children[t];
    if (!(r instanceof Me))
      return null;
    for (; r.children.length; ) {
      let { i: l, off: a } = r.childPos(i, 1);
      for (; ; l++) {
        if (l == r.children.length)
          return null;
        if ((r = r.children[l]).length)
          break;
      }
      i = a;
    }
    if (!(r instanceof Et))
      return null;
    let s = Be(r.text, i);
    if (s == i)
      return null;
    let o = Gn(r.dom, i, s).getClientRects();
    for (let l = 0; l < o.length; l++) {
      let a = o[l];
      if (l == o.length - 1 || a.top < a.bottom && a.left < a.right)
        return a;
    }
    return null;
  }
  measureVisibleLineHeights(e) {
    let t = [], { from: i, to: r } = e, s = this.view.contentDOM.clientWidth, o = s > Math.max(this.view.scrollDOM.clientWidth, this.minWidth) + 1, l = -1, a = this.view.textDirection == we.LTR;
    for (let h = 0, u = 0; u < this.children.length; u++) {
      let c = this.children[u], f = h + c.length;
      if (f > r)
        break;
      if (h >= i) {
        let d = c.dom.getBoundingClientRect();
        if (t.push(d.height), o) {
          let p = c.dom.lastChild, m = p ? vi(p) : [];
          if (m.length) {
            let O = m[m.length - 1], g = a ? O.right - d.left : d.right - O.left;
            g > l && (l = g, this.minWidth = s, this.minWidthFrom = h, this.minWidthTo = f);
          }
        }
      }
      h = f + c.breakAfter;
    }
    return t;
  }
  textDirectionAt(e) {
    let { i: t } = this.childPos(e, 1);
    return getComputedStyle(this.children[t].dom).direction == "rtl" ? we.RTL : we.LTR;
  }
  measureTextSize() {
    for (let s of this.children)
      if (s instanceof Me) {
        let o = s.measureTextSize();
        if (o)
          return o;
      }
    let e = document.createElement("div"), t, i, r;
    return e.className = "cm-line", e.style.width = "99999px", e.style.position = "absolute", e.textContent = "abc def ghi jkl mno pqr stu", this.view.observer.ignore(() => {
      this.dom.appendChild(e);
      let s = vi(e.firstChild)[0];
      t = e.getBoundingClientRect().height, i = s ? s.width / 27 : 7, r = s ? s.height : t, e.remove();
    }), { lineHeight: t, charWidth: i, textHeight: r };
  }
  childCursor(e = this.length) {
    let t = this.children.length;
    return t && (e -= this.children[--t].length), new Zp(this.children, e, t);
  }
  computeBlockGapDeco() {
    let e = [], t = this.view.viewState;
    for (let i = 0, r = 0; ; r++) {
      let s = r == t.viewports.length ? null : t.viewports[r], o = s ? s.from - 1 : this.length;
      if (o > i) {
        let l = (t.lineBlockAt(o).bottom - t.lineBlockAt(i).top) / this.view.scaleY;
        e.push(j.replace({
          widget: new nc(l),
          block: !0,
          inclusive: !0,
          isBlockGap: !0
        }).range(i, o));
      }
      if (!s)
        break;
      i = s.to + 1;
    }
    return j.set(e);
  }
  updateDeco() {
    let e = 0, t = this.view.state.facet(Pr).map((s) => (this.dynamicDecorationMap[e++] = typeof s == "function") ? s(this.view) : s), i = !1, r = this.view.state.facet(nm).map((s, o) => {
      let l = typeof s == "function";
      return l && (i = !0), l ? s(this.view) : s;
    });
    for (r.length && (this.dynamicDecorationMap[e++] = i, t.push(oe.join(r))), this.decorations = [
      ...t,
      this.computeBlockGapDeco(),
      this.view.viewState.lineGapDeco
    ]; e < this.decorations.length; )
      this.dynamicDecorationMap[e++] = !1;
    return this.decorations;
  }
  scrollIntoView(e) {
    if (e.isSnapshot) {
      let h = this.view.viewState.lineBlockAt(e.range.head);
      this.view.scrollDOM.scrollTop = h.top - e.yMargin, this.view.scrollDOM.scrollLeft = e.xMargin;
      return;
    }
    for (let h of this.view.state.facet(em))
      try {
        if (h(this.view, e.range, e))
          return !0;
      } catch (u) {
        it(this.view.state, u, "scroll handler");
      }
    let { range: t } = e, i = this.coordsAt(t.head, t.empty ? t.assoc : t.head > t.anchor ? -1 : 1), r;
    if (!i)
      return;
    !t.empty && (r = this.coordsAt(t.anchor, t.anchor > t.head ? -1 : 1)) && (i = {
      left: Math.min(i.left, r.left),
      top: Math.min(i.top, r.top),
      right: Math.max(i.right, r.right),
      bottom: Math.max(i.bottom, r.bottom)
    });
    let s = sm(this.view), o = {
      left: i.left - s.left,
      top: i.top - s.top,
      right: i.right + s.right,
      bottom: i.bottom + s.bottom
    }, { offsetWidth: l, offsetHeight: a } = this.view.scrollDOM;
    fb(this.view.scrollDOM, o, t.head < t.anchor ? -1 : 1, e.x, e.y, Math.max(Math.min(e.xMargin, l), -l), Math.max(Math.min(e.yMargin, a), -a), this.view.textDirection == we.LTR);
  }
}
function Zb(n) {
  return n.node.nodeType == 1 && n.node.firstChild && (n.offset == 0 || n.node.childNodes[n.offset - 1].contentEditable == "false") && (n.offset == n.node.childNodes.length || n.node.childNodes[n.offset].contentEditable == "false");
}
class nc extends Kt {
  constructor(e) {
    super(), this.height = e;
  }
  toDOM() {
    let e = document.createElement("div");
    return e.className = "cm-gap", this.updateDOM(e), e;
  }
  eq(e) {
    return e.height == this.height;
  }
  updateDOM(e) {
    return e.style.height = this.height + "px", !0;
  }
  get editable() {
    return !0;
  }
  get estimatedHeight() {
    return this.height;
  }
  ignoreEvent() {
    return !1;
  }
}
function om(n, e) {
  let t = n.observer.selectionRange;
  if (!t.focusNode)
    return null;
  let i = Ap(t.focusNode, t.focusOffset), r = Rp(t.focusNode, t.focusOffset), s = i || r;
  if (r && i && r.node != i.node) {
    let l = pe.get(r.node);
    if (!l || l instanceof Et && l.text != r.node.nodeValue)
      s = r;
    else if (n.docView.lastCompositionAfterCursor) {
      let a = pe.get(i.node);
      !a || a instanceof Et && a.text != i.node.nodeValue || (s = r);
    }
  }
  if (n.docView.lastCompositionAfterCursor = s != i, !s)
    return null;
  let o = e - s.offset;
  return { from: o, to: o + s.node.nodeValue.length, node: s.node };
}
function Mb(n, e, t) {
  let i = om(n, t);
  if (!i)
    return null;
  let { node: r, from: s, to: o } = i, l = r.nodeValue;
  if (/[\n\r]/.test(l) || n.state.doc.sliceString(i.from, i.to) != l)
    return null;
  let a = e.invertedDesc, h = new wt(a.mapPos(s), a.mapPos(o), s, o), u = [];
  for (let c = r.parentNode; ; c = c.parentNode) {
    let f = pe.get(c);
    if (f instanceof an)
      u.push({ node: c, deco: f.mark });
    else {
      if (f instanceof Me || c.nodeName == "DIV" && c.parentNode == n.contentDOM)
        return { range: h, text: r, marks: u, line: c };
      if (c != n.contentDOM)
        u.push({ node: c, deco: new Vr({
          inclusive: !0,
          attributes: kb(c),
          tagName: c.tagName.toLowerCase()
        }) });
      else
        return null;
    }
  }
}
function Eb(n, e) {
  return n.nodeType != 1 ? 0 : (e && n.childNodes[e - 1].contentEditable == "false" ? 1 : 0) | (e < n.childNodes.length && n.childNodes[e].contentEditable == "false" ? 2 : 0);
}
let zb = class {
  constructor() {
    this.changes = [];
  }
  compareRange(e, t) {
    Pa(e, t, this.changes);
  }
  comparePoint(e, t) {
    Pa(e, t, this.changes);
  }
};
function Xb(n, e, t) {
  let i = new zb();
  return oe.compare(n, e, t, i), i.changes;
}
function Db(n, e) {
  for (let t = n; t && t != e; t = t.assignedSlot || t.parentNode)
    if (t.nodeType == 1 && t.contentEditable == "false")
      return !0;
  return !1;
}
function Lb(n, e) {
  let t = !1;
  return e && n.iterChangedRanges((i, r) => {
    i < e.to && r > e.from && (t = !0);
  }), t;
}
function Ib(n, e, t = 1) {
  let i = n.charCategorizer(e), r = n.doc.lineAt(e), s = e - r.from;
  if (r.length == 0)
    return $.cursor(e);
  s == 0 ? t = 1 : s == r.length && (t = -1);
  let o = s, l = s;
  t < 0 ? o = Be(r.text, s, !1) : l = Be(r.text, s);
  let a = i(r.text.slice(o, l));
  for (; o > 0; ) {
    let h = Be(r.text, o, !1);
    if (i(r.text.slice(h, o)) != a)
      break;
    o = h;
  }
  for (; l < r.length; ) {
    let h = Be(r.text, l);
    if (i(r.text.slice(l, h)) != a)
      break;
    l = h;
  }
  return $.range(o + r.from, l + r.from);
}
function _b(n, e) {
  return e.left > n ? e.left - n : Math.max(0, n - e.right);
}
function qb(n, e) {
  return e.top > n ? e.top - n : Math.max(0, n - e.bottom);
}
function al(n, e) {
  return n.top < e.bottom - 1 && n.bottom > e.top + 1;
}
function ic(n, e) {
  return e < n.top ? { top: e, left: n.left, right: n.right, bottom: n.bottom } : n;
}
function rc(n, e) {
  return e > n.bottom ? { top: n.top, left: n.left, right: n.right, bottom: e } : n;
}
function Aa(n, e, t) {
  let i, r, s, o, l = !1, a, h, u, c;
  for (let p = n.firstChild; p; p = p.nextSibling) {
    let m = vi(p);
    for (let O = 0; O < m.length; O++) {
      let g = m[O];
      r && al(r, g) && (g = ic(rc(g, r.bottom), r.top));
      let b = _b(e, g), S = qb(t, g);
      if (b == 0 && S == 0)
        return p.nodeType == 3 ? sc(p, e, t) : Aa(p, e, t);
      if (!i || o > S || o == S && s > b) {
        i = p, r = g, s = b, o = S;
        let Q = S ? t < g.top ? -1 : 1 : b ? e < g.left ? -1 : 1 : 0;
        l = !Q || (Q > 0 ? O < m.length - 1 : O > 0);
      }
      b == 0 ? t > g.bottom && (!u || u.bottom < g.bottom) ? (a = p, u = g) : t < g.top && (!c || c.top > g.top) && (h = p, c = g) : u && al(u, g) ? u = rc(u, g.bottom) : c && al(c, g) && (c = ic(c, g.top));
    }
  }
  if (u && u.bottom >= t ? (i = a, r = u) : c && c.top <= t && (i = h, r = c), !i)
    return { node: n, offset: 0 };
  let f = Math.max(r.left, Math.min(r.right, e));
  if (i.nodeType == 3)
    return sc(i, f, t);
  if (l && i.contentEditable != "false")
    return Aa(i, f, t);
  let d = Array.prototype.indexOf.call(n.childNodes, i) + (e >= (r.left + r.right) / 2 ? 1 : 0);
  return { node: n, offset: d };
}
function sc(n, e, t) {
  let i = n.nodeValue.length, r = -1, s = 1e9, o = 0;
  for (let l = 0; l < i; l++) {
    let a = Gn(n, l, l + 1).getClientRects();
    for (let h = 0; h < a.length; h++) {
      let u = a[h];
      if (u.top == u.bottom)
        continue;
      o || (o = e - u.left);
      let c = (u.top > t ? u.top - t : t - u.bottom) - 1;
      if (u.left - 1 <= e && u.right + 1 >= e && c < s) {
        let f = e >= (u.left + u.right) / 2, d = f;
        if ((V.chrome || V.gecko) && Gn(n, l).getBoundingClientRect().left == u.right && (d = !f), c <= 0)
          return { node: n, offset: l + (d ? 1 : 0) };
        r = l + (d ? 1 : 0), s = c;
      }
    }
  }
  return { node: n, offset: r > -1 ? r : o > 0 ? n.nodeValue.length : 0 };
}
function lm(n, e, t, i = -1) {
  var r, s;
  let o = n.contentDOM.getBoundingClientRect(), l = o.top + n.viewState.paddingTop, a, { docHeight: h } = n.viewState, { x: u, y: c } = e, f = c - l;
  if (f < 0)
    return 0;
  if (f > h)
    return n.state.doc.length;
  for (let Q = n.viewState.heightOracle.textHeight / 2, P = !1; a = n.elementAtHeight(f), a.type != Ke.Text; )
    for (; f = i > 0 ? a.bottom + Q : a.top - Q, !(f >= 0 && f <= h); ) {
      if (P)
        return t ? null : 0;
      P = !0, i = -i;
    }
  c = l + f;
  let d = a.from;
  if (d < n.viewport.from)
    return n.viewport.from == 0 ? 0 : t ? null : oc(n, o, a, u, c);
  if (d > n.viewport.to)
    return n.viewport.to == n.state.doc.length ? n.state.doc.length : t ? null : oc(n, o, a, u, c);
  let p = n.dom.ownerDocument, m = n.root.elementFromPoint ? n.root : p, O = m.elementFromPoint(u, c);
  O && !n.contentDOM.contains(O) && (O = null), O || (u = Math.max(o.left + 1, Math.min(o.right - 1, u)), O = m.elementFromPoint(u, c), O && !n.contentDOM.contains(O) && (O = null));
  let g, b = -1;
  if (O && ((r = n.docView.nearest(O)) === null || r === void 0 ? void 0 : r.isEditable) != !1) {
    if (p.caretPositionFromPoint) {
      let Q = p.caretPositionFromPoint(u, c);
      Q && ({ offsetNode: g, offset: b } = Q);
    } else if (p.caretRangeFromPoint) {
      let Q = p.caretRangeFromPoint(u, c);
      Q && ({ startContainer: g, startOffset: b } = Q, (!n.contentDOM.contains(g) || V.safari && Wb(g, b, u) || V.chrome && Bb(g, b, u)) && (g = void 0));
    }
  }
  if (!g || !n.docView.dom.contains(g)) {
    let Q = Me.find(n.docView, d);
    if (!Q)
      return f > a.top + a.height / 2 ? a.to : a.from;
    ({ node: g, offset: b } = Aa(Q.dom, u, c));
  }
  let S = n.docView.nearest(g);
  if (!S)
    return null;
  if (S.isWidget && ((s = S.dom) === null || s === void 0 ? void 0 : s.nodeType) == 1) {
    let Q = S.dom.getBoundingClientRect();
    return e.y < Q.top || e.y <= Q.bottom && e.x <= (Q.left + Q.right) / 2 ? S.posAtStart : S.posAtEnd;
  } else
    return S.localPosFromDOM(g, b) + S.posAtStart;
}
function oc(n, e, t, i, r) {
  let s = Math.round((i - e.left) * n.defaultCharacterWidth);
  if (n.lineWrapping && t.height > n.defaultLineHeight * 1.5) {
    let l = n.viewState.heightOracle.textHeight, a = Math.floor((r - t.top - (n.defaultLineHeight - l) * 0.5) / l);
    s += a * n.viewState.heightOracle.lineLength;
  }
  let o = n.state.sliceDoc(t.from, t.to);
  return t.from + Oa(o, s, n.state.tabSize);
}
function Wb(n, e, t) {
  let i;
  if (n.nodeType != 3 || e != (i = n.nodeValue.length))
    return !1;
  for (let r = n.nextSibling; r; r = r.nextSibling)
    if (r.nodeType != 1 || r.nodeName != "BR")
      return !1;
  return Gn(n, i - 1, i).getBoundingClientRect().left > t;
}
function Bb(n, e, t) {
  if (e != 0)
    return !1;
  for (let r = n; ; ) {
    let s = r.parentNode;
    if (!s || s.nodeType != 1 || s.firstChild != r)
      return !1;
    if (s.classList.contains("cm-line"))
      break;
    r = s;
  }
  let i = n.nodeType == 1 ? n.getBoundingClientRect() : Gn(n, 0, Math.max(n.nodeValue.length, 1)).getBoundingClientRect();
  return t - i.left > 5;
}
function Ra(n, e) {
  let t = n.lineBlockAt(e);
  if (Array.isArray(t.type)) {
    for (let i of t.type)
      if (i.to > e || i.to == e && (i.to == t.to || i.type == Ke.Text))
        return i;
  }
  return t;
}
function Vb(n, e, t, i) {
  let r = Ra(n, e.head), s = !i || r.type != Ke.Text || !(n.lineWrapping || r.widgetLineBreaks) ? null : n.coordsAtPos(e.assoc < 0 && e.head > r.from ? e.head - 1 : e.head);
  if (s) {
    let o = n.dom.getBoundingClientRect(), l = n.textDirectionAt(r.from), a = n.posAtCoords({
      x: t == (l == we.LTR) ? o.right - 1 : o.left + 1,
      y: (s.top + s.bottom) / 2
    });
    if (a != null)
      return $.cursor(a, t ? -1 : 1);
  }
  return $.cursor(t ? r.to : r.from, t ? -1 : 1);
}
function lc(n, e, t, i) {
  let r = n.state.doc.lineAt(e.head), s = n.bidiSpans(r), o = n.textDirectionAt(r.from);
  for (let l = e, a = null; ; ) {
    let h = Tb(r, s, o, l, t), u = Yp;
    if (!h) {
      if (r.number == (t ? n.state.doc.lines : 1))
        return l;
      u = `
`, r = n.state.doc.line(r.number + (t ? 1 : -1)), s = n.bidiSpans(r), h = n.visualLineSide(r, !t);
    }
    if (a) {
      if (!a(u))
        return l;
    } else {
      if (!i)
        return h;
      a = i(u);
    }
    l = h;
  }
}
function Yb(n, e, t) {
  let i = n.state.charCategorizer(e), r = i(t);
  return (s) => {
    let o = i(s);
    return r == ve.Space && (r = o), r == o;
  };
}
function jb(n, e, t, i) {
  let r = e.head, s = t ? 1 : -1;
  if (r == (t ? n.state.doc.length : 0))
    return $.cursor(r, e.assoc);
  let o = e.goalColumn, l, a = n.contentDOM.getBoundingClientRect(), h = n.coordsAtPos(r, e.assoc || -1), u = n.documentTop;
  if (h)
    o == null && (o = h.left - a.left), l = s < 0 ? h.top : h.bottom;
  else {
    let d = n.viewState.lineBlockAt(r);
    o == null && (o = Math.min(a.right - a.left, n.defaultCharacterWidth * (r - d.from))), l = (s < 0 ? d.top : d.bottom) + u;
  }
  let c = a.left + o, f = i ?? n.viewState.heightOracle.textHeight >> 1;
  for (let d = 0; ; d += 10) {
    let p = l + (f + d) * s, m = lm(n, { x: c, y: p }, !1, s);
    if (p < a.top || p > a.bottom || (s < 0 ? m < r : m > r)) {
      let O = n.docView.coordsForChar(m), g = !O || p < O.top ? -1 : 1;
      return $.cursor(m, g, void 0, o);
    }
  }
}
function Ls(n, e, t) {
  for (; ; ) {
    let i = 0;
    for (let r of n)
      r.between(e - 1, e + 1, (s, o, l) => {
        if (e > s && e < o) {
          let a = i || t || (e - s < o - e ? -1 : 1);
          e = a < 0 ? s : o, i = a;
        }
      });
    if (!i)
      return e;
  }
}
function hl(n, e, t) {
  let i = Ls(n.state.facet(Rh).map((r) => r(n)), t.from, e.head > t.from ? -1 : 1);
  return i == t.from ? t : $.cursor(i, i < t.from ? 1 : -1);
}
class Nb {
  setSelectionOrigin(e) {
    this.lastSelectionOrigin = e, this.lastSelectionTime = Date.now();
  }
  constructor(e) {
    this.view = e, this.lastKeyCode = 0, this.lastKeyTime = 0, this.lastTouchTime = 0, this.lastFocusTime = 0, this.lastScrollTop = 0, this.lastScrollLeft = 0, this.pendingIOSKey = void 0, this.lastSelectionOrigin = null, this.lastSelectionTime = 0, this.lastEscPress = 0, this.lastContextMenu = 0, this.scrollHandlers = [], this.handlers = /* @__PURE__ */ Object.create(null), this.composing = -1, this.compositionFirstChange = null, this.compositionEndedAt = 0, this.compositionPendingKey = !1, this.compositionPendingChange = !1, this.mouseSelection = null, this.draggedContent = null, this.handleEvent = this.handleEvent.bind(this), this.notifiedFocused = e.hasFocus, V.safari && e.contentDOM.addEventListener("input", () => null), V.gecko && hy(e.contentDOM.ownerDocument);
  }
  handleEvent(e) {
    !ty(this.view, e) || this.ignoreDuringComposition(e) || e.type == "keydown" && this.keydown(e) || this.runHandlers(e.type, e);
  }
  runHandlers(e, t) {
    let i = this.handlers[e];
    if (i) {
      for (let r of i.observers)
        r(this.view, t);
      for (let r of i.handlers) {
        if (t.defaultPrevented)
          break;
        if (r(this.view, t)) {
          t.preventDefault();
          break;
        }
      }
    }
  }
  ensureHandlers(e) {
    let t = Ub(e), i = this.handlers, r = this.view.contentDOM;
    for (let s in t)
      if (s != "scroll") {
        let o = !t[s].handlers.length, l = i[s];
        l && o != !l.handlers.length && (r.removeEventListener(s, this.handleEvent), l = null), l || r.addEventListener(s, this.handleEvent, { passive: o });
      }
    for (let s in i)
      s != "scroll" && !t[s] && r.removeEventListener(s, this.handleEvent);
    this.handlers = t;
  }
  keydown(e) {
    if (this.lastKeyCode = e.keyCode, this.lastKeyTime = Date.now(), e.keyCode == 9 && Date.now() < this.lastEscPress + 2e3)
      return !0;
    if (e.keyCode != 27 && hm.indexOf(e.keyCode) < 0 && (this.view.inputState.lastEscPress = 0), V.android && V.chrome && !e.synthetic && (e.keyCode == 13 || e.keyCode == 8))
      return this.view.observer.delayAndroidKey(e.key, e.keyCode), !0;
    let t;
    return V.ios && !e.synthetic && !e.altKey && !e.metaKey && ((t = am.find((i) => i.keyCode == e.keyCode)) && !e.ctrlKey || Fb.indexOf(e.key) > -1 && e.ctrlKey && !e.shiftKey) ? (this.pendingIOSKey = t || e, setTimeout(() => this.flushIOSKey(), 250), !0) : (e.keyCode != 229 && this.view.observer.forceFlush(), !1);
  }
  flushIOSKey(e) {
    let t = this.pendingIOSKey;
    return !t || t.key == "Enter" && e && e.from < e.to && /^\S+$/.test(e.insert.toString()) ? !1 : (this.pendingIOSKey = void 0, mi(this.view.contentDOM, t.key, t.keyCode, t instanceof KeyboardEvent ? t : void 0));
  }
  ignoreDuringComposition(e) {
    return /^key/.test(e.type) ? this.composing > 0 ? !0 : V.safari && !V.ios && this.compositionPendingKey && Date.now() - this.compositionEndedAt < 100 ? (this.compositionPendingKey = !1, !0) : !1 : !1;
  }
  startMouseSelection(e) {
    this.mouseSelection && this.mouseSelection.destroy(), this.mouseSelection = e;
  }
  update(e) {
    this.mouseSelection && this.mouseSelection.update(e), this.draggedContent && e.docChanged && (this.draggedContent = this.draggedContent.map(e.changes)), e.transactions.length && (this.lastKeyCode = this.lastSelectionTime = 0);
  }
  destroy() {
    this.mouseSelection && this.mouseSelection.destroy();
  }
}
function ac(n, e) {
  return (t, i) => {
    try {
      return e.call(n, i, t);
    } catch (r) {
      it(t.state, r);
    }
  };
}
function Ub(n) {
  let e = /* @__PURE__ */ Object.create(null);
  function t(i) {
    return e[i] || (e[i] = { observers: [], handlers: [] });
  }
  for (let i of n) {
    let r = i.spec;
    if (r && r.domEventHandlers)
      for (let s in r.domEventHandlers) {
        let o = r.domEventHandlers[s];
        o && t(s).handlers.push(ac(i.value, o));
      }
    if (r && r.domEventObservers)
      for (let s in r.domEventObservers) {
        let o = r.domEventObservers[s];
        o && t(s).observers.push(ac(i.value, o));
      }
  }
  for (let i in zt)
    t(i).handlers.push(zt[i]);
  for (let i in vt)
    t(i).observers.push(vt[i]);
  return e;
}
const am = [
  { key: "Backspace", keyCode: 8, inputType: "deleteContentBackward" },
  { key: "Enter", keyCode: 13, inputType: "insertParagraph" },
  { key: "Enter", keyCode: 13, inputType: "insertLineBreak" },
  { key: "Delete", keyCode: 46, inputType: "deleteContentForward" }
], Fb = "dthko", hm = [16, 17, 18, 20, 91, 92, 224, 225], os = 6;
function ls(n) {
  return Math.max(0, n) * 0.7 + 8;
}
function Gb(n, e) {
  return Math.max(Math.abs(n.clientX - e.clientX), Math.abs(n.clientY - e.clientY));
}
class Hb {
  constructor(e, t, i, r) {
    this.view = e, this.startEvent = t, this.style = i, this.mustSelect = r, this.scrollSpeed = { x: 0, y: 0 }, this.scrolling = -1, this.lastEvent = t, this.scrollParent = db(e.contentDOM), this.atoms = e.state.facet(Rh).map((o) => o(e));
    let s = e.contentDOM.ownerDocument;
    s.addEventListener("mousemove", this.move = this.move.bind(this)), s.addEventListener("mouseup", this.up = this.up.bind(this)), this.extend = t.shiftKey, this.multiple = e.state.facet(ee.allowMultipleSelections) && Kb(e, t), this.dragging = ey(e, t) && dm(t) == 1 ? null : !1;
  }
  start(e) {
    this.dragging === !1 && this.select(e);
  }
  move(e) {
    var t;
    if (e.buttons == 0)
      return this.destroy();
    if (this.dragging || this.dragging == null && Gb(this.startEvent, e) < 10)
      return;
    this.select(this.lastEvent = e);
    let i = 0, r = 0, s = ((t = this.scrollParent) === null || t === void 0 ? void 0 : t.getBoundingClientRect()) || { left: 0, top: 0, right: this.view.win.innerWidth, bottom: this.view.win.innerHeight }, o = sm(this.view);
    e.clientX - o.left <= s.left + os ? i = -ls(s.left - e.clientX) : e.clientX + o.right >= s.right - os && (i = ls(e.clientX - s.right)), e.clientY - o.top <= s.top + os ? r = -ls(s.top - e.clientY) : e.clientY + o.bottom >= s.bottom - os && (r = ls(e.clientY - s.bottom)), this.setScrollSpeed(i, r);
  }
  up(e) {
    this.dragging == null && this.select(this.lastEvent), this.dragging || e.preventDefault(), this.destroy();
  }
  destroy() {
    this.setScrollSpeed(0, 0);
    let e = this.view.contentDOM.ownerDocument;
    e.removeEventListener("mousemove", this.move), e.removeEventListener("mouseup", this.up), this.view.inputState.mouseSelection = this.view.inputState.draggedContent = null;
  }
  setScrollSpeed(e, t) {
    this.scrollSpeed = { x: e, y: t }, e || t ? this.scrolling < 0 && (this.scrolling = setInterval(() => this.scroll(), 50)) : this.scrolling > -1 && (clearInterval(this.scrolling), this.scrolling = -1);
  }
  scroll() {
    this.scrollParent ? (this.scrollParent.scrollLeft += this.scrollSpeed.x, this.scrollParent.scrollTop += this.scrollSpeed.y) : this.view.win.scrollBy(this.scrollSpeed.x, this.scrollSpeed.y), this.dragging === !1 && this.select(this.lastEvent);
  }
  skipAtoms(e) {
    let t = null;
    for (let i = 0; i < e.ranges.length; i++) {
      let r = e.ranges[i], s = null;
      if (r.empty) {
        let o = Ls(this.atoms, r.from, 0);
        o != r.from && (s = $.cursor(o, -1));
      } else {
        let o = Ls(this.atoms, r.from, -1), l = Ls(this.atoms, r.to, 1);
        (o != r.from || l != r.to) && (s = $.range(r.from == r.anchor ? o : l, r.from == r.head ? o : l));
      }
      s && (t || (t = e.ranges.slice()), t[i] = s);
    }
    return t ? $.create(t, e.mainIndex) : e;
  }
  select(e) {
    let { view: t } = this, i = this.skipAtoms(this.style.get(e, this.extend, this.multiple));
    (this.mustSelect || !i.eq(t.state.selection, this.dragging === !1)) && this.view.dispatch({
      selection: i,
      userEvent: "select.pointer"
    }), this.mustSelect = !1;
  }
  update(e) {
    this.style.update(e) && setTimeout(() => this.select(this.lastEvent), 20);
  }
}
function Kb(n, e) {
  let t = n.state.facet(jp);
  return t.length ? t[0](e) : V.mac ? e.metaKey : e.ctrlKey;
}
function Jb(n, e) {
  let t = n.state.facet(Np);
  return t.length ? t[0](e) : V.mac ? !e.altKey : !e.ctrlKey;
}
function ey(n, e) {
  let { main: t } = n.state.selection;
  if (t.empty)
    return !1;
  let i = Js(n.root);
  if (!i || i.rangeCount == 0)
    return !0;
  let r = i.getRangeAt(0).getClientRects();
  for (let s = 0; s < r.length; s++) {
    let o = r[s];
    if (o.left <= e.clientX && o.right >= e.clientX && o.top <= e.clientY && o.bottom >= e.clientY)
      return !0;
  }
  return !1;
}
function ty(n, e) {
  if (!e.bubbles)
    return !0;
  if (e.defaultPrevented)
    return !1;
  for (let t = e.target, i; t != n.contentDOM; t = t.parentNode)
    if (!t || t.nodeType == 11 || (i = pe.get(t)) && i.ignoreEvent(e))
      return !1;
  return !0;
}
const zt = /* @__PURE__ */ Object.create(null), vt = /* @__PURE__ */ Object.create(null), um = V.ie && V.ie_version < 15 || V.ios && V.webkit_version < 604;
function ny(n) {
  let e = n.dom.parentNode;
  if (!e)
    return;
  let t = e.appendChild(document.createElement("textarea"));
  t.style.cssText = "position: fixed; left: -10000px; top: 10px", t.focus(), setTimeout(() => {
    n.focus(), t.remove(), cm(n, t.value);
  }, 50);
}
function cm(n, e) {
  let { state: t } = n, i, r = 1, s = t.toText(e), o = s.lines == t.selection.ranges.length;
  if (Za != null && t.selection.ranges.every((a) => a.empty) && Za == s.toString()) {
    let a = -1;
    i = t.changeByRange((h) => {
      let u = t.doc.lineAt(h.from);
      if (u.from == a)
        return { range: h };
      a = u.from;
      let c = t.toText((o ? s.line(r++).text : e) + t.lineBreak);
      return {
        changes: { from: u.from, insert: c },
        range: $.cursor(h.from + c.length)
      };
    });
  } else
    o ? i = t.changeByRange((a) => {
      let h = s.line(r++);
      return {
        changes: { from: a.from, to: a.to, insert: h.text },
        range: $.cursor(a.from + h.length)
      };
    }) : i = t.replaceSelection(s);
  n.dispatch(i, {
    userEvent: "input.paste",
    scrollIntoView: !0
  });
}
vt.scroll = (n) => {
  n.inputState.lastScrollTop = n.scrollDOM.scrollTop, n.inputState.lastScrollLeft = n.scrollDOM.scrollLeft;
};
zt.keydown = (n, e) => (n.inputState.setSelectionOrigin("select"), e.keyCode == 27 && (n.inputState.lastEscPress = Date.now()), !1);
vt.touchstart = (n, e) => {
  n.inputState.lastTouchTime = Date.now(), n.inputState.setSelectionOrigin("select.pointer");
};
vt.touchmove = (n) => {
  n.inputState.setSelectionOrigin("select.pointer");
};
zt.mousedown = (n, e) => {
  if (n.observer.flush(), n.inputState.lastTouchTime > Date.now() - 2e3)
    return !1;
  let t = null;
  for (let i of n.state.facet(Up))
    if (t = i(n, e), t)
      break;
  if (!t && e.button == 0 && (t = sy(n, e)), t) {
    let i = !n.hasFocus;
    n.inputState.startMouseSelection(new Hb(n, e, t, i)), i && n.observer.ignore(() => $p(n.contentDOM));
    let r = n.inputState.mouseSelection;
    if (r)
      return r.start(e), r.dragging === !1;
  }
  return !1;
};
function hc(n, e, t, i) {
  if (i == 1)
    return $.cursor(e, t);
  if (i == 2)
    return Ib(n.state, e, t);
  {
    let r = Me.find(n.docView, e), s = n.state.doc.lineAt(r ? r.posAtEnd : e), o = r ? r.posAtStart : s.from, l = r ? r.posAtEnd : s.to;
    return l < n.state.doc.length && l == s.to && l++, $.range(o, l);
  }
}
let fm = (n, e) => n >= e.top && n <= e.bottom, uc = (n, e, t) => fm(e, t) && n >= t.left && n <= t.right;
function iy(n, e, t, i) {
  let r = Me.find(n.docView, e);
  if (!r)
    return 1;
  let s = e - r.posAtStart;
  if (s == 0)
    return 1;
  if (s == r.length)
    return -1;
  let o = r.coordsAt(s, -1);
  if (o && uc(t, i, o))
    return -1;
  let l = r.coordsAt(s, 1);
  return l && uc(t, i, l) ? 1 : o && fm(i, o) ? -1 : 1;
}
function cc(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1);
  return { pos: t, bias: iy(n, t, e.clientX, e.clientY) };
}
const ry = V.ie && V.ie_version <= 11;
let fc = null, dc = 0, pc = 0;
function dm(n) {
  if (!ry)
    return n.detail;
  let e = fc, t = pc;
  return fc = n, pc = Date.now(), dc = !e || t > Date.now() - 400 && Math.abs(e.clientX - n.clientX) < 2 && Math.abs(e.clientY - n.clientY) < 2 ? (dc + 1) % 3 : 1;
}
function sy(n, e) {
  let t = cc(n, e), i = dm(e), r = n.state.selection;
  return {
    update(s) {
      s.docChanged && (t.pos = s.changes.mapPos(t.pos), r = r.map(s.changes));
    },
    get(s, o, l) {
      let a = cc(n, s), h, u = hc(n, a.pos, a.bias, i);
      if (t.pos != a.pos && !o) {
        let c = hc(n, t.pos, t.bias, i), f = Math.min(c.from, u.from), d = Math.max(c.to, u.to);
        u = f < u.from ? $.range(f, d) : $.range(d, f);
      }
      return o ? r.replaceRange(r.main.extend(u.from, u.to)) : l && i == 1 && r.ranges.length > 1 && (h = oy(r, a.pos)) ? h : l ? r.addRange(u) : $.create([u]);
    }
  };
}
function oy(n, e) {
  for (let t = 0; t < n.ranges.length; t++) {
    let { from: i, to: r } = n.ranges[t];
    if (i <= e && r >= e)
      return $.create(n.ranges.slice(0, t).concat(n.ranges.slice(t + 1)), n.mainIndex == t ? 0 : n.mainIndex - (n.mainIndex > t ? 1 : 0));
  }
  return null;
}
zt.dragstart = (n, e) => {
  let { selection: { main: t } } = n.state;
  if (e.target.draggable) {
    let r = n.docView.nearest(e.target);
    if (r && r.isWidget) {
      let s = r.posAtStart, o = s + r.length;
      (s >= t.to || o <= t.from) && (t = $.range(s, o));
    }
  }
  let { inputState: i } = n;
  return i.mouseSelection && (i.mouseSelection.dragging = !0), i.draggedContent = t, e.dataTransfer && (e.dataTransfer.setData("Text", n.state.sliceDoc(t.from, t.to)), e.dataTransfer.effectAllowed = "copyMove"), !1;
};
zt.dragend = (n) => (n.inputState.draggedContent = null, !1);
function mc(n, e, t, i) {
  if (!t)
    return;
  let r = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), { draggedContent: s } = n.inputState, o = i && s && Jb(n, e) ? { from: s.from, to: s.to } : null, l = { from: r, insert: t }, a = n.state.changes(o ? [o, l] : l);
  n.focus(), n.dispatch({
    changes: a,
    selection: { anchor: a.mapPos(r, -1), head: a.mapPos(r, 1) },
    userEvent: o ? "move.drop" : "input.drop"
  }), n.inputState.draggedContent = null;
}
zt.drop = (n, e) => {
  if (!e.dataTransfer)
    return !1;
  if (n.state.readOnly)
    return !0;
  let t = e.dataTransfer.files;
  if (t && t.length) {
    let i = Array(t.length), r = 0, s = () => {
      ++r == t.length && mc(n, e, i.filter((o) => o != null).join(n.state.lineBreak), !1);
    };
    for (let o = 0; o < t.length; o++) {
      let l = new FileReader();
      l.onerror = s, l.onload = () => {
        /[\x00-\x08\x0e-\x1f]{2}/.test(l.result) || (i[o] = l.result), s();
      }, l.readAsText(t[o]);
    }
    return !0;
  } else {
    let i = e.dataTransfer.getData("Text");
    if (i)
      return mc(n, e, i, !0), !0;
  }
  return !1;
};
zt.paste = (n, e) => {
  if (n.state.readOnly)
    return !0;
  n.observer.flush();
  let t = um ? null : e.clipboardData;
  return t ? (cm(n, t.getData("text/plain") || t.getData("text/uri-list")), !0) : (ny(n), !1);
};
function ly(n, e) {
  let t = n.dom.parentNode;
  if (!t)
    return;
  let i = t.appendChild(document.createElement("textarea"));
  i.style.cssText = "position: fixed; left: -10000px; top: 10px", i.value = e, i.focus(), i.selectionEnd = e.length, i.selectionStart = 0, setTimeout(() => {
    i.remove(), n.focus();
  }, 50);
}
function ay(n) {
  let e = [], t = [], i = !1;
  for (let r of n.selection.ranges)
    r.empty || (e.push(n.sliceDoc(r.from, r.to)), t.push(r));
  if (!e.length) {
    let r = -1;
    for (let { from: s } of n.selection.ranges) {
      let o = n.doc.lineAt(s);
      o.number > r && (e.push(o.text), t.push({ from: o.from, to: Math.min(n.doc.length, o.to + 1) })), r = o.number;
    }
    i = !0;
  }
  return { text: e.join(n.lineBreak), ranges: t, linewise: i };
}
let Za = null;
zt.copy = zt.cut = (n, e) => {
  let { text: t, ranges: i, linewise: r } = ay(n.state);
  if (!t && !r)
    return !1;
  Za = r ? t : null, e.type == "cut" && !n.state.readOnly && n.dispatch({
    changes: i,
    scrollIntoView: !0,
    userEvent: "delete.cut"
  });
  let s = um ? null : e.clipboardData;
  return s ? (s.clearData(), s.setData("text/plain", t), !0) : (ly(n, t), !1);
};
const pm = /* @__PURE__ */ cn.define();
function mm(n, e) {
  let t = [];
  for (let i of n.facet(Hp)) {
    let r = i(n, e);
    r && t.push(r);
  }
  return t ? n.update({ effects: t, annotations: pm.of(!0) }) : null;
}
function Om(n) {
  setTimeout(() => {
    let e = n.hasFocus;
    if (e != n.inputState.notifiedFocused) {
      let t = mm(n.state, e);
      t ? n.dispatch(t) : n.update([]);
    }
  }, 10);
}
vt.focus = (n) => {
  n.inputState.lastFocusTime = Date.now(), !n.scrollDOM.scrollTop && (n.inputState.lastScrollTop || n.inputState.lastScrollLeft) && (n.scrollDOM.scrollTop = n.inputState.lastScrollTop, n.scrollDOM.scrollLeft = n.inputState.lastScrollLeft), Om(n);
};
vt.blur = (n) => {
  n.observer.clearSelectionRange(), Om(n);
};
vt.compositionstart = vt.compositionupdate = (n) => {
  n.inputState.compositionFirstChange == null && (n.inputState.compositionFirstChange = !0), n.inputState.composing < 0 && (n.inputState.composing = 0);
};
vt.compositionend = (n) => {
  n.inputState.composing = -1, n.inputState.compositionEndedAt = Date.now(), n.inputState.compositionPendingKey = !0, n.inputState.compositionPendingChange = n.observer.pendingRecords().length > 0, n.inputState.compositionFirstChange = null, V.chrome && V.android ? n.observer.flushSoon() : n.inputState.compositionPendingChange ? Promise.resolve().then(() => n.observer.flush()) : setTimeout(() => {
    n.inputState.composing < 0 && n.docView.hasComposition && n.update([]);
  }, 50);
};
vt.contextmenu = (n) => {
  n.inputState.lastContextMenu = Date.now();
};
zt.beforeinput = (n, e) => {
  var t;
  let i;
  if (V.chrome && V.android && (i = am.find((r) => r.inputType == e.inputType)) && (n.observer.delayAndroidKey(i.key, i.keyCode), i.key == "Backspace" || i.key == "Delete")) {
    let r = ((t = window.visualViewport) === null || t === void 0 ? void 0 : t.height) || 0;
    setTimeout(() => {
      var s;
      (((s = window.visualViewport) === null || s === void 0 ? void 0 : s.height) || 0) > r + 10 && n.hasFocus && (n.contentDOM.blur(), n.focus());
    }, 100);
  }
  return V.ios && e.inputType == "deleteContentForward" && n.observer.flushSoon(), V.safari && e.inputType == "insertText" && n.inputState.composing >= 0 && setTimeout(() => vt.compositionend(n, e), 20), !1;
};
const Oc = /* @__PURE__ */ new Set();
function hy(n) {
  Oc.has(n) || (Oc.add(n), n.addEventListener("copy", () => {
  }), n.addEventListener("cut", () => {
  }));
}
const gc = ["pre-wrap", "normal", "pre-line", "break-spaces"];
class uy {
  constructor(e) {
    this.lineWrapping = e, this.doc = le.empty, this.heightSamples = {}, this.lineHeight = 14, this.charWidth = 7, this.textHeight = 14, this.lineLength = 30, this.heightChanged = !1;
  }
  heightForGap(e, t) {
    let i = this.doc.lineAt(t).number - this.doc.lineAt(e).number + 1;
    return this.lineWrapping && (i += Math.max(0, Math.ceil((t - e - i * this.lineLength * 0.5) / this.lineLength))), this.lineHeight * i;
  }
  heightForLine(e) {
    return this.lineWrapping ? (1 + Math.max(0, Math.ceil((e - this.lineLength) / (this.lineLength - 5)))) * this.lineHeight : this.lineHeight;
  }
  setDoc(e) {
    return this.doc = e, this;
  }
  mustRefreshForWrapping(e) {
    return gc.indexOf(e) > -1 != this.lineWrapping;
  }
  mustRefreshForHeights(e) {
    let t = !1;
    for (let i = 0; i < e.length; i++) {
      let r = e[i];
      r < 0 ? i++ : this.heightSamples[Math.floor(r * 10)] || (t = !0, this.heightSamples[Math.floor(r * 10)] = !0);
    }
    return t;
  }
  refresh(e, t, i, r, s, o) {
    let l = gc.indexOf(e) > -1, a = Math.round(t) != Math.round(this.lineHeight) || this.lineWrapping != l;
    if (this.lineWrapping = l, this.lineHeight = t, this.charWidth = i, this.textHeight = r, this.lineLength = s, a) {
      this.heightSamples = {};
      for (let h = 0; h < o.length; h++) {
        let u = o[h];
        u < 0 ? h++ : this.heightSamples[Math.floor(u * 10)] = !0;
      }
    }
    return a;
  }
}
class cy {
  constructor(e, t) {
    this.from = e, this.heights = t, this.index = 0;
  }
  get more() {
    return this.index < this.heights.length;
  }
}
class Vt {
  /**
  @internal
  */
  constructor(e, t, i, r, s) {
    this.from = e, this.length = t, this.top = i, this.height = r, this._content = s;
  }
  /**
  The type of element this is. When querying lines, this may be
  an array of all the blocks that make up the line.
  */
  get type() {
    return typeof this._content == "number" ? Ke.Text : Array.isArray(this._content) ? this._content : this._content.type;
  }
  /**
  The end of the element as a document position.
  */
  get to() {
    return this.from + this.length;
  }
  /**
  The bottom position of the element.
  */
  get bottom() {
    return this.top + this.height;
  }
  /**
  If this is a widget block, this will return the widget
  associated with it.
  */
  get widget() {
    return this._content instanceof An ? this._content.widget : null;
  }
  /**
  If this is a textblock, this holds the number of line breaks
  that appear in widgets inside the block.
  */
  get widgetLineBreaks() {
    return typeof this._content == "number" ? this._content : 0;
  }
  /**
  @internal
  */
  join(e) {
    let t = (Array.isArray(this._content) ? this._content : [this]).concat(Array.isArray(e._content) ? e._content : [e]);
    return new Vt(this.from, this.length + e.length, this.top, this.height + e.height, t);
  }
}
var xe = /* @__PURE__ */ function(n) {
  return n[n.ByPos = 0] = "ByPos", n[n.ByHeight = 1] = "ByHeight", n[n.ByPosNoHeight = 2] = "ByPosNoHeight", n;
}(xe || (xe = {}));
const Is = 1e-3;
class Je {
  constructor(e, t, i = 2) {
    this.length = e, this.height = t, this.flags = i;
  }
  get outdated() {
    return (this.flags & 2) > 0;
  }
  set outdated(e) {
    this.flags = (e ? 2 : 0) | this.flags & -3;
  }
  setHeight(e, t) {
    this.height != t && (Math.abs(this.height - t) > Is && (e.heightChanged = !0), this.height = t);
  }
  // Base case is to replace a leaf node, which simply builds a tree
  // from the new nodes and returns that (HeightMapBranch and
  // HeightMapGap override this to actually use from/to)
  replace(e, t, i) {
    return Je.of(i);
  }
  // Again, these are base cases, and are overridden for branch and gap nodes.
  decomposeLeft(e, t) {
    t.push(this);
  }
  decomposeRight(e, t) {
    t.push(this);
  }
  applyChanges(e, t, i, r) {
    let s = this, o = i.doc;
    for (let l = r.length - 1; l >= 0; l--) {
      let { fromA: a, toA: h, fromB: u, toB: c } = r[l], f = s.lineAt(a, xe.ByPosNoHeight, i.setDoc(t), 0, 0), d = f.to >= h ? f : s.lineAt(h, xe.ByPosNoHeight, i, 0, 0);
      for (c += d.to - h, h = d.to; l > 0 && f.from <= r[l - 1].toA; )
        a = r[l - 1].fromA, u = r[l - 1].fromB, l--, a < f.from && (f = s.lineAt(a, xe.ByPosNoHeight, i, 0, 0));
      u += f.from - a, a = f.from;
      let p = Zh.build(i.setDoc(o), e, u, c);
      s = s.replace(a, h, p);
    }
    return s.updateHeight(i, 0);
  }
  static empty() {
    return new ct(0, 0);
  }
  // nodes uses null values to indicate the position of line breaks.
  // There are never line breaks at the start or end of the array, or
  // two line breaks next to each other, and the array isn't allowed
  // to be empty (same restrictions as return value from the builder).
  static of(e) {
    if (e.length == 1)
      return e[0];
    let t = 0, i = e.length, r = 0, s = 0;
    for (; ; )
      if (t == i)
        if (r > s * 2) {
          let l = e[t - 1];
          l.break ? e.splice(--t, 1, l.left, null, l.right) : e.splice(--t, 1, l.left, l.right), i += 1 + l.break, r -= l.size;
        } else if (s > r * 2) {
          let l = e[i];
          l.break ? e.splice(i, 1, l.left, null, l.right) : e.splice(i, 1, l.left, l.right), i += 2 + l.break, s -= l.size;
        } else
          break;
      else if (r < s) {
        let l = e[t++];
        l && (r += l.size);
      } else {
        let l = e[--i];
        l && (s += l.size);
      }
    let o = 0;
    return e[t - 1] == null ? (o = 1, t--) : e[t] == null && (o = 1, i++), new fy(Je.of(e.slice(0, t)), o, Je.of(e.slice(i)));
  }
}
Je.prototype.size = 1;
class gm extends Je {
  constructor(e, t, i) {
    super(e, t), this.deco = i;
  }
  blockAt(e, t, i, r) {
    return new Vt(r, this.length, i, this.height, this.deco || 0);
  }
  lineAt(e, t, i, r, s) {
    return this.blockAt(0, i, r, s);
  }
  forEachLine(e, t, i, r, s, o) {
    e <= s + this.length && t >= s && o(this.blockAt(0, i, r, s));
  }
  updateHeight(e, t = 0, i = !1, r) {
    return r && r.from <= t && r.more && this.setHeight(e, r.heights[r.index++]), this.outdated = !1, this;
  }
  toString() {
    return `block(${this.length})`;
  }
}
class ct extends gm {
  constructor(e, t) {
    super(e, t, null), this.collapsed = 0, this.widgetHeight = 0, this.breaks = 0;
  }
  blockAt(e, t, i, r) {
    return new Vt(r, this.length, i, this.height, this.breaks);
  }
  replace(e, t, i) {
    let r = i[0];
    return i.length == 1 && (r instanceof ct || r instanceof Le && r.flags & 4) && Math.abs(this.length - r.length) < 10 ? (r instanceof Le ? r = new ct(r.length, this.height) : r.height = this.height, this.outdated || (r.outdated = !1), r) : Je.of(i);
  }
  updateHeight(e, t = 0, i = !1, r) {
    return r && r.from <= t && r.more ? this.setHeight(e, r.heights[r.index++]) : (i || this.outdated) && this.setHeight(e, Math.max(this.widgetHeight, e.heightForLine(this.length - this.collapsed)) + this.breaks * e.lineHeight), this.outdated = !1, this;
  }
  toString() {
    return `line(${this.length}${this.collapsed ? -this.collapsed : ""}${this.widgetHeight ? ":" + this.widgetHeight : ""})`;
  }
}
class Le extends Je {
  constructor(e) {
    super(e, 0);
  }
  heightMetrics(e, t) {
    let i = e.doc.lineAt(t).number, r = e.doc.lineAt(t + this.length).number, s = r - i + 1, o, l = 0;
    if (e.lineWrapping) {
      let a = Math.min(this.height, e.lineHeight * s);
      o = a / s, this.length > s + 1 && (l = (this.height - a) / (this.length - s - 1));
    } else
      o = this.height / s;
    return { firstLine: i, lastLine: r, perLine: o, perChar: l };
  }
  blockAt(e, t, i, r) {
    let { firstLine: s, lastLine: o, perLine: l, perChar: a } = this.heightMetrics(t, r);
    if (t.lineWrapping) {
      let h = r + (e < t.lineHeight ? 0 : Math.round(Math.max(0, Math.min(1, (e - i) / this.height)) * this.length)), u = t.doc.lineAt(h), c = l + u.length * a, f = Math.max(i, e - c / 2);
      return new Vt(u.from, u.length, f, c, 0);
    } else {
      let h = Math.max(0, Math.min(o - s, Math.floor((e - i) / l))), { from: u, length: c } = t.doc.line(s + h);
      return new Vt(u, c, i + l * h, l, 0);
    }
  }
  lineAt(e, t, i, r, s) {
    if (t == xe.ByHeight)
      return this.blockAt(e, i, r, s);
    if (t == xe.ByPosNoHeight) {
      let { from: d, to: p } = i.doc.lineAt(e);
      return new Vt(d, p - d, 0, 0, 0);
    }
    let { firstLine: o, perLine: l, perChar: a } = this.heightMetrics(i, s), h = i.doc.lineAt(e), u = l + h.length * a, c = h.number - o, f = r + l * c + a * (h.from - s - c);
    return new Vt(h.from, h.length, Math.max(r, Math.min(f, r + this.height - u)), u, 0);
  }
  forEachLine(e, t, i, r, s, o) {
    e = Math.max(e, s), t = Math.min(t, s + this.length);
    let { firstLine: l, perLine: a, perChar: h } = this.heightMetrics(i, s);
    for (let u = e, c = r; u <= t; ) {
      let f = i.doc.lineAt(u);
      if (u == e) {
        let p = f.number - l;
        c += a * p + h * (e - s - p);
      }
      let d = a + h * f.length;
      o(new Vt(f.from, f.length, c, d, 0)), c += d, u = f.to + 1;
    }
  }
  replace(e, t, i) {
    let r = this.length - t;
    if (r > 0) {
      let s = i[i.length - 1];
      s instanceof Le ? i[i.length - 1] = new Le(s.length + r) : i.push(null, new Le(r - 1));
    }
    if (e > 0) {
      let s = i[0];
      s instanceof Le ? i[0] = new Le(e + s.length) : i.unshift(new Le(e - 1), null);
    }
    return Je.of(i);
  }
  decomposeLeft(e, t) {
    t.push(new Le(e - 1), null);
  }
  decomposeRight(e, t) {
    t.push(null, new Le(this.length - e - 1));
  }
  updateHeight(e, t = 0, i = !1, r) {
    let s = t + this.length;
    if (r && r.from <= t + this.length && r.more) {
      let o = [], l = Math.max(t, r.from), a = -1;
      for (r.from > t && o.push(new Le(r.from - t - 1).updateHeight(e, t)); l <= s && r.more; ) {
        let u = e.doc.lineAt(l).length;
        o.length && o.push(null);
        let c = r.heights[r.index++];
        a == -1 ? a = c : Math.abs(c - a) >= Is && (a = -2);
        let f = new ct(u, c);
        f.outdated = !1, o.push(f), l += u + 1;
      }
      l <= s && o.push(null, new Le(s - l).updateHeight(e, l));
      let h = Je.of(o);
      return (a < 0 || Math.abs(h.height - this.height) >= Is || Math.abs(a - this.heightMetrics(e, t).perLine) >= Is) && (e.heightChanged = !0), h;
    } else
      (i || this.outdated) && (this.setHeight(e, e.heightForGap(t, t + this.length)), this.outdated = !1);
    return this;
  }
  toString() {
    return `gap(${this.length})`;
  }
}
class fy extends Je {
  constructor(e, t, i) {
    super(e.length + t + i.length, e.height + i.height, t | (e.outdated || i.outdated ? 2 : 0)), this.left = e, this.right = i, this.size = e.size + i.size;
  }
  get break() {
    return this.flags & 1;
  }
  blockAt(e, t, i, r) {
    let s = i + this.left.height;
    return e < s ? this.left.blockAt(e, t, i, r) : this.right.blockAt(e, t, s, r + this.left.length + this.break);
  }
  lineAt(e, t, i, r, s) {
    let o = r + this.left.height, l = s + this.left.length + this.break, a = t == xe.ByHeight ? e < o : e < l, h = a ? this.left.lineAt(e, t, i, r, s) : this.right.lineAt(e, t, i, o, l);
    if (this.break || (a ? h.to < l : h.from > l))
      return h;
    let u = t == xe.ByPosNoHeight ? xe.ByPosNoHeight : xe.ByPos;
    return a ? h.join(this.right.lineAt(l, u, i, o, l)) : this.left.lineAt(l, u, i, r, s).join(h);
  }
  forEachLine(e, t, i, r, s, o) {
    let l = r + this.left.height, a = s + this.left.length + this.break;
    if (this.break)
      e < a && this.left.forEachLine(e, t, i, r, s, o), t >= a && this.right.forEachLine(e, t, i, l, a, o);
    else {
      let h = this.lineAt(a, xe.ByPos, i, r, s);
      e < h.from && this.left.forEachLine(e, h.from - 1, i, r, s, o), h.to >= e && h.from <= t && o(h), t > h.to && this.right.forEachLine(h.to + 1, t, i, l, a, o);
    }
  }
  replace(e, t, i) {
    let r = this.left.length + this.break;
    if (t < r)
      return this.balanced(this.left.replace(e, t, i), this.right);
    if (e > this.left.length)
      return this.balanced(this.left, this.right.replace(e - r, t - r, i));
    let s = [];
    e > 0 && this.decomposeLeft(e, s);
    let o = s.length;
    for (let l of i)
      s.push(l);
    if (e > 0 && bc(s, o - 1), t < this.length) {
      let l = s.length;
      this.decomposeRight(t, s), bc(s, l);
    }
    return Je.of(s);
  }
  decomposeLeft(e, t) {
    let i = this.left.length;
    if (e <= i)
      return this.left.decomposeLeft(e, t);
    t.push(this.left), this.break && (i++, e >= i && t.push(null)), e > i && this.right.decomposeLeft(e - i, t);
  }
  decomposeRight(e, t) {
    let i = this.left.length, r = i + this.break;
    if (e >= r)
      return this.right.decomposeRight(e - r, t);
    e < i && this.left.decomposeRight(e, t), this.break && e < r && t.push(null), t.push(this.right);
  }
  balanced(e, t) {
    return e.size > 2 * t.size || t.size > 2 * e.size ? Je.of(this.break ? [e, null, t] : [e, t]) : (this.left = e, this.right = t, this.height = e.height + t.height, this.outdated = e.outdated || t.outdated, this.size = e.size + t.size, this.length = e.length + this.break + t.length, this);
  }
  updateHeight(e, t = 0, i = !1, r) {
    let { left: s, right: o } = this, l = t + s.length + this.break, a = null;
    return r && r.from <= t + s.length && r.more ? a = s = s.updateHeight(e, t, i, r) : s.updateHeight(e, t, i), r && r.from <= l + o.length && r.more ? a = o = o.updateHeight(e, l, i, r) : o.updateHeight(e, l, i), a ? this.balanced(s, o) : (this.height = this.left.height + this.right.height, this.outdated = !1, this);
  }
  toString() {
    return this.left + (this.break ? " " : "-") + this.right;
  }
}
function bc(n, e) {
  let t, i;
  n[e] == null && (t = n[e - 1]) instanceof Le && (i = n[e + 1]) instanceof Le && n.splice(e - 1, 3, new Le(t.length + 1 + i.length));
}
const dy = 5;
class Zh {
  constructor(e, t) {
    this.pos = e, this.oracle = t, this.nodes = [], this.lineStart = -1, this.lineEnd = -1, this.covering = null, this.writtenTo = e;
  }
  get isCovered() {
    return this.covering && this.nodes[this.nodes.length - 1] == this.covering;
  }
  span(e, t) {
    if (this.lineStart > -1) {
      let i = Math.min(t, this.lineEnd), r = this.nodes[this.nodes.length - 1];
      r instanceof ct ? r.length += i - this.pos : (i > this.pos || !this.isCovered) && this.nodes.push(new ct(i - this.pos, -1)), this.writtenTo = i, t > i && (this.nodes.push(null), this.writtenTo++, this.lineStart = -1);
    }
    this.pos = t;
  }
  point(e, t, i) {
    if (e < t || i.heightRelevant) {
      let r = i.widget ? i.widget.estimatedHeight : 0, s = i.widget ? i.widget.lineBreaks : 0;
      r < 0 && (r = this.oracle.lineHeight);
      let o = t - e;
      i.block ? this.addBlock(new gm(o, r, i)) : (o || s || r >= dy) && this.addLineDeco(r, s, o);
    } else
      t > e && this.span(e, t);
    this.lineEnd > -1 && this.lineEnd < this.pos && (this.lineEnd = this.oracle.doc.lineAt(this.pos).to);
  }
  enterLine() {
    if (this.lineStart > -1)
      return;
    let { from: e, to: t } = this.oracle.doc.lineAt(this.pos);
    this.lineStart = e, this.lineEnd = t, this.writtenTo < e && ((this.writtenTo < e - 1 || this.nodes[this.nodes.length - 1] == null) && this.nodes.push(this.blankContent(this.writtenTo, e - 1)), this.nodes.push(null)), this.pos > e && this.nodes.push(new ct(this.pos - e, -1)), this.writtenTo = this.pos;
  }
  blankContent(e, t) {
    let i = new Le(t - e);
    return this.oracle.doc.lineAt(e).to == t && (i.flags |= 4), i;
  }
  ensureLine() {
    this.enterLine();
    let e = this.nodes.length ? this.nodes[this.nodes.length - 1] : null;
    if (e instanceof ct)
      return e;
    let t = new ct(0, -1);
    return this.nodes.push(t), t;
  }
  addBlock(e) {
    this.enterLine();
    let t = e.deco;
    t && t.startSide > 0 && !this.isCovered && this.ensureLine(), this.nodes.push(e), this.writtenTo = this.pos = this.pos + e.length, t && t.endSide > 0 && (this.covering = e);
  }
  addLineDeco(e, t, i) {
    let r = this.ensureLine();
    r.length += i, r.collapsed += i, r.widgetHeight = Math.max(r.widgetHeight, e), r.breaks += t, this.writtenTo = this.pos = this.pos + i;
  }
  finish(e) {
    let t = this.nodes.length == 0 ? null : this.nodes[this.nodes.length - 1];
    this.lineStart > -1 && !(t instanceof ct) && !this.isCovered ? this.nodes.push(new ct(0, -1)) : (this.writtenTo < this.pos || t == null) && this.nodes.push(this.blankContent(this.writtenTo, this.pos));
    let i = e;
    for (let r of this.nodes)
      r instanceof ct && r.updateHeight(this.oracle, i), i += r ? r.length : 1;
    return this.nodes;
  }
  // Always called with a region that on both sides either stretches
  // to a line break or the end of the document.
  // The returned array uses null to indicate line breaks, but never
  // starts or ends in a line break, or has multiple line breaks next
  // to each other.
  static build(e, t, i, r) {
    let s = new Zh(i, e);
    return oe.spans(t, i, r, s, 0), s.finish(i);
  }
}
function py(n, e, t) {
  let i = new my();
  return oe.compare(n, e, t, i, 0), i.changes;
}
class my {
  constructor() {
    this.changes = [];
  }
  compareRange() {
  }
  comparePoint(e, t, i, r) {
    (e < t || i && i.heightRelevant || r && r.heightRelevant) && Pa(e, t, this.changes, 5);
  }
}
function Oy(n, e) {
  let t = n.getBoundingClientRect(), i = n.ownerDocument, r = i.defaultView || window, s = Math.max(0, t.left), o = Math.min(r.innerWidth, t.right), l = Math.max(0, t.top), a = Math.min(r.innerHeight, t.bottom);
  for (let h = n.parentNode; h && h != i.body; )
    if (h.nodeType == 1) {
      let u = h, c = window.getComputedStyle(u);
      if ((u.scrollHeight > u.clientHeight || u.scrollWidth > u.clientWidth) && c.overflow != "visible") {
        let f = u.getBoundingClientRect();
        s = Math.max(s, f.left), o = Math.min(o, f.right), l = Math.max(l, f.top), a = h == n.parentNode ? f.bottom : Math.min(a, f.bottom);
      }
      h = c.position == "absolute" || c.position == "fixed" ? u.offsetParent : u.parentNode;
    } else if (h.nodeType == 11)
      h = h.host;
    else
      break;
  return {
    left: s - t.left,
    right: Math.max(s, o) - t.left,
    top: l - (t.top + e),
    bottom: Math.max(l, a) - (t.top + e)
  };
}
function gy(n, e) {
  let t = n.getBoundingClientRect();
  return {
    left: 0,
    right: t.right - t.left,
    top: e,
    bottom: t.bottom - (t.top + e)
  };
}
class ul {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.size = i;
  }
  static same(e, t) {
    if (e.length != t.length)
      return !1;
    for (let i = 0; i < e.length; i++) {
      let r = e[i], s = t[i];
      if (r.from != s.from || r.to != s.to || r.size != s.size)
        return !1;
    }
    return !0;
  }
  draw(e, t) {
    return j.replace({
      widget: new by(this.size * (t ? e.scaleY : e.scaleX), t)
    }).range(this.from, this.to);
  }
}
class by extends Kt {
  constructor(e, t) {
    super(), this.size = e, this.vertical = t;
  }
  eq(e) {
    return e.size == this.size && e.vertical == this.vertical;
  }
  toDOM() {
    let e = document.createElement("div");
    return this.vertical ? e.style.height = this.size + "px" : (e.style.width = this.size + "px", e.style.height = "2px", e.style.display = "inline-block"), e;
  }
  get estimatedHeight() {
    return this.vertical ? this.size : -1;
  }
}
class yc {
  constructor(e) {
    this.state = e, this.pixelViewport = { left: 0, right: window.innerWidth, top: 0, bottom: 0 }, this.inView = !0, this.paddingTop = 0, this.paddingBottom = 0, this.contentDOMWidth = 0, this.contentDOMHeight = 0, this.editorHeight = 0, this.editorWidth = 0, this.scrollTop = 0, this.scrolledToBottom = !1, this.scaleX = 1, this.scaleY = 1, this.scrollAnchorPos = 0, this.scrollAnchorHeight = -1, this.scaler = kc, this.scrollTarget = null, this.printing = !1, this.mustMeasureContent = !0, this.defaultTextDirection = we.LTR, this.visibleRanges = [], this.mustEnforceCursorAssoc = !1;
    let t = e.facet(Ah).some((i) => typeof i != "function" && i.class == "cm-lineWrapping");
    this.heightOracle = new uy(t), this.stateDeco = e.facet(Pr).filter((i) => typeof i != "function"), this.heightMap = Je.empty().applyChanges(this.stateDeco, le.empty, this.heightOracle.setDoc(e.doc), [new wt(0, 0, 0, e.doc.length)]), this.viewport = this.getViewport(0, null), this.updateViewportLines(), this.updateForViewport(), this.lineGaps = this.ensureLineGaps([]), this.lineGapDeco = j.set(this.lineGaps.map((i) => i.draw(this, !1))), this.computeVisibleRanges();
  }
  updateForViewport() {
    let e = [this.viewport], { main: t } = this.state.selection;
    for (let i = 0; i <= 1; i++) {
      let r = i ? t.head : t.anchor;
      if (!e.some(({ from: s, to: o }) => r >= s && r <= o)) {
        let { from: s, to: o } = this.lineBlockAt(r);
        e.push(new as(s, o));
      }
    }
    this.viewports = e.sort((i, r) => i.from - r.from), this.scaler = this.heightMap.height <= 7e6 ? kc : new xy(this.heightOracle, this.heightMap, this.viewports);
  }
  updateViewportLines() {
    this.viewportLines = [], this.heightMap.forEachLine(this.viewport.from, this.viewport.to, this.heightOracle.setDoc(this.state.doc), 0, 0, (e) => {
      this.viewportLines.push(this.scaler.scale == 1 ? e : lr(e, this.scaler));
    });
  }
  update(e, t = null) {
    this.state = e.state;
    let i = this.stateDeco;
    this.stateDeco = this.state.facet(Pr).filter((u) => typeof u != "function");
    let r = e.changedRanges, s = wt.extendWithRanges(r, py(i, this.stateDeco, e ? e.changes : Ee.empty(this.state.doc.length))), o = this.heightMap.height, l = this.scrolledToBottom ? null : this.scrollAnchorAt(this.scrollTop);
    this.heightMap = this.heightMap.applyChanges(this.stateDeco, e.startState.doc, this.heightOracle.setDoc(this.state.doc), s), this.heightMap.height != o && (e.flags |= 2), l ? (this.scrollAnchorPos = e.changes.mapPos(l.from, -1), this.scrollAnchorHeight = l.top) : (this.scrollAnchorPos = -1, this.scrollAnchorHeight = this.heightMap.height);
    let a = s.length ? this.mapViewport(this.viewport, e.changes) : this.viewport;
    (t && (t.range.head < a.from || t.range.head > a.to) || !this.viewportIsAppropriate(a)) && (a = this.getViewport(0, t));
    let h = !e.changes.empty || e.flags & 2 || a.from != this.viewport.from || a.to != this.viewport.to;
    this.viewport = a, this.updateForViewport(), h && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(this.mapLineGaps(this.lineGaps, e.changes))), e.flags |= this.computeVisibleRanges(), t && (this.scrollTarget = t), !this.mustEnforceCursorAssoc && e.selectionSet && e.view.lineWrapping && e.state.selection.main.empty && e.state.selection.main.assoc && !e.state.facet(Jp) && (this.mustEnforceCursorAssoc = !0);
  }
  measure(e) {
    let t = e.contentDOM, i = window.getComputedStyle(t), r = this.heightOracle, s = i.whiteSpace;
    this.defaultTextDirection = i.direction == "rtl" ? we.RTL : we.LTR;
    let o = this.heightOracle.mustRefreshForWrapping(s), l = t.getBoundingClientRect(), a = o || this.mustMeasureContent || this.contentDOMHeight != l.height;
    this.contentDOMHeight = l.height, this.mustMeasureContent = !1;
    let h = 0, u = 0;
    if (l.width && l.height) {
      let { scaleX: Q, scaleY: P } = Qp(t, l);
      (Q > 5e-3 && Math.abs(this.scaleX - Q) > 5e-3 || P > 5e-3 && Math.abs(this.scaleY - P) > 5e-3) && (this.scaleX = Q, this.scaleY = P, h |= 8, o = a = !0);
    }
    let c = (parseInt(i.paddingTop) || 0) * this.scaleY, f = (parseInt(i.paddingBottom) || 0) * this.scaleY;
    (this.paddingTop != c || this.paddingBottom != f) && (this.paddingTop = c, this.paddingBottom = f, h |= 10), this.editorWidth != e.scrollDOM.clientWidth && (r.lineWrapping && (a = !0), this.editorWidth = e.scrollDOM.clientWidth, h |= 8);
    let d = e.scrollDOM.scrollTop * this.scaleY;
    this.scrollTop != d && (this.scrollAnchorHeight = -1, this.scrollTop = d), this.scrolledToBottom = Tp(e.scrollDOM);
    let p = (this.printing ? gy : Oy)(t, this.paddingTop), m = p.top - this.pixelViewport.top, O = p.bottom - this.pixelViewport.bottom;
    this.pixelViewport = p;
    let g = this.pixelViewport.bottom > this.pixelViewport.top && this.pixelViewport.right > this.pixelViewport.left;
    if (g != this.inView && (this.inView = g, g && (a = !0)), !this.inView && !this.scrollTarget)
      return 0;
    let b = l.width;
    if ((this.contentDOMWidth != b || this.editorHeight != e.scrollDOM.clientHeight) && (this.contentDOMWidth = l.width, this.editorHeight = e.scrollDOM.clientHeight, h |= 8), a) {
      let Q = e.docView.measureVisibleLineHeights(this.viewport);
      if (r.mustRefreshForHeights(Q) && (o = !0), o || r.lineWrapping && Math.abs(b - this.contentDOMWidth) > r.charWidth) {
        let { lineHeight: P, charWidth: w, textHeight: C } = e.docView.measureTextSize();
        o = P > 0 && r.refresh(s, P, w, C, b / w, Q), o && (e.docView.minWidth = 0, h |= 8);
      }
      m > 0 && O > 0 ? u = Math.max(m, O) : m < 0 && O < 0 && (u = Math.min(m, O)), r.heightChanged = !1;
      for (let P of this.viewports) {
        let w = P.from == this.viewport.from ? Q : e.docView.measureVisibleLineHeights(P);
        this.heightMap = (o ? Je.empty().applyChanges(this.stateDeco, le.empty, this.heightOracle, [new wt(0, 0, 0, e.state.doc.length)]) : this.heightMap).updateHeight(r, 0, o, new cy(P.from, w));
      }
      r.heightChanged && (h |= 2);
    }
    let S = !this.viewportIsAppropriate(this.viewport, u) || this.scrollTarget && (this.scrollTarget.range.head < this.viewport.from || this.scrollTarget.range.head > this.viewport.to);
    return S && (this.viewport = this.getViewport(u, this.scrollTarget)), this.updateForViewport(), (h & 2 || S) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(o ? [] : this.lineGaps, e)), h |= this.computeVisibleRanges(), this.mustEnforceCursorAssoc && (this.mustEnforceCursorAssoc = !1, e.docView.enforceCursorAssoc()), h;
  }
  get visibleTop() {
    return this.scaler.fromDOM(this.pixelViewport.top);
  }
  get visibleBottom() {
    return this.scaler.fromDOM(this.pixelViewport.bottom);
  }
  getViewport(e, t) {
    let i = 0.5 - Math.max(-0.5, Math.min(0.5, e / 1e3 / 2)), r = this.heightMap, s = this.heightOracle, { visibleTop: o, visibleBottom: l } = this, a = new as(r.lineAt(o - i * 1e3, xe.ByHeight, s, 0, 0).from, r.lineAt(l + (1 - i) * 1e3, xe.ByHeight, s, 0, 0).to);
    if (t) {
      let { head: h } = t.range;
      if (h < a.from || h > a.to) {
        let u = Math.min(this.editorHeight, this.pixelViewport.bottom - this.pixelViewport.top), c = r.lineAt(h, xe.ByPos, s, 0, 0), f;
        t.y == "center" ? f = (c.top + c.bottom) / 2 - u / 2 : t.y == "start" || t.y == "nearest" && h < a.from ? f = c.top : f = c.bottom - u, a = new as(r.lineAt(f - 1e3 / 2, xe.ByHeight, s, 0, 0).from, r.lineAt(f + u + 1e3 / 2, xe.ByHeight, s, 0, 0).to);
      }
    }
    return a;
  }
  mapViewport(e, t) {
    let i = t.mapPos(e.from, -1), r = t.mapPos(e.to, 1);
    return new as(this.heightMap.lineAt(i, xe.ByPos, this.heightOracle, 0, 0).from, this.heightMap.lineAt(r, xe.ByPos, this.heightOracle, 0, 0).to);
  }
  // Checks if a given viewport covers the visible part of the
  // document and not too much beyond that.
  viewportIsAppropriate({ from: e, to: t }, i = 0) {
    if (!this.inView)
      return !0;
    let { top: r } = this.heightMap.lineAt(e, xe.ByPos, this.heightOracle, 0, 0), { bottom: s } = this.heightMap.lineAt(t, xe.ByPos, this.heightOracle, 0, 0), { visibleTop: o, visibleBottom: l } = this;
    return (e == 0 || r <= o - Math.max(10, Math.min(
      -i,
      250
      /* VP.MaxCoverMargin */
    ))) && (t == this.state.doc.length || s >= l + Math.max(10, Math.min(
      i,
      250
      /* VP.MaxCoverMargin */
    ))) && r > o - 2 * 1e3 && s < l + 2 * 1e3;
  }
  mapLineGaps(e, t) {
    if (!e.length || t.empty)
      return e;
    let i = [];
    for (let r of e)
      t.touchesRange(r.from, r.to) || i.push(new ul(t.mapPos(r.from), t.mapPos(r.to), r.size));
    return i;
  }
  // Computes positions in the viewport where the start or end of a
  // line should be hidden, trying to reuse existing line gaps when
  // appropriate to avoid unneccesary redraws.
  // Uses crude character-counting for the positioning and sizing,
  // since actual DOM coordinates aren't always available and
  // predictable. Relies on generous margins (see LG.Margin) to hide
  // the artifacts this might produce from the user.
  ensureLineGaps(e, t) {
    let i = this.heightOracle.lineWrapping, r = i ? 1e4 : 2e3, s = r >> 1, o = r << 1;
    if (this.defaultTextDirection != we.LTR && !i)
      return [];
    let l = [], a = (h, u, c, f) => {
      if (u - h < s)
        return;
      let d = this.state.selection.main, p = [d.from];
      d.empty || p.push(d.to);
      for (let O of p)
        if (O > h && O < u) {
          a(h, O - 10, c, f), a(O + 10, u, c, f);
          return;
        }
      let m = ky(e, (O) => O.from >= c.from && O.to <= c.to && Math.abs(O.from - h) < s && Math.abs(O.to - u) < s && !p.some((g) => O.from < g && O.to > g));
      if (!m) {
        if (u < c.to && t && i && t.visibleRanges.some((O) => O.from <= u && O.to >= u)) {
          let O = t.moveToLineBoundary($.cursor(u), !1, !0).head;
          O > h && (u = O);
        }
        m = new ul(h, u, this.gapSize(c, h, u, f));
      }
      l.push(m);
    };
    for (let h of this.viewportLines) {
      if (h.length < o)
        continue;
      let u = yy(h.from, h.to, this.stateDeco);
      if (u.total < o)
        continue;
      let c = this.scrollTarget ? this.scrollTarget.range.head : null, f, d;
      if (i) {
        let p = r / this.heightOracle.lineLength * this.heightOracle.lineHeight, m, O;
        if (c != null) {
          let g = us(u, c), b = ((this.visibleBottom - this.visibleTop) / 2 + p) / h.height;
          m = g - b, O = g + b;
        } else
          m = (this.visibleTop - h.top - p) / h.height, O = (this.visibleBottom - h.top + p) / h.height;
        f = hs(u, m), d = hs(u, O);
      } else {
        let p = u.total * this.heightOracle.charWidth, m = r * this.heightOracle.charWidth, O, g;
        if (c != null) {
          let b = us(u, c), S = ((this.pixelViewport.right - this.pixelViewport.left) / 2 + m) / p;
          O = b - S, g = b + S;
        } else
          O = (this.pixelViewport.left - m) / p, g = (this.pixelViewport.right + m) / p;
        f = hs(u, O), d = hs(u, g);
      }
      f > h.from && a(h.from, f, h, u), d < h.to && a(d, h.to, h, u);
    }
    return l;
  }
  gapSize(e, t, i, r) {
    let s = us(r, i) - us(r, t);
    return this.heightOracle.lineWrapping ? e.height * s : r.total * this.heightOracle.charWidth * s;
  }
  updateLineGaps(e) {
    ul.same(e, this.lineGaps) || (this.lineGaps = e, this.lineGapDeco = j.set(e.map((t) => t.draw(this, this.heightOracle.lineWrapping))));
  }
  computeVisibleRanges() {
    let e = this.stateDeco;
    this.lineGaps.length && (e = e.concat(this.lineGapDeco));
    let t = [];
    oe.spans(e, this.viewport.from, this.viewport.to, {
      span(r, s) {
        t.push({ from: r, to: s });
      },
      point() {
      }
    }, 20);
    let i = t.length != this.visibleRanges.length || this.visibleRanges.some((r, s) => r.from != t[s].from || r.to != t[s].to);
    return this.visibleRanges = t, i ? 4 : 0;
  }
  lineBlockAt(e) {
    return e >= this.viewport.from && e <= this.viewport.to && this.viewportLines.find((t) => t.from <= e && t.to >= e) || lr(this.heightMap.lineAt(e, xe.ByPos, this.heightOracle, 0, 0), this.scaler);
  }
  lineBlockAtHeight(e) {
    return lr(this.heightMap.lineAt(this.scaler.fromDOM(e), xe.ByHeight, this.heightOracle, 0, 0), this.scaler);
  }
  scrollAnchorAt(e) {
    let t = this.lineBlockAtHeight(e + 8);
    return t.from >= this.viewport.from || this.viewportLines[0].top - e > 200 ? t : this.viewportLines[0];
  }
  elementAtHeight(e) {
    return lr(this.heightMap.blockAt(this.scaler.fromDOM(e), this.heightOracle, 0, 0), this.scaler);
  }
  get docHeight() {
    return this.scaler.toDOM(this.heightMap.height);
  }
  get contentHeight() {
    return this.docHeight + this.paddingTop + this.paddingBottom;
  }
}
class as {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
function yy(n, e, t) {
  let i = [], r = n, s = 0;
  return oe.spans(t, n, e, {
    span() {
    },
    point(o, l) {
      o > r && (i.push({ from: r, to: o }), s += o - r), r = l;
    }
  }, 20), r < e && (i.push({ from: r, to: e }), s += e - r), { total: s, ranges: i };
}
function hs({ total: n, ranges: e }, t) {
  if (t <= 0)
    return e[0].from;
  if (t >= 1)
    return e[e.length - 1].to;
  let i = Math.floor(n * t);
  for (let r = 0; ; r++) {
    let { from: s, to: o } = e[r], l = o - s;
    if (i <= l)
      return s + i;
    i -= l;
  }
}
function us(n, e) {
  let t = 0;
  for (let { from: i, to: r } of n.ranges) {
    if (e <= r) {
      t += e - i;
      break;
    }
    t += r - i;
  }
  return t / n.total;
}
function ky(n, e) {
  for (let t of n)
    if (e(t))
      return t;
}
const kc = {
  toDOM(n) {
    return n;
  },
  fromDOM(n) {
    return n;
  },
  scale: 1
};
class xy {
  constructor(e, t, i) {
    let r = 0, s = 0, o = 0;
    this.viewports = i.map(({ from: l, to: a }) => {
      let h = t.lineAt(l, xe.ByPos, e, 0, 0).top, u = t.lineAt(a, xe.ByPos, e, 0, 0).bottom;
      return r += u - h, { from: l, to: a, top: h, bottom: u, domTop: 0, domBottom: 0 };
    }), this.scale = (7e6 - r) / (t.height - r);
    for (let l of this.viewports)
      l.domTop = o + (l.top - s) * this.scale, o = l.domBottom = l.domTop + (l.bottom - l.top), s = l.bottom;
  }
  toDOM(e) {
    for (let t = 0, i = 0, r = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.top)
        return r + (e - i) * this.scale;
      if (e <= s.bottom)
        return s.domTop + (e - s.top);
      i = s.bottom, r = s.domBottom;
    }
  }
  fromDOM(e) {
    for (let t = 0, i = 0, r = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.domTop)
        return i + (e - r) / this.scale;
      if (e <= s.domBottom)
        return s.top + (e - s.domTop);
      i = s.bottom, r = s.domBottom;
    }
  }
}
function lr(n, e) {
  if (e.scale == 1)
    return n;
  let t = e.toDOM(n.top), i = e.toDOM(n.bottom);
  return new Vt(n.from, n.length, t, i - t, Array.isArray(n._content) ? n._content.map((r) => lr(r, e)) : n._content);
}
const cs = /* @__PURE__ */ B.define({ combine: (n) => n.join(" ") }), Ma = /* @__PURE__ */ B.define({ combine: (n) => n.indexOf(!0) > -1 }), Ea = /* @__PURE__ */ Cn.newName(), bm = /* @__PURE__ */ Cn.newName(), ym = /* @__PURE__ */ Cn.newName(), km = { "&light": "." + bm, "&dark": "." + ym };
function za(n, e, t) {
  return new Cn(e, {
    finish(i) {
      return /&/.test(i) ? i.replace(/&\w*/, (r) => {
        if (r == "&")
          return n;
        if (!t || !t[r])
          throw new RangeError(`Unsupported selector: ${r}`);
        return t[r];
      }) : n + " " + i;
    }
  });
}
const wy = /* @__PURE__ */ za("." + Ea, {
  "&": {
    position: "relative !important",
    boxSizing: "border-box",
    "&.cm-focused": {
      // Provide a simple default outline to make sure a focused
      // editor is visually distinct. Can't leave the default behavior
      // because that will apply to the content element, which is
      // inside the scrollable container and doesn't include the
      // gutters. We also can't use an 'auto' outline, since those
      // are, for some reason, drawn behind the element content, which
      // will cause things like the active line background to cover
      // the outline (#297).
      outline: "1px dotted #212121"
    },
    display: "flex !important",
    flexDirection: "column"
  },
  ".cm-scroller": {
    display: "flex !important",
    alignItems: "flex-start !important",
    fontFamily: "monospace",
    lineHeight: 1.4,
    height: "100%",
    overflowX: "auto",
    position: "relative",
    zIndex: 0
  },
  ".cm-content": {
    margin: 0,
    flexGrow: 2,
    flexShrink: 0,
    display: "block",
    whiteSpace: "pre",
    wordWrap: "normal",
    // https://github.com/codemirror/dev/issues/456
    boxSizing: "border-box",
    minHeight: "100%",
    padding: "4px 0",
    outline: "none",
    "&[contenteditable=true]": {
      WebkitUserModify: "read-write-plaintext-only"
    }
  },
  ".cm-lineWrapping": {
    whiteSpace_fallback: "pre-wrap",
    // For IE
    whiteSpace: "break-spaces",
    wordBreak: "break-word",
    // For Safari, which doesn't support overflow-wrap: anywhere
    overflowWrap: "anywhere",
    flexShrink: 1
  },
  "&light .cm-content": { caretColor: "black" },
  "&dark .cm-content": { caretColor: "white" },
  ".cm-line": {
    display: "block",
    padding: "0 2px 0 6px"
  },
  ".cm-layer": {
    position: "absolute",
    left: 0,
    top: 0,
    contain: "size style",
    "& > *": {
      position: "absolute"
    }
  },
  "&light .cm-selectionBackground": {
    background: "#d9d9d9"
  },
  "&dark .cm-selectionBackground": {
    background: "#222"
  },
  "&light.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#d7d4f0"
  },
  "&dark.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#233"
  },
  ".cm-cursorLayer": {
    pointerEvents: "none"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer": {
    animation: "steps(1) cm-blink 1.2s infinite"
  },
  // Two animations defined so that we can switch between them to
  // restart the animation without forcing another style
  // recomputation.
  "@keyframes cm-blink": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  "@keyframes cm-blink2": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  ".cm-cursor, .cm-dropCursor": {
    borderLeft: "1.2px solid black",
    marginLeft: "-0.6px",
    pointerEvents: "none"
  },
  ".cm-cursor": {
    display: "none"
  },
  "&dark .cm-cursor": {
    borderLeftColor: "#444"
  },
  ".cm-dropCursor": {
    position: "absolute"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer .cm-cursor": {
    display: "block"
  },
  ".cm-iso": {
    unicodeBidi: "isolate"
  },
  ".cm-announced": {
    position: "fixed",
    top: "-10000px"
  },
  "@media print": {
    ".cm-announced": { display: "none" }
  },
  "&light .cm-activeLine": { backgroundColor: "#cceeff44" },
  "&dark .cm-activeLine": { backgroundColor: "#99eeff33" },
  "&light .cm-specialChar": { color: "red" },
  "&dark .cm-specialChar": { color: "#f78" },
  ".cm-gutters": {
    flexShrink: 0,
    display: "flex",
    height: "100%",
    boxSizing: "border-box",
    insetInlineStart: 0,
    zIndex: 200
  },
  "&light .cm-gutters": {
    backgroundColor: "#f5f5f5",
    color: "#6c6c6c",
    borderRight: "1px solid #ddd"
  },
  "&dark .cm-gutters": {
    backgroundColor: "#333338",
    color: "#ccc"
  },
  ".cm-gutter": {
    display: "flex !important",
    // Necessary -- prevents margin collapsing
    flexDirection: "column",
    flexShrink: 0,
    boxSizing: "border-box",
    minHeight: "100%",
    overflow: "hidden"
  },
  ".cm-gutterElement": {
    boxSizing: "border-box"
  },
  ".cm-lineNumbers .cm-gutterElement": {
    padding: "0 3px 0 5px",
    minWidth: "20px",
    textAlign: "right",
    whiteSpace: "nowrap"
  },
  "&light .cm-activeLineGutter": {
    backgroundColor: "#e2f2ff"
  },
  "&dark .cm-activeLineGutter": {
    backgroundColor: "#222227"
  },
  ".cm-panels": {
    boxSizing: "border-box",
    position: "sticky",
    left: 0,
    right: 0
  },
  "&light .cm-panels": {
    backgroundColor: "#f5f5f5",
    color: "black"
  },
  "&light .cm-panels-top": {
    borderBottom: "1px solid #ddd"
  },
  "&light .cm-panels-bottom": {
    borderTop: "1px solid #ddd"
  },
  "&dark .cm-panels": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tab": {
    display: "inline-block",
    overflow: "hidden",
    verticalAlign: "bottom"
  },
  ".cm-widgetBuffer": {
    verticalAlign: "text-top",
    height: "1em",
    width: 0,
    display: "inline"
  },
  ".cm-placeholder": {
    color: "#888",
    display: "inline-block",
    verticalAlign: "top"
  },
  ".cm-highlightSpace:before": {
    content: "attr(data-display)",
    position: "absolute",
    pointerEvents: "none",
    color: "#888"
  },
  ".cm-highlightTab": {
    backgroundImage: `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="200" height="20"><path stroke="%23888" stroke-width="1" fill="none" d="M1 10H196L190 5M190 15L196 10M197 4L197 16"/></svg>')`,
    backgroundSize: "auto 100%",
    backgroundPosition: "right 90%",
    backgroundRepeat: "no-repeat"
  },
  ".cm-trailingSpace": {
    backgroundColor: "#ff332255"
  },
  ".cm-button": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    padding: ".2em 1em",
    borderRadius: "1px"
  },
  "&light .cm-button": {
    backgroundImage: "linear-gradient(#eff1f5, #d9d9df)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#b4b4b4, #d0d3d6)"
    }
  },
  "&dark .cm-button": {
    backgroundImage: "linear-gradient(#393939, #111)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#111, #333)"
    }
  },
  ".cm-textfield": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    border: "1px solid silver",
    padding: ".2em .5em"
  },
  "&light .cm-textfield": {
    backgroundColor: "white"
  },
  "&dark .cm-textfield": {
    border: "1px solid #555",
    backgroundColor: "inherit"
  }
}, km), ar = "￿";
class Sy {
  constructor(e, t) {
    this.points = e, this.text = "", this.lineSeparator = t.facet(ee.lineSeparator);
  }
  append(e) {
    this.text += e;
  }
  lineBreak() {
    this.text += ar;
  }
  readRange(e, t) {
    if (!e)
      return this;
    let i = e.parentNode;
    for (let r = e; ; ) {
      this.findPointBefore(i, r);
      let s = this.text.length;
      this.readNode(r);
      let o = r.nextSibling;
      if (o == t)
        break;
      let l = pe.get(r), a = pe.get(o);
      (l && a ? l.breakAfter : (l ? l.breakAfter : eo(r)) || eo(o) && (r.nodeName != "BR" || r.cmIgnore) && this.text.length > s) && this.lineBreak(), r = o;
    }
    return this.findPointBefore(i, t), this;
  }
  readTextNode(e) {
    let t = e.nodeValue;
    for (let i of this.points)
      i.node == e && (i.pos = this.text.length + Math.min(i.offset, t.length));
    for (let i = 0, r = this.lineSeparator ? null : /\r\n?|\n/g; ; ) {
      let s = -1, o = 1, l;
      if (this.lineSeparator ? (s = t.indexOf(this.lineSeparator, i), o = this.lineSeparator.length) : (l = r.exec(t)) && (s = l.index, o = l[0].length), this.append(t.slice(i, s < 0 ? t.length : s)), s < 0)
        break;
      if (this.lineBreak(), o > 1)
        for (let a of this.points)
          a.node == e && a.pos > this.text.length && (a.pos -= o - 1);
      i = s + o;
    }
  }
  readNode(e) {
    if (e.cmIgnore)
      return;
    let t = pe.get(e), i = t && t.overrideDOMText;
    if (i != null) {
      this.findPointInside(e, i.length);
      for (let r = i.iter(); !r.next().done; )
        r.lineBreak ? this.lineBreak() : this.append(r.value);
    } else
      e.nodeType == 3 ? this.readTextNode(e) : e.nodeName == "BR" ? e.nextSibling && this.lineBreak() : e.nodeType == 1 && this.readRange(e.firstChild, null);
  }
  findPointBefore(e, t) {
    for (let i of this.points)
      i.node == e && e.childNodes[i.offset] == t && (i.pos = this.text.length);
  }
  findPointInside(e, t) {
    for (let i of this.points)
      (e.nodeType == 3 ? i.node == e : e.contains(i.node)) && (i.pos = this.text.length + (vy(e, i.node, i.offset) ? t : 0));
  }
}
function vy(n, e, t) {
  for (; ; ) {
    if (!e || t < ln(e))
      return !1;
    if (e == n)
      return !0;
    t = Fn(e) + 1, e = e.parentNode;
  }
}
class xc {
  constructor(e, t) {
    this.node = e, this.offset = t, this.pos = -1;
  }
}
class Py {
  constructor(e, t, i, r) {
    this.typeOver = r, this.bounds = null, this.text = "";
    let { impreciseHead: s, impreciseAnchor: o } = e.docView;
    if (e.state.readOnly && t > -1)
      this.newSel = null;
    else if (t > -1 && (this.bounds = e.docView.domBoundsAround(t, i, 0))) {
      let l = s || o ? [] : Cy(e), a = new Sy(l, e.state);
      a.readRange(this.bounds.startDOM, this.bounds.endDOM), this.text = a.text, this.newSel = Ty(l, this.bounds.from);
    } else {
      let l = e.observer.selectionRange, a = s && s.node == l.focusNode && s.offset == l.focusOffset || !ya(e.contentDOM, l.focusNode) ? e.state.selection.main.head : e.docView.posFromDOM(l.focusNode, l.focusOffset), h = o && o.node == l.anchorNode && o.offset == l.anchorOffset || !ya(e.contentDOM, l.anchorNode) ? e.state.selection.main.anchor : e.docView.posFromDOM(l.anchorNode, l.anchorOffset), u = e.viewport;
      if ((V.ios || V.chrome) && e.state.selection.main.empty && a != h && (u.from > 0 || u.to < e.state.doc.length)) {
        let c = Math.min(a, h), f = Math.max(a, h), d = u.from - c, p = u.to - f;
        (d == 0 || d == 1 || c == 0) && (p == 0 || p == -1 || f == e.state.doc.length) && (a = 0, h = e.state.doc.length);
      }
      this.newSel = $.single(h, a);
    }
  }
}
function xm(n, e) {
  let t, { newSel: i } = e, r = n.state.selection.main, s = n.inputState.lastKeyTime > Date.now() - 100 ? n.inputState.lastKeyCode : -1;
  if (e.bounds) {
    let { from: o, to: l } = e.bounds, a = r.from, h = null;
    (s === 8 || V.android && e.text.length < l - o) && (a = r.to, h = "end");
    let u = $y(n.state.doc.sliceString(o, l, ar), e.text, a - o, h);
    u && (V.chrome && s == 13 && u.toB == u.from + 2 && e.text.slice(u.from, u.toB) == ar + ar && u.toB--, t = {
      from: o + u.from,
      to: o + u.toA,
      insert: le.of(e.text.slice(u.from, u.toB).split(ar))
    });
  } else
    i && (!n.hasFocus && n.state.facet(Lo) || i.main.eq(r)) && (i = null);
  if (!t && !i)
    return !1;
  if (!t && e.typeOver && !r.empty && i && i.main.empty ? t = { from: r.from, to: r.to, insert: n.state.doc.slice(r.from, r.to) } : t && t.from >= r.from && t.to <= r.to && (t.from != r.from || t.to != r.to) && r.to - r.from - (t.to - t.from) <= 4 ? t = {
    from: r.from,
    to: r.to,
    insert: n.state.doc.slice(r.from, t.from).append(t.insert).append(n.state.doc.slice(t.to, r.to))
  } : (V.mac || V.android) && t && t.from == t.to && t.from == r.head - 1 && /^\. ?$/.test(t.insert.toString()) && n.contentDOM.getAttribute("autocorrect") == "off" ? (i && t.insert.length == 2 && (i = $.single(i.main.anchor - 1, i.main.head - 1)), t = { from: r.from, to: r.to, insert: le.of([" "]) }) : V.chrome && t && t.from == t.to && t.from == r.head && t.insert.toString() == `
 ` && n.lineWrapping && (i && (i = $.single(i.main.anchor - 1, i.main.head - 1)), t = { from: r.from, to: r.to, insert: le.of([" "]) }), t) {
    if (V.ios && n.inputState.flushIOSKey(t) || V.android && (t.to == r.to && // GBoard will sometimes remove a space it just inserted
    // after a completion when you press enter
    (t.from == r.from || t.from == r.from - 1 && n.state.sliceDoc(t.from, r.from) == " ") && t.insert.length == 1 && t.insert.lines == 2 && mi(n.contentDOM, "Enter", 13) || (t.from == r.from - 1 && t.to == r.to && t.insert.length == 0 || s == 8 && t.insert.length < t.to - t.from && t.to > r.head) && mi(n.contentDOM, "Backspace", 8) || t.from == r.from && t.to == r.to + 1 && t.insert.length == 0 && mi(n.contentDOM, "Delete", 46)))
      return !0;
    let o = t.insert.toString();
    n.inputState.composing >= 0 && n.inputState.composing++;
    let l, a = () => l || (l = Qy(n, t, i));
    return n.state.facet(Gp).some((h) => h(n, t.from, t.to, o, a)) || n.dispatch(a()), !0;
  } else if (i && !i.main.eq(r)) {
    let o = !1, l = "select";
    return n.inputState.lastSelectionTime > Date.now() - 50 && (n.inputState.lastSelectionOrigin == "select" && (o = !0), l = n.inputState.lastSelectionOrigin), n.dispatch({ selection: i, scrollIntoView: o, userEvent: l }), !0;
  } else
    return !1;
}
function Qy(n, e, t) {
  let i, r = n.state, s = r.selection.main;
  if (e.from >= s.from && e.to <= s.to && e.to - e.from >= (s.to - s.from) / 3 && (!t || t.main.empty && t.main.from == e.from + e.insert.length) && n.inputState.composing < 0) {
    let l = s.from < e.from ? r.sliceDoc(s.from, e.from) : "", a = s.to > e.to ? r.sliceDoc(e.to, s.to) : "";
    i = r.replaceSelection(n.state.toText(l + e.insert.sliceString(0, void 0, n.state.lineBreak) + a));
  } else {
    let l = r.changes(e), a = t && t.main.to <= l.newLength ? t.main : void 0;
    if (r.selection.ranges.length > 1 && n.inputState.composing >= 0 && e.to <= s.to && e.to >= s.to - 10) {
      let h = n.state.sliceDoc(e.from, e.to), u, c = t && om(n, t.main.head);
      if (c) {
        let p = e.insert.length - (e.to - e.from);
        u = { from: c.from, to: c.to - p };
      } else
        u = n.state.doc.lineAt(s.head);
      let f = s.to - e.to, d = s.to - s.from;
      i = r.changeByRange((p) => {
        if (p.from == s.from && p.to == s.to)
          return { changes: l, range: a || p.map(l) };
        let m = p.to - f, O = m - h.length;
        if (p.to - p.from != d || n.state.sliceDoc(O, m) != h || // Unfortunately, there's no way to make multiple
        // changes in the same node work without aborting
        // composition, so cursors in the composition range are
        // ignored.
        p.to >= u.from && p.from <= u.to)
          return { range: p };
        let g = r.changes({ from: O, to: m, insert: e.insert }), b = p.to - s.to;
        return {
          changes: g,
          range: a ? $.range(Math.max(0, a.anchor + b), Math.max(0, a.head + b)) : p.map(g)
        };
      });
    } else
      i = {
        changes: l,
        selection: a && r.selection.replaceRange(a)
      };
  }
  let o = "input.type";
  return (n.composing || n.inputState.compositionPendingChange && n.inputState.compositionEndedAt > Date.now() - 50) && (n.inputState.compositionPendingChange = !1, o += ".compose", n.inputState.compositionFirstChange && (o += ".start", n.inputState.compositionFirstChange = !1)), r.update(i, { userEvent: o, scrollIntoView: !0 });
}
function $y(n, e, t, i) {
  let r = Math.min(n.length, e.length), s = 0;
  for (; s < r && n.charCodeAt(s) == e.charCodeAt(s); )
    s++;
  if (s == r && n.length == e.length)
    return null;
  let o = n.length, l = e.length;
  for (; o > 0 && l > 0 && n.charCodeAt(o - 1) == e.charCodeAt(l - 1); )
    o--, l--;
  if (i == "end") {
    let a = Math.max(0, s - Math.min(o, l));
    t -= o + a - s;
  }
  if (o < s && n.length < e.length) {
    let a = t <= s && t >= o ? s - t : 0;
    s -= a, l = s + (l - o), o = s;
  } else if (l < s) {
    let a = t <= s && t >= l ? s - t : 0;
    s -= a, o = s + (o - l), l = s;
  }
  return { from: s, toA: o, toB: l };
}
function Cy(n) {
  let e = [];
  if (n.root.activeElement != n.contentDOM)
    return e;
  let { anchorNode: t, anchorOffset: i, focusNode: r, focusOffset: s } = n.observer.selectionRange;
  return t && (e.push(new xc(t, i)), (r != t || s != i) && e.push(new xc(r, s))), e;
}
function Ty(n, e) {
  if (n.length == 0)
    return null;
  let t = n[0].pos, i = n.length == 2 ? n[1].pos : t;
  return t > -1 && i > -1 ? $.single(t + e, i + e) : null;
}
const Ay = {
  childList: !0,
  characterData: !0,
  subtree: !0,
  attributes: !0,
  characterDataOldValue: !0
}, cl = V.ie && V.ie_version <= 11;
class Ry {
  constructor(e) {
    this.view = e, this.active = !1, this.selectionRange = new pb(), this.selectionChanged = !1, this.delayedFlush = -1, this.resizeTimeout = -1, this.queue = [], this.delayedAndroidKey = null, this.flushingAndroidKey = -1, this.lastChange = 0, this.scrollTargets = [], this.intersection = null, this.resizeScroll = null, this.intersecting = !1, this.gapIntersection = null, this.gaps = [], this.printQuery = null, this.parentCheck = -1, this.dom = e.contentDOM, this.observer = new MutationObserver((t) => {
      for (let i of t)
        this.queue.push(i);
      (V.ie && V.ie_version <= 11 || V.ios && e.composing) && t.some((i) => i.type == "childList" && i.removedNodes.length || i.type == "characterData" && i.oldValue.length > i.target.nodeValue.length) ? this.flushSoon() : this.flush();
    }), cl && (this.onCharData = (t) => {
      this.queue.push({
        target: t.target,
        type: "characterData",
        oldValue: t.prevValue
      }), this.flushSoon();
    }), this.onSelectionChange = this.onSelectionChange.bind(this), this.onResize = this.onResize.bind(this), this.onPrint = this.onPrint.bind(this), this.onScroll = this.onScroll.bind(this), window.matchMedia && (this.printQuery = window.matchMedia("print")), typeof ResizeObserver == "function" && (this.resizeScroll = new ResizeObserver(() => {
      var t;
      ((t = this.view.docView) === null || t === void 0 ? void 0 : t.lastUpdate) < Date.now() - 75 && this.onResize();
    }), this.resizeScroll.observe(e.scrollDOM)), this.addWindowListeners(this.win = e.win), this.start(), typeof IntersectionObserver == "function" && (this.intersection = new IntersectionObserver((t) => {
      this.parentCheck < 0 && (this.parentCheck = setTimeout(this.listenForScroll.bind(this), 1e3)), t.length > 0 && t[t.length - 1].intersectionRatio > 0 != this.intersecting && (this.intersecting = !this.intersecting, this.intersecting != this.view.inView && this.onScrollChanged(document.createEvent("Event")));
    }, { threshold: [0, 1e-3] }), this.intersection.observe(this.dom), this.gapIntersection = new IntersectionObserver((t) => {
      t.length > 0 && t[t.length - 1].intersectionRatio > 0 && this.onScrollChanged(document.createEvent("Event"));
    }, {})), this.listenForScroll(), this.readSelectionRange();
  }
  onScrollChanged(e) {
    this.view.inputState.runHandlers("scroll", e), this.intersecting && this.view.measure();
  }
  onScroll(e) {
    this.intersecting && this.flush(!1), this.onScrollChanged(e);
  }
  onResize() {
    this.resizeTimeout < 0 && (this.resizeTimeout = setTimeout(() => {
      this.resizeTimeout = -1, this.view.requestMeasure();
    }, 50));
  }
  onPrint(e) {
    e.type == "change" && !e.matches || (this.view.viewState.printing = !0, this.view.measure(), setTimeout(() => {
      this.view.viewState.printing = !1, this.view.requestMeasure();
    }, 500));
  }
  updateGaps(e) {
    if (this.gapIntersection && (e.length != this.gaps.length || this.gaps.some((t, i) => t != e[i]))) {
      this.gapIntersection.disconnect();
      for (let t of e)
        this.gapIntersection.observe(t);
      this.gaps = e;
    }
  }
  onSelectionChange(e) {
    let t = this.selectionChanged;
    if (!this.readSelectionRange() || this.delayedAndroidKey)
      return;
    let { view: i } = this, r = this.selectionRange;
    if (i.state.facet(Lo) ? i.root.activeElement != this.dom : !Ds(i.dom, r))
      return;
    let s = r.anchorNode && i.docView.nearest(r.anchorNode);
    if (s && s.ignoreEvent(e)) {
      t || (this.selectionChanged = !1);
      return;
    }
    (V.ie && V.ie_version <= 11 || V.android && V.chrome) && !i.state.selection.main.empty && // (Selection.isCollapsed isn't reliable on IE)
    r.focusNode && pr(r.focusNode, r.focusOffset, r.anchorNode, r.anchorOffset) ? this.flushSoon() : this.flush(!1);
  }
  readSelectionRange() {
    let { view: e } = this, t = Js(e.root);
    if (!t)
      return !1;
    let i = V.safari && e.root.nodeType == 11 && ub(this.dom.ownerDocument) == this.dom && Zy(this.view, t) || t;
    if (!i || this.selectionRange.eq(i))
      return !1;
    let r = Ds(this.dom, i);
    return r && !this.selectionChanged && e.inputState.lastFocusTime > Date.now() - 200 && e.inputState.lastTouchTime < Date.now() - 300 && Ob(this.dom, i) ? (this.view.inputState.lastFocusTime = 0, e.docView.updateSelection(), !1) : (this.selectionRange.setRange(i), r && (this.selectionChanged = !0), !0);
  }
  setSelectionRange(e, t) {
    this.selectionRange.set(e.node, e.offset, t.node, t.offset), this.selectionChanged = !1;
  }
  clearSelectionRange() {
    this.selectionRange.set(null, 0, null, 0);
  }
  listenForScroll() {
    this.parentCheck = -1;
    let e = 0, t = null;
    for (let i = this.dom; i; )
      if (i.nodeType == 1)
        !t && e < this.scrollTargets.length && this.scrollTargets[e] == i ? e++ : t || (t = this.scrollTargets.slice(0, e)), t && t.push(i), i = i.assignedSlot || i.parentNode;
      else if (i.nodeType == 11)
        i = i.host;
      else
        break;
    if (e < this.scrollTargets.length && !t && (t = this.scrollTargets.slice(0, e)), t) {
      for (let i of this.scrollTargets)
        i.removeEventListener("scroll", this.onScroll);
      for (let i of this.scrollTargets = t)
        i.addEventListener("scroll", this.onScroll);
    }
  }
  ignore(e) {
    if (!this.active)
      return e();
    try {
      return this.stop(), e();
    } finally {
      this.start(), this.clear();
    }
  }
  start() {
    this.active || (this.observer.observe(this.dom, Ay), cl && this.dom.addEventListener("DOMCharacterDataModified", this.onCharData), this.active = !0);
  }
  stop() {
    this.active && (this.active = !1, this.observer.disconnect(), cl && this.dom.removeEventListener("DOMCharacterDataModified", this.onCharData));
  }
  // Throw away any pending changes
  clear() {
    this.processRecords(), this.queue.length = 0, this.selectionChanged = !1;
  }
  // Chrome Android, especially in combination with GBoard, not only
  // doesn't reliably fire regular key events, but also often
  // surrounds the effect of enter or backspace with a bunch of
  // composition events that, when interrupted, cause text duplication
  // or other kinds of corruption. This hack makes the editor back off
  // from handling DOM changes for a moment when such a key is
  // detected (via beforeinput or keydown), and then tries to flush
  // them or, if that has no effect, dispatches the given key.
  delayAndroidKey(e, t) {
    var i;
    if (!this.delayedAndroidKey) {
      let r = () => {
        let s = this.delayedAndroidKey;
        s && (this.clearDelayedAndroidKey(), this.view.inputState.lastKeyCode = s.keyCode, this.view.inputState.lastKeyTime = Date.now(), !this.flush() && s.force && mi(this.dom, s.key, s.keyCode));
      };
      this.flushingAndroidKey = this.view.win.requestAnimationFrame(r);
    }
    (!this.delayedAndroidKey || e == "Enter") && (this.delayedAndroidKey = {
      key: e,
      keyCode: t,
      // Only run the key handler when no changes are detected if
      // this isn't coming right after another change, in which case
      // it is probably part of a weird chain of updates, and should
      // be ignored if it returns the DOM to its previous state.
      force: this.lastChange < Date.now() - 50 || !!(!((i = this.delayedAndroidKey) === null || i === void 0) && i.force)
    });
  }
  clearDelayedAndroidKey() {
    this.win.cancelAnimationFrame(this.flushingAndroidKey), this.delayedAndroidKey = null, this.flushingAndroidKey = -1;
  }
  flushSoon() {
    this.delayedFlush < 0 && (this.delayedFlush = this.view.win.requestAnimationFrame(() => {
      this.delayedFlush = -1, this.flush();
    }));
  }
  forceFlush() {
    this.delayedFlush >= 0 && (this.view.win.cancelAnimationFrame(this.delayedFlush), this.delayedFlush = -1), this.flush();
  }
  pendingRecords() {
    for (let e of this.observer.takeRecords())
      this.queue.push(e);
    return this.queue;
  }
  processRecords() {
    let e = this.pendingRecords();
    e.length && (this.queue = []);
    let t = -1, i = -1, r = !1;
    for (let s of e) {
      let o = this.readMutation(s);
      o && (o.typeOver && (r = !0), t == -1 ? { from: t, to: i } = o : (t = Math.min(o.from, t), i = Math.max(o.to, i)));
    }
    return { from: t, to: i, typeOver: r };
  }
  readChange() {
    let { from: e, to: t, typeOver: i } = this.processRecords(), r = this.selectionChanged && Ds(this.dom, this.selectionRange);
    if (e < 0 && !r)
      return null;
    e > -1 && (this.lastChange = Date.now()), this.view.inputState.lastFocusTime = 0, this.selectionChanged = !1;
    let s = new Py(this.view, e, t, i);
    return this.view.docView.domChanged = { newSel: s.newSel ? s.newSel.main : null }, s;
  }
  // Apply pending changes, if any
  flush(e = !0) {
    if (this.delayedFlush >= 0 || this.delayedAndroidKey)
      return !1;
    e && this.readSelectionRange();
    let t = this.readChange();
    if (!t)
      return this.view.requestMeasure(), !1;
    let i = this.view.state, r = xm(this.view, t);
    return this.view.state == i && this.view.update([]), r;
  }
  readMutation(e) {
    let t = this.view.docView.nearest(e.target);
    if (!t || t.ignoreMutation(e))
      return null;
    if (t.markDirty(e.type == "attributes"), e.type == "attributes" && (t.flags |= 4), e.type == "childList") {
      let i = wc(t, e.previousSibling || e.target.previousSibling, -1), r = wc(t, e.nextSibling || e.target.nextSibling, 1);
      return {
        from: i ? t.posAfter(i) : t.posAtStart,
        to: r ? t.posBefore(r) : t.posAtEnd,
        typeOver: !1
      };
    } else
      return e.type == "characterData" ? { from: t.posAtStart, to: t.posAtEnd, typeOver: e.target.nodeValue == e.oldValue } : null;
  }
  setWindow(e) {
    e != this.win && (this.removeWindowListeners(this.win), this.win = e, this.addWindowListeners(this.win));
  }
  addWindowListeners(e) {
    e.addEventListener("resize", this.onResize), this.printQuery ? this.printQuery.addEventListener("change", this.onPrint) : e.addEventListener("beforeprint", this.onPrint), e.addEventListener("scroll", this.onScroll), e.document.addEventListener("selectionchange", this.onSelectionChange);
  }
  removeWindowListeners(e) {
    e.removeEventListener("scroll", this.onScroll), e.removeEventListener("resize", this.onResize), this.printQuery ? this.printQuery.removeEventListener("change", this.onPrint) : e.removeEventListener("beforeprint", this.onPrint), e.document.removeEventListener("selectionchange", this.onSelectionChange);
  }
  destroy() {
    var e, t, i;
    this.stop(), (e = this.intersection) === null || e === void 0 || e.disconnect(), (t = this.gapIntersection) === null || t === void 0 || t.disconnect(), (i = this.resizeScroll) === null || i === void 0 || i.disconnect();
    for (let r of this.scrollTargets)
      r.removeEventListener("scroll", this.onScroll);
    this.removeWindowListeners(this.win), clearTimeout(this.parentCheck), clearTimeout(this.resizeTimeout), this.win.cancelAnimationFrame(this.delayedFlush), this.win.cancelAnimationFrame(this.flushingAndroidKey);
  }
}
function wc(n, e, t) {
  for (; e; ) {
    let i = pe.get(e);
    if (i && i.parent == n)
      return i;
    let r = e.parentNode;
    e = r != n.dom ? r : t > 0 ? e.nextSibling : e.previousSibling;
  }
  return null;
}
function Sc(n, e) {
  let t = e.startContainer, i = e.startOffset, r = e.endContainer, s = e.endOffset, o = n.docView.domAtPos(n.state.selection.main.anchor);
  return pr(o.node, o.offset, r, s) && ([t, i, r, s] = [r, s, t, i]), { anchorNode: t, anchorOffset: i, focusNode: r, focusOffset: s };
}
function Zy(n, e) {
  if (e.getComposedRanges) {
    let r = e.getComposedRanges(n.root)[0];
    if (r)
      return Sc(n, r);
  }
  let t = null;
  function i(r) {
    r.preventDefault(), r.stopImmediatePropagation(), t = r.getTargetRanges()[0];
  }
  return n.contentDOM.addEventListener("beforeinput", i, !0), n.dom.ownerDocument.execCommand("indent"), n.contentDOM.removeEventListener("beforeinput", i, !0), t ? Sc(n, t) : null;
}
class I {
  /**
  The current editor state.
  */
  get state() {
    return this.viewState.state;
  }
  /**
  To be able to display large documents without consuming too much
  memory or overloading the browser, CodeMirror only draws the
  code that is visible (plus a margin around it) to the DOM. This
  property tells you the extent of the current drawn viewport, in
  document positions.
  */
  get viewport() {
    return this.viewState.viewport;
  }
  /**
  When there are, for example, large collapsed ranges in the
  viewport, its size can be a lot bigger than the actual visible
  content. Thus, if you are doing something like styling the
  content in the viewport, it is preferable to only do so for
  these ranges, which are the subset of the viewport that is
  actually drawn.
  */
  get visibleRanges() {
    return this.viewState.visibleRanges;
  }
  /**
  Returns false when the editor is entirely scrolled out of view
  or otherwise hidden.
  */
  get inView() {
    return this.viewState.inView;
  }
  /**
  Indicates whether the user is currently composing text via
  [IME](https://en.wikipedia.org/wiki/Input_method), and at least
  one change has been made in the current composition.
  */
  get composing() {
    return this.inputState.composing > 0;
  }
  /**
  Indicates whether the user is currently in composing state. Note
  that on some platforms, like Android, this will be the case a
  lot, since just putting the cursor on a word starts a
  composition there.
  */
  get compositionStarted() {
    return this.inputState.composing >= 0;
  }
  /**
  The document or shadow root that the view lives in.
  */
  get root() {
    return this._root;
  }
  /**
  @internal
  */
  get win() {
    return this.dom.ownerDocument.defaultView || window;
  }
  /**
  Construct a new view. You'll want to either provide a `parent`
  option, or put `view.dom` into your document after creating a
  view, so that the user can see the editor.
  */
  constructor(e = {}) {
    this.plugins = [], this.pluginMap = /* @__PURE__ */ new Map(), this.editorAttrs = {}, this.contentAttrs = {}, this.bidiCache = [], this.destroyed = !1, this.updateState = 2, this.measureScheduled = -1, this.measureRequests = [], this.contentDOM = document.createElement("div"), this.scrollDOM = document.createElement("div"), this.scrollDOM.tabIndex = -1, this.scrollDOM.className = "cm-scroller", this.scrollDOM.appendChild(this.contentDOM), this.announceDOM = document.createElement("div"), this.announceDOM.className = "cm-announced", this.announceDOM.setAttribute("aria-live", "polite"), this.dom = document.createElement("div"), this.dom.appendChild(this.announceDOM), this.dom.appendChild(this.scrollDOM), e.parent && e.parent.appendChild(this.dom);
    let { dispatch: t } = e;
    this.dispatchTransactions = e.dispatchTransactions || t && ((i) => i.forEach((r) => t(r, this))) || ((i) => this.update(i)), this.dispatch = this.dispatch.bind(this), this._root = e.root || mb(e.parent) || document, this.viewState = new yc(e.state || ee.create(e)), e.scrollTo && e.scrollTo.is(ss) && (this.viewState.scrollTarget = e.scrollTo.value.clip(this.viewState.state)), this.plugins = this.state.facet(sr).map((i) => new ll(i));
    for (let i of this.plugins)
      i.update(this);
    this.observer = new Ry(this), this.inputState = new Nb(this), this.inputState.ensureHandlers(this.plugins), this.docView = new tc(this), this.mountStyles(), this.updateAttrs(), this.updateState = 0, this.requestMeasure();
  }
  dispatch(...e) {
    let t = e.length == 1 && e[0] instanceof Re ? e : e.length == 1 && Array.isArray(e[0]) ? e[0] : [this.state.update(...e)];
    this.dispatchTransactions(t, this);
  }
  /**
  Update the view for the given array of transactions. This will
  update the visible document and selection to match the state
  produced by the transactions, and notify view plugins of the
  change. You should usually call
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead, which uses this
  as a primitive.
  */
  update(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.update are not allowed while an update is in progress");
    let t = !1, i = !1, r, s = this.state;
    for (let f of e) {
      if (f.startState != s)
        throw new RangeError("Trying to update state with a transaction that doesn't start from the previous state.");
      s = f.state;
    }
    if (this.destroyed) {
      this.viewState.state = s;
      return;
    }
    let o = this.hasFocus, l = 0, a = null;
    e.some((f) => f.annotation(pm)) ? (this.inputState.notifiedFocused = o, l = 1) : o != this.inputState.notifiedFocused && (this.inputState.notifiedFocused = o, a = mm(s, o), a || (l = 1));
    let h = this.observer.delayedAndroidKey, u = null;
    if (h ? (this.observer.clearDelayedAndroidKey(), u = this.observer.readChange(), (u && !this.state.doc.eq(s.doc) || !this.state.selection.eq(s.selection)) && (u = null)) : this.observer.clear(), s.facet(ee.phrases) != this.state.facet(ee.phrases))
      return this.setState(s);
    r = to.create(this, s, e), r.flags |= l;
    let c = this.viewState.scrollTarget;
    try {
      this.updateState = 2;
      for (let f of e) {
        if (c && (c = c.map(f.changes)), f.scrollIntoView) {
          let { main: d } = f.state.selection;
          c = new Oi(d.empty ? d : $.cursor(d.head, d.head > d.anchor ? -1 : 1));
        }
        for (let d of f.effects)
          d.is(ss) && (c = d.value.clip(this.state));
      }
      this.viewState.update(r, c), this.bidiCache = no.update(this.bidiCache, r.changes), r.empty || (this.updatePlugins(r), this.inputState.update(r)), t = this.docView.update(r), this.state.facet(or) != this.styleModules && this.mountStyles(), i = this.updateAttrs(), this.showAnnouncements(e), this.docView.updateSelection(t, e.some((f) => f.isUserEvent("select.pointer")));
    } finally {
      this.updateState = 0;
    }
    if (r.startState.facet(cs) != r.state.facet(cs) && (this.viewState.mustMeasureContent = !0), (t || i || c || this.viewState.mustEnforceCursorAssoc || this.viewState.mustMeasureContent) && this.requestMeasure(), t && this.docViewUpdate(), !r.empty)
      for (let f of this.state.facet(Ta))
        try {
          f(r);
        } catch (d) {
          it(this.state, d, "update listener");
        }
    (a || u) && Promise.resolve().then(() => {
      a && this.state == a.startState && this.dispatch(a), u && !xm(this, u) && h.force && mi(this.contentDOM, h.key, h.keyCode);
    });
  }
  /**
  Reset the view to the given state. (This will cause the entire
  document to be redrawn and all view plugins to be reinitialized,
  so you should probably only use it when the new state isn't
  derived from the old state. Otherwise, use
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead.)
  */
  setState(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.setState are not allowed while an update is in progress");
    if (this.destroyed) {
      this.viewState.state = e;
      return;
    }
    this.updateState = 2;
    let t = this.hasFocus;
    try {
      for (let i of this.plugins)
        i.destroy(this);
      this.viewState = new yc(e), this.plugins = e.facet(sr).map((i) => new ll(i)), this.pluginMap.clear();
      for (let i of this.plugins)
        i.update(this);
      this.docView.destroy(), this.docView = new tc(this), this.inputState.ensureHandlers(this.plugins), this.mountStyles(), this.updateAttrs(), this.bidiCache = [];
    } finally {
      this.updateState = 0;
    }
    t && this.focus(), this.requestMeasure();
  }
  updatePlugins(e) {
    let t = e.startState.facet(sr), i = e.state.facet(sr);
    if (t != i) {
      let r = [];
      for (let s of i) {
        let o = t.indexOf(s);
        if (o < 0)
          r.push(new ll(s));
        else {
          let l = this.plugins[o];
          l.mustUpdate = e, r.push(l);
        }
      }
      for (let s of this.plugins)
        s.mustUpdate != e && s.destroy(this);
      this.plugins = r, this.pluginMap.clear();
    } else
      for (let r of this.plugins)
        r.mustUpdate = e;
    for (let r = 0; r < this.plugins.length; r++)
      this.plugins[r].update(this);
    t != i && this.inputState.ensureHandlers(this.plugins);
  }
  docViewUpdate() {
    for (let e of this.plugins) {
      let t = e.value;
      if (t && t.docViewUpdate)
        try {
          t.docViewUpdate(this);
        } catch (i) {
          it(this.state, i, "doc view update listener");
        }
    }
  }
  /**
  @internal
  */
  measure(e = !0) {
    if (this.destroyed)
      return;
    if (this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.observer.delayedAndroidKey) {
      this.measureScheduled = -1, this.requestMeasure();
      return;
    }
    this.measureScheduled = 0, e && this.observer.forceFlush();
    let t = null, i = this.scrollDOM, r = i.scrollTop * this.scaleY, { scrollAnchorPos: s, scrollAnchorHeight: o } = this.viewState;
    Math.abs(r - this.viewState.scrollTop) > 1 && (o = -1), this.viewState.scrollAnchorHeight = -1;
    try {
      for (let l = 0; ; l++) {
        if (o < 0)
          if (Tp(i))
            s = -1, o = this.viewState.heightMap.height;
          else {
            let d = this.viewState.scrollAnchorAt(r);
            s = d.from, o = d.top;
          }
        this.updateState = 1;
        let a = this.viewState.measure(this);
        if (!a && !this.measureRequests.length && this.viewState.scrollTarget == null)
          break;
        if (l > 5) {
          console.warn(this.measureRequests.length ? "Measure loop restarted more than 5 times" : "Viewport failed to stabilize");
          break;
        }
        let h = [];
        a & 4 || ([this.measureRequests, h] = [h, this.measureRequests]);
        let u = h.map((d) => {
          try {
            return d.read(this);
          } catch (p) {
            return it(this.state, p), vc;
          }
        }), c = to.create(this, this.state, []), f = !1;
        c.flags |= a, t ? t.flags |= a : t = c, this.updateState = 2, c.empty || (this.updatePlugins(c), this.inputState.update(c), this.updateAttrs(), f = this.docView.update(c), f && this.docViewUpdate());
        for (let d = 0; d < h.length; d++)
          if (u[d] != vc)
            try {
              let p = h[d];
              p.write && p.write(u[d], this);
            } catch (p) {
              it(this.state, p);
            }
        if (f && this.docView.updateSelection(!0), !c.viewportChanged && this.measureRequests.length == 0) {
          if (this.viewState.editorHeight)
            if (this.viewState.scrollTarget) {
              this.docView.scrollIntoView(this.viewState.scrollTarget), this.viewState.scrollTarget = null, o = -1;
              continue;
            } else {
              let p = (s < 0 ? this.viewState.heightMap.height : this.viewState.lineBlockAt(s).top) - o;
              if (p > 1 || p < -1) {
                r = r + p, i.scrollTop = r / this.scaleY, o = -1;
                continue;
              }
            }
          break;
        }
      }
    } finally {
      this.updateState = 0, this.measureScheduled = -1;
    }
    if (t && !t.empty)
      for (let l of this.state.facet(Ta))
        l(t);
  }
  /**
  Get the CSS classes for the currently active editor themes.
  */
  get themeClasses() {
    return Ea + " " + (this.state.facet(Ma) ? ym : bm) + " " + this.state.facet(cs);
  }
  updateAttrs() {
    let e = Pc(this, tm, {
      class: "cm-editor" + (this.hasFocus ? " cm-focused " : " ") + this.themeClasses
    }), t = {
      spellcheck: "false",
      autocorrect: "off",
      autocapitalize: "off",
      translate: "no",
      contenteditable: this.state.facet(Lo) ? "true" : "false",
      class: "cm-content",
      style: `${V.tabSize}: ${this.state.tabSize}`,
      role: "textbox",
      "aria-multiline": "true"
    };
    this.state.readOnly && (t["aria-readonly"] = "true"), Pc(this, Ah, t);
    let i = this.observer.ignore(() => {
      let r = va(this.contentDOM, this.contentAttrs, t), s = va(this.dom, this.editorAttrs, e);
      return r || s;
    });
    return this.editorAttrs = e, this.contentAttrs = t, i;
  }
  showAnnouncements(e) {
    let t = !0;
    for (let i of e)
      for (let r of i.effects)
        if (r.is(I.announce)) {
          t && (this.announceDOM.textContent = ""), t = !1;
          let s = this.announceDOM.appendChild(document.createElement("div"));
          s.textContent = r.value;
        }
  }
  mountStyles() {
    this.styleModules = this.state.facet(or);
    let e = this.state.facet(I.cspNonce);
    Cn.mount(this.root, this.styleModules.concat(wy).reverse(), e ? { nonce: e } : void 0);
  }
  readMeasured() {
    if (this.updateState == 2)
      throw new Error("Reading the editor layout isn't allowed during an update");
    this.updateState == 0 && this.measureScheduled > -1 && this.measure(!1);
  }
  /**
  Schedule a layout measurement, optionally providing callbacks to
  do custom DOM measuring followed by a DOM write phase. Using
  this is preferable reading DOM layout directly from, for
  example, an event handler, because it'll make sure measuring and
  drawing done by other components is synchronized, avoiding
  unnecessary DOM layout computations.
  */
  requestMeasure(e) {
    if (this.measureScheduled < 0 && (this.measureScheduled = this.win.requestAnimationFrame(() => this.measure())), e) {
      if (this.measureRequests.indexOf(e) > -1)
        return;
      if (e.key != null) {
        for (let t = 0; t < this.measureRequests.length; t++)
          if (this.measureRequests[t].key === e.key) {
            this.measureRequests[t] = e;
            return;
          }
      }
      this.measureRequests.push(e);
    }
  }
  /**
  Get the value of a specific plugin, if present. Note that
  plugins that crash can be dropped from a view, so even when you
  know you registered a given plugin, it is recommended to check
  the return value of this method.
  */
  plugin(e) {
    let t = this.pluginMap.get(e);
    return (t === void 0 || t && t.spec != e) && this.pluginMap.set(e, t = this.plugins.find((i) => i.spec == e) || null), t && t.update(this).value;
  }
  /**
  The top position of the document, in screen coordinates. This
  may be negative when the editor is scrolled down. Points
  directly to the top of the first line, not above the padding.
  */
  get documentTop() {
    return this.contentDOM.getBoundingClientRect().top + this.viewState.paddingTop;
  }
  /**
  Reports the padding above and below the document.
  */
  get documentPadding() {
    return { top: this.viewState.paddingTop, bottom: this.viewState.paddingBottom };
  }
  /**
  If the editor is transformed with CSS, this provides the scale
  along the X axis. Otherwise, it will just be 1. Note that
  transforms other than translation and scaling are not supported.
  */
  get scaleX() {
    return this.viewState.scaleX;
  }
  /**
  Provide the CSS transformed scale along the Y axis.
  */
  get scaleY() {
    return this.viewState.scaleY;
  }
  /**
  Find the text line or block widget at the given vertical
  position (which is interpreted as relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop)).
  */
  elementAtHeight(e) {
    return this.readMeasured(), this.viewState.elementAtHeight(e);
  }
  /**
  Find the line block (see
  [`lineBlockAt`](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) at the given
  height, again interpreted relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop).
  */
  lineBlockAtHeight(e) {
    return this.readMeasured(), this.viewState.lineBlockAtHeight(e);
  }
  /**
  Get the extent and vertical position of all [line
  blocks](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) in the viewport. Positions
  are relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop);
  */
  get viewportLineBlocks() {
    return this.viewState.viewportLines;
  }
  /**
  Find the line block around the given document position. A line
  block is a range delimited on both sides by either a
  non-[hidden](https://codemirror.net/6/docs/ref/#view.Decoration^replace) line breaks, or the
  start/end of the document. It will usually just hold a line of
  text, but may be broken into multiple textblocks by block
  widgets.
  */
  lineBlockAt(e) {
    return this.viewState.lineBlockAt(e);
  }
  /**
  The editor's total content height.
  */
  get contentHeight() {
    return this.viewState.contentHeight;
  }
  /**
  Move a cursor position by [grapheme
  cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak). `forward` determines whether
  the motion is away from the line start, or towards it. In
  bidirectional text, the line is traversed in visual order, using
  the editor's [text direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection).
  When the start position was the last one on the line, the
  returned position will be across the line break. If there is no
  further line, the original position is returned.
  
  By default, this method moves over a single cluster. The
  optional `by` argument can be used to move across more. It will
  be called with the first cluster as argument, and should return
  a predicate that determines, for each subsequent cluster,
  whether it should also be moved over.
  */
  moveByChar(e, t, i) {
    return hl(this, e, lc(this, e, t, i));
  }
  /**
  Move a cursor position across the next group of either
  [letters](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) or non-letter
  non-whitespace characters.
  */
  moveByGroup(e, t) {
    return hl(this, e, lc(this, e, t, (i) => Yb(this, e.head, i)));
  }
  /**
  Get the cursor position visually at the start or end of a line.
  Note that this may differ from the _logical_ position at its
  start or end (which is simply at `line.from`/`line.to`) if text
  at the start or end goes against the line's base text direction.
  */
  visualLineSide(e, t) {
    let i = this.bidiSpans(e), r = this.textDirectionAt(e.from), s = i[t ? i.length - 1 : 0];
    return $.cursor(s.side(t, r) + e.from, s.forward(!t, r) ? 1 : -1);
  }
  /**
  Move to the next line boundary in the given direction. If
  `includeWrap` is true, line wrapping is on, and there is a
  further wrap point on the current line, the wrap point will be
  returned. Otherwise this function will return the start or end
  of the line.
  */
  moveToLineBoundary(e, t, i = !0) {
    return Vb(this, e, t, i);
  }
  /**
  Move a cursor position vertically. When `distance` isn't given,
  it defaults to moving to the next line (including wrapped
  lines). Otherwise, `distance` should provide a positive distance
  in pixels.
  
  When `start` has a
  [`goalColumn`](https://codemirror.net/6/docs/ref/#state.SelectionRange.goalColumn), the vertical
  motion will use that as a target horizontal position. Otherwise,
  the cursor's own horizontal position is used. The returned
  cursor will have its goal column set to whichever column was
  used.
  */
  moveVertically(e, t, i) {
    return hl(this, e, jb(this, e, t, i));
  }
  /**
  Find the DOM parent node and offset (child offset if `node` is
  an element, character offset when it is a text node) at the
  given document position.
  
  Note that for positions that aren't currently in
  `visibleRanges`, the resulting DOM position isn't necessarily
  meaningful (it may just point before or after a placeholder
  element).
  */
  domAtPos(e) {
    return this.docView.domAtPos(e);
  }
  /**
  Find the document position at the given DOM node. Can be useful
  for associating positions with DOM events. Will raise an error
  when `node` isn't part of the editor content.
  */
  posAtDOM(e, t = 0) {
    return this.docView.posFromDOM(e, t);
  }
  posAtCoords(e, t = !0) {
    return this.readMeasured(), lm(this, e, t);
  }
  /**
  Get the screen coordinates at the given document position.
  `side` determines whether the coordinates are based on the
  element before (-1) or after (1) the position (if no element is
  available on the given side, the method will transparently use
  another strategy to get reasonable coordinates).
  */
  coordsAtPos(e, t = 1) {
    this.readMeasured();
    let i = this.docView.coordsAt(e, t);
    if (!i || i.left == i.right)
      return i;
    let r = this.state.doc.lineAt(e), s = this.bidiSpans(r), o = s[xn.find(s, e - r.from, -1, t)];
    return Xo(i, o.dir == we.LTR == t > 0);
  }
  /**
  Return the rectangle around a given character. If `pos` does not
  point in front of a character that is in the viewport and
  rendered (i.e. not replaced, not a line break), this will return
  null. For space characters that are a line wrap point, this will
  return the position before the line break.
  */
  coordsForChar(e) {
    return this.readMeasured(), this.docView.coordsForChar(e);
  }
  /**
  The default width of a character in the editor. May not
  accurately reflect the width of all characters (given variable
  width fonts or styling of invididual ranges).
  */
  get defaultCharacterWidth() {
    return this.viewState.heightOracle.charWidth;
  }
  /**
  The default height of a line in the editor. May not be accurate
  for all lines.
  */
  get defaultLineHeight() {
    return this.viewState.heightOracle.lineHeight;
  }
  /**
  The text direction
  ([`direction`](https://developer.mozilla.org/en-US/docs/Web/CSS/direction)
  CSS property) of the editor's content element.
  */
  get textDirection() {
    return this.viewState.defaultTextDirection;
  }
  /**
  Find the text direction of the block at the given position, as
  assigned by CSS. If
  [`perLineTextDirection`](https://codemirror.net/6/docs/ref/#view.EditorView^perLineTextDirection)
  isn't enabled, or the given position is outside of the viewport,
  this will always return the same as
  [`textDirection`](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection). Note that
  this may trigger a DOM layout.
  */
  textDirectionAt(e) {
    return !this.state.facet(Kp) || e < this.viewport.from || e > this.viewport.to ? this.textDirection : (this.readMeasured(), this.docView.textDirectionAt(e));
  }
  /**
  Whether this editor [wraps lines](https://codemirror.net/6/docs/ref/#view.EditorView.lineWrapping)
  (as determined by the
  [`white-space`](https://developer.mozilla.org/en-US/docs/Web/CSS/white-space)
  CSS property of its content element).
  */
  get lineWrapping() {
    return this.viewState.heightOracle.lineWrapping;
  }
  /**
  Returns the bidirectional text structure of the given line
  (which should be in the current document) as an array of span
  objects. The order of these spans matches the [text
  direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection)—if that is
  left-to-right, the leftmost spans come first, otherwise the
  rightmost spans come first.
  */
  bidiSpans(e) {
    if (e.length > My)
      return Vp(e.length);
    let t = this.textDirectionAt(e.from), i;
    for (let s of this.bidiCache)
      if (s.from == e.from && s.dir == t && (s.fresh || Bp(s.isolates, i = ec(this, e))))
        return s.order;
    i || (i = ec(this, e));
    let r = Cb(e.text, t, i);
    return this.bidiCache.push(new no(e.from, e.to, t, i, !0, r)), r;
  }
  /**
  Check whether the editor has focus.
  */
  get hasFocus() {
    var e;
    return (this.dom.ownerDocument.hasFocus() || V.safari && ((e = this.inputState) === null || e === void 0 ? void 0 : e.lastContextMenu) > Date.now() - 3e4) && this.root.activeElement == this.contentDOM;
  }
  /**
  Put focus on the editor.
  */
  focus() {
    this.observer.ignore(() => {
      $p(this.contentDOM), this.docView.updateSelection();
    });
  }
  /**
  Update the [root](https://codemirror.net/6/docs/ref/##view.EditorViewConfig.root) in which the editor lives. This is only
  necessary when moving the editor's existing DOM to a new window or shadow root.
  */
  setRoot(e) {
    this._root != e && (this._root = e, this.observer.setWindow((e.nodeType == 9 ? e : e.ownerDocument).defaultView || window), this.mountStyles());
  }
  /**
  Clean up this editor view, removing its element from the
  document, unregistering event handlers, and notifying
  plugins. The view instance can no longer be used after
  calling this.
  */
  destroy() {
    for (let e of this.plugins)
      e.destroy(this);
    this.plugins = [], this.inputState.destroy(), this.docView.destroy(), this.dom.remove(), this.observer.destroy(), this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.destroyed = !0;
  }
  /**
  Returns an effect that can be
  [added](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) to a transaction to
  cause it to scroll the given position or range into view.
  */
  static scrollIntoView(e, t = {}) {
    return ss.of(new Oi(typeof e == "number" ? $.cursor(e) : e, t.y, t.x, t.yMargin, t.xMargin));
  }
  /**
  Return an effect that resets the editor to its current (at the
  time this method was called) scroll position. Note that this
  only affects the editor's own scrollable element, not parents.
  See also
  [`EditorViewConfig.scrollTo`](https://codemirror.net/6/docs/ref/#view.EditorViewConfig.scrollTo).
  
  The effect should be used with a document identical to the one
  it was created for. Failing to do so is not an error, but may
  not scroll to the expected position. You can
  [map](https://codemirror.net/6/docs/ref/#state.StateEffect.map) the effect to account for changes.
  */
  scrollSnapshot() {
    let { scrollTop: e, scrollLeft: t } = this.scrollDOM, i = this.viewState.scrollAnchorAt(e);
    return ss.of(new Oi($.cursor(i.from), "start", "start", i.top - e, t, !0));
  }
  /**
  Returns an extension that can be used to add DOM event handlers.
  The value should be an object mapping event names to handler
  functions. For any given event, such functions are ordered by
  extension precedence, and the first handler to return true will
  be assumed to have handled that event, and no other handlers or
  built-in behavior will be activated for it. These are registered
  on the [content element](https://codemirror.net/6/docs/ref/#view.EditorView.contentDOM), except
  for `scroll` handlers, which will be called any time the
  editor's [scroll element](https://codemirror.net/6/docs/ref/#view.EditorView.scrollDOM) or one of
  its parent nodes is scrolled.
  */
  static domEventHandlers(e) {
    return Qe.define(() => ({}), { eventHandlers: e });
  }
  /**
  Create an extension that registers DOM event observers. Contrary
  to event [handlers](https://codemirror.net/6/docs/ref/#view.EditorView^domEventHandlers),
  observers can't be prevented from running by a higher-precedence
  handler returning true. They also don't prevent other handlers
  and observers from running when they return true, and should not
  call `preventDefault`.
  */
  static domEventObservers(e) {
    return Qe.define(() => ({}), { eventObservers: e });
  }
  /**
  Create a theme extension. The first argument can be a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)
  style spec providing the styles for the theme. These will be
  prefixed with a generated class for the style.
  
  Because the selectors will be prefixed with a scope class, rule
  that directly match the editor's [wrapper
  element](https://codemirror.net/6/docs/ref/#view.EditorView.dom)—to which the scope class will be
  added—need to be explicitly differentiated by adding an `&` to
  the selector for that element—for example
  `&.cm-focused`.
  
  When `dark` is set to true, the theme will be marked as dark,
  which will cause the `&dark` rules from [base
  themes](https://codemirror.net/6/docs/ref/#view.EditorView^baseTheme) to be used (as opposed to
  `&light` when a light theme is active).
  */
  static theme(e, t) {
    let i = Cn.newName(), r = [cs.of(i), or.of(za(`.${i}`, e))];
    return t && t.dark && r.push(Ma.of(!0)), r;
  }
  /**
  Create an extension that adds styles to the base theme. Like
  with [`theme`](https://codemirror.net/6/docs/ref/#view.EditorView^theme), use `&` to indicate the
  place of the editor wrapper element when directly targeting
  that. You can also use `&dark` or `&light` instead to only
  target editors with a dark or light theme.
  */
  static baseTheme(e) {
    return un.lowest(or.of(za("." + Ea, e, km)));
  }
  /**
  Retrieve an editor view instance from the view's DOM
  representation.
  */
  static findFromDOM(e) {
    var t;
    let i = e.querySelector(".cm-content"), r = i && pe.get(i) || pe.get(e);
    return ((t = r == null ? void 0 : r.rootView) === null || t === void 0 ? void 0 : t.view) || null;
  }
}
I.styleModule = or;
I.inputHandler = Gp;
I.scrollHandler = em;
I.focusChangeEffect = Hp;
I.perLineTextDirection = Kp;
I.exceptionSink = Fp;
I.updateListener = Ta;
I.editable = Lo;
I.mouseSelectionStyle = Up;
I.dragMovesSelection = Np;
I.clickAddsSelectionRange = jp;
I.decorations = Pr;
I.outerDecorations = nm;
I.atomicRanges = Rh;
I.bidiIsolatedRanges = im;
I.scrollMargins = rm;
I.darkTheme = Ma;
I.cspNonce = /* @__PURE__ */ B.define({ combine: (n) => n.length ? n[0] : "" });
I.contentAttributes = Ah;
I.editorAttributes = tm;
I.lineWrapping = /* @__PURE__ */ I.contentAttributes.of({ class: "cm-lineWrapping" });
I.announce = /* @__PURE__ */ K.define();
const My = 4096, vc = {};
class no {
  constructor(e, t, i, r, s, o) {
    this.from = e, this.to = t, this.dir = i, this.isolates = r, this.fresh = s, this.order = o;
  }
  static update(e, t) {
    if (t.empty && !e.some((s) => s.fresh))
      return e;
    let i = [], r = e.length ? e[e.length - 1].dir : we.LTR;
    for (let s = Math.max(0, e.length - 10); s < e.length; s++) {
      let o = e[s];
      o.dir == r && !t.touchesRange(o.from, o.to) && i.push(new no(t.mapPos(o.from, 1), t.mapPos(o.to, -1), o.dir, o.isolates, !1, o.order));
    }
    return i;
  }
}
function Pc(n, e, t) {
  for (let i = n.state.facet(e), r = i.length - 1; r >= 0; r--) {
    let s = i[r], o = typeof s == "function" ? s(n) : s;
    o && Sa(o, t);
  }
  return t;
}
const Ey = V.mac ? "mac" : V.windows ? "win" : V.linux ? "linux" : "key";
function zy(n, e) {
  const t = n.split(/-(?!$)/);
  let i = t[t.length - 1];
  i == "Space" && (i = " ");
  let r, s, o, l;
  for (let a = 0; a < t.length - 1; ++a) {
    const h = t[a];
    if (/^(cmd|meta|m)$/i.test(h))
      l = !0;
    else if (/^a(lt)?$/i.test(h))
      r = !0;
    else if (/^(c|ctrl|control)$/i.test(h))
      s = !0;
    else if (/^s(hift)?$/i.test(h))
      o = !0;
    else if (/^mod$/i.test(h))
      e == "mac" ? l = !0 : s = !0;
    else
      throw new Error("Unrecognized modifier name: " + h);
  }
  return r && (i = "Alt-" + i), s && (i = "Ctrl-" + i), l && (i = "Meta-" + i), o && (i = "Shift-" + i), i;
}
function fs(n, e, t) {
  return e.altKey && (n = "Alt-" + n), e.ctrlKey && (n = "Ctrl-" + n), e.metaKey && (n = "Meta-" + n), t !== !1 && e.shiftKey && (n = "Shift-" + n), n;
}
const Xy = /* @__PURE__ */ un.default(/* @__PURE__ */ I.domEventHandlers({
  keydown(n, e) {
    return Sm(wm(e.state), n, e, "editor");
  }
})), zi = /* @__PURE__ */ B.define({ enables: Xy }), Qc = /* @__PURE__ */ new WeakMap();
function wm(n) {
  let e = n.facet(zi), t = Qc.get(e);
  return t || Qc.set(e, t = Iy(e.reduce((i, r) => i.concat(r), []))), t;
}
function Dy(n, e, t) {
  return Sm(wm(n.state), e, n, t);
}
let bn = null;
const Ly = 4e3;
function Iy(n, e = Ey) {
  let t = /* @__PURE__ */ Object.create(null), i = /* @__PURE__ */ Object.create(null), r = (o, l) => {
    let a = i[o];
    if (a == null)
      i[o] = l;
    else if (a != l)
      throw new Error("Key binding " + o + " is used both as a regular binding and as a multi-stroke prefix");
  }, s = (o, l, a, h, u) => {
    var c, f;
    let d = t[o] || (t[o] = /* @__PURE__ */ Object.create(null)), p = l.split(/ (?!$)/).map((g) => zy(g, e));
    for (let g = 1; g < p.length; g++) {
      let b = p.slice(0, g).join(" ");
      r(b, !0), d[b] || (d[b] = {
        preventDefault: !0,
        stopPropagation: !1,
        run: [(S) => {
          let Q = bn = { view: S, prefix: b, scope: o };
          return setTimeout(() => {
            bn == Q && (bn = null);
          }, Ly), !0;
        }]
      });
    }
    let m = p.join(" ");
    r(m, !1);
    let O = d[m] || (d[m] = {
      preventDefault: !1,
      stopPropagation: !1,
      run: ((f = (c = d._any) === null || c === void 0 ? void 0 : c.run) === null || f === void 0 ? void 0 : f.slice()) || []
    });
    a && O.run.push(a), h && (O.preventDefault = !0), u && (O.stopPropagation = !0);
  };
  for (let o of n) {
    let l = o.scope ? o.scope.split(" ") : ["editor"];
    if (o.any)
      for (let h of l) {
        let u = t[h] || (t[h] = /* @__PURE__ */ Object.create(null));
        u._any || (u._any = { preventDefault: !1, stopPropagation: !1, run: [] });
        for (let c in u)
          u[c].run.push(o.any);
      }
    let a = o[e] || o.key;
    if (a)
      for (let h of l)
        s(h, a, o.run, o.preventDefault, o.stopPropagation), o.shift && s(h, "Shift-" + a, o.shift, o.preventDefault, o.stopPropagation);
  }
  return t;
}
function Sm(n, e, t, i) {
  let r = hb(e), s = Ie(r, 0), o = bt(s) == r.length && r != " ", l = "", a = !1, h = !1, u = !1;
  bn && bn.view == t && bn.scope == i && (l = bn.prefix + " ", hm.indexOf(e.keyCode) < 0 && (h = !0, bn = null));
  let c = /* @__PURE__ */ new Set(), f = (O) => {
    if (O) {
      for (let g of O.run)
        if (!c.has(g) && (c.add(g), g(t, e)))
          return O.stopPropagation && (u = !0), !0;
      O.preventDefault && (O.stopPropagation && (u = !0), h = !0);
    }
    return !1;
  }, d = n[i], p, m;
  return d && (f(d[l + fs(r, e, !o)]) ? a = !0 : o && (e.altKey || e.metaKey || e.ctrlKey) && // Ctrl-Alt may be used for AltGr on Windows
  !(V.windows && e.ctrlKey && e.altKey) && (p = Tn[e.keyCode]) && p != r ? (f(d[l + fs(p, e, !0)]) || e.shiftKey && (m = vr[e.keyCode]) != r && m != p && f(d[l + fs(m, e, !1)])) && (a = !0) : o && e.shiftKey && f(d[l + fs(r, e, !0)]) && (a = !0), !a && f(d._any) && (a = !0)), h && (a = !0), a && u && e.stopPropagation(), a;
}
class jr {
  /**
  Create a marker with the given class and dimensions. If `width`
  is null, the DOM element will get no width style.
  */
  constructor(e, t, i, r, s) {
    this.className = e, this.left = t, this.top = i, this.width = r, this.height = s;
  }
  draw() {
    let e = document.createElement("div");
    return e.className = this.className, this.adjust(e), e;
  }
  update(e, t) {
    return t.className != this.className ? !1 : (this.adjust(e), !0);
  }
  adjust(e) {
    e.style.left = this.left + "px", e.style.top = this.top + "px", this.width != null && (e.style.width = this.width + "px"), e.style.height = this.height + "px";
  }
  eq(e) {
    return this.left == e.left && this.top == e.top && this.width == e.width && this.height == e.height && this.className == e.className;
  }
  /**
  Create a set of rectangles for the given selection range,
  assigning them theclass`className`. Will create a single
  rectangle for empty ranges, and a set of selection-style
  rectangles covering the range's content (in a bidi-aware
  way) for non-empty ones.
  */
  static forRange(e, t, i) {
    if (i.empty) {
      let r = e.coordsAtPos(i.head, i.assoc || 1);
      if (!r)
        return [];
      let s = vm(e);
      return [new jr(t, r.left - s.left, r.top - s.top, null, r.bottom - r.top)];
    } else
      return _y(e, t, i);
  }
}
function vm(n) {
  let e = n.scrollDOM.getBoundingClientRect();
  return { left: (n.textDirection == we.LTR ? e.left : e.right - n.scrollDOM.clientWidth * n.scaleX) - n.scrollDOM.scrollLeft * n.scaleX, top: e.top - n.scrollDOM.scrollTop * n.scaleY };
}
function $c(n, e, t) {
  let i = $.cursor(e);
  return {
    from: Math.max(t.from, n.moveToLineBoundary(i, !1, !0).from),
    to: Math.min(t.to, n.moveToLineBoundary(i, !0, !0).from),
    type: Ke.Text
  };
}
function _y(n, e, t) {
  if (t.to <= n.viewport.from || t.from >= n.viewport.to)
    return [];
  let i = Math.max(t.from, n.viewport.from), r = Math.min(t.to, n.viewport.to), s = n.textDirection == we.LTR, o = n.contentDOM, l = o.getBoundingClientRect(), a = vm(n), h = o.querySelector(".cm-line"), u = h && window.getComputedStyle(h), c = l.left + (u ? parseInt(u.paddingLeft) + Math.min(0, parseInt(u.textIndent)) : 0), f = l.right - (u ? parseInt(u.paddingRight) : 0), d = Ra(n, i), p = Ra(n, r), m = d.type == Ke.Text ? d : null, O = p.type == Ke.Text ? p : null;
  if (m && (n.lineWrapping || d.widgetLineBreaks) && (m = $c(n, i, m)), O && (n.lineWrapping || p.widgetLineBreaks) && (O = $c(n, r, O)), m && O && m.from == O.from)
    return b(S(t.from, t.to, m));
  {
    let P = m ? S(t.from, null, m) : Q(d, !1), w = O ? S(null, t.to, O) : Q(p, !0), C = [];
    return (m || d).to < (O || p).from - (m && O ? 1 : 0) || d.widgetLineBreaks > 1 && P.bottom + n.defaultLineHeight / 2 < w.top ? C.push(g(c, P.bottom, f, w.top)) : P.bottom < w.top && n.elementAtHeight((P.bottom + w.top) / 2).type == Ke.Text && (P.bottom = w.top = (P.bottom + w.top) / 2), b(P).concat(C).concat(b(w));
  }
  function g(P, w, C, L) {
    return new jr(
      e,
      P - a.left,
      w - a.top - 0.01,
      C - P,
      L - w + 0.01
      /* C.Epsilon */
    );
  }
  function b({ top: P, bottom: w, horizontal: C }) {
    let L = [];
    for (let q = 0; q < C.length; q += 2)
      L.push(g(C[q], P, C[q + 1], w));
    return L;
  }
  function S(P, w, C) {
    let L = 1e9, q = -1e9, v = [];
    function R(W, _, G, U, se) {
      let ce = n.coordsAtPos(W, W == C.to ? -2 : 2), y = n.coordsAtPos(G, G == C.from ? 2 : -2);
      !ce || !y || (L = Math.min(ce.top, y.top, L), q = Math.max(ce.bottom, y.bottom, q), se == we.LTR ? v.push(s && _ ? c : ce.left, s && U ? f : y.right) : v.push(!s && U ? c : y.left, !s && _ ? f : ce.right));
    }
    let A = P ?? C.from, E = w ?? C.to;
    for (let W of n.visibleRanges)
      if (W.to > A && W.from < E)
        for (let _ = Math.max(W.from, A), G = Math.min(W.to, E); ; ) {
          let U = n.state.doc.lineAt(_);
          for (let se of n.bidiSpans(U)) {
            let ce = se.from + U.from, y = se.to + U.from;
            if (ce >= G)
              break;
            y > _ && R(Math.max(ce, _), P == null && ce <= A, Math.min(y, G), w == null && y >= E, se.dir);
          }
          if (_ = U.to + 1, _ >= G)
            break;
        }
    return v.length == 0 && R(A, P == null, E, w == null, n.textDirection), { top: L, bottom: q, horizontal: v };
  }
  function Q(P, w) {
    let C = l.top + (w ? P.top : P.bottom);
    return { top: C, bottom: C, horizontal: [] };
  }
}
function qy(n, e) {
  return n.constructor == e.constructor && n.eq(e);
}
class Wy {
  constructor(e, t) {
    this.view = e, this.layer = t, this.drawn = [], this.scaleX = 1, this.scaleY = 1, this.measureReq = { read: this.measure.bind(this), write: this.draw.bind(this) }, this.dom = e.scrollDOM.appendChild(document.createElement("div")), this.dom.classList.add("cm-layer"), t.above && this.dom.classList.add("cm-layer-above"), t.class && this.dom.classList.add(t.class), this.scale(), this.dom.setAttribute("aria-hidden", "true"), this.setOrder(e.state), e.requestMeasure(this.measureReq), t.mount && t.mount(this.dom, e);
  }
  update(e) {
    e.startState.facet(_s) != e.state.facet(_s) && this.setOrder(e.state), (this.layer.update(e, this.dom) || e.geometryChanged) && (this.scale(), e.view.requestMeasure(this.measureReq));
  }
  docViewUpdate(e) {
    this.layer.updateOnDocViewUpdate !== !1 && e.requestMeasure(this.measureReq);
  }
  setOrder(e) {
    let t = 0, i = e.facet(_s);
    for (; t < i.length && i[t] != this.layer; )
      t++;
    this.dom.style.zIndex = String((this.layer.above ? 150 : -1) - t);
  }
  measure() {
    return this.layer.markers(this.view);
  }
  scale() {
    let { scaleX: e, scaleY: t } = this.view;
    (e != this.scaleX || t != this.scaleY) && (this.scaleX = e, this.scaleY = t, this.dom.style.transform = `scale(${1 / e}, ${1 / t})`);
  }
  draw(e) {
    if (e.length != this.drawn.length || e.some((t, i) => !qy(t, this.drawn[i]))) {
      let t = this.dom.firstChild, i = 0;
      for (let r of e)
        r.update && t && r.constructor && this.drawn[i].constructor && r.update(t, this.drawn[i]) ? (t = t.nextSibling, i++) : this.dom.insertBefore(r.draw(), t);
      for (; t; ) {
        let r = t.nextSibling;
        t.remove(), t = r;
      }
      this.drawn = e;
    }
  }
  destroy() {
    this.layer.destroy && this.layer.destroy(this.dom, this.view), this.dom.remove();
  }
}
const _s = /* @__PURE__ */ B.define();
function Pm(n) {
  return [
    Qe.define((e) => new Wy(e, n)),
    _s.of(n)
  ];
}
const Qm = !V.ios, Qr = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, {
      cursorBlinkRate: 1200,
      drawRangeCursor: !0
    }, {
      cursorBlinkRate: (e, t) => Math.min(e, t),
      drawRangeCursor: (e, t) => e || t
    });
  }
});
function By(n = {}) {
  return [
    Qr.of(n),
    Vy,
    Yy,
    jy,
    Jp.of(!0)
  ];
}
function $m(n) {
  return n.startState.facet(Qr) != n.state.facet(Qr);
}
const Vy = /* @__PURE__ */ Pm({
  above: !0,
  markers(n) {
    let { state: e } = n, t = e.facet(Qr), i = [];
    for (let r of e.selection.ranges) {
      let s = r == e.selection.main;
      if (r.empty ? !s || Qm : t.drawRangeCursor) {
        let o = s ? "cm-cursor cm-cursor-primary" : "cm-cursor cm-cursor-secondary", l = r.empty ? r : $.cursor(r.head, r.head > r.anchor ? -1 : 1);
        for (let a of jr.forRange(n, o, l))
          i.push(a);
      }
    }
    return i;
  },
  update(n, e) {
    n.transactions.some((i) => i.selection) && (e.style.animationName = e.style.animationName == "cm-blink" ? "cm-blink2" : "cm-blink");
    let t = $m(n);
    return t && Cc(n.state, e), n.docChanged || n.selectionSet || t;
  },
  mount(n, e) {
    Cc(e.state, n);
  },
  class: "cm-cursorLayer"
});
function Cc(n, e) {
  e.style.animationDuration = n.facet(Qr).cursorBlinkRate + "ms";
}
const Yy = /* @__PURE__ */ Pm({
  above: !1,
  markers(n) {
    return n.state.selection.ranges.map((e) => e.empty ? [] : jr.forRange(n, "cm-selectionBackground", e)).reduce((e, t) => e.concat(t));
  },
  update(n, e) {
    return n.docChanged || n.selectionSet || n.viewportChanged || $m(n);
  },
  class: "cm-selectionLayer"
}), Xa = {
  ".cm-line": {
    "& ::selection": { backgroundColor: "transparent !important" },
    "&::selection": { backgroundColor: "transparent !important" }
  }
};
Qm && (Xa[".cm-line"].caretColor = "transparent !important", Xa[".cm-content"] = { caretColor: "transparent !important" });
const jy = /* @__PURE__ */ un.highest(/* @__PURE__ */ I.theme(Xa)), Cm = /* @__PURE__ */ K.define({
  map(n, e) {
    return n == null ? null : e.mapPos(n);
  }
}), hr = /* @__PURE__ */ De.define({
  create() {
    return null;
  },
  update(n, e) {
    return n != null && (n = e.changes.mapPos(n)), e.effects.reduce((t, i) => i.is(Cm) ? i.value : t, n);
  }
}), Ny = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.view = n, this.cursor = null, this.measureReq = { read: this.readPos.bind(this), write: this.drawCursor.bind(this) };
  }
  update(n) {
    var e;
    let t = n.state.field(hr);
    t == null ? this.cursor != null && ((e = this.cursor) === null || e === void 0 || e.remove(), this.cursor = null) : (this.cursor || (this.cursor = this.view.scrollDOM.appendChild(document.createElement("div")), this.cursor.className = "cm-dropCursor"), (n.startState.field(hr) != t || n.docChanged || n.geometryChanged) && this.view.requestMeasure(this.measureReq));
  }
  readPos() {
    let { view: n } = this, e = n.state.field(hr), t = e != null && n.coordsAtPos(e);
    if (!t)
      return null;
    let i = n.scrollDOM.getBoundingClientRect();
    return {
      left: t.left - i.left + n.scrollDOM.scrollLeft * n.scaleX,
      top: t.top - i.top + n.scrollDOM.scrollTop * n.scaleY,
      height: t.bottom - t.top
    };
  }
  drawCursor(n) {
    if (this.cursor) {
      let { scaleX: e, scaleY: t } = this.view;
      n ? (this.cursor.style.left = n.left / e + "px", this.cursor.style.top = n.top / t + "px", this.cursor.style.height = n.height / t + "px") : this.cursor.style.left = "-100000px";
    }
  }
  destroy() {
    this.cursor && this.cursor.remove();
  }
  setDropPos(n) {
    this.view.state.field(hr) != n && this.view.dispatch({ effects: Cm.of(n) });
  }
}, {
  eventObservers: {
    dragover(n) {
      this.setDropPos(this.view.posAtCoords({ x: n.clientX, y: n.clientY }));
    },
    dragleave(n) {
      (n.target == this.view.contentDOM || !this.view.contentDOM.contains(n.relatedTarget)) && this.setDropPos(null);
    },
    dragend() {
      this.setDropPos(null);
    },
    drop() {
      this.setDropPos(null);
    }
  }
});
function Uy() {
  return [hr, Ny];
}
function Tc(n, e, t, i, r) {
  e.lastIndex = 0;
  for (let s = n.iterRange(t, i), o = t, l; !s.next().done; o += s.value.length)
    if (!s.lineBreak)
      for (; l = e.exec(s.value); )
        r(o + l.index, l);
}
function Fy(n, e) {
  let t = n.visibleRanges;
  if (t.length == 1 && t[0].from == n.viewport.from && t[0].to == n.viewport.to)
    return t;
  let i = [];
  for (let { from: r, to: s } of t)
    r = Math.max(n.state.doc.lineAt(r).from, r - e), s = Math.min(n.state.doc.lineAt(s).to, s + e), i.length && i[i.length - 1].to >= r ? i[i.length - 1].to = s : i.push({ from: r, to: s });
  return i;
}
class Gy {
  /**
  Create a decorator.
  */
  constructor(e) {
    const { regexp: t, decoration: i, decorate: r, boundary: s, maxLength: o = 1e3 } = e;
    if (!t.global)
      throw new RangeError("The regular expression given to MatchDecorator should have its 'g' flag set");
    if (this.regexp = t, r)
      this.addMatch = (l, a, h, u) => r(u, h, h + l[0].length, l, a);
    else if (typeof i == "function")
      this.addMatch = (l, a, h, u) => {
        let c = i(l, a, h);
        c && u(h, h + l[0].length, c);
      };
    else if (i)
      this.addMatch = (l, a, h, u) => u(h, h + l[0].length, i);
    else
      throw new RangeError("Either 'decorate' or 'decoration' should be provided to MatchDecorator");
    this.boundary = s, this.maxLength = o;
  }
  /**
  Compute the full set of decorations for matches in the given
  view's viewport. You'll want to call this when initializing your
  plugin.
  */
  createDeco(e) {
    let t = new $n(), i = t.add.bind(t);
    for (let { from: r, to: s } of Fy(e, this.maxLength))
      Tc(e.state.doc, this.regexp, r, s, (o, l) => this.addMatch(l, e, o, i));
    return t.finish();
  }
  /**
  Update a set of decorations for a view update. `deco` _must_ be
  the set of decorations produced by _this_ `MatchDecorator` for
  the view state before the update.
  */
  updateDeco(e, t) {
    let i = 1e9, r = -1;
    return e.docChanged && e.changes.iterChanges((s, o, l, a) => {
      a > e.view.viewport.from && l < e.view.viewport.to && (i = Math.min(l, i), r = Math.max(a, r));
    }), e.viewportChanged || r - i > 1e3 ? this.createDeco(e.view) : r > -1 ? this.updateRange(e.view, t.map(e.changes), i, r) : t;
  }
  updateRange(e, t, i, r) {
    for (let s of e.visibleRanges) {
      let o = Math.max(s.from, i), l = Math.min(s.to, r);
      if (l > o) {
        let a = e.state.doc.lineAt(o), h = a.to < l ? e.state.doc.lineAt(l) : a, u = Math.max(s.from, a.from), c = Math.min(s.to, h.to);
        if (this.boundary) {
          for (; o > a.from; o--)
            if (this.boundary.test(a.text[o - 1 - a.from])) {
              u = o;
              break;
            }
          for (; l < h.to; l++)
            if (this.boundary.test(h.text[l - h.from])) {
              c = l;
              break;
            }
        }
        let f = [], d, p = (m, O, g) => f.push(g.range(m, O));
        if (a == h)
          for (this.regexp.lastIndex = u - a.from; (d = this.regexp.exec(a.text)) && d.index < c - a.from; )
            this.addMatch(d, e, d.index + a.from, p);
        else
          Tc(e.state.doc, this.regexp, u, c, (m, O) => this.addMatch(O, e, m, p));
        t = t.update({ filterFrom: u, filterTo: c, filter: (m, O) => m < u || O > c, add: f });
      }
    }
    return t;
  }
}
const Da = /x/.unicode != null ? "gu" : "g", Hy = /* @__PURE__ */ new RegExp(`[\0-\b
--­؜​‎‏\u2028\u2029‭‮⁦⁧⁩\uFEFF￹-￼]`, Da), Ky = {
  0: "null",
  7: "bell",
  8: "backspace",
  10: "newline",
  11: "vertical tab",
  13: "carriage return",
  27: "escape",
  8203: "zero width space",
  8204: "zero width non-joiner",
  8205: "zero width joiner",
  8206: "left-to-right mark",
  8207: "right-to-left mark",
  8232: "line separator",
  8237: "left-to-right override",
  8238: "right-to-left override",
  8294: "left-to-right isolate",
  8295: "right-to-left isolate",
  8297: "pop directional isolate",
  8233: "paragraph separator",
  65279: "zero width no-break space",
  65532: "object replacement"
};
let fl = null;
function Jy() {
  var n;
  if (fl == null && typeof document < "u" && document.body) {
    let e = document.body.style;
    fl = ((n = e.tabSize) !== null && n !== void 0 ? n : e.MozTabSize) != null;
  }
  return fl || !1;
}
const qs = /* @__PURE__ */ B.define({
  combine(n) {
    let e = Ht(n, {
      render: null,
      specialChars: Hy,
      addSpecialChars: null
    });
    return (e.replaceTabs = !Jy()) && (e.specialChars = new RegExp("	|" + e.specialChars.source, Da)), e.addSpecialChars && (e.specialChars = new RegExp(e.specialChars.source + "|" + e.addSpecialChars.source, Da)), e;
  }
});
function ek(n = {}) {
  return [qs.of(n), tk()];
}
let Ac = null;
function tk() {
  return Ac || (Ac = Qe.fromClass(class {
    constructor(n) {
      this.view = n, this.decorations = j.none, this.decorationCache = /* @__PURE__ */ Object.create(null), this.decorator = this.makeDecorator(n.state.facet(qs)), this.decorations = this.decorator.createDeco(n);
    }
    makeDecorator(n) {
      return new Gy({
        regexp: n.specialChars,
        decoration: (e, t, i) => {
          let { doc: r } = t.state, s = Ie(e[0], 0);
          if (s == 9) {
            let o = r.lineAt(i), l = t.state.tabSize, a = Mt(o.text, l, i - o.from);
            return j.replace({
              widget: new sk((l - a % l) * this.view.defaultCharacterWidth / this.view.scaleX)
            });
          }
          return this.decorationCache[s] || (this.decorationCache[s] = j.replace({ widget: new rk(n, s) }));
        },
        boundary: n.replaceTabs ? void 0 : /[^]/
      });
    }
    update(n) {
      let e = n.state.facet(qs);
      n.startState.facet(qs) != e ? (this.decorator = this.makeDecorator(e), this.decorations = this.decorator.createDeco(n.view)) : this.decorations = this.decorator.updateDeco(n, this.decorations);
    }
  }, {
    decorations: (n) => n.decorations
  }));
}
const nk = "•";
function ik(n) {
  return n >= 32 ? nk : n == 10 ? "␤" : String.fromCharCode(9216 + n);
}
class rk extends Kt {
  constructor(e, t) {
    super(), this.options = e, this.code = t;
  }
  eq(e) {
    return e.code == this.code;
  }
  toDOM(e) {
    let t = ik(this.code), i = e.state.phrase("Control character") + " " + (Ky[this.code] || "0x" + this.code.toString(16)), r = this.options.render && this.options.render(this.code, i, t);
    if (r)
      return r;
    let s = document.createElement("span");
    return s.textContent = t, s.title = i, s.setAttribute("aria-label", i), s.className = "cm-specialChar", s;
  }
  ignoreEvent() {
    return !1;
  }
}
class sk extends Kt {
  constructor(e) {
    super(), this.width = e;
  }
  eq(e) {
    return e.width == this.width;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.textContent = "	", e.className = "cm-tab", e.style.width = this.width + "px", e;
  }
  ignoreEvent() {
    return !1;
  }
}
function ok() {
  return ak;
}
const lk = /* @__PURE__ */ j.line({ class: "cm-activeLine" }), ak = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.docChanged || n.selectionSet) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = -1, t = [];
    for (let i of n.state.selection.ranges) {
      let r = n.lineBlockAt(i.head);
      r.from > e && (t.push(lk.range(r.from)), e = r.from);
    }
    return j.set(t);
  }
}, {
  decorations: (n) => n.decorations
});
class hk extends Kt {
  constructor(e) {
    super(), this.content = e;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.className = "cm-placeholder", e.style.pointerEvents = "none", e.appendChild(typeof this.content == "string" ? document.createTextNode(this.content) : this.content), typeof this.content == "string" ? e.setAttribute("aria-label", "placeholder " + this.content) : e.setAttribute("aria-hidden", "true"), e;
  }
  coordsAt(e) {
    let t = e.firstChild ? vi(e.firstChild) : [];
    if (!t.length)
      return null;
    let i = window.getComputedStyle(e.parentNode), r = Xo(t[0], i.direction != "rtl"), s = parseInt(i.lineHeight);
    return r.bottom - r.top > s * 1.5 ? { left: r.left, right: r.right, top: r.top, bottom: r.top + s } : r;
  }
  ignoreEvent() {
    return !1;
  }
}
function uk(n) {
  return Qe.fromClass(class {
    constructor(e) {
      this.view = e, this.placeholder = n ? j.set([j.widget({ widget: new hk(n), side: 1 }).range(0)]) : j.none;
    }
    get decorations() {
      return this.view.state.doc.length ? j.none : this.placeholder;
    }
  }, { decorations: (e) => e.decorations });
}
const La = 2e3;
function ck(n, e, t) {
  let i = Math.min(e.line, t.line), r = Math.max(e.line, t.line), s = [];
  if (e.off > La || t.off > La || e.col < 0 || t.col < 0) {
    let o = Math.min(e.off, t.off), l = Math.max(e.off, t.off);
    for (let a = i; a <= r; a++) {
      let h = n.doc.line(a);
      h.length <= l && s.push($.range(h.from + o, h.to + l));
    }
  } else {
    let o = Math.min(e.col, t.col), l = Math.max(e.col, t.col);
    for (let a = i; a <= r; a++) {
      let h = n.doc.line(a), u = Oa(h.text, o, n.tabSize, !0);
      if (u < 0)
        s.push($.cursor(h.to));
      else {
        let c = Oa(h.text, l, n.tabSize);
        s.push($.range(h.from + u, h.from + c));
      }
    }
  }
  return s;
}
function fk(n, e) {
  let t = n.coordsAtPos(n.viewport.from);
  return t ? Math.round(Math.abs((t.left - e) / n.defaultCharacterWidth)) : -1;
}
function Rc(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), i = n.state.doc.lineAt(t), r = t - i.from, s = r > La ? -1 : r == i.length ? fk(n, e.clientX) : Mt(i.text, n.state.tabSize, t - i.from);
  return { line: i.number, col: s, off: r };
}
function dk(n, e) {
  let t = Rc(n, e), i = n.state.selection;
  return t ? {
    update(r) {
      if (r.docChanged) {
        let s = r.changes.mapPos(r.startState.doc.line(t.line).from), o = r.state.doc.lineAt(s);
        t = { line: o.number, col: t.col, off: Math.min(t.off, o.length) }, i = i.map(r.changes);
      }
    },
    get(r, s, o) {
      let l = Rc(n, r);
      if (!l)
        return i;
      let a = ck(n.state, t, l);
      return a.length ? o ? $.create(a.concat(i.ranges)) : $.create(a) : i;
    }
  } : null;
}
function pk(n) {
  let e = (t) => t.altKey && t.button == 0;
  return I.mouseSelectionStyle.of((t, i) => e(i) ? dk(t, i) : null);
}
const mk = {
  Alt: [18, (n) => !!n.altKey],
  Control: [17, (n) => !!n.ctrlKey],
  Shift: [16, (n) => !!n.shiftKey],
  Meta: [91, (n) => !!n.metaKey]
}, Ok = { style: "cursor: crosshair" };
function gk(n = {}) {
  let [e, t] = mk[n.key || "Alt"], i = Qe.fromClass(class {
    constructor(r) {
      this.view = r, this.isDown = !1;
    }
    set(r) {
      this.isDown != r && (this.isDown = r, this.view.update([]));
    }
  }, {
    eventObservers: {
      keydown(r) {
        this.set(r.keyCode == e || t(r));
      },
      keyup(r) {
        (r.keyCode == e || !t(r)) && this.set(!1);
      },
      mousemove(r) {
        this.set(t(r));
      }
    }
  });
  return [
    i,
    I.contentAttributes.of((r) => {
      var s;
      return !((s = r.plugin(i)) === null || s === void 0) && s.isDown ? Ok : null;
    })
  ];
}
const Fi = "-10000px";
class Tm {
  constructor(e, t, i, r) {
    this.facet = t, this.createTooltipView = i, this.removeTooltipView = r, this.input = e.state.facet(t), this.tooltips = this.input.filter((o) => o);
    let s = null;
    this.tooltipViews = this.tooltips.map((o) => s = i(o, s));
  }
  update(e, t) {
    var i;
    let r = e.state.facet(this.facet), s = r.filter((a) => a);
    if (r === this.input) {
      for (let a of this.tooltipViews)
        a.update && a.update(e);
      return !1;
    }
    let o = [], l = t ? [] : null;
    for (let a = 0; a < s.length; a++) {
      let h = s[a], u = -1;
      if (h) {
        for (let c = 0; c < this.tooltips.length; c++) {
          let f = this.tooltips[c];
          f && f.create == h.create && (u = c);
        }
        if (u < 0)
          o[a] = this.createTooltipView(h, a ? o[a - 1] : null), l && (l[a] = !!h.above);
        else {
          let c = o[a] = this.tooltipViews[u];
          l && (l[a] = t[u]), c.update && c.update(e);
        }
      }
    }
    for (let a of this.tooltipViews)
      o.indexOf(a) < 0 && (this.removeTooltipView(a), (i = a.destroy) === null || i === void 0 || i.call(a));
    return t && (l.forEach((a, h) => t[h] = a), t.length = l.length), this.input = r, this.tooltips = s, this.tooltipViews = o, !0;
  }
}
function bk(n) {
  let { win: e } = n;
  return { top: 0, left: 0, bottom: e.innerHeight, right: e.innerWidth };
}
const dl = /* @__PURE__ */ B.define({
  combine: (n) => {
    var e, t, i;
    return {
      position: V.ios ? "absolute" : ((e = n.find((r) => r.position)) === null || e === void 0 ? void 0 : e.position) || "fixed",
      parent: ((t = n.find((r) => r.parent)) === null || t === void 0 ? void 0 : t.parent) || null,
      tooltipSpace: ((i = n.find((r) => r.tooltipSpace)) === null || i === void 0 ? void 0 : i.tooltipSpace) || bk
    };
  }
}), Zc = /* @__PURE__ */ new WeakMap(), Mh = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.view = n, this.above = [], this.inView = !0, this.madeAbsolute = !1, this.lastTransaction = 0, this.measureTimeout = -1;
    let e = n.state.facet(dl);
    this.position = e.position, this.parent = e.parent, this.classes = n.themeClasses, this.createContainer(), this.measureReq = { read: this.readMeasure.bind(this), write: this.writeMeasure.bind(this), key: this }, this.resizeObserver = typeof ResizeObserver == "function" ? new ResizeObserver(() => this.measureSoon()) : null, this.manager = new Tm(n, Eh, (t, i) => this.createTooltip(t, i), (t) => {
      this.resizeObserver && this.resizeObserver.unobserve(t.dom), t.dom.remove();
    }), this.above = this.manager.tooltips.map((t) => !!t.above), this.intersectionObserver = typeof IntersectionObserver == "function" ? new IntersectionObserver((t) => {
      Date.now() > this.lastTransaction - 50 && t.length > 0 && t[t.length - 1].intersectionRatio < 1 && this.measureSoon();
    }, { threshold: [1] }) : null, this.observeIntersection(), n.win.addEventListener("resize", this.measureSoon = this.measureSoon.bind(this)), this.maybeMeasure();
  }
  createContainer() {
    this.parent ? (this.container = document.createElement("div"), this.container.style.position = "relative", this.container.className = this.view.themeClasses, this.parent.appendChild(this.container)) : this.container = this.view.dom;
  }
  observeIntersection() {
    if (this.intersectionObserver) {
      this.intersectionObserver.disconnect();
      for (let n of this.manager.tooltipViews)
        this.intersectionObserver.observe(n.dom);
    }
  }
  measureSoon() {
    this.measureTimeout < 0 && (this.measureTimeout = setTimeout(() => {
      this.measureTimeout = -1, this.maybeMeasure();
    }, 50));
  }
  update(n) {
    n.transactions.length && (this.lastTransaction = Date.now());
    let e = this.manager.update(n, this.above);
    e && this.observeIntersection();
    let t = e || n.geometryChanged, i = n.state.facet(dl);
    if (i.position != this.position && !this.madeAbsolute) {
      this.position = i.position;
      for (let r of this.manager.tooltipViews)
        r.dom.style.position = this.position;
      t = !0;
    }
    if (i.parent != this.parent) {
      this.parent && this.container.remove(), this.parent = i.parent, this.createContainer();
      for (let r of this.manager.tooltipViews)
        this.container.appendChild(r.dom);
      t = !0;
    } else
      this.parent && this.view.themeClasses != this.classes && (this.classes = this.container.className = this.view.themeClasses);
    t && this.maybeMeasure();
  }
  createTooltip(n, e) {
    let t = n.create(this.view), i = e ? e.dom : null;
    if (t.dom.classList.add("cm-tooltip"), n.arrow && !t.dom.querySelector(".cm-tooltip > .cm-tooltip-arrow")) {
      let r = document.createElement("div");
      r.className = "cm-tooltip-arrow", t.dom.appendChild(r);
    }
    return t.dom.style.position = this.position, t.dom.style.top = Fi, t.dom.style.left = "0px", this.container.insertBefore(t.dom, i), t.mount && t.mount(this.view), this.resizeObserver && this.resizeObserver.observe(t.dom), t;
  }
  destroy() {
    var n, e, t;
    this.view.win.removeEventListener("resize", this.measureSoon);
    for (let i of this.manager.tooltipViews)
      i.dom.remove(), (n = i.destroy) === null || n === void 0 || n.call(i);
    this.parent && this.container.remove(), (e = this.resizeObserver) === null || e === void 0 || e.disconnect(), (t = this.intersectionObserver) === null || t === void 0 || t.disconnect(), clearTimeout(this.measureTimeout);
  }
  readMeasure() {
    let n = this.view.dom.getBoundingClientRect(), e = 1, t = 1, i = !1;
    if (this.position == "fixed" && this.manager.tooltipViews.length) {
      let { dom: r } = this.manager.tooltipViews[0];
      if (V.gecko)
        i = r.offsetParent != this.container.ownerDocument.body;
      else if (r.style.top == Fi && r.style.left == "0px") {
        let s = r.getBoundingClientRect();
        i = Math.abs(s.top + 1e4) > 1 || Math.abs(s.left) > 1;
      }
    }
    if (i || this.position == "absolute")
      if (this.parent) {
        let r = this.parent.getBoundingClientRect();
        r.width && r.height && (e = r.width / this.parent.offsetWidth, t = r.height / this.parent.offsetHeight);
      } else
        ({ scaleX: e, scaleY: t } = this.view.viewState);
    return {
      editor: n,
      parent: this.parent ? this.container.getBoundingClientRect() : n,
      pos: this.manager.tooltips.map((r, s) => {
        let o = this.manager.tooltipViews[s];
        return o.getCoords ? o.getCoords(r.pos) : this.view.coordsAtPos(r.pos);
      }),
      size: this.manager.tooltipViews.map(({ dom: r }) => r.getBoundingClientRect()),
      space: this.view.state.facet(dl).tooltipSpace(this.view),
      scaleX: e,
      scaleY: t,
      makeAbsolute: i
    };
  }
  writeMeasure(n) {
    var e;
    if (n.makeAbsolute) {
      this.madeAbsolute = !0, this.position = "absolute";
      for (let l of this.manager.tooltipViews)
        l.dom.style.position = "absolute";
    }
    let { editor: t, space: i, scaleX: r, scaleY: s } = n, o = [];
    for (let l = 0; l < this.manager.tooltips.length; l++) {
      let a = this.manager.tooltips[l], h = this.manager.tooltipViews[l], { dom: u } = h, c = n.pos[l], f = n.size[l];
      if (!c || c.bottom <= Math.max(t.top, i.top) || c.top >= Math.min(t.bottom, i.bottom) || c.right < Math.max(t.left, i.left) - 0.1 || c.left > Math.min(t.right, i.right) + 0.1) {
        u.style.top = Fi;
        continue;
      }
      let d = a.arrow ? h.dom.querySelector(".cm-tooltip-arrow") : null, p = d ? 7 : 0, m = f.right - f.left, O = (e = Zc.get(h)) !== null && e !== void 0 ? e : f.bottom - f.top, g = h.offset || kk, b = this.view.textDirection == we.LTR, S = f.width > i.right - i.left ? b ? i.left : i.right - f.width : b ? Math.min(c.left - (d ? 14 : 0) + g.x, i.right - m) : Math.max(i.left, c.left - m + (d ? 14 : 0) - g.x), Q = this.above[l];
      !a.strictSide && (Q ? c.top - (f.bottom - f.top) - g.y < i.top : c.bottom + (f.bottom - f.top) + g.y > i.bottom) && Q == i.bottom - c.bottom > c.top - i.top && (Q = this.above[l] = !Q);
      let P = (Q ? c.top - i.top : i.bottom - c.bottom) - p;
      if (P < O && h.resize !== !1) {
        if (P < this.view.defaultLineHeight) {
          u.style.top = Fi;
          continue;
        }
        Zc.set(h, O), u.style.height = (O = P) / s + "px";
      } else
        u.style.height && (u.style.height = "");
      let w = Q ? c.top - O - p - g.y : c.bottom + p + g.y, C = S + m;
      if (h.overlap !== !0)
        for (let L of o)
          L.left < C && L.right > S && L.top < w + O && L.bottom > w && (w = Q ? L.top - O - 2 - p : L.bottom + p + 2);
      if (this.position == "absolute" ? (u.style.top = (w - n.parent.top) / s + "px", u.style.left = (S - n.parent.left) / r + "px") : (u.style.top = w / s + "px", u.style.left = S / r + "px"), d) {
        let L = c.left + (b ? g.x : -g.x) - (S + 14 - 7);
        d.style.left = L / r + "px";
      }
      h.overlap !== !0 && o.push({ left: S, top: w, right: C, bottom: w + O }), u.classList.toggle("cm-tooltip-above", Q), u.classList.toggle("cm-tooltip-below", !Q), h.positioned && h.positioned(n.space);
    }
  }
  maybeMeasure() {
    if (this.manager.tooltips.length && (this.view.inView && this.view.requestMeasure(this.measureReq), this.inView != this.view.inView && (this.inView = this.view.inView, !this.inView)))
      for (let n of this.manager.tooltipViews)
        n.dom.style.top = Fi;
  }
}, {
  eventObservers: {
    scroll() {
      this.maybeMeasure();
    }
  }
}), yk = /* @__PURE__ */ I.baseTheme({
  ".cm-tooltip": {
    zIndex: 100,
    boxSizing: "border-box"
  },
  "&light .cm-tooltip": {
    border: "1px solid #bbb",
    backgroundColor: "#f5f5f5"
  },
  "&light .cm-tooltip-section:not(:first-child)": {
    borderTop: "1px solid #bbb"
  },
  "&dark .cm-tooltip": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tooltip-arrow": {
    height: "7px",
    width: `${7 * 2}px`,
    position: "absolute",
    zIndex: -1,
    overflow: "hidden",
    "&:before, &:after": {
      content: "''",
      position: "absolute",
      width: 0,
      height: 0,
      borderLeft: "7px solid transparent",
      borderRight: "7px solid transparent"
    },
    ".cm-tooltip-above &": {
      bottom: "-7px",
      "&:before": {
        borderTop: "7px solid #bbb"
      },
      "&:after": {
        borderTop: "7px solid #f5f5f5",
        bottom: "1px"
      }
    },
    ".cm-tooltip-below &": {
      top: "-7px",
      "&:before": {
        borderBottom: "7px solid #bbb"
      },
      "&:after": {
        borderBottom: "7px solid #f5f5f5",
        top: "1px"
      }
    }
  },
  "&dark .cm-tooltip .cm-tooltip-arrow": {
    "&:before": {
      borderTopColor: "#333338",
      borderBottomColor: "#333338"
    },
    "&:after": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    }
  }
}), kk = { x: 0, y: 0 }, Eh = /* @__PURE__ */ B.define({
  enables: [Mh, yk]
}), io = /* @__PURE__ */ B.define({
  combine: (n) => n.reduce((e, t) => e.concat(t), [])
});
class Io {
  // Needs to be static so that host tooltip instances always match
  static create(e) {
    return new Io(e);
  }
  constructor(e) {
    this.view = e, this.mounted = !1, this.dom = document.createElement("div"), this.dom.classList.add("cm-tooltip-hover"), this.manager = new Tm(e, io, (t, i) => this.createHostedView(t, i), (t) => t.dom.remove());
  }
  createHostedView(e, t) {
    let i = e.create(this.view);
    return i.dom.classList.add("cm-tooltip-section"), this.dom.insertBefore(i.dom, t ? t.dom.nextSibling : this.dom.firstChild), this.mounted && i.mount && i.mount(this.view), i;
  }
  mount(e) {
    for (let t of this.manager.tooltipViews)
      t.mount && t.mount(e);
    this.mounted = !0;
  }
  positioned(e) {
    for (let t of this.manager.tooltipViews)
      t.positioned && t.positioned(e);
  }
  update(e) {
    this.manager.update(e);
  }
  destroy() {
    var e;
    for (let t of this.manager.tooltipViews)
      (e = t.destroy) === null || e === void 0 || e.call(t);
  }
  passProp(e) {
    let t;
    for (let i of this.manager.tooltipViews) {
      let r = i[e];
      if (r !== void 0) {
        if (t === void 0)
          t = r;
        else if (t !== r)
          return;
      }
    }
    return t;
  }
  get offset() {
    return this.passProp("offset");
  }
  get getCoords() {
    return this.passProp("getCoords");
  }
  get overlap() {
    return this.passProp("overlap");
  }
  get resize() {
    return this.passProp("resize");
  }
}
const xk = /* @__PURE__ */ Eh.compute([io], (n) => {
  let e = n.facet(io);
  return e.length === 0 ? null : {
    pos: Math.min(...e.map((t) => t.pos)),
    end: Math.max(...e.map((t) => {
      var i;
      return (i = t.end) !== null && i !== void 0 ? i : t.pos;
    })),
    create: Io.create,
    above: e[0].above,
    arrow: e.some((t) => t.arrow)
  };
});
class wk {
  constructor(e, t, i, r, s) {
    this.view = e, this.source = t, this.field = i, this.setHover = r, this.hoverTime = s, this.hoverTimeout = -1, this.restartTimeout = -1, this.pending = null, this.lastMove = { x: 0, y: 0, target: e.dom, time: 0 }, this.checkHover = this.checkHover.bind(this), e.dom.addEventListener("mouseleave", this.mouseleave = this.mouseleave.bind(this)), e.dom.addEventListener("mousemove", this.mousemove = this.mousemove.bind(this));
  }
  update() {
    this.pending && (this.pending = null, clearTimeout(this.restartTimeout), this.restartTimeout = setTimeout(() => this.startHover(), 20));
  }
  get active() {
    return this.view.state.field(this.field);
  }
  checkHover() {
    if (this.hoverTimeout = -1, this.active.length)
      return;
    let e = Date.now() - this.lastMove.time;
    e < this.hoverTime ? this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime - e) : this.startHover();
  }
  startHover() {
    clearTimeout(this.restartTimeout);
    let { view: e, lastMove: t } = this, i = e.docView.nearest(t.target);
    if (!i)
      return;
    let r, s = 1;
    if (i instanceof kn)
      r = i.posAtStart;
    else {
      if (r = e.posAtCoords(t), r == null)
        return;
      let l = e.coordsAtPos(r);
      if (!l || t.y < l.top || t.y > l.bottom || t.x < l.left - e.defaultCharacterWidth || t.x > l.right + e.defaultCharacterWidth)
        return;
      let a = e.bidiSpans(e.state.doc.lineAt(r)).find((u) => u.from <= r && u.to >= r), h = a && a.dir == we.RTL ? -1 : 1;
      s = t.x < l.left ? -h : h;
    }
    let o = this.source(e, r, s);
    if (o != null && o.then) {
      let l = this.pending = { pos: r };
      o.then((a) => {
        this.pending == l && (this.pending = null, a && !(Array.isArray(a) && !a.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(a) ? a : [a]) }));
      }, (a) => it(e.state, a, "hover tooltip"));
    } else
      o && !(Array.isArray(o) && !o.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(o) ? o : [o]) });
  }
  get tooltip() {
    let e = this.view.plugin(Mh), t = e ? e.manager.tooltips.findIndex((i) => i.create == Io.create) : -1;
    return t > -1 ? e.manager.tooltipViews[t] : null;
  }
  mousemove(e) {
    var t, i;
    this.lastMove = { x: e.clientX, y: e.clientY, target: e.target, time: Date.now() }, this.hoverTimeout < 0 && (this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime));
    let { active: r, tooltip: s } = this;
    if (r.length && s && !Sk(s.dom, e) || this.pending) {
      let { pos: o } = r[0] || this.pending, l = (i = (t = r[0]) === null || t === void 0 ? void 0 : t.end) !== null && i !== void 0 ? i : o;
      (o == l ? this.view.posAtCoords(this.lastMove) != o : !vk(this.view, o, l, e.clientX, e.clientY)) && (this.view.dispatch({ effects: this.setHover.of([]) }), this.pending = null);
    }
  }
  mouseleave(e) {
    clearTimeout(this.hoverTimeout), this.hoverTimeout = -1;
    let { active: t } = this;
    if (t.length) {
      let { tooltip: i } = this;
      i && i.dom.contains(e.relatedTarget) ? this.watchTooltipLeave(i.dom) : this.view.dispatch({ effects: this.setHover.of([]) });
    }
  }
  watchTooltipLeave(e) {
    let t = (i) => {
      e.removeEventListener("mouseleave", t), this.active.length && !this.view.dom.contains(i.relatedTarget) && this.view.dispatch({ effects: this.setHover.of([]) });
    };
    e.addEventListener("mouseleave", t);
  }
  destroy() {
    clearTimeout(this.hoverTimeout), this.view.dom.removeEventListener("mouseleave", this.mouseleave), this.view.dom.removeEventListener("mousemove", this.mousemove);
  }
}
const ds = 4;
function Sk(n, e) {
  let t = n.getBoundingClientRect();
  return e.clientX >= t.left - ds && e.clientX <= t.right + ds && e.clientY >= t.top - ds && e.clientY <= t.bottom + ds;
}
function vk(n, e, t, i, r, s) {
  let o = n.scrollDOM.getBoundingClientRect(), l = n.documentTop + n.documentPadding.top + n.contentHeight;
  if (o.left > i || o.right < i || o.top > r || Math.min(o.bottom, l) < r)
    return !1;
  let a = n.posAtCoords({ x: i, y: r }, !1);
  return a >= e && a <= t;
}
function Pk(n, e = {}) {
  let t = K.define(), i = De.define({
    create() {
      return [];
    },
    update(r, s) {
      if (r.length && (e.hideOnChange && (s.docChanged || s.selection) ? r = [] : e.hideOn && (r = r.filter((o) => !e.hideOn(s, o))), s.docChanged)) {
        let o = [];
        for (let l of r) {
          let a = s.changes.mapPos(l.pos, -1, qe.TrackDel);
          if (a != null) {
            let h = Object.assign(/* @__PURE__ */ Object.create(null), l);
            h.pos = a, h.end != null && (h.end = s.changes.mapPos(h.end)), o.push(h);
          }
        }
        r = o;
      }
      for (let o of s.effects)
        o.is(t) && (r = o.value), o.is(Qk) && (r = []);
      return r;
    },
    provide: (r) => io.from(r)
  });
  return [
    i,
    Qe.define((r) => new wk(
      r,
      n,
      i,
      t,
      e.hoverTime || 300
      /* Hover.Time */
    )),
    xk
  ];
}
function Am(n, e) {
  let t = n.plugin(Mh);
  if (!t)
    return null;
  let i = t.manager.tooltips.indexOf(e);
  return i < 0 ? null : t.manager.tooltipViews[i];
}
const Qk = /* @__PURE__ */ K.define(), Mc = /* @__PURE__ */ B.define({
  combine(n) {
    let e, t;
    for (let i of n)
      e = e || i.topContainer, t = t || i.bottomContainer;
    return { topContainer: e, bottomContainer: t };
  }
});
function $r(n, e) {
  let t = n.plugin(Rm), i = t ? t.specs.indexOf(e) : -1;
  return i > -1 ? t.panels[i] : null;
}
const Rm = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.input = n.state.facet(Cr), this.specs = this.input.filter((t) => t), this.panels = this.specs.map((t) => t(n));
    let e = n.state.facet(Mc);
    this.top = new ps(n, !0, e.topContainer), this.bottom = new ps(n, !1, e.bottomContainer), this.top.sync(this.panels.filter((t) => t.top)), this.bottom.sync(this.panels.filter((t) => !t.top));
    for (let t of this.panels)
      t.dom.classList.add("cm-panel"), t.mount && t.mount();
  }
  update(n) {
    let e = n.state.facet(Mc);
    this.top.container != e.topContainer && (this.top.sync([]), this.top = new ps(n.view, !0, e.topContainer)), this.bottom.container != e.bottomContainer && (this.bottom.sync([]), this.bottom = new ps(n.view, !1, e.bottomContainer)), this.top.syncClasses(), this.bottom.syncClasses();
    let t = n.state.facet(Cr);
    if (t != this.input) {
      let i = t.filter((a) => a), r = [], s = [], o = [], l = [];
      for (let a of i) {
        let h = this.specs.indexOf(a), u;
        h < 0 ? (u = a(n.view), l.push(u)) : (u = this.panels[h], u.update && u.update(n)), r.push(u), (u.top ? s : o).push(u);
      }
      this.specs = i, this.panels = r, this.top.sync(s), this.bottom.sync(o);
      for (let a of l)
        a.dom.classList.add("cm-panel"), a.mount && a.mount();
    } else
      for (let i of this.panels)
        i.update && i.update(n);
  }
  destroy() {
    this.top.sync([]), this.bottom.sync([]);
  }
}, {
  provide: (n) => I.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return t && { top: t.top.scrollMargin(), bottom: t.bottom.scrollMargin() };
  })
});
class ps {
  constructor(e, t, i) {
    this.view = e, this.top = t, this.container = i, this.dom = void 0, this.classes = "", this.panels = [], this.syncClasses();
  }
  sync(e) {
    for (let t of this.panels)
      t.destroy && e.indexOf(t) < 0 && t.destroy();
    this.panels = e, this.syncDOM();
  }
  syncDOM() {
    if (this.panels.length == 0) {
      this.dom && (this.dom.remove(), this.dom = void 0);
      return;
    }
    if (!this.dom) {
      this.dom = document.createElement("div"), this.dom.className = this.top ? "cm-panels cm-panels-top" : "cm-panels cm-panels-bottom", this.dom.style[this.top ? "top" : "bottom"] = "0";
      let t = this.container || this.view.dom;
      t.insertBefore(this.dom, this.top ? t.firstChild : null);
    }
    let e = this.dom.firstChild;
    for (let t of this.panels)
      if (t.dom.parentNode == this.dom) {
        for (; e != t.dom; )
          e = Ec(e);
        e = e.nextSibling;
      } else
        this.dom.insertBefore(t.dom, e);
    for (; e; )
      e = Ec(e);
  }
  scrollMargin() {
    return !this.dom || this.container ? 0 : Math.max(0, this.top ? this.dom.getBoundingClientRect().bottom - Math.max(0, this.view.scrollDOM.getBoundingClientRect().top) : Math.min(innerHeight, this.view.scrollDOM.getBoundingClientRect().bottom) - this.dom.getBoundingClientRect().top);
  }
  syncClasses() {
    if (!(!this.container || this.classes == this.view.themeClasses)) {
      for (let e of this.classes.split(" "))
        e && this.container.classList.remove(e);
      for (let e of (this.classes = this.view.themeClasses).split(" "))
        e && this.container.classList.add(e);
    }
  }
}
function Ec(n) {
  let e = n.nextSibling;
  return n.remove(), e;
}
const Cr = /* @__PURE__ */ B.define({
  enables: Rm
});
class hn extends Un {
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  Compare this marker to another marker of the same type.
  */
  eq(e) {
    return !1;
  }
  /**
  Called if the marker has a `toDOM` method and its representation
  was removed from a gutter.
  */
  destroy(e) {
  }
}
hn.prototype.elementClass = "";
hn.prototype.toDOM = void 0;
hn.prototype.mapMode = qe.TrackBefore;
hn.prototype.startSide = hn.prototype.endSide = -1;
hn.prototype.point = !0;
const Ws = /* @__PURE__ */ B.define(), $k = {
  class: "",
  renderEmptyElements: !1,
  elementStyle: "",
  markers: () => oe.empty,
  lineMarker: () => null,
  widgetMarker: () => null,
  lineMarkerChange: null,
  initialSpacer: null,
  updateSpacer: null,
  domEventHandlers: {}
}, Or = /* @__PURE__ */ B.define();
function Ck(n) {
  return [Zm(), Or.of(Object.assign(Object.assign({}, $k), n))];
}
const zc = /* @__PURE__ */ B.define({
  combine: (n) => n.some((e) => e)
});
function Zm(n) {
  return [
    Tk
  ];
}
const Tk = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.view = n, this.prevViewport = n.viewport, this.dom = document.createElement("div"), this.dom.className = "cm-gutters", this.dom.setAttribute("aria-hidden", "true"), this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px", this.gutters = n.state.facet(Or).map((e) => new Dc(n, e));
    for (let e of this.gutters)
      this.dom.appendChild(e.dom);
    this.fixed = !n.state.facet(zc), this.fixed && (this.dom.style.position = "sticky"), this.syncGutters(!1), n.scrollDOM.insertBefore(this.dom, n.contentDOM);
  }
  update(n) {
    if (this.updateGutters(n)) {
      let e = this.prevViewport, t = n.view.viewport, i = Math.min(e.to, t.to) - Math.max(e.from, t.from);
      this.syncGutters(i < (t.to - t.from) * 0.8);
    }
    n.geometryChanged && (this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px"), this.view.state.facet(zc) != !this.fixed && (this.fixed = !this.fixed, this.dom.style.position = this.fixed ? "sticky" : ""), this.prevViewport = n.view.viewport;
  }
  syncGutters(n) {
    let e = this.dom.nextSibling;
    n && this.dom.remove();
    let t = oe.iter(this.view.state.facet(Ws), this.view.viewport.from), i = [], r = this.gutters.map((s) => new Ak(s, this.view.viewport, -this.view.documentPadding.top));
    for (let s of this.view.viewportLineBlocks)
      if (i.length && (i = []), Array.isArray(s.type)) {
        let o = !0;
        for (let l of s.type)
          if (l.type == Ke.Text && o) {
            Ia(t, i, l.from);
            for (let a of r)
              a.line(this.view, l, i);
            o = !1;
          } else if (l.widget)
            for (let a of r)
              a.widget(this.view, l);
      } else if (s.type == Ke.Text) {
        Ia(t, i, s.from);
        for (let o of r)
          o.line(this.view, s, i);
      } else if (s.widget)
        for (let o of r)
          o.widget(this.view, s);
    for (let s of r)
      s.finish();
    n && this.view.scrollDOM.insertBefore(this.dom, e);
  }
  updateGutters(n) {
    let e = n.startState.facet(Or), t = n.state.facet(Or), i = n.docChanged || n.heightChanged || n.viewportChanged || !oe.eq(n.startState.facet(Ws), n.state.facet(Ws), n.view.viewport.from, n.view.viewport.to);
    if (e == t)
      for (let r of this.gutters)
        r.update(n) && (i = !0);
    else {
      i = !0;
      let r = [];
      for (let s of t) {
        let o = e.indexOf(s);
        o < 0 ? r.push(new Dc(this.view, s)) : (this.gutters[o].update(n), r.push(this.gutters[o]));
      }
      for (let s of this.gutters)
        s.dom.remove(), r.indexOf(s) < 0 && s.destroy();
      for (let s of r)
        this.dom.appendChild(s.dom);
      this.gutters = r;
    }
    return i;
  }
  destroy() {
    for (let n of this.gutters)
      n.destroy();
    this.dom.remove();
  }
}, {
  provide: (n) => I.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return !t || t.gutters.length == 0 || !t.fixed ? null : e.textDirection == we.LTR ? { left: t.dom.offsetWidth * e.scaleX } : { right: t.dom.offsetWidth * e.scaleX };
  })
});
function Xc(n) {
  return Array.isArray(n) ? n : [n];
}
function Ia(n, e, t) {
  for (; n.value && n.from <= t; )
    n.from == t && e.push(n.value), n.next();
}
class Ak {
  constructor(e, t, i) {
    this.gutter = e, this.height = i, this.i = 0, this.cursor = oe.iter(e.markers, t.from);
  }
  addElement(e, t, i) {
    let { gutter: r } = this, s = (t.top - this.height) / e.scaleY, o = t.height / e.scaleY;
    if (this.i == r.elements.length) {
      let l = new Mm(e, o, s, i);
      r.elements.push(l), r.dom.appendChild(l.dom);
    } else
      r.elements[this.i].update(e, o, s, i);
    this.height = t.bottom, this.i++;
  }
  line(e, t, i) {
    let r = [];
    Ia(this.cursor, r, t.from), i.length && (r = r.concat(i));
    let s = this.gutter.config.lineMarker(e, t, r);
    s && r.unshift(s);
    let o = this.gutter;
    r.length == 0 && !o.config.renderEmptyElements || this.addElement(e, t, r);
  }
  widget(e, t) {
    let i = this.gutter.config.widgetMarker(e, t.widget, t);
    i && this.addElement(e, t, [i]);
  }
  finish() {
    let e = this.gutter;
    for (; e.elements.length > this.i; ) {
      let t = e.elements.pop();
      e.dom.removeChild(t.dom), t.destroy();
    }
  }
}
class Dc {
  constructor(e, t) {
    this.view = e, this.config = t, this.elements = [], this.spacer = null, this.dom = document.createElement("div"), this.dom.className = "cm-gutter" + (this.config.class ? " " + this.config.class : "");
    for (let i in t.domEventHandlers)
      this.dom.addEventListener(i, (r) => {
        let s = r.target, o;
        if (s != this.dom && this.dom.contains(s)) {
          for (; s.parentNode != this.dom; )
            s = s.parentNode;
          let a = s.getBoundingClientRect();
          o = (a.top + a.bottom) / 2;
        } else
          o = r.clientY;
        let l = e.lineBlockAtHeight(o - e.documentTop);
        t.domEventHandlers[i](e, l, r) && r.preventDefault();
      });
    this.markers = Xc(t.markers(e)), t.initialSpacer && (this.spacer = new Mm(e, 0, 0, [t.initialSpacer(e)]), this.dom.appendChild(this.spacer.dom), this.spacer.dom.style.cssText += "visibility: hidden; pointer-events: none");
  }
  update(e) {
    let t = this.markers;
    if (this.markers = Xc(this.config.markers(e.view)), this.spacer && this.config.updateSpacer) {
      let r = this.config.updateSpacer(this.spacer.markers[0], e);
      r != this.spacer.markers[0] && this.spacer.update(e.view, 0, 0, [r]);
    }
    let i = e.view.viewport;
    return !oe.eq(this.markers, t, i.from, i.to) || (this.config.lineMarkerChange ? this.config.lineMarkerChange(e) : !1);
  }
  destroy() {
    for (let e of this.elements)
      e.destroy();
  }
}
class Mm {
  constructor(e, t, i, r) {
    this.height = -1, this.above = 0, this.markers = [], this.dom = document.createElement("div"), this.dom.className = "cm-gutterElement", this.update(e, t, i, r);
  }
  update(e, t, i, r) {
    this.height != t && (this.height = t, this.dom.style.height = t + "px"), this.above != i && (this.dom.style.marginTop = (this.above = i) ? i + "px" : ""), Rk(this.markers, r) || this.setMarkers(e, r);
  }
  setMarkers(e, t) {
    let i = "cm-gutterElement", r = this.dom.firstChild;
    for (let s = 0, o = 0; ; ) {
      let l = o, a = s < t.length ? t[s++] : null, h = !1;
      if (a) {
        let u = a.elementClass;
        u && (i += " " + u);
        for (let c = o; c < this.markers.length; c++)
          if (this.markers[c].compare(a)) {
            l = c, h = !0;
            break;
          }
      } else
        l = this.markers.length;
      for (; o < l; ) {
        let u = this.markers[o++];
        if (u.toDOM) {
          u.destroy(r);
          let c = r.nextSibling;
          r.remove(), r = c;
        }
      }
      if (!a)
        break;
      a.toDOM && (h ? r = r.nextSibling : this.dom.insertBefore(a.toDOM(e), r)), h && o++;
    }
    this.dom.className = i, this.markers = t;
  }
  destroy() {
    this.setMarkers(null, []);
  }
}
function Rk(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (!n[t].compare(e[t]))
      return !1;
  return !0;
}
const Zk = /* @__PURE__ */ B.define(), ci = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, { formatNumber: String, domEventHandlers: {} }, {
      domEventHandlers(e, t) {
        let i = Object.assign({}, e);
        for (let r in t) {
          let s = i[r], o = t[r];
          i[r] = s ? (l, a, h) => s(l, a, h) || o(l, a, h) : o;
        }
        return i;
      }
    });
  }
});
class pl extends hn {
  constructor(e) {
    super(), this.number = e;
  }
  eq(e) {
    return this.number == e.number;
  }
  toDOM() {
    return document.createTextNode(this.number);
  }
}
function ml(n, e) {
  return n.state.facet(ci).formatNumber(e, n.state);
}
const Mk = /* @__PURE__ */ Or.compute([ci], (n) => ({
  class: "cm-lineNumbers",
  renderEmptyElements: !1,
  markers(e) {
    return e.state.facet(Zk);
  },
  lineMarker(e, t, i) {
    return i.some((r) => r.toDOM) ? null : new pl(ml(e, e.state.doc.lineAt(t.from).number));
  },
  widgetMarker: () => null,
  lineMarkerChange: (e) => e.startState.facet(ci) != e.state.facet(ci),
  initialSpacer(e) {
    return new pl(ml(e, Lc(e.state.doc.lines)));
  },
  updateSpacer(e, t) {
    let i = ml(t.view, Lc(t.view.state.doc.lines));
    return i == e.number ? e : new pl(i);
  },
  domEventHandlers: n.facet(ci).domEventHandlers
}));
function Ek(n = {}) {
  return [
    ci.of(n),
    Zm(),
    Mk
  ];
}
function Lc(n) {
  let e = 9;
  for (; e < n; )
    e = e * 10 + 9;
  return e;
}
const zk = /* @__PURE__ */ new class extends hn {
  constructor() {
    super(...arguments), this.elementClass = "cm-activeLineGutter";
  }
}(), Xk = /* @__PURE__ */ Ws.compute(["selection"], (n) => {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let r = n.doc.lineAt(i.head).from;
    r > t && (t = r, e.push(zk.range(r)));
  }
  return oe.of(e);
});
function Dk() {
  return Xk;
}
const Em = 1024;
let Lk = 0;
class yt {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
class F {
  /**
  Create a new node prop type.
  */
  constructor(e = {}) {
    this.id = Lk++, this.perNode = !!e.perNode, this.deserialize = e.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(e) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e != "function" && (e = ze.match(e)), (t) => {
      let i = e(t);
      return i === void 0 ? null : [this, i];
    };
  }
}
F.closedBy = new F({ deserialize: (n) => n.split(" ") });
F.openedBy = new F({ deserialize: (n) => n.split(" ") });
F.group = new F({ deserialize: (n) => n.split(" ") });
F.isolate = new F({ deserialize: (n) => {
  if (n && n != "rtl" && n != "ltr" && n != "auto")
    throw new RangeError("Invalid value for isolate: " + n);
  return n || "auto";
} });
F.contextHash = new F({ perNode: !0 });
F.lookAhead = new F({ perNode: !0 });
F.mounted = new F({ perNode: !0 });
class Tr {
  constructor(e, t, i) {
    this.tree = e, this.overlay = t, this.parser = i;
  }
  /**
  @internal
  */
  static get(e) {
    return e && e.props && e.props[F.mounted.id];
  }
}
const Ik = /* @__PURE__ */ Object.create(null);
class ze {
  /**
  @internal
  */
  constructor(e, t, i, r = 0) {
    this.name = e, this.props = t, this.id = i, this.flags = r;
  }
  /**
  Define a node type.
  */
  static define(e) {
    let t = e.props && e.props.length ? /* @__PURE__ */ Object.create(null) : Ik, i = (e.top ? 1 : 0) | (e.skipped ? 2 : 0) | (e.error ? 4 : 0) | (e.name == null ? 8 : 0), r = new ze(e.name || "", t, e.id, i);
    if (e.props) {
      for (let s of e.props)
        if (Array.isArray(s) || (s = s(r)), s) {
          if (s[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          t[s[0].id] = s[1];
        }
    }
    return r;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(e) {
    return this.props[e.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(e) {
    if (typeof e == "string") {
      if (this.name == e)
        return !0;
      let t = this.prop(F.group);
      return t ? t.indexOf(e) > -1 : !1;
    }
    return this.id == e;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(e) {
    let t = /* @__PURE__ */ Object.create(null);
    for (let i in e)
      for (let r of i.split(" "))
        t[r] = e[i];
    return (i) => {
      for (let r = i.prop(F.group), s = -1; s < (r ? r.length : 0); s++) {
        let o = t[s < 0 ? i.name : r[s]];
        if (o)
          return o;
      }
    };
  }
}
ze.none = new ze(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class Nr {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(e) {
    this.types = e;
    for (let t = 0; t < e.length; t++)
      if (e[t].id != t)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...e) {
    let t = [];
    for (let i of this.types) {
      let r = null;
      for (let s of e) {
        let o = s(i);
        o && (r || (r = Object.assign({}, i.props)), r[o[0].id] = o[1]);
      }
      t.push(r ? new ze(i.name, r, i.id, i.flags) : i);
    }
    return new Nr(t);
  }
}
const ms = /* @__PURE__ */ new WeakMap(), Ic = /* @__PURE__ */ new WeakMap();
var be;
(function(n) {
  n[n.ExcludeBuffers = 1] = "ExcludeBuffers", n[n.IncludeAnonymous = 2] = "IncludeAnonymous", n[n.IgnoreMounts = 4] = "IgnoreMounts", n[n.IgnoreOverlays = 8] = "IgnoreOverlays";
})(be || (be = {}));
class ae {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(e, t, i, r, s) {
    if (this.type = e, this.children = t, this.positions = i, this.length = r, this.props = null, s && s.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [o, l] of s)
        this.props[typeof o == "number" ? o : o.id] = l;
    }
  }
  /**
  @internal
  */
  toString() {
    let e = Tr.get(this);
    if (e && !e.overlay)
      return e.tree.toString();
    let t = "";
    for (let i of this.children) {
      let r = i.toString();
      r && (t && (t += ","), t += r);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (t.length ? "(" + t + ")" : "") : t;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(e = 0) {
    return new ro(this.topNode, e);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(e, t = 0, i = 0) {
    let r = ms.get(this) || this.topNode, s = new ro(r);
    return s.moveTo(e, t), ms.set(this, s._tree), s;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new Ne(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(e, t = 0) {
    let i = Ar(ms.get(this) || this.topNode, e, t, !1);
    return ms.set(this, i), i;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(e, t = 0) {
    let i = Ar(Ic.get(this) || this.topNode, e, t, !0);
    return Ic.set(this, i), i;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(e, t = 0) {
    return Wk(this, e, t);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(e) {
    let { enter: t, leave: i, from: r = 0, to: s = this.length } = e, o = e.mode || 0, l = (o & be.IncludeAnonymous) > 0;
    for (let a = this.cursor(o | be.IncludeAnonymous); ; ) {
      let h = !1;
      if (a.from <= s && a.to >= r && (!l && a.type.isAnonymous || t(a) !== !1)) {
        if (a.firstChild())
          continue;
        h = !0;
      }
      for (; h && i && (l || !a.type.isAnonymous) && i(a), !a.nextSibling(); ) {
        if (!a.parent())
          return;
        h = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(e) {
    return e.perNode ? this.props ? this.props[e.id] : void 0 : this.type.prop(e);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let e = [];
    if (this.props)
      for (let t in this.props)
        e.push([+t, this.props[t]]);
    return e;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(e = {}) {
    return this.children.length <= 8 ? this : Dh(ze.none, this.children, this.positions, 0, this.children.length, 0, this.length, (t, i, r) => new ae(this.type, t, i, r, this.propValues), e.makeTree || ((t, i, r) => new ae(ze.none, t, i, r)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(e) {
    return Bk(e);
  }
}
ae.empty = new ae(ze.none, [], [], 0);
class zh {
  constructor(e, t) {
    this.buffer = e, this.index = t;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new zh(this.buffer, this.index);
  }
}
class Rn {
  /**
  Create a tree buffer.
  */
  constructor(e, t, i) {
    this.buffer = e, this.length = t, this.set = i;
  }
  /**
  @internal
  */
  get type() {
    return ze.none;
  }
  /**
  @internal
  */
  toString() {
    let e = [];
    for (let t = 0; t < this.buffer.length; )
      e.push(this.childString(t)), t = this.buffer[t + 3];
    return e.join(",");
  }
  /**
  @internal
  */
  childString(e) {
    let t = this.buffer[e], i = this.buffer[e + 3], r = this.set.types[t], s = r.name;
    if (/\W/.test(s) && !r.isError && (s = JSON.stringify(s)), e += 4, i == e)
      return s;
    let o = [];
    for (; e < i; )
      o.push(this.childString(e)), e = this.buffer[e + 3];
    return s + "(" + o.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(e, t, i, r, s) {
    let { buffer: o } = this, l = -1;
    for (let a = e; a != t && !(zm(s, r, o[a + 1], o[a + 2]) && (l = a, i > 0)); a = o[a + 3])
      ;
    return l;
  }
  /**
  @internal
  */
  slice(e, t, i) {
    let r = this.buffer, s = new Uint16Array(t - e), o = 0;
    for (let l = e, a = 0; l < t; ) {
      s[a++] = r[l++], s[a++] = r[l++] - i;
      let h = s[a++] = r[l++] - i;
      s[a++] = r[l++] - e, o = Math.max(o, h);
    }
    return new Rn(s, o, this.set);
  }
}
function zm(n, e, t, i) {
  switch (n) {
    case -2:
      return t < e;
    case -1:
      return i >= e && t < e;
    case 0:
      return t < e && i > e;
    case 1:
      return t <= e && i > e;
    case 2:
      return i > e;
    case 4:
      return !0;
  }
}
function Ar(n, e, t, i) {
  for (var r; n.from == n.to || (t < 1 ? n.from >= e : n.from > e) || (t > -1 ? n.to <= e : n.to < e); ) {
    let o = !i && n instanceof Ne && n.index < 0 ? null : n.parent;
    if (!o)
      return n;
    n = o;
  }
  let s = i ? 0 : be.IgnoreOverlays;
  if (i)
    for (let o = n, l = o.parent; l; o = l, l = o.parent)
      o instanceof Ne && o.index < 0 && ((r = l.enter(e, t, s)) === null || r === void 0 ? void 0 : r.from) != o.from && (n = l);
  for (; ; ) {
    let o = n.enter(e, t, s);
    if (!o)
      return n;
    n = o;
  }
}
class Xm {
  cursor(e = 0) {
    return new ro(this, e);
  }
  getChild(e, t = null, i = null) {
    let r = _c(this, e, t, i);
    return r.length ? r[0] : null;
  }
  getChildren(e, t = null, i = null) {
    return _c(this, e, t, i);
  }
  resolve(e, t = 0) {
    return Ar(this, e, t, !1);
  }
  resolveInner(e, t = 0) {
    return Ar(this, e, t, !0);
  }
  matchContext(e) {
    return _a(this, e);
  }
  enterUnfinishedNodesBefore(e) {
    let t = this.childBefore(e), i = this;
    for (; t; ) {
      let r = t.lastChild;
      if (!r || r.to != t.to)
        break;
      r.type.isError && r.from == r.to ? (i = t, t = r.prevSibling) : t = r;
    }
    return i;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class Ne extends Xm {
  constructor(e, t, i, r) {
    super(), this._tree = e, this.from = t, this.index = i, this._parent = r;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(e, t, i, r, s = 0) {
    for (let o = this; ; ) {
      for (let { children: l, positions: a } = o._tree, h = t > 0 ? l.length : -1; e != h; e += t) {
        let u = l[e], c = a[e] + o.from;
        if (zm(r, i, c, c + u.length)) {
          if (u instanceof Rn) {
            if (s & be.ExcludeBuffers)
              continue;
            let f = u.findChild(0, u.buffer.length, t, i - c, r);
            if (f > -1)
              return new Yt(new _k(o, u, e, c), null, f);
          } else if (s & be.IncludeAnonymous || !u.type.isAnonymous || Xh(u)) {
            let f;
            if (!(s & be.IgnoreMounts) && (f = Tr.get(u)) && !f.overlay)
              return new Ne(f.tree, c, e, o);
            let d = new Ne(u, c, e, o);
            return s & be.IncludeAnonymous || !d.type.isAnonymous ? d : d.nextChild(t < 0 ? u.children.length - 1 : 0, t, i, r);
          }
        }
      }
      if (s & be.IncludeAnonymous || !o.type.isAnonymous || (o.index >= 0 ? e = o.index + t : e = t < 0 ? -1 : o._parent._tree.children.length, o = o._parent, !o))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.nextChild(
      0,
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    let r;
    if (!(i & be.IgnoreOverlays) && (r = Tr.get(this._tree)) && r.overlay) {
      let s = e - this.from;
      for (let { from: o, to: l } of r.overlay)
        if ((t > 0 ? o <= s : o < s) && (t < 0 ? l >= s : l > s))
          return new Ne(r.tree, r.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, e, t, i);
  }
  nextSignificantParent() {
    let e = this;
    for (; e.type.isAnonymous && e._parent; )
      e = e._parent;
    return e;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function _c(n, e, t, i) {
  let r = n.cursor(), s = [];
  if (!r.firstChild())
    return s;
  if (t != null) {
    for (let o = !1; !o; )
      if (o = r.type.is(t), !r.nextSibling())
        return s;
  }
  for (; ; ) {
    if (i != null && r.type.is(i))
      return s;
    if (r.type.is(e) && s.push(r.node), !r.nextSibling())
      return i == null ? s : [];
  }
}
function _a(n, e, t = e.length - 1) {
  for (let i = n.parent; t >= 0; i = i.parent) {
    if (!i)
      return !1;
    if (!i.type.isAnonymous) {
      if (e[t] && e[t] != i.name)
        return !1;
      t--;
    }
  }
  return !0;
}
class _k {
  constructor(e, t, i, r) {
    this.parent = e, this.buffer = t, this.index = i, this.start = r;
  }
}
class Yt extends Xm {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(e, t, i) {
    super(), this.context = e, this._parent = t, this.index = i, this.type = e.buffer.set.types[e.buffer.buffer[i]];
  }
  child(e, t, i) {
    let { buffer: r } = this.context, s = r.findChild(this.index + 4, r.buffer[this.index + 3], e, t - this.context.start, i);
    return s < 0 ? null : new Yt(this.context, this, s);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.child(
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.child(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    if (i & be.ExcludeBuffers)
      return null;
    let { buffer: r } = this.context, s = r.findChild(this.index + 4, r.buffer[this.index + 3], t > 0 ? 1 : -1, e - this.context.start, t);
    return s < 0 ? null : new Yt(this.context, this, s);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(e) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + e,
      e,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: e } = this.context, t = e.buffer[this.index + 3];
    return t < (this._parent ? e.buffer[this._parent.index + 3] : e.buffer.length) ? new Yt(this.context, this._parent, t) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: e } = this.context, t = this._parent ? this._parent.index + 4 : 0;
    return this.index == t ? this.externalSibling(-1) : new Yt(this.context, this._parent, e.findChild(
      t,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let e = [], t = [], { buffer: i } = this.context, r = this.index + 4, s = i.buffer[this.index + 3];
    if (s > r) {
      let o = i.buffer[this.index + 1];
      e.push(i.slice(r, s, o)), t.push(0);
    }
    return new ae(this.type, e, t, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function Dm(n) {
  if (!n.length)
    return null;
  let e = 0, t = n[0];
  for (let s = 1; s < n.length; s++) {
    let o = n[s];
    (o.from > t.from || o.to < t.to) && (t = o, e = s);
  }
  let i = t instanceof Ne && t.index < 0 ? null : t.parent, r = n.slice();
  return i ? r[e] = i : r.splice(e, 1), new qk(r, t);
}
class qk {
  constructor(e, t) {
    this.heads = e, this.node = t;
  }
  get next() {
    return Dm(this.heads);
  }
}
function Wk(n, e, t) {
  let i = n.resolveInner(e, t), r = null;
  for (let s = i instanceof Ne ? i : i.context.parent; s; s = s.parent)
    if (s.index < 0) {
      let o = s.parent;
      (r || (r = [i])).push(o.resolve(e, t)), s = o;
    } else {
      let o = Tr.get(s.tree);
      if (o && o.overlay && o.overlay[0].from <= e && o.overlay[o.overlay.length - 1].to >= e) {
        let l = new Ne(o.tree, o.overlay[0].from + s.from, -1, s);
        (r || (r = [i])).push(Ar(l, e, t, !1));
      }
    }
  return r ? Dm(r) : i;
}
class ro {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(e, t = 0) {
    if (this.mode = t, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, e instanceof Ne)
      this.yieldNode(e);
    else {
      this._tree = e.context.parent, this.buffer = e.context;
      for (let i = e._parent; i; i = i._parent)
        this.stack.unshift(i.index);
      this.bufferNode = e, this.yieldBuf(e.index);
    }
  }
  yieldNode(e) {
    return e ? (this._tree = e, this.type = e.type, this.from = e.from, this.to = e.to, !0) : !1;
  }
  yieldBuf(e, t) {
    this.index = e;
    let { start: i, buffer: r } = this.buffer;
    return this.type = t || r.set.types[r.buffer[e]], this.from = i + r.buffer[e + 1], this.to = i + r.buffer[e + 2], !0;
  }
  /**
  @internal
  */
  yield(e) {
    return e ? e instanceof Ne ? (this.buffer = null, this.yieldNode(e)) : (this.buffer = e.context, this.yieldBuf(e.index, e.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(e, t, i) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e < 0 ? this._tree._tree.children.length - 1 : 0, e, t, i, this.mode));
    let { buffer: r } = this.buffer, s = r.findChild(this.index + 4, r.buffer[this.index + 3], e, t - this.buffer.start, i);
    return s < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(s));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(e) {
    return this.enterChild(
      1,
      e,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(e) {
    return this.enterChild(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(e, t, i = this.mode) {
    return this.buffer ? i & be.ExcludeBuffers ? !1 : this.enterChild(1, e, t) : this.yield(this._tree.enter(e, t, i));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & be.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let e = this.mode & be.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e);
  }
  /**
  @internal
  */
  sibling(e) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e, e, 0, 4, this.mode)) : !1;
    let { buffer: t } = this.buffer, i = this.stack.length - 1;
    if (e < 0) {
      let r = i < 0 ? 0 : this.stack[i] + 4;
      if (this.index != r)
        return this.yieldBuf(t.findChild(
          r,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let r = t.buffer[this.index + 3];
      if (r < (i < 0 ? t.buffer.length : t.buffer[this.stack[i] + 3]))
        return this.yieldBuf(r);
    }
    return i < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + e, e, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(e) {
    let t, i, { buffer: r } = this;
    if (r) {
      if (e > 0) {
        if (this.index < r.buffer.buffer.length)
          return !1;
      } else
        for (let s = 0; s < this.index; s++)
          if (r.buffer.buffer[s + 3] < this.index)
            return !1;
      ({ index: t, parent: i } = r);
    } else
      ({ index: t, _parent: i } = this._tree);
    for (; i; { index: t, _parent: i } = i)
      if (t > -1)
        for (let s = t + e, o = e < 0 ? -1 : i._tree.children.length; s != o; s += e) {
          let l = i._tree.children[s];
          if (this.mode & be.IncludeAnonymous || l instanceof Rn || !l.type.isAnonymous || Xh(l))
            return !1;
        }
    return !0;
  }
  move(e, t) {
    if (t && this.enterChild(
      e,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(e))
        return !0;
      if (this.atLastNode(e) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(e = !0) {
    return this.move(1, e);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(e = !0) {
    return this.move(-1, e);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(e, t = 0) {
    for (; (this.from == this.to || (t < 1 ? this.from >= e : this.from > e) || (t > -1 ? this.to <= e : this.to < e)) && this.parent(); )
      ;
    for (; this.enterChild(1, e, t); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let e = this.bufferNode, t = null, i = 0;
    if (e && e.context == this.buffer)
      e:
        for (let r = this.index, s = this.stack.length; s >= 0; ) {
          for (let o = e; o; o = o._parent)
            if (o.index == r) {
              if (r == this.index)
                return o;
              t = o, i = s + 1;
              break e;
            }
          r = this.stack[--s];
        }
    for (let r = i; r < this.stack.length; r++)
      t = new Yt(this.buffer, t, this.stack[r]);
    return this.bufferNode = new Yt(this.buffer, t, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(e, t) {
    for (let i = 0; ; ) {
      let r = !1;
      if (this.type.isAnonymous || e(this) !== !1) {
        if (this.firstChild()) {
          i++;
          continue;
        }
        this.type.isAnonymous || (r = !0);
      }
      for (; r && t && t(this), r = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!i)
          return;
        this.parent(), i--, r = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(e) {
    if (!this.buffer)
      return _a(this.node, e);
    let { buffer: t } = this.buffer, { types: i } = t.set;
    for (let r = e.length - 1, s = this.stack.length - 1; r >= 0; s--) {
      if (s < 0)
        return _a(this.node, e, r);
      let o = i[t.buffer[this.stack[s]]];
      if (!o.isAnonymous) {
        if (e[r] && e[r] != o.name)
          return !1;
        r--;
      }
    }
    return !0;
  }
}
function Xh(n) {
  return n.children.some((e) => e instanceof Rn || !e.type.isAnonymous || Xh(e));
}
function Bk(n) {
  var e;
  let { buffer: t, nodeSet: i, maxBufferLength: r = Em, reused: s = [], minRepeatType: o = i.types.length } = n, l = Array.isArray(t) ? new zh(t, t.length) : t, a = i.types, h = 0, u = 0;
  function c(P, w, C, L, q, v) {
    let { id: R, start: A, end: E, size: W } = l, _ = u;
    for (; W < 0; )
      if (l.next(), W == -1) {
        let y = s[R];
        C.push(y), L.push(A - P);
        return;
      } else if (W == -3) {
        h = R;
        return;
      } else if (W == -4) {
        u = R;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${W}`);
    let G = a[R], U, se, ce = A - P;
    if (E - A <= r && (se = O(l.pos - w, q))) {
      let y = new Uint16Array(se.size - se.skip), he = l.pos - se.size, ke = y.length;
      for (; l.pos > he; )
        ke = g(se.start, y, ke);
      U = new Rn(y, E - se.start, i), ce = se.start - P;
    } else {
      let y = l.pos - W;
      l.next();
      let he = [], ke = [], x = R >= o ? R : -1, $e = 0, pt = E;
      for (; l.pos > y; )
        x >= 0 && l.id == x && l.size >= 0 ? (l.end <= pt - r && (p(he, ke, A, $e, l.end, pt, x, _), $e = he.length, pt = l.end), l.next()) : v > 2500 ? f(A, y, he, ke) : c(A, y, he, ke, x, v + 1);
      if (x >= 0 && $e > 0 && $e < he.length && p(he, ke, A, $e, A, pt, x, _), he.reverse(), ke.reverse(), x > -1 && $e > 0) {
        let Ce = d(G);
        U = Dh(G, he, ke, 0, he.length, 0, E - A, Ce, Ce);
      } else
        U = m(G, he, ke, E - A, _ - E);
    }
    C.push(U), L.push(ce);
  }
  function f(P, w, C, L) {
    let q = [], v = 0, R = -1;
    for (; l.pos > w; ) {
      let { id: A, start: E, end: W, size: _ } = l;
      if (_ > 4)
        l.next();
      else {
        if (R > -1 && E < R)
          break;
        R < 0 && (R = W - r), q.push(A, E, W), v++, l.next();
      }
    }
    if (v) {
      let A = new Uint16Array(v * 4), E = q[q.length - 2];
      for (let W = q.length - 3, _ = 0; W >= 0; W -= 3)
        A[_++] = q[W], A[_++] = q[W + 1] - E, A[_++] = q[W + 2] - E, A[_++] = _;
      C.push(new Rn(A, q[2] - E, i)), L.push(E - P);
    }
  }
  function d(P) {
    return (w, C, L) => {
      let q = 0, v = w.length - 1, R, A;
      if (v >= 0 && (R = w[v]) instanceof ae) {
        if (!v && R.type == P && R.length == L)
          return R;
        (A = R.prop(F.lookAhead)) && (q = C[v] + R.length + A);
      }
      return m(P, w, C, L, q);
    };
  }
  function p(P, w, C, L, q, v, R, A) {
    let E = [], W = [];
    for (; P.length > L; )
      E.push(P.pop()), W.push(w.pop() + C - q);
    P.push(m(i.types[R], E, W, v - q, A - v)), w.push(q - C);
  }
  function m(P, w, C, L, q = 0, v) {
    if (h) {
      let R = [F.contextHash, h];
      v = v ? [R].concat(v) : [R];
    }
    if (q > 25) {
      let R = [F.lookAhead, q];
      v = v ? [R].concat(v) : [R];
    }
    return new ae(P, w, C, L, v);
  }
  function O(P, w) {
    let C = l.fork(), L = 0, q = 0, v = 0, R = C.end - r, A = { size: 0, start: 0, skip: 0 };
    e:
      for (let E = C.pos - P; C.pos > E; ) {
        let W = C.size;
        if (C.id == w && W >= 0) {
          A.size = L, A.start = q, A.skip = v, v += 4, L += 4, C.next();
          continue;
        }
        let _ = C.pos - W;
        if (W < 0 || _ < E || C.start < R)
          break;
        let G = C.id >= o ? 4 : 0, U = C.start;
        for (C.next(); C.pos > _; ) {
          if (C.size < 0)
            if (C.size == -3)
              G += 4;
            else
              break e;
          else
            C.id >= o && (G += 4);
          C.next();
        }
        q = U, L += W, v += G;
      }
    return (w < 0 || L == P) && (A.size = L, A.start = q, A.skip = v), A.size > 4 ? A : void 0;
  }
  function g(P, w, C) {
    let { id: L, start: q, end: v, size: R } = l;
    if (l.next(), R >= 0 && L < o) {
      let A = C;
      if (R > 4) {
        let E = l.pos - (R - 4);
        for (; l.pos > E; )
          C = g(P, w, C);
      }
      w[--C] = A, w[--C] = v - P, w[--C] = q - P, w[--C] = L;
    } else
      R == -3 ? h = L : R == -4 && (u = L);
    return C;
  }
  let b = [], S = [];
  for (; l.pos > 0; )
    c(n.start || 0, n.bufferStart || 0, b, S, -1, 0);
  let Q = (e = n.length) !== null && e !== void 0 ? e : b.length ? S[0] + b[0].length : 0;
  return new ae(a[n.topID], b.reverse(), S.reverse(), Q);
}
const qc = /* @__PURE__ */ new WeakMap();
function Bs(n, e) {
  if (!n.isAnonymous || e instanceof Rn || e.type != n)
    return 1;
  let t = qc.get(e);
  if (t == null) {
    t = 1;
    for (let i of e.children) {
      if (i.type != n || !(i instanceof ae)) {
        t = 1;
        break;
      }
      t += Bs(n, i);
    }
    qc.set(e, t);
  }
  return t;
}
function Dh(n, e, t, i, r, s, o, l, a) {
  let h = 0;
  for (let p = i; p < r; p++)
    h += Bs(n, e[p]);
  let u = Math.ceil(
    h * 1.5 / 8
    /* Balance.BranchFactor */
  ), c = [], f = [];
  function d(p, m, O, g, b) {
    for (let S = O; S < g; ) {
      let Q = S, P = m[S], w = Bs(n, p[S]);
      for (S++; S < g; S++) {
        let C = Bs(n, p[S]);
        if (w + C >= u)
          break;
        w += C;
      }
      if (S == Q + 1) {
        if (w > u) {
          let C = p[Q];
          d(C.children, C.positions, 0, C.children.length, m[Q] + b);
          continue;
        }
        c.push(p[Q]);
      } else {
        let C = m[S - 1] + p[S - 1].length - P;
        c.push(Dh(n, p, m, Q, S, P, C, null, a));
      }
      f.push(P + b - s);
    }
  }
  return d(e, t, i, r, 0), (l || a)(c, f, o);
}
class Lm {
  constructor() {
    this.map = /* @__PURE__ */ new WeakMap();
  }
  setBuffer(e, t, i) {
    let r = this.map.get(e);
    r || this.map.set(e, r = /* @__PURE__ */ new Map()), r.set(t, i);
  }
  getBuffer(e, t) {
    let i = this.map.get(e);
    return i && i.get(t);
  }
  /**
  Set the value for this syntax node.
  */
  set(e, t) {
    e instanceof Yt ? this.setBuffer(e.context.buffer, e.index, t) : e instanceof Ne && this.map.set(e.tree, t);
  }
  /**
  Retrieve value for this syntax node, if it exists in the map.
  */
  get(e) {
    return e instanceof Yt ? this.getBuffer(e.context.buffer, e.index) : e instanceof Ne ? this.map.get(e.tree) : void 0;
  }
  /**
  Set the value for the node that a cursor currently points to.
  */
  cursorSet(e, t) {
    e.buffer ? this.setBuffer(e.buffer.buffer, e.index, t) : this.map.set(e.tree, t);
  }
  /**
  Retrieve the value for the node that a cursor currently points
  to.
  */
  cursorGet(e) {
    return e.buffer ? this.getBuffer(e.buffer.buffer, e.index) : this.map.get(e.tree);
  }
}
class on {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(e, t, i, r, s = !1, o = !1) {
    this.from = e, this.to = t, this.tree = i, this.offset = r, this.open = (s ? 1 : 0) | (o ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(e, t = [], i = !1) {
    let r = [new on(0, e.length, e, 0, !1, i)];
    for (let s of t)
      s.to > e.length && r.push(s);
    return r;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(e, t, i = 128) {
    if (!t.length)
      return e;
    let r = [], s = 1, o = e.length ? e[0] : null;
    for (let l = 0, a = 0, h = 0; ; l++) {
      let u = l < t.length ? t[l] : null, c = u ? u.fromA : 1e9;
      if (c - a >= i)
        for (; o && o.from < c; ) {
          let f = o;
          if (a >= f.from || c <= f.to || h) {
            let d = Math.max(f.from, a) - h, p = Math.min(f.to, c) - h;
            f = d >= p ? null : new on(d, p, f.tree, f.offset + h, l > 0, !!u);
          }
          if (f && r.push(f), o.to > c)
            break;
          o = s < e.length ? e[s++] : null;
        }
      if (!u)
        break;
      a = u.toA, h = u.toA - u.toB;
    }
    return r;
  }
}
class Lh {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(e, t, i) {
    return typeof e == "string" && (e = new Vk(e)), i = i ? i.length ? i.map((r) => new yt(r.from, r.to)) : [new yt(0, 0)] : [new yt(0, e.length)], this.createParse(e, t || [], i);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(e, t, i) {
    let r = this.startParse(e, t, i);
    for (; ; ) {
      let s = r.advance();
      if (s)
        return s;
    }
  }
}
class Vk {
  constructor(e) {
    this.string = e;
  }
  get length() {
    return this.string.length;
  }
  chunk(e) {
    return this.string.slice(e);
  }
  get lineChunks() {
    return !1;
  }
  read(e, t) {
    return this.string.slice(e, t);
  }
}
function Im(n) {
  return (e, t, i, r) => new jk(e, n, t, i, r);
}
class Wc {
  constructor(e, t, i, r, s) {
    this.parser = e, this.parse = t, this.overlay = i, this.target = r, this.from = s;
  }
}
function Bc(n) {
  if (!n.length || n.some((e) => e.from >= e.to))
    throw new RangeError("Invalid inner parse ranges given: " + JSON.stringify(n));
}
class Yk {
  constructor(e, t, i, r, s, o, l) {
    this.parser = e, this.predicate = t, this.mounts = i, this.index = r, this.start = s, this.target = o, this.prev = l, this.depth = 0, this.ranges = [];
  }
}
const qa = new F({ perNode: !0 });
class jk {
  constructor(e, t, i, r, s) {
    this.nest = t, this.input = i, this.fragments = r, this.ranges = s, this.inner = [], this.innerDone = 0, this.baseTree = null, this.stoppedAt = null, this.baseParse = e;
  }
  advance() {
    if (this.baseParse) {
      let i = this.baseParse.advance();
      if (!i)
        return null;
      if (this.baseParse = null, this.baseTree = i, this.startInner(), this.stoppedAt != null)
        for (let r of this.inner)
          r.parse.stopAt(this.stoppedAt);
    }
    if (this.innerDone == this.inner.length) {
      let i = this.baseTree;
      return this.stoppedAt != null && (i = new ae(i.type, i.children, i.positions, i.length, i.propValues.concat([[qa, this.stoppedAt]]))), i;
    }
    let e = this.inner[this.innerDone], t = e.parse.advance();
    if (t) {
      this.innerDone++;
      let i = Object.assign(/* @__PURE__ */ Object.create(null), e.target.props);
      i[F.mounted.id] = new Tr(t, e.overlay, e.parser), e.target.props = i;
    }
    return null;
  }
  get parsedPos() {
    if (this.baseParse)
      return 0;
    let e = this.input.length;
    for (let t = this.innerDone; t < this.inner.length; t++)
      this.inner[t].from < e && (e = Math.min(e, this.inner[t].parse.parsedPos));
    return e;
  }
  stopAt(e) {
    if (this.stoppedAt = e, this.baseParse)
      this.baseParse.stopAt(e);
    else
      for (let t = this.innerDone; t < this.inner.length; t++)
        this.inner[t].parse.stopAt(e);
  }
  startInner() {
    let e = new Fk(this.fragments), t = null, i = null, r = new ro(new Ne(this.baseTree, this.ranges[0].from, 0, null), be.IncludeAnonymous | be.IgnoreMounts);
    e:
      for (let s, o; ; ) {
        let l = !0, a;
        if (this.stoppedAt != null && r.from >= this.stoppedAt)
          l = !1;
        else if (e.hasNode(r)) {
          if (t) {
            let h = t.mounts.find((u) => u.frag.from <= r.from && u.frag.to >= r.to && u.mount.overlay);
            if (h)
              for (let u of h.mount.overlay) {
                let c = u.from + h.pos, f = u.to + h.pos;
                c >= r.from && f <= r.to && !t.ranges.some((d) => d.from < f && d.to > c) && t.ranges.push({ from: c, to: f });
              }
          }
          l = !1;
        } else if (i && (o = Nk(i.ranges, r.from, r.to)))
          l = o != 2;
        else if (!r.type.isAnonymous && (s = this.nest(r, this.input)) && (r.from < r.to || !s.overlay)) {
          r.tree || Uk(r);
          let h = e.findMounts(r.from, s.parser);
          if (typeof s.overlay == "function")
            t = new Yk(s.parser, s.overlay, h, this.inner.length, r.from, r.tree, t);
          else {
            let u = jc(this.ranges, s.overlay || (r.from < r.to ? [new yt(r.from, r.to)] : []));
            u.length && Bc(u), (u.length || !s.overlay) && this.inner.push(new Wc(s.parser, u.length ? s.parser.startParse(this.input, Nc(h, u), u) : s.parser.startParse(""), s.overlay ? s.overlay.map((c) => new yt(c.from - r.from, c.to - r.from)) : null, r.tree, u.length ? u[0].from : r.from)), s.overlay ? u.length && (i = { ranges: u, depth: 0, prev: i }) : l = !1;
          }
        } else
          t && (a = t.predicate(r)) && (a === !0 && (a = new yt(r.from, r.to)), a.from < a.to && t.ranges.push(a));
        if (l && r.firstChild())
          t && t.depth++, i && i.depth++;
        else
          for (; !r.nextSibling(); ) {
            if (!r.parent())
              break e;
            if (t && !--t.depth) {
              let h = jc(this.ranges, t.ranges);
              h.length && (Bc(h), this.inner.splice(t.index, 0, new Wc(t.parser, t.parser.startParse(this.input, Nc(t.mounts, h), h), t.ranges.map((u) => new yt(u.from - t.start, u.to - t.start)), t.target, h[0].from))), t = t.prev;
            }
            i && !--i.depth && (i = i.prev);
          }
      }
  }
}
function Nk(n, e, t) {
  for (let i of n) {
    if (i.from >= t)
      break;
    if (i.to > e)
      return i.from <= e && i.to >= t ? 2 : 1;
  }
  return 0;
}
function Vc(n, e, t, i, r, s) {
  if (e < t) {
    let o = n.buffer[e + 1];
    i.push(n.slice(e, t, o)), r.push(o - s);
  }
}
function Uk(n) {
  let { node: e } = n, t = [], i = e.context.buffer;
  do
    t.push(n.index), n.parent();
  while (!n.tree);
  let r = n.tree, s = r.children.indexOf(i), o = r.children[s], l = o.buffer, a = [s];
  function h(u, c, f, d, p, m) {
    let O = t[m], g = [], b = [];
    Vc(o, u, O, g, b, d);
    let S = l[O + 1], Q = l[O + 2];
    a.push(g.length);
    let P = m ? h(O + 4, l[O + 3], o.set.types[l[O]], S, Q - S, m - 1) : e.toTree();
    return g.push(P), b.push(S - d), Vc(o, l[O + 3], c, g, b, d), new ae(f, g, b, p);
  }
  r.children[s] = h(0, l.length, ze.none, 0, o.length, t.length - 1);
  for (let u of a) {
    let c = n.tree.children[u], f = n.tree.positions[u];
    n.yield(new Ne(c, f + n.from, u, n._tree));
  }
}
class Yc {
  constructor(e, t) {
    this.offset = t, this.done = !1, this.cursor = e.cursor(be.IncludeAnonymous | be.IgnoreMounts);
  }
  // Move to the first node (in pre-order) that starts at or after `pos`.
  moveTo(e) {
    let { cursor: t } = this, i = e - this.offset;
    for (; !this.done && t.from < i; )
      t.to >= e && t.enter(i, 1, be.IgnoreOverlays | be.ExcludeBuffers) || t.next(!1) || (this.done = !0);
  }
  hasNode(e) {
    if (this.moveTo(e.from), !this.done && this.cursor.from + this.offset == e.from && this.cursor.tree)
      for (let t = this.cursor.tree; ; ) {
        if (t == e.tree)
          return !0;
        if (t.children.length && t.positions[0] == 0 && t.children[0] instanceof ae)
          t = t.children[0];
        else
          break;
      }
    return !1;
  }
}
let Fk = class {
  constructor(e) {
    var t;
    if (this.fragments = e, this.curTo = 0, this.fragI = 0, e.length) {
      let i = this.curFrag = e[0];
      this.curTo = (t = i.tree.prop(qa)) !== null && t !== void 0 ? t : i.to, this.inner = new Yc(i.tree, -i.offset);
    } else
      this.curFrag = this.inner = null;
  }
  hasNode(e) {
    for (; this.curFrag && e.from >= this.curTo; )
      this.nextFrag();
    return this.curFrag && this.curFrag.from <= e.from && this.curTo >= e.to && this.inner.hasNode(e);
  }
  nextFrag() {
    var e;
    if (this.fragI++, this.fragI == this.fragments.length)
      this.curFrag = this.inner = null;
    else {
      let t = this.curFrag = this.fragments[this.fragI];
      this.curTo = (e = t.tree.prop(qa)) !== null && e !== void 0 ? e : t.to, this.inner = new Yc(t.tree, -t.offset);
    }
  }
  findMounts(e, t) {
    var i;
    let r = [];
    if (this.inner) {
      this.inner.cursor.moveTo(e, 1);
      for (let s = this.inner.cursor.node; s; s = s.parent) {
        let o = (i = s.tree) === null || i === void 0 ? void 0 : i.prop(F.mounted);
        if (o && o.parser == t)
          for (let l = this.fragI; l < this.fragments.length; l++) {
            let a = this.fragments[l];
            if (a.from >= s.to)
              break;
            a.tree == this.curFrag.tree && r.push({
              frag: a,
              pos: s.from - a.offset,
              mount: o
            });
          }
      }
    }
    return r;
  }
};
function jc(n, e) {
  let t = null, i = e;
  for (let r = 1, s = 0; r < n.length; r++) {
    let o = n[r - 1].to, l = n[r].from;
    for (; s < i.length; s++) {
      let a = i[s];
      if (a.from >= l)
        break;
      a.to <= o || (t || (i = t = e.slice()), a.from < o ? (t[s] = new yt(a.from, o), a.to > l && t.splice(s + 1, 0, new yt(l, a.to))) : a.to > l ? t[s--] = new yt(l, a.to) : t.splice(s--, 1));
    }
  }
  return i;
}
function Gk(n, e, t, i) {
  let r = 0, s = 0, o = !1, l = !1, a = -1e9, h = [];
  for (; ; ) {
    let u = r == n.length ? 1e9 : o ? n[r].to : n[r].from, c = s == e.length ? 1e9 : l ? e[s].to : e[s].from;
    if (o != l) {
      let f = Math.max(a, t), d = Math.min(u, c, i);
      f < d && h.push(new yt(f, d));
    }
    if (a = Math.min(u, c), a == 1e9)
      break;
    u == a && (o ? (o = !1, r++) : o = !0), c == a && (l ? (l = !1, s++) : l = !0);
  }
  return h;
}
function Nc(n, e) {
  let t = [];
  for (let { pos: i, mount: r, frag: s } of n) {
    let o = i + (r.overlay ? r.overlay[0].from : 0), l = o + r.tree.length, a = Math.max(s.from, o), h = Math.min(s.to, l);
    if (r.overlay) {
      let u = r.overlay.map((f) => new yt(f.from + i, f.to + i)), c = Gk(e, u, a, h);
      for (let f = 0, d = a; ; f++) {
        let p = f == c.length, m = p ? h : c[f].from;
        if (m > d && t.push(new on(d, m, r.tree, -o, s.from >= d || s.openStart, s.to <= m || s.openEnd)), p)
          break;
        d = c[f].to;
      }
    } else
      t.push(new on(a, h, r.tree, -o, s.from >= o || s.openStart, s.to <= l || s.openEnd));
  }
  return t;
}
let Hk = 0;
class At {
  /**
  @internal
  */
  constructor(e, t, i) {
    this.set = e, this.base = t, this.modified = i, this.id = Hk++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(e) {
    if (e != null && e.base)
      throw new Error("Can not derive from a modified tag");
    let t = new At([], null, []);
    if (t.set.push(t), e)
      for (let i of e.set)
        t.set.push(i);
    return t;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let e = new so();
    return (t) => t.modified.indexOf(e) > -1 ? t : so.get(t.base || t, t.modified.concat(e).sort((i, r) => i.id - r.id));
  }
}
let Kk = 0;
class so {
  constructor() {
    this.instances = [], this.id = Kk++;
  }
  static get(e, t) {
    if (!t.length)
      return e;
    let i = t[0].instances.find((l) => l.base == e && Jk(t, l.modified));
    if (i)
      return i;
    let r = [], s = new At(r, e, t);
    for (let l of t)
      l.instances.push(s);
    let o = ex(t);
    for (let l of e.set)
      if (!l.modified.length)
        for (let a of o)
          r.push(so.get(l, a));
    return s;
  }
}
function Jk(n, e) {
  return n.length == e.length && n.every((t, i) => t == e[i]);
}
function ex(n) {
  let e = [[]];
  for (let t = 0; t < n.length; t++)
    for (let i = 0, r = e.length; i < r; i++)
      e.push(e[i].concat(n[t]));
  return e.sort((t, i) => i.length - t.length);
}
function Xi(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t in n) {
    let i = n[t];
    Array.isArray(i) || (i = [i]);
    for (let r of t.split(" "))
      if (r) {
        let s = [], o = 2, l = r;
        for (let c = 0; ; ) {
          if (l == "..." && c > 0 && c + 3 == r.length) {
            o = 1;
            break;
          }
          let f = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(l);
          if (!f)
            throw new RangeError("Invalid path: " + r);
          if (s.push(f[0] == "*" ? "" : f[0][0] == '"' ? JSON.parse(f[0]) : f[0]), c += f[0].length, c == r.length)
            break;
          let d = r[c++];
          if (c == r.length && d == "!") {
            o = 0;
            break;
          }
          if (d != "/")
            throw new RangeError("Invalid path: " + r);
          l = r.slice(c);
        }
        let a = s.length - 1, h = s[a];
        if (!h)
          throw new RangeError("Invalid path: " + r);
        let u = new oo(i, o, a > 0 ? s.slice(0, a) : null);
        e[h] = u.sort(e[h]);
      }
  }
  return _m.add(e);
}
const _m = new F();
class oo {
  constructor(e, t, i, r) {
    this.tags = e, this.mode = t, this.context = i, this.next = r;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(e) {
    return !e || e.depth < this.depth ? (this.next = e, this) : (e.next = this.sort(e.next), e);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
oo.empty = new oo([], 2, null);
function qm(n, e) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let s of n)
    if (!Array.isArray(s.tag))
      t[s.tag.id] = s.class;
    else
      for (let o of s.tag)
        t[o.id] = s.class;
  let { scope: i, all: r = null } = e || {};
  return {
    style: (s) => {
      let o = r;
      for (let l of s)
        for (let a of l.set) {
          let h = t[a.id];
          if (h) {
            o = o ? o + " " + h : h;
            break;
          }
        }
      return o;
    },
    scope: i
  };
}
function tx(n, e) {
  let t = null;
  for (let i of n) {
    let r = i.style(e);
    r && (t = t ? t + " " + r : r);
  }
  return t;
}
function nx(n, e, t, i = 0, r = n.length) {
  let s = new ix(i, Array.isArray(e) ? e : [e], t);
  s.highlightRange(n.cursor(), i, r, "", s.highlighters), s.flush(r);
}
class ix {
  constructor(e, t, i) {
    this.at = e, this.highlighters = t, this.span = i, this.class = "";
  }
  startSpan(e, t) {
    t != this.class && (this.flush(e), e > this.at && (this.at = e), this.class = t);
  }
  flush(e) {
    e > this.at && this.class && this.span(this.at, e, this.class);
  }
  highlightRange(e, t, i, r, s) {
    let { type: o, from: l, to: a } = e;
    if (l >= i || a <= t)
      return;
    o.isTop && (s = this.highlighters.filter((d) => !d.scope || d.scope(o)));
    let h = r, u = rx(e) || oo.empty, c = tx(s, u.tags);
    if (c && (h && (h += " "), h += c, u.mode == 1 && (r += (r ? " " : "") + c)), this.startSpan(Math.max(t, l), h), u.opaque)
      return;
    let f = e.tree && e.tree.prop(F.mounted);
    if (f && f.overlay) {
      let d = e.node.enter(f.overlay[0].from + l, 1), p = this.highlighters.filter((O) => !O.scope || O.scope(f.tree.type)), m = e.firstChild();
      for (let O = 0, g = l; ; O++) {
        let b = O < f.overlay.length ? f.overlay[O] : null, S = b ? b.from + l : a, Q = Math.max(t, g), P = Math.min(i, S);
        if (Q < P && m)
          for (; e.from < P && (this.highlightRange(e, Q, P, r, s), this.startSpan(Math.min(P, e.to), h), !(e.to >= S || !e.nextSibling())); )
            ;
        if (!b || S > i)
          break;
        g = b.to + l, g > t && (this.highlightRange(d.cursor(), Math.max(t, b.from + l), Math.min(i, g), "", p), this.startSpan(Math.min(i, g), h));
      }
      m && e.parent();
    } else if (e.firstChild()) {
      f && (r = "");
      do
        if (!(e.to <= t)) {
          if (e.from >= i)
            break;
          this.highlightRange(e, t, i, r, s), this.startSpan(Math.min(i, e.to), h);
        }
      while (e.nextSibling());
      e.parent();
    }
  }
}
function rx(n) {
  let e = n.type.prop(_m);
  for (; e && e.context && !n.matchContext(e.context); )
    e = e.next;
  return e || null;
}
const z = At.define, Os = z(), On = z(), Uc = z(On), Fc = z(On), gn = z(), gs = z(gn), Ol = z(gn), qt = z(), Dn = z(qt), It = z(), _t = z(), Wa = z(), Gi = z(Wa), bs = z(), k = {
  /**
  A comment.
  */
  comment: Os,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: z(Os),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: z(Os),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: z(Os),
  /**
  Any kind of identifier.
  */
  name: On,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: z(On),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: Uc,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: z(Uc),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: Fc,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: z(Fc),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: z(On),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: z(On),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: z(On),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: z(On),
  /**
  A literal value.
  */
  literal: gn,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: gs,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: z(gs),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: z(gs),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: z(gs),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: Ol,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: z(Ol),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: z(Ol),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: z(gn),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: z(gn),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: z(gn),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: z(gn),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: z(gn),
  /**
  A language keyword.
  */
  keyword: It,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: z(It),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: z(It),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: z(It),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: z(It),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: z(It),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: z(It),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: z(It),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: z(It),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: z(It),
  /**
  An operator.
  */
  operator: _t,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: z(_t),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: z(_t),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: z(_t),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: z(_t),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: z(_t),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: z(_t),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: z(_t),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: z(_t),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: z(_t),
  /**
  Program or markup punctuation.
  */
  punctuation: Wa,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: z(Wa),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: Gi,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: z(Gi),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: z(Gi),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: z(Gi),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: z(Gi),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: qt,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: Dn,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: z(Dn),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: z(Dn),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: z(Dn),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: z(Dn),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: z(Dn),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: z(Dn),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: z(qt),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: z(qt),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: z(qt),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: z(qt),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: z(qt),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: z(qt),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: z(qt),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: z(qt),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: z(),
  /**
  Deleted text.
  */
  deleted: z(),
  /**
  Changed text.
  */
  changed: z(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: z(),
  /**
  Metadata or meta-instruction.
  */
  meta: bs,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: z(bs),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: z(bs),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: z(bs),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: At.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: At.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: At.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: At.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: At.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: At.defineModifier()
};
qm([
  { tag: k.link, class: "tok-link" },
  { tag: k.heading, class: "tok-heading" },
  { tag: k.emphasis, class: "tok-emphasis" },
  { tag: k.strong, class: "tok-strong" },
  { tag: k.keyword, class: "tok-keyword" },
  { tag: k.atom, class: "tok-atom" },
  { tag: k.bool, class: "tok-bool" },
  { tag: k.url, class: "tok-url" },
  { tag: k.labelName, class: "tok-labelName" },
  { tag: k.inserted, class: "tok-inserted" },
  { tag: k.deleted, class: "tok-deleted" },
  { tag: k.literal, class: "tok-literal" },
  { tag: k.string, class: "tok-string" },
  { tag: k.number, class: "tok-number" },
  { tag: [k.regexp, k.escape, k.special(k.string)], class: "tok-string2" },
  { tag: k.variableName, class: "tok-variableName" },
  { tag: k.local(k.variableName), class: "tok-variableName tok-local" },
  { tag: k.definition(k.variableName), class: "tok-variableName tok-definition" },
  { tag: k.special(k.variableName), class: "tok-variableName2" },
  { tag: k.definition(k.propertyName), class: "tok-propertyName tok-definition" },
  { tag: k.typeName, class: "tok-typeName" },
  { tag: k.namespace, class: "tok-namespace" },
  { tag: k.className, class: "tok-className" },
  { tag: k.macroName, class: "tok-macroName" },
  { tag: k.propertyName, class: "tok-propertyName" },
  { tag: k.operator, class: "tok-operator" },
  { tag: k.comment, class: "tok-comment" },
  { tag: k.meta, class: "tok-meta" },
  { tag: k.invalid, class: "tok-invalid" },
  { tag: k.punctuation, class: "tok-punctuation" }
]);
var gl;
const jn = /* @__PURE__ */ new F();
function Ih(n) {
  return B.define({
    combine: n ? (e) => e.concat(n) : void 0
  });
}
const _h = /* @__PURE__ */ new F();
class kt {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(e, t, i = [], r = "") {
    this.data = e, this.name = r, ee.prototype.hasOwnProperty("tree") || Object.defineProperty(ee.prototype, "tree", { get() {
      return ye(this);
    } }), this.parser = t, this.extension = [
      Zn.of(this),
      ee.languageData.of((s, o, l) => {
        let a = Gc(s, o, l), h = a.type.prop(jn);
        if (!h)
          return [];
        let u = s.facet(h), c = a.type.prop(_h);
        if (c) {
          let f = a.resolve(o - a.from, l);
          for (let d of c)
            if (d.test(f, s)) {
              let p = s.facet(d.facet);
              return d.type == "replace" ? p : p.concat(u);
            }
        }
        return u;
      })
    ].concat(i);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(e, t, i = -1) {
    return Gc(e, t, i).type.prop(jn) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(e) {
    let t = e.facet(Zn);
    if ((t == null ? void 0 : t.data) == this.data)
      return [{ from: 0, to: e.doc.length }];
    if (!t || !t.allowsNesting)
      return [];
    let i = [], r = (s, o) => {
      if (s.prop(jn) == this.data) {
        i.push({ from: o, to: o + s.length });
        return;
      }
      let l = s.prop(F.mounted);
      if (l) {
        if (l.tree.prop(jn) == this.data) {
          if (l.overlay)
            for (let a of l.overlay)
              i.push({ from: a.from + o, to: a.to + o });
          else
            i.push({ from: o, to: o + s.length });
          return;
        } else if (l.overlay) {
          let a = i.length;
          if (r(l.tree, l.overlay[0].from + o), i.length > a)
            return;
        }
      }
      for (let a = 0; a < s.children.length; a++) {
        let h = s.children[a];
        h instanceof ae && r(h, s.positions[a] + o);
      }
    };
    return r(ye(e), 0), i;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
kt.setState = /* @__PURE__ */ K.define();
function Gc(n, e, t) {
  let i = n.facet(Zn), r = ye(n).topNode;
  if (!i || i.allowsNesting)
    for (let s = r; s; s = s.enter(e, t, be.ExcludeBuffers))
      s.type.isTop && (r = s);
  return r;
}
class $i extends kt {
  constructor(e, t, i) {
    super(e, t, [], i), this.parser = t;
  }
  /**
  Define a language from a parser.
  */
  static define(e) {
    let t = Ih(e.languageData);
    return new $i(t, e.parser.configure({
      props: [jn.add((i) => i.isTop ? t : void 0)]
    }), e.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(e, t) {
    return new $i(this.data, this.parser.configure(e), t || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function ye(n) {
  let e = n.field(kt.state, !1);
  return e ? e.tree : ae.empty;
}
class sx {
  /**
  Create an input object for the given document.
  */
  constructor(e) {
    this.doc = e, this.cursorPos = 0, this.string = "", this.cursor = e.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(e) {
    return this.string = this.cursor.next(e - this.cursorPos).value, this.cursorPos = e + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(e) {
    return this.syncTo(e), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(e, t) {
    let i = this.cursorPos - this.string.length;
    return e < i || t >= this.cursorPos ? this.doc.sliceString(e, t) : this.string.slice(e - i, t - i);
  }
}
let Hi = null;
class Rr {
  constructor(e, t, i = [], r, s, o, l, a) {
    this.parser = e, this.state = t, this.fragments = i, this.tree = r, this.treeLen = s, this.viewport = o, this.skipped = l, this.scheduleOn = a, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Rr(e, t, [], ae.empty, 0, i, [], null);
  }
  startParse() {
    return this.parser.startParse(new sx(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(e, t) {
    return t != null && t >= this.state.doc.length && (t = void 0), this.tree != ae.empty && this.isDone(t ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var i;
      if (typeof e == "number") {
        let r = Date.now() + e;
        e = () => Date.now() > r;
      }
      for (this.parse || (this.parse = this.startParse()), t != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > t) && t < this.state.doc.length && this.parse.stopAt(t); ; ) {
        let r = this.parse.advance();
        if (r)
          if (this.fragments = this.withoutTempSkipped(on.addTree(r, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (i = this.parse.stoppedAt) !== null && i !== void 0 ? i : this.state.doc.length, this.tree = r, this.parse = null, this.treeLen < (t ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (e())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let e, t;
    this.parse && (e = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > e) && this.parse.stopAt(e), this.withContext(() => {
      for (; !(t = this.parse.advance()); )
        ;
    }), this.treeLen = e, this.tree = t, this.fragments = this.withoutTempSkipped(on.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(e) {
    let t = Hi;
    Hi = this;
    try {
      return e();
    } finally {
      Hi = t;
    }
  }
  withoutTempSkipped(e) {
    for (let t; t = this.tempSkipped.pop(); )
      e = Hc(e, t.from, t.to);
    return e;
  }
  /**
  @internal
  */
  changes(e, t) {
    let { fragments: i, tree: r, treeLen: s, viewport: o, skipped: l } = this;
    if (this.takeTree(), !e.empty) {
      let a = [];
      if (e.iterChangedRanges((h, u, c, f) => a.push({ fromA: h, toA: u, fromB: c, toB: f })), i = on.applyChanges(i, a), r = ae.empty, s = 0, o = { from: e.mapPos(o.from, -1), to: e.mapPos(o.to, 1) }, this.skipped.length) {
        l = [];
        for (let h of this.skipped) {
          let u = e.mapPos(h.from, 1), c = e.mapPos(h.to, -1);
          u < c && l.push({ from: u, to: c });
        }
      }
    }
    return new Rr(this.parser, t, i, r, s, o, l, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(e) {
    if (this.viewport.from == e.from && this.viewport.to == e.to)
      return !1;
    this.viewport = e;
    let t = this.skipped.length;
    for (let i = 0; i < this.skipped.length; i++) {
      let { from: r, to: s } = this.skipped[i];
      r < e.to && s > e.from && (this.fragments = Hc(this.fragments, r, s), this.skipped.splice(i--, 1));
    }
    return this.skipped.length >= t ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(e, t) {
    this.skipped.push({ from: e, to: t });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(e) {
    return new class extends Lh {
      createParse(t, i, r) {
        let s = r[0].from, o = r[r.length - 1].to;
        return {
          parsedPos: s,
          advance() {
            let a = Hi;
            if (a) {
              for (let h of r)
                a.tempSkipped.push(h);
              e && (a.scheduleOn = a.scheduleOn ? Promise.all([a.scheduleOn, e]) : e);
            }
            return this.parsedPos = o, new ae(ze.none, [], [], o - s);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(e) {
    e = Math.min(e, this.state.doc.length);
    let t = this.fragments;
    return this.treeLen >= e && t.length && t[0].from == 0 && t[0].to >= e;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return Hi;
  }
}
function Hc(n, e, t) {
  return on.applyChanges(n, [{ fromA: e, toA: t, fromB: e, toB: t }]);
}
class Ci {
  constructor(e) {
    this.context = e, this.tree = e.tree;
  }
  apply(e) {
    if (!e.docChanged && this.tree == this.context.tree)
      return this;
    let t = this.context.changes(e.changes, e.state), i = this.context.treeLen == e.startState.doc.length ? void 0 : Math.max(e.changes.mapPos(this.context.treeLen), t.viewport.to);
    return t.work(20, i) || t.takeTree(), new Ci(t);
  }
  static init(e) {
    let t = Math.min(3e3, e.doc.length), i = Rr.create(e.facet(Zn).parser, e, { from: 0, to: t });
    return i.work(20, t) || i.takeTree(), new Ci(i);
  }
}
kt.state = /* @__PURE__ */ De.define({
  create: Ci.init,
  update(n, e) {
    for (let t of e.effects)
      if (t.is(kt.setState))
        return t.value;
    return e.startState.facet(Zn) != e.state.facet(Zn) ? Ci.init(e.state) : n.apply(e);
  }
});
let Wm = (n) => {
  let e = setTimeout(
    () => n(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(e);
};
typeof requestIdleCallback < "u" && (Wm = (n) => {
  let e = -1, t = setTimeout(
    () => {
      e = requestIdleCallback(n, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => e < 0 ? clearTimeout(t) : cancelIdleCallback(e);
});
const bl = typeof navigator < "u" && (!((gl = navigator.scheduling) === null || gl === void 0) && gl.isInputPending) ? () => navigator.scheduling.isInputPending() : null, ox = /* @__PURE__ */ Qe.fromClass(class {
  constructor(e) {
    this.view = e, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(e) {
    let t = this.view.state.field(kt.state).context;
    (t.updateViewport(e.view.viewport) || this.view.viewport.to > t.treeLen) && this.scheduleWork(), (e.docChanged || e.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(t);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: e } = this.view, t = e.field(kt.state);
    (t.tree != t.context.tree || !t.context.isDone(e.doc.length)) && (this.working = Wm(this.work));
  }
  work(e) {
    this.working = null;
    let t = Date.now();
    if (this.chunkEnd < t && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = t + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: i, viewport: { to: r } } = this.view, s = i.field(kt.state);
    if (s.tree == s.context.tree && s.context.isDone(
      r + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let o = Date.now() + Math.min(this.chunkBudget, 100, e && !bl ? Math.max(25, e.timeRemaining() - 5) : 1e9), l = s.context.treeLen < r && i.doc.length > r + 1e3, a = s.context.work(() => bl && bl() || Date.now() > o, r + (l ? 0 : 1e5));
    this.chunkBudget -= Date.now() - t, (a || this.chunkBudget <= 0) && (s.context.takeTree(), this.view.dispatch({ effects: kt.setState.of(new Ci(s.context)) })), this.chunkBudget > 0 && !(a && !l) && this.scheduleWork(), this.checkAsyncSchedule(s.context);
  }
  checkAsyncSchedule(e) {
    e.scheduleOn && (this.workScheduled++, e.scheduleOn.then(() => this.scheduleWork()).catch((t) => it(this.view.state, t)).then(() => this.workScheduled--), e.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), Zn = /* @__PURE__ */ B.define({
  combine(n) {
    return n.length ? n[0] : null;
  },
  enables: (n) => [
    kt.state,
    ox,
    I.contentAttributes.compute([n], (e) => {
      let t = e.facet(n);
      return t && t.name ? { "data-language": t.name } : {};
    })
  ]
});
class Zr {
  /**
  Create a language support object.
  */
  constructor(e, t = []) {
    this.language = e, this.support = t, this.extension = [e, t];
  }
}
class lo {
  constructor(e, t, i, r, s, o = void 0) {
    this.name = e, this.alias = t, this.extensions = i, this.filename = r, this.loadFunc = s, this.support = o, this.loading = null;
  }
  /**
  Start loading the the language. Will return a promise that
  resolves to a [`LanguageSupport`](https://codemirror.net/6/docs/ref/#language.LanguageSupport)
  object when the language successfully loads.
  */
  load() {
    return this.loading || (this.loading = this.loadFunc().then((e) => this.support = e, (e) => {
      throw this.loading = null, e;
    }));
  }
  /**
  Create a language description.
  */
  static of(e) {
    let { load: t, support: i } = e;
    if (!t) {
      if (!i)
        throw new RangeError("Must pass either 'load' or 'support' to LanguageDescription.of");
      t = () => Promise.resolve(i);
    }
    return new lo(e.name, (e.alias || []).concat(e.name).map((r) => r.toLowerCase()), e.extensions || [], e.filename, t, i);
  }
  /**
  Look for a language in the given array of descriptions that
  matches the filename. Will first match
  [`filename`](https://codemirror.net/6/docs/ref/#language.LanguageDescription.filename) patterns,
  and then [extensions](https://codemirror.net/6/docs/ref/#language.LanguageDescription.extensions),
  and return the first language that matches.
  */
  static matchFilename(e, t) {
    for (let r of e)
      if (r.filename && r.filename.test(t))
        return r;
    let i = /\.([^.]+)$/.exec(t);
    if (i) {
      for (let r of e)
        if (r.extensions.indexOf(i[1]) > -1)
          return r;
    }
    return null;
  }
  /**
  Look for a language whose name or alias matches the the given
  name (case-insensitively). If `fuzzy` is true, and no direct
  matchs is found, this'll also search for a language whose name
  or alias occurs in the string (for names shorter than three
  characters, only when surrounded by non-word characters).
  */
  static matchLanguageName(e, t, i = !0) {
    t = t.toLowerCase();
    for (let r of e)
      if (r.alias.some((s) => s == t))
        return r;
    if (i)
      for (let r of e)
        for (let s of r.alias) {
          let o = t.indexOf(s);
          if (o > -1 && (s.length > 2 || !/\w/.test(t[o - 1]) && !/\w/.test(t[o + s.length])))
            return r;
        }
    return null;
  }
}
const lx = /* @__PURE__ */ B.define(), Di = /* @__PURE__ */ B.define({
  combine: (n) => {
    if (!n.length)
      return "  ";
    let e = n[0];
    if (!e || /\S/.test(e) || Array.from(e).some((t) => t != e[0]))
      throw new Error("Invalid indent unit: " + JSON.stringify(n[0]));
    return e;
  }
});
function ao(n) {
  let e = n.facet(Di);
  return e.charCodeAt(0) == 9 ? n.tabSize * e.length : e.length;
}
function Mr(n, e) {
  let t = "", i = n.tabSize, r = n.facet(Di)[0];
  if (r == "	") {
    for (; e >= i; )
      t += "	", e -= i;
    r = " ";
  }
  for (let s = 0; s < e; s++)
    t += r;
  return t;
}
function qh(n, e) {
  n instanceof ee && (n = new _o(n));
  for (let i of n.state.facet(lx)) {
    let r = i(n, e);
    if (r !== void 0)
      return r;
  }
  let t = ye(n.state);
  return t.length >= e ? ax(n, t, e) : null;
}
class _o {
  /**
  Create an indent context.
  */
  constructor(e, t = {}) {
    this.state = e, this.options = t, this.unit = ao(e);
  }
  /**
  Get a description of the line at the given position, taking
  [simulated line
  breaks](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  into account. If there is such a break at `pos`, the `bias`
  argument determines whether the part of the line line before or
  after the break is used.
  */
  lineAt(e, t = 1) {
    let i = this.state.doc.lineAt(e), { simulateBreak: r, simulateDoubleBreak: s } = this.options;
    return r != null && r >= i.from && r <= i.to ? s && r == e ? { text: "", from: e } : (t < 0 ? r < e : r <= e) ? { text: i.text.slice(r - i.from), from: r } : { text: i.text.slice(0, r - i.from), from: i.from } : i;
  }
  /**
  Get the text directly after `pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  textAfterPos(e, t = 1) {
    if (this.options.simulateDoubleBreak && e == this.options.simulateBreak)
      return "";
    let { text: i, from: r } = this.lineAt(e, t);
    return i.slice(e - r, Math.min(i.length, e + 100 - r));
  }
  /**
  Find the column for the given position.
  */
  column(e, t = 1) {
    let { text: i, from: r } = this.lineAt(e, t), s = this.countColumn(i, e - r), o = this.options.overrideIndentation ? this.options.overrideIndentation(r) : -1;
    return o > -1 && (s += o - this.countColumn(i, i.search(/\S|$/))), s;
  }
  /**
  Find the column position (taking tabs into account) of the given
  position in the given string.
  */
  countColumn(e, t = e.length) {
    return Mt(e, this.state.tabSize, t);
  }
  /**
  Find the indentation column of the line at the given point.
  */
  lineIndent(e, t = 1) {
    let { text: i, from: r } = this.lineAt(e, t), s = this.options.overrideIndentation;
    if (s) {
      let o = s(r);
      if (o > -1)
        return o;
    }
    return this.countColumn(i, i.search(/\S|$/));
  }
  /**
  Returns the [simulated line
  break](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  for this context, if any.
  */
  get simulatedBreak() {
    return this.options.simulateBreak || null;
  }
}
const Ur = /* @__PURE__ */ new F();
function ax(n, e, t) {
  let i = e.resolveStack(t), r = i.node.enterUnfinishedNodesBefore(t);
  if (r != i.node) {
    let s = [];
    for (let o = r; o != i.node; o = o.parent)
      s.push(o);
    for (let o = s.length - 1; o >= 0; o--)
      i = { node: s[o], next: i };
  }
  return Bm(i, n, t);
}
function Bm(n, e, t) {
  for (let i = n; i; i = i.next) {
    let r = ux(i.node);
    if (r)
      return r(Wh.create(e, t, i));
  }
  return 0;
}
function hx(n) {
  return n.pos == n.options.simulateBreak && n.options.simulateDoubleBreak;
}
function ux(n) {
  let e = n.type.prop(Ur);
  if (e)
    return e;
  let t = n.firstChild, i;
  if (t && (i = t.type.prop(F.closedBy))) {
    let r = n.lastChild, s = r && i.indexOf(r.name) > -1;
    return (o) => Vm(o, !0, 1, void 0, s && !hx(o) ? r.from : void 0);
  }
  return n.parent == null ? cx : null;
}
function cx() {
  return 0;
}
class Wh extends _o {
  constructor(e, t, i) {
    super(e.state, e.options), this.base = e, this.pos = t, this.context = i;
  }
  /**
  The syntax tree node to which the indentation strategy
  applies.
  */
  get node() {
    return this.context.node;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Wh(e, t, i);
  }
  /**
  Get the text directly after `this.pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  get textAfter() {
    return this.textAfterPos(this.pos);
  }
  /**
  Get the indentation at the reference line for `this.node`, which
  is the line on which it starts, unless there is a node that is
  _not_ a parent of this node covering the start of that line. If
  so, the line at the start of that node is tried, again skipping
  on if it is covered by another such node.
  */
  get baseIndent() {
    return this.baseIndentFor(this.node);
  }
  /**
  Get the indentation for the reference line of the given node
  (see [`baseIndent`](https://codemirror.net/6/docs/ref/#language.TreeIndentContext.baseIndent)).
  */
  baseIndentFor(e) {
    let t = this.state.doc.lineAt(e.from);
    for (; ; ) {
      let i = e.resolve(t.from);
      for (; i.parent && i.parent.from == i.from; )
        i = i.parent;
      if (fx(i, e))
        break;
      t = this.state.doc.lineAt(i.from);
    }
    return this.lineIndent(t.from);
  }
  /**
  Continue looking for indentations in the node's parent nodes,
  and return the result of that.
  */
  continue() {
    return Bm(this.context.next, this.base, this.pos);
  }
}
function fx(n, e) {
  for (let t = e; t; t = t.parent)
    if (n == t)
      return !0;
  return !1;
}
function dx(n) {
  let e = n.node, t = e.childAfter(e.from), i = e.lastChild;
  if (!t)
    return null;
  let r = n.options.simulateBreak, s = n.state.doc.lineAt(t.from), o = r == null || r <= s.from ? s.to : Math.min(s.to, r);
  for (let l = t.to; ; ) {
    let a = e.childAfter(l);
    if (!a || a == i)
      return null;
    if (!a.type.isSkipped)
      return a.from < o ? t : null;
    l = a.to;
  }
}
function px({ closing: n, align: e = !0, units: t = 1 }) {
  return (i) => Vm(i, e, t, n);
}
function Vm(n, e, t, i, r) {
  let s = n.textAfter, o = s.match(/^\s*/)[0].length, l = i && s.slice(o, o + i.length) == i || r == n.pos + o, a = e ? dx(n) : null;
  return a ? l ? n.column(a.from) : n.column(a.to) : n.baseIndent + (l ? 0 : n.unit * t);
}
const mx = (n) => n.baseIndent;
function Vs({ except: n, units: e = 1 } = {}) {
  return (t) => {
    let i = n && n.test(t.textAfter);
    return t.baseIndent + (i ? 0 : e * t.unit);
  };
}
const Ox = 200;
function gx() {
  return ee.transactionFilter.of((n) => {
    if (!n.docChanged || !n.isUserEvent("input.type") && !n.isUserEvent("input.complete"))
      return n;
    let e = n.startState.languageDataAt("indentOnInput", n.startState.selection.main.head);
    if (!e.length)
      return n;
    let t = n.newDoc, { head: i } = n.newSelection.main, r = t.lineAt(i);
    if (i > r.from + Ox)
      return n;
    let s = t.sliceString(r.from, i);
    if (!e.some((h) => h.test(s)))
      return n;
    let { state: o } = n, l = -1, a = [];
    for (let { head: h } of o.selection.ranges) {
      let u = o.doc.lineAt(h);
      if (u.from == l)
        continue;
      l = u.from;
      let c = qh(o, u.from);
      if (c == null)
        continue;
      let f = /^\s*/.exec(u.text)[0], d = Mr(o, c);
      f != d && a.push({ from: u.from, to: u.from + f.length, insert: d });
    }
    return a.length ? [n, { changes: a, sequential: !0 }] : n;
  });
}
const Ym = /* @__PURE__ */ B.define(), Li = /* @__PURE__ */ new F();
function jm(n) {
  let e = n.firstChild, t = n.lastChild;
  return e && e.to < t.from ? { from: e.to, to: t.type.isError ? n.to : t.from } : null;
}
function bx(n, e, t) {
  let i = ye(n);
  if (i.length < t)
    return null;
  let r = i.resolveStack(t, 1), s = null;
  for (let o = r; o; o = o.next) {
    let l = o.node;
    if (l.to <= t || l.from > t)
      continue;
    if (s && l.from < e)
      break;
    let a = l.type.prop(Li);
    if (a && (l.to < i.length - 50 || i.length == n.doc.length || !yx(l))) {
      let h = a(l, n);
      h && h.from <= t && h.from >= e && h.to > t && (s = h);
    }
  }
  return s;
}
function yx(n) {
  let e = n.lastChild;
  return e && e.to == n.to && e.type.isError;
}
function ho(n, e, t) {
  for (let i of n.facet(Ym)) {
    let r = i(n, e, t);
    if (r)
      return r;
  }
  return bx(n, e, t);
}
function Nm(n, e) {
  let t = e.mapPos(n.from, 1), i = e.mapPos(n.to, -1);
  return t >= i ? void 0 : { from: t, to: i };
}
const qo = /* @__PURE__ */ K.define({ map: Nm }), Fr = /* @__PURE__ */ K.define({ map: Nm });
function Um(n) {
  let e = [];
  for (let { head: t } of n.state.selection.ranges)
    e.some((i) => i.from <= t && i.to >= t) || e.push(n.lineBlockAt(t));
  return e;
}
const Kn = /* @__PURE__ */ De.define({
  create() {
    return j.none;
  },
  update(n, e) {
    n = n.map(e.changes);
    for (let t of e.effects)
      if (t.is(qo) && !kx(n, t.value.from, t.value.to)) {
        let { preparePlaceholder: i } = e.state.facet(Hm), r = i ? j.replace({ widget: new $x(i(e.state, t.value)) }) : Kc;
        n = n.update({ add: [r.range(t.value.from, t.value.to)] });
      } else
        t.is(Fr) && (n = n.update({
          filter: (i, r) => t.value.from != i || t.value.to != r,
          filterFrom: t.value.from,
          filterTo: t.value.to
        }));
    if (e.selection) {
      let t = !1, { head: i } = e.selection.main;
      n.between(i, i, (r, s) => {
        r < i && s > i && (t = !0);
      }), t && (n = n.update({
        filterFrom: i,
        filterTo: i,
        filter: (r, s) => s <= i || r >= i
      }));
    }
    return n;
  },
  provide: (n) => I.decorations.from(n),
  toJSON(n, e) {
    let t = [];
    return n.between(0, e.doc.length, (i, r) => {
      t.push(i, r);
    }), t;
  },
  fromJSON(n) {
    if (!Array.isArray(n) || n.length % 2)
      throw new RangeError("Invalid JSON for fold state");
    let e = [];
    for (let t = 0; t < n.length; ) {
      let i = n[t++], r = n[t++];
      if (typeof i != "number" || typeof r != "number")
        throw new RangeError("Invalid JSON for fold state");
      e.push(Kc.range(i, r));
    }
    return j.set(e, !0);
  }
});
function uo(n, e, t) {
  var i;
  let r = null;
  return (i = n.field(Kn, !1)) === null || i === void 0 || i.between(e, t, (s, o) => {
    (!r || r.from > s) && (r = { from: s, to: o });
  }), r;
}
function kx(n, e, t) {
  let i = !1;
  return n.between(e, e, (r, s) => {
    r == e && s == t && (i = !0);
  }), i;
}
function Fm(n, e) {
  return n.field(Kn, !1) ? e : e.concat(K.appendConfig.of(Km()));
}
const xx = (n) => {
  for (let e of Um(n)) {
    let t = ho(n.state, e.from, e.to);
    if (t)
      return n.dispatch({ effects: Fm(n.state, [qo.of(t), Gm(n, t)]) }), !0;
  }
  return !1;
}, wx = (n) => {
  if (!n.state.field(Kn, !1))
    return !1;
  let e = [];
  for (let t of Um(n)) {
    let i = uo(n.state, t.from, t.to);
    i && e.push(Fr.of(i), Gm(n, i, !1));
  }
  return e.length && n.dispatch({ effects: e }), e.length > 0;
};
function Gm(n, e, t = !0) {
  let i = n.state.doc.lineAt(e.from).number, r = n.state.doc.lineAt(e.to).number;
  return I.announce.of(`${n.state.phrase(t ? "Folded lines" : "Unfolded lines")} ${i} ${n.state.phrase("to")} ${r}.`);
}
const Sx = (n) => {
  let { state: e } = n, t = [];
  for (let i = 0; i < e.doc.length; ) {
    let r = n.lineBlockAt(i), s = ho(e, r.from, r.to);
    s && t.push(qo.of(s)), i = (s ? n.lineBlockAt(s.to) : r).to + 1;
  }
  return t.length && n.dispatch({ effects: Fm(n.state, t) }), !!t.length;
}, vx = (n) => {
  let e = n.state.field(Kn, !1);
  if (!e || !e.size)
    return !1;
  let t = [];
  return e.between(0, n.state.doc.length, (i, r) => {
    t.push(Fr.of({ from: i, to: r }));
  }), n.dispatch({ effects: t }), !0;
}, Px = [
  { key: "Ctrl-Shift-[", mac: "Cmd-Alt-[", run: xx },
  { key: "Ctrl-Shift-]", mac: "Cmd-Alt-]", run: wx },
  { key: "Ctrl-Alt-[", run: Sx },
  { key: "Ctrl-Alt-]", run: vx }
], Qx = {
  placeholderDOM: null,
  preparePlaceholder: null,
  placeholderText: "…"
}, Hm = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, Qx);
  }
});
function Km(n) {
  return [Kn, Ax];
}
function Jm(n, e) {
  let { state: t } = n, i = t.facet(Hm), r = (o) => {
    let l = n.lineBlockAt(n.posAtDOM(o.target)), a = uo(n.state, l.from, l.to);
    a && n.dispatch({ effects: Fr.of(a) }), o.preventDefault();
  };
  if (i.placeholderDOM)
    return i.placeholderDOM(n, r, e);
  let s = document.createElement("span");
  return s.textContent = i.placeholderText, s.setAttribute("aria-label", t.phrase("folded code")), s.title = t.phrase("unfold"), s.className = "cm-foldPlaceholder", s.onclick = r, s;
}
const Kc = /* @__PURE__ */ j.replace({ widget: /* @__PURE__ */ new class extends Kt {
  toDOM(n) {
    return Jm(n, null);
  }
}() });
class $x extends Kt {
  constructor(e) {
    super(), this.value = e;
  }
  eq(e) {
    return this.value == e.value;
  }
  toDOM(e) {
    return Jm(e, this.value);
  }
}
const Cx = {
  openText: "⌄",
  closedText: "›",
  markerDOM: null,
  domEventHandlers: {},
  foldingChanged: () => !1
};
class yl extends hn {
  constructor(e, t) {
    super(), this.config = e, this.open = t;
  }
  eq(e) {
    return this.config == e.config && this.open == e.open;
  }
  toDOM(e) {
    if (this.config.markerDOM)
      return this.config.markerDOM(this.open);
    let t = document.createElement("span");
    return t.textContent = this.open ? this.config.openText : this.config.closedText, t.title = e.state.phrase(this.open ? "Fold line" : "Unfold line"), t;
  }
}
function Tx(n = {}) {
  let e = Object.assign(Object.assign({}, Cx), n), t = new yl(e, !0), i = new yl(e, !1), r = Qe.fromClass(class {
    constructor(o) {
      this.from = o.viewport.from, this.markers = this.buildMarkers(o);
    }
    update(o) {
      (o.docChanged || o.viewportChanged || o.startState.facet(Zn) != o.state.facet(Zn) || o.startState.field(Kn, !1) != o.state.field(Kn, !1) || ye(o.startState) != ye(o.state) || e.foldingChanged(o)) && (this.markers = this.buildMarkers(o.view));
    }
    buildMarkers(o) {
      let l = new $n();
      for (let a of o.viewportLineBlocks) {
        let h = uo(o.state, a.from, a.to) ? i : ho(o.state, a.from, a.to) ? t : null;
        h && l.add(a.from, a.from, h);
      }
      return l.finish();
    }
  }), { domEventHandlers: s } = e;
  return [
    r,
    Ck({
      class: "cm-foldGutter",
      markers(o) {
        var l;
        return ((l = o.plugin(r)) === null || l === void 0 ? void 0 : l.markers) || oe.empty;
      },
      initialSpacer() {
        return new yl(e, !1);
      },
      domEventHandlers: Object.assign(Object.assign({}, s), { click: (o, l, a) => {
        if (s.click && s.click(o, l, a))
          return !0;
        let h = uo(o.state, l.from, l.to);
        if (h)
          return o.dispatch({ effects: Fr.of(h) }), !0;
        let u = ho(o.state, l.from, l.to);
        return u ? (o.dispatch({ effects: qo.of(u) }), !0) : !1;
      } })
    }),
    Km()
  ];
}
const Ax = /* @__PURE__ */ I.baseTheme({
  ".cm-foldPlaceholder": {
    backgroundColor: "#eee",
    border: "1px solid #ddd",
    color: "#888",
    borderRadius: ".2em",
    margin: "0 1px",
    padding: "0 1px",
    cursor: "pointer"
  },
  ".cm-foldGutter span": {
    padding: "0 1px",
    cursor: "pointer"
  }
});
class Wo {
  constructor(e, t) {
    this.specs = e;
    let i;
    function r(l) {
      let a = Cn.newName();
      return (i || (i = /* @__PURE__ */ Object.create(null)))["." + a] = l, a;
    }
    const s = typeof t.all == "string" ? t.all : t.all ? r(t.all) : void 0, o = t.scope;
    this.scope = o instanceof kt ? (l) => l.prop(jn) == o.data : o ? (l) => l == o : void 0, this.style = qm(e.map((l) => ({
      tag: l.tag,
      class: l.class || r(Object.assign({}, l, { tag: null }))
    })), {
      all: s
    }).style, this.module = i ? new Cn(i) : null, this.themeType = t.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(e, t) {
    return new Wo(e, t || {});
  }
}
const Ba = /* @__PURE__ */ B.define(), eO = /* @__PURE__ */ B.define({
  combine(n) {
    return n.length ? [n[0]] : null;
  }
});
function kl(n) {
  let e = n.facet(Ba);
  return e.length ? e : n.facet(eO);
}
function Rx(n, e) {
  let t = [Mx], i;
  return n instanceof Wo && (n.module && t.push(I.styleModule.of(n.module)), i = n.themeType), e != null && e.fallback ? t.push(eO.of(n)) : i ? t.push(Ba.computeN([I.darkTheme], (r) => r.facet(I.darkTheme) == (i == "dark") ? [n] : [])) : t.push(Ba.of(n)), t;
}
class Zx {
  constructor(e) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = ye(e.state), this.decorations = this.buildDeco(e, kl(e.state)), this.decoratedTo = e.viewport.to;
  }
  update(e) {
    let t = ye(e.state), i = kl(e.state), r = i != kl(e.startState), { viewport: s } = e.view, o = e.changes.mapPos(this.decoratedTo, 1);
    t.length < s.to && !r && t.type == this.tree.type && o >= s.to ? (this.decorations = this.decorations.map(e.changes), this.decoratedTo = o) : (t != this.tree || e.viewportChanged || r) && (this.tree = t, this.decorations = this.buildDeco(e.view, i), this.decoratedTo = s.to);
  }
  buildDeco(e, t) {
    if (!t || !this.tree.length)
      return j.none;
    let i = new $n();
    for (let { from: r, to: s } of e.visibleRanges)
      nx(this.tree, t, (o, l, a) => {
        i.add(o, l, this.markCache[a] || (this.markCache[a] = j.mark({ class: a })));
      }, r, s);
    return i.finish();
  }
}
const Mx = /* @__PURE__ */ un.high(/* @__PURE__ */ Qe.fromClass(Zx, {
  decorations: (n) => n.decorations
})), Ex = /* @__PURE__ */ Wo.define([
  {
    tag: k.meta,
    color: "#404740"
  },
  {
    tag: k.link,
    textDecoration: "underline"
  },
  {
    tag: k.heading,
    textDecoration: "underline",
    fontWeight: "bold"
  },
  {
    tag: k.emphasis,
    fontStyle: "italic"
  },
  {
    tag: k.strong,
    fontWeight: "bold"
  },
  {
    tag: k.strikethrough,
    textDecoration: "line-through"
  },
  {
    tag: k.keyword,
    color: "#708"
  },
  {
    tag: [k.atom, k.bool, k.url, k.contentSeparator, k.labelName],
    color: "#219"
  },
  {
    tag: [k.literal, k.inserted],
    color: "#164"
  },
  {
    tag: [k.string, k.deleted],
    color: "#a11"
  },
  {
    tag: [k.regexp, k.escape, /* @__PURE__ */ k.special(k.string)],
    color: "#e40"
  },
  {
    tag: /* @__PURE__ */ k.definition(k.variableName),
    color: "#00f"
  },
  {
    tag: /* @__PURE__ */ k.local(k.variableName),
    color: "#30a"
  },
  {
    tag: [k.typeName, k.namespace],
    color: "#085"
  },
  {
    tag: k.className,
    color: "#167"
  },
  {
    tag: [/* @__PURE__ */ k.special(k.variableName), k.macroName],
    color: "#256"
  },
  {
    tag: /* @__PURE__ */ k.definition(k.propertyName),
    color: "#00c"
  },
  {
    tag: k.comment,
    color: "#940"
  },
  {
    tag: k.invalid,
    color: "#f00"
  }
]), zx = /* @__PURE__ */ I.baseTheme({
  "&.cm-focused .cm-matchingBracket": { backgroundColor: "#328c8252" },
  "&.cm-focused .cm-nonmatchingBracket": { backgroundColor: "#bb555544" }
}), tO = 1e4, nO = "()[]{}", iO = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, {
      afterCursor: !0,
      brackets: nO,
      maxScanDistance: tO,
      renderMatch: Lx
    });
  }
}), Xx = /* @__PURE__ */ j.mark({ class: "cm-matchingBracket" }), Dx = /* @__PURE__ */ j.mark({ class: "cm-nonmatchingBracket" });
function Lx(n) {
  let e = [], t = n.matched ? Xx : Dx;
  return e.push(t.range(n.start.from, n.start.to)), n.end && e.push(t.range(n.end.from, n.end.to)), e;
}
const Ix = /* @__PURE__ */ De.define({
  create() {
    return j.none;
  },
  update(n, e) {
    if (!e.docChanged && !e.selection)
      return n;
    let t = [], i = e.state.facet(iO);
    for (let r of e.state.selection.ranges) {
      if (!r.empty)
        continue;
      let s = jt(e.state, r.head, -1, i) || r.head > 0 && jt(e.state, r.head - 1, 1, i) || i.afterCursor && (jt(e.state, r.head, 1, i) || r.head < e.state.doc.length && jt(e.state, r.head + 1, -1, i));
      s && (t = t.concat(i.renderMatch(s, e.state)));
    }
    return j.set(t, !0);
  },
  provide: (n) => I.decorations.from(n)
}), _x = [
  Ix,
  zx
];
function qx(n = {}) {
  return [iO.of(n), _x];
}
const rO = /* @__PURE__ */ new F();
function Va(n, e, t) {
  let i = n.prop(e < 0 ? F.openedBy : F.closedBy);
  if (i)
    return i;
  if (n.name.length == 1) {
    let r = t.indexOf(n.name);
    if (r > -1 && r % 2 == (e < 0 ? 1 : 0))
      return [t[r + e]];
  }
  return null;
}
function Ya(n) {
  let e = n.type.prop(rO);
  return e ? e(n.node) : n;
}
function jt(n, e, t, i = {}) {
  let r = i.maxScanDistance || tO, s = i.brackets || nO, o = ye(n), l = o.resolveInner(e, t);
  for (let a = l; a; a = a.parent) {
    let h = Va(a.type, t, s);
    if (h && a.from < a.to) {
      let u = Ya(a);
      if (u && (t > 0 ? e >= u.from && e < u.to : e > u.from && e <= u.to))
        return Wx(n, e, t, a, u, h, s);
    }
  }
  return Bx(n, e, t, o, l.type, r, s);
}
function Wx(n, e, t, i, r, s, o) {
  let l = i.parent, a = { from: r.from, to: r.to }, h = 0, u = l == null ? void 0 : l.cursor();
  if (u && (t < 0 ? u.childBefore(i.from) : u.childAfter(i.to)))
    do
      if (t < 0 ? u.to <= i.from : u.from >= i.to) {
        if (h == 0 && s.indexOf(u.type.name) > -1 && u.from < u.to) {
          let c = Ya(u);
          return { start: a, end: c ? { from: c.from, to: c.to } : void 0, matched: !0 };
        } else if (Va(u.type, t, o))
          h++;
        else if (Va(u.type, -t, o)) {
          if (h == 0) {
            let c = Ya(u);
            return {
              start: a,
              end: c && c.from < c.to ? { from: c.from, to: c.to } : void 0,
              matched: !1
            };
          }
          h--;
        }
      }
    while (t < 0 ? u.prevSibling() : u.nextSibling());
  return { start: a, matched: !1 };
}
function Bx(n, e, t, i, r, s, o) {
  let l = t < 0 ? n.sliceDoc(e - 1, e) : n.sliceDoc(e, e + 1), a = o.indexOf(l);
  if (a < 0 || a % 2 == 0 != t > 0)
    return null;
  let h = { from: t < 0 ? e - 1 : e, to: t > 0 ? e + 1 : e }, u = n.doc.iterRange(e, t > 0 ? n.doc.length : 0), c = 0;
  for (let f = 0; !u.next().done && f <= s; ) {
    let d = u.value;
    t < 0 && (f += d.length);
    let p = e + f * t;
    for (let m = t > 0 ? 0 : d.length - 1, O = t > 0 ? d.length : -1; m != O; m += t) {
      let g = o.indexOf(d[m]);
      if (!(g < 0 || i.resolveInner(p + m, 1).type != r))
        if (g % 2 == 0 == t > 0)
          c++;
        else {
          if (c == 1)
            return { start: h, end: { from: p + m, to: p + m + 1 }, matched: g >> 1 == a >> 1 };
          c--;
        }
    }
    t > 0 && (f += d.length);
  }
  return u.done ? { start: h, matched: !1 } : null;
}
const Vx = /* @__PURE__ */ Object.create(null), Jc = [ze.none], ef = [], tf = /* @__PURE__ */ Object.create(null), Yx = /* @__PURE__ */ Object.create(null);
for (let [n, e] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Yx[n] = /* @__PURE__ */ jx(Vx, e);
function xl(n, e) {
  ef.indexOf(n) > -1 || (ef.push(n), console.warn(e));
}
function jx(n, e) {
  let t = [];
  for (let l of e.split(" ")) {
    let a = [];
    for (let h of l.split(".")) {
      let u = n[h] || k[h];
      u ? typeof u == "function" ? a.length ? a = a.map(u) : xl(h, `Modifier ${h} used at start of tag`) : a.length ? xl(h, `Tag ${h} used as modifier`) : a = Array.isArray(u) ? u : [u] : xl(h, `Unknown highlighting tag ${h}`);
    }
    for (let h of a)
      t.push(h);
  }
  if (!t.length)
    return 0;
  let i = e.replace(/ /g, "_"), r = i + " " + t.map((l) => l.id), s = tf[r];
  if (s)
    return s.id;
  let o = tf[r] = ze.define({
    id: Jc.length,
    name: i,
    props: [Xi({ [i]: t })]
  });
  return Jc.push(o), o.id;
}
we.RTL, we.LTR;
const Nx = (n) => {
  let { state: e } = n, t = e.doc.lineAt(e.selection.main.from), i = Vh(n.state, t.from);
  return i.line ? Ux(n) : i.block ? Gx(n) : !1;
};
function Bh(n, e) {
  return ({ state: t, dispatch: i }) => {
    if (t.readOnly)
      return !1;
    let r = n(e, t);
    return r ? (i(t.update(r)), !0) : !1;
  };
}
const Ux = /* @__PURE__ */ Bh(
  Jx,
  0
  /* CommentOption.Toggle */
), Fx = /* @__PURE__ */ Bh(
  sO,
  0
  /* CommentOption.Toggle */
), Gx = /* @__PURE__ */ Bh(
  (n, e) => sO(n, e, Kx(e)),
  0
  /* CommentOption.Toggle */
);
function Vh(n, e) {
  let t = n.languageDataAt("commentTokens", e);
  return t.length ? t[0] : {};
}
const Ki = 50;
function Hx(n, { open: e, close: t }, i, r) {
  let s = n.sliceDoc(i - Ki, i), o = n.sliceDoc(r, r + Ki), l = /\s*$/.exec(s)[0].length, a = /^\s*/.exec(o)[0].length, h = s.length - l;
  if (s.slice(h - e.length, h) == e && o.slice(a, a + t.length) == t)
    return {
      open: { pos: i - l, margin: l && 1 },
      close: { pos: r + a, margin: a && 1 }
    };
  let u, c;
  r - i <= 2 * Ki ? u = c = n.sliceDoc(i, r) : (u = n.sliceDoc(i, i + Ki), c = n.sliceDoc(r - Ki, r));
  let f = /^\s*/.exec(u)[0].length, d = /\s*$/.exec(c)[0].length, p = c.length - d - t.length;
  return u.slice(f, f + e.length) == e && c.slice(p, p + t.length) == t ? {
    open: {
      pos: i + f + e.length,
      margin: /\s/.test(u.charAt(f + e.length)) ? 1 : 0
    },
    close: {
      pos: r - d - t.length,
      margin: /\s/.test(c.charAt(p - 1)) ? 1 : 0
    }
  } : null;
}
function Kx(n) {
  let e = [];
  for (let t of n.selection.ranges) {
    let i = n.doc.lineAt(t.from), r = t.to <= i.to ? i : n.doc.lineAt(t.to), s = e.length - 1;
    s >= 0 && e[s].to > i.from ? e[s].to = r.to : e.push({ from: i.from + /^\s*/.exec(i.text)[0].length, to: r.to });
  }
  return e;
}
function sO(n, e, t = e.selection.ranges) {
  let i = t.map((s) => Vh(e, s.from).block);
  if (!i.every((s) => s))
    return null;
  let r = t.map((s, o) => Hx(e, i[o], s.from, s.to));
  if (n != 2 && !r.every((s) => s))
    return { changes: e.changes(t.map((s, o) => r[o] ? [] : [{ from: s.from, insert: i[o].open + " " }, { from: s.to, insert: " " + i[o].close }])) };
  if (n != 1 && r.some((s) => s)) {
    let s = [];
    for (let o = 0, l; o < r.length; o++)
      if (l = r[o]) {
        let a = i[o], { open: h, close: u } = l;
        s.push({ from: h.pos - a.open.length, to: h.pos + h.margin }, { from: u.pos - u.margin, to: u.pos + a.close.length });
      }
    return { changes: s };
  }
  return null;
}
function Jx(n, e, t = e.selection.ranges) {
  let i = [], r = -1;
  for (let { from: s, to: o } of t) {
    let l = i.length, a = 1e9, h = Vh(e, s).line;
    if (h) {
      for (let u = s; u <= o; ) {
        let c = e.doc.lineAt(u);
        if (c.from > r && (s == o || o > c.from)) {
          r = c.from;
          let f = /^\s*/.exec(c.text)[0].length, d = f == c.length, p = c.text.slice(f, f + h.length) == h ? f : -1;
          f < c.text.length && f < a && (a = f), i.push({ line: c, comment: p, token: h, indent: f, empty: d, single: !1 });
        }
        u = c.to + 1;
      }
      if (a < 1e9)
        for (let u = l; u < i.length; u++)
          i[u].indent < i[u].line.text.length && (i[u].indent = a);
      i.length == l + 1 && (i[l].single = !0);
    }
  }
  if (n != 2 && i.some((s) => s.comment < 0 && (!s.empty || s.single))) {
    let s = [];
    for (let { line: l, token: a, indent: h, empty: u, single: c } of i)
      (c || !u) && s.push({ from: l.from + h, insert: a + " " });
    let o = e.changes(s);
    return { changes: o, selection: e.selection.map(o, 1) };
  } else if (n != 1 && i.some((s) => s.comment >= 0)) {
    let s = [];
    for (let { line: o, comment: l, token: a } of i)
      if (l >= 0) {
        let h = o.from + l, u = h + a.length;
        o.text[u - o.from] == " " && u++, s.push({ from: h, to: u });
      }
    return { changes: s };
  }
  return null;
}
const ja = /* @__PURE__ */ cn.define(), ew = /* @__PURE__ */ cn.define(), tw = /* @__PURE__ */ B.define(), oO = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, {
      minDepth: 100,
      newGroupDelay: 500,
      joinToEvent: (e, t) => t
    }, {
      minDepth: Math.max,
      newGroupDelay: Math.min,
      joinToEvent: (e, t) => (i, r) => e(i, r) || t(i, r)
    });
  }
}), lO = /* @__PURE__ */ De.define({
  create() {
    return Nt.empty;
  },
  update(n, e) {
    let t = e.state.facet(oO), i = e.annotation(ja);
    if (i) {
      let a = rt.fromTransaction(e, i.selection), h = i.side, u = h == 0 ? n.undone : n.done;
      return a ? u = co(u, u.length, t.minDepth, a) : u = uO(u, e.startState.selection), new Nt(h == 0 ? i.rest : u, h == 0 ? u : i.rest);
    }
    let r = e.annotation(ew);
    if ((r == "full" || r == "before") && (n = n.isolate()), e.annotation(Re.addToHistory) === !1)
      return e.changes.empty ? n : n.addMapping(e.changes.desc);
    let s = rt.fromTransaction(e), o = e.annotation(Re.time), l = e.annotation(Re.userEvent);
    return s ? n = n.addChanges(s, o, l, t, e) : e.selection && (n = n.addSelection(e.startState.selection, o, l, t.newGroupDelay)), (r == "full" || r == "after") && (n = n.isolate()), n;
  },
  toJSON(n) {
    return { done: n.done.map((e) => e.toJSON()), undone: n.undone.map((e) => e.toJSON()) };
  },
  fromJSON(n) {
    return new Nt(n.done.map(rt.fromJSON), n.undone.map(rt.fromJSON));
  }
});
function nw(n = {}) {
  return [
    lO,
    oO.of(n),
    I.domEventHandlers({
      beforeinput(e, t) {
        let i = e.inputType == "historyUndo" ? aO : e.inputType == "historyRedo" ? Na : null;
        return i ? (e.preventDefault(), i(t)) : !1;
      }
    })
  ];
}
function Bo(n, e) {
  return function({ state: t, dispatch: i }) {
    if (!e && t.readOnly)
      return !1;
    let r = t.field(lO, !1);
    if (!r)
      return !1;
    let s = r.pop(n, t, e);
    return s ? (i(s), !0) : !1;
  };
}
const aO = /* @__PURE__ */ Bo(0, !1), Na = /* @__PURE__ */ Bo(1, !1), iw = /* @__PURE__ */ Bo(0, !0), rw = /* @__PURE__ */ Bo(1, !0);
class rt {
  constructor(e, t, i, r, s) {
    this.changes = e, this.effects = t, this.mapped = i, this.startSelection = r, this.selectionsAfter = s;
  }
  setSelAfter(e) {
    return new rt(this.changes, this.effects, this.mapped, this.startSelection, e);
  }
  toJSON() {
    var e, t, i;
    return {
      changes: (e = this.changes) === null || e === void 0 ? void 0 : e.toJSON(),
      mapped: (t = this.mapped) === null || t === void 0 ? void 0 : t.toJSON(),
      startSelection: (i = this.startSelection) === null || i === void 0 ? void 0 : i.toJSON(),
      selectionsAfter: this.selectionsAfter.map((r) => r.toJSON())
    };
  }
  static fromJSON(e) {
    return new rt(e.changes && Ee.fromJSON(e.changes), [], e.mapped && Ut.fromJSON(e.mapped), e.startSelection && $.fromJSON(e.startSelection), e.selectionsAfter.map($.fromJSON));
  }
  // This does not check `addToHistory` and such, it assumes the
  // transaction needs to be converted to an item. Returns null when
  // there are no changes or effects in the transaction.
  static fromTransaction(e, t) {
    let i = xt;
    for (let r of e.startState.facet(tw)) {
      let s = r(e);
      s.length && (i = i.concat(s));
    }
    return !i.length && e.changes.empty ? null : new rt(e.changes.invert(e.startState.doc), i, void 0, t || e.startState.selection, xt);
  }
  static selection(e) {
    return new rt(void 0, xt, void 0, void 0, e);
  }
}
function co(n, e, t, i) {
  let r = e + 1 > t + 20 ? e - t - 1 : 0, s = n.slice(r, e);
  return s.push(i), s;
}
function sw(n, e) {
  let t = [], i = !1;
  return n.iterChangedRanges((r, s) => t.push(r, s)), e.iterChangedRanges((r, s, o, l) => {
    for (let a = 0; a < t.length; ) {
      let h = t[a++], u = t[a++];
      l >= h && o <= u && (i = !0);
    }
  }), i;
}
function ow(n, e) {
  return n.ranges.length == e.ranges.length && n.ranges.filter((t, i) => t.empty != e.ranges[i].empty).length === 0;
}
function hO(n, e) {
  return n.length ? e.length ? n.concat(e) : n : e;
}
const xt = [], lw = 200;
function uO(n, e) {
  if (n.length) {
    let t = n[n.length - 1], i = t.selectionsAfter.slice(Math.max(0, t.selectionsAfter.length - lw));
    return i.length && i[i.length - 1].eq(e) ? n : (i.push(e), co(n, n.length - 1, 1e9, t.setSelAfter(i)));
  } else
    return [rt.selection([e])];
}
function aw(n) {
  let e = n[n.length - 1], t = n.slice();
  return t[n.length - 1] = e.setSelAfter(e.selectionsAfter.slice(0, e.selectionsAfter.length - 1)), t;
}
function wl(n, e) {
  if (!n.length)
    return n;
  let t = n.length, i = xt;
  for (; t; ) {
    let r = hw(n[t - 1], e, i);
    if (r.changes && !r.changes.empty || r.effects.length) {
      let s = n.slice(0, t);
      return s[t - 1] = r, s;
    } else
      e = r.mapped, t--, i = r.selectionsAfter;
  }
  return i.length ? [rt.selection(i)] : xt;
}
function hw(n, e, t) {
  let i = hO(n.selectionsAfter.length ? n.selectionsAfter.map((l) => l.map(e)) : xt, t);
  if (!n.changes)
    return rt.selection(i);
  let r = n.changes.map(e), s = e.mapDesc(n.changes, !0), o = n.mapped ? n.mapped.composeDesc(s) : s;
  return new rt(r, K.mapEffects(n.effects, e), o, n.startSelection.map(s), i);
}
const uw = /^(input\.type|delete)($|\.)/;
class Nt {
  constructor(e, t, i = 0, r = void 0) {
    this.done = e, this.undone = t, this.prevTime = i, this.prevUserEvent = r;
  }
  isolate() {
    return this.prevTime ? new Nt(this.done, this.undone) : this;
  }
  addChanges(e, t, i, r, s) {
    let o = this.done, l = o[o.length - 1];
    return l && l.changes && !l.changes.empty && e.changes && (!i || uw.test(i)) && (!l.selectionsAfter.length && t - this.prevTime < r.newGroupDelay && r.joinToEvent(s, sw(l.changes, e.changes)) || // For compose (but not compose.start) events, always join with previous event
    i == "input.type.compose") ? o = co(o, o.length - 1, r.minDepth, new rt(e.changes.compose(l.changes), hO(e.effects, l.effects), l.mapped, l.startSelection, xt)) : o = co(o, o.length, r.minDepth, e), new Nt(o, xt, t, i);
  }
  addSelection(e, t, i, r) {
    let s = this.done.length ? this.done[this.done.length - 1].selectionsAfter : xt;
    return s.length > 0 && t - this.prevTime < r && i == this.prevUserEvent && i && /^select($|\.)/.test(i) && ow(s[s.length - 1], e) ? this : new Nt(uO(this.done, e), this.undone, t, i);
  }
  addMapping(e) {
    return new Nt(wl(this.done, e), wl(this.undone, e), this.prevTime, this.prevUserEvent);
  }
  pop(e, t, i) {
    let r = e == 0 ? this.done : this.undone;
    if (r.length == 0)
      return null;
    let s = r[r.length - 1], o = s.selectionsAfter[0] || t.selection;
    if (i && s.selectionsAfter.length)
      return t.update({
        selection: s.selectionsAfter[s.selectionsAfter.length - 1],
        annotations: ja.of({ side: e, rest: aw(r), selection: o }),
        userEvent: e == 0 ? "select.undo" : "select.redo",
        scrollIntoView: !0
      });
    if (s.changes) {
      let l = r.length == 1 ? xt : r.slice(0, r.length - 1);
      return s.mapped && (l = wl(l, s.mapped)), t.update({
        changes: s.changes,
        selection: s.startSelection,
        effects: s.effects,
        annotations: ja.of({ side: e, rest: l, selection: o }),
        filter: !1,
        userEvent: e == 0 ? "undo" : "redo",
        scrollIntoView: !0
      });
    } else
      return null;
  }
}
Nt.empty = /* @__PURE__ */ new Nt(xt, xt);
const cw = [
  { key: "Mod-z", run: aO, preventDefault: !0 },
  { key: "Mod-y", mac: "Mod-Shift-z", run: Na, preventDefault: !0 },
  { linux: "Ctrl-Shift-z", run: Na, preventDefault: !0 },
  { key: "Mod-u", run: iw, preventDefault: !0 },
  { key: "Alt-u", mac: "Mod-Shift-u", run: rw, preventDefault: !0 }
];
function Ii(n, e) {
  return $.create(n.ranges.map(e), n.mainIndex);
}
function Jt(n, e) {
  return n.update({ selection: e, scrollIntoView: !0, userEvent: "select" });
}
function Xt({ state: n, dispatch: e }, t) {
  let i = Ii(n.selection, t);
  return i.eq(n.selection, !0) ? !1 : (e(Jt(n, i)), !0);
}
function Vo(n, e) {
  return $.cursor(e ? n.to : n.from);
}
function cO(n, e) {
  return Xt(n, (t) => t.empty ? n.moveByChar(t, e) : Vo(t, e));
}
function Ue(n) {
  return n.textDirectionAt(n.state.selection.main.head) == we.LTR;
}
const fO = (n) => cO(n, !Ue(n)), dO = (n) => cO(n, Ue(n));
function pO(n, e) {
  return Xt(n, (t) => t.empty ? n.moveByGroup(t, e) : Vo(t, e));
}
const fw = (n) => pO(n, !Ue(n)), dw = (n) => pO(n, Ue(n));
function pw(n, e, t) {
  if (e.type.prop(t))
    return !0;
  let i = e.to - e.from;
  return i && (i > 2 || /[^\s,.;:]/.test(n.sliceDoc(e.from, e.to))) || e.firstChild;
}
function Yo(n, e, t) {
  let i = ye(n).resolveInner(e.head), r = t ? F.closedBy : F.openedBy;
  for (let a = e.head; ; ) {
    let h = t ? i.childAfter(a) : i.childBefore(a);
    if (!h)
      break;
    pw(n, h, r) ? i = h : a = t ? h.to : h.from;
  }
  let s = i.type.prop(r), o, l;
  return s && (o = t ? jt(n, i.from, 1) : jt(n, i.to, -1)) && o.matched ? l = t ? o.end.to : o.end.from : l = t ? i.to : i.from, $.cursor(l, t ? -1 : 1);
}
const mw = (n) => Xt(n, (e) => Yo(n.state, e, !Ue(n))), Ow = (n) => Xt(n, (e) => Yo(n.state, e, Ue(n)));
function mO(n, e) {
  return Xt(n, (t) => {
    if (!t.empty)
      return Vo(t, e);
    let i = n.moveVertically(t, e);
    return i.head != t.head ? i : n.moveToLineBoundary(t, e);
  });
}
const OO = (n) => mO(n, !1), gO = (n) => mO(n, !0);
function bO(n) {
  let e = n.scrollDOM.clientHeight < n.scrollDOM.scrollHeight - 2, t = 0, i = 0, r;
  if (e) {
    for (let s of n.state.facet(I.scrollMargins)) {
      let o = s(n);
      o != null && o.top && (t = Math.max(o == null ? void 0 : o.top, t)), o != null && o.bottom && (i = Math.max(o == null ? void 0 : o.bottom, i));
    }
    r = n.scrollDOM.clientHeight - t - i;
  } else
    r = (n.dom.ownerDocument.defaultView || window).innerHeight;
  return {
    marginTop: t,
    marginBottom: i,
    selfScroll: e,
    height: Math.max(n.defaultLineHeight, r - 5)
  };
}
function yO(n, e) {
  let t = bO(n), { state: i } = n, r = Ii(i.selection, (o) => o.empty ? n.moveVertically(o, e, t.height) : Vo(o, e));
  if (r.eq(i.selection))
    return !1;
  let s;
  if (t.selfScroll) {
    let o = n.coordsAtPos(i.selection.main.head), l = n.scrollDOM.getBoundingClientRect(), a = l.top + t.marginTop, h = l.bottom - t.marginBottom;
    o && o.top > a && o.bottom < h && (s = I.scrollIntoView(r.main.head, { y: "start", yMargin: o.top - a }));
  }
  return n.dispatch(Jt(i, r), { effects: s }), !0;
}
const nf = (n) => yO(n, !1), Ua = (n) => yO(n, !0);
function Mn(n, e, t) {
  let i = n.lineBlockAt(e.head), r = n.moveToLineBoundary(e, t);
  if (r.head == e.head && r.head != (t ? i.to : i.from) && (r = n.moveToLineBoundary(e, t, !1)), !t && r.head == i.from && i.length) {
    let s = /^\s*/.exec(n.state.sliceDoc(i.from, Math.min(i.from + 100, i.to)))[0].length;
    s && e.head != i.from + s && (r = $.cursor(i.from + s));
  }
  return r;
}
const gw = (n) => Xt(n, (e) => Mn(n, e, !0)), bw = (n) => Xt(n, (e) => Mn(n, e, !1)), yw = (n) => Xt(n, (e) => Mn(n, e, !Ue(n))), kw = (n) => Xt(n, (e) => Mn(n, e, Ue(n))), xw = (n) => Xt(n, (e) => $.cursor(n.lineBlockAt(e.head).from, 1)), ww = (n) => Xt(n, (e) => $.cursor(n.lineBlockAt(e.head).to, -1));
function Sw(n, e, t) {
  let i = !1, r = Ii(n.selection, (s) => {
    let o = jt(n, s.head, -1) || jt(n, s.head, 1) || s.head > 0 && jt(n, s.head - 1, 1) || s.head < n.doc.length && jt(n, s.head + 1, -1);
    if (!o || !o.end)
      return s;
    i = !0;
    let l = o.start.from == s.head ? o.end.to : o.end.from;
    return $.cursor(l);
  });
  return i ? (e(Jt(n, r)), !0) : !1;
}
const vw = ({ state: n, dispatch: e }) => Sw(n, e);
function Qt(n, e) {
  let t = Ii(n.state.selection, (i) => {
    let r = e(i);
    return $.range(i.anchor, r.head, r.goalColumn, r.bidiLevel || void 0);
  });
  return t.eq(n.state.selection) ? !1 : (n.dispatch(Jt(n.state, t)), !0);
}
function kO(n, e) {
  return Qt(n, (t) => n.moveByChar(t, e));
}
const xO = (n) => kO(n, !Ue(n)), wO = (n) => kO(n, Ue(n));
function SO(n, e) {
  return Qt(n, (t) => n.moveByGroup(t, e));
}
const Pw = (n) => SO(n, !Ue(n)), Qw = (n) => SO(n, Ue(n)), $w = (n) => Qt(n, (e) => Yo(n.state, e, !Ue(n))), Cw = (n) => Qt(n, (e) => Yo(n.state, e, Ue(n)));
function vO(n, e) {
  return Qt(n, (t) => n.moveVertically(t, e));
}
const PO = (n) => vO(n, !1), QO = (n) => vO(n, !0);
function $O(n, e) {
  return Qt(n, (t) => n.moveVertically(t, e, bO(n).height));
}
const rf = (n) => $O(n, !1), sf = (n) => $O(n, !0), Tw = (n) => Qt(n, (e) => Mn(n, e, !0)), Aw = (n) => Qt(n, (e) => Mn(n, e, !1)), Rw = (n) => Qt(n, (e) => Mn(n, e, !Ue(n))), Zw = (n) => Qt(n, (e) => Mn(n, e, Ue(n))), Mw = (n) => Qt(n, (e) => $.cursor(n.lineBlockAt(e.head).from)), Ew = (n) => Qt(n, (e) => $.cursor(n.lineBlockAt(e.head).to)), of = ({ state: n, dispatch: e }) => (e(Jt(n, { anchor: 0 })), !0), lf = ({ state: n, dispatch: e }) => (e(Jt(n, { anchor: n.doc.length })), !0), af = ({ state: n, dispatch: e }) => (e(Jt(n, { anchor: n.selection.main.anchor, head: 0 })), !0), hf = ({ state: n, dispatch: e }) => (e(Jt(n, { anchor: n.selection.main.anchor, head: n.doc.length })), !0), zw = ({ state: n, dispatch: e }) => (e(n.update({ selection: { anchor: 0, head: n.doc.length }, userEvent: "select" })), !0), Xw = ({ state: n, dispatch: e }) => {
  let t = jo(n).map(({ from: i, to: r }) => $.range(i, Math.min(r + 1, n.doc.length)));
  return e(n.update({ selection: $.create(t), userEvent: "select" })), !0;
}, Dw = ({ state: n, dispatch: e }) => {
  let t = Ii(n.selection, (i) => {
    var r;
    let s = ye(n).resolveStack(i.from, 1);
    for (let o = s; o; o = o.next) {
      let { node: l } = o;
      if ((l.from < i.from && l.to >= i.to || l.to > i.to && l.from <= i.from) && (!((r = l.parent) === null || r === void 0) && r.parent))
        return $.range(l.to, l.from);
    }
    return i;
  });
  return e(Jt(n, t)), !0;
}, Lw = ({ state: n, dispatch: e }) => {
  let t = n.selection, i = null;
  return t.ranges.length > 1 ? i = $.create([t.main]) : t.main.empty || (i = $.create([$.cursor(t.main.head)])), i ? (e(Jt(n, i)), !0) : !1;
};
function Gr(n, e) {
  if (n.state.readOnly)
    return !1;
  let t = "delete.selection", { state: i } = n, r = i.changeByRange((s) => {
    let { from: o, to: l } = s;
    if (o == l) {
      let a = e(s);
      a < o ? (t = "delete.backward", a = ys(n, a, !1)) : a > o && (t = "delete.forward", a = ys(n, a, !0)), o = Math.min(o, a), l = Math.max(l, a);
    } else
      o = ys(n, o, !1), l = ys(n, l, !0);
    return o == l ? { range: s } : { changes: { from: o, to: l }, range: $.cursor(o, o < s.head ? -1 : 1) };
  });
  return r.changes.empty ? !1 : (n.dispatch(i.update(r, {
    scrollIntoView: !0,
    userEvent: t,
    effects: t == "delete.selection" ? I.announce.of(i.phrase("Selection deleted")) : void 0
  })), !0);
}
function ys(n, e, t) {
  if (n instanceof I)
    for (let i of n.state.facet(I.atomicRanges).map((r) => r(n)))
      i.between(e, e, (r, s) => {
        r < e && s > e && (e = t ? s : r);
      });
  return e;
}
const CO = (n, e, t) => Gr(n, (i) => {
  let r = i.from, { state: s } = n, o = s.doc.lineAt(r), l, a;
  if (t && !e && r > o.from && r < o.from + 200 && !/[^ \t]/.test(l = o.text.slice(0, r - o.from))) {
    if (l[l.length - 1] == "	")
      return r - 1;
    let h = Mt(l, s.tabSize), u = h % ao(s) || ao(s);
    for (let c = 0; c < u && l[l.length - 1 - c] == " "; c++)
      r--;
    a = r;
  } else
    a = Be(o.text, r - o.from, e, e) + o.from, a == r && o.number != (e ? s.doc.lines : 1) ? a += e ? 1 : -1 : !e && /[\ufe00-\ufe0f]/.test(o.text.slice(a - o.from, r - o.from)) && (a = Be(o.text, a - o.from, !1, !1) + o.from);
  return a;
}), Fa = (n) => CO(n, !1, !0), TO = (n) => CO(n, !0, !1), AO = (n, e) => Gr(n, (t) => {
  let i = t.head, { state: r } = n, s = r.doc.lineAt(i), o = r.charCategorizer(i);
  for (let l = null; ; ) {
    if (i == (e ? s.to : s.from)) {
      i == t.head && s.number != (e ? r.doc.lines : 1) && (i += e ? 1 : -1);
      break;
    }
    let a = Be(s.text, i - s.from, e) + s.from, h = s.text.slice(Math.min(i, a) - s.from, Math.max(i, a) - s.from), u = o(h);
    if (l != null && u != l)
      break;
    (h != " " || i != t.head) && (l = u), i = a;
  }
  return i;
}), RO = (n) => AO(n, !1), Iw = (n) => AO(n, !0), _w = (n) => Gr(n, (e) => {
  let t = n.lineBlockAt(e.head).to;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), qw = (n) => Gr(n, (e) => {
  let t = n.moveToLineBoundary(e, !1).head;
  return e.head > t ? t : Math.max(0, e.head - 1);
}), Ww = (n) => Gr(n, (e) => {
  let t = n.moveToLineBoundary(e, !0).head;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), Bw = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => ({
    changes: { from: i.from, to: i.to, insert: le.of(["", ""]) },
    range: $.cursor(i.from)
  }));
  return e(n.update(t, { scrollIntoView: !0, userEvent: "input" })), !0;
}, Vw = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => {
    if (!i.empty || i.from == 0 || i.from == n.doc.length)
      return { range: i };
    let r = i.from, s = n.doc.lineAt(r), o = r == s.from ? r - 1 : Be(s.text, r - s.from, !1) + s.from, l = r == s.to ? r + 1 : Be(s.text, r - s.from, !0) + s.from;
    return {
      changes: { from: o, to: l, insert: n.doc.slice(r, l).append(n.doc.slice(o, r)) },
      range: $.cursor(l)
    };
  });
  return t.changes.empty ? !1 : (e(n.update(t, { scrollIntoView: !0, userEvent: "move.character" })), !0);
};
function jo(n) {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let r = n.doc.lineAt(i.from), s = n.doc.lineAt(i.to);
    if (!i.empty && i.to == s.from && (s = n.doc.lineAt(i.to - 1)), t >= r.number) {
      let o = e[e.length - 1];
      o.to = s.to, o.ranges.push(i);
    } else
      e.push({ from: r.from, to: s.to, ranges: [i] });
    t = s.number + 1;
  }
  return e;
}
function ZO(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [], r = [];
  for (let s of jo(n)) {
    if (t ? s.to == n.doc.length : s.from == 0)
      continue;
    let o = n.doc.lineAt(t ? s.to + 1 : s.from - 1), l = o.length + 1;
    if (t) {
      i.push({ from: s.to, to: o.to }, { from: s.from, insert: o.text + n.lineBreak });
      for (let a of s.ranges)
        r.push($.range(Math.min(n.doc.length, a.anchor + l), Math.min(n.doc.length, a.head + l)));
    } else {
      i.push({ from: o.from, to: s.from }, { from: s.to, insert: n.lineBreak + o.text });
      for (let a of s.ranges)
        r.push($.range(a.anchor - l, a.head - l));
    }
  }
  return i.length ? (e(n.update({
    changes: i,
    scrollIntoView: !0,
    selection: $.create(r, n.selection.mainIndex),
    userEvent: "move.line"
  })), !0) : !1;
}
const Yw = ({ state: n, dispatch: e }) => ZO(n, e, !1), jw = ({ state: n, dispatch: e }) => ZO(n, e, !0);
function MO(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [];
  for (let r of jo(n))
    t ? i.push({ from: r.from, insert: n.doc.slice(r.from, r.to) + n.lineBreak }) : i.push({ from: r.to, insert: n.lineBreak + n.doc.slice(r.from, r.to) });
  return e(n.update({ changes: i, scrollIntoView: !0, userEvent: "input.copyline" })), !0;
}
const Nw = ({ state: n, dispatch: e }) => MO(n, e, !1), Uw = ({ state: n, dispatch: e }) => MO(n, e, !0), Fw = (n) => {
  if (n.state.readOnly)
    return !1;
  let { state: e } = n, t = e.changes(jo(e).map(({ from: r, to: s }) => (r > 0 ? r-- : s < e.doc.length && s++, { from: r, to: s }))), i = Ii(e.selection, (r) => {
    let s;
    if (n.lineWrapping) {
      let o = n.lineBlockAt(r.head), l = n.coordsAtPos(r.head, r.assoc || 1);
      l && (s = o.bottom + n.documentTop - l.bottom + n.defaultLineHeight / 2);
    }
    return n.moveVertically(r, !0, s);
  }).map(t);
  return n.dispatch({ changes: t, selection: i, scrollIntoView: !0, userEvent: "delete.line" }), !0;
};
function Gw(n, e) {
  if (/\(\)|\[\]|\{\}/.test(n.sliceDoc(e - 1, e + 1)))
    return { from: e, to: e };
  let t = ye(n).resolveInner(e), i = t.childBefore(e), r = t.childAfter(e), s;
  return i && r && i.to <= e && r.from >= e && (s = i.type.prop(F.closedBy)) && s.indexOf(r.name) > -1 && n.doc.lineAt(i.to).from == n.doc.lineAt(r.from).from && !/\S/.test(n.sliceDoc(i.to, r.from)) ? { from: i.to, to: r.from } : null;
}
const Hw = /* @__PURE__ */ EO(!1), Kw = /* @__PURE__ */ EO(!0);
function EO(n) {
  return ({ state: e, dispatch: t }) => {
    if (e.readOnly)
      return !1;
    let i = e.changeByRange((r) => {
      let { from: s, to: o } = r, l = e.doc.lineAt(s), a = !n && s == o && Gw(e, s);
      n && (s = o = (o <= l.to ? l : e.doc.lineAt(o)).to);
      let h = new _o(e, { simulateBreak: s, simulateDoubleBreak: !!a }), u = qh(h, s);
      for (u == null && (u = Mt(/^\s*/.exec(e.doc.lineAt(s).text)[0], e.tabSize)); o < l.to && /\s/.test(l.text[o - l.from]); )
        o++;
      a ? { from: s, to: o } = a : s > l.from && s < l.from + 100 && !/\S/.test(l.text.slice(0, s)) && (s = l.from);
      let c = ["", Mr(e, u)];
      return a && c.push(Mr(e, h.lineIndent(l.from, -1))), {
        changes: { from: s, to: o, insert: le.of(c) },
        range: $.cursor(s + 1 + c[1].length)
      };
    });
    return t(e.update(i, { scrollIntoView: !0, userEvent: "input" })), !0;
  };
}
function Yh(n, e) {
  let t = -1;
  return n.changeByRange((i) => {
    let r = [];
    for (let o = i.from; o <= i.to; ) {
      let l = n.doc.lineAt(o);
      l.number > t && (i.empty || i.to > l.from) && (e(l, r, i), t = l.number), o = l.to + 1;
    }
    let s = n.changes(r);
    return {
      changes: r,
      range: $.range(s.mapPos(i.anchor, 1), s.mapPos(i.head, 1))
    };
  });
}
const Jw = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = /* @__PURE__ */ Object.create(null), i = new _o(n, { overrideIndentation: (s) => {
    let o = t[s];
    return o ?? -1;
  } }), r = Yh(n, (s, o, l) => {
    let a = qh(i, s.from);
    if (a == null)
      return;
    /\S/.test(s.text) || (a = 0);
    let h = /^\s*/.exec(s.text)[0], u = Mr(n, a);
    (h != u || l.from < s.from + h.length) && (t[s.from] = a, o.push({ from: s.from, to: s.from + h.length, insert: u }));
  });
  return r.changes.empty || e(n.update(r, { userEvent: "indent" })), !0;
}, zO = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(Yh(n, (t, i) => {
  i.push({ from: t.from, insert: n.facet(Di) });
}), { userEvent: "input.indent" })), !0), XO = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(Yh(n, (t, i) => {
  let r = /^\s*/.exec(t.text)[0];
  if (!r)
    return;
  let s = Mt(r, n.tabSize), o = 0, l = Mr(n, Math.max(0, s - ao(n)));
  for (; o < r.length && o < l.length && r.charCodeAt(o) == l.charCodeAt(o); )
    o++;
  i.push({ from: t.from + o, to: t.from + r.length, insert: l.slice(o) });
}), { userEvent: "delete.dedent" })), !0), eS = [
  { key: "Ctrl-b", run: fO, shift: xO, preventDefault: !0 },
  { key: "Ctrl-f", run: dO, shift: wO },
  { key: "Ctrl-p", run: OO, shift: PO },
  { key: "Ctrl-n", run: gO, shift: QO },
  { key: "Ctrl-a", run: xw, shift: Mw },
  { key: "Ctrl-e", run: ww, shift: Ew },
  { key: "Ctrl-d", run: TO },
  { key: "Ctrl-h", run: Fa },
  { key: "Ctrl-k", run: _w },
  { key: "Ctrl-Alt-h", run: RO },
  { key: "Ctrl-o", run: Bw },
  { key: "Ctrl-t", run: Vw },
  { key: "Ctrl-v", run: Ua }
], tS = /* @__PURE__ */ [
  { key: "ArrowLeft", run: fO, shift: xO, preventDefault: !0 },
  { key: "Mod-ArrowLeft", mac: "Alt-ArrowLeft", run: fw, shift: Pw, preventDefault: !0 },
  { mac: "Cmd-ArrowLeft", run: yw, shift: Rw, preventDefault: !0 },
  { key: "ArrowRight", run: dO, shift: wO, preventDefault: !0 },
  { key: "Mod-ArrowRight", mac: "Alt-ArrowRight", run: dw, shift: Qw, preventDefault: !0 },
  { mac: "Cmd-ArrowRight", run: kw, shift: Zw, preventDefault: !0 },
  { key: "ArrowUp", run: OO, shift: PO, preventDefault: !0 },
  { mac: "Cmd-ArrowUp", run: of, shift: af },
  { mac: "Ctrl-ArrowUp", run: nf, shift: rf },
  { key: "ArrowDown", run: gO, shift: QO, preventDefault: !0 },
  { mac: "Cmd-ArrowDown", run: lf, shift: hf },
  { mac: "Ctrl-ArrowDown", run: Ua, shift: sf },
  { key: "PageUp", run: nf, shift: rf },
  { key: "PageDown", run: Ua, shift: sf },
  { key: "Home", run: bw, shift: Aw, preventDefault: !0 },
  { key: "Mod-Home", run: of, shift: af },
  { key: "End", run: gw, shift: Tw, preventDefault: !0 },
  { key: "Mod-End", run: lf, shift: hf },
  { key: "Enter", run: Hw },
  { key: "Mod-a", run: zw },
  { key: "Backspace", run: Fa, shift: Fa },
  { key: "Delete", run: TO },
  { key: "Mod-Backspace", mac: "Alt-Backspace", run: RO },
  { key: "Mod-Delete", mac: "Alt-Delete", run: Iw },
  { mac: "Mod-Backspace", run: qw },
  { mac: "Mod-Delete", run: Ww }
].concat(/* @__PURE__ */ eS.map((n) => ({ mac: n.key, run: n.run, shift: n.shift }))), nS = /* @__PURE__ */ [
  { key: "Alt-ArrowLeft", mac: "Ctrl-ArrowLeft", run: mw, shift: $w },
  { key: "Alt-ArrowRight", mac: "Ctrl-ArrowRight", run: Ow, shift: Cw },
  { key: "Alt-ArrowUp", run: Yw },
  { key: "Shift-Alt-ArrowUp", run: Nw },
  { key: "Alt-ArrowDown", run: jw },
  { key: "Shift-Alt-ArrowDown", run: Uw },
  { key: "Escape", run: Lw },
  { key: "Mod-Enter", run: Kw },
  { key: "Alt-l", mac: "Ctrl-l", run: Xw },
  { key: "Mod-i", run: Dw, preventDefault: !0 },
  { key: "Mod-[", run: XO },
  { key: "Mod-]", run: zO },
  { key: "Mod-Alt-\\", run: Jw },
  { key: "Shift-Mod-k", run: Fw },
  { key: "Shift-Mod-\\", run: vw },
  { key: "Mod-/", run: Nx },
  { key: "Alt-A", run: Fx }
].concat(tS), iS = { key: "Tab", run: zO, shift: XO };
function ge() {
  var n = arguments[0];
  typeof n == "string" && (n = document.createElement(n));
  var e = 1, t = arguments[1];
  if (t && typeof t == "object" && t.nodeType == null && !Array.isArray(t)) {
    for (var i in t)
      if (Object.prototype.hasOwnProperty.call(t, i)) {
        var r = t[i];
        typeof r == "string" ? n.setAttribute(i, r) : r != null && (n[i] = r);
      }
    e++;
  }
  for (; e < arguments.length; e++)
    DO(n, arguments[e]);
  return n;
}
function DO(n, e) {
  if (typeof e == "string")
    n.appendChild(document.createTextNode(e));
  else if (e != null)
    if (e.nodeType != null)
      n.appendChild(e);
    else if (Array.isArray(e))
      for (var t = 0; t < e.length; t++)
        DO(n, e[t]);
    else
      throw new RangeError("Unsupported child node: " + e);
}
const uf = typeof String.prototype.normalize == "function" ? (n) => n.normalize("NFKD") : (n) => n;
class Ti {
  /**
  Create a text cursor. The query is the search string, `from` to
  `to` provides the region to search.
  
  When `normalize` is given, it will be called, on both the query
  string and the content it is matched against, before comparing.
  You can, for example, create a case-insensitive search by
  passing `s => s.toLowerCase()`.
  
  Text is always normalized with
  [`.normalize("NFKD")`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/normalize)
  (when supported).
  */
  constructor(e, t, i = 0, r = e.length, s, o) {
    this.test = o, this.value = { from: 0, to: 0 }, this.done = !1, this.matches = [], this.buffer = "", this.bufferPos = 0, this.iter = e.iterRange(i, r), this.bufferStart = i, this.normalize = s ? (l) => s(uf(l)) : uf, this.query = this.normalize(t);
  }
  peek() {
    if (this.bufferPos == this.buffer.length) {
      if (this.bufferStart += this.buffer.length, this.iter.next(), this.iter.done)
        return -1;
      this.bufferPos = 0, this.buffer = this.iter.value;
    }
    return Ie(this.buffer, this.bufferPos);
  }
  /**
  Look for the next match. Updates the iterator's
  [`value`](https://codemirror.net/6/docs/ref/#search.SearchCursor.value) and
  [`done`](https://codemirror.net/6/docs/ref/#search.SearchCursor.done) properties. Should be called
  at least once before using the cursor.
  */
  next() {
    for (; this.matches.length; )
      this.matches.pop();
    return this.nextOverlapping();
  }
  /**
  The `next` method will ignore matches that partially overlap a
  previous match. This method behaves like `next`, but includes
  such matches.
  */
  nextOverlapping() {
    for (; ; ) {
      let e = this.peek();
      if (e < 0)
        return this.done = !0, this;
      let t = Sh(e), i = this.bufferStart + this.bufferPos;
      this.bufferPos += bt(e);
      let r = this.normalize(t);
      for (let s = 0, o = i; ; s++) {
        let l = r.charCodeAt(s), a = this.match(l, o, this.bufferPos + this.bufferStart);
        if (s == r.length - 1) {
          if (a)
            return this.value = a, this;
          break;
        }
        o == i && s < t.length && t.charCodeAt(s) == l && o++;
      }
    }
  }
  match(e, t, i) {
    let r = null;
    for (let s = 0; s < this.matches.length; s += 2) {
      let o = this.matches[s], l = !1;
      this.query.charCodeAt(o) == e && (o == this.query.length - 1 ? r = { from: this.matches[s + 1], to: i } : (this.matches[s]++, l = !0)), l || (this.matches.splice(s, 2), s -= 2);
    }
    return this.query.charCodeAt(0) == e && (this.query.length == 1 ? r = { from: t, to: i } : this.matches.push(1, t)), r && this.test && !this.test(r.from, r.to, this.buffer, this.bufferStart) && (r = null), r;
  }
}
typeof Symbol < "u" && (Ti.prototype[Symbol.iterator] = function() {
  return this;
});
const LO = { from: -1, to: -1, match: /* @__PURE__ */ /.*/.exec("") }, jh = "gm" + (/x/.unicode == null ? "" : "u");
class IO {
  /**
  Create a cursor that will search the given range in the given
  document. `query` should be the raw pattern (as you'd pass it to
  `new RegExp`).
  */
  constructor(e, t, i, r = 0, s = e.length) {
    if (this.text = e, this.to = s, this.curLine = "", this.done = !1, this.value = LO, /\\[sWDnr]|\n|\r|\[\^/.test(t))
      return new _O(e, t, i, r, s);
    this.re = new RegExp(t, jh + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.iter = e.iter();
    let o = e.lineAt(r);
    this.curLineStart = o.from, this.matchPos = fo(e, r), this.getLine(this.curLineStart);
  }
  getLine(e) {
    this.iter.next(e), this.iter.lineBreak ? this.curLine = "" : (this.curLine = this.iter.value, this.curLineStart + this.curLine.length > this.to && (this.curLine = this.curLine.slice(0, this.to - this.curLineStart)), this.iter.next());
  }
  nextLine() {
    this.curLineStart = this.curLineStart + this.curLine.length + 1, this.curLineStart > this.to ? this.curLine = "" : this.getLine(0);
  }
  /**
  Move to the next match, if there is one.
  */
  next() {
    for (let e = this.matchPos - this.curLineStart; ; ) {
      this.re.lastIndex = e;
      let t = this.matchPos <= this.to && this.re.exec(this.curLine);
      if (t) {
        let i = this.curLineStart + t.index, r = i + t[0].length;
        if (this.matchPos = fo(this.text, r + (i == r ? 1 : 0)), i == this.curLineStart + this.curLine.length && this.nextLine(), (i < r || i > this.value.to) && (!this.test || this.test(i, r, t)))
          return this.value = { from: i, to: r, match: t }, this;
        e = this.matchPos - this.curLineStart;
      } else if (this.curLineStart + this.curLine.length < this.to)
        this.nextLine(), e = 0;
      else
        return this.done = !0, this;
    }
  }
}
const Sl = /* @__PURE__ */ new WeakMap();
class gi {
  constructor(e, t) {
    this.from = e, this.text = t;
  }
  get to() {
    return this.from + this.text.length;
  }
  static get(e, t, i) {
    let r = Sl.get(e);
    if (!r || r.from >= i || r.to <= t) {
      let l = new gi(t, e.sliceString(t, i));
      return Sl.set(e, l), l;
    }
    if (r.from == t && r.to == i)
      return r;
    let { text: s, from: o } = r;
    return o > t && (s = e.sliceString(t, o) + s, o = t), r.to < i && (s += e.sliceString(r.to, i)), Sl.set(e, new gi(o, s)), new gi(t, s.slice(t - o, i - o));
  }
}
class _O {
  constructor(e, t, i, r, s) {
    this.text = e, this.to = s, this.done = !1, this.value = LO, this.matchPos = fo(e, r), this.re = new RegExp(t, jh + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.flat = gi.get(e, r, this.chunkEnd(
      r + 5e3
      /* Chunk.Base */
    ));
  }
  chunkEnd(e) {
    return e >= this.to ? this.to : this.text.lineAt(e).to;
  }
  next() {
    for (; ; ) {
      let e = this.re.lastIndex = this.matchPos - this.flat.from, t = this.re.exec(this.flat.text);
      if (t && !t[0] && t.index == e && (this.re.lastIndex = e + 1, t = this.re.exec(this.flat.text)), t) {
        let i = this.flat.from + t.index, r = i + t[0].length;
        if ((this.flat.to >= this.to || t.index + t[0].length <= this.flat.text.length - 10) && (!this.test || this.test(i, r, t)))
          return this.value = { from: i, to: r, match: t }, this.matchPos = fo(this.text, r + (i == r ? 1 : 0)), this;
      }
      if (this.flat.to == this.to)
        return this.done = !0, this;
      this.flat = gi.get(this.text, this.flat.from, this.chunkEnd(this.flat.from + this.flat.text.length * 2));
    }
  }
}
typeof Symbol < "u" && (IO.prototype[Symbol.iterator] = _O.prototype[Symbol.iterator] = function() {
  return this;
});
function rS(n) {
  try {
    return new RegExp(n, jh), !0;
  } catch {
    return !1;
  }
}
function fo(n, e) {
  if (e >= n.length)
    return e;
  let t = n.lineAt(e), i;
  for (; e < t.to && (i = t.text.charCodeAt(e - t.from)) >= 56320 && i < 57344; )
    e++;
  return e;
}
function Ga(n) {
  let e = String(n.state.doc.lineAt(n.state.selection.main.head).number), t = ge("input", { class: "cm-textfield", name: "line", value: e }), i = ge("form", {
    class: "cm-gotoLine",
    onkeydown: (s) => {
      s.keyCode == 27 ? (s.preventDefault(), n.dispatch({ effects: po.of(!1) }), n.focus()) : s.keyCode == 13 && (s.preventDefault(), r());
    },
    onsubmit: (s) => {
      s.preventDefault(), r();
    }
  }, ge("label", n.state.phrase("Go to line"), ": ", t), " ", ge("button", { class: "cm-button", type: "submit" }, n.state.phrase("go")));
  function r() {
    let s = /^([+-])?(\d+)?(:\d+)?(%)?$/.exec(t.value);
    if (!s)
      return;
    let { state: o } = n, l = o.doc.lineAt(o.selection.main.head), [, a, h, u, c] = s, f = u ? +u.slice(1) : 0, d = h ? +h : l.number;
    if (h && c) {
      let O = d / 100;
      a && (O = O * (a == "-" ? -1 : 1) + l.number / o.doc.lines), d = Math.round(o.doc.lines * O);
    } else
      h && a && (d = d * (a == "-" ? -1 : 1) + l.number);
    let p = o.doc.line(Math.max(1, Math.min(o.doc.lines, d))), m = $.cursor(p.from + Math.max(0, Math.min(f, p.length)));
    n.dispatch({
      effects: [po.of(!1), I.scrollIntoView(m.from, { y: "center" })],
      selection: m
    }), n.focus();
  }
  return { dom: i };
}
const po = /* @__PURE__ */ K.define(), cf = /* @__PURE__ */ De.define({
  create() {
    return !0;
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(po) && (n = t.value);
    return n;
  },
  provide: (n) => Cr.from(n, (e) => e ? Ga : null)
}), sS = (n) => {
  let e = $r(n, Ga);
  if (!e) {
    let t = [po.of(!0)];
    n.state.field(cf, !1) == null && t.push(K.appendConfig.of([cf, oS])), n.dispatch({ effects: t }), e = $r(n, Ga);
  }
  return e && e.dom.querySelector("input").select(), !0;
}, oS = /* @__PURE__ */ I.baseTheme({
  ".cm-panel.cm-gotoLine": {
    padding: "2px 6px 4px",
    "& label": { fontSize: "80%" }
  }
}), lS = {
  highlightWordAroundCursor: !1,
  minSelectionLength: 1,
  maxMatches: 100,
  wholeWords: !1
}, aS = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, lS, {
      highlightWordAroundCursor: (e, t) => e || t,
      minSelectionLength: Math.min,
      maxMatches: Math.min
    });
  }
});
function hS(n) {
  return [pS, dS];
}
const uS = /* @__PURE__ */ j.mark({ class: "cm-selectionMatch" }), cS = /* @__PURE__ */ j.mark({ class: "cm-selectionMatch cm-selectionMatch-main" });
function ff(n, e, t, i) {
  return (t == 0 || n(e.sliceDoc(t - 1, t)) != ve.Word) && (i == e.doc.length || n(e.sliceDoc(i, i + 1)) != ve.Word);
}
function fS(n, e, t, i) {
  return n(e.sliceDoc(t, t + 1)) == ve.Word && n(e.sliceDoc(i - 1, i)) == ve.Word;
}
const dS = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.selectionSet || n.docChanged || n.viewportChanged) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = n.state.facet(aS), { state: t } = n, i = t.selection;
    if (i.ranges.length > 1)
      return j.none;
    let r = i.main, s, o = null;
    if (r.empty) {
      if (!e.highlightWordAroundCursor)
        return j.none;
      let a = t.wordAt(r.head);
      if (!a)
        return j.none;
      o = t.charCategorizer(r.head), s = t.sliceDoc(a.from, a.to);
    } else {
      let a = r.to - r.from;
      if (a < e.minSelectionLength || a > 200)
        return j.none;
      if (e.wholeWords) {
        if (s = t.sliceDoc(r.from, r.to), o = t.charCategorizer(r.head), !(ff(o, t, r.from, r.to) && fS(o, t, r.from, r.to)))
          return j.none;
      } else if (s = t.sliceDoc(r.from, r.to), !s)
        return j.none;
    }
    let l = [];
    for (let a of n.visibleRanges) {
      let h = new Ti(t.doc, s, a.from, a.to);
      for (; !h.next().done; ) {
        let { from: u, to: c } = h.value;
        if ((!o || ff(o, t, u, c)) && (r.empty && u <= r.from && c >= r.to ? l.push(cS.range(u, c)) : (u >= r.to || c <= r.from) && l.push(uS.range(u, c)), l.length > e.maxMatches))
          return j.none;
      }
    }
    return j.set(l);
  }
}, {
  decorations: (n) => n.decorations
}), pS = /* @__PURE__ */ I.baseTheme({
  ".cm-selectionMatch": { backgroundColor: "#99ff7780" },
  ".cm-searchMatch .cm-selectionMatch": { backgroundColor: "transparent" }
}), mS = ({ state: n, dispatch: e }) => {
  let { selection: t } = n, i = $.create(t.ranges.map((r) => n.wordAt(r.head) || $.cursor(r.head)), t.mainIndex);
  return i.eq(t) ? !1 : (e(n.update({ selection: i })), !0);
};
function OS(n, e) {
  let { main: t, ranges: i } = n.selection, r = n.wordAt(t.head), s = r && r.from == t.from && r.to == t.to;
  for (let o = !1, l = new Ti(n.doc, e, i[i.length - 1].to); ; )
    if (l.next(), l.done) {
      if (o)
        return null;
      l = new Ti(n.doc, e, 0, Math.max(0, i[i.length - 1].from - 1)), o = !0;
    } else {
      if (o && i.some((a) => a.from == l.value.from))
        continue;
      if (s) {
        let a = n.wordAt(l.value.from);
        if (!a || a.from != l.value.from || a.to != l.value.to)
          continue;
      }
      return l.value;
    }
}
const gS = ({ state: n, dispatch: e }) => {
  let { ranges: t } = n.selection;
  if (t.some((s) => s.from === s.to))
    return mS({ state: n, dispatch: e });
  let i = n.sliceDoc(t[0].from, t[0].to);
  if (n.selection.ranges.some((s) => n.sliceDoc(s.from, s.to) != i))
    return !1;
  let r = OS(n, i);
  return r ? (e(n.update({
    selection: n.selection.addRange($.range(r.from, r.to), !1),
    effects: I.scrollIntoView(r.to)
  })), !0) : !1;
}, _i = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, {
      top: !1,
      caseSensitive: !1,
      literal: !1,
      regexp: !1,
      wholeWord: !1,
      createPanel: (e) => new TS(e),
      scrollToMatch: (e) => I.scrollIntoView(e)
    });
  }
});
class qO {
  /**
  Create a query object.
  */
  constructor(e) {
    this.search = e.search, this.caseSensitive = !!e.caseSensitive, this.literal = !!e.literal, this.regexp = !!e.regexp, this.replace = e.replace || "", this.valid = !!this.search && (!this.regexp || rS(this.search)), this.unquoted = this.unquote(this.search), this.wholeWord = !!e.wholeWord;
  }
  /**
  @internal
  */
  unquote(e) {
    return this.literal ? e : e.replace(/\\([nrt\\])/g, (t, i) => i == "n" ? `
` : i == "r" ? "\r" : i == "t" ? "	" : "\\");
  }
  /**
  Compare this query to another query.
  */
  eq(e) {
    return this.search == e.search && this.replace == e.replace && this.caseSensitive == e.caseSensitive && this.regexp == e.regexp && this.wholeWord == e.wholeWord;
  }
  /**
  @internal
  */
  create() {
    return this.regexp ? new xS(this) : new yS(this);
  }
  /**
  Get a search cursor for this query, searching through the given
  range in the given state.
  */
  getCursor(e, t = 0, i) {
    let r = e.doc ? e : ee.create({ doc: e });
    return i == null && (i = r.doc.length), this.regexp ? li(this, r, t, i) : oi(this, r, t, i);
  }
}
class WO {
  constructor(e) {
    this.spec = e;
  }
}
function oi(n, e, t, i) {
  return new Ti(e.doc, n.unquoted, t, i, n.caseSensitive ? void 0 : (r) => r.toLowerCase(), n.wholeWord ? bS(e.doc, e.charCategorizer(e.selection.main.head)) : void 0);
}
function bS(n, e) {
  return (t, i, r, s) => ((s > t || s + r.length < i) && (s = Math.max(0, t - 2), r = n.sliceString(s, Math.min(n.length, i + 2))), (e(mo(r, t - s)) != ve.Word || e(Oo(r, t - s)) != ve.Word) && (e(Oo(r, i - s)) != ve.Word || e(mo(r, i - s)) != ve.Word));
}
class yS extends WO {
  constructor(e) {
    super(e);
  }
  nextMatch(e, t, i) {
    let r = oi(this.spec, e, i, e.doc.length).nextOverlapping();
    return r.done && (r = oi(this.spec, e, 0, t).nextOverlapping()), r.done ? null : r.value;
  }
  // Searching in reverse is, rather than implementing an inverted search
  // cursor, done by scanning chunk after chunk forward.
  prevMatchInRange(e, t, i) {
    for (let r = i; ; ) {
      let s = Math.max(t, r - 1e4 - this.spec.unquoted.length), o = oi(this.spec, e, s, r), l = null;
      for (; !o.nextOverlapping().done; )
        l = o.value;
      if (l)
        return l;
      if (s == t)
        return null;
      r -= 1e4;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace);
  }
  matchAll(e, t) {
    let i = oi(this.spec, e, 0, e.doc.length), r = [];
    for (; !i.next().done; ) {
      if (r.length >= t)
        return null;
      r.push(i.value);
    }
    return r;
  }
  highlight(e, t, i, r) {
    let s = oi(this.spec, e, Math.max(0, t - this.spec.unquoted.length), Math.min(i + this.spec.unquoted.length, e.doc.length));
    for (; !s.next().done; )
      r(s.value.from, s.value.to);
  }
}
function li(n, e, t, i) {
  return new IO(e.doc, n.search, {
    ignoreCase: !n.caseSensitive,
    test: n.wholeWord ? kS(e.charCategorizer(e.selection.main.head)) : void 0
  }, t, i);
}
function mo(n, e) {
  return n.slice(Be(n, e, !1), e);
}
function Oo(n, e) {
  return n.slice(e, Be(n, e));
}
function kS(n) {
  return (e, t, i) => !i[0].length || (n(mo(i.input, i.index)) != ve.Word || n(Oo(i.input, i.index)) != ve.Word) && (n(Oo(i.input, i.index + i[0].length)) != ve.Word || n(mo(i.input, i.index + i[0].length)) != ve.Word);
}
class xS extends WO {
  nextMatch(e, t, i) {
    let r = li(this.spec, e, i, e.doc.length).next();
    return r.done && (r = li(this.spec, e, 0, t).next()), r.done ? null : r.value;
  }
  prevMatchInRange(e, t, i) {
    for (let r = 1; ; r++) {
      let s = Math.max(
        t,
        i - r * 1e4
        /* FindPrev.ChunkSize */
      ), o = li(this.spec, e, s, i), l = null;
      for (; !o.next().done; )
        l = o.value;
      if (l && (s == t || l.from > s + 10))
        return l;
      if (s == t)
        return null;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace).replace(/\$([$&\d+])/g, (t, i) => i == "$" ? "$" : i == "&" ? e.match[0] : i != "0" && +i < e.match.length ? e.match[i] : t);
  }
  matchAll(e, t) {
    let i = li(this.spec, e, 0, e.doc.length), r = [];
    for (; !i.next().done; ) {
      if (r.length >= t)
        return null;
      r.push(i.value);
    }
    return r;
  }
  highlight(e, t, i, r) {
    let s = li(this.spec, e, Math.max(
      0,
      t - 250
      /* RegExp.HighlightMargin */
    ), Math.min(i + 250, e.doc.length));
    for (; !s.next().done; )
      r(s.value.from, s.value.to);
  }
}
const Er = /* @__PURE__ */ K.define(), Nh = /* @__PURE__ */ K.define(), Pn = /* @__PURE__ */ De.define({
  create(n) {
    return new vl(Ha(n).create(), null);
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(Er) ? n = new vl(t.value.create(), n.panel) : t.is(Nh) && (n = new vl(n.query, t.value ? Uh : null));
    return n;
  },
  provide: (n) => Cr.from(n, (e) => e.panel)
});
class vl {
  constructor(e, t) {
    this.query = e, this.panel = t;
  }
}
const wS = /* @__PURE__ */ j.mark({ class: "cm-searchMatch" }), SS = /* @__PURE__ */ j.mark({ class: "cm-searchMatch cm-searchMatch-selected" }), vS = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.view = n, this.decorations = this.highlight(n.state.field(Pn));
  }
  update(n) {
    let e = n.state.field(Pn);
    (e != n.startState.field(Pn) || n.docChanged || n.selectionSet || n.viewportChanged) && (this.decorations = this.highlight(e));
  }
  highlight({ query: n, panel: e }) {
    if (!e || !n.spec.valid)
      return j.none;
    let { view: t } = this, i = new $n();
    for (let r = 0, s = t.visibleRanges, o = s.length; r < o; r++) {
      let { from: l, to: a } = s[r];
      for (; r < o - 1 && a > s[r + 1].from - 2 * 250; )
        a = s[++r].to;
      n.highlight(t.state, l, a, (h, u) => {
        let c = t.state.selection.ranges.some((f) => f.from == h && f.to == u);
        i.add(h, u, c ? SS : wS);
      });
    }
    return i.finish();
  }
}, {
  decorations: (n) => n.decorations
});
function Hr(n) {
  return (e) => {
    let t = e.state.field(Pn, !1);
    return t && t.query.spec.valid ? n(e, t) : YO(e);
  };
}
const go = /* @__PURE__ */ Hr((n, { query: e }) => {
  let { to: t } = n.state.selection.main, i = e.nextMatch(n.state, t, t);
  if (!i)
    return !1;
  let r = $.single(i.from, i.to), s = n.state.facet(_i);
  return n.dispatch({
    selection: r,
    effects: [Fh(n, i), s.scrollToMatch(r.main, n)],
    userEvent: "select.search"
  }), VO(n), !0;
}), bo = /* @__PURE__ */ Hr((n, { query: e }) => {
  let { state: t } = n, { from: i } = t.selection.main, r = e.prevMatch(t, i, i);
  if (!r)
    return !1;
  let s = $.single(r.from, r.to), o = n.state.facet(_i);
  return n.dispatch({
    selection: s,
    effects: [Fh(n, r), o.scrollToMatch(s.main, n)],
    userEvent: "select.search"
  }), VO(n), !0;
}), PS = /* @__PURE__ */ Hr((n, { query: e }) => {
  let t = e.matchAll(n.state, 1e3);
  return !t || !t.length ? !1 : (n.dispatch({
    selection: $.create(t.map((i) => $.range(i.from, i.to))),
    userEvent: "select.search.matches"
  }), !0);
}), QS = ({ state: n, dispatch: e }) => {
  let t = n.selection;
  if (t.ranges.length > 1 || t.main.empty)
    return !1;
  let { from: i, to: r } = t.main, s = [], o = 0;
  for (let l = new Ti(n.doc, n.sliceDoc(i, r)); !l.next().done; ) {
    if (s.length > 1e3)
      return !1;
    l.value.from == i && (o = s.length), s.push($.range(l.value.from, l.value.to));
  }
  return e(n.update({
    selection: $.create(s, o),
    userEvent: "select.search.matches"
  })), !0;
}, df = /* @__PURE__ */ Hr((n, { query: e }) => {
  let { state: t } = n, { from: i, to: r } = t.selection.main;
  if (t.readOnly)
    return !1;
  let s = e.nextMatch(t, i, i);
  if (!s)
    return !1;
  let o = [], l, a, h = [];
  if (s.from == i && s.to == r && (a = t.toText(e.getReplacement(s)), o.push({ from: s.from, to: s.to, insert: a }), s = e.nextMatch(t, s.from, s.to), h.push(I.announce.of(t.phrase("replaced match on line $", t.doc.lineAt(i).number) + "."))), s) {
    let u = o.length == 0 || o[0].from >= s.to ? 0 : s.to - s.from - a.length;
    l = $.single(s.from - u, s.to - u), h.push(Fh(n, s)), h.push(t.facet(_i).scrollToMatch(l.main, n));
  }
  return n.dispatch({
    changes: o,
    selection: l,
    effects: h,
    userEvent: "input.replace"
  }), !0;
}), $S = /* @__PURE__ */ Hr((n, { query: e }) => {
  if (n.state.readOnly)
    return !1;
  let t = e.matchAll(n.state, 1e9).map((r) => {
    let { from: s, to: o } = r;
    return { from: s, to: o, insert: e.getReplacement(r) };
  });
  if (!t.length)
    return !1;
  let i = n.state.phrase("replaced $ matches", t.length) + ".";
  return n.dispatch({
    changes: t,
    effects: I.announce.of(i),
    userEvent: "input.replace.all"
  }), !0;
});
function Uh(n) {
  return n.state.facet(_i).createPanel(n);
}
function Ha(n, e) {
  var t, i, r, s, o;
  let l = n.selection.main, a = l.empty || l.to > l.from + 100 ? "" : n.sliceDoc(l.from, l.to);
  if (e && !a)
    return e;
  let h = n.facet(_i);
  return new qO({
    search: ((t = e == null ? void 0 : e.literal) !== null && t !== void 0 ? t : h.literal) ? a : a.replace(/\n/g, "\\n"),
    caseSensitive: (i = e == null ? void 0 : e.caseSensitive) !== null && i !== void 0 ? i : h.caseSensitive,
    literal: (r = e == null ? void 0 : e.literal) !== null && r !== void 0 ? r : h.literal,
    regexp: (s = e == null ? void 0 : e.regexp) !== null && s !== void 0 ? s : h.regexp,
    wholeWord: (o = e == null ? void 0 : e.wholeWord) !== null && o !== void 0 ? o : h.wholeWord
  });
}
function BO(n) {
  let e = $r(n, Uh);
  return e && e.dom.querySelector("[main-field]");
}
function VO(n) {
  let e = BO(n);
  e && e == n.root.activeElement && e.select();
}
const YO = (n) => {
  let e = n.state.field(Pn, !1);
  if (e && e.panel) {
    let t = BO(n);
    if (t && t != n.root.activeElement) {
      let i = Ha(n.state, e.query.spec);
      i.valid && n.dispatch({ effects: Er.of(i) }), t.focus(), t.select();
    }
  } else
    n.dispatch({ effects: [
      Nh.of(!0),
      e ? Er.of(Ha(n.state, e.query.spec)) : K.appendConfig.of(RS)
    ] });
  return !0;
}, jO = (n) => {
  let e = n.state.field(Pn, !1);
  if (!e || !e.panel)
    return !1;
  let t = $r(n, Uh);
  return t && t.dom.contains(n.root.activeElement) && n.focus(), n.dispatch({ effects: Nh.of(!1) }), !0;
}, CS = [
  { key: "Mod-f", run: YO, scope: "editor search-panel" },
  { key: "F3", run: go, shift: bo, scope: "editor search-panel", preventDefault: !0 },
  { key: "Mod-g", run: go, shift: bo, scope: "editor search-panel", preventDefault: !0 },
  { key: "Escape", run: jO, scope: "editor search-panel" },
  { key: "Mod-Shift-l", run: QS },
  { key: "Mod-Alt-g", run: sS },
  { key: "Mod-d", run: gS, preventDefault: !0 }
];
class TS {
  constructor(e) {
    this.view = e;
    let t = this.query = e.state.field(Pn).query.spec;
    this.commit = this.commit.bind(this), this.searchField = ge("input", {
      value: t.search,
      placeholder: lt(e, "Find"),
      "aria-label": lt(e, "Find"),
      class: "cm-textfield",
      name: "search",
      form: "",
      "main-field": "true",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.replaceField = ge("input", {
      value: t.replace,
      placeholder: lt(e, "Replace"),
      "aria-label": lt(e, "Replace"),
      class: "cm-textfield",
      name: "replace",
      form: "",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.caseField = ge("input", {
      type: "checkbox",
      name: "case",
      form: "",
      checked: t.caseSensitive,
      onchange: this.commit
    }), this.reField = ge("input", {
      type: "checkbox",
      name: "re",
      form: "",
      checked: t.regexp,
      onchange: this.commit
    }), this.wordField = ge("input", {
      type: "checkbox",
      name: "word",
      form: "",
      checked: t.wholeWord,
      onchange: this.commit
    });
    function i(r, s, o) {
      return ge("button", { class: "cm-button", name: r, onclick: s, type: "button" }, o);
    }
    this.dom = ge("div", { onkeydown: (r) => this.keydown(r), class: "cm-search" }, [
      this.searchField,
      i("next", () => go(e), [lt(e, "next")]),
      i("prev", () => bo(e), [lt(e, "previous")]),
      i("select", () => PS(e), [lt(e, "all")]),
      ge("label", null, [this.caseField, lt(e, "match case")]),
      ge("label", null, [this.reField, lt(e, "regexp")]),
      ge("label", null, [this.wordField, lt(e, "by word")]),
      ...e.state.readOnly ? [] : [
        ge("br"),
        this.replaceField,
        i("replace", () => df(e), [lt(e, "replace")]),
        i("replaceAll", () => $S(e), [lt(e, "replace all")])
      ],
      ge("button", {
        name: "close",
        onclick: () => jO(e),
        "aria-label": lt(e, "close"),
        type: "button"
      }, ["×"])
    ]);
  }
  commit() {
    let e = new qO({
      search: this.searchField.value,
      caseSensitive: this.caseField.checked,
      regexp: this.reField.checked,
      wholeWord: this.wordField.checked,
      replace: this.replaceField.value
    });
    e.eq(this.query) || (this.query = e, this.view.dispatch({ effects: Er.of(e) }));
  }
  keydown(e) {
    Dy(this.view, e, "search-panel") ? e.preventDefault() : e.keyCode == 13 && e.target == this.searchField ? (e.preventDefault(), (e.shiftKey ? bo : go)(this.view)) : e.keyCode == 13 && e.target == this.replaceField && (e.preventDefault(), df(this.view));
  }
  update(e) {
    for (let t of e.transactions)
      for (let i of t.effects)
        i.is(Er) && !i.value.eq(this.query) && this.setQuery(i.value);
  }
  setQuery(e) {
    this.query = e, this.searchField.value = e.search, this.replaceField.value = e.replace, this.caseField.checked = e.caseSensitive, this.reField.checked = e.regexp, this.wordField.checked = e.wholeWord;
  }
  mount() {
    this.searchField.select();
  }
  get pos() {
    return 80;
  }
  get top() {
    return this.view.state.facet(_i).top;
  }
}
function lt(n, e) {
  return n.state.phrase(e);
}
const ks = 30, xs = /[\s\.,:;?!]/;
function Fh(n, { from: e, to: t }) {
  let i = n.state.doc.lineAt(e), r = n.state.doc.lineAt(t).to, s = Math.max(i.from, e - ks), o = Math.min(r, t + ks), l = n.state.sliceDoc(s, o);
  if (s != i.from) {
    for (let a = 0; a < ks; a++)
      if (!xs.test(l[a + 1]) && xs.test(l[a])) {
        l = l.slice(a);
        break;
      }
  }
  if (o != r) {
    for (let a = l.length - 1; a > l.length - ks; a--)
      if (!xs.test(l[a - 1]) && xs.test(l[a])) {
        l = l.slice(0, a);
        break;
      }
  }
  return I.announce.of(`${n.state.phrase("current match")}. ${l} ${n.state.phrase("on line")} ${i.number}.`);
}
const AS = /* @__PURE__ */ I.baseTheme({
  ".cm-panel.cm-search": {
    padding: "2px 6px 4px",
    position: "relative",
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "4px",
      backgroundColor: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    },
    "& input, & button, & label": {
      margin: ".2em .6em .2em 0"
    },
    "& input[type=checkbox]": {
      marginRight: ".2em"
    },
    "& label": {
      fontSize: "80%",
      whiteSpace: "pre"
    }
  },
  "&light .cm-searchMatch": { backgroundColor: "#ffff0054" },
  "&dark .cm-searchMatch": { backgroundColor: "#00ffff8a" },
  "&light .cm-searchMatch-selected": { backgroundColor: "#ff6a0054" },
  "&dark .cm-searchMatch-selected": { backgroundColor: "#ff00ff8a" }
}), RS = [
  Pn,
  /* @__PURE__ */ un.low(vS),
  AS
];
class Gh {
  /**
  Create a new completion context. (Mostly useful for testing
  completion sources—in the editor, the extension will create
  these for you.)
  */
  constructor(e, t, i) {
    this.state = e, this.pos = t, this.explicit = i, this.abortListeners = [];
  }
  /**
  Get the extent, content, and (if there is a token) type of the
  token before `this.pos`.
  */
  tokenBefore(e) {
    let t = ye(this.state).resolveInner(this.pos, -1);
    for (; t && e.indexOf(t.name) < 0; )
      t = t.parent;
    return t ? {
      from: t.from,
      to: this.pos,
      text: this.state.sliceDoc(t.from, this.pos),
      type: t.type
    } : null;
  }
  /**
  Get the match of the given expression directly before the
  cursor.
  */
  matchBefore(e) {
    let t = this.state.doc.lineAt(this.pos), i = Math.max(t.from, this.pos - 250), r = t.text.slice(i - t.from, this.pos - t.from), s = r.search(UO(e, !1));
    return s < 0 ? null : { from: i + s, to: this.pos, text: r.slice(s) };
  }
  /**
  Yields true when the query has been aborted. Can be useful in
  asynchronous queries to avoid doing work that will be ignored.
  */
  get aborted() {
    return this.abortListeners == null;
  }
  /**
  Allows you to register abort handlers, which will be called when
  the query is
  [aborted](https://codemirror.net/6/docs/ref/#autocomplete.CompletionContext.aborted).
  */
  addEventListener(e, t) {
    e == "abort" && this.abortListeners && this.abortListeners.push(t);
  }
}
function pf(n) {
  let e = Object.keys(n).join(""), t = /\w/.test(e);
  return t && (e = e.replace(/\w/g, "")), `[${t ? "\\w" : ""}${e.replace(/[^\w\s]/g, "\\$&")}]`;
}
function ZS(n) {
  let e = /* @__PURE__ */ Object.create(null), t = /* @__PURE__ */ Object.create(null);
  for (let { label: r } of n) {
    e[r[0]] = !0;
    for (let s = 1; s < r.length; s++)
      t[r[s]] = !0;
  }
  let i = pf(e) + pf(t) + "*$";
  return [new RegExp("^" + i), new RegExp(i)];
}
function NO(n) {
  let e = n.map((r) => typeof r == "string" ? { label: r } : r), [t, i] = e.every((r) => /^\w+$/.test(r.label)) ? [/\w*$/, /\w+$/] : ZS(e);
  return (r) => {
    let s = r.matchBefore(i);
    return s || r.explicit ? { from: s ? s.from : r.pos, options: e, validFor: t } : null;
  };
}
function MS(n, e) {
  return (t) => {
    for (let i = ye(t.state).resolveInner(t.pos, -1); i; i = i.parent) {
      if (n.indexOf(i.name) > -1)
        return null;
      if (i.type.isTop)
        break;
    }
    return e(t);
  };
}
class mf {
  constructor(e, t, i, r) {
    this.completion = e, this.source = t, this.match = i, this.score = r;
  }
}
function Qn(n) {
  return n.selection.main.from;
}
function UO(n, e) {
  var t;
  let { source: i } = n, r = e && i[0] != "^", s = i[i.length - 1] != "$";
  return !r && !s ? n : new RegExp(`${r ? "^" : ""}(?:${i})${s ? "$" : ""}`, (t = n.flags) !== null && t !== void 0 ? t : n.ignoreCase ? "i" : "");
}
const Hh = /* @__PURE__ */ cn.define();
function ES(n, e, t, i) {
  let { main: r } = n.selection, s = t - r.from, o = i - r.from;
  return Object.assign(Object.assign({}, n.changeByRange((l) => l != r && t != i && n.sliceDoc(l.from + s, l.from + o) != n.sliceDoc(t, i) ? { range: l } : {
    changes: { from: l.from + s, to: i == r.from ? l.to : l.from + o, insert: e },
    range: $.cursor(l.from + s + e.length)
  })), { scrollIntoView: !0, userEvent: "input.complete" });
}
const Of = /* @__PURE__ */ new WeakMap();
function zS(n) {
  if (!Array.isArray(n))
    return n;
  let e = Of.get(n);
  return e || Of.set(n, e = NO(n)), e;
}
const yo = /* @__PURE__ */ K.define(), zr = /* @__PURE__ */ K.define();
class XS {
  constructor(e) {
    this.pattern = e, this.chars = [], this.folded = [], this.any = [], this.precise = [], this.byWord = [], this.score = 0, this.matched = [];
    for (let t = 0; t < e.length; ) {
      let i = Ie(e, t), r = bt(i);
      this.chars.push(i);
      let s = e.slice(t, t + r), o = s.toUpperCase();
      this.folded.push(Ie(o == s ? s.toLowerCase() : o, 0)), t += r;
    }
    this.astral = e.length != this.chars.length;
  }
  ret(e, t) {
    return this.score = e, this.matched = t, this;
  }
  // Matches a given word (completion) against the pattern (input).
  // Will return a boolean indicating whether there was a match and,
  // on success, set `this.score` to the score, `this.matched` to an
  // array of `from, to` pairs indicating the matched parts of `word`.
  //
  // The score is a number that is more negative the worse the match
  // is. See `Penalty` above.
  match(e) {
    if (this.pattern.length == 0)
      return this.ret(-100, []);
    if (e.length < this.pattern.length)
      return null;
    let { chars: t, folded: i, any: r, precise: s, byWord: o } = this;
    if (t.length == 1) {
      let b = Ie(e, 0), S = bt(b), Q = S == e.length ? 0 : -100;
      if (b != t[0])
        if (b == i[0])
          Q += -200;
        else
          return null;
      return this.ret(Q, [0, S]);
    }
    let l = e.indexOf(this.pattern);
    if (l == 0)
      return this.ret(e.length == this.pattern.length ? 0 : -100, [0, this.pattern.length]);
    let a = t.length, h = 0;
    if (l < 0) {
      for (let b = 0, S = Math.min(e.length, 200); b < S && h < a; ) {
        let Q = Ie(e, b);
        (Q == t[h] || Q == i[h]) && (r[h++] = b), b += bt(Q);
      }
      if (h < a)
        return null;
    }
    let u = 0, c = 0, f = !1, d = 0, p = -1, m = -1, O = /[a-z]/.test(e), g = !0;
    for (let b = 0, S = Math.min(e.length, 200), Q = 0; b < S && c < a; ) {
      let P = Ie(e, b);
      l < 0 && (u < a && P == t[u] && (s[u++] = b), d < a && (P == t[d] || P == i[d] ? (d == 0 && (p = b), m = b + 1, d++) : d = 0));
      let w, C = P < 255 ? P >= 48 && P <= 57 || P >= 97 && P <= 122 ? 2 : P >= 65 && P <= 90 ? 1 : 0 : (w = Sh(P)) != w.toLowerCase() ? 1 : w != w.toUpperCase() ? 2 : 0;
      (!b || C == 1 && O || Q == 0 && C != 0) && (t[c] == P || i[c] == P && (f = !0) ? o[c++] = b : o.length && (g = !1)), Q = C, b += bt(P);
    }
    return c == a && o[0] == 0 && g ? this.result(-100 + (f ? -200 : 0), o, e) : d == a && p == 0 ? this.ret(-200 - e.length + (m == e.length ? 0 : -100), [0, m]) : l > -1 ? this.ret(-700 - e.length, [l, l + this.pattern.length]) : d == a ? this.ret(-900 - e.length, [p, m]) : c == a ? this.result(-100 + (f ? -200 : 0) + -700 + (g ? 0 : -1100), o, e) : t.length == 2 ? null : this.result((r[0] ? -700 : 0) + -200 + -1100, r, e);
  }
  result(e, t, i) {
    let r = [], s = 0;
    for (let o of t) {
      let l = o + (this.astral ? bt(Ie(i, o)) : 1);
      s && r[s - 1] == o ? r[s - 1] = l : (r[s++] = o, r[s++] = l);
    }
    return this.ret(e - i.length, r);
  }
}
class DS {
  constructor(e) {
    this.pattern = e, this.matched = [], this.score = 0, this.folded = e.toLowerCase();
  }
  match(e) {
    if (e.length < this.pattern.length)
      return null;
    let t = e.slice(0, this.pattern.length), i = t == this.pattern ? 0 : t.toLowerCase() == this.folded ? -200 : null;
    return i == null ? null : (this.matched = [0, t.length], this.score = i + (e.length == this.pattern.length ? 0 : -100), this);
  }
}
const We = /* @__PURE__ */ B.define({
  combine(n) {
    return Ht(n, {
      activateOnTyping: !0,
      activateOnCompletion: () => !1,
      activateOnTypingDelay: 100,
      selectOnOpen: !0,
      override: null,
      closeOnBlur: !0,
      maxRenderedOptions: 100,
      defaultKeymap: !0,
      tooltipClass: () => "",
      optionClass: () => "",
      aboveCursor: !1,
      icons: !0,
      addToOptions: [],
      positionInfo: LS,
      filterStrict: !1,
      compareCompletions: (e, t) => e.label.localeCompare(t.label),
      interactionDelay: 75,
      updateSyncTime: 100
    }, {
      defaultKeymap: (e, t) => e && t,
      closeOnBlur: (e, t) => e && t,
      icons: (e, t) => e && t,
      tooltipClass: (e, t) => (i) => gf(e(i), t(i)),
      optionClass: (e, t) => (i) => gf(e(i), t(i)),
      addToOptions: (e, t) => e.concat(t),
      filterStrict: (e, t) => e || t
    });
  }
});
function gf(n, e) {
  return n ? e ? n + " " + e : n : e;
}
function LS(n, e, t, i, r, s) {
  let o = n.textDirection == we.RTL, l = o, a = !1, h = "top", u, c, f = e.left - r.left, d = r.right - e.right, p = i.right - i.left, m = i.bottom - i.top;
  if (l && f < Math.min(p, d) ? l = !1 : !l && d < Math.min(p, f) && (l = !0), p <= (l ? f : d))
    u = Math.max(r.top, Math.min(t.top, r.bottom - m)) - e.top, c = Math.min(400, l ? f : d);
  else {
    a = !0, c = Math.min(
      400,
      (o ? e.right : r.right - e.left) - 30
      /* Info.Margin */
    );
    let b = r.bottom - e.bottom;
    b >= m || b > e.top ? u = t.bottom - e.top : (h = "bottom", u = e.bottom - t.top);
  }
  let O = (e.bottom - e.top) / s.offsetHeight, g = (e.right - e.left) / s.offsetWidth;
  return {
    style: `${h}: ${u / O}px; max-width: ${c / g}px`,
    class: "cm-completionInfo-" + (a ? o ? "left-narrow" : "right-narrow" : l ? "left" : "right")
  };
}
function IS(n) {
  let e = n.addToOptions.slice();
  return n.icons && e.push({
    render(t) {
      let i = document.createElement("div");
      return i.classList.add("cm-completionIcon"), t.type && i.classList.add(...t.type.split(/\s+/g).map((r) => "cm-completionIcon-" + r)), i.setAttribute("aria-hidden", "true"), i;
    },
    position: 20
  }), e.push({
    render(t, i, r, s) {
      let o = document.createElement("span");
      o.className = "cm-completionLabel";
      let l = t.displayLabel || t.label, a = 0;
      for (let h = 0; h < s.length; ) {
        let u = s[h++], c = s[h++];
        u > a && o.appendChild(document.createTextNode(l.slice(a, u)));
        let f = o.appendChild(document.createElement("span"));
        f.appendChild(document.createTextNode(l.slice(u, c))), f.className = "cm-completionMatchedText", a = c;
      }
      return a < l.length && o.appendChild(document.createTextNode(l.slice(a))), o;
    },
    position: 50
  }, {
    render(t) {
      if (!t.detail)
        return null;
      let i = document.createElement("span");
      return i.className = "cm-completionDetail", i.textContent = t.detail, i;
    },
    position: 80
  }), e.sort((t, i) => t.position - i.position).map((t) => t.render);
}
function Pl(n, e, t) {
  if (n <= t)
    return { from: 0, to: n };
  if (e < 0 && (e = 0), e <= n >> 1) {
    let r = Math.floor(e / t);
    return { from: r * t, to: (r + 1) * t };
  }
  let i = Math.floor((n - e) / t);
  return { from: n - (i + 1) * t, to: n - i * t };
}
class _S {
  constructor(e, t, i) {
    this.view = e, this.stateField = t, this.applyCompletion = i, this.info = null, this.infoDestroy = null, this.placeInfoReq = {
      read: () => this.measureInfo(),
      write: (a) => this.placeInfo(a),
      key: this
    }, this.space = null, this.currentClass = "";
    let r = e.state.field(t), { options: s, selected: o } = r.open, l = e.state.facet(We);
    this.optionContent = IS(l), this.optionClass = l.optionClass, this.tooltipClass = l.tooltipClass, this.range = Pl(s.length, o, l.maxRenderedOptions), this.dom = document.createElement("div"), this.dom.className = "cm-tooltip-autocomplete", this.updateTooltipClass(e.state), this.dom.addEventListener("mousedown", (a) => {
      let { options: h } = e.state.field(t).open;
      for (let u = a.target, c; u && u != this.dom; u = u.parentNode)
        if (u.nodeName == "LI" && (c = /-(\d+)$/.exec(u.id)) && +c[1] < h.length) {
          this.applyCompletion(e, h[+c[1]]), a.preventDefault();
          return;
        }
    }), this.dom.addEventListener("focusout", (a) => {
      let h = e.state.field(this.stateField, !1);
      h && h.tooltip && e.state.facet(We).closeOnBlur && a.relatedTarget != e.contentDOM && e.dispatch({ effects: zr.of(null) });
    }), this.showOptions(s, r.id);
  }
  mount() {
    this.updateSel();
  }
  showOptions(e, t) {
    this.list && this.list.remove(), this.list = this.dom.appendChild(this.createListBox(e, t, this.range)), this.list.addEventListener("scroll", () => {
      this.info && this.view.requestMeasure(this.placeInfoReq);
    });
  }
  update(e) {
    var t;
    let i = e.state.field(this.stateField), r = e.startState.field(this.stateField);
    if (this.updateTooltipClass(e.state), i != r) {
      let { options: s, selected: o, disabled: l } = i.open;
      (!r.open || r.open.options != s) && (this.range = Pl(s.length, o, e.state.facet(We).maxRenderedOptions), this.showOptions(s, i.id)), this.updateSel(), l != ((t = r.open) === null || t === void 0 ? void 0 : t.disabled) && this.dom.classList.toggle("cm-tooltip-autocomplete-disabled", !!l);
    }
  }
  updateTooltipClass(e) {
    let t = this.tooltipClass(e);
    if (t != this.currentClass) {
      for (let i of this.currentClass.split(" "))
        i && this.dom.classList.remove(i);
      for (let i of t.split(" "))
        i && this.dom.classList.add(i);
      this.currentClass = t;
    }
  }
  positioned(e) {
    this.space = e, this.info && this.view.requestMeasure(this.placeInfoReq);
  }
  updateSel() {
    let e = this.view.state.field(this.stateField), t = e.open;
    if ((t.selected > -1 && t.selected < this.range.from || t.selected >= this.range.to) && (this.range = Pl(t.options.length, t.selected, this.view.state.facet(We).maxRenderedOptions), this.showOptions(t.options, e.id)), this.updateSelectedOption(t.selected)) {
      this.destroyInfo();
      let { completion: i } = t.options[t.selected], { info: r } = i;
      if (!r)
        return;
      let s = typeof r == "string" ? document.createTextNode(r) : r(i);
      if (!s)
        return;
      "then" in s ? s.then((o) => {
        o && this.view.state.field(this.stateField, !1) == e && this.addInfoPane(o, i);
      }).catch((o) => it(this.view.state, o, "completion info")) : this.addInfoPane(s, i);
    }
  }
  addInfoPane(e, t) {
    this.destroyInfo();
    let i = this.info = document.createElement("div");
    if (i.className = "cm-tooltip cm-completionInfo", e.nodeType != null)
      i.appendChild(e), this.infoDestroy = null;
    else {
      let { dom: r, destroy: s } = e;
      i.appendChild(r), this.infoDestroy = s || null;
    }
    this.dom.appendChild(i), this.view.requestMeasure(this.placeInfoReq);
  }
  updateSelectedOption(e) {
    let t = null;
    for (let i = this.list.firstChild, r = this.range.from; i; i = i.nextSibling, r++)
      i.nodeName != "LI" || !i.id ? r-- : r == e ? i.hasAttribute("aria-selected") || (i.setAttribute("aria-selected", "true"), t = i) : i.hasAttribute("aria-selected") && i.removeAttribute("aria-selected");
    return t && WS(this.list, t), t;
  }
  measureInfo() {
    let e = this.dom.querySelector("[aria-selected]");
    if (!e || !this.info)
      return null;
    let t = this.dom.getBoundingClientRect(), i = this.info.getBoundingClientRect(), r = e.getBoundingClientRect(), s = this.space;
    if (!s) {
      let o = this.dom.ownerDocument.defaultView || window;
      s = { left: 0, top: 0, right: o.innerWidth, bottom: o.innerHeight };
    }
    return r.top > Math.min(s.bottom, t.bottom) - 10 || r.bottom < Math.max(s.top, t.top) + 10 ? null : this.view.state.facet(We).positionInfo(this.view, t, r, i, s, this.dom);
  }
  placeInfo(e) {
    this.info && (e ? (e.style && (this.info.style.cssText = e.style), this.info.className = "cm-tooltip cm-completionInfo " + (e.class || "")) : this.info.style.cssText = "top: -1e6px");
  }
  createListBox(e, t, i) {
    const r = document.createElement("ul");
    r.id = t, r.setAttribute("role", "listbox"), r.setAttribute("aria-expanded", "true"), r.setAttribute("aria-label", this.view.state.phrase("Completions"));
    let s = null;
    for (let o = i.from; o < i.to; o++) {
      let { completion: l, match: a } = e[o], { section: h } = l;
      if (h) {
        let f = typeof h == "string" ? h : h.name;
        if (f != s && (o > i.from || i.from == 0))
          if (s = f, typeof h != "string" && h.header)
            r.appendChild(h.header(h));
          else {
            let d = r.appendChild(document.createElement("completion-section"));
            d.textContent = f;
          }
      }
      const u = r.appendChild(document.createElement("li"));
      u.id = t + "-" + o, u.setAttribute("role", "option");
      let c = this.optionClass(l);
      c && (u.className = c);
      for (let f of this.optionContent) {
        let d = f(l, this.view.state, this.view, a);
        d && u.appendChild(d);
      }
    }
    return i.from && r.classList.add("cm-completionListIncompleteTop"), i.to < e.length && r.classList.add("cm-completionListIncompleteBottom"), r;
  }
  destroyInfo() {
    this.info && (this.infoDestroy && this.infoDestroy(), this.info.remove(), this.info = null);
  }
  destroy() {
    this.destroyInfo();
  }
}
function qS(n, e) {
  return (t) => new _S(t, n, e);
}
function WS(n, e) {
  let t = n.getBoundingClientRect(), i = e.getBoundingClientRect(), r = t.height / n.offsetHeight;
  i.top < t.top ? n.scrollTop -= (t.top - i.top) / r : i.bottom > t.bottom && (n.scrollTop += (i.bottom - t.bottom) / r);
}
function bf(n) {
  return (n.boost || 0) * 100 + (n.apply ? 10 : 0) + (n.info ? 5 : 0) + (n.type ? 1 : 0);
}
function BS(n, e) {
  let t = [], i = null, r = (h) => {
    t.push(h);
    let { section: u } = h.completion;
    if (u) {
      i || (i = []);
      let c = typeof u == "string" ? u : u.name;
      i.some((f) => f.name == c) || i.push(typeof u == "string" ? { name: c } : u);
    }
  }, s = e.facet(We);
  for (let h of n)
    if (h.hasResult()) {
      let u = h.result.getMatch;
      if (h.result.filter === !1)
        for (let c of h.result.options)
          r(new mf(c, h.source, u ? u(c) : [], 1e9 - t.length));
      else {
        let c = e.sliceDoc(h.from, h.to), f, d = s.filterStrict ? new DS(c) : new XS(c);
        for (let p of h.result.options)
          if (f = d.match(p.label)) {
            let m = p.displayLabel ? u ? u(p, f.matched) : [] : f.matched;
            r(new mf(p, h.source, m, f.score + (p.boost || 0)));
          }
      }
    }
  if (i) {
    let h = /* @__PURE__ */ Object.create(null), u = 0, c = (f, d) => {
      var p, m;
      return ((p = f.rank) !== null && p !== void 0 ? p : 1e9) - ((m = d.rank) !== null && m !== void 0 ? m : 1e9) || (f.name < d.name ? -1 : 1);
    };
    for (let f of i.sort(c))
      u -= 1e5, h[f.name] = u;
    for (let f of t) {
      let { section: d } = f.completion;
      d && (f.score += h[typeof d == "string" ? d : d.name]);
    }
  }
  let o = [], l = null, a = s.compareCompletions;
  for (let h of t.sort((u, c) => c.score - u.score || a(u.completion, c.completion))) {
    let u = h.completion;
    !l || l.label != u.label || l.detail != u.detail || l.type != null && u.type != null && l.type != u.type || l.apply != u.apply || l.boost != u.boost ? o.push(h) : bf(h.completion) > bf(l) && (o[o.length - 1] = h), l = h.completion;
  }
  return o;
}
class fi {
  constructor(e, t, i, r, s, o) {
    this.options = e, this.attrs = t, this.tooltip = i, this.timestamp = r, this.selected = s, this.disabled = o;
  }
  setSelected(e, t) {
    return e == this.selected || e >= this.options.length ? this : new fi(this.options, yf(t, e), this.tooltip, this.timestamp, e, this.disabled);
  }
  static build(e, t, i, r, s) {
    let o = BS(e, t);
    if (!o.length)
      return r && e.some(
        (a) => a.state == 1
        /* State.Pending */
      ) ? new fi(r.options, r.attrs, r.tooltip, r.timestamp, r.selected, !0) : null;
    let l = t.facet(We).selectOnOpen ? 0 : -1;
    if (r && r.selected != l && r.selected != -1) {
      let a = r.options[r.selected].completion;
      for (let h = 0; h < o.length; h++)
        if (o[h].completion == a) {
          l = h;
          break;
        }
    }
    return new fi(o, yf(i, l), {
      pos: e.reduce((a, h) => h.hasResult() ? Math.min(a, h.from) : a, 1e8),
      create: US,
      above: s.aboveCursor
    }, r ? r.timestamp : Date.now(), l, !1);
  }
  map(e) {
    return new fi(this.options, this.attrs, Object.assign(Object.assign({}, this.tooltip), { pos: e.mapPos(this.tooltip.pos) }), this.timestamp, this.selected, this.disabled);
  }
}
class ko {
  constructor(e, t, i) {
    this.active = e, this.id = t, this.open = i;
  }
  static start() {
    return new ko(jS, "cm-ac-" + Math.floor(Math.random() * 2e6).toString(36), null);
  }
  update(e) {
    let { state: t } = e, i = t.facet(We), s = (i.override || t.languageDataAt("autocomplete", Qn(t)).map(zS)).map((l) => (this.active.find((h) => h.source == l) || new Fe(
      l,
      this.active.some(
        (h) => h.state != 0
        /* State.Inactive */
      ) ? 1 : 0
      /* State.Inactive */
    )).update(e, i));
    s.length == this.active.length && s.every((l, a) => l == this.active[a]) && (s = this.active);
    let o = this.open;
    o && e.docChanged && (o = o.map(e.changes)), e.selection || s.some((l) => l.hasResult() && e.changes.touchesRange(l.from, l.to)) || !VS(s, this.active) ? o = fi.build(s, t, this.id, o, i) : o && o.disabled && !s.some(
      (l) => l.state == 1
      /* State.Pending */
    ) && (o = null), !o && s.every(
      (l) => l.state != 1
      /* State.Pending */
    ) && s.some((l) => l.hasResult()) && (s = s.map((l) => l.hasResult() ? new Fe(
      l.source,
      0
      /* State.Inactive */
    ) : l));
    for (let l of e.effects)
      l.is(GO) && (o = o && o.setSelected(l.value, this.id));
    return s == this.active && o == this.open ? this : new ko(s, this.id, o);
  }
  get tooltip() {
    return this.open ? this.open.tooltip : null;
  }
  get attrs() {
    return this.open ? this.open.attrs : YS;
  }
}
function VS(n, e) {
  if (n == e)
    return !0;
  for (let t = 0, i = 0; ; ) {
    for (; t < n.length && !n[t].hasResult; )
      t++;
    for (; i < e.length && !e[i].hasResult; )
      i++;
    let r = t == n.length, s = i == e.length;
    if (r || s)
      return r == s;
    if (n[t++].result != e[i++].result)
      return !1;
  }
}
const YS = {
  "aria-autocomplete": "list"
};
function yf(n, e) {
  let t = {
    "aria-autocomplete": "list",
    "aria-haspopup": "listbox",
    "aria-controls": n
  };
  return e > -1 && (t["aria-activedescendant"] = n + "-" + e), t;
}
const jS = [];
function Ka(n, e) {
  if (n.isUserEvent("input.complete")) {
    let t = n.annotation(Hh);
    if (t && e.activateOnCompletion(t))
      return "input";
  }
  return n.isUserEvent("input.type") ? "input" : n.isUserEvent("delete.backward") ? "delete" : null;
}
class Fe {
  constructor(e, t, i = -1) {
    this.source = e, this.state = t, this.explicitPos = i;
  }
  hasResult() {
    return !1;
  }
  update(e, t) {
    let i = Ka(e, t), r = this;
    i ? r = r.handleUserEvent(e, i, t) : e.docChanged ? r = r.handleChange(e) : e.selection && r.state != 0 && (r = new Fe(
      r.source,
      0
      /* State.Inactive */
    ));
    for (let s of e.effects)
      if (s.is(yo))
        r = new Fe(r.source, 1, s.value ? Qn(e.state) : -1);
      else if (s.is(zr))
        r = new Fe(
          r.source,
          0
          /* State.Inactive */
        );
      else if (s.is(FO))
        for (let o of s.value)
          o.source == r.source && (r = o);
    return r;
  }
  handleUserEvent(e, t, i) {
    return t == "delete" || !i.activateOnTyping ? this.map(e.changes) : new Fe(
      this.source,
      1
      /* State.Pending */
    );
  }
  handleChange(e) {
    return e.changes.touchesRange(Qn(e.startState)) ? new Fe(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty || this.explicitPos < 0 ? this : new Fe(this.source, this.state, e.mapPos(this.explicitPos));
  }
}
class bi extends Fe {
  constructor(e, t, i, r, s) {
    super(e, 2, t), this.result = i, this.from = r, this.to = s;
  }
  hasResult() {
    return !0;
  }
  handleUserEvent(e, t, i) {
    var r;
    let s = this.result;
    s.map && !e.changes.empty && (s = s.map(s, e.changes));
    let o = e.changes.mapPos(this.from), l = e.changes.mapPos(this.to, 1), a = Qn(e.state);
    if ((this.explicitPos < 0 ? a <= o : a < this.from) || a > l || !s || t == "delete" && Qn(e.startState) == this.from)
      return new Fe(
        this.source,
        t == "input" && i.activateOnTyping ? 1 : 0
        /* State.Inactive */
      );
    let h = this.explicitPos < 0 ? -1 : e.changes.mapPos(this.explicitPos);
    return NS(s.validFor, e.state, o, l) ? new bi(this.source, h, s, o, l) : s.update && (s = s.update(s, o, l, new Gh(e.state, a, h >= 0))) ? new bi(this.source, h, s, s.from, (r = s.to) !== null && r !== void 0 ? r : Qn(e.state)) : new Fe(this.source, 1, h);
  }
  handleChange(e) {
    return e.changes.touchesRange(this.from, this.to) ? new Fe(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty ? this : (this.result.map ? this.result.map(this.result, e) : this.result) ? new bi(this.source, this.explicitPos < 0 ? -1 : e.mapPos(this.explicitPos), this.result, e.mapPos(this.from), e.mapPos(this.to, 1)) : new Fe(
      this.source,
      0
      /* State.Inactive */
    );
  }
}
function NS(n, e, t, i) {
  if (!n)
    return !1;
  let r = e.sliceDoc(t, i);
  return typeof n == "function" ? n(r, t, i, e) : UO(n, !0).test(r);
}
const FO = /* @__PURE__ */ K.define({
  map(n, e) {
    return n.map((t) => t.map(e));
  }
}), GO = /* @__PURE__ */ K.define(), nt = /* @__PURE__ */ De.define({
  create() {
    return ko.start();
  },
  update(n, e) {
    return n.update(e);
  },
  provide: (n) => [
    Eh.from(n, (e) => e.tooltip),
    I.contentAttributes.from(n, (e) => e.attrs)
  ]
});
function Kh(n, e) {
  const t = e.completion.apply || e.completion.label;
  let i = n.state.field(nt).active.find((r) => r.source == e.source);
  return i instanceof bi ? (typeof t == "string" ? n.dispatch(Object.assign(Object.assign({}, ES(n.state, t, i.from, i.to)), { annotations: Hh.of(e.completion) })) : t(n, e.completion, i.from, i.to), !0) : !1;
}
const US = /* @__PURE__ */ qS(nt, Kh);
function ws(n, e = "option") {
  return (t) => {
    let i = t.state.field(nt, !1);
    if (!i || !i.open || i.open.disabled || Date.now() - i.open.timestamp < t.state.facet(We).interactionDelay)
      return !1;
    let r = 1, s;
    e == "page" && (s = Am(t, i.open.tooltip)) && (r = Math.max(2, Math.floor(s.dom.offsetHeight / s.dom.querySelector("li").offsetHeight) - 1));
    let { length: o } = i.open.options, l = i.open.selected > -1 ? i.open.selected + r * (n ? 1 : -1) : n ? 0 : o - 1;
    return l < 0 ? l = e == "page" ? 0 : o - 1 : l >= o && (l = e == "page" ? o - 1 : 0), t.dispatch({ effects: GO.of(l) }), !0;
  };
}
const FS = (n) => {
  let e = n.state.field(nt, !1);
  return n.state.readOnly || !e || !e.open || e.open.selected < 0 || e.open.disabled || Date.now() - e.open.timestamp < n.state.facet(We).interactionDelay ? !1 : Kh(n, e.open.options[e.open.selected]);
}, GS = (n) => n.state.field(nt, !1) ? (n.dispatch({ effects: yo.of(!0) }), !0) : !1, HS = (n) => {
  let e = n.state.field(nt, !1);
  return !e || !e.active.some(
    (t) => t.state != 0
    /* State.Inactive */
  ) ? !1 : (n.dispatch({ effects: zr.of(null) }), !0);
};
class KS {
  constructor(e, t) {
    this.active = e, this.context = t, this.time = Date.now(), this.updates = [], this.done = void 0;
  }
}
const JS = 50, e2 = 1e3, t2 = /* @__PURE__ */ Qe.fromClass(class {
  constructor(n) {
    this.view = n, this.debounceUpdate = -1, this.running = [], this.debounceAccept = -1, this.pendingStart = !1, this.composing = 0;
    for (let e of n.state.field(nt).active)
      e.state == 1 && this.startQuery(e);
  }
  update(n) {
    let e = n.state.field(nt), t = n.state.facet(We);
    if (!n.selectionSet && !n.docChanged && n.startState.field(nt) == e)
      return;
    let i = n.transactions.some((s) => (s.selection || s.docChanged) && !Ka(s, t));
    for (let s = 0; s < this.running.length; s++) {
      let o = this.running[s];
      if (i || o.updates.length + n.transactions.length > JS && Date.now() - o.time > e2) {
        for (let l of o.context.abortListeners)
          try {
            l();
          } catch (a) {
            it(this.view.state, a);
          }
        o.context.abortListeners = null, this.running.splice(s--, 1);
      } else
        o.updates.push(...n.transactions);
    }
    this.debounceUpdate > -1 && clearTimeout(this.debounceUpdate), n.transactions.some((s) => s.effects.some((o) => o.is(yo))) && (this.pendingStart = !0);
    let r = this.pendingStart ? 50 : t.activateOnTypingDelay;
    if (this.debounceUpdate = e.active.some((s) => s.state == 1 && !this.running.some((o) => o.active.source == s.source)) ? setTimeout(() => this.startUpdate(), r) : -1, this.composing != 0)
      for (let s of n.transactions)
        Ka(s, t) == "input" ? this.composing = 2 : this.composing == 2 && s.selection && (this.composing = 3);
  }
  startUpdate() {
    this.debounceUpdate = -1, this.pendingStart = !1;
    let { state: n } = this.view, e = n.field(nt);
    for (let t of e.active)
      t.state == 1 && !this.running.some((i) => i.active.source == t.source) && this.startQuery(t);
  }
  startQuery(n) {
    let { state: e } = this.view, t = Qn(e), i = new Gh(e, t, n.explicitPos == t), r = new KS(n, i);
    this.running.push(r), Promise.resolve(n.source(i)).then((s) => {
      r.context.aborted || (r.done = s || null, this.scheduleAccept());
    }, (s) => {
      this.view.dispatch({ effects: zr.of(null) }), it(this.view.state, s);
    });
  }
  scheduleAccept() {
    this.running.every((n) => n.done !== void 0) ? this.accept() : this.debounceAccept < 0 && (this.debounceAccept = setTimeout(() => this.accept(), this.view.state.facet(We).updateSyncTime));
  }
  // For each finished query in this.running, try to create a result
  // or, if appropriate, restart the query.
  accept() {
    var n;
    this.debounceAccept > -1 && clearTimeout(this.debounceAccept), this.debounceAccept = -1;
    let e = [], t = this.view.state.facet(We);
    for (let i = 0; i < this.running.length; i++) {
      let r = this.running[i];
      if (r.done === void 0)
        continue;
      if (this.running.splice(i--, 1), r.done) {
        let o = new bi(r.active.source, r.active.explicitPos, r.done, r.done.from, (n = r.done.to) !== null && n !== void 0 ? n : Qn(r.updates.length ? r.updates[0].startState : this.view.state));
        for (let l of r.updates)
          o = o.update(l, t);
        if (o.hasResult()) {
          e.push(o);
          continue;
        }
      }
      let s = this.view.state.field(nt).active.find((o) => o.source == r.active.source);
      if (s && s.state == 1)
        if (r.done == null) {
          let o = new Fe(
            r.active.source,
            0
            /* State.Inactive */
          );
          for (let l of r.updates)
            o = o.update(l, t);
          o.state != 1 && e.push(o);
        } else
          this.startQuery(s);
    }
    e.length && this.view.dispatch({ effects: FO.of(e) });
  }
}, {
  eventHandlers: {
    blur(n) {
      let e = this.view.state.field(nt, !1);
      if (e && e.tooltip && this.view.state.facet(We).closeOnBlur) {
        let t = e.open && Am(this.view, e.open.tooltip);
        (!t || !t.dom.contains(n.relatedTarget)) && setTimeout(() => this.view.dispatch({ effects: zr.of(null) }), 10);
      }
    },
    compositionstart() {
      this.composing = 1;
    },
    compositionend() {
      this.composing == 3 && setTimeout(() => this.view.dispatch({ effects: yo.of(!1) }), 20), this.composing = 0;
    }
  }
}), n2 = typeof navigator == "object" && /* @__PURE__ */ /Win/.test(navigator.platform), i2 = /* @__PURE__ */ un.highest(/* @__PURE__ */ I.domEventHandlers({
  keydown(n, e) {
    let t = e.state.field(nt, !1);
    if (!t || !t.open || t.open.disabled || t.open.selected < 0 || n.key.length > 1 || n.ctrlKey && !(n2 && n.altKey) || n.metaKey)
      return !1;
    let i = t.open.options[t.open.selected], r = t.active.find((o) => o.source == i.source), s = i.completion.commitCharacters || r.result.commitCharacters;
    return s && s.indexOf(n.key) > -1 && Kh(e, i), !1;
  }
})), HO = /* @__PURE__ */ I.baseTheme({
  ".cm-tooltip.cm-tooltip-autocomplete": {
    "& > ul": {
      fontFamily: "monospace",
      whiteSpace: "nowrap",
      overflow: "hidden auto",
      maxWidth_fallback: "700px",
      maxWidth: "min(700px, 95vw)",
      minWidth: "250px",
      maxHeight: "10em",
      height: "100%",
      listStyle: "none",
      margin: 0,
      padding: 0,
      "& > li, & > completion-section": {
        padding: "1px 3px",
        lineHeight: 1.2
      },
      "& > li": {
        overflowX: "hidden",
        textOverflow: "ellipsis",
        cursor: "pointer"
      },
      "& > completion-section": {
        display: "list-item",
        borderBottom: "1px solid silver",
        paddingLeft: "0.5em",
        opacity: 0.7
      }
    }
  },
  "&light .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#17c",
    color: "white"
  },
  "&light .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#777"
  },
  "&dark .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#347",
    color: "white"
  },
  "&dark .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#444"
  },
  ".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after": {
    content: '"···"',
    opacity: 0.5,
    display: "block",
    textAlign: "center"
  },
  ".cm-tooltip.cm-completionInfo": {
    position: "absolute",
    padding: "3px 9px",
    width: "max-content",
    maxWidth: "400px",
    boxSizing: "border-box"
  },
  ".cm-completionInfo.cm-completionInfo-left": { right: "100%" },
  ".cm-completionInfo.cm-completionInfo-right": { left: "100%" },
  ".cm-completionInfo.cm-completionInfo-left-narrow": { right: "30px" },
  ".cm-completionInfo.cm-completionInfo-right-narrow": { left: "30px" },
  "&light .cm-snippetField": { backgroundColor: "#00000022" },
  "&dark .cm-snippetField": { backgroundColor: "#ffffff22" },
  ".cm-snippetFieldPosition": {
    verticalAlign: "text-top",
    width: 0,
    height: "1.15em",
    display: "inline-block",
    margin: "0 -0.7px -.7em",
    borderLeft: "1.4px dotted #888"
  },
  ".cm-completionMatchedText": {
    textDecoration: "underline"
  },
  ".cm-completionDetail": {
    marginLeft: "0.5em",
    fontStyle: "italic"
  },
  ".cm-completionIcon": {
    fontSize: "90%",
    width: ".8em",
    display: "inline-block",
    textAlign: "center",
    paddingRight: ".6em",
    opacity: "0.6",
    boxSizing: "content-box"
  },
  ".cm-completionIcon-function, .cm-completionIcon-method": {
    "&:after": { content: "'ƒ'" }
  },
  ".cm-completionIcon-class": {
    "&:after": { content: "'○'" }
  },
  ".cm-completionIcon-interface": {
    "&:after": { content: "'◌'" }
  },
  ".cm-completionIcon-variable": {
    "&:after": { content: "'𝑥'" }
  },
  ".cm-completionIcon-constant": {
    "&:after": { content: "'𝐶'" }
  },
  ".cm-completionIcon-type": {
    "&:after": { content: "'𝑡'" }
  },
  ".cm-completionIcon-enum": {
    "&:after": { content: "'∪'" }
  },
  ".cm-completionIcon-property": {
    "&:after": { content: "'□'" }
  },
  ".cm-completionIcon-keyword": {
    "&:after": { content: "'🔑︎'" }
    // Disable emoji rendering
  },
  ".cm-completionIcon-namespace": {
    "&:after": { content: "'▢'" }
  },
  ".cm-completionIcon-text": {
    "&:after": { content: "'abc'", fontSize: "50%", verticalAlign: "middle" }
  }
});
class r2 {
  constructor(e, t, i, r) {
    this.field = e, this.line = t, this.from = i, this.to = r;
  }
}
class Jh {
  constructor(e, t, i) {
    this.field = e, this.from = t, this.to = i;
  }
  map(e) {
    let t = e.mapPos(this.from, -1, qe.TrackDel), i = e.mapPos(this.to, 1, qe.TrackDel);
    return t == null || i == null ? null : new Jh(this.field, t, i);
  }
}
class eu {
  constructor(e, t) {
    this.lines = e, this.fieldPositions = t;
  }
  instantiate(e, t) {
    let i = [], r = [t], s = e.doc.lineAt(t), o = /^\s*/.exec(s.text)[0];
    for (let a of this.lines) {
      if (i.length) {
        let h = o, u = /^\t*/.exec(a)[0].length;
        for (let c = 0; c < u; c++)
          h += e.facet(Di);
        r.push(t + h.length - u), a = h + a.slice(u);
      }
      i.push(a), t += a.length + 1;
    }
    let l = this.fieldPositions.map((a) => new Jh(a.field, r[a.line] + a.from, r[a.line] + a.to));
    return { text: i, ranges: l };
  }
  static parse(e) {
    let t = [], i = [], r = [], s;
    for (let o of e.split(/\r\n?|\n/)) {
      for (; s = /[#$]\{(?:(\d+)(?::([^}]*))?|([^}]*))\}/.exec(o); ) {
        let l = s[1] ? +s[1] : null, a = s[2] || s[3] || "", h = -1;
        for (let u = 0; u < t.length; u++)
          (l != null ? t[u].seq == l : a && t[u].name == a) && (h = u);
        if (h < 0) {
          let u = 0;
          for (; u < t.length && (l == null || t[u].seq != null && t[u].seq < l); )
            u++;
          t.splice(u, 0, { seq: l, name: a }), h = u;
          for (let c of r)
            c.field >= h && c.field++;
        }
        r.push(new r2(h, i.length, s.index, s.index + a.length)), o = o.slice(0, s.index) + a + o.slice(s.index + s[0].length);
      }
      for (let l; l = /\\([{}])/.exec(o); ) {
        o = o.slice(0, l.index) + l[1] + o.slice(l.index + l[0].length);
        for (let a of r)
          a.line == i.length && a.from > l.index && (a.from--, a.to--);
      }
      i.push(o);
    }
    return new eu(i, r);
  }
}
let s2 = /* @__PURE__ */ j.widget({ widget: /* @__PURE__ */ new class extends Kt {
  toDOM() {
    let n = document.createElement("span");
    return n.className = "cm-snippetFieldPosition", n;
  }
  ignoreEvent() {
    return !1;
  }
}() }), o2 = /* @__PURE__ */ j.mark({ class: "cm-snippetField" });
class qi {
  constructor(e, t) {
    this.ranges = e, this.active = t, this.deco = j.set(e.map((i) => (i.from == i.to ? s2 : o2).range(i.from, i.to)));
  }
  map(e) {
    let t = [];
    for (let i of this.ranges) {
      let r = i.map(e);
      if (!r)
        return null;
      t.push(r);
    }
    return new qi(t, this.active);
  }
  selectionInsideField(e) {
    return e.ranges.every((t) => this.ranges.some((i) => i.field == this.active && i.from <= t.from && i.to >= t.to));
  }
}
const Kr = /* @__PURE__ */ K.define({
  map(n, e) {
    return n && n.map(e);
  }
}), l2 = /* @__PURE__ */ K.define(), Xr = /* @__PURE__ */ De.define({
  create() {
    return null;
  },
  update(n, e) {
    for (let t of e.effects) {
      if (t.is(Kr))
        return t.value;
      if (t.is(l2) && n)
        return new qi(n.ranges, t.value);
    }
    return n && e.docChanged && (n = n.map(e.changes)), n && e.selection && !n.selectionInsideField(e.selection) && (n = null), n;
  },
  provide: (n) => I.decorations.from(n, (e) => e ? e.deco : j.none)
});
function tu(n, e) {
  return $.create(n.filter((t) => t.field == e).map((t) => $.range(t.from, t.to)));
}
function a2(n) {
  let e = eu.parse(n);
  return (t, i, r, s) => {
    let { text: o, ranges: l } = e.instantiate(t.state, r), a = {
      changes: { from: r, to: s, insert: le.of(o) },
      scrollIntoView: !0,
      annotations: i ? [Hh.of(i), Re.userEvent.of("input.complete")] : void 0
    };
    if (l.length && (a.selection = tu(l, 0)), l.some((h) => h.field > 0)) {
      let h = new qi(l, 0), u = a.effects = [Kr.of(h)];
      t.state.field(Xr, !1) === void 0 && u.push(K.appendConfig.of([Xr, d2, p2, HO]));
    }
    t.dispatch(t.state.update(a));
  };
}
function KO(n) {
  return ({ state: e, dispatch: t }) => {
    let i = e.field(Xr, !1);
    if (!i || n < 0 && i.active == 0)
      return !1;
    let r = i.active + n, s = n > 0 && !i.ranges.some((o) => o.field == r + n);
    return t(e.update({
      selection: tu(i.ranges, r),
      effects: Kr.of(s ? null : new qi(i.ranges, r)),
      scrollIntoView: !0
    })), !0;
  };
}
const h2 = ({ state: n, dispatch: e }) => n.field(Xr, !1) ? (e(n.update({ effects: Kr.of(null) })), !0) : !1, u2 = /* @__PURE__ */ KO(1), c2 = /* @__PURE__ */ KO(-1), f2 = [
  { key: "Tab", run: u2, shift: c2 },
  { key: "Escape", run: h2 }
], kf = /* @__PURE__ */ B.define({
  combine(n) {
    return n.length ? n[0] : f2;
  }
}), d2 = /* @__PURE__ */ un.highest(/* @__PURE__ */ zi.compute([kf], (n) => n.facet(kf)));
function tt(n, e) {
  return Object.assign(Object.assign({}, e), { apply: a2(n) });
}
const p2 = /* @__PURE__ */ I.domEventHandlers({
  mousedown(n, e) {
    let t = e.state.field(Xr, !1), i;
    if (!t || (i = e.posAtCoords({ x: n.clientX, y: n.clientY })) == null)
      return !1;
    let r = t.ranges.find((s) => s.from <= i && s.to >= i);
    return !r || r.field == t.active ? !1 : (e.dispatch({
      selection: tu(t.ranges, r.field),
      effects: Kr.of(t.ranges.some((s) => s.field > r.field) ? new qi(t.ranges, r.field) : null),
      scrollIntoView: !0
    }), !0);
  }
}), Dr = {
  brackets: ["(", "[", "{", "'", '"'],
  before: ")]}:;>",
  stringPrefixes: []
}, Nn = /* @__PURE__ */ K.define({
  map(n, e) {
    let t = e.mapPos(n, -1, qe.TrackAfter);
    return t ?? void 0;
  }
}), nu = /* @__PURE__ */ new class extends Un {
}();
nu.startSide = 1;
nu.endSide = -1;
const JO = /* @__PURE__ */ De.define({
  create() {
    return oe.empty;
  },
  update(n, e) {
    if (n = n.map(e.changes), e.selection) {
      let t = e.state.doc.lineAt(e.selection.main.head);
      n = n.update({ filter: (i) => i >= t.from && i <= t.to });
    }
    for (let t of e.effects)
      t.is(Nn) && (n = n.update({ add: [nu.range(t.value, t.value + 1)] }));
    return n;
  }
});
function m2() {
  return [g2, JO];
}
const Ql = "()[]{}<>";
function eg(n) {
  for (let e = 0; e < Ql.length; e += 2)
    if (Ql.charCodeAt(e) == n)
      return Ql.charAt(e + 1);
  return Sh(n < 128 ? n : n + 1);
}
function tg(n, e) {
  return n.languageDataAt("closeBrackets", e)[0] || Dr;
}
const O2 = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), g2 = /* @__PURE__ */ I.inputHandler.of((n, e, t, i) => {
  if ((O2 ? n.composing : n.compositionStarted) || n.state.readOnly)
    return !1;
  let r = n.state.selection.main;
  if (i.length > 2 || i.length == 2 && bt(Ie(i, 0)) == 1 || e != r.from || t != r.to)
    return !1;
  let s = k2(n.state, i);
  return s ? (n.dispatch(s), !0) : !1;
}), b2 = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let i = tg(n, n.selection.main.head).brackets || Dr.brackets, r = null, s = n.changeByRange((o) => {
    if (o.empty) {
      let l = x2(n.doc, o.head);
      for (let a of i)
        if (a == l && No(n.doc, o.head) == eg(Ie(a, 0)))
          return {
            changes: { from: o.head - a.length, to: o.head + a.length },
            range: $.cursor(o.head - a.length)
          };
    }
    return { range: r = o };
  });
  return r || e(n.update(s, { scrollIntoView: !0, userEvent: "delete.backward" })), !r;
}, y2 = [
  { key: "Backspace", run: b2 }
];
function k2(n, e) {
  let t = tg(n, n.selection.main.head), i = t.brackets || Dr.brackets;
  for (let r of i) {
    let s = eg(Ie(r, 0));
    if (e == r)
      return s == r ? v2(n, r, i.indexOf(r + r + r) > -1, t) : w2(n, r, s, t.before || Dr.before);
    if (e == s && ng(n, n.selection.main.from))
      return S2(n, r, s);
  }
  return null;
}
function ng(n, e) {
  let t = !1;
  return n.field(JO).between(0, n.doc.length, (i) => {
    i == e && (t = !0);
  }), t;
}
function No(n, e) {
  let t = n.sliceString(e, e + 2);
  return t.slice(0, bt(Ie(t, 0)));
}
function x2(n, e) {
  let t = n.sliceString(e - 2, e);
  return bt(Ie(t, 0)) == t.length ? t : t.slice(1);
}
function w2(n, e, t, i) {
  let r = null, s = n.changeByRange((o) => {
    if (!o.empty)
      return {
        changes: [{ insert: e, from: o.from }, { insert: t, from: o.to }],
        effects: Nn.of(o.to + e.length),
        range: $.range(o.anchor + e.length, o.head + e.length)
      };
    let l = No(n.doc, o.head);
    return !l || /\s/.test(l) || i.indexOf(l) > -1 ? {
      changes: { insert: e + t, from: o.head },
      effects: Nn.of(o.head + e.length),
      range: $.cursor(o.head + e.length)
    } : { range: r = o };
  });
  return r ? null : n.update(s, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function S2(n, e, t) {
  let i = null, r = n.changeByRange((s) => s.empty && No(n.doc, s.head) == t ? {
    changes: { from: s.head, to: s.head + t.length, insert: t },
    range: $.cursor(s.head + t.length)
  } : i = { range: s });
  return i ? null : n.update(r, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function v2(n, e, t, i) {
  let r = i.stringPrefixes || Dr.stringPrefixes, s = null, o = n.changeByRange((l) => {
    if (!l.empty)
      return {
        changes: [{ insert: e, from: l.from }, { insert: e, from: l.to }],
        effects: Nn.of(l.to + e.length),
        range: $.range(l.anchor + e.length, l.head + e.length)
      };
    let a = l.head, h = No(n.doc, a), u;
    if (h == e) {
      if (xf(n, a))
        return {
          changes: { insert: e + e, from: a },
          effects: Nn.of(a + e.length),
          range: $.cursor(a + e.length)
        };
      if (ng(n, a)) {
        let f = t && n.sliceDoc(a, a + e.length * 3) == e + e + e ? e + e + e : e;
        return {
          changes: { from: a, to: a + f.length, insert: f },
          range: $.cursor(a + f.length)
        };
      }
    } else {
      if (t && n.sliceDoc(a - 2 * e.length, a) == e + e && (u = wf(n, a - 2 * e.length, r)) > -1 && xf(n, u))
        return {
          changes: { insert: e + e + e + e, from: a },
          effects: Nn.of(a + e.length),
          range: $.cursor(a + e.length)
        };
      if (n.charCategorizer(a)(h) != ve.Word && wf(n, a, r) > -1 && !P2(n, a, e, r))
        return {
          changes: { insert: e + e, from: a },
          effects: Nn.of(a + e.length),
          range: $.cursor(a + e.length)
        };
    }
    return { range: s = l };
  });
  return s ? null : n.update(o, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function xf(n, e) {
  let t = ye(n).resolveInner(e + 1);
  return t.parent && t.from == e;
}
function P2(n, e, t, i) {
  let r = ye(n).resolveInner(e, -1), s = i.reduce((o, l) => Math.max(o, l.length), 0);
  for (let o = 0; o < 5; o++) {
    let l = n.sliceDoc(r.from, Math.min(r.to, r.from + t.length + s)), a = l.indexOf(t);
    if (!a || a > -1 && i.indexOf(l.slice(0, a)) > -1) {
      let u = r.firstChild;
      for (; u && u.from == r.from && u.to - u.from > t.length + a; ) {
        if (n.sliceDoc(u.to - t.length, u.to) == t)
          return !1;
        u = u.firstChild;
      }
      return !0;
    }
    let h = r.to == e && r.parent;
    if (!h)
      break;
    r = h;
  }
  return !1;
}
function wf(n, e, t) {
  let i = n.charCategorizer(e);
  if (i(n.sliceDoc(e - 1, e)) != ve.Word)
    return e;
  for (let r of t) {
    let s = e - r.length;
    if (n.sliceDoc(s, e) == r && i(n.sliceDoc(s - 1, s)) != ve.Word)
      return s;
  }
  return -1;
}
function Q2(n = {}) {
  return [
    i2,
    nt,
    We.of(n),
    t2,
    $2,
    HO
  ];
}
const ig = [
  { key: "Ctrl-Space", run: GS },
  { key: "Escape", run: HS },
  { key: "ArrowDown", run: /* @__PURE__ */ ws(!0) },
  { key: "ArrowUp", run: /* @__PURE__ */ ws(!1) },
  { key: "PageDown", run: /* @__PURE__ */ ws(!0, "page") },
  { key: "PageUp", run: /* @__PURE__ */ ws(!1, "page") },
  { key: "Enter", run: FS }
], $2 = /* @__PURE__ */ un.highest(/* @__PURE__ */ zi.computeN([We], (n) => n.facet(We).defaultKeymap ? [ig] : []));
class C2 {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.diagnostic = i;
  }
}
class qn {
  constructor(e, t, i) {
    this.diagnostics = e, this.panel = t, this.selected = i;
  }
  static init(e, t, i) {
    let r = e, s = i.facet(ru).markerFilter;
    s && (r = s(r, i));
    let o = j.set(r.map((l) => l.from == l.to || l.from == l.to - 1 && i.doc.lineAt(l.from).to == l.from ? j.widget({
      widget: new D2(l),
      diagnostic: l
    }).range(l.from) : j.mark({
      attributes: { class: "cm-lintRange cm-lintRange-" + l.severity + (l.markClass ? " " + l.markClass : "") },
      diagnostic: l,
      inclusive: !0
    }).range(l.from, l.to)), !0);
    return new qn(o, t, Ai(o));
  }
}
function Ai(n, e = null, t = 0) {
  let i = null;
  return n.between(t, 1e9, (r, s, { spec: o }) => {
    if (!(e && o.diagnostic != e))
      return i = new C2(r, s, o.diagnostic), !1;
  }), i;
}
function T2(n, e) {
  let t = e.pos, i = e.end || t, r = n.state.facet(ru).hideOn(n, t, i);
  if (r != null)
    return r;
  let s = n.startState.doc.lineAt(e.pos);
  return !!(n.effects.some((o) => o.is(rg)) || n.changes.touchesRange(s.from, Math.max(s.to, i)));
}
function A2(n, e) {
  return n.field(dt, !1) ? e : e.concat(K.appendConfig.of(_2));
}
const rg = /* @__PURE__ */ K.define(), iu = /* @__PURE__ */ K.define(), sg = /* @__PURE__ */ K.define(), dt = /* @__PURE__ */ De.define({
  create() {
    return new qn(j.none, null, null);
  },
  update(n, e) {
    if (e.docChanged) {
      let t = n.diagnostics.map(e.changes), i = null;
      if (n.selected) {
        let r = e.changes.mapPos(n.selected.from, 1);
        i = Ai(t, n.selected.diagnostic, r) || Ai(t, null, r);
      }
      n = new qn(t, n.panel, i);
    }
    for (let t of e.effects)
      t.is(rg) ? n = qn.init(t.value, n.panel, e.state) : t.is(iu) ? n = new qn(n.diagnostics, t.value ? Uo.open : null, n.selected) : t.is(sg) && (n = new qn(n.diagnostics, n.panel, t.value));
    return n;
  },
  provide: (n) => [
    Cr.from(n, (e) => e.panel),
    I.decorations.from(n, (e) => e.diagnostics)
  ]
}), R2 = /* @__PURE__ */ j.mark({ class: "cm-lintRange cm-lintRange-active", inclusive: !0 });
function Z2(n, e, t) {
  let { diagnostics: i } = n.state.field(dt), r = [], s = 2e8, o = 0;
  i.between(e - (t < 0 ? 1 : 0), e + (t > 0 ? 1 : 0), (a, h, { spec: u }) => {
    e >= a && e <= h && (a == h || (e > a || t > 0) && (e < h || t < 0)) && (r.push(u.diagnostic), s = Math.min(a, s), o = Math.max(h, o));
  });
  let l = n.state.facet(ru).tooltipFilter;
  return l && (r = l(r, n.state)), r.length ? {
    pos: s,
    end: o,
    above: n.state.doc.lineAt(s).to < o,
    create() {
      return { dom: M2(n, r) };
    }
  } : null;
}
function M2(n, e) {
  return ge("ul", { class: "cm-tooltip-lint" }, e.map((t) => lg(n, t, !1)));
}
const E2 = (n) => {
  let e = n.state.field(dt, !1);
  (!e || !e.panel) && n.dispatch({ effects: A2(n.state, [iu.of(!0)]) });
  let t = $r(n, Uo.open);
  return t && t.dom.querySelector(".cm-panel-lint ul").focus(), !0;
}, Sf = (n) => {
  let e = n.state.field(dt, !1);
  return !e || !e.panel ? !1 : (n.dispatch({ effects: iu.of(!1) }), !0);
}, z2 = (n) => {
  let e = n.state.field(dt, !1);
  if (!e)
    return !1;
  let t = n.state.selection.main, i = e.diagnostics.iter(t.to + 1);
  return !i.value && (i = e.diagnostics.iter(0), !i.value || i.from == t.from && i.to == t.to) ? !1 : (n.dispatch({ selection: { anchor: i.from, head: i.to }, scrollIntoView: !0 }), !0);
}, X2 = [
  { key: "Mod-Shift-m", run: E2, preventDefault: !0 },
  { key: "F8", run: z2 }
], ru = /* @__PURE__ */ B.define({
  combine(n) {
    return Object.assign({ sources: n.map((e) => e.source).filter((e) => e != null) }, Ht(n.map((e) => e.config), {
      delay: 750,
      markerFilter: null,
      tooltipFilter: null,
      needsRefresh: null,
      hideOn: () => null
    }, {
      needsRefresh: (e, t) => e ? t ? (i) => e(i) || t(i) : e : t
    }));
  }
});
function og(n) {
  let e = [];
  if (n)
    e:
      for (let { name: t } of n) {
        for (let i = 0; i < t.length; i++) {
          let r = t[i];
          if (/[a-zA-Z]/.test(r) && !e.some((s) => s.toLowerCase() == r.toLowerCase())) {
            e.push(r);
            continue e;
          }
        }
        e.push("");
      }
  return e;
}
function lg(n, e, t) {
  var i;
  let r = t ? og(e.actions) : [];
  return ge("li", { class: "cm-diagnostic cm-diagnostic-" + e.severity }, ge("span", { class: "cm-diagnosticText" }, e.renderMessage ? e.renderMessage(n) : e.message), (i = e.actions) === null || i === void 0 ? void 0 : i.map((s, o) => {
    let l = !1, a = (f) => {
      if (f.preventDefault(), l)
        return;
      l = !0;
      let d = Ai(n.state.field(dt).diagnostics, e);
      d && s.apply(n, d.from, d.to);
    }, { name: h } = s, u = r[o] ? h.indexOf(r[o]) : -1, c = u < 0 ? h : [
      h.slice(0, u),
      ge("u", h.slice(u, u + 1)),
      h.slice(u + 1)
    ];
    return ge("button", {
      type: "button",
      class: "cm-diagnosticAction",
      onclick: a,
      onmousedown: a,
      "aria-label": ` Action: ${h}${u < 0 ? "" : ` (access key "${r[o]})"`}.`
    }, c);
  }), e.source && ge("div", { class: "cm-diagnosticSource" }, e.source));
}
class D2 extends Kt {
  constructor(e) {
    super(), this.diagnostic = e;
  }
  eq(e) {
    return e.diagnostic == this.diagnostic;
  }
  toDOM() {
    return ge("span", { class: "cm-lintPoint cm-lintPoint-" + this.diagnostic.severity });
  }
}
class vf {
  constructor(e, t) {
    this.diagnostic = t, this.id = "item_" + Math.floor(Math.random() * 4294967295).toString(16), this.dom = lg(e, t, !0), this.dom.id = this.id, this.dom.setAttribute("role", "option");
  }
}
class Uo {
  constructor(e) {
    this.view = e, this.items = [];
    let t = (r) => {
      if (r.keyCode == 27)
        Sf(this.view), this.view.focus();
      else if (r.keyCode == 38 || r.keyCode == 33)
        this.moveSelection((this.selectedIndex - 1 + this.items.length) % this.items.length);
      else if (r.keyCode == 40 || r.keyCode == 34)
        this.moveSelection((this.selectedIndex + 1) % this.items.length);
      else if (r.keyCode == 36)
        this.moveSelection(0);
      else if (r.keyCode == 35)
        this.moveSelection(this.items.length - 1);
      else if (r.keyCode == 13)
        this.view.focus();
      else if (r.keyCode >= 65 && r.keyCode <= 90 && this.selectedIndex >= 0) {
        let { diagnostic: s } = this.items[this.selectedIndex], o = og(s.actions);
        for (let l = 0; l < o.length; l++)
          if (o[l].toUpperCase().charCodeAt(0) == r.keyCode) {
            let a = Ai(this.view.state.field(dt).diagnostics, s);
            a && s.actions[l].apply(e, a.from, a.to);
          }
      } else
        return;
      r.preventDefault();
    }, i = (r) => {
      for (let s = 0; s < this.items.length; s++)
        this.items[s].dom.contains(r.target) && this.moveSelection(s);
    };
    this.list = ge("ul", {
      tabIndex: 0,
      role: "listbox",
      "aria-label": this.view.state.phrase("Diagnostics"),
      onkeydown: t,
      onclick: i
    }), this.dom = ge("div", { class: "cm-panel-lint" }, this.list, ge("button", {
      type: "button",
      name: "close",
      "aria-label": this.view.state.phrase("close"),
      onclick: () => Sf(this.view)
    }, "×")), this.update();
  }
  get selectedIndex() {
    let e = this.view.state.field(dt).selected;
    if (!e)
      return -1;
    for (let t = 0; t < this.items.length; t++)
      if (this.items[t].diagnostic == e.diagnostic)
        return t;
    return -1;
  }
  update() {
    let { diagnostics: e, selected: t } = this.view.state.field(dt), i = 0, r = !1, s = null;
    for (e.between(0, this.view.state.doc.length, (o, l, { spec: a }) => {
      let h = -1, u;
      for (let c = i; c < this.items.length; c++)
        if (this.items[c].diagnostic == a.diagnostic) {
          h = c;
          break;
        }
      h < 0 ? (u = new vf(this.view, a.diagnostic), this.items.splice(i, 0, u), r = !0) : (u = this.items[h], h > i && (this.items.splice(i, h - i), r = !0)), t && u.diagnostic == t.diagnostic ? u.dom.hasAttribute("aria-selected") || (u.dom.setAttribute("aria-selected", "true"), s = u) : u.dom.hasAttribute("aria-selected") && u.dom.removeAttribute("aria-selected"), i++;
    }); i < this.items.length && !(this.items.length == 1 && this.items[0].diagnostic.from < 0); )
      r = !0, this.items.pop();
    this.items.length == 0 && (this.items.push(new vf(this.view, {
      from: -1,
      to: -1,
      severity: "info",
      message: this.view.state.phrase("No diagnostics")
    })), r = !0), s ? (this.list.setAttribute("aria-activedescendant", s.id), this.view.requestMeasure({
      key: this,
      read: () => ({ sel: s.dom.getBoundingClientRect(), panel: this.list.getBoundingClientRect() }),
      write: ({ sel: o, panel: l }) => {
        let a = l.height / this.list.offsetHeight;
        o.top < l.top ? this.list.scrollTop -= (l.top - o.top) / a : o.bottom > l.bottom && (this.list.scrollTop += (o.bottom - l.bottom) / a);
      }
    })) : this.selectedIndex < 0 && this.list.removeAttribute("aria-activedescendant"), r && this.sync();
  }
  sync() {
    let e = this.list.firstChild;
    function t() {
      let i = e;
      e = i.nextSibling, i.remove();
    }
    for (let i of this.items)
      if (i.dom.parentNode == this.list) {
        for (; e != i.dom; )
          t();
        e = i.dom.nextSibling;
      } else
        this.list.insertBefore(i.dom, e);
    for (; e; )
      t();
  }
  moveSelection(e) {
    if (this.selectedIndex < 0)
      return;
    let t = this.view.state.field(dt), i = Ai(t.diagnostics, this.items[e].diagnostic);
    i && this.view.dispatch({
      selection: { anchor: i.from, head: i.to },
      scrollIntoView: !0,
      effects: sg.of(i)
    });
  }
  static open(e) {
    return new Uo(e);
  }
}
function L2(n, e = 'viewBox="0 0 40 40"') {
  return `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" ${e}>${encodeURIComponent(n)}</svg>')`;
}
function Ss(n) {
  return L2(`<path d="m0 2.5 l2 -1.5 l1 0 l2 1.5 l1 0" stroke="${n}" fill="none" stroke-width=".7"/>`, 'width="6" height="3"');
}
const I2 = /* @__PURE__ */ I.baseTheme({
  ".cm-diagnostic": {
    padding: "3px 6px 3px 8px",
    marginLeft: "-1px",
    display: "block",
    whiteSpace: "pre-wrap"
  },
  ".cm-diagnostic-error": { borderLeft: "5px solid #d11" },
  ".cm-diagnostic-warning": { borderLeft: "5px solid orange" },
  ".cm-diagnostic-info": { borderLeft: "5px solid #999" },
  ".cm-diagnostic-hint": { borderLeft: "5px solid #66d" },
  ".cm-diagnosticAction": {
    font: "inherit",
    border: "none",
    padding: "2px 4px",
    backgroundColor: "#444",
    color: "white",
    borderRadius: "3px",
    marginLeft: "8px",
    cursor: "pointer"
  },
  ".cm-diagnosticSource": {
    fontSize: "70%",
    opacity: 0.7
  },
  ".cm-lintRange": {
    backgroundPosition: "left bottom",
    backgroundRepeat: "repeat-x",
    paddingBottom: "0.7px"
  },
  ".cm-lintRange-error": { backgroundImage: /* @__PURE__ */ Ss("#d11") },
  ".cm-lintRange-warning": { backgroundImage: /* @__PURE__ */ Ss("orange") },
  ".cm-lintRange-info": { backgroundImage: /* @__PURE__ */ Ss("#999") },
  ".cm-lintRange-hint": { backgroundImage: /* @__PURE__ */ Ss("#66d") },
  ".cm-lintRange-active": { backgroundColor: "#ffdd9980" },
  ".cm-tooltip-lint": {
    padding: 0,
    margin: 0
  },
  ".cm-lintPoint": {
    position: "relative",
    "&:after": {
      content: '""',
      position: "absolute",
      bottom: 0,
      left: "-2px",
      borderLeft: "3px solid transparent",
      borderRight: "3px solid transparent",
      borderBottom: "4px solid #d11"
    }
  },
  ".cm-lintPoint-warning": {
    "&:after": { borderBottomColor: "orange" }
  },
  ".cm-lintPoint-info": {
    "&:after": { borderBottomColor: "#999" }
  },
  ".cm-lintPoint-hint": {
    "&:after": { borderBottomColor: "#66d" }
  },
  ".cm-panel.cm-panel-lint": {
    position: "relative",
    "& ul": {
      maxHeight: "100px",
      overflowY: "auto",
      "& [aria-selected]": {
        backgroundColor: "#ddd",
        "& u": { textDecoration: "underline" }
      },
      "&:focus [aria-selected]": {
        background_fallback: "#bdf",
        backgroundColor: "Highlight",
        color_fallback: "white",
        color: "HighlightText"
      },
      "& u": { textDecoration: "none" },
      padding: 0,
      margin: 0
    },
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "2px",
      background: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    }
  }
}), _2 = [
  dt,
  /* @__PURE__ */ I.decorations.compute([dt], (n) => {
    let { selected: e, panel: t } = n.field(dt);
    return !e || !t || e.from == e.to ? j.none : j.set([
      R2.range(e.from, e.to)
    ]);
  }),
  /* @__PURE__ */ Pk(Z2, { hideOn: T2 }),
  I2
], q2 = [
  Ek(),
  Dk(),
  ek(),
  nw(),
  Tx(),
  By(),
  Uy(),
  ee.allowMultipleSelections.of(!0),
  gx(),
  Rx(Ex, { fallback: !0 }),
  qx(),
  m2(),
  Q2(),
  pk(),
  gk(),
  ok(),
  hS(),
  zi.of([
    ...y2,
    ...nS,
    ...CS,
    ...cw,
    ...Px,
    ...ig,
    ...X2
  ])
];
/*!
* VueCodemirror v6.1.1
* Copyright (c) Surmon. All rights reserved.
* Released under the MIT License.
* Surmon
*/
var W2 = Object.freeze({ autofocus: !1, disabled: !1, indentWithTab: !0, tabSize: 2, placeholder: "", autoDestroy: !0, extensions: [q2] }), B2 = Symbol("vue-codemirror-global-config"), Ge, V2 = function(n) {
  var e = n.onUpdate, t = n.onChange, i = n.onFocus, r = n.onBlur, s = function(o, l) {
    var a = {};
    for (var h in o)
      Object.prototype.hasOwnProperty.call(o, h) && l.indexOf(h) < 0 && (a[h] = o[h]);
    if (o != null && typeof Object.getOwnPropertySymbols == "function") {
      var u = 0;
      for (h = Object.getOwnPropertySymbols(o); u < h.length; u++)
        l.indexOf(h[u]) < 0 && Object.prototype.propertyIsEnumerable.call(o, h[u]) && (a[h[u]] = o[h[u]]);
    }
    return a;
  }(n, ["onUpdate", "onChange", "onFocus", "onBlur"]);
  return ee.create({ doc: s.doc, selection: s.selection, extensions: (Array.isArray(s.extensions) ? s.extensions : [s.extensions]).concat([I.updateListener.of(function(o) {
    e(o), o.docChanged && t(o.state.doc.toString(), o), o.focusChanged && (o.view.hasFocus ? i(o) : r(o));
  })]) });
}, ai = function(n) {
  var e = new Br();
  return { compartment: e, run: function(t) {
    e.get(n.state) ? n.dispatch({ effects: e.reconfigure(t) }) : n.dispatch({ effects: K.appendConfig.of(e.of(t)) });
  } };
}, Pf = function(n, e) {
  var t = ai(n), i = t.compartment, r = t.run;
  return function(s) {
    var o = i.get(n.state);
    r(s ?? o !== e ? e : []);
  };
}, vs = { type: Boolean, default: void 0 }, Y2 = { autofocus: vs, disabled: vs, indentWithTab: vs, tabSize: Number, placeholder: String, style: Object, autoDestroy: vs, phrases: Object, root: Object, extensions: Array, selection: Object }, j2 = { modelValue: { type: String, default: "" } }, N2 = Object.assign(Object.assign({}, Y2), j2);
(function(n) {
  n.Change = "change", n.Update = "update", n.Focus = "focus", n.Blur = "blur", n.Ready = "ready", n.ModelUpdate = "update:modelValue";
})(Ge || (Ge = {}));
var Wn = {};
Wn[Ge.Change] = function(n, e) {
  return !0;
}, Wn[Ge.Update] = function(n) {
  return !0;
}, Wn[Ge.Focus] = function(n) {
  return !0;
}, Wn[Ge.Blur] = function(n) {
  return !0;
}, Wn[Ge.Ready] = function(n) {
  return !0;
};
var ag = {};
ag[Ge.ModelUpdate] = Wn[Ge.Change];
var U2 = Object.assign(Object.assign({}, Wn), ag), F2 = Pt({ name: "VueCodemirror", props: Object.assign({}, N2), emits: Object.assign({}, U2), setup: function(n, e) {
  var t = il(), i = il(), r = il(), s = Object.assign(Object.assign({}, W2), op(B2, {})), o = lp(function() {
    var l = {};
    return Object.keys(X0(n)).forEach(function(a) {
      var h;
      a !== "modelValue" && (l[a] = (h = n[a]) !== null && h !== void 0 ? h : s[a]);
    }), l;
  });
  return xh(function() {
    var l;
    i.value = V2({ doc: n.modelValue, selection: o.value.selection, extensions: (l = s.extensions) !== null && l !== void 0 ? l : [], onFocus: function(h) {
      return e.emit(Ge.Focus, h);
    }, onBlur: function(h) {
      return e.emit(Ge.Blur, h);
    }, onUpdate: function(h) {
      return e.emit(Ge.Update, h);
    }, onChange: function(h, u) {
      h !== n.modelValue && (e.emit(Ge.Change, h, u), e.emit(Ge.ModelUpdate, h, u));
    } }), r.value = function(h) {
      return new I(Object.assign({}, h));
    }({ state: i.value, parent: t.value, root: o.value.root });
    var a = function(h) {
      var u = function() {
        return h.state.doc.toString();
      }, c = ai(h).run, f = Pf(h, [I.editable.of(!1), ee.readOnly.of(!0)]), d = Pf(h, zi.of([iS])), p = ai(h).run, m = ai(h).run, O = ai(h).run, g = ai(h).run;
      return { focus: function() {
        return h.focus();
      }, getDoc: u, setDoc: function(b) {
        b !== u() && h.dispatch({ changes: { from: 0, to: h.state.doc.length, insert: b } });
      }, reExtensions: c, toggleDisabled: f, toggleIndentWithTab: d, setTabSize: function(b) {
        p([ee.tabSize.of(b), Di.of(" ".repeat(b))]);
      }, setPhrases: function(b) {
        m([ee.phrases.of(b)]);
      }, setPlaceholder: function(b) {
        O(uk(b));
      }, setStyle: function(b) {
        b === void 0 && (b = {}), g(I.theme({ "&": Object.assign({}, b) }));
      } };
    }(r.value);
    mt(function() {
      return n.modelValue;
    }, function(h) {
      h !== a.getDoc() && a.setDoc(h);
    }), mt(function() {
      return n.extensions;
    }, function(h) {
      return a.reExtensions(h || []);
    }, { immediate: !0 }), mt(function() {
      return o.value.disabled;
    }, function(h) {
      return a.toggleDisabled(h);
    }, { immediate: !0 }), mt(function() {
      return o.value.indentWithTab;
    }, function(h) {
      return a.toggleIndentWithTab(h);
    }, { immediate: !0 }), mt(function() {
      return o.value.tabSize;
    }, function(h) {
      return a.setTabSize(h);
    }, { immediate: !0 }), mt(function() {
      return o.value.phrases;
    }, function(h) {
      return a.setPhrases(h || {});
    }, { immediate: !0 }), mt(function() {
      return o.value.placeholder;
    }, function(h) {
      return a.setPlaceholder(h);
    }, { immediate: !0 }), mt(function() {
      return o.value.style;
    }, function(h) {
      return a.setStyle(h);
    }, { immediate: !0 }), o.value.autofocus && a.focus(), e.emit(Ge.Ready, { state: i.value, view: r.value, container: t.value });
  }), D0(function() {
    o.value.autoDestroy && r.value && function(l) {
      l.destroy();
    }(r.value);
  }), function() {
    return L0("div", { class: "v-codemirror", style: { display: "contents" }, ref: t });
  };
} }), G2 = F2;
function xo(n, e) {
  const t = String(n);
  if (typeof e != "string")
    throw new TypeError("Expected character");
  let i = 0, r = t.indexOf(e);
  for (; r !== -1; )
    i++, r = t.indexOf(e, r + e.length);
  return i;
}
const He = En(/[A-Za-z]/), je = En(/[\dA-Za-z]/), H2 = En(/[#-'*+\--9=?A-Z^-~]/);
function wo(n) {
  return (
    // Special whitespace codes (which have negative values), C0 and Control
    // character DEL
    n !== null && (n < 32 || n === 127)
  );
}
const Ja = En(/\d/), K2 = En(/[\dA-Fa-f]/), J2 = En(/[!-/:-@[-`{-~]/);
function N(n) {
  return n !== null && n < -2;
}
function me(n) {
  return n !== null && (n < 0 || n === 32);
}
function te(n) {
  return n === -2 || n === -1 || n === 32;
}
const Fo = En(new RegExp("\\p{P}|\\p{S}", "u")), Jn = En(/\s/);
function En(n) {
  return e;
  function e(t) {
    return t !== null && t > -1 && n.test(String.fromCharCode(t));
  }
}
function ev(n) {
  if (typeof n != "string")
    throw new TypeError("Expected a string");
  return n.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
}
const Go = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends string>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & {type: Condition}) &
   *   (<Condition extends Props>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Condition) &
   *   (<Condition extends TestFunction>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Predicate<Condition, Node>) &
   *   ((test?: null | undefined) => (node?: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test} [test]
   * @returns {Check}
   */
  function(n) {
    if (n == null)
      return rv;
    if (typeof n == "function")
      return Ho(n);
    if (typeof n == "object")
      return Array.isArray(n) ? tv(n) : nv(n);
    if (typeof n == "string")
      return iv(n);
    throw new Error("Expected function, string, or object as test");
  }
);
function tv(n) {
  const e = [];
  let t = -1;
  for (; ++t < n.length; )
    e[t] = Go(n[t]);
  return Ho(i);
  function i(...r) {
    let s = -1;
    for (; ++s < e.length; )
      if (e[s].apply(this, r))
        return !0;
    return !1;
  }
}
function nv(n) {
  const e = (
    /** @type {Record<string, unknown>} */
    n
  );
  return Ho(t);
  function t(i) {
    const r = (
      /** @type {Record<string, unknown>} */
      /** @type {unknown} */
      i
    );
    let s;
    for (s in n)
      if (r[s] !== e[s])
        return !1;
    return !0;
  }
}
function iv(n) {
  return Ho(e);
  function e(t) {
    return t && t.type === n;
  }
}
function Ho(n) {
  return e;
  function e(t, i, r) {
    return !!(sv(t) && n.call(
      this,
      t,
      typeof i == "number" ? i : void 0,
      r || void 0
    ));
  }
}
function rv() {
  return !0;
}
function sv(n) {
  return n !== null && typeof n == "object" && "type" in n;
}
const hg = [], ov = !0, eh = !1, lv = "skip";
function ug(n, e, t, i) {
  let r;
  typeof e == "function" && typeof t != "function" ? (i = t, t = e) : r = e;
  const s = Go(r), o = i ? -1 : 1;
  l(n, void 0, [])();
  function l(a, h, u) {
    const c = (
      /** @type {Record<string, unknown>} */
      a && typeof a == "object" ? a : {}
    );
    if (typeof c.type == "string") {
      const d = (
        // `hast`
        typeof c.tagName == "string" ? c.tagName : (
          // `xast`
          typeof c.name == "string" ? c.name : void 0
        )
      );
      Object.defineProperty(f, "name", {
        value: "node (" + (a.type + (d ? "<" + d + ">" : "")) + ")"
      });
    }
    return f;
    function f() {
      let d = hg, p, m, O;
      if ((!e || s(a, h, u[u.length - 1] || void 0)) && (d = av(t(a, u)), d[0] === eh))
        return d;
      if ("children" in a && a.children) {
        const g = (
          /** @type {UnistParent} */
          a
        );
        if (g.children && d[0] !== lv)
          for (m = (i ? g.children.length : -1) + o, O = u.concat(g); m > -1 && m < g.children.length; ) {
            const b = g.children[m];
            if (p = l(b, m, O)(), p[0] === eh)
              return p;
            m = typeof p[1] == "number" ? p[1] : m + o;
          }
      }
      return d;
    }
  }
}
function av(n) {
  return Array.isArray(n) ? n : typeof n == "number" ? [ov, n] : n == null ? hg : [n];
}
function hv(n, e, t) {
  const r = Go((t || {}).ignore || []), s = uv(e);
  let o = -1;
  for (; ++o < s.length; )
    ug(n, "text", l);
  function l(h, u) {
    let c = -1, f;
    for (; ++c < u.length; ) {
      const d = u[c], p = f ? f.children : void 0;
      if (r(
        d,
        p ? p.indexOf(d) : void 0,
        f
      ))
        return;
      f = d;
    }
    if (f)
      return a(h, u);
  }
  function a(h, u) {
    const c = u[u.length - 1], f = s[o][0], d = s[o][1];
    let p = 0;
    const O = c.children.indexOf(h);
    let g = !1, b = [];
    f.lastIndex = 0;
    let S = f.exec(h.value);
    for (; S; ) {
      const Q = S.index, P = {
        index: S.index,
        input: S.input,
        stack: [...u, h]
      };
      let w = d(...S, P);
      if (typeof w == "string" && (w = w.length > 0 ? { type: "text", value: w } : void 0), w === !1 ? f.lastIndex = Q + 1 : (p !== Q && b.push({
        type: "text",
        value: h.value.slice(p, Q)
      }), Array.isArray(w) ? b.push(...w) : w && b.push(w), p = Q + S[0].length, g = !0), !f.global)
        break;
      S = f.exec(h.value);
    }
    return g ? (p < h.value.length && b.push({ type: "text", value: h.value.slice(p) }), c.children.splice(O, 1, ...b)) : b = [h], O + b.length;
  }
}
function uv(n) {
  const e = [];
  if (!Array.isArray(n))
    throw new TypeError("Expected find and replace tuple or list of tuples");
  const t = !n[0] || Array.isArray(n[0]) ? n : [n];
  let i = -1;
  for (; ++i < t.length; ) {
    const r = t[i];
    e.push([cv(r[0]), fv(r[1])]);
  }
  return e;
}
function cv(n) {
  return typeof n == "string" ? new RegExp(ev(n), "g") : n;
}
function fv(n) {
  return typeof n == "function" ? n : function() {
    return n;
  };
}
const $l = "phrasing", Cl = ["autolink", "link", "image", "label"];
function dv() {
  return {
    transforms: [kv],
    enter: {
      literalAutolink: mv,
      literalAutolinkEmail: Tl,
      literalAutolinkHttp: Tl,
      literalAutolinkWww: Tl
    },
    exit: {
      literalAutolink: yv,
      literalAutolinkEmail: bv,
      literalAutolinkHttp: Ov,
      literalAutolinkWww: gv
    }
  };
}
function pv() {
  return {
    unsafe: [
      {
        character: "@",
        before: "[+\\-.\\w]",
        after: "[\\-.\\w]",
        inConstruct: $l,
        notInConstruct: Cl
      },
      {
        character: ".",
        before: "[Ww]",
        after: "[\\-.\\w]",
        inConstruct: $l,
        notInConstruct: Cl
      },
      {
        character: ":",
        before: "[ps]",
        after: "\\/",
        inConstruct: $l,
        notInConstruct: Cl
      }
    ]
  };
}
function mv(n) {
  this.enter({ type: "link", title: null, url: "", children: [] }, n);
}
function Tl(n) {
  this.config.enter.autolinkProtocol.call(this, n);
}
function Ov(n) {
  this.config.exit.autolinkProtocol.call(this, n);
}
function gv(n) {
  this.config.exit.data.call(this, n);
  const e = this.stack[this.stack.length - 1];
  e.type, e.url = "http://" + this.sliceSerialize(n);
}
function bv(n) {
  this.config.exit.autolinkEmail.call(this, n);
}
function yv(n) {
  this.exit(n);
}
function kv(n) {
  hv(
    n,
    [
      [/(https?:\/\/|www(?=\.))([-.\w]+)([^ \t\r\n]*)/gi, xv],
      [/([-.\w+]+)@([-\w]+(?:\.[-\w]+)+)/g, wv]
    ],
    { ignore: ["link", "linkReference"] }
  );
}
function xv(n, e, t, i, r) {
  let s = "";
  if (!cg(r) || (/^w/i.test(e) && (t = e + t, e = "", s = "http://"), !Sv(t)))
    return !1;
  const o = vv(t + i);
  if (!o[0])
    return !1;
  const l = {
    type: "link",
    title: null,
    url: s + e + o[0],
    children: [{ type: "text", value: e + o[0] }]
  };
  return o[1] ? [l, { type: "text", value: o[1] }] : l;
}
function wv(n, e, t, i) {
  return (
    // Not an expected previous character.
    !cg(i, !0) || // Label ends in not allowed character.
    /[-\d_]$/.test(t) ? !1 : {
      type: "link",
      title: null,
      url: "mailto:" + e + "@" + t,
      children: [{ type: "text", value: e + "@" + t }]
    }
  );
}
function Sv(n) {
  const e = n.split(".");
  return !(e.length < 2 || e[e.length - 1] && (/_/.test(e[e.length - 1]) || !/[a-zA-Z\d]/.test(e[e.length - 1])) || e[e.length - 2] && (/_/.test(e[e.length - 2]) || !/[a-zA-Z\d]/.test(e[e.length - 2])));
}
function vv(n) {
  const e = /[!"&'),.:;<>?\]}]+$/.exec(n);
  if (!e)
    return [n, void 0];
  n = n.slice(0, e.index);
  let t = e[0], i = t.indexOf(")");
  const r = xo(n, "(");
  let s = xo(n, ")");
  for (; i !== -1 && r > s; )
    n += t.slice(0, i + 1), t = t.slice(i + 1), i = t.indexOf(")"), s++;
  return [n, t];
}
function cg(n, e) {
  const t = n.input.charCodeAt(n.index - 1);
  return (n.index === 0 || Jn(t) || Fo(t)) && (!e || t !== 47);
}
function Zt(n) {
  return n.replace(/[\t\n\r ]+/g, " ").replace(/^ | $/g, "").toLowerCase().toUpperCase();
}
fg.peek = zv;
function Pv() {
  return {
    enter: {
      gfmFootnoteDefinition: $v,
      gfmFootnoteDefinitionLabelString: Cv,
      gfmFootnoteCall: Rv,
      gfmFootnoteCallString: Zv
    },
    exit: {
      gfmFootnoteDefinition: Av,
      gfmFootnoteDefinitionLabelString: Tv,
      gfmFootnoteCall: Ev,
      gfmFootnoteCallString: Mv
    }
  };
}
function Qv() {
  return {
    // This is on by default already.
    unsafe: [{ character: "[", inConstruct: ["phrasing", "label", "reference"] }],
    handlers: { footnoteDefinition: Xv, footnoteReference: fg }
  };
}
function $v(n) {
  this.enter(
    { type: "footnoteDefinition", identifier: "", label: "", children: [] },
    n
  );
}
function Cv() {
  this.buffer();
}
function Tv(n) {
  const e = this.resume(), t = this.stack[this.stack.length - 1];
  t.type, t.label = e, t.identifier = Zt(
    this.sliceSerialize(n)
  ).toLowerCase();
}
function Av(n) {
  this.exit(n);
}
function Rv(n) {
  this.enter({ type: "footnoteReference", identifier: "", label: "" }, n);
}
function Zv() {
  this.buffer();
}
function Mv(n) {
  const e = this.resume(), t = this.stack[this.stack.length - 1];
  t.type, t.label = e, t.identifier = Zt(
    this.sliceSerialize(n)
  ).toLowerCase();
}
function Ev(n) {
  this.exit(n);
}
function fg(n, e, t, i) {
  const r = t.createTracker(i);
  let s = r.move("[^");
  const o = t.enter("footnoteReference"), l = t.enter("reference");
  return s += r.move(
    t.safe(t.associationId(n), {
      ...r.current(),
      before: s,
      after: "]"
    })
  ), l(), o(), s += r.move("]"), s;
}
function zv() {
  return "[";
}
function Xv(n, e, t, i) {
  const r = t.createTracker(i);
  let s = r.move("[^");
  const o = t.enter("footnoteDefinition"), l = t.enter("label");
  return s += r.move(
    t.safe(t.associationId(n), {
      ...r.current(),
      before: s,
      after: "]"
    })
  ), l(), s += r.move(
    "]:" + (n.children && n.children.length > 0 ? " " : "")
  ), r.shift(4), s += r.move(
    t.indentLines(t.containerFlow(n, r.current()), Dv)
  ), o(), s;
}
function Dv(n, e, t) {
  return e === 0 ? n : (t ? "" : "    ") + n;
}
const Lv = [
  "autolink",
  "destinationLiteral",
  "destinationRaw",
  "reference",
  "titleQuote",
  "titleApostrophe"
];
dg.peek = Bv;
function Iv() {
  return {
    canContainEols: ["delete"],
    enter: { strikethrough: qv },
    exit: { strikethrough: Wv }
  };
}
function _v() {
  return {
    unsafe: [
      {
        character: "~",
        inConstruct: "phrasing",
        notInConstruct: Lv
      }
    ],
    handlers: { delete: dg }
  };
}
function qv(n) {
  this.enter({ type: "delete", children: [] }, n);
}
function Wv(n) {
  this.exit(n);
}
function dg(n, e, t, i) {
  const r = t.createTracker(i), s = t.enter("strikethrough");
  let o = r.move("~~");
  return o += t.containerPhrasing(n, {
    ...r.current(),
    before: o,
    after: "~"
  }), o += r.move("~~"), s(), o;
}
function Bv() {
  return "~";
}
function Vv(n, e = {}) {
  const t = (e.align || []).concat(), i = e.stringLength || jv, r = [], s = [], o = [], l = [];
  let a = 0, h = -1;
  for (; ++h < n.length; ) {
    const p = [], m = [];
    let O = -1;
    for (n[h].length > a && (a = n[h].length); ++O < n[h].length; ) {
      const g = Yv(n[h][O]);
      if (e.alignDelimiters !== !1) {
        const b = i(g);
        m[O] = b, (l[O] === void 0 || b > l[O]) && (l[O] = b);
      }
      p.push(g);
    }
    s[h] = p, o[h] = m;
  }
  let u = -1;
  if (typeof t == "object" && "length" in t)
    for (; ++u < a; )
      r[u] = Qf(t[u]);
  else {
    const p = Qf(t);
    for (; ++u < a; )
      r[u] = p;
  }
  u = -1;
  const c = [], f = [];
  for (; ++u < a; ) {
    const p = r[u];
    let m = "", O = "";
    p === 99 ? (m = ":", O = ":") : p === 108 ? m = ":" : p === 114 && (O = ":");
    let g = e.alignDelimiters === !1 ? 1 : Math.max(
      1,
      l[u] - m.length - O.length
    );
    const b = m + "-".repeat(g) + O;
    e.alignDelimiters !== !1 && (g = m.length + g + O.length, g > l[u] && (l[u] = g), f[u] = g), c[u] = b;
  }
  s.splice(1, 0, c), o.splice(1, 0, f), h = -1;
  const d = [];
  for (; ++h < s.length; ) {
    const p = s[h], m = o[h];
    u = -1;
    const O = [];
    for (; ++u < a; ) {
      const g = p[u] || "";
      let b = "", S = "";
      if (e.alignDelimiters !== !1) {
        const Q = l[u] - (m[u] || 0), P = r[u];
        P === 114 ? b = " ".repeat(Q) : P === 99 ? Q % 2 ? (b = " ".repeat(Q / 2 + 0.5), S = " ".repeat(Q / 2 - 0.5)) : (b = " ".repeat(Q / 2), S = b) : S = " ".repeat(Q);
      }
      e.delimiterStart !== !1 && !u && O.push("|"), e.padding !== !1 && // Don’t add the opening space if we’re not aligning and the cell is
      // empty: there will be a closing space.
      !(e.alignDelimiters === !1 && g === "") && (e.delimiterStart !== !1 || u) && O.push(" "), e.alignDelimiters !== !1 && O.push(b), O.push(g), e.alignDelimiters !== !1 && O.push(S), e.padding !== !1 && O.push(" "), (e.delimiterEnd !== !1 || u !== a - 1) && O.push("|");
    }
    d.push(
      e.delimiterEnd === !1 ? O.join("").replace(/ +$/, "") : O.join("")
    );
  }
  return d.join(`
`);
}
function Yv(n) {
  return n == null ? "" : String(n);
}
function jv(n) {
  return n.length;
}
function Qf(n) {
  const e = typeof n == "string" ? n.codePointAt(0) : 0;
  return e === 67 || e === 99 ? 99 : e === 76 || e === 108 ? 108 : e === 82 || e === 114 ? 114 : 0;
}
const $f = {}.hasOwnProperty;
function Nv(n, e) {
  const t = e || {};
  function i(r, ...s) {
    let o = i.invalid;
    const l = i.handlers;
    if (r && $f.call(r, n)) {
      const a = String(r[n]);
      o = $f.call(l, a) ? l[a] : i.unknown;
    }
    if (o)
      return o.call(this, r, ...s);
  }
  return i.handlers = t.handlers || {}, i.invalid = t.invalid, i.unknown = t.unknown, i;
}
function Uv(n, e, t, i) {
  const r = t.enter("blockquote"), s = t.createTracker(i);
  s.move("> "), s.shift(2);
  const o = t.indentLines(
    t.containerFlow(n, s.current()),
    Fv
  );
  return r(), o;
}
function Fv(n, e, t) {
  return ">" + (t ? "" : " ") + n;
}
function Gv(n, e) {
  return Cf(n, e.inConstruct, !0) && !Cf(n, e.notInConstruct, !1);
}
function Cf(n, e, t) {
  if (typeof e == "string" && (e = [e]), !e || e.length === 0)
    return t;
  let i = -1;
  for (; ++i < e.length; )
    if (n.includes(e[i]))
      return !0;
  return !1;
}
function Tf(n, e, t, i) {
  let r = -1;
  for (; ++r < t.unsafe.length; )
    if (t.unsafe[r].character === `
` && Gv(t.stack, t.unsafe[r]))
      return /[ \t]/.test(i.before) ? "" : " ";
  return `\\
`;
}
function Hv(n, e) {
  const t = String(n);
  let i = t.indexOf(e), r = i, s = 0, o = 0;
  if (typeof e != "string")
    throw new TypeError("Expected substring");
  for (; i !== -1; )
    i === r ? ++s > o && (o = s) : s = 1, r = i + e.length, i = t.indexOf(e, r);
  return o;
}
function Kv(n, e) {
  return !!(e.options.fences === !1 && n.value && // If there’s no info…
  !n.lang && // And there’s a non-whitespace character…
  /[^ \r\n]/.test(n.value) && // And the value doesn’t start or end in a blank…
  !/^[\t ]*(?:[\r\n]|$)|(?:^|[\r\n])[\t ]*$/.test(n.value));
}
function Jv(n) {
  const e = n.options.fence || "`";
  if (e !== "`" && e !== "~")
    throw new Error(
      "Cannot serialize code with `" + e + "` for `options.fence`, expected `` ` `` or `~`"
    );
  return e;
}
function eP(n, e, t, i) {
  const r = Jv(t), s = n.value || "", o = r === "`" ? "GraveAccent" : "Tilde";
  if (Kv(n, t)) {
    const c = t.enter("codeIndented"), f = t.indentLines(s, tP);
    return c(), f;
  }
  const l = t.createTracker(i), a = r.repeat(Math.max(Hv(s, r) + 1, 3)), h = t.enter("codeFenced");
  let u = l.move(a);
  if (n.lang) {
    const c = t.enter(`codeFencedLang${o}`);
    u += l.move(
      t.safe(n.lang, {
        before: u,
        after: " ",
        encode: ["`"],
        ...l.current()
      })
    ), c();
  }
  if (n.lang && n.meta) {
    const c = t.enter(`codeFencedMeta${o}`);
    u += l.move(" "), u += l.move(
      t.safe(n.meta, {
        before: u,
        after: `
`,
        encode: ["`"],
        ...l.current()
      })
    ), c();
  }
  return u += l.move(`
`), s && (u += l.move(s + `
`)), u += l.move(a), h(), u;
}
function tP(n, e, t) {
  return (t ? "" : "    ") + n;
}
function su(n) {
  const e = n.options.quote || '"';
  if (e !== '"' && e !== "'")
    throw new Error(
      "Cannot serialize title with `" + e + "` for `options.quote`, expected `\"`, or `'`"
    );
  return e;
}
function nP(n, e, t, i) {
  const r = su(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.enter("definition");
  let l = t.enter("label");
  const a = t.createTracker(i);
  let h = a.move("[");
  return h += a.move(
    t.safe(t.associationId(n), {
      before: h,
      after: "]",
      ...a.current()
    })
  ), h += a.move("]: "), l(), // If there’s no url, or…
  !n.url || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (l = t.enter("destinationLiteral"), h += a.move("<"), h += a.move(
    t.safe(n.url, { before: h, after: ">", ...a.current() })
  ), h += a.move(">")) : (l = t.enter("destinationRaw"), h += a.move(
    t.safe(n.url, {
      before: h,
      after: n.title ? " " : `
`,
      ...a.current()
    })
  )), l(), n.title && (l = t.enter(`title${s}`), h += a.move(" " + r), h += a.move(
    t.safe(n.title, {
      before: h,
      after: r,
      ...a.current()
    })
  ), h += a.move(r), l()), o(), h;
}
function iP(n) {
  const e = n.options.emphasis || "*";
  if (e !== "*" && e !== "_")
    throw new Error(
      "Cannot serialize emphasis with `" + e + "` for `options.emphasis`, expected `*`, or `_`"
    );
  return e;
}
pg.peek = rP;
function pg(n, e, t, i) {
  const r = iP(t), s = t.enter("emphasis"), o = t.createTracker(i);
  let l = o.move(r);
  return l += o.move(
    t.containerPhrasing(n, {
      before: l,
      after: r,
      ...o.current()
    })
  ), l += o.move(r), s(), l;
}
function rP(n, e, t) {
  return t.options.emphasis || "*";
}
function mg(n, e, t, i) {
  let r, s, o;
  typeof e == "function" && typeof t != "function" ? (s = void 0, o = e, r = t) : (s = e, o = t, r = i), ug(n, s, l, r);
  function l(a, h) {
    const u = h[h.length - 1], c = u ? u.children.indexOf(a) : void 0;
    return o(a, c, u);
  }
}
const sP = {};
function ou(n, e) {
  const t = sP, i = typeof t.includeImageAlt == "boolean" ? t.includeImageAlt : !0, r = typeof t.includeHtml == "boolean" ? t.includeHtml : !0;
  return Og(n, i, r);
}
function Og(n, e, t) {
  if (oP(n)) {
    if ("value" in n)
      return n.type === "html" && !t ? "" : n.value;
    if (e && "alt" in n && n.alt)
      return n.alt;
    if ("children" in n)
      return Af(n.children, e, t);
  }
  return Array.isArray(n) ? Af(n, e, t) : "";
}
function Af(n, e, t) {
  const i = [];
  let r = -1;
  for (; ++r < n.length; )
    i[r] = Og(n[r], e, t);
  return i.join("");
}
function oP(n) {
  return !!(n && typeof n == "object");
}
function lP(n, e) {
  let t = !1;
  return mg(n, function(i) {
    if ("value" in i && /\r?\n|\r/.test(i.value) || i.type === "break")
      return t = !0, eh;
  }), !!((!n.depth || n.depth < 3) && ou(n) && (e.options.setext || t));
}
function aP(n, e, t, i) {
  const r = Math.max(Math.min(6, n.depth || 1), 1), s = t.createTracker(i);
  if (lP(n, t)) {
    const u = t.enter("headingSetext"), c = t.enter("phrasing"), f = t.containerPhrasing(n, {
      ...s.current(),
      before: `
`,
      after: `
`
    });
    return c(), u(), f + `
` + (r === 1 ? "=" : "-").repeat(
      // The whole size…
      f.length - // Minus the position of the character after the last EOL (or
      // 0 if there is none)…
      (Math.max(f.lastIndexOf("\r"), f.lastIndexOf(`
`)) + 1)
    );
  }
  const o = "#".repeat(r), l = t.enter("headingAtx"), a = t.enter("phrasing");
  s.move(o + " ");
  let h = t.containerPhrasing(n, {
    before: "# ",
    after: `
`,
    ...s.current()
  });
  return /^[\t ]/.test(h) && (h = "&#x" + h.charCodeAt(0).toString(16).toUpperCase() + ";" + h.slice(1)), h = h ? o + " " + h : o, t.options.closeAtx && (h += " " + o), a(), l(), h;
}
gg.peek = hP;
function gg(n) {
  return n.value || "";
}
function hP() {
  return "<";
}
bg.peek = uP;
function bg(n, e, t, i) {
  const r = su(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.enter("image");
  let l = t.enter("label");
  const a = t.createTracker(i);
  let h = a.move("![");
  return h += a.move(
    t.safe(n.alt, { before: h, after: "]", ...a.current() })
  ), h += a.move("]("), l(), // If there’s no url but there is a title…
  !n.url && n.title || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (l = t.enter("destinationLiteral"), h += a.move("<"), h += a.move(
    t.safe(n.url, { before: h, after: ">", ...a.current() })
  ), h += a.move(">")) : (l = t.enter("destinationRaw"), h += a.move(
    t.safe(n.url, {
      before: h,
      after: n.title ? " " : ")",
      ...a.current()
    })
  )), l(), n.title && (l = t.enter(`title${s}`), h += a.move(" " + r), h += a.move(
    t.safe(n.title, {
      before: h,
      after: r,
      ...a.current()
    })
  ), h += a.move(r), l()), h += a.move(")"), o(), h;
}
function uP() {
  return "!";
}
yg.peek = cP;
function yg(n, e, t, i) {
  const r = n.referenceType, s = t.enter("imageReference");
  let o = t.enter("label");
  const l = t.createTracker(i);
  let a = l.move("![");
  const h = t.safe(n.alt, {
    before: a,
    after: "]",
    ...l.current()
  });
  a += l.move(h + "]["), o();
  const u = t.stack;
  t.stack = [], o = t.enter("reference");
  const c = t.safe(t.associationId(n), {
    before: a,
    after: "]",
    ...l.current()
  });
  return o(), t.stack = u, s(), r === "full" || !h || h !== c ? a += l.move(c + "]") : r === "shortcut" ? a = a.slice(0, -1) : a += l.move("]"), a;
}
function cP() {
  return "!";
}
kg.peek = fP;
function kg(n, e, t) {
  let i = n.value || "", r = "`", s = -1;
  for (; new RegExp("(^|[^`])" + r + "([^`]|$)").test(i); )
    r += "`";
  for (/[^ \r\n]/.test(i) && (/^[ \r\n]/.test(i) && /[ \r\n]$/.test(i) || /^`|`$/.test(i)) && (i = " " + i + " "); ++s < t.unsafe.length; ) {
    const o = t.unsafe[s], l = t.compilePattern(o);
    let a;
    if (o.atBreak)
      for (; a = l.exec(i); ) {
        let h = a.index;
        i.charCodeAt(h) === 10 && i.charCodeAt(h - 1) === 13 && h--, i = i.slice(0, h) + " " + i.slice(a.index + 1);
      }
  }
  return r + i + r;
}
function fP() {
  return "`";
}
function xg(n, e) {
  const t = ou(n);
  return !!(!e.options.resourceLink && // If there’s a url…
  n.url && // And there’s a no title…
  !n.title && // And the content of `node` is a single text node…
  n.children && n.children.length === 1 && n.children[0].type === "text" && // And if the url is the same as the content…
  (t === n.url || "mailto:" + t === n.url) && // And that starts w/ a protocol…
  /^[a-z][a-z+.-]+:/i.test(n.url) && // And that doesn’t contain ASCII control codes (character escapes and
  // references don’t work), space, or angle brackets…
  !/[\0- <>\u007F]/.test(n.url));
}
wg.peek = dP;
function wg(n, e, t, i) {
  const r = su(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.createTracker(i);
  let l, a;
  if (xg(n, t)) {
    const u = t.stack;
    t.stack = [], l = t.enter("autolink");
    let c = o.move("<");
    return c += o.move(
      t.containerPhrasing(n, {
        before: c,
        after: ">",
        ...o.current()
      })
    ), c += o.move(">"), l(), t.stack = u, c;
  }
  l = t.enter("link"), a = t.enter("label");
  let h = o.move("[");
  return h += o.move(
    t.containerPhrasing(n, {
      before: h,
      after: "](",
      ...o.current()
    })
  ), h += o.move("]("), a(), // If there’s no url but there is a title…
  !n.url && n.title || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (a = t.enter("destinationLiteral"), h += o.move("<"), h += o.move(
    t.safe(n.url, { before: h, after: ">", ...o.current() })
  ), h += o.move(">")) : (a = t.enter("destinationRaw"), h += o.move(
    t.safe(n.url, {
      before: h,
      after: n.title ? " " : ")",
      ...o.current()
    })
  )), a(), n.title && (a = t.enter(`title${s}`), h += o.move(" " + r), h += o.move(
    t.safe(n.title, {
      before: h,
      after: r,
      ...o.current()
    })
  ), h += o.move(r), a()), h += o.move(")"), l(), h;
}
function dP(n, e, t) {
  return xg(n, t) ? "<" : "[";
}
Sg.peek = pP;
function Sg(n, e, t, i) {
  const r = n.referenceType, s = t.enter("linkReference");
  let o = t.enter("label");
  const l = t.createTracker(i);
  let a = l.move("[");
  const h = t.containerPhrasing(n, {
    before: a,
    after: "]",
    ...l.current()
  });
  a += l.move(h + "]["), o();
  const u = t.stack;
  t.stack = [], o = t.enter("reference");
  const c = t.safe(t.associationId(n), {
    before: a,
    after: "]",
    ...l.current()
  });
  return o(), t.stack = u, s(), r === "full" || !h || h !== c ? a += l.move(c + "]") : r === "shortcut" ? a = a.slice(0, -1) : a += l.move("]"), a;
}
function pP() {
  return "[";
}
function lu(n) {
  const e = n.options.bullet || "*";
  if (e !== "*" && e !== "+" && e !== "-")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.bullet`, expected `*`, `+`, or `-`"
    );
  return e;
}
function mP(n) {
  const e = lu(n), t = n.options.bulletOther;
  if (!t)
    return e === "*" ? "-" : "*";
  if (t !== "*" && t !== "+" && t !== "-")
    throw new Error(
      "Cannot serialize items with `" + t + "` for `options.bulletOther`, expected `*`, `+`, or `-`"
    );
  if (t === e)
    throw new Error(
      "Expected `bullet` (`" + e + "`) and `bulletOther` (`" + t + "`) to be different"
    );
  return t;
}
function OP(n) {
  const e = n.options.bulletOrdered || ".";
  if (e !== "." && e !== ")")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.bulletOrdered`, expected `.` or `)`"
    );
  return e;
}
function vg(n) {
  const e = n.options.rule || "*";
  if (e !== "*" && e !== "-" && e !== "_")
    throw new Error(
      "Cannot serialize rules with `" + e + "` for `options.rule`, expected `*`, `-`, or `_`"
    );
  return e;
}
function gP(n, e, t, i) {
  const r = t.enter("list"), s = t.bulletCurrent;
  let o = n.ordered ? OP(t) : lu(t);
  const l = n.ordered ? o === "." ? ")" : "." : mP(t);
  let a = e && t.bulletLastUsed ? o === t.bulletLastUsed : !1;
  if (!n.ordered) {
    const u = n.children ? n.children[0] : void 0;
    if (
      // Bullet could be used as a thematic break marker:
      (o === "*" || o === "-") && // Empty first list item:
      u && (!u.children || !u.children[0]) && // Directly in two other list items:
      t.stack[t.stack.length - 1] === "list" && t.stack[t.stack.length - 2] === "listItem" && t.stack[t.stack.length - 3] === "list" && t.stack[t.stack.length - 4] === "listItem" && // That are each the first child.
      t.indexStack[t.indexStack.length - 1] === 0 && t.indexStack[t.indexStack.length - 2] === 0 && t.indexStack[t.indexStack.length - 3] === 0 && (a = !0), vg(t) === o && u
    ) {
      let c = -1;
      for (; ++c < n.children.length; ) {
        const f = n.children[c];
        if (f && f.type === "listItem" && f.children && f.children[0] && f.children[0].type === "thematicBreak") {
          a = !0;
          break;
        }
      }
    }
  }
  a && (o = l), t.bulletCurrent = o;
  const h = t.containerFlow(n, i);
  return t.bulletLastUsed = o, t.bulletCurrent = s, r(), h;
}
function bP(n) {
  const e = n.options.listItemIndent || "one";
  if (e !== "tab" && e !== "one" && e !== "mixed")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.listItemIndent`, expected `tab`, `one`, or `mixed`"
    );
  return e;
}
function yP(n, e, t, i) {
  const r = bP(t);
  let s = t.bulletCurrent || lu(t);
  e && e.type === "list" && e.ordered && (s = (typeof e.start == "number" && e.start > -1 ? e.start : 1) + (t.options.incrementListMarker === !1 ? 0 : e.children.indexOf(n)) + s);
  let o = s.length + 1;
  (r === "tab" || r === "mixed" && (e && e.type === "list" && e.spread || n.spread)) && (o = Math.ceil(o / 4) * 4);
  const l = t.createTracker(i);
  l.move(s + " ".repeat(o - s.length)), l.shift(o);
  const a = t.enter("listItem"), h = t.indentLines(
    t.containerFlow(n, l.current()),
    u
  );
  return a(), h;
  function u(c, f, d) {
    return f ? (d ? "" : " ".repeat(o)) + c : (d ? s : s + " ".repeat(o - s.length)) + c;
  }
}
function kP(n, e, t, i) {
  const r = t.enter("paragraph"), s = t.enter("phrasing"), o = t.containerPhrasing(n, i);
  return s(), r(), o;
}
const xP = (
  /** @type {(node?: unknown) => node is Exclude<PhrasingContent, Html>} */
  Go([
    "break",
    "delete",
    "emphasis",
    // To do: next major: removed since footnotes were added to GFM.
    "footnote",
    "footnoteReference",
    "image",
    "imageReference",
    "inlineCode",
    // Enabled by `mdast-util-math`:
    "inlineMath",
    "link",
    "linkReference",
    // Enabled by `mdast-util-mdx`:
    "mdxJsxTextElement",
    // Enabled by `mdast-util-mdx`:
    "mdxTextExpression",
    "strong",
    "text",
    // Enabled by `mdast-util-directive`:
    "textDirective"
  ])
);
function wP(n, e, t, i) {
  return (n.children.some(function(o) {
    return xP(o);
  }) ? t.containerPhrasing : t.containerFlow).call(t, n, i);
}
function SP(n) {
  const e = n.options.strong || "*";
  if (e !== "*" && e !== "_")
    throw new Error(
      "Cannot serialize strong with `" + e + "` for `options.strong`, expected `*`, or `_`"
    );
  return e;
}
Pg.peek = vP;
function Pg(n, e, t, i) {
  const r = SP(t), s = t.enter("strong"), o = t.createTracker(i);
  let l = o.move(r + r);
  return l += o.move(
    t.containerPhrasing(n, {
      before: l,
      after: r,
      ...o.current()
    })
  ), l += o.move(r + r), s(), l;
}
function vP(n, e, t) {
  return t.options.strong || "*";
}
function PP(n, e, t, i) {
  return t.safe(n.value, i);
}
function QP(n) {
  const e = n.options.ruleRepetition || 3;
  if (e < 3)
    throw new Error(
      "Cannot serialize rules with repetition `" + e + "` for `options.ruleRepetition`, expected `3` or more"
    );
  return e;
}
function $P(n, e, t) {
  const i = (vg(t) + (t.options.ruleSpaces ? " " : "")).repeat(QP(t));
  return t.options.ruleSpaces ? i.slice(0, -1) : i;
}
const Qg = {
  blockquote: Uv,
  break: Tf,
  code: eP,
  definition: nP,
  emphasis: pg,
  hardBreak: Tf,
  heading: aP,
  html: gg,
  image: bg,
  imageReference: yg,
  inlineCode: kg,
  link: wg,
  linkReference: Sg,
  list: gP,
  listItem: yP,
  paragraph: kP,
  root: wP,
  strong: Pg,
  text: PP,
  thematicBreak: $P
}, Rf = document.createElement("i");
function au(n) {
  const e = "&" + n + ";";
  Rf.innerHTML = e;
  const t = Rf.textContent;
  return t.charCodeAt(t.length - 1) === 59 && n !== "semi" || t === e ? !1 : t;
}
function $g(n, e) {
  const t = Number.parseInt(n, e);
  return (
    // C0 except for HT, LF, FF, CR, space.
    t < 9 || t === 11 || t > 13 && t < 32 || // Control character (DEL) of C0, and C1 controls.
    t > 126 && t < 160 || // Lone high surrogates and low surrogates.
    t > 55295 && t < 57344 || // Noncharacters.
    t > 64975 && t < 65008 || /* eslint-disable no-bitwise */
    (t & 65535) === 65535 || (t & 65535) === 65534 || /* eslint-enable no-bitwise */
    // Out of range
    t > 1114111 ? "�" : String.fromCodePoint(t)
  );
}
const CP = /\\([!-/:-@[-`{-~])|&(#(?:\d{1,7}|x[\da-f]{1,6})|[\da-z]{1,31});/gi;
function TP(n) {
  return n.replace(CP, AP);
}
function AP(n, e, t) {
  if (e)
    return e;
  if (t.charCodeAt(0) === 35) {
    const r = t.charCodeAt(1), s = r === 120 || r === 88;
    return $g(t.slice(s ? 2 : 1), s ? 16 : 10);
  }
  return au(t) || n;
}
function RP() {
  return {
    enter: {
      table: ZP,
      tableData: Zf,
      tableHeader: Zf,
      tableRow: EP
    },
    exit: {
      codeText: zP,
      table: MP,
      tableData: Al,
      tableHeader: Al,
      tableRow: Al
    }
  };
}
function ZP(n) {
  const e = n._align;
  this.enter(
    {
      type: "table",
      align: e.map(function(t) {
        return t === "none" ? null : t;
      }),
      children: []
    },
    n
  ), this.data.inTable = !0;
}
function MP(n) {
  this.exit(n), this.data.inTable = void 0;
}
function EP(n) {
  this.enter({ type: "tableRow", children: [] }, n);
}
function Al(n) {
  this.exit(n);
}
function Zf(n) {
  this.enter({ type: "tableCell", children: [] }, n);
}
function zP(n) {
  let e = this.resume();
  this.data.inTable && (e = e.replace(/\\([\\|])/g, XP));
  const t = this.stack[this.stack.length - 1];
  t.type, t.value = e, this.exit(n);
}
function XP(n, e) {
  return e === "|" ? e : n;
}
function DP(n) {
  const e = n || {}, t = e.tableCellPadding, i = e.tablePipeAlign, r = e.stringLength, s = t ? " " : "|";
  return {
    unsafe: [
      { character: "\r", inConstruct: "tableCell" },
      { character: `
`, inConstruct: "tableCell" },
      // A pipe, when followed by a tab or space (padding), or a dash or colon
      // (unpadded delimiter row), could result in a table.
      { atBreak: !0, character: "|", after: "[	 :-]" },
      // A pipe in a cell must be encoded.
      { character: "|", inConstruct: "tableCell" },
      // A colon must be followed by a dash, in which case it could start a
      // delimiter row.
      { atBreak: !0, character: ":", after: "-" },
      // A delimiter row can also start with a dash, when followed by more
      // dashes, a colon, or a pipe.
      // This is a stricter version than the built in check for lists, thematic
      // breaks, and setex heading underlines though:
      // <https://github.com/syntax-tree/mdast-util-to-markdown/blob/51a2038/lib/unsafe.js#L57>
      { atBreak: !0, character: "-", after: "[:|-]" }
    ],
    handlers: {
      inlineCode: f,
      table: o,
      tableCell: a,
      tableRow: l
    }
  };
  function o(d, p, m, O) {
    return h(u(d, m, O), d.align);
  }
  function l(d, p, m, O) {
    const g = c(d, m, O), b = h([g]);
    return b.slice(0, b.indexOf(`
`));
  }
  function a(d, p, m, O) {
    const g = m.enter("tableCell"), b = m.enter("phrasing"), S = m.containerPhrasing(d, {
      ...O,
      before: s,
      after: s
    });
    return b(), g(), S;
  }
  function h(d, p) {
    return Vv(d, {
      align: p,
      // @ts-expect-error: `markdown-table` types should support `null`.
      alignDelimiters: i,
      // @ts-expect-error: `markdown-table` types should support `null`.
      padding: t,
      // @ts-expect-error: `markdown-table` types should support `null`.
      stringLength: r
    });
  }
  function u(d, p, m) {
    const O = d.children;
    let g = -1;
    const b = [], S = p.enter("table");
    for (; ++g < O.length; )
      b[g] = c(O[g], p, m);
    return S(), b;
  }
  function c(d, p, m) {
    const O = d.children;
    let g = -1;
    const b = [], S = p.enter("tableRow");
    for (; ++g < O.length; )
      b[g] = a(O[g], d, p, m);
    return S(), b;
  }
  function f(d, p, m) {
    let O = Qg.inlineCode(d, p, m);
    return m.stack.includes("tableCell") && (O = O.replace(/\|/g, "\\$&")), O;
  }
}
function LP() {
  return {
    exit: {
      taskListCheckValueChecked: Mf,
      taskListCheckValueUnchecked: Mf,
      paragraph: _P
    }
  };
}
function IP() {
  return {
    unsafe: [{ atBreak: !0, character: "-", after: "[:|-]" }],
    handlers: { listItem: qP }
  };
}
function Mf(n) {
  const e = this.stack[this.stack.length - 2];
  e.type, e.checked = n.type === "taskListCheckValueChecked";
}
function _P(n) {
  const e = this.stack[this.stack.length - 2];
  if (e && e.type === "listItem" && typeof e.checked == "boolean") {
    const t = this.stack[this.stack.length - 1];
    t.type;
    const i = t.children[0];
    if (i && i.type === "text") {
      const r = e.children;
      let s = -1, o;
      for (; ++s < r.length; ) {
        const l = r[s];
        if (l.type === "paragraph") {
          o = l;
          break;
        }
      }
      o === t && (i.value = i.value.slice(1), i.value.length === 0 ? t.children.shift() : t.position && i.position && typeof i.position.start.offset == "number" && (i.position.start.column++, i.position.start.offset++, t.position.start = Object.assign({}, i.position.start)));
    }
  }
  this.exit(n);
}
function qP(n, e, t, i) {
  const r = n.children[0], s = typeof n.checked == "boolean" && r && r.type === "paragraph", o = "[" + (n.checked ? "x" : " ") + "] ", l = t.createTracker(i);
  s && l.move(o);
  let a = Qg.listItem(n, e, t, {
    ...i,
    ...l.current()
  });
  return s && (a = a.replace(/^(?:[*+-]|\d+\.)([\r\n]| {1,3})/, h)), a;
  function h(u) {
    return u + o;
  }
}
function WP() {
  return [
    dv(),
    Pv(),
    Iv(),
    RP(),
    LP()
  ];
}
function BP(n) {
  return {
    extensions: [
      pv(),
      Qv(),
      _v(),
      DP(n),
      IP()
    ]
  };
}
function St(n, e, t, i) {
  const r = n.length;
  let s = 0, o;
  if (e < 0 ? e = -e > r ? 0 : r + e : e = e > r ? r : e, t = t > 0 ? t : 0, i.length < 1e4)
    o = Array.from(i), o.unshift(e, t), n.splice(...o);
  else
    for (t && n.splice(e, t); s < i.length; )
      o = i.slice(s, s + 1e4), o.unshift(e, 0), n.splice(...o), s += 1e4, e += 1e4;
}
function gt(n, e) {
  return n.length > 0 ? (St(n, n.length, 0, e), n) : e;
}
const Ef = {}.hasOwnProperty;
function Cg(n) {
  const e = {};
  let t = -1;
  for (; ++t < n.length; )
    VP(e, n[t]);
  return e;
}
function VP(n, e) {
  let t;
  for (t in e) {
    const r = (Ef.call(n, t) ? n[t] : void 0) || (n[t] = {}), s = e[t];
    let o;
    if (s)
      for (o in s) {
        Ef.call(r, o) || (r[o] = []);
        const l = s[o];
        YP(
          // @ts-expect-error Looks like a list.
          r[o],
          Array.isArray(l) ? l : l ? [l] : []
        );
      }
  }
}
function YP(n, e) {
  let t = -1;
  const i = [];
  for (; ++t < e.length; )
    (e[t].add === "after" ? n : i).push(e[t]);
  St(n, 0, 0, i);
}
const jP = {
  tokenize: KP,
  partial: !0
}, Tg = {
  tokenize: JP,
  partial: !0
}, Ag = {
  tokenize: eQ,
  partial: !0
}, Rg = {
  tokenize: tQ,
  partial: !0
}, NP = {
  tokenize: nQ,
  partial: !0
}, Zg = {
  tokenize: GP,
  previous: Eg
}, Mg = {
  tokenize: HP,
  previous: zg
}, fn = {
  tokenize: FP,
  previous: Xg
}, en = {};
function UP() {
  return {
    text: en
  };
}
let Ln = 48;
for (; Ln < 123; )
  en[Ln] = fn, Ln++, Ln === 58 ? Ln = 65 : Ln === 91 && (Ln = 97);
en[43] = fn;
en[45] = fn;
en[46] = fn;
en[95] = fn;
en[72] = [fn, Mg];
en[104] = [fn, Mg];
en[87] = [fn, Zg];
en[119] = [fn, Zg];
function FP(n, e, t) {
  const i = this;
  let r, s;
  return o;
  function o(c) {
    return !th(c) || !Xg.call(i, i.previous) || hu(i.events) ? t(c) : (n.enter("literalAutolink"), n.enter("literalAutolinkEmail"), l(c));
  }
  function l(c) {
    return th(c) ? (n.consume(c), l) : c === 64 ? (n.consume(c), a) : t(c);
  }
  function a(c) {
    return c === 46 ? n.check(
      NP,
      u,
      h
    )(c) : c === 45 || c === 95 || je(c) ? (s = !0, n.consume(c), a) : u(c);
  }
  function h(c) {
    return n.consume(c), r = !0, a;
  }
  function u(c) {
    return s && r && He(i.previous) ? (n.exit("literalAutolinkEmail"), n.exit("literalAutolink"), e(c)) : t(c);
  }
}
function GP(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return o !== 87 && o !== 119 || !Eg.call(i, i.previous) || hu(i.events) ? t(o) : (n.enter("literalAutolink"), n.enter("literalAutolinkWww"), n.check(
      jP,
      n.attempt(Tg, n.attempt(Ag, s), t),
      t
    )(o));
  }
  function s(o) {
    return n.exit("literalAutolinkWww"), n.exit("literalAutolink"), e(o);
  }
}
function HP(n, e, t) {
  const i = this;
  let r = "", s = !1;
  return o;
  function o(c) {
    return (c === 72 || c === 104) && zg.call(i, i.previous) && !hu(i.events) ? (n.enter("literalAutolink"), n.enter("literalAutolinkHttp"), r += String.fromCodePoint(c), n.consume(c), l) : t(c);
  }
  function l(c) {
    if (He(c) && r.length < 5)
      return r += String.fromCodePoint(c), n.consume(c), l;
    if (c === 58) {
      const f = r.toLowerCase();
      if (f === "http" || f === "https")
        return n.consume(c), a;
    }
    return t(c);
  }
  function a(c) {
    return c === 47 ? (n.consume(c), s ? h : (s = !0, a)) : t(c);
  }
  function h(c) {
    return c === null || wo(c) || me(c) || Jn(c) || Fo(c) ? t(c) : n.attempt(Tg, n.attempt(Ag, u), t)(c);
  }
  function u(c) {
    return n.exit("literalAutolinkHttp"), n.exit("literalAutolink"), e(c);
  }
}
function KP(n, e, t) {
  let i = 0;
  return r;
  function r(o) {
    return (o === 87 || o === 119) && i < 3 ? (i++, n.consume(o), r) : o === 46 && i === 3 ? (n.consume(o), s) : t(o);
  }
  function s(o) {
    return o === null ? t(o) : e(o);
  }
}
function JP(n, e, t) {
  let i, r, s;
  return o;
  function o(h) {
    return h === 46 || h === 95 ? n.check(Rg, a, l)(h) : h === null || me(h) || Jn(h) || h !== 45 && Fo(h) ? a(h) : (s = !0, n.consume(h), o);
  }
  function l(h) {
    return h === 95 ? i = !0 : (r = i, i = void 0), n.consume(h), o;
  }
  function a(h) {
    return r || i || !s ? t(h) : e(h);
  }
}
function eQ(n, e) {
  let t = 0, i = 0;
  return r;
  function r(o) {
    return o === 40 ? (t++, n.consume(o), r) : o === 41 && i < t ? s(o) : o === 33 || o === 34 || o === 38 || o === 39 || o === 41 || o === 42 || o === 44 || o === 46 || o === 58 || o === 59 || o === 60 || o === 63 || o === 93 || o === 95 || o === 126 ? n.check(Rg, e, s)(o) : o === null || me(o) || Jn(o) ? e(o) : (n.consume(o), r);
  }
  function s(o) {
    return o === 41 && i++, n.consume(o), r;
  }
}
function tQ(n, e, t) {
  return i;
  function i(l) {
    return l === 33 || l === 34 || l === 39 || l === 41 || l === 42 || l === 44 || l === 46 || l === 58 || l === 59 || l === 63 || l === 95 || l === 126 ? (n.consume(l), i) : l === 38 ? (n.consume(l), s) : l === 93 ? (n.consume(l), r) : (
      // `<` is an end.
      l === 60 || // So is whitespace.
      l === null || me(l) || Jn(l) ? e(l) : t(l)
    );
  }
  function r(l) {
    return l === null || l === 40 || l === 91 || me(l) || Jn(l) ? e(l) : i(l);
  }
  function s(l) {
    return He(l) ? o(l) : t(l);
  }
  function o(l) {
    return l === 59 ? (n.consume(l), i) : He(l) ? (n.consume(l), o) : t(l);
  }
}
function nQ(n, e, t) {
  return i;
  function i(s) {
    return n.consume(s), r;
  }
  function r(s) {
    return je(s) ? t(s) : e(s);
  }
}
function Eg(n) {
  return n === null || n === 40 || n === 42 || n === 95 || n === 91 || n === 93 || n === 126 || me(n);
}
function zg(n) {
  return !He(n);
}
function Xg(n) {
  return !(n === 47 || th(n));
}
function th(n) {
  return n === 43 || n === 45 || n === 46 || n === 95 || je(n);
}
function hu(n) {
  let e = n.length, t = !1;
  for (; e--; ) {
    const i = n[e][1];
    if ((i.type === "labelLink" || i.type === "labelImage") && !i._balanced) {
      t = !0;
      break;
    }
    if (i._gfmAutolinkLiteralWalkedInto) {
      t = !1;
      break;
    }
  }
  return n.length > 0 && !t && (n[n.length - 1][1]._gfmAutolinkLiteralWalkedInto = !0), t;
}
function Wi(n) {
  const e = [];
  let t = -1, i = 0, r = 0;
  for (; ++t < n.length; ) {
    const s = n.charCodeAt(t);
    let o = "";
    if (s === 37 && je(n.charCodeAt(t + 1)) && je(n.charCodeAt(t + 2)))
      r = 2;
    else if (s < 128)
      /[!#$&-;=?-Z_a-z~]/.test(String.fromCharCode(s)) || (o = String.fromCharCode(s));
    else if (s > 55295 && s < 57344) {
      const l = n.charCodeAt(t + 1);
      s < 56320 && l > 56319 && l < 57344 ? (o = String.fromCharCode(s, l), r = 1) : o = "�";
    } else
      o = String.fromCharCode(s);
    o && (e.push(n.slice(i, t), encodeURIComponent(o)), i = t + r + 1, o = ""), r && (t += r, r = 0);
  }
  return e.join("") + n.slice(i);
}
function So(n) {
  if (n === null || me(n) || Jn(n))
    return 1;
  if (Fo(n))
    return 2;
}
function Ko(n, e, t) {
  const i = [];
  let r = -1;
  for (; ++r < n.length; ) {
    const s = n[r].resolveAll;
    s && !i.includes(s) && (e = s(e, t), i.push(s));
  }
  return e;
}
const nh = {
  name: "attention",
  tokenize: rQ,
  resolveAll: iQ
};
function iQ(n, e) {
  let t = -1, i, r, s, o, l, a, h, u;
  for (; ++t < n.length; )
    if (n[t][0] === "enter" && n[t][1].type === "attentionSequence" && n[t][1]._close) {
      for (i = t; i--; )
        if (n[i][0] === "exit" && n[i][1].type === "attentionSequence" && n[i][1]._open && // If the markers are the same:
        e.sliceSerialize(n[i][1]).charCodeAt(0) === e.sliceSerialize(n[t][1]).charCodeAt(0)) {
          if ((n[i][1]._close || n[t][1]._open) && (n[t][1].end.offset - n[t][1].start.offset) % 3 && !((n[i][1].end.offset - n[i][1].start.offset + n[t][1].end.offset - n[t][1].start.offset) % 3))
            continue;
          a = n[i][1].end.offset - n[i][1].start.offset > 1 && n[t][1].end.offset - n[t][1].start.offset > 1 ? 2 : 1;
          const c = Object.assign({}, n[i][1].end), f = Object.assign({}, n[t][1].start);
          zf(c, -a), zf(f, a), o = {
            type: a > 1 ? "strongSequence" : "emphasisSequence",
            start: c,
            end: Object.assign({}, n[i][1].end)
          }, l = {
            type: a > 1 ? "strongSequence" : "emphasisSequence",
            start: Object.assign({}, n[t][1].start),
            end: f
          }, s = {
            type: a > 1 ? "strongText" : "emphasisText",
            start: Object.assign({}, n[i][1].end),
            end: Object.assign({}, n[t][1].start)
          }, r = {
            type: a > 1 ? "strong" : "emphasis",
            start: Object.assign({}, o.start),
            end: Object.assign({}, l.end)
          }, n[i][1].end = Object.assign({}, o.start), n[t][1].start = Object.assign({}, l.end), h = [], n[i][1].end.offset - n[i][1].start.offset && (h = gt(h, [["enter", n[i][1], e], ["exit", n[i][1], e]])), h = gt(h, [["enter", r, e], ["enter", o, e], ["exit", o, e], ["enter", s, e]]), h = gt(h, Ko(e.parser.constructs.insideSpan.null, n.slice(i + 1, t), e)), h = gt(h, [["exit", s, e], ["enter", l, e], ["exit", l, e], ["exit", r, e]]), n[t][1].end.offset - n[t][1].start.offset ? (u = 2, h = gt(h, [["enter", n[t][1], e], ["exit", n[t][1], e]])) : u = 0, St(n, i - 1, t - i + 3, h), t = i + h.length - u - 2;
          break;
        }
    }
  for (t = -1; ++t < n.length; )
    n[t][1].type === "attentionSequence" && (n[t][1].type = "data");
  return n;
}
function rQ(n, e) {
  const t = this.parser.constructs.attentionMarkers.null, i = this.previous, r = So(i);
  let s;
  return o;
  function o(a) {
    return s = a, n.enter("attentionSequence"), l(a);
  }
  function l(a) {
    if (a === s)
      return n.consume(a), l;
    const h = n.exit("attentionSequence"), u = So(a), c = !u || u === 2 && r || t.includes(a), f = !r || r === 2 && u || t.includes(i);
    return h._open = !!(s === 42 ? c : c && (r || !f)), h._close = !!(s === 42 ? f : f && (u || !c)), e(a);
  }
}
function zf(n, e) {
  n.column += e, n.offset += e, n._bufferIndex += e;
}
const sQ = {
  name: "autolink",
  tokenize: oQ
};
function oQ(n, e, t) {
  let i = 0;
  return r;
  function r(d) {
    return n.enter("autolink"), n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.enter("autolinkProtocol"), s;
  }
  function s(d) {
    return He(d) ? (n.consume(d), o) : d === 64 ? t(d) : h(d);
  }
  function o(d) {
    return d === 43 || d === 45 || d === 46 || je(d) ? (i = 1, l(d)) : h(d);
  }
  function l(d) {
    return d === 58 ? (n.consume(d), i = 0, a) : (d === 43 || d === 45 || d === 46 || je(d)) && i++ < 32 ? (n.consume(d), l) : (i = 0, h(d));
  }
  function a(d) {
    return d === 62 ? (n.exit("autolinkProtocol"), n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.exit("autolink"), e) : d === null || d === 32 || d === 60 || wo(d) ? t(d) : (n.consume(d), a);
  }
  function h(d) {
    return d === 64 ? (n.consume(d), u) : H2(d) ? (n.consume(d), h) : t(d);
  }
  function u(d) {
    return je(d) ? c(d) : t(d);
  }
  function c(d) {
    return d === 46 ? (n.consume(d), i = 0, u) : d === 62 ? (n.exit("autolinkProtocol").type = "autolinkEmail", n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.exit("autolink"), e) : f(d);
  }
  function f(d) {
    if ((d === 45 || je(d)) && i++ < 63) {
      const p = d === 45 ? f : c;
      return n.consume(d), p;
    }
    return t(d);
  }
}
function re(n, e, t, i) {
  const r = i ? i - 1 : Number.POSITIVE_INFINITY;
  let s = 0;
  return o;
  function o(a) {
    return te(a) ? (n.enter(t), l(a)) : e(a);
  }
  function l(a) {
    return te(a) && s++ < r ? (n.consume(a), l) : (n.exit(t), e(a));
  }
}
const Jr = {
  tokenize: lQ,
  partial: !0
};
function lQ(n, e, t) {
  return i;
  function i(s) {
    return te(s) ? re(n, r, "linePrefix")(s) : r(s);
  }
  function r(s) {
    return s === null || N(s) ? e(s) : t(s);
  }
}
const Dg = {
  name: "blockQuote",
  tokenize: aQ,
  continuation: {
    tokenize: hQ
  },
  exit: uQ
};
function aQ(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    if (o === 62) {
      const l = i.containerState;
      return l.open || (n.enter("blockQuote", {
        _container: !0
      }), l.open = !0), n.enter("blockQuotePrefix"), n.enter("blockQuoteMarker"), n.consume(o), n.exit("blockQuoteMarker"), s;
    }
    return t(o);
  }
  function s(o) {
    return te(o) ? (n.enter("blockQuotePrefixWhitespace"), n.consume(o), n.exit("blockQuotePrefixWhitespace"), n.exit("blockQuotePrefix"), e) : (n.exit("blockQuotePrefix"), e(o));
  }
}
function hQ(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return te(o) ? re(n, s, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(o) : s(o);
  }
  function s(o) {
    return n.attempt(Dg, e, t)(o);
  }
}
function uQ(n) {
  n.exit("blockQuote");
}
const Lg = {
  name: "characterEscape",
  tokenize: cQ
};
function cQ(n, e, t) {
  return i;
  function i(s) {
    return n.enter("characterEscape"), n.enter("escapeMarker"), n.consume(s), n.exit("escapeMarker"), r;
  }
  function r(s) {
    return J2(s) ? (n.enter("characterEscapeValue"), n.consume(s), n.exit("characterEscapeValue"), n.exit("characterEscape"), e) : t(s);
  }
}
const Ig = {
  name: "characterReference",
  tokenize: fQ
};
function fQ(n, e, t) {
  const i = this;
  let r = 0, s, o;
  return l;
  function l(c) {
    return n.enter("characterReference"), n.enter("characterReferenceMarker"), n.consume(c), n.exit("characterReferenceMarker"), a;
  }
  function a(c) {
    return c === 35 ? (n.enter("characterReferenceMarkerNumeric"), n.consume(c), n.exit("characterReferenceMarkerNumeric"), h) : (n.enter("characterReferenceValue"), s = 31, o = je, u(c));
  }
  function h(c) {
    return c === 88 || c === 120 ? (n.enter("characterReferenceMarkerHexadecimal"), n.consume(c), n.exit("characterReferenceMarkerHexadecimal"), n.enter("characterReferenceValue"), s = 6, o = K2, u) : (n.enter("characterReferenceValue"), s = 7, o = Ja, u(c));
  }
  function u(c) {
    if (c === 59 && r) {
      const f = n.exit("characterReferenceValue");
      return o === je && !au(i.sliceSerialize(f)) ? t(c) : (n.enter("characterReferenceMarker"), n.consume(c), n.exit("characterReferenceMarker"), n.exit("characterReference"), e);
    }
    return o(c) && r++ < s ? (n.consume(c), u) : t(c);
  }
}
const Xf = {
  tokenize: pQ,
  partial: !0
}, Df = {
  name: "codeFenced",
  tokenize: dQ,
  concrete: !0
};
function dQ(n, e, t) {
  const i = this, r = {
    tokenize: P,
    partial: !0
  };
  let s = 0, o = 0, l;
  return a;
  function a(w) {
    return h(w);
  }
  function h(w) {
    const C = i.events[i.events.length - 1];
    return s = C && C[1].type === "linePrefix" ? C[2].sliceSerialize(C[1], !0).length : 0, l = w, n.enter("codeFenced"), n.enter("codeFencedFence"), n.enter("codeFencedFenceSequence"), u(w);
  }
  function u(w) {
    return w === l ? (o++, n.consume(w), u) : o < 3 ? t(w) : (n.exit("codeFencedFenceSequence"), te(w) ? re(n, c, "whitespace")(w) : c(w));
  }
  function c(w) {
    return w === null || N(w) ? (n.exit("codeFencedFence"), i.interrupt ? e(w) : n.check(Xf, m, Q)(w)) : (n.enter("codeFencedFenceInfo"), n.enter("chunkString", {
      contentType: "string"
    }), f(w));
  }
  function f(w) {
    return w === null || N(w) ? (n.exit("chunkString"), n.exit("codeFencedFenceInfo"), c(w)) : te(w) ? (n.exit("chunkString"), n.exit("codeFencedFenceInfo"), re(n, d, "whitespace")(w)) : w === 96 && w === l ? t(w) : (n.consume(w), f);
  }
  function d(w) {
    return w === null || N(w) ? c(w) : (n.enter("codeFencedFenceMeta"), n.enter("chunkString", {
      contentType: "string"
    }), p(w));
  }
  function p(w) {
    return w === null || N(w) ? (n.exit("chunkString"), n.exit("codeFencedFenceMeta"), c(w)) : w === 96 && w === l ? t(w) : (n.consume(w), p);
  }
  function m(w) {
    return n.attempt(r, Q, O)(w);
  }
  function O(w) {
    return n.enter("lineEnding"), n.consume(w), n.exit("lineEnding"), g;
  }
  function g(w) {
    return s > 0 && te(w) ? re(n, b, "linePrefix", s + 1)(w) : b(w);
  }
  function b(w) {
    return w === null || N(w) ? n.check(Xf, m, Q)(w) : (n.enter("codeFlowValue"), S(w));
  }
  function S(w) {
    return w === null || N(w) ? (n.exit("codeFlowValue"), b(w)) : (n.consume(w), S);
  }
  function Q(w) {
    return n.exit("codeFenced"), e(w);
  }
  function P(w, C, L) {
    let q = 0;
    return v;
    function v(_) {
      return w.enter("lineEnding"), w.consume(_), w.exit("lineEnding"), R;
    }
    function R(_) {
      return w.enter("codeFencedFence"), te(_) ? re(w, A, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(_) : A(_);
    }
    function A(_) {
      return _ === l ? (w.enter("codeFencedFenceSequence"), E(_)) : L(_);
    }
    function E(_) {
      return _ === l ? (q++, w.consume(_), E) : q >= o ? (w.exit("codeFencedFenceSequence"), te(_) ? re(w, W, "whitespace")(_) : W(_)) : L(_);
    }
    function W(_) {
      return _ === null || N(_) ? (w.exit("codeFencedFence"), C(_)) : L(_);
    }
  }
}
function pQ(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return o === null ? t(o) : (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), s);
  }
  function s(o) {
    return i.parser.lazy[i.now().line] ? t(o) : e(o);
  }
}
const Rl = {
  name: "codeIndented",
  tokenize: OQ
}, mQ = {
  tokenize: gQ,
  partial: !0
};
function OQ(n, e, t) {
  const i = this;
  return r;
  function r(h) {
    return n.enter("codeIndented"), re(n, s, "linePrefix", 5)(h);
  }
  function s(h) {
    const u = i.events[i.events.length - 1];
    return u && u[1].type === "linePrefix" && u[2].sliceSerialize(u[1], !0).length >= 4 ? o(h) : t(h);
  }
  function o(h) {
    return h === null ? a(h) : N(h) ? n.attempt(mQ, o, a)(h) : (n.enter("codeFlowValue"), l(h));
  }
  function l(h) {
    return h === null || N(h) ? (n.exit("codeFlowValue"), o(h)) : (n.consume(h), l);
  }
  function a(h) {
    return n.exit("codeIndented"), e(h);
  }
}
function gQ(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return i.parser.lazy[i.now().line] ? t(o) : N(o) ? (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), r) : re(n, s, "linePrefix", 5)(o);
  }
  function s(o) {
    const l = i.events[i.events.length - 1];
    return l && l[1].type === "linePrefix" && l[2].sliceSerialize(l[1], !0).length >= 4 ? e(o) : N(o) ? r(o) : t(o);
  }
}
const bQ = {
  name: "codeText",
  tokenize: xQ,
  resolve: yQ,
  previous: kQ
};
function yQ(n) {
  let e = n.length - 4, t = 3, i, r;
  if ((n[t][1].type === "lineEnding" || n[t][1].type === "space") && (n[e][1].type === "lineEnding" || n[e][1].type === "space")) {
    for (i = t; ++i < e; )
      if (n[i][1].type === "codeTextData") {
        n[t][1].type = "codeTextPadding", n[e][1].type = "codeTextPadding", t += 2, e -= 2;
        break;
      }
  }
  for (i = t - 1, e++; ++i <= e; )
    r === void 0 ? i !== e && n[i][1].type !== "lineEnding" && (r = i) : (i === e || n[i][1].type === "lineEnding") && (n[r][1].type = "codeTextData", i !== r + 2 && (n[r][1].end = n[i - 1][1].end, n.splice(r + 2, i - r - 2), e -= i - r - 2, i = r + 2), r = void 0);
  return n;
}
function kQ(n) {
  return n !== 96 || this.events[this.events.length - 1][1].type === "characterEscape";
}
function xQ(n, e, t) {
  let i = 0, r, s;
  return o;
  function o(c) {
    return n.enter("codeText"), n.enter("codeTextSequence"), l(c);
  }
  function l(c) {
    return c === 96 ? (n.consume(c), i++, l) : (n.exit("codeTextSequence"), a(c));
  }
  function a(c) {
    return c === null ? t(c) : c === 32 ? (n.enter("space"), n.consume(c), n.exit("space"), a) : c === 96 ? (s = n.enter("codeTextSequence"), r = 0, u(c)) : N(c) ? (n.enter("lineEnding"), n.consume(c), n.exit("lineEnding"), a) : (n.enter("codeTextData"), h(c));
  }
  function h(c) {
    return c === null || c === 32 || c === 96 || N(c) ? (n.exit("codeTextData"), a(c)) : (n.consume(c), h);
  }
  function u(c) {
    return c === 96 ? (n.consume(c), r++, u) : r === i ? (n.exit("codeTextSequence"), n.exit("codeText"), e(c)) : (s.type = "codeTextData", h(c));
  }
}
class wQ {
  /**
   * @param {ReadonlyArray<T> | null | undefined} [initial]
   *   Initial items (optional).
   * @returns
   *   Splice buffer.
   */
  constructor(e) {
    this.left = e ? [...e] : [], this.right = [];
  }
  /**
   * Array access;
   * does not move the cursor.
   *
   * @param {number} index
   *   Index.
   * @return {T}
   *   Item.
   */
  get(e) {
    if (e < 0 || e >= this.left.length + this.right.length)
      throw new RangeError("Cannot access index `" + e + "` in a splice buffer of size `" + (this.left.length + this.right.length) + "`");
    return e < this.left.length ? this.left[e] : this.right[this.right.length - e + this.left.length - 1];
  }
  /**
   * The length of the splice buffer, one greater than the largest index in the
   * array.
   */
  get length() {
    return this.left.length + this.right.length;
  }
  /**
   * Remove and return `list[0]`;
   * moves the cursor to `0`.
   *
   * @returns {T | undefined}
   *   Item, optional.
   */
  shift() {
    return this.setCursor(0), this.right.pop();
  }
  /**
   * Slice the buffer to get an array;
   * does not move the cursor.
   *
   * @param {number} start
   *   Start.
   * @param {number | null | undefined} [end]
   *   End (optional).
   * @returns {Array<T>}
   *   Array of items.
   */
  slice(e, t) {
    const i = t ?? Number.POSITIVE_INFINITY;
    return i < this.left.length ? this.left.slice(e, i) : e > this.left.length ? this.right.slice(this.right.length - i + this.left.length, this.right.length - e + this.left.length).reverse() : this.left.slice(e).concat(this.right.slice(this.right.length - i + this.left.length).reverse());
  }
  /**
   * Mimics the behavior of Array.prototype.splice() except for the change of
   * interface necessary to avoid segfaults when patching in very large arrays.
   *
   * This operation moves cursor is moved to `start` and results in the cursor
   * placed after any inserted items.
   *
   * @param {number} start
   *   Start;
   *   zero-based index at which to start changing the array;
   *   negative numbers count backwards from the end of the array and values
   *   that are out-of bounds are clamped to the appropriate end of the array.
   * @param {number | null | undefined} [deleteCount=0]
   *   Delete count (default: `0`);
   *   maximum number of elements to delete, starting from start.
   * @param {Array<T> | null | undefined} [items=[]]
   *   Items to include in place of the deleted items (default: `[]`).
   * @return {Array<T>}
   *   Any removed items.
   */
  splice(e, t, i) {
    const r = t || 0;
    this.setCursor(Math.trunc(e));
    const s = this.right.splice(this.right.length - r, Number.POSITIVE_INFINITY);
    return i && Ji(this.left, i), s.reverse();
  }
  /**
   * Remove and return the highest-numbered item in the array, so
   * `list[list.length - 1]`;
   * Moves the cursor to `length`.
   *
   * @returns {T | undefined}
   *   Item, optional.
   */
  pop() {
    return this.setCursor(Number.POSITIVE_INFINITY), this.left.pop();
  }
  /**
   * Inserts a single item to the high-numbered side of the array;
   * moves the cursor to `length`.
   *
   * @param {T} item
   *   Item.
   * @returns {undefined}
   *   Nothing.
   */
  push(e) {
    this.setCursor(Number.POSITIVE_INFINITY), this.left.push(e);
  }
  /**
   * Inserts many items to the high-numbered side of the array.
   * Moves the cursor to `length`.
   *
   * @param {Array<T>} items
   *   Items.
   * @returns {undefined}
   *   Nothing.
   */
  pushMany(e) {
    this.setCursor(Number.POSITIVE_INFINITY), Ji(this.left, e);
  }
  /**
   * Inserts a single item to the low-numbered side of the array;
   * Moves the cursor to `0`.
   *
   * @param {T} item
   *   Item.
   * @returns {undefined}
   *   Nothing.
   */
  unshift(e) {
    this.setCursor(0), this.right.push(e);
  }
  /**
   * Inserts many items to the low-numbered side of the array;
   * moves the cursor to `0`.
   *
   * @param {Array<T>} items
   *   Items.
   * @returns {undefined}
   *   Nothing.
   */
  unshiftMany(e) {
    this.setCursor(0), Ji(this.right, e.reverse());
  }
  /**
   * Move the cursor to a specific position in the array. Requires
   * time proportional to the distance moved.
   *
   * If `n < 0`, the cursor will end up at the beginning.
   * If `n > length`, the cursor will end up at the end.
   *
   * @param {number} n
   *   Position.
   * @return {undefined}
   *   Nothing.
   */
  setCursor(e) {
    if (!(e === this.left.length || e > this.left.length && this.right.length === 0 || e < 0 && this.left.length === 0))
      if (e < this.left.length) {
        const t = this.left.splice(e, Number.POSITIVE_INFINITY);
        Ji(this.right, t.reverse());
      } else {
        const t = this.right.splice(this.left.length + this.right.length - e, Number.POSITIVE_INFINITY);
        Ji(this.left, t.reverse());
      }
  }
}
function Ji(n, e) {
  let t = 0;
  if (e.length < 1e4)
    n.push(...e);
  else
    for (; t < e.length; )
      n.push(...e.slice(t, t + 1e4)), t += 1e4;
}
function _g(n) {
  const e = {};
  let t = -1, i, r, s, o, l, a, h;
  const u = new wQ(n);
  for (; ++t < u.length; ) {
    for (; t in e; )
      t = e[t];
    if (i = u.get(t), t && i[1].type === "chunkFlow" && u.get(t - 1)[1].type === "listItemPrefix" && (a = i[1]._tokenizer.events, s = 0, s < a.length && a[s][1].type === "lineEndingBlank" && (s += 2), s < a.length && a[s][1].type === "content"))
      for (; ++s < a.length && a[s][1].type !== "content"; )
        a[s][1].type === "chunkText" && (a[s][1]._isInFirstContentOfListItem = !0, s++);
    if (i[0] === "enter")
      i[1].contentType && (Object.assign(e, SQ(u, t)), t = e[t], h = !0);
    else if (i[1]._container) {
      for (s = t, r = void 0; s-- && (o = u.get(s), o[1].type === "lineEnding" || o[1].type === "lineEndingBlank"); )
        o[0] === "enter" && (r && (u.get(r)[1].type = "lineEndingBlank"), o[1].type = "lineEnding", r = s);
      r && (i[1].end = Object.assign({}, u.get(r)[1].start), l = u.slice(r, t), l.unshift(i), u.splice(r, t - r + 1, l));
    }
  }
  return St(n, 0, Number.POSITIVE_INFINITY, u.slice(0)), !h;
}
function SQ(n, e) {
  const t = n.get(e)[1], i = n.get(e)[2];
  let r = e - 1;
  const s = [], o = t._tokenizer || i.parser[t.contentType](t.start), l = o.events, a = [], h = {};
  let u, c, f = -1, d = t, p = 0, m = 0;
  const O = [m];
  for (; d; ) {
    for (; n.get(++r)[1] !== d; )
      ;
    s.push(r), d._tokenizer || (u = i.sliceStream(d), d.next || u.push(null), c && o.defineSkip(d.start), d._isInFirstContentOfListItem && (o._gfmTasklistFirstContentOfListItem = !0), o.write(u), d._isInFirstContentOfListItem && (o._gfmTasklistFirstContentOfListItem = void 0)), c = d, d = d.next;
  }
  for (d = t; ++f < l.length; )
    // Find a void token that includes a break.
    l[f][0] === "exit" && l[f - 1][0] === "enter" && l[f][1].type === l[f - 1][1].type && l[f][1].start.line !== l[f][1].end.line && (m = f + 1, O.push(m), d._tokenizer = void 0, d.previous = void 0, d = d.next);
  for (o.events = [], d ? (d._tokenizer = void 0, d.previous = void 0) : O.pop(), f = O.length; f--; ) {
    const g = l.slice(O[f], O[f + 1]), b = s.pop();
    a.push([b, b + g.length - 1]), n.splice(b, 2, g);
  }
  for (a.reverse(), f = -1; ++f < a.length; )
    h[p + a[f][0]] = p + a[f][1], p += a[f][1] - a[f][0] - 1;
  return h;
}
const vQ = {
  tokenize: $Q,
  resolve: QQ
}, PQ = {
  tokenize: CQ,
  partial: !0
};
function QQ(n) {
  return _g(n), n;
}
function $Q(n, e) {
  let t;
  return i;
  function i(l) {
    return n.enter("content"), t = n.enter("chunkContent", {
      contentType: "content"
    }), r(l);
  }
  function r(l) {
    return l === null ? s(l) : N(l) ? n.check(PQ, o, s)(l) : (n.consume(l), r);
  }
  function s(l) {
    return n.exit("chunkContent"), n.exit("content"), e(l);
  }
  function o(l) {
    return n.consume(l), n.exit("chunkContent"), t.next = n.enter("chunkContent", {
      contentType: "content",
      previous: t
    }), t = t.next, r;
  }
}
function CQ(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return n.exit("chunkContent"), n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), re(n, s, "linePrefix");
  }
  function s(o) {
    if (o === null || N(o))
      return t(o);
    const l = i.events[i.events.length - 1];
    return !i.parser.constructs.disable.null.includes("codeIndented") && l && l[1].type === "linePrefix" && l[2].sliceSerialize(l[1], !0).length >= 4 ? e(o) : n.interrupt(i.parser.constructs.flow, t, e)(o);
  }
}
function qg(n, e, t, i, r, s, o, l, a) {
  const h = a || Number.POSITIVE_INFINITY;
  let u = 0;
  return c;
  function c(g) {
    return g === 60 ? (n.enter(i), n.enter(r), n.enter(s), n.consume(g), n.exit(s), f) : g === null || g === 32 || g === 41 || wo(g) ? t(g) : (n.enter(i), n.enter(o), n.enter(l), n.enter("chunkString", {
      contentType: "string"
    }), m(g));
  }
  function f(g) {
    return g === 62 ? (n.enter(s), n.consume(g), n.exit(s), n.exit(r), n.exit(i), e) : (n.enter(l), n.enter("chunkString", {
      contentType: "string"
    }), d(g));
  }
  function d(g) {
    return g === 62 ? (n.exit("chunkString"), n.exit(l), f(g)) : g === null || g === 60 || N(g) ? t(g) : (n.consume(g), g === 92 ? p : d);
  }
  function p(g) {
    return g === 60 || g === 62 || g === 92 ? (n.consume(g), d) : d(g);
  }
  function m(g) {
    return !u && (g === null || g === 41 || me(g)) ? (n.exit("chunkString"), n.exit(l), n.exit(o), n.exit(i), e(g)) : u < h && g === 40 ? (n.consume(g), u++, m) : g === 41 ? (n.consume(g), u--, m) : g === null || g === 32 || g === 40 || wo(g) ? t(g) : (n.consume(g), g === 92 ? O : m);
  }
  function O(g) {
    return g === 40 || g === 41 || g === 92 ? (n.consume(g), m) : m(g);
  }
}
function Wg(n, e, t, i, r, s) {
  const o = this;
  let l = 0, a;
  return h;
  function h(d) {
    return n.enter(i), n.enter(r), n.consume(d), n.exit(r), n.enter(s), u;
  }
  function u(d) {
    return l > 999 || d === null || d === 91 || d === 93 && !a || // To do: remove in the future once we’ve switched from
    // `micromark-extension-footnote` to `micromark-extension-gfm-footnote`,
    // which doesn’t need this.
    // Hidden footnotes hook.
    /* c8 ignore next 3 */
    d === 94 && !l && "_hiddenFootnoteSupport" in o.parser.constructs ? t(d) : d === 93 ? (n.exit(s), n.enter(r), n.consume(d), n.exit(r), n.exit(i), e) : N(d) ? (n.enter("lineEnding"), n.consume(d), n.exit("lineEnding"), u) : (n.enter("chunkString", {
      contentType: "string"
    }), c(d));
  }
  function c(d) {
    return d === null || d === 91 || d === 93 || N(d) || l++ > 999 ? (n.exit("chunkString"), u(d)) : (n.consume(d), a || (a = !te(d)), d === 92 ? f : c);
  }
  function f(d) {
    return d === 91 || d === 92 || d === 93 ? (n.consume(d), l++, c) : c(d);
  }
}
function Bg(n, e, t, i, r, s) {
  let o;
  return l;
  function l(f) {
    return f === 34 || f === 39 || f === 40 ? (n.enter(i), n.enter(r), n.consume(f), n.exit(r), o = f === 40 ? 41 : f, a) : t(f);
  }
  function a(f) {
    return f === o ? (n.enter(r), n.consume(f), n.exit(r), n.exit(i), e) : (n.enter(s), h(f));
  }
  function h(f) {
    return f === o ? (n.exit(s), a(o)) : f === null ? t(f) : N(f) ? (n.enter("lineEnding"), n.consume(f), n.exit("lineEnding"), re(n, h, "linePrefix")) : (n.enter("chunkString", {
      contentType: "string"
    }), u(f));
  }
  function u(f) {
    return f === o || f === null || N(f) ? (n.exit("chunkString"), h(f)) : (n.consume(f), f === 92 ? c : u);
  }
  function c(f) {
    return f === o || f === 92 ? (n.consume(f), u) : u(f);
  }
}
function gr(n, e) {
  let t;
  return i;
  function i(r) {
    return N(r) ? (n.enter("lineEnding"), n.consume(r), n.exit("lineEnding"), t = !0, i) : te(r) ? re(
      n,
      i,
      t ? "linePrefix" : "lineSuffix"
    )(r) : e(r);
  }
}
const TQ = {
  name: "definition",
  tokenize: RQ
}, AQ = {
  tokenize: ZQ,
  partial: !0
};
function RQ(n, e, t) {
  const i = this;
  let r;
  return s;
  function s(d) {
    return n.enter("definition"), o(d);
  }
  function o(d) {
    return Wg.call(
      i,
      n,
      l,
      // Note: we don’t need to reset the way `markdown-rs` does.
      t,
      "definitionLabel",
      "definitionLabelMarker",
      "definitionLabelString"
    )(d);
  }
  function l(d) {
    return r = Zt(i.sliceSerialize(i.events[i.events.length - 1][1]).slice(1, -1)), d === 58 ? (n.enter("definitionMarker"), n.consume(d), n.exit("definitionMarker"), a) : t(d);
  }
  function a(d) {
    return me(d) ? gr(n, h)(d) : h(d);
  }
  function h(d) {
    return qg(
      n,
      u,
      // Note: we don’t need to reset the way `markdown-rs` does.
      t,
      "definitionDestination",
      "definitionDestinationLiteral",
      "definitionDestinationLiteralMarker",
      "definitionDestinationRaw",
      "definitionDestinationString"
    )(d);
  }
  function u(d) {
    return n.attempt(AQ, c, c)(d);
  }
  function c(d) {
    return te(d) ? re(n, f, "whitespace")(d) : f(d);
  }
  function f(d) {
    return d === null || N(d) ? (n.exit("definition"), i.parser.defined.push(r), e(d)) : t(d);
  }
}
function ZQ(n, e, t) {
  return i;
  function i(l) {
    return me(l) ? gr(n, r)(l) : t(l);
  }
  function r(l) {
    return Bg(n, s, t, "definitionTitle", "definitionTitleMarker", "definitionTitleString")(l);
  }
  function s(l) {
    return te(l) ? re(n, o, "whitespace")(l) : o(l);
  }
  function o(l) {
    return l === null || N(l) ? e(l) : t(l);
  }
}
const MQ = {
  name: "hardBreakEscape",
  tokenize: EQ
};
function EQ(n, e, t) {
  return i;
  function i(s) {
    return n.enter("hardBreakEscape"), n.consume(s), r;
  }
  function r(s) {
    return N(s) ? (n.exit("hardBreakEscape"), e(s)) : t(s);
  }
}
const zQ = {
  name: "headingAtx",
  tokenize: DQ,
  resolve: XQ
};
function XQ(n, e) {
  let t = n.length - 2, i = 3, r, s;
  return n[i][1].type === "whitespace" && (i += 2), t - 2 > i && n[t][1].type === "whitespace" && (t -= 2), n[t][1].type === "atxHeadingSequence" && (i === t - 1 || t - 4 > i && n[t - 2][1].type === "whitespace") && (t -= i + 1 === t ? 2 : 4), t > i && (r = {
    type: "atxHeadingText",
    start: n[i][1].start,
    end: n[t][1].end
  }, s = {
    type: "chunkText",
    start: n[i][1].start,
    end: n[t][1].end,
    contentType: "text"
  }, St(n, i, t - i + 1, [["enter", r, e], ["enter", s, e], ["exit", s, e], ["exit", r, e]])), n;
}
function DQ(n, e, t) {
  let i = 0;
  return r;
  function r(u) {
    return n.enter("atxHeading"), s(u);
  }
  function s(u) {
    return n.enter("atxHeadingSequence"), o(u);
  }
  function o(u) {
    return u === 35 && i++ < 6 ? (n.consume(u), o) : u === null || me(u) ? (n.exit("atxHeadingSequence"), l(u)) : t(u);
  }
  function l(u) {
    return u === 35 ? (n.enter("atxHeadingSequence"), a(u)) : u === null || N(u) ? (n.exit("atxHeading"), e(u)) : te(u) ? re(n, l, "whitespace")(u) : (n.enter("atxHeadingText"), h(u));
  }
  function a(u) {
    return u === 35 ? (n.consume(u), a) : (n.exit("atxHeadingSequence"), l(u));
  }
  function h(u) {
    return u === null || u === 35 || me(u) ? (n.exit("atxHeadingText"), l(u)) : (n.consume(u), h);
  }
}
const LQ = [
  "address",
  "article",
  "aside",
  "base",
  "basefont",
  "blockquote",
  "body",
  "caption",
  "center",
  "col",
  "colgroup",
  "dd",
  "details",
  "dialog",
  "dir",
  "div",
  "dl",
  "dt",
  "fieldset",
  "figcaption",
  "figure",
  "footer",
  "form",
  "frame",
  "frameset",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "head",
  "header",
  "hr",
  "html",
  "iframe",
  "legend",
  "li",
  "link",
  "main",
  "menu",
  "menuitem",
  "nav",
  "noframes",
  "ol",
  "optgroup",
  "option",
  "p",
  "param",
  "search",
  "section",
  "summary",
  "table",
  "tbody",
  "td",
  "tfoot",
  "th",
  "thead",
  "title",
  "tr",
  "track",
  "ul"
], Lf = ["pre", "script", "style", "textarea"], IQ = {
  name: "htmlFlow",
  tokenize: BQ,
  resolveTo: WQ,
  concrete: !0
}, _Q = {
  tokenize: YQ,
  partial: !0
}, qQ = {
  tokenize: VQ,
  partial: !0
};
function WQ(n) {
  let e = n.length;
  for (; e-- && !(n[e][0] === "enter" && n[e][1].type === "htmlFlow"); )
    ;
  return e > 1 && n[e - 2][1].type === "linePrefix" && (n[e][1].start = n[e - 2][1].start, n[e + 1][1].start = n[e - 2][1].start, n.splice(e - 2, 2)), n;
}
function BQ(n, e, t) {
  const i = this;
  let r, s, o, l, a;
  return h;
  function h(x) {
    return u(x);
  }
  function u(x) {
    return n.enter("htmlFlow"), n.enter("htmlFlowData"), n.consume(x), c;
  }
  function c(x) {
    return x === 33 ? (n.consume(x), f) : x === 47 ? (n.consume(x), s = !0, m) : x === 63 ? (n.consume(x), r = 3, i.interrupt ? e : y) : He(x) ? (n.consume(x), o = String.fromCharCode(x), O) : t(x);
  }
  function f(x) {
    return x === 45 ? (n.consume(x), r = 2, d) : x === 91 ? (n.consume(x), r = 5, l = 0, p) : He(x) ? (n.consume(x), r = 4, i.interrupt ? e : y) : t(x);
  }
  function d(x) {
    return x === 45 ? (n.consume(x), i.interrupt ? e : y) : t(x);
  }
  function p(x) {
    const $e = "CDATA[";
    return x === $e.charCodeAt(l++) ? (n.consume(x), l === $e.length ? i.interrupt ? e : A : p) : t(x);
  }
  function m(x) {
    return He(x) ? (n.consume(x), o = String.fromCharCode(x), O) : t(x);
  }
  function O(x) {
    if (x === null || x === 47 || x === 62 || me(x)) {
      const $e = x === 47, pt = o.toLowerCase();
      return !$e && !s && Lf.includes(pt) ? (r = 1, i.interrupt ? e(x) : A(x)) : LQ.includes(o.toLowerCase()) ? (r = 6, $e ? (n.consume(x), g) : i.interrupt ? e(x) : A(x)) : (r = 7, i.interrupt && !i.parser.lazy[i.now().line] ? t(x) : s ? b(x) : S(x));
    }
    return x === 45 || je(x) ? (n.consume(x), o += String.fromCharCode(x), O) : t(x);
  }
  function g(x) {
    return x === 62 ? (n.consume(x), i.interrupt ? e : A) : t(x);
  }
  function b(x) {
    return te(x) ? (n.consume(x), b) : v(x);
  }
  function S(x) {
    return x === 47 ? (n.consume(x), v) : x === 58 || x === 95 || He(x) ? (n.consume(x), Q) : te(x) ? (n.consume(x), S) : v(x);
  }
  function Q(x) {
    return x === 45 || x === 46 || x === 58 || x === 95 || je(x) ? (n.consume(x), Q) : P(x);
  }
  function P(x) {
    return x === 61 ? (n.consume(x), w) : te(x) ? (n.consume(x), P) : S(x);
  }
  function w(x) {
    return x === null || x === 60 || x === 61 || x === 62 || x === 96 ? t(x) : x === 34 || x === 39 ? (n.consume(x), a = x, C) : te(x) ? (n.consume(x), w) : L(x);
  }
  function C(x) {
    return x === a ? (n.consume(x), a = null, q) : x === null || N(x) ? t(x) : (n.consume(x), C);
  }
  function L(x) {
    return x === null || x === 34 || x === 39 || x === 47 || x === 60 || x === 61 || x === 62 || x === 96 || me(x) ? P(x) : (n.consume(x), L);
  }
  function q(x) {
    return x === 47 || x === 62 || te(x) ? S(x) : t(x);
  }
  function v(x) {
    return x === 62 ? (n.consume(x), R) : t(x);
  }
  function R(x) {
    return x === null || N(x) ? A(x) : te(x) ? (n.consume(x), R) : t(x);
  }
  function A(x) {
    return x === 45 && r === 2 ? (n.consume(x), G) : x === 60 && r === 1 ? (n.consume(x), U) : x === 62 && r === 4 ? (n.consume(x), he) : x === 63 && r === 3 ? (n.consume(x), y) : x === 93 && r === 5 ? (n.consume(x), ce) : N(x) && (r === 6 || r === 7) ? (n.exit("htmlFlowData"), n.check(_Q, ke, E)(x)) : x === null || N(x) ? (n.exit("htmlFlowData"), E(x)) : (n.consume(x), A);
  }
  function E(x) {
    return n.check(qQ, W, ke)(x);
  }
  function W(x) {
    return n.enter("lineEnding"), n.consume(x), n.exit("lineEnding"), _;
  }
  function _(x) {
    return x === null || N(x) ? E(x) : (n.enter("htmlFlowData"), A(x));
  }
  function G(x) {
    return x === 45 ? (n.consume(x), y) : A(x);
  }
  function U(x) {
    return x === 47 ? (n.consume(x), o = "", se) : A(x);
  }
  function se(x) {
    if (x === 62) {
      const $e = o.toLowerCase();
      return Lf.includes($e) ? (n.consume(x), he) : A(x);
    }
    return He(x) && o.length < 8 ? (n.consume(x), o += String.fromCharCode(x), se) : A(x);
  }
  function ce(x) {
    return x === 93 ? (n.consume(x), y) : A(x);
  }
  function y(x) {
    return x === 62 ? (n.consume(x), he) : x === 45 && r === 2 ? (n.consume(x), y) : A(x);
  }
  function he(x) {
    return x === null || N(x) ? (n.exit("htmlFlowData"), ke(x)) : (n.consume(x), he);
  }
  function ke(x) {
    return n.exit("htmlFlow"), e(x);
  }
}
function VQ(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return N(o) ? (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), s) : t(o);
  }
  function s(o) {
    return i.parser.lazy[i.now().line] ? t(o) : e(o);
  }
}
function YQ(n, e, t) {
  return i;
  function i(r) {
    return n.enter("lineEnding"), n.consume(r), n.exit("lineEnding"), n.attempt(Jr, e, t);
  }
}
const jQ = {
  name: "htmlText",
  tokenize: NQ
};
function NQ(n, e, t) {
  const i = this;
  let r, s, o;
  return l;
  function l(y) {
    return n.enter("htmlText"), n.enter("htmlTextData"), n.consume(y), a;
  }
  function a(y) {
    return y === 33 ? (n.consume(y), h) : y === 47 ? (n.consume(y), P) : y === 63 ? (n.consume(y), S) : He(y) ? (n.consume(y), L) : t(y);
  }
  function h(y) {
    return y === 45 ? (n.consume(y), u) : y === 91 ? (n.consume(y), s = 0, p) : He(y) ? (n.consume(y), b) : t(y);
  }
  function u(y) {
    return y === 45 ? (n.consume(y), d) : t(y);
  }
  function c(y) {
    return y === null ? t(y) : y === 45 ? (n.consume(y), f) : N(y) ? (o = c, U(y)) : (n.consume(y), c);
  }
  function f(y) {
    return y === 45 ? (n.consume(y), d) : c(y);
  }
  function d(y) {
    return y === 62 ? G(y) : y === 45 ? f(y) : c(y);
  }
  function p(y) {
    const he = "CDATA[";
    return y === he.charCodeAt(s++) ? (n.consume(y), s === he.length ? m : p) : t(y);
  }
  function m(y) {
    return y === null ? t(y) : y === 93 ? (n.consume(y), O) : N(y) ? (o = m, U(y)) : (n.consume(y), m);
  }
  function O(y) {
    return y === 93 ? (n.consume(y), g) : m(y);
  }
  function g(y) {
    return y === 62 ? G(y) : y === 93 ? (n.consume(y), g) : m(y);
  }
  function b(y) {
    return y === null || y === 62 ? G(y) : N(y) ? (o = b, U(y)) : (n.consume(y), b);
  }
  function S(y) {
    return y === null ? t(y) : y === 63 ? (n.consume(y), Q) : N(y) ? (o = S, U(y)) : (n.consume(y), S);
  }
  function Q(y) {
    return y === 62 ? G(y) : S(y);
  }
  function P(y) {
    return He(y) ? (n.consume(y), w) : t(y);
  }
  function w(y) {
    return y === 45 || je(y) ? (n.consume(y), w) : C(y);
  }
  function C(y) {
    return N(y) ? (o = C, U(y)) : te(y) ? (n.consume(y), C) : G(y);
  }
  function L(y) {
    return y === 45 || je(y) ? (n.consume(y), L) : y === 47 || y === 62 || me(y) ? q(y) : t(y);
  }
  function q(y) {
    return y === 47 ? (n.consume(y), G) : y === 58 || y === 95 || He(y) ? (n.consume(y), v) : N(y) ? (o = q, U(y)) : te(y) ? (n.consume(y), q) : G(y);
  }
  function v(y) {
    return y === 45 || y === 46 || y === 58 || y === 95 || je(y) ? (n.consume(y), v) : R(y);
  }
  function R(y) {
    return y === 61 ? (n.consume(y), A) : N(y) ? (o = R, U(y)) : te(y) ? (n.consume(y), R) : q(y);
  }
  function A(y) {
    return y === null || y === 60 || y === 61 || y === 62 || y === 96 ? t(y) : y === 34 || y === 39 ? (n.consume(y), r = y, E) : N(y) ? (o = A, U(y)) : te(y) ? (n.consume(y), A) : (n.consume(y), W);
  }
  function E(y) {
    return y === r ? (n.consume(y), r = void 0, _) : y === null ? t(y) : N(y) ? (o = E, U(y)) : (n.consume(y), E);
  }
  function W(y) {
    return y === null || y === 34 || y === 39 || y === 60 || y === 61 || y === 96 ? t(y) : y === 47 || y === 62 || me(y) ? q(y) : (n.consume(y), W);
  }
  function _(y) {
    return y === 47 || y === 62 || me(y) ? q(y) : t(y);
  }
  function G(y) {
    return y === 62 ? (n.consume(y), n.exit("htmlTextData"), n.exit("htmlText"), e) : t(y);
  }
  function U(y) {
    return n.exit("htmlTextData"), n.enter("lineEnding"), n.consume(y), n.exit("lineEnding"), se;
  }
  function se(y) {
    return te(y) ? re(n, ce, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(y) : ce(y);
  }
  function ce(y) {
    return n.enter("htmlTextData"), o(y);
  }
}
const uu = {
  name: "labelEnd",
  tokenize: JQ,
  resolveTo: KQ,
  resolveAll: HQ
}, UQ = {
  tokenize: e$
}, FQ = {
  tokenize: t$
}, GQ = {
  tokenize: n$
};
function HQ(n) {
  let e = -1;
  for (; ++e < n.length; ) {
    const t = n[e][1];
    (t.type === "labelImage" || t.type === "labelLink" || t.type === "labelEnd") && (n.splice(e + 1, t.type === "labelImage" ? 4 : 2), t.type = "data", e++);
  }
  return n;
}
function KQ(n, e) {
  let t = n.length, i = 0, r, s, o, l;
  for (; t--; )
    if (r = n[t][1], s) {
      if (r.type === "link" || r.type === "labelLink" && r._inactive)
        break;
      n[t][0] === "enter" && r.type === "labelLink" && (r._inactive = !0);
    } else if (o) {
      if (n[t][0] === "enter" && (r.type === "labelImage" || r.type === "labelLink") && !r._balanced && (s = t, r.type !== "labelLink")) {
        i = 2;
        break;
      }
    } else
      r.type === "labelEnd" && (o = t);
  const a = {
    type: n[s][1].type === "labelLink" ? "link" : "image",
    start: Object.assign({}, n[s][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  }, h = {
    type: "label",
    start: Object.assign({}, n[s][1].start),
    end: Object.assign({}, n[o][1].end)
  }, u = {
    type: "labelText",
    start: Object.assign({}, n[s + i + 2][1].end),
    end: Object.assign({}, n[o - 2][1].start)
  };
  return l = [["enter", a, e], ["enter", h, e]], l = gt(l, n.slice(s + 1, s + i + 3)), l = gt(l, [["enter", u, e]]), l = gt(l, Ko(e.parser.constructs.insideSpan.null, n.slice(s + i + 4, o - 3), e)), l = gt(l, [["exit", u, e], n[o - 2], n[o - 1], ["exit", h, e]]), l = gt(l, n.slice(o + 1)), l = gt(l, [["exit", a, e]]), St(n, s, n.length, l), n;
}
function JQ(n, e, t) {
  const i = this;
  let r = i.events.length, s, o;
  for (; r--; )
    if ((i.events[r][1].type === "labelImage" || i.events[r][1].type === "labelLink") && !i.events[r][1]._balanced) {
      s = i.events[r][1];
      break;
    }
  return l;
  function l(f) {
    return s ? s._inactive ? c(f) : (o = i.parser.defined.includes(Zt(i.sliceSerialize({
      start: s.end,
      end: i.now()
    }))), n.enter("labelEnd"), n.enter("labelMarker"), n.consume(f), n.exit("labelMarker"), n.exit("labelEnd"), a) : t(f);
  }
  function a(f) {
    return f === 40 ? n.attempt(UQ, u, o ? u : c)(f) : f === 91 ? n.attempt(FQ, u, o ? h : c)(f) : o ? u(f) : c(f);
  }
  function h(f) {
    return n.attempt(GQ, u, c)(f);
  }
  function u(f) {
    return e(f);
  }
  function c(f) {
    return s._balanced = !0, t(f);
  }
}
function e$(n, e, t) {
  return i;
  function i(c) {
    return n.enter("resource"), n.enter("resourceMarker"), n.consume(c), n.exit("resourceMarker"), r;
  }
  function r(c) {
    return me(c) ? gr(n, s)(c) : s(c);
  }
  function s(c) {
    return c === 41 ? u(c) : qg(n, o, l, "resourceDestination", "resourceDestinationLiteral", "resourceDestinationLiteralMarker", "resourceDestinationRaw", "resourceDestinationString", 32)(c);
  }
  function o(c) {
    return me(c) ? gr(n, a)(c) : u(c);
  }
  function l(c) {
    return t(c);
  }
  function a(c) {
    return c === 34 || c === 39 || c === 40 ? Bg(n, h, t, "resourceTitle", "resourceTitleMarker", "resourceTitleString")(c) : u(c);
  }
  function h(c) {
    return me(c) ? gr(n, u)(c) : u(c);
  }
  function u(c) {
    return c === 41 ? (n.enter("resourceMarker"), n.consume(c), n.exit("resourceMarker"), n.exit("resource"), e) : t(c);
  }
}
function t$(n, e, t) {
  const i = this;
  return r;
  function r(l) {
    return Wg.call(i, n, s, o, "reference", "referenceMarker", "referenceString")(l);
  }
  function s(l) {
    return i.parser.defined.includes(Zt(i.sliceSerialize(i.events[i.events.length - 1][1]).slice(1, -1))) ? e(l) : t(l);
  }
  function o(l) {
    return t(l);
  }
}
function n$(n, e, t) {
  return i;
  function i(s) {
    return n.enter("reference"), n.enter("referenceMarker"), n.consume(s), n.exit("referenceMarker"), r;
  }
  function r(s) {
    return s === 93 ? (n.enter("referenceMarker"), n.consume(s), n.exit("referenceMarker"), n.exit("reference"), e) : t(s);
  }
}
const i$ = {
  name: "labelStartImage",
  tokenize: r$,
  resolveAll: uu.resolveAll
};
function r$(n, e, t) {
  const i = this;
  return r;
  function r(l) {
    return n.enter("labelImage"), n.enter("labelImageMarker"), n.consume(l), n.exit("labelImageMarker"), s;
  }
  function s(l) {
    return l === 91 ? (n.enter("labelMarker"), n.consume(l), n.exit("labelMarker"), n.exit("labelImage"), o) : t(l);
  }
  function o(l) {
    return l === 94 && "_hiddenFootnoteSupport" in i.parser.constructs ? t(l) : e(l);
  }
}
const s$ = {
  name: "labelStartLink",
  tokenize: o$,
  resolveAll: uu.resolveAll
};
function o$(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return n.enter("labelLink"), n.enter("labelMarker"), n.consume(o), n.exit("labelMarker"), n.exit("labelLink"), s;
  }
  function s(o) {
    return o === 94 && "_hiddenFootnoteSupport" in i.parser.constructs ? t(o) : e(o);
  }
}
const Zl = {
  name: "lineEnding",
  tokenize: l$
};
function l$(n, e) {
  return t;
  function t(i) {
    return n.enter("lineEnding"), n.consume(i), n.exit("lineEnding"), re(n, e, "linePrefix");
  }
}
const Ys = {
  name: "thematicBreak",
  tokenize: a$
};
function a$(n, e, t) {
  let i = 0, r;
  return s;
  function s(h) {
    return n.enter("thematicBreak"), o(h);
  }
  function o(h) {
    return r = h, l(h);
  }
  function l(h) {
    return h === r ? (n.enter("thematicBreakSequence"), a(h)) : i >= 3 && (h === null || N(h)) ? (n.exit("thematicBreak"), e(h)) : t(h);
  }
  function a(h) {
    return h === r ? (n.consume(h), i++, a) : (n.exit("thematicBreakSequence"), te(h) ? re(n, l, "whitespace")(h) : l(h));
  }
}
const et = {
  name: "list",
  tokenize: c$,
  continuation: {
    tokenize: f$
  },
  exit: p$
}, h$ = {
  tokenize: m$,
  partial: !0
}, u$ = {
  tokenize: d$,
  partial: !0
};
function c$(n, e, t) {
  const i = this, r = i.events[i.events.length - 1];
  let s = r && r[1].type === "linePrefix" ? r[2].sliceSerialize(r[1], !0).length : 0, o = 0;
  return l;
  function l(d) {
    const p = i.containerState.type || (d === 42 || d === 43 || d === 45 ? "listUnordered" : "listOrdered");
    if (p === "listUnordered" ? !i.containerState.marker || d === i.containerState.marker : Ja(d)) {
      if (i.containerState.type || (i.containerState.type = p, n.enter(p, {
        _container: !0
      })), p === "listUnordered")
        return n.enter("listItemPrefix"), d === 42 || d === 45 ? n.check(Ys, t, h)(d) : h(d);
      if (!i.interrupt || d === 49)
        return n.enter("listItemPrefix"), n.enter("listItemValue"), a(d);
    }
    return t(d);
  }
  function a(d) {
    return Ja(d) && ++o < 10 ? (n.consume(d), a) : (!i.interrupt || o < 2) && (i.containerState.marker ? d === i.containerState.marker : d === 41 || d === 46) ? (n.exit("listItemValue"), h(d)) : t(d);
  }
  function h(d) {
    return n.enter("listItemMarker"), n.consume(d), n.exit("listItemMarker"), i.containerState.marker = i.containerState.marker || d, n.check(
      Jr,
      // Can’t be empty when interrupting.
      i.interrupt ? t : u,
      n.attempt(h$, f, c)
    );
  }
  function u(d) {
    return i.containerState.initialBlankLine = !0, s++, f(d);
  }
  function c(d) {
    return te(d) ? (n.enter("listItemPrefixWhitespace"), n.consume(d), n.exit("listItemPrefixWhitespace"), f) : t(d);
  }
  function f(d) {
    return i.containerState.size = s + i.sliceSerialize(n.exit("listItemPrefix"), !0).length, e(d);
  }
}
function f$(n, e, t) {
  const i = this;
  return i.containerState._closeFlow = void 0, n.check(Jr, r, s);
  function r(l) {
    return i.containerState.furtherBlankLines = i.containerState.furtherBlankLines || i.containerState.initialBlankLine, re(n, e, "listItemIndent", i.containerState.size + 1)(l);
  }
  function s(l) {
    return i.containerState.furtherBlankLines || !te(l) ? (i.containerState.furtherBlankLines = void 0, i.containerState.initialBlankLine = void 0, o(l)) : (i.containerState.furtherBlankLines = void 0, i.containerState.initialBlankLine = void 0, n.attempt(u$, e, o)(l));
  }
  function o(l) {
    return i.containerState._closeFlow = !0, i.interrupt = void 0, re(n, n.attempt(et, e, t), "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(l);
  }
}
function d$(n, e, t) {
  const i = this;
  return re(n, r, "listItemIndent", i.containerState.size + 1);
  function r(s) {
    const o = i.events[i.events.length - 1];
    return o && o[1].type === "listItemIndent" && o[2].sliceSerialize(o[1], !0).length === i.containerState.size ? e(s) : t(s);
  }
}
function p$(n) {
  n.exit(this.containerState.type);
}
function m$(n, e, t) {
  const i = this;
  return re(n, r, "listItemPrefixWhitespace", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 5);
  function r(s) {
    const o = i.events[i.events.length - 1];
    return !te(s) && o && o[1].type === "listItemPrefixWhitespace" ? e(s) : t(s);
  }
}
const If = {
  name: "setextUnderline",
  tokenize: g$,
  resolveTo: O$
};
function O$(n, e) {
  let t = n.length, i, r, s;
  for (; t--; )
    if (n[t][0] === "enter") {
      if (n[t][1].type === "content") {
        i = t;
        break;
      }
      n[t][1].type === "paragraph" && (r = t);
    } else
      n[t][1].type === "content" && n.splice(t, 1), !s && n[t][1].type === "definition" && (s = t);
  const o = {
    type: "setextHeading",
    start: Object.assign({}, n[r][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  };
  return n[r][1].type = "setextHeadingText", s ? (n.splice(r, 0, ["enter", o, e]), n.splice(s + 1, 0, ["exit", n[i][1], e]), n[i][1].end = Object.assign({}, n[s][1].end)) : n[i][1] = o, n.push(["exit", o, e]), n;
}
function g$(n, e, t) {
  const i = this;
  let r;
  return s;
  function s(h) {
    let u = i.events.length, c;
    for (; u--; )
      if (i.events[u][1].type !== "lineEnding" && i.events[u][1].type !== "linePrefix" && i.events[u][1].type !== "content") {
        c = i.events[u][1].type === "paragraph";
        break;
      }
    return !i.parser.lazy[i.now().line] && (i.interrupt || c) ? (n.enter("setextHeadingLine"), r = h, o(h)) : t(h);
  }
  function o(h) {
    return n.enter("setextHeadingLineSequence"), l(h);
  }
  function l(h) {
    return h === r ? (n.consume(h), l) : (n.exit("setextHeadingLineSequence"), te(h) ? re(n, a, "lineSuffix")(h) : a(h));
  }
  function a(h) {
    return h === null || N(h) ? (n.exit("setextHeadingLine"), e(h)) : t(h);
  }
}
const b$ = {
  tokenize: Q$,
  partial: !0
};
function y$() {
  return {
    document: {
      91: {
        tokenize: S$,
        continuation: {
          tokenize: v$
        },
        exit: P$
      }
    },
    text: {
      91: {
        tokenize: w$
      },
      93: {
        add: "after",
        tokenize: k$,
        resolveTo: x$
      }
    }
  };
}
function k$(n, e, t) {
  const i = this;
  let r = i.events.length;
  const s = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let o;
  for (; r--; ) {
    const a = i.events[r][1];
    if (a.type === "labelImage") {
      o = a;
      break;
    }
    if (a.type === "gfmFootnoteCall" || a.type === "labelLink" || a.type === "label" || a.type === "image" || a.type === "link")
      break;
  }
  return l;
  function l(a) {
    if (!o || !o._balanced)
      return t(a);
    const h = Zt(
      i.sliceSerialize({
        start: o.end,
        end: i.now()
      })
    );
    return h.codePointAt(0) !== 94 || !s.includes(h.slice(1)) ? t(a) : (n.enter("gfmFootnoteCallLabelMarker"), n.consume(a), n.exit("gfmFootnoteCallLabelMarker"), e(a));
  }
}
function x$(n, e) {
  let t = n.length;
  for (; t--; )
    if (n[t][1].type === "labelImage" && n[t][0] === "enter") {
      n[t][1];
      break;
    }
  n[t + 1][1].type = "data", n[t + 3][1].type = "gfmFootnoteCallLabelMarker";
  const i = {
    type: "gfmFootnoteCall",
    start: Object.assign({}, n[t + 3][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  }, r = {
    type: "gfmFootnoteCallMarker",
    start: Object.assign({}, n[t + 3][1].end),
    end: Object.assign({}, n[t + 3][1].end)
  };
  r.end.column++, r.end.offset++, r.end._bufferIndex++;
  const s = {
    type: "gfmFootnoteCallString",
    start: Object.assign({}, r.end),
    end: Object.assign({}, n[n.length - 1][1].start)
  }, o = {
    type: "chunkString",
    contentType: "string",
    start: Object.assign({}, s.start),
    end: Object.assign({}, s.end)
  }, l = [
    // Take the `labelImageMarker` (now `data`, the `!`)
    n[t + 1],
    n[t + 2],
    ["enter", i, e],
    // The `[`
    n[t + 3],
    n[t + 4],
    // The `^`.
    ["enter", r, e],
    ["exit", r, e],
    // Everything in between.
    ["enter", s, e],
    ["enter", o, e],
    ["exit", o, e],
    ["exit", s, e],
    // The ending (`]`, properly parsed and labelled).
    n[n.length - 2],
    n[n.length - 1],
    ["exit", i, e]
  ];
  return n.splice(t, n.length - t + 1, ...l), n;
}
function w$(n, e, t) {
  const i = this, r = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let s = 0, o;
  return l;
  function l(c) {
    return n.enter("gfmFootnoteCall"), n.enter("gfmFootnoteCallLabelMarker"), n.consume(c), n.exit("gfmFootnoteCallLabelMarker"), a;
  }
  function a(c) {
    return c !== 94 ? t(c) : (n.enter("gfmFootnoteCallMarker"), n.consume(c), n.exit("gfmFootnoteCallMarker"), n.enter("gfmFootnoteCallString"), n.enter("chunkString").contentType = "string", h);
  }
  function h(c) {
    if (
      // Too long.
      s > 999 || // Closing brace with nothing.
      c === 93 && !o || // Space or tab is not supported by GFM for some reason.
      // `\n` and `[` not being supported makes sense.
      c === null || c === 91 || me(c)
    )
      return t(c);
    if (c === 93) {
      n.exit("chunkString");
      const f = n.exit("gfmFootnoteCallString");
      return r.includes(Zt(i.sliceSerialize(f))) ? (n.enter("gfmFootnoteCallLabelMarker"), n.consume(c), n.exit("gfmFootnoteCallLabelMarker"), n.exit("gfmFootnoteCall"), e) : t(c);
    }
    return me(c) || (o = !0), s++, n.consume(c), c === 92 ? u : h;
  }
  function u(c) {
    return c === 91 || c === 92 || c === 93 ? (n.consume(c), s++, h) : h(c);
  }
}
function S$(n, e, t) {
  const i = this, r = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let s, o = 0, l;
  return a;
  function a(p) {
    return n.enter("gfmFootnoteDefinition")._container = !0, n.enter("gfmFootnoteDefinitionLabel"), n.enter("gfmFootnoteDefinitionLabelMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionLabelMarker"), h;
  }
  function h(p) {
    return p === 94 ? (n.enter("gfmFootnoteDefinitionMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionMarker"), n.enter("gfmFootnoteDefinitionLabelString"), n.enter("chunkString").contentType = "string", u) : t(p);
  }
  function u(p) {
    if (
      // Too long.
      o > 999 || // Closing brace with nothing.
      p === 93 && !l || // Space or tab is not supported by GFM for some reason.
      // `\n` and `[` not being supported makes sense.
      p === null || p === 91 || me(p)
    )
      return t(p);
    if (p === 93) {
      n.exit("chunkString");
      const m = n.exit("gfmFootnoteDefinitionLabelString");
      return s = Zt(i.sliceSerialize(m)), n.enter("gfmFootnoteDefinitionLabelMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionLabelMarker"), n.exit("gfmFootnoteDefinitionLabel"), f;
    }
    return me(p) || (l = !0), o++, n.consume(p), p === 92 ? c : u;
  }
  function c(p) {
    return p === 91 || p === 92 || p === 93 ? (n.consume(p), o++, u) : u(p);
  }
  function f(p) {
    return p === 58 ? (n.enter("definitionMarker"), n.consume(p), n.exit("definitionMarker"), r.includes(s) || r.push(s), re(
      n,
      d,
      "gfmFootnoteDefinitionWhitespace"
    )) : t(p);
  }
  function d(p) {
    return e(p);
  }
}
function v$(n, e, t) {
  return n.check(Jr, e, n.attempt(b$, e, t));
}
function P$(n) {
  n.exit("gfmFootnoteDefinition");
}
function Q$(n, e, t) {
  const i = this;
  return re(
    n,
    r,
    "gfmFootnoteDefinitionIndent",
    5
  );
  function r(s) {
    const o = i.events[i.events.length - 1];
    return o && o[1].type === "gfmFootnoteDefinitionIndent" && o[2].sliceSerialize(o[1], !0).length === 4 ? e(s) : t(s);
  }
}
function $$(n) {
  let t = (n || {}).singleTilde;
  const i = {
    tokenize: s,
    resolveAll: r
  };
  return t == null && (t = !0), {
    text: {
      126: i
    },
    insideSpan: {
      null: [i]
    },
    attentionMarkers: {
      null: [126]
    }
  };
  function r(o, l) {
    let a = -1;
    for (; ++a < o.length; )
      if (o[a][0] === "enter" && o[a][1].type === "strikethroughSequenceTemporary" && o[a][1]._close) {
        let h = a;
        for (; h--; )
          if (o[h][0] === "exit" && o[h][1].type === "strikethroughSequenceTemporary" && o[h][1]._open && // If the sizes are the same:
          o[a][1].end.offset - o[a][1].start.offset === o[h][1].end.offset - o[h][1].start.offset) {
            o[a][1].type = "strikethroughSequence", o[h][1].type = "strikethroughSequence";
            const u = {
              type: "strikethrough",
              start: Object.assign({}, o[h][1].start),
              end: Object.assign({}, o[a][1].end)
            }, c = {
              type: "strikethroughText",
              start: Object.assign({}, o[h][1].end),
              end: Object.assign({}, o[a][1].start)
            }, f = [
              ["enter", u, l],
              ["enter", o[h][1], l],
              ["exit", o[h][1], l],
              ["enter", c, l]
            ], d = l.parser.constructs.insideSpan.null;
            d && St(
              f,
              f.length,
              0,
              Ko(d, o.slice(h + 1, a), l)
            ), St(f, f.length, 0, [
              ["exit", c, l],
              ["enter", o[a][1], l],
              ["exit", o[a][1], l],
              ["exit", u, l]
            ]), St(o, h - 1, a - h + 3, f), a = h + f.length - 2;
            break;
          }
      }
    for (a = -1; ++a < o.length; )
      o[a][1].type === "strikethroughSequenceTemporary" && (o[a][1].type = "data");
    return o;
  }
  function s(o, l, a) {
    const h = this.previous, u = this.events;
    let c = 0;
    return f;
    function f(p) {
      return h === 126 && u[u.length - 1][1].type !== "characterEscape" ? a(p) : (o.enter("strikethroughSequenceTemporary"), d(p));
    }
    function d(p) {
      const m = So(h);
      if (p === 126)
        return c > 1 ? a(p) : (o.consume(p), c++, d);
      if (c < 2 && !t)
        return a(p);
      const O = o.exit("strikethroughSequenceTemporary"), g = So(p);
      return O._open = !g || g === 2 && !!m, O._close = !m || m === 2 && !!g, l(p);
    }
  }
}
class C$ {
  /**
   * Create a new edit map.
   */
  constructor() {
    this.map = [];
  }
  /**
   * Create an edit: a remove and/or add at a certain place.
   *
   * @param {number} index
   * @param {number} remove
   * @param {Array<Event>} add
   * @returns {undefined}
   */
  add(e, t, i) {
    T$(this, e, t, i);
  }
  // To do: add this when moving to `micromark`.
  // /**
  //  * Create an edit: but insert `add` before existing additions.
  //  *
  //  * @param {number} index
  //  * @param {number} remove
  //  * @param {Array<Event>} add
  //  * @returns {undefined}
  //  */
  // addBefore(index, remove, add) {
  //   addImpl(this, index, remove, add, true)
  // }
  /**
   * Done, change the events.
   *
   * @param {Array<Event>} events
   * @returns {undefined}
   */
  consume(e) {
    if (this.map.sort(function(s, o) {
      return s[0] - o[0];
    }), this.map.length === 0)
      return;
    let t = this.map.length;
    const i = [];
    for (; t > 0; )
      t -= 1, i.push(
        e.slice(this.map[t][0] + this.map[t][1]),
        this.map[t][2]
      ), e.length = this.map[t][0];
    i.push([...e]), e.length = 0;
    let r = i.pop();
    for (; r; )
      e.push(...r), r = i.pop();
    this.map.length = 0;
  }
}
function T$(n, e, t, i) {
  let r = 0;
  if (!(t === 0 && i.length === 0)) {
    for (; r < n.map.length; ) {
      if (n.map[r][0] === e) {
        n.map[r][1] += t, n.map[r][2].push(...i);
        return;
      }
      r += 1;
    }
    n.map.push([e, t, i]);
  }
}
function A$(n, e) {
  let t = !1;
  const i = [];
  for (; e < n.length; ) {
    const r = n[e];
    if (t) {
      if (r[0] === "enter")
        r[1].type === "tableContent" && i.push(
          n[e + 1][1].type === "tableDelimiterMarker" ? "left" : "none"
        );
      else if (r[1].type === "tableContent") {
        if (n[e - 1][1].type === "tableDelimiterMarker") {
          const s = i.length - 1;
          i[s] = i[s] === "left" ? "center" : "right";
        }
      } else if (r[1].type === "tableDelimiterRow")
        break;
    } else
      r[0] === "enter" && r[1].type === "tableDelimiterRow" && (t = !0);
    e += 1;
  }
  return i;
}
function R$() {
  return {
    flow: {
      null: {
        tokenize: Z$,
        resolveAll: M$
      }
    }
  };
}
function Z$(n, e, t) {
  const i = this;
  let r = 0, s = 0, o;
  return l;
  function l(v) {
    let R = i.events.length - 1;
    for (; R > -1; ) {
      const W = i.events[R][1].type;
      if (W === "lineEnding" || // Note: markdown-rs uses `whitespace` instead of `linePrefix`
      W === "linePrefix")
        R--;
      else
        break;
    }
    const A = R > -1 ? i.events[R][1].type : null, E = A === "tableHead" || A === "tableRow" ? w : a;
    return E === w && i.parser.lazy[i.now().line] ? t(v) : E(v);
  }
  function a(v) {
    return n.enter("tableHead"), n.enter("tableRow"), h(v);
  }
  function h(v) {
    return v === 124 || (o = !0, s += 1), u(v);
  }
  function u(v) {
    return v === null ? t(v) : N(v) ? s > 1 ? (s = 0, i.interrupt = !0, n.exit("tableRow"), n.enter("lineEnding"), n.consume(v), n.exit("lineEnding"), d) : t(v) : te(v) ? re(n, u, "whitespace")(v) : (s += 1, o && (o = !1, r += 1), v === 124 ? (n.enter("tableCellDivider"), n.consume(v), n.exit("tableCellDivider"), o = !0, u) : (n.enter("data"), c(v)));
  }
  function c(v) {
    return v === null || v === 124 || me(v) ? (n.exit("data"), u(v)) : (n.consume(v), v === 92 ? f : c);
  }
  function f(v) {
    return v === 92 || v === 124 ? (n.consume(v), c) : c(v);
  }
  function d(v) {
    return i.interrupt = !1, i.parser.lazy[i.now().line] ? t(v) : (n.enter("tableDelimiterRow"), o = !1, te(v) ? re(
      n,
      p,
      "linePrefix",
      i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
    )(v) : p(v));
  }
  function p(v) {
    return v === 45 || v === 58 ? O(v) : v === 124 ? (o = !0, n.enter("tableCellDivider"), n.consume(v), n.exit("tableCellDivider"), m) : P(v);
  }
  function m(v) {
    return te(v) ? re(n, O, "whitespace")(v) : O(v);
  }
  function O(v) {
    return v === 58 ? (s += 1, o = !0, n.enter("tableDelimiterMarker"), n.consume(v), n.exit("tableDelimiterMarker"), g) : v === 45 ? (s += 1, g(v)) : v === null || N(v) ? Q(v) : P(v);
  }
  function g(v) {
    return v === 45 ? (n.enter("tableDelimiterFiller"), b(v)) : P(v);
  }
  function b(v) {
    return v === 45 ? (n.consume(v), b) : v === 58 ? (o = !0, n.exit("tableDelimiterFiller"), n.enter("tableDelimiterMarker"), n.consume(v), n.exit("tableDelimiterMarker"), S) : (n.exit("tableDelimiterFiller"), S(v));
  }
  function S(v) {
    return te(v) ? re(n, Q, "whitespace")(v) : Q(v);
  }
  function Q(v) {
    return v === 124 ? p(v) : v === null || N(v) ? !o || r !== s ? P(v) : (n.exit("tableDelimiterRow"), n.exit("tableHead"), e(v)) : P(v);
  }
  function P(v) {
    return t(v);
  }
  function w(v) {
    return n.enter("tableRow"), C(v);
  }
  function C(v) {
    return v === 124 ? (n.enter("tableCellDivider"), n.consume(v), n.exit("tableCellDivider"), C) : v === null || N(v) ? (n.exit("tableRow"), e(v)) : te(v) ? re(n, C, "whitespace")(v) : (n.enter("data"), L(v));
  }
  function L(v) {
    return v === null || v === 124 || me(v) ? (n.exit("data"), C(v)) : (n.consume(v), v === 92 ? q : L);
  }
  function q(v) {
    return v === 92 || v === 124 ? (n.consume(v), L) : L(v);
  }
}
function M$(n, e) {
  let t = -1, i = !0, r = 0, s = [0, 0, 0, 0], o = [0, 0, 0, 0], l = !1, a = 0, h, u, c;
  const f = new C$();
  for (; ++t < n.length; ) {
    const d = n[t], p = d[1];
    d[0] === "enter" ? p.type === "tableHead" ? (l = !1, a !== 0 && (_f(f, e, a, h, u), u = void 0, a = 0), h = {
      type: "table",
      start: Object.assign({}, p.start),
      // Note: correct end is set later.
      end: Object.assign({}, p.end)
    }, f.add(t, 0, [["enter", h, e]])) : p.type === "tableRow" || p.type === "tableDelimiterRow" ? (i = !0, c = void 0, s = [0, 0, 0, 0], o = [0, t + 1, 0, 0], l && (l = !1, u = {
      type: "tableBody",
      start: Object.assign({}, p.start),
      // Note: correct end is set later.
      end: Object.assign({}, p.end)
    }, f.add(t, 0, [["enter", u, e]])), r = p.type === "tableDelimiterRow" ? 2 : u ? 3 : 1) : r && (p.type === "data" || p.type === "tableDelimiterMarker" || p.type === "tableDelimiterFiller") ? (i = !1, o[2] === 0 && (s[1] !== 0 && (o[0] = o[1], c = Ps(
      f,
      e,
      s,
      r,
      void 0,
      c
    ), s = [0, 0, 0, 0]), o[2] = t)) : p.type === "tableCellDivider" && (i ? i = !1 : (s[1] !== 0 && (o[0] = o[1], c = Ps(
      f,
      e,
      s,
      r,
      void 0,
      c
    )), s = o, o = [s[1], t, 0, 0])) : p.type === "tableHead" ? (l = !0, a = t) : p.type === "tableRow" || p.type === "tableDelimiterRow" ? (a = t, s[1] !== 0 ? (o[0] = o[1], c = Ps(
      f,
      e,
      s,
      r,
      t,
      c
    )) : o[1] !== 0 && (c = Ps(f, e, o, r, t, c)), r = 0) : r && (p.type === "data" || p.type === "tableDelimiterMarker" || p.type === "tableDelimiterFiller") && (o[3] = t);
  }
  for (a !== 0 && _f(f, e, a, h, u), f.consume(e.events), t = -1; ++t < e.events.length; ) {
    const d = e.events[t];
    d[0] === "enter" && d[1].type === "table" && (d[1]._align = A$(e.events, t));
  }
  return n;
}
function Ps(n, e, t, i, r, s) {
  const o = i === 1 ? "tableHeader" : i === 2 ? "tableDelimiter" : "tableData", l = "tableContent";
  t[0] !== 0 && (s.end = Object.assign({}, hi(e.events, t[0])), n.add(t[0], 0, [["exit", s, e]]));
  const a = hi(e.events, t[1]);
  if (s = {
    type: o,
    start: Object.assign({}, a),
    // Note: correct end is set later.
    end: Object.assign({}, a)
  }, n.add(t[1], 0, [["enter", s, e]]), t[2] !== 0) {
    const h = hi(e.events, t[2]), u = hi(e.events, t[3]), c = {
      type: l,
      start: Object.assign({}, h),
      end: Object.assign({}, u)
    };
    if (n.add(t[2], 0, [["enter", c, e]]), i !== 2) {
      const f = e.events[t[2]], d = e.events[t[3]];
      if (f[1].end = Object.assign({}, d[1].end), f[1].type = "chunkText", f[1].contentType = "text", t[3] > t[2] + 1) {
        const p = t[2] + 1, m = t[3] - t[2] - 1;
        n.add(p, m, []);
      }
    }
    n.add(t[3] + 1, 0, [["exit", c, e]]);
  }
  return r !== void 0 && (s.end = Object.assign({}, hi(e.events, r)), n.add(r, 0, [["exit", s, e]]), s = void 0), s;
}
function _f(n, e, t, i, r) {
  const s = [], o = hi(e.events, t);
  r && (r.end = Object.assign({}, o), s.push(["exit", r, e])), i.end = Object.assign({}, o), s.push(["exit", i, e]), n.add(t + 1, 0, s);
}
function hi(n, e) {
  const t = n[e], i = t[0] === "enter" ? "start" : "end";
  return t[1][i];
}
const E$ = {
  tokenize: X$
};
function z$() {
  return {
    text: {
      91: E$
    }
  };
}
function X$(n, e, t) {
  const i = this;
  return r;
  function r(a) {
    return (
      // Exit if there’s stuff before.
      i.previous !== null || // Exit if not in the first content that is the first child of a list
      // item.
      !i._gfmTasklistFirstContentOfListItem ? t(a) : (n.enter("taskListCheck"), n.enter("taskListCheckMarker"), n.consume(a), n.exit("taskListCheckMarker"), s)
    );
  }
  function s(a) {
    return me(a) ? (n.enter("taskListCheckValueUnchecked"), n.consume(a), n.exit("taskListCheckValueUnchecked"), o) : a === 88 || a === 120 ? (n.enter("taskListCheckValueChecked"), n.consume(a), n.exit("taskListCheckValueChecked"), o) : t(a);
  }
  function o(a) {
    return a === 93 ? (n.enter("taskListCheckMarker"), n.consume(a), n.exit("taskListCheckMarker"), n.exit("taskListCheck"), l) : t(a);
  }
  function l(a) {
    return N(a) ? e(a) : te(a) ? n.check(
      {
        tokenize: D$
      },
      e,
      t
    )(a) : t(a);
  }
}
function D$(n, e, t) {
  return re(n, i, "whitespace");
  function i(r) {
    return r === null ? t(r) : e(r);
  }
}
function L$(n) {
  return Cg([
    UP(),
    y$(),
    $$(n),
    R$(),
    z$()
  ]);
}
const I$ = {};
function _$(n) {
  const e = (
    /** @type {Processor} */
    this
  ), t = n || I$, i = e.data(), r = i.micromarkExtensions || (i.micromarkExtensions = []), s = i.fromMarkdownExtensions || (i.fromMarkdownExtensions = []), o = i.toMarkdownExtensions || (i.toMarkdownExtensions = []);
  r.push(L$(t)), s.push(WP()), o.push(BP(t));
}
const Ze = {
  xmark: '<svg class="cs-close-button" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M342.6 150.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L192 210.7 86.6 105.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L146.7 256 41.4 361.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L192 301.3 297.4 406.6c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L237.3 256 342.6 150.6z"/></svg>',
  config: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M495.9 166.6c3.2 8.7 .5 18.4-6.4 24.6l-43.3 39.4c1.1 8.3 1.7 16.8 1.7 25.4s-.6 17.1-1.7 25.4l43.3 39.4c6.9 6.2 9.6 15.9 6.4 24.6c-4.4 11.9-9.7 23.3-15.8 34.3l-4.7 8.1c-6.6 11-14 21.4-22.1 31.2c-5.9 7.2-15.7 9.6-24.5 6.8l-55.7-17.7c-13.4 10.3-28.2 18.9-44 25.4l-12.5 57.1c-2 9.1-9 16.3-18.2 17.8c-13.8 2.3-28 3.5-42.5 3.5s-28.7-1.2-42.5-3.5c-9.2-1.5-16.2-8.7-18.2-17.8l-12.5-57.1c-15.8-6.5-30.6-15.1-44-25.4L83.1 425.9c-8.8 2.8-18.6 .3-24.5-6.8c-8.1-9.8-15.5-20.2-22.1-31.2l-4.7-8.1c-6.1-11-11.4-22.4-15.8-34.3c-3.2-8.7-.5-18.4 6.4-24.6l43.3-39.4C64.6 273.1 64 264.6 64 256s.6-17.1 1.7-25.4L22.4 191.2c-6.9-6.2-9.6-15.9-6.4-24.6c4.4-11.9 9.7-23.3 15.8-34.3l4.7-8.1c6.6-11 14-21.4 22.1-31.2c5.9-7.2 15.7-9.6 24.5-6.8l55.7 17.7c13.4-10.3 28.2-18.9 44-25.4l12.5-57.1c2-9.1 9-16.3 18.2-17.8C227.3 1.2 241.5 0 256 0s28.7 1.2 42.5 3.5c9.2 1.5 16.2 8.7 18.2 17.8l12.5 57.1c15.8 6.5 30.6 15.1 44 25.4l55.7-17.7c8.8-2.8 18.6-.3 24.5 6.8c8.1 9.8 15.5 20.2 22.1 31.2l4.7 8.1c6.1 11 11.4 22.4 15.8 34.3zM256 336a80 80 0 1 0 0-160 80 80 0 1 0 0 160z" fill="currentColor"/></svg>',
  headingup: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M32 96l512 0c17.7 0 32-14.3 32-32s-14.3-32-32-32L32 32C14.3 32 0 46.3 0 64S14.3 96 32 96zM9.4 233.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L96 237.3 96 448c0 17.7 14.3 32 32 32s32-14.3 32-32l0-210.7 41.4 41.4c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3l-96-96c-12.5-12.5-32.8-12.5-45.3 0l-96 96zm320 45.3c12.5 12.5 32.8 12.5 45.3 0L416 237.3 416 448c0 17.7 14.3 32 32 32s32-14.3 32-32l0-210.7 41.4 41.4c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3l-96-96c-12.5-12.5-32.8-12.5-45.3 0l-96 96c-12.5 12.5-12.5 32.8 0 45.3z" fill="currentColor"/></svg>',
  headingdown: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M544 416L32 416c-17.7 0-32 14.3-32 32s14.3 32 32 32l512 0c17.7 0 32-14.3 32-32s-14.3-32-32-32zm22.6-137.4c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L480 274.7 480 64c0-17.7-14.3-32-32-32s-32 14.3-32 32l0 210.7-41.4-41.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3l96 96c12.5 12.5 32.8 12.5 45.3 0l96-96zm-320-45.3c-12.5-12.5-32.8-12.5-45.3 0L160 274.7 160 64c0-17.7-14.3-32-32-32s-32 14.3-32 32l0 210.7L54.6 233.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3l96 96c12.5 12.5 32.8 12.5 45.3 0l96-96c12.5-12.5 12.5-32.8 0-45.3z" fill="currentColor"/></svg>',
  bold: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M0 64C0 46.3 14.3 32 32 32H80 96 224c70.7 0 128 57.3 128 128c0 31.3-11.3 60.1-30 82.3c37.1 22.4 62 63.1 62 109.7c0 70.7-57.3 128-128 128H96 80 32c-17.7 0-32-14.3-32-32s14.3-32 32-32H48V256 96H32C14.3 96 0 81.7 0 64zM224 224c35.3 0 64-28.7 64-64s-28.7-64-64-64H112V224H224zM112 288V416H256c35.3 0 64-28.7 64-64s-28.7-64-64-64H224 112z" fill="currentColor"/></svg>',
  italic: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M128 64c0-17.7 14.3-32 32-32H352c17.7 0 32 14.3 32 32s-14.3 32-32 32H293.3L160 416h64c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H90.7L224 96H160c-17.7 0-32-14.3-32-32z" fill="currentColor"/></svg>',
  strikethrough: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M161.3 144c3.2-17.2 14-30.1 33.7-38.6c21.1-9 51.8-12.3 88.6-6.5c11.9 1.9 48.8 9.1 60.1 12c17.1 4.5 34.6-5.6 39.2-22.7s-5.6-34.6-22.7-39.2c-14.3-3.8-53.6-11.4-66.6-13.4c-44.7-7-88.3-4.2-123.7 10.9c-36.5 15.6-64.4 44.8-71.8 87.3c-.1 .6-.2 1.1-.2 1.7c-2.8 23.9 .5 45.6 10.1 64.6c4.5 9 10.2 16.9 16.7 23.9H32c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H270.1c-.1 0-.3-.1-.4-.1l-1.1-.3c-36-10.8-65.2-19.6-85.2-33.1c-9.3-6.3-15-12.6-18.2-19.1c-3.1-6.1-5.2-14.6-3.8-27.4zM348.9 337.2c2.7 6.5 4.4 15.8 1.9 30.1c-3 17.6-13.8 30.8-33.9 39.4c-21.1 9-51.7 12.3-88.5 6.5c-18-2.9-49.1-13.5-74.4-22.1c-5.6-1.9-11-3.7-15.9-5.4c-16.8-5.6-34.9 3.5-40.5 20.3s3.5 34.9 20.3 40.5c3.6 1.2 7.9 2.7 12.7 4.3l0 0 0 0c24.9 8.5 63.6 21.7 87.6 25.6l0 0 .2 0c44.7 7 88.3 4.2 123.7-10.9c36.5-15.6 64.4-44.8 71.8-87.3c3.6-21 2.7-40.4-3.1-58.1H335.1c7 5.6 11.4 11.2 13.9 17.2z" fill="currentColor"/></svg>',
  link: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M579.8 267.7c56.5-56.5 56.5-148 0-204.5c-50-50-128.8-56.5-186.3-15.4l-1.6 1.1c-14.4 10.3-17.7 30.3-7.4 44.6s30.3 17.7 44.6 7.4l1.6-1.1c32.1-22.9 76-19.3 103.8 8.6c31.5 31.5 31.5 82.5 0 114L422.3 334.8c-31.5 31.5-82.5 31.5-114 0c-27.9-27.9-31.5-71.8-8.6-103.8l1.1-1.6c10.3-14.4 6.9-34.4-7.4-44.6s-34.4-6.9-44.6 7.4l-1.1 1.6C206.5 251.2 213 330 263 380c56.5 56.5 148 56.5 204.5 0L579.8 267.7zM60.2 244.3c-56.5 56.5-56.5 148 0 204.5c50 50 128.8 56.5 186.3 15.4l1.6-1.1c14.4-10.3 17.7-30.3 7.4-44.6s-30.3-17.7-44.6-7.4l-1.6 1.1c-32.1 22.9-76 19.3-103.8-8.6C74 372 74 321 105.5 289.5L217.7 177.2c31.5-31.5 82.5-31.5 114 0c27.9 27.9 31.5 71.8 8.6 103.9l-1.1 1.6c-10.3 14.4-6.9 34.4 7.4 44.6s34.4 6.9 44.6-7.4l1.1-1.6C433.5 260.8 427 182 377 132c-56.5-56.5-148-56.5-204.5 0L60.2 244.3z" fill="currentColor"/></svg>',
  line: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M432 256c0 17.7-14.3 32-32 32L48 288c-17.7 0-32-14.3-32-32s14.3-32 32-32l352 0c17.7 0 32 14.3 32 32z" fill="currentColor"/></svg>',
  listul: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M64 144a48 48 0 1 0 0-96 48 48 0 1 0 0 96zM192 64c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zm0 160c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zm0 160c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zM64 464a48 48 0 1 0 0-96 48 48 0 1 0 0 96zm48-208a48 48 0 1 0 -96 0 48 48 0 1 0 96 0z" fill="currentColor"/></svg>',
  listol: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M24 56c0-13.3 10.7-24 24-24H80c13.3 0 24 10.7 24 24V176h16c13.3 0 24 10.7 24 24s-10.7 24-24 24H40c-13.3 0-24-10.7-24-24s10.7-24 24-24H56V80H48C34.7 80 24 69.3 24 56zM86.7 341.2c-6.5-7.4-18.3-6.9-24 1.2L51.5 357.9c-7.7 10.8-22.7 13.3-33.5 5.6s-13.3-22.7-5.6-33.5l11.1-15.6c23.7-33.2 72.3-35.6 99.2-4.9c21.3 24.4 20.8 60.9-1.1 84.7L86.8 432H120c13.3 0 24 10.7 24 24s-10.7 24-24 24H32c-9.5 0-18.2-5.6-22-14.4s-2.1-18.9 4.3-25.9l72-78c5.3-5.8 5.4-14.6 .3-20.5zM224 64H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32zm0 160H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32zm0 160H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32z" fill="currentColor"/></svg>',
  listtask: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M152.1 38.2c9.9 8.9 10.7 24 1.8 33.9l-72 80c-4.4 4.9-10.6 7.8-17.2 7.9s-12.9-2.4-17.6-7L7 113C-2.3 103.6-2.3 88.4 7 79s24.6-9.4 33.9 0l22.1 22.1 55.1-61.2c8.9-9.9 24-10.7 33.9-1.8zm0 160c9.9 8.9 10.7 24 1.8 33.9l-72 80c-4.4 4.9-10.6 7.8-17.2 7.9s-12.9-2.4-17.6-7L7 273c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l22.1 22.1 55.1-61.2c8.9-9.9 24-10.7 33.9-1.8zM224 96c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H256c-17.7 0-32-14.3-32-32zm0 160c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H256c-17.7 0-32-14.3-32-32zM160 416c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H192c-17.7 0-32-14.3-32-32zM48 368a48 48 0 1 1 0 96 48 48 0 1 1 0-96z" fill="currentColor"/></svg>',
  code: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M392.8 1.2c-17-4.9-34.7 5-39.6 22l-128 448c-4.9 17 5 34.7 22 39.6s34.7-5 39.6-22l128-448c4.9-17-5-34.7-22-39.6zm80.6 120.1c-12.5 12.5-12.5 32.8 0 45.3L562.7 256l-89.4 89.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0l112-112c12.5-12.5 12.5-32.8 0-45.3l-112-112c-12.5-12.5-32.8-12.5-45.3 0zm-306.7 0c-12.5-12.5-32.8-12.5-45.3 0l-112 112c-12.5 12.5-12.5 32.8 0 45.3l112 112c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L77.3 256l89.4-89.4c12.5-12.5 12.5-32.8 0-45.3z" fill="currentColor"/></svg>',
  block: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M160 368c26.5 0 48 21.5 48 48v16l72.5-54.4c8.3-6.2 18.4-9.6 28.8-9.6H448c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H64c-8.8 0-16 7.2-16 16V352c0 8.8 7.2 16 16 16h96zm48 124l-.2 .2-5.1 3.8-17.1 12.8c-4.8 3.6-11.3 4.2-16.8 1.5s-8.8-8.2-8.8-14.3V474.7v-6.4V468v-4V416H112 64c-35.3 0-64-28.7-64-64V64C0 28.7 28.7 0 64 0H448c35.3 0 64 28.7 64 64V352c0 35.3-28.7 64-64 64H309.3L208 492z" fill="currentColor"/></svg>',
  math: '<svg style="width: 16px; height: 16px;"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M282.6 78.1c8-27.3 33-46.1 61.4-46.1H544c17.7 0 32 14.3 32 32s-14.3 32-32 32H344L238.7 457c-3.6 12.3-14.1 21.2-26.8 22.8s-25.1-4.6-31.5-15.6L77.6 288H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H77.6c22.8 0 43.8 12.1 55.3 31.8l65.2 111.8L282.6 78.1zM393.4 233.4c12.5-12.5 32.8-12.5 45.3 0L480 274.7l41.4-41.4c12.5-12.5 32.8-12.5 45.3 0s12.5 32.8 0 45.3L525.3 320l41.4 41.4c12.5 12.5 12.5 32.8 0 45.3s-32.8 12.5-45.3 0L480 365.3l-41.4 41.4c-12.5 12.5-32.8 12.5-45.3 0s-12.5-32.8 0-45.3L434.7 320l-41.4-41.4c-12.5-12.5-12.5-32.8 0-45.3z" fill="currentColor"/></svg>',
  editor: '<svg style="width: 16px; height: 16px;"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M288 64c0 17.7-14.3 32-32 32H32C14.3 96 0 81.7 0 64S14.3 32 32 32H256c17.7 0 32 14.3 32 32zm0 256c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H256c17.7 0 32 14.3 32 32zM0 192c0-17.7 14.3-32 32-32H416c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32zM448 448c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32z" fill="currentColor"/></svg>',
  viewer: '<svg style="width: 16px; height: 16px;"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M448 64c0 17.7-14.3 32-32 32H192c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32zm0 256c0 17.7-14.3 32-32 32H192c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32zM0 192c0-17.7 14.3-32 32-32H416c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32zM448 448c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32z" fill="currentColor"/></svg>',
  expand: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M200 32H56C42.7 32 32 42.7 32 56V200c0 9.7 5.8 18.5 14.8 22.2s19.3 1.7 26.2-5.2l40-40 79 79-79 79L73 295c-6.9-6.9-17.2-8.9-26.2-5.2S32 302.3 32 312V456c0 13.3 10.7 24 24 24H200c9.7 0 18.5-5.8 22.2-14.8s1.7-19.3-5.2-26.2l-40-40 79-79 79 79-40 40c-6.9 6.9-8.9 17.2-5.2 26.2s12.5 14.8 22.2 14.8H456c13.3 0 24-10.7 24-24V312c0-9.7-5.8-18.5-14.8-22.2s-19.3-1.7-26.2 5.2l-40 40-79-79 79-79 40 40c6.9 6.9 17.2 8.9 26.2 5.2s14.8-12.5 14.8-22.2V56c0-13.3-10.7-24-24-24H312c-9.7 0-18.5 5.8-22.2 14.8s-1.7 19.3 5.2 26.2l40 40-79 79-79-79 40-40c6.9-6.9 8.9-17.2 5.2-26.2S209.7 32 200 32z" fill="currentColor"/></svg>',
  info: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 192 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M48 80a48 48 0 1 1 96 0A48 48 0 1 1 48 80zM0 224c0-17.7 14.3-32 32-32H96c17.7 0 32 14.3 32 32V448h32c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H64V256H32c-17.7 0-32-14.3-32-32z" fill="currentColor"/></svg>',
  picture: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M0 96C0 60.7 28.7 32 64 32H448c35.3 0 64 28.7 64 64V416c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V96zM323.8 202.5c-4.5-6.6-11.9-10.5-19.8-10.5s-15.4 3.9-19.8 10.5l-87 127.6L170.7 297c-4.6-5.7-11.5-9-18.7-9s-14.2 3.3-18.7 9l-64 80c-5.8 7.2-6.9 17.1-2.9 25.4s12.4 13.6 21.6 13.6h96 32H424c8.9 0 17.1-4.9 21.2-12.8s3.6-17.4-1.4-24.7l-120-176zM112 192a48 48 0 1 0 0-96 48 48 0 1 0 0 96z" fill="currentColor"/></svg>',
  table: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M64 256V160H224v96H64zm0 64H224v96H64V320zm224 96V320H448v96H288zM448 256H288V160H448v96zM64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H448c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64z" fill="currentColor"/></svg>',
  quote: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M0 216C0 149.7 53.7 96 120 96h8c17.7 0 32 14.3 32 32s-14.3 32-32 32h-8c-30.9 0-56 25.1-56 56v8h64c35.3 0 64 28.7 64 64v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V320 288 216zm256 0c0-66.3 53.7-120 120-120h8c17.7 0 32 14.3 32 32s-14.3 32-32 32h-8c-30.9 0-56 25.1-56 56v8h64c35.3 0 64 28.7 64 64v64c0 35.3-28.7 64-64 64H320c-35.3 0-64-28.7-64-64V320 288 216z" fill="currentColor"/></svg>',
  help: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M80 160c0-35.3 28.7-64 64-64h32c35.3 0 64 28.7 64 64v3.6c0 21.8-11.1 42.1-29.4 53.8l-42.2 27.1c-25.2 16.2-40.4 44.1-40.4 74V320c0 17.7 14.3 32 32 32s32-14.3 32-32v-1.4c0-8.2 4.2-15.8 11-20.2l42.2-27.1c36.6-23.6 58.8-64.1 58.8-107.7V160c0-70.7-57.3-128-128-128H144C73.3 32 16 89.3 16 160c0 17.7 14.3 32 32 32s32-14.3 32-32zm80 320a40 40 0 1 0 0-80 40 40 0 1 0 0 80z" fill="currentColor"/></svg>',
  github: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 496 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M165.9 397.4c0 2-2.3 3.6-5.2 3.6-3.3 .3-5.6-1.3-5.6-3.6 0-2 2.3-3.6 5.2-3.6 3-.3 5.6 1.3 5.6 3.6zm-31.1-4.5c-.7 2 1.3 4.3 4.3 4.9 2.6 1 5.6 0 6.2-2s-1.3-4.3-4.3-5.2c-2.6-.7-5.5 .3-6.2 2.3zm44.2-1.7c-2.9 .7-4.9 2.6-4.6 4.9 .3 2 2.9 3.3 5.9 2.6 2.9-.7 4.9-2.6 4.6-4.6-.3-1.9-3-3.2-5.9-2.9zM244.8 8C106.1 8 0 113.3 0 252c0 110.9 69.8 205.8 169.5 239.2 12.8 2.3 17.3-5.6 17.3-12.1 0-6.2-.3-40.4-.3-61.4 0 0-70 15-84.7-29.8 0 0-11.4-29.1-27.8-36.6 0 0-22.9-15.7 1.6-15.4 0 0 24.9 2 38.6 25.8 21.9 38.6 58.6 27.5 72.9 20.9 2.3-16 8.8-27.1 16-33.7-55.9-6.2-112.3-14.3-112.3-110.5 0-27.5 7.6-41.3 23.6-58.9-2.6-6.5-11.1-33.3 2.6-67.9 20.9-6.5 69 27 69 27 20-5.6 41.5-8.5 62.8-8.5s42.8 2.9 62.8 8.5c0 0 48.1-33.6 69-27 13.7 34.7 5.2 61.4 2.6 67.9 16 17.7 25.8 31.5 25.8 58.9 0 96.5-58.9 104.2-114.8 110.5 9.2 7.9 17 22.9 17 46.4 0 33.7-.3 75.4-.3 83.6 0 6.5 4.6 14.4 17.3 12.1C428.2 457.8 496 362.9 496 252 496 113.3 383.5 8 244.8 8zM97.2 352.9c-1.3 1-1 3.3 .7 5.2 1.6 1.6 3.9 2.3 5.2 1 1.3-1 1-3.3-.7-5.2-1.6-1.6-3.9-2.3-5.2-1zm-10.8-8.1c-.7 1.3 .3 2.9 2.3 3.9 1.6 1 3.6 .7 4.3-.7 .7-1.3-.3-2.9-2.3-3.9-2-.6-3.6-.3-4.3 .7zm32.4 35.6c-1.6 1.3-1 4.3 1.3 6.2 2.3 2.3 5.2 2.6 6.5 1 1.3-1.3 .7-4.3-1.3-6.2-2.2-2.3-5.2-2.6-6.5-1zm-11.4-14.7c-1.6 1-1.6 3.6 0 5.9 1.6 2.3 4.3 3.3 5.6 2.3 1.6-1.3 1.6-3.9 0-6.2-1.4-2.3-4-3.3-5.6-2z" fill="currentColor"/></svg>'
}, q$ = { class: "cs-dialog-header" }, W$ = ["innerHTML"], Jo = /* @__PURE__ */ Pt({
  __name: "MDialog",
  emits: ["close"],
  setup(n, { emit: e }) {
    const t = e, i = Se(void 0);
    function r(s) {
      i.value && !i.value.contains(s.target) && t("close");
    }
    return (s, o) => (fe(), Ae("div", {
      class: "cs-dialog-container",
      onClick: r
    }, [
      D("div", {
        class: "cs-dialog",
        ref_key: "dialog",
        ref: i
      }, [
        D("div", q$, [
          cr(s.$slots, "header"),
          D("div", {
            class: "cs-close-container",
            onClick: o[0] || (o[0] = (l) => t("close")),
            innerHTML: xr(Ze).xmark
          }, null, 8, W$)
        ]),
        cr(s.$slots, "default")
      ], 512)
    ]));
  }
}), B$ = { class: "cs-dialog-item" }, V$ = /* @__PURE__ */ D("div", { class: "cs-dialog-item-label" }, " 选择语言 ", -1), Y$ = ["value"], j$ = { class: "cs-dialog-item" }, N$ = /* @__PURE__ */ D("div", {
  class: "cs-dialog-item-label",
  style: { "min-height": "50vh" }
}, " 代码 ", -1), U$ = { class: "cs-dialog-submit-area" }, F$ = /* @__PURE__ */ Pt({
  __name: "ToolCode",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      Gt(null, e.container);
    }
    const i = Se(""), r = Se(""), s = [
      { value: "cpp", name: "C++" },
      { value: "pascal", name: "Pascal" },
      { value: "c", name: "C" },
      { value: "javascript", name: "Javascript" },
      { value: "java", name: "Java" },
      { value: "markdown", name: "Markdown" },
      { value: "latex", name: "LaTeX" }
    ];
    return (o, l) => (fe(), ei(Jo, { onClose: t }, {
      header: Rt(() => [
        Wr(" 插入代码 ")
      ]),
      default: Rt(() => [
        D("div", null, [
          D("div", B$, [
            V$,
            sn(D("select", {
              "onUpdate:modelValue": l[0] || (l[0] = (a) => i.value = a),
              class: "cs-dialog-item-content"
            }, [
              (fe(), Ae(Bn, null, Vn(s, (a) => D("option", {
                key: a.value,
                value: a.value
              }, wi(a.name), 9, Y$)), 64))
            ], 512), [
              [I0, i.value]
            ])
          ]),
          D("div", j$, [
            N$,
            sn(D("textarea", {
              class: "cs-dialog-item-content",
              "onUpdate:modelValue": l[1] || (l[1] = (a) => r.value = a)
            }, null, 512), [
              [wn, r.value]
            ])
          ]),
          D("div", U$, [
            D("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, "取消"),
            D("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: l[2] || (l[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, "确认")
          ])
        ])
      ]),
      _: 1
    }));
  }
}), G$ = { class: "cs-dialog-item" }, H$ = /* @__PURE__ */ D("div", { class: "cs-dialog-item-label" }, " 图片地址 ", -1), K$ = { class: "cs-dialog-item" }, J$ = /* @__PURE__ */ D("div", { class: "cs-dialog-item-label" }, " 图片介绍 ", -1), eC = /* @__PURE__ */ D("div", { class: "cs-dialog-item" }, [
  /* @__PURE__ */ D("div", { class: "cs-dialog-upload" }, " 上传图片 ")
], -1), tC = { class: "cs-dialog-submit-area" }, nC = /* @__PURE__ */ Pt({
  __name: "ToolPicture",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      Gt(null, e.container);
    }
    const i = Se(""), r = Se("");
    return (s, o) => (fe(), ei(Jo, { onClose: t }, {
      header: Rt(() => [
        Wr(" 插入图片 ")
      ]),
      default: Rt(() => [
        D("div", null, [
          D("div", G$, [
            H$,
            sn(D("input", {
              type: "text",
              "onUpdate:modelValue": o[0] || (o[0] = (l) => i.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [wn, i.value]
            ])
          ]),
          D("div", K$, [
            J$,
            sn(D("input", {
              type: "text",
              "onUpdate:modelValue": o[1] || (o[1] = (l) => r.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [wn, r.value]
            ])
          ]),
          eC,
          D("div", tC, [
            D("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, "取消"),
            D("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: o[2] || (o[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, "确认")
          ])
        ])
      ]),
      _: 1
    }));
  }
}), iC = { class: "cs-dialog-container" }, rC = { class: "cs-dialog-sidebar" }, sC = { class: "cs-dialog-header" }, oC = ["innerHTML"], lC = { class: "cs-dialog-view" }, aC = /* @__PURE__ */ Pt({
  __name: "MDialogExtra",
  emits: ["close"],
  setup(n, { emit: e }) {
    const t = e, i = Se(void 0);
    return (r, s) => (fe(), Ae("div", iC, [
      D("div", {
        class: "cs-dialog cs-dialog-big",
        ref_key: "dialog",
        ref: i
      }, [
        D("div", rC, [
          D("div", sC, [
            cr(r.$slots, "header"),
            D("div", {
              class: "cs-close-container",
              onClick: s[0] || (s[0] = (o) => t("close")),
              innerHTML: xr(Ze).xmark
            }, null, 8, oC)
          ]),
          cr(r.$slots, "default")
        ]),
        D("div", lC, [
          cr(r.$slots, "view")
        ])
      ], 512)
    ]));
  }
}), hC = { class: "cs-dialog-item" }, uC = /* @__PURE__ */ D("div", { class: "cs-dialog-item-label" }, " 行数 ", -1), cC = { class: "cs-dialog-item" }, fC = /* @__PURE__ */ D("div", { class: "cs-dialog-item-label" }, " 列数 ", -1), dC = { class: "cs-dialog-area" }, pC = /* @__PURE__ */ D("h3", null, "编辑区", -1), mC = { class: "submit-area" }, OC = { class: "cs-dialog-table-editor" }, gC = ["data-x", "data-y"], bC = /* @__PURE__ */ Pt({
  __name: "ToolTable",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      Gt(null, e.container);
    }
    const i = Se(1), r = Se(1), s = Se([NaN, NaN]), o = Se([NaN, NaN]), l = Se(""), a = Se(!1), h = Se([[""]]);
    function u() {
      for (i.value = Math.max(1, i.value), r.value = Math.max(1, r.value), i.value = Math.min(100, i.value), r.value = Math.min(100, r.value); h.value.length < i.value; )
        h.value.push([]);
      for (; h.value.length > i.value; )
        h.value.pop();
      for (let O of h.value) {
        for (; O.length < r.value; )
          O.push("");
        for (; O.length > r.value; )
          O.pop();
      }
    }
    function c(O, g) {
      return s.value[0] <= O && O <= o.value[0] && s.value[1] <= g && g <= o.value[1];
    }
    function f(O) {
      if (O.target) {
        a.value = !1;
        const g = Number.parseInt(O.target.dataset.x || "-1"), b = Number.parseInt(O.target.dataset.y || "-1");
        s.value = o.value = [g, b];
      }
    }
    function d(O) {
      if (!a.value && !Number.isNaN(s.value[0]) && O.target) {
        const g = Number.parseInt(O.target.dataset.x || "-1"), b = Number.parseInt(O.target.dataset.y || "-1");
        o.value = [g, b];
      }
    }
    function p(O) {
      a.value = !0;
    }
    function m() {
      let [O, g] = s.value, [b, S] = o.value;
      if (0 <= O && O < i.value && 0 <= b && b < i.value && 0 <= g && g < r.value && 0 <= S && S < r.value)
        for (let Q = O; Q <= b; Q++)
          for (let P = g; P <= S; P++)
            h.value[Q][P] = l.value;
    }
    return mt(i, u), mt(r, u), (O, g) => (fe(), ei(aC, { onClose: t }, {
      header: Rt(() => [
        Wr(" 插入表格 ")
      ]),
      view: Rt(() => [
        D("table", OC, [
          D("tbody", null, [
            (fe(!0), Ae(Bn, null, Vn(Object.entries(h.value), ([b, S]) => (fe(), Ae("tr", null, [
              (fe(!0), Ae(Bn, null, Vn(Object.entries(S), ([Q, P]) => (fe(), Ae("td", {
                "data-x": b,
                "data-y": Q,
                class: Es({ selected: c(Number.parseInt(b), Number.parseInt(Q)) }),
                onMousedown: f,
                onMouseenter: d,
                onMouseup: p
              }, wi(P) + "  ", 43, gC))), 256))
            ]))), 256))
          ])
        ])
      ]),
      default: Rt(() => [
        D("div", hC, [
          uC,
          sn(D("input", {
            type: "number",
            "onUpdate:modelValue": g[0] || (g[0] = (b) => i.value = b),
            class: "cs-dialog-item-content",
            min: "1",
            max: "100"
          }, null, 512), [
            [wn, i.value]
          ])
        ]),
        D("div", cC, [
          fC,
          sn(D("input", {
            type: "number",
            "onUpdate:modelValue": g[1] || (g[1] = (b) => r.value = b),
            class: "cs-dialog-item-content",
            min: "1",
            max: "100"
          }, null, 512), [
            [wn, r.value]
          ])
        ]),
        D("div", { class: "cs-dialog-item" }, [
          D("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: m
          }, "修改")
        ]),
        D("div", dC, [
          pC,
          sn(D("textarea", {
            "onUpdate:modelValue": g[2] || (g[2] = (b) => l.value = b)
          }, null, 512), [
            [wn, l.value]
          ])
        ]),
        D("div", mC, [
          D("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: t
          }, "取消"),
          D("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: g[3] || (g[3] = () => {
              O.confirm(i.value, r.value, h.value), t();
            })
          }, "确认")
        ])
      ]),
      _: 1
    }));
  }
}), yC = { class: "cs-dialog-item" }, kC = /* @__PURE__ */ D("div", { class: "cs-dialog-item-label" }, " 链接地址 ", -1), xC = { class: "cs-dialog-item" }, wC = /* @__PURE__ */ D("div", { class: "cs-dialog-item-label" }, " 链接介绍 ", -1), SC = { class: "submit-area" }, vC = /* @__PURE__ */ Pt({
  __name: "ToolLink",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      Gt(null, e.container);
    }
    const i = Se(""), r = Se("");
    return (s, o) => (fe(), ei(Jo, { onClose: t }, {
      header: Rt(() => [
        Wr(" 插入链接 ")
      ]),
      default: Rt(() => [
        D("div", null, [
          D("div", yC, [
            kC,
            sn(D("input", {
              type: "text",
              "onUpdate:modelValue": o[0] || (o[0] = (l) => i.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [wn, i.value]
            ])
          ]),
          D("div", xC, [
            wC,
            sn(D("input", {
              type: "text",
              "onUpdate:modelValue": o[1] || (o[1] = (l) => r.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [wn, r.value]
            ])
          ]),
          D("div", SC, [
            D("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, "取消"),
            D("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: o[2] || (o[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, "确认")
          ])
        ])
      ]),
      _: 1
    }));
  }
}), PC = /* @__PURE__ */ D("div", null, [
  /* @__PURE__ */ D("h2", null, "Todo"),
  /* @__PURE__ */ D("ul", null, [
    /* @__PURE__ */ D("li", null, "快捷方式（比如按 Ctrl+B 自动将选中范围加粗）；"),
    /* @__PURE__ */ D("li", null, "研究一下手机适配；"),
    /* @__PURE__ */ D("li", null, "修可能存在的 bug。")
  ])
], -1), QC = /* @__PURE__ */ Pt({
  __name: "ToolHelp",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      Gt(null, e.container);
    }
    return (i, r) => (fe(), ei(Jo, { onClose: t }, {
      header: Rt(() => [
        Wr(" 帮助手册我还没写 ")
      ]),
      default: Rt(() => [
        PC
      ]),
      _: 1
    }));
  }
});
class vo {
  static create(e, t, i, r, s) {
    let o = r + (r << 8) + e + (t << 4) | 0;
    return new vo(e, t, i, o, s, [], []);
  }
  constructor(e, t, i, r, s, o, l) {
    this.type = e, this.value = t, this.from = i, this.hash = r, this.end = s, this.children = o, this.positions = l, this.hashProp = [[F.contextHash, r]];
  }
  addChild(e, t) {
    e.prop(F.contextHash) != this.hash && (e = new ae(e.type, e.children, e.positions, e.length, this.hashProp)), this.children.push(e), this.positions.push(t);
  }
  toTree(e, t = this.end) {
    let i = this.children.length - 1;
    return i >= 0 && (t = Math.max(t, this.positions[i] + this.children[i].length + this.from)), new ae(e.types[this.type], this.children, this.positions, t - this.from).balance({
      makeTree: (r, s, o) => new ae(ze.none, r, s, o, this.hashProp)
    });
  }
}
var M;
(function(n) {
  n[n.Document = 1] = "Document", n[n.CodeBlock = 2] = "CodeBlock", n[n.FencedCode = 3] = "FencedCode", n[n.Blockquote = 4] = "Blockquote", n[n.HorizontalRule = 5] = "HorizontalRule", n[n.BulletList = 6] = "BulletList", n[n.OrderedList = 7] = "OrderedList", n[n.ListItem = 8] = "ListItem", n[n.ATXHeading1 = 9] = "ATXHeading1", n[n.ATXHeading2 = 10] = "ATXHeading2", n[n.ATXHeading3 = 11] = "ATXHeading3", n[n.ATXHeading4 = 12] = "ATXHeading4", n[n.ATXHeading5 = 13] = "ATXHeading5", n[n.ATXHeading6 = 14] = "ATXHeading6", n[n.SetextHeading1 = 15] = "SetextHeading1", n[n.SetextHeading2 = 16] = "SetextHeading2", n[n.HTMLBlock = 17] = "HTMLBlock", n[n.LinkReference = 18] = "LinkReference", n[n.Paragraph = 19] = "Paragraph", n[n.CommentBlock = 20] = "CommentBlock", n[n.ProcessingInstructionBlock = 21] = "ProcessingInstructionBlock", n[n.Escape = 22] = "Escape", n[n.Entity = 23] = "Entity", n[n.HardBreak = 24] = "HardBreak", n[n.Emphasis = 25] = "Emphasis", n[n.StrongEmphasis = 26] = "StrongEmphasis", n[n.Link = 27] = "Link", n[n.Image = 28] = "Image", n[n.InlineCode = 29] = "InlineCode", n[n.HTMLTag = 30] = "HTMLTag", n[n.Comment = 31] = "Comment", n[n.ProcessingInstruction = 32] = "ProcessingInstruction", n[n.Autolink = 33] = "Autolink", n[n.HeaderMark = 34] = "HeaderMark", n[n.QuoteMark = 35] = "QuoteMark", n[n.ListMark = 36] = "ListMark", n[n.LinkMark = 37] = "LinkMark", n[n.EmphasisMark = 38] = "EmphasisMark", n[n.CodeMark = 39] = "CodeMark", n[n.CodeText = 40] = "CodeText", n[n.CodeInfo = 41] = "CodeInfo", n[n.LinkTitle = 42] = "LinkTitle", n[n.LinkLabel = 43] = "LinkLabel", n[n.URL = 44] = "URL";
})(M || (M = {}));
class $C {
  /// @internal
  constructor(e, t) {
    this.start = e, this.content = t, this.marks = [], this.parsers = [];
  }
}
class CC {
  constructor() {
    this.text = "", this.baseIndent = 0, this.basePos = 0, this.depth = 0, this.markers = [], this.pos = 0, this.indent = 0, this.next = -1;
  }
  /// @internal
  forward() {
    this.basePos > this.pos && this.forwardInner();
  }
  /// @internal
  forwardInner() {
    let e = this.skipSpace(this.basePos);
    this.indent = this.countIndent(e, this.pos, this.indent), this.pos = e, this.next = e == this.text.length ? -1 : this.text.charCodeAt(e);
  }
  /// Skip whitespace after the given position, return the position of
  /// the next non-space character or the end of the line if there's
  /// only space after `from`.
  skipSpace(e) {
    return br(this.text, e);
  }
  /// @internal
  reset(e) {
    for (this.text = e, this.baseIndent = this.basePos = this.pos = this.indent = 0, this.forwardInner(), this.depth = 1; this.markers.length; )
      this.markers.pop();
  }
  /// Move the line's base position forward to the given position.
  /// This should only be called by composite [block
  /// parsers](#BlockParser.parse) or [markup skipping
  /// functions](#NodeSpec.composite).
  moveBase(e) {
    this.basePos = e, this.baseIndent = this.countIndent(e, this.pos, this.indent);
  }
  /// Move the line's base position forward to the given _column_.
  moveBaseColumn(e) {
    this.baseIndent = e, this.basePos = this.findColumn(e);
  }
  /// Store a composite-block-level marker. Should be called from
  /// [markup skipping functions](#NodeSpec.composite) when they
  /// consume any non-whitespace characters.
  addMarker(e) {
    this.markers.push(e);
  }
  /// Find the column position at `to`, optionally starting at a given
  /// position and column.
  countIndent(e, t = 0, i = 0) {
    for (let r = t; r < e; r++)
      i += this.text.charCodeAt(r) == 9 ? 4 - i % 4 : 1;
    return i;
  }
  /// Find the position corresponding to the given column.
  findColumn(e) {
    let t = 0;
    for (let i = 0; t < this.text.length && i < e; t++)
      i += this.text.charCodeAt(t) == 9 ? 4 - i % 4 : 1;
    return t;
  }
  /// @internal
  scrub() {
    if (!this.baseIndent)
      return this.text;
    let e = "";
    for (let t = 0; t < this.basePos; t++)
      e += " ";
    return e + this.text.slice(this.basePos);
  }
}
function qf(n, e, t) {
  if (t.pos == t.text.length || n != e.block && t.indent >= e.stack[t.depth + 1].value + t.baseIndent)
    return !0;
  if (t.indent >= t.baseIndent + 4)
    return !1;
  let i = (n.type == M.OrderedList ? du : fu)(t, e, !1);
  return i > 0 && (n.type != M.BulletList || cu(t, e, !1) < 0) && t.text.charCodeAt(t.pos + i - 1) == n.value;
}
const Vg = {
  [M.Blockquote](n, e, t) {
    return t.next != 62 ? !1 : (t.markers.push(ie(M.QuoteMark, e.lineStart + t.pos, e.lineStart + t.pos + 1)), t.moveBase(t.pos + ($t(t.text.charCodeAt(t.pos + 1)) ? 2 : 1)), n.end = e.lineStart + t.text.length, !0);
  },
  [M.ListItem](n, e, t) {
    return t.indent < t.baseIndent + n.value && t.next > -1 ? !1 : (t.moveBaseColumn(t.baseIndent + n.value), !0);
  },
  [M.OrderedList]: qf,
  [M.BulletList]: qf,
  [M.Document]() {
    return !0;
  }
};
function $t(n) {
  return n == 32 || n == 9 || n == 10 || n == 13;
}
function br(n, e = 0) {
  for (; e < n.length && $t(n.charCodeAt(e)); )
    e++;
  return e;
}
function Wf(n, e, t) {
  for (; e > t && $t(n.charCodeAt(e - 1)); )
    e--;
  return e;
}
function Yg(n) {
  if (n.next != 96 && n.next != 126)
    return -1;
  let e = n.pos + 1;
  for (; e < n.text.length && n.text.charCodeAt(e) == n.next; )
    e++;
  if (e < n.pos + 3)
    return -1;
  if (n.next == 96) {
    for (let t = e; t < n.text.length; t++)
      if (n.text.charCodeAt(t) == 96)
        return -1;
  }
  return e;
}
function jg(n) {
  return n.next != 62 ? -1 : n.text.charCodeAt(n.pos + 1) == 32 ? 2 : 1;
}
function cu(n, e, t) {
  if (n.next != 42 && n.next != 45 && n.next != 95)
    return -1;
  let i = 1;
  for (let r = n.pos + 1; r < n.text.length; r++) {
    let s = n.text.charCodeAt(r);
    if (s == n.next)
      i++;
    else if (!$t(s))
      return -1;
  }
  return t && n.next == 45 && Fg(n) > -1 && n.depth == e.stack.length || i < 3 ? -1 : 1;
}
function Ng(n, e) {
  for (let t = n.stack.length - 1; t >= 0; t--)
    if (n.stack[t].type == e)
      return !0;
  return !1;
}
function fu(n, e, t) {
  return (n.next == 45 || n.next == 43 || n.next == 42) && (n.pos == n.text.length - 1 || $t(n.text.charCodeAt(n.pos + 1))) && (!t || Ng(e, M.BulletList) || n.skipSpace(n.pos + 2) < n.text.length) ? 1 : -1;
}
function du(n, e, t) {
  let i = n.pos, r = n.next;
  for (; r >= 48 && r <= 57; ) {
    i++;
    if (i == n.text.length)
      return -1;
    r = n.text.charCodeAt(i);
  }
  return i == n.pos || i > n.pos + 9 || r != 46 && r != 41 || i < n.text.length - 1 && !$t(n.text.charCodeAt(i + 1)) || t && !Ng(e, M.OrderedList) && (n.skipSpace(i + 1) == n.text.length || i > n.pos + 1 || n.next != 49) ? -1 : i + 1 - n.pos;
}
function Ug(n) {
  if (n.next != 35)
    return -1;
  let e = n.pos + 1;
  for (; e < n.text.length && n.text.charCodeAt(e) == 35; )
    e++;
  if (e < n.text.length && n.text.charCodeAt(e) != 32)
    return -1;
  let t = e - n.pos;
  return t > 6 ? -1 : t;
}
function Fg(n) {
  if (n.next != 45 && n.next != 61 || n.indent >= n.baseIndent + 4)
    return -1;
  let e = n.pos + 1;
  for (; e < n.text.length && n.text.charCodeAt(e) == n.next; )
    e++;
  let t = e;
  for (; e < n.text.length && $t(n.text.charCodeAt(e)); )
    e++;
  return e == n.text.length ? t : -1;
}
const ih = /^[ \t]*$/, Gg = /-->/, Hg = /\?>/, rh = [
  [/^<(?:script|pre|style)(?:\s|>|$)/i, /<\/(?:script|pre|style)>/i],
  [/^\s*<!--/, Gg],
  [/^\s*<\?/, Hg],
  [/^\s*<![A-Z]/, />/],
  [/^\s*<!\[CDATA\[/, /\]\]>/],
  [/^\s*<\/?(?:address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h1|h2|h3|h4|h5|h6|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul)(?:\s|\/?>|$)/i, ih],
  [/^\s*(?:<\/[a-z][\w-]*\s*>|<[a-z][\w-]*(\s+[a-z:_][\w-.]*(?:\s*=\s*(?:[^\s"'=<>`]+|'[^']*'|"[^"]*"))?)*\s*>)\s*$/i, ih]
];
function Kg(n, e, t) {
  if (n.next != 60)
    return -1;
  let i = n.text.slice(n.pos);
  for (let r = 0, s = rh.length - (t ? 1 : 0); r < s; r++)
    if (rh[r][0].test(i))
      return r;
  return -1;
}
function Bf(n, e) {
  let t = n.countIndent(e, n.pos, n.indent), i = n.countIndent(n.skipSpace(e), e, t);
  return i >= t + 5 ? t + 1 : i;
}
function In(n, e, t) {
  let i = n.length - 1;
  i >= 0 && n[i].to == e && n[i].type == M.CodeText ? n[i].to = t : n.push(ie(M.CodeText, e, t));
}
const Qs = {
  LinkReference: void 0,
  IndentedCode(n, e) {
    let t = e.baseIndent + 4;
    if (e.indent < t)
      return !1;
    let i = e.findColumn(t), r = n.lineStart + i, s = n.lineStart + e.text.length, o = [], l = [];
    for (In(o, r, s); n.nextLine() && e.depth >= n.stack.length; )
      if (e.pos == e.text.length) {
        In(l, n.lineStart - 1, n.lineStart);
        for (let a of e.markers)
          l.push(a);
      } else {
        if (e.indent < t)
          break;
        {
          if (l.length) {
            for (let h of l)
              h.type == M.CodeText ? In(o, h.from, h.to) : o.push(h);
            l = [];
          }
          In(o, n.lineStart - 1, n.lineStart);
          for (let h of e.markers)
            o.push(h);
          s = n.lineStart + e.text.length;
          let a = n.lineStart + e.findColumn(e.baseIndent + 4);
          a < s && In(o, a, s);
        }
      }
    return l.length && (l = l.filter((a) => a.type != M.CodeText), l.length && (e.markers = l.concat(e.markers))), n.addNode(n.buffer.writeElements(o, -r).finish(M.CodeBlock, s - r), r), !0;
  },
  FencedCode(n, e) {
    let t = Yg(e);
    if (t < 0)
      return !1;
    let i = n.lineStart + e.pos, r = e.next, s = t - e.pos, o = e.skipSpace(t), l = Wf(e.text, e.text.length, o), a = [ie(M.CodeMark, i, i + s)];
    o < l && a.push(ie(M.CodeInfo, n.lineStart + o, n.lineStart + l));
    for (let h = !0; n.nextLine() && e.depth >= n.stack.length; h = !1) {
      let u = e.pos;
      if (e.indent - e.baseIndent < 4)
        for (; u < e.text.length && e.text.charCodeAt(u) == r; )
          u++;
      if (u - e.pos >= s && e.skipSpace(u) == e.text.length) {
        for (let c of e.markers)
          a.push(c);
        a.push(ie(M.CodeMark, n.lineStart + e.pos, n.lineStart + u)), n.nextLine();
        break;
      } else {
        h || In(a, n.lineStart - 1, n.lineStart);
        for (let d of e.markers)
          a.push(d);
        let c = n.lineStart + e.basePos, f = n.lineStart + e.text.length;
        c < f && In(a, c, f);
      }
    }
    return n.addNode(n.buffer.writeElements(a, -i).finish(M.FencedCode, n.prevLineEnd() - i), i), !0;
  },
  Blockquote(n, e) {
    let t = jg(e);
    return t < 0 ? !1 : (n.startContext(M.Blockquote, e.pos), n.addNode(M.QuoteMark, n.lineStart + e.pos, n.lineStart + e.pos + 1), e.moveBase(e.pos + t), null);
  },
  HorizontalRule(n, e) {
    if (cu(e, n, !1) < 0)
      return !1;
    let t = n.lineStart + e.pos;
    return n.nextLine(), n.addNode(M.HorizontalRule, t), !0;
  },
  BulletList(n, e) {
    let t = fu(e, n, !1);
    if (t < 0)
      return !1;
    n.block.type != M.BulletList && n.startContext(M.BulletList, e.basePos, e.next);
    let i = Bf(e, e.pos + 1);
    return n.startContext(M.ListItem, e.basePos, i - e.baseIndent), n.addNode(M.ListMark, n.lineStart + e.pos, n.lineStart + e.pos + t), e.moveBaseColumn(i), null;
  },
  OrderedList(n, e) {
    let t = du(e, n, !1);
    if (t < 0)
      return !1;
    n.block.type != M.OrderedList && n.startContext(M.OrderedList, e.basePos, e.text.charCodeAt(e.pos + t - 1));
    let i = Bf(e, e.pos + t);
    return n.startContext(M.ListItem, e.basePos, i - e.baseIndent), n.addNode(M.ListMark, n.lineStart + e.pos, n.lineStart + e.pos + t), e.moveBaseColumn(i), null;
  },
  ATXHeading(n, e) {
    let t = Ug(e);
    if (t < 0)
      return !1;
    let i = e.pos, r = n.lineStart + i, s = Wf(e.text, e.text.length, i), o = s;
    for (; o > i && e.text.charCodeAt(o - 1) == e.next; )
      o--;
    (o == s || o == i || !$t(e.text.charCodeAt(o - 1))) && (o = e.text.length);
    let l = n.buffer.write(M.HeaderMark, 0, t).writeElements(n.parser.parseInline(e.text.slice(i + t + 1, o), r + t + 1), -r);
    o < e.text.length && l.write(M.HeaderMark, o - i, s - i);
    let a = l.finish(M.ATXHeading1 - 1 + t, e.text.length - i);
    return n.nextLine(), n.addNode(a, r), !0;
  },
  HTMLBlock(n, e) {
    let t = Kg(e, n, !1);
    if (t < 0)
      return !1;
    let i = n.lineStart + e.pos, r = rh[t][1], s = [], o = r != ih;
    for (; !r.test(e.text) && n.nextLine(); ) {
      if (e.depth < n.stack.length) {
        o = !1;
        break;
      }
      for (let h of e.markers)
        s.push(h);
    }
    o && n.nextLine();
    let l = r == Gg ? M.CommentBlock : r == Hg ? M.ProcessingInstructionBlock : M.HTMLBlock, a = n.prevLineEnd();
    return n.addNode(n.buffer.writeElements(s, -i).finish(l, a - i), i), !0;
  },
  SetextHeading: void 0
  // Specifies relative precedence for block-continue function
};
class TC {
  constructor(e) {
    this.stage = 0, this.elts = [], this.pos = 0, this.start = e.start, this.advance(e.content);
  }
  nextLine(e, t, i) {
    if (this.stage == -1)
      return !1;
    let r = i.content + `
` + t.scrub(), s = this.advance(r);
    return s > -1 && s < r.length ? this.complete(e, i, s) : !1;
  }
  finish(e, t) {
    return (this.stage == 2 || this.stage == 3) && br(t.content, this.pos) == t.content.length ? this.complete(e, t, t.content.length) : !1;
  }
  complete(e, t, i) {
    return e.addLeafElement(t, ie(M.LinkReference, this.start, this.start + i, this.elts)), !0;
  }
  nextStage(e) {
    return e ? (this.pos = e.to - this.start, this.elts.push(e), this.stage++, !0) : (e === !1 && (this.stage = -1), !1);
  }
  advance(e) {
    for (; ; ) {
      if (this.stage == -1)
        return -1;
      if (this.stage == 0) {
        if (!this.nextStage(l1(e, this.pos, this.start, !0)))
          return -1;
        if (e.charCodeAt(this.pos) != 58)
          return this.stage = -1;
        this.elts.push(ie(M.LinkMark, this.pos + this.start, this.pos + this.start + 1)), this.pos++;
      } else if (this.stage == 1) {
        if (!this.nextStage(s1(e, br(e, this.pos), this.start)))
          return -1;
      } else if (this.stage == 2) {
        let t = br(e, this.pos), i = 0;
        if (t > this.pos) {
          let r = o1(e, t, this.start);
          if (r) {
            let s = Ml(e, r.to - this.start);
            s > 0 && (this.nextStage(r), i = s);
          }
        }
        return i || (i = Ml(e, this.pos)), i > 0 && i < e.length ? i : -1;
      } else
        return Ml(e, this.pos);
    }
  }
}
function Ml(n, e) {
  for (; e < n.length; e++) {
    let t = n.charCodeAt(e);
    if (t == 10)
      break;
    if (!$t(t))
      return -1;
  }
  return e;
}
class AC {
  nextLine(e, t, i) {
    let r = t.depth < e.stack.length ? -1 : Fg(t), s = t.next;
    if (r < 0)
      return !1;
    let o = ie(M.HeaderMark, e.lineStart + t.pos, e.lineStart + r);
    return e.nextLine(), e.addLeafElement(i, ie(s == 61 ? M.SetextHeading1 : M.SetextHeading2, i.start, e.prevLineEnd(), [
      ...e.parser.parseInline(i.content, i.start),
      o
    ])), !0;
  }
  finish() {
    return !1;
  }
}
const RC = {
  LinkReference(n, e) {
    return e.content.charCodeAt(0) == 91 ? new TC(e) : null;
  },
  SetextHeading() {
    return new AC();
  }
}, ZC = [
  (n, e) => Ug(e) >= 0,
  (n, e) => Yg(e) >= 0,
  (n, e) => jg(e) >= 0,
  (n, e) => fu(e, n, !0) >= 0,
  (n, e) => du(e, n, !0) >= 0,
  (n, e) => cu(e, n, !0) >= 0,
  (n, e) => Kg(e, n, !0) >= 0
], MC = { text: "", end: 0 };
class EC {
  /// @internal
  constructor(e, t, i, r) {
    this.parser = e, this.input = t, this.ranges = r, this.line = new CC(), this.atEnd = !1, this.reusePlaceholders = /* @__PURE__ */ new Map(), this.stoppedAt = null, this.rangeI = 0, this.to = r[r.length - 1].to, this.lineStart = this.absoluteLineStart = this.absoluteLineEnd = r[0].from, this.block = vo.create(M.Document, 0, this.lineStart, 0, 0), this.stack = [this.block], this.fragments = i.length ? new LC(i, t) : null, this.readLine();
  }
  get parsedPos() {
    return this.absoluteLineStart;
  }
  advance() {
    if (this.stoppedAt != null && this.absoluteLineStart > this.stoppedAt)
      return this.finish();
    let { line: e } = this;
    for (; ; ) {
      for (let i = 0; ; ) {
        let r = e.depth < this.stack.length ? this.stack[this.stack.length - 1] : null;
        for (; i < e.markers.length && (!r || e.markers[i].from < r.end); ) {
          let s = e.markers[i++];
          this.addNode(s.type, s.from, s.to);
        }
        if (!r)
          break;
        this.finishContext();
      }
      if (e.pos < e.text.length)
        break;
      if (!this.nextLine())
        return this.finish();
    }
    if (this.fragments && this.reuseFragment(e.basePos))
      return null;
    e:
      for (; ; ) {
        for (let i of this.parser.blockParsers)
          if (i) {
            let r = i(this, e);
            if (r != !1) {
              if (r == !0)
                return null;
              e.forward();
              continue e;
            }
          }
        break;
      }
    let t = new $C(this.lineStart + e.pos, e.text.slice(e.pos));
    for (let i of this.parser.leafBlockParsers)
      if (i) {
        let r = i(this, t);
        r && t.parsers.push(r);
      }
    e:
      for (; this.nextLine() && e.pos != e.text.length; ) {
        if (e.indent < e.baseIndent + 4) {
          for (let i of this.parser.endLeafBlock)
            if (i(this, e, t))
              break e;
        }
        for (let i of t.parsers)
          if (i.nextLine(this, e, t))
            return null;
        t.content += `
` + e.scrub();
        for (let i of e.markers)
          t.marks.push(i);
      }
    return this.finishLeaf(t), null;
  }
  stopAt(e) {
    if (this.stoppedAt != null && this.stoppedAt < e)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = e;
  }
  reuseFragment(e) {
    if (!this.fragments.moveTo(this.absoluteLineStart + e, this.absoluteLineStart) || !this.fragments.matches(this.block.hash))
      return !1;
    let t = this.fragments.takeNodes(this);
    return t ? (this.absoluteLineStart += t, this.lineStart = a1(this.absoluteLineStart, this.ranges), this.moveRangeI(), this.absoluteLineStart < this.to ? (this.lineStart++, this.absoluteLineStart++, this.readLine()) : (this.atEnd = !0, this.readLine()), !0) : !1;
  }
  /// The number of parent blocks surrounding the current block.
  get depth() {
    return this.stack.length;
  }
  /// Get the type of the parent block at the given depth. When no
  /// depth is passed, return the type of the innermost parent.
  parentType(e = this.depth - 1) {
    return this.parser.nodeSet.types[this.stack[e].type];
  }
  /// Move to the next input line. This should only be called by
  /// (non-composite) [block parsers](#BlockParser.parse) that consume
  /// the line directly, or leaf block parser
  /// [`nextLine`](#LeafBlockParser.nextLine) methods when they
  /// consume the current line (and return true).
  nextLine() {
    return this.lineStart += this.line.text.length, this.absoluteLineEnd >= this.to ? (this.absoluteLineStart = this.absoluteLineEnd, this.atEnd = !0, this.readLine(), !1) : (this.lineStart++, this.absoluteLineStart = this.absoluteLineEnd + 1, this.moveRangeI(), this.readLine(), !0);
  }
  moveRangeI() {
    for (; this.rangeI < this.ranges.length - 1 && this.absoluteLineStart >= this.ranges[this.rangeI].to; )
      this.rangeI++, this.absoluteLineStart = Math.max(this.absoluteLineStart, this.ranges[this.rangeI].from);
  }
  /// @internal
  scanLine(e) {
    let t = MC;
    if (t.end = e, e >= this.to)
      t.text = "";
    else if (t.text = this.lineChunkAt(e), t.end += t.text.length, this.ranges.length > 1) {
      let i = this.absoluteLineStart, r = this.rangeI;
      for (; this.ranges[r].to < t.end; ) {
        r++;
        let s = this.ranges[r].from, o = this.lineChunkAt(s);
        t.end = s + o.length, t.text = t.text.slice(0, this.ranges[r - 1].to - i) + o, i = t.end - t.text.length;
      }
    }
    return t;
  }
  /// @internal
  readLine() {
    let { line: e } = this, { text: t, end: i } = this.scanLine(this.absoluteLineStart);
    for (this.absoluteLineEnd = i, e.reset(t); e.depth < this.stack.length; e.depth++) {
      let r = this.stack[e.depth], s = this.parser.skipContextMarkup[r.type];
      if (!s)
        throw new Error("Unhandled block context " + M[r.type]);
      if (!s(r, this, e))
        break;
      e.forward();
    }
  }
  lineChunkAt(e) {
    let t = this.input.chunk(e), i;
    if (this.input.lineChunks)
      i = t == `
` ? "" : t;
    else {
      let r = t.indexOf(`
`);
      i = r < 0 ? t : t.slice(0, r);
    }
    return e + i.length > this.to ? i.slice(0, this.to - e) : i;
  }
  /// The end position of the previous line.
  prevLineEnd() {
    return this.atEnd ? this.lineStart : this.lineStart - 1;
  }
  /// @internal
  startContext(e, t, i = 0) {
    this.block = vo.create(e, i, this.lineStart + t, this.block.hash, this.lineStart + this.line.text.length), this.stack.push(this.block);
  }
  /// Start a composite block. Should only be called from [block
  /// parser functions](#BlockParser.parse) that return null.
  startComposite(e, t, i = 0) {
    this.startContext(this.parser.getNodeType(e), t, i);
  }
  /// @internal
  addNode(e, t, i) {
    typeof e == "number" && (e = new ae(this.parser.nodeSet.types[e], Ri, Ri, (i ?? this.prevLineEnd()) - t)), this.block.addChild(e, t - this.block.from);
  }
  /// Add a block element. Can be called by [block
  /// parsers](#BlockParser.parse).
  addElement(e) {
    this.block.addChild(e.toTree(this.parser.nodeSet), e.from - this.block.from);
  }
  /// Add a block element from a [leaf parser](#LeafBlockParser). This
  /// makes sure any extra composite block markup (such as blockquote
  /// markers) inside the block are also added to the syntax tree.
  addLeafElement(e, t) {
    this.addNode(this.buffer.writeElements(lh(t.children, e.marks), -t.from).finish(t.type, t.to - t.from), t.from);
  }
  /// @internal
  finishContext() {
    let e = this.stack.pop(), t = this.stack[this.stack.length - 1];
    t.addChild(e.toTree(this.parser.nodeSet), e.from - t.from), this.block = t;
  }
  finish() {
    for (; this.stack.length > 1; )
      this.finishContext();
    return this.addGaps(this.block.toTree(this.parser.nodeSet, this.lineStart));
  }
  addGaps(e) {
    return this.ranges.length > 1 ? Jg(this.ranges, 0, e.topNode, this.ranges[0].from, this.reusePlaceholders) : e;
  }
  /// @internal
  finishLeaf(e) {
    for (let i of e.parsers)
      if (i.finish(this, e))
        return;
    let t = lh(this.parser.parseInline(e.content, e.start), e.marks);
    this.addNode(this.buffer.writeElements(t, -e.start).finish(M.Paragraph, e.content.length), e.start);
  }
  elt(e, t, i, r) {
    return typeof e == "string" ? ie(this.parser.getNodeType(e), t, i, r) : new n1(e, t);
  }
  /// @internal
  get buffer() {
    return new t1(this.parser.nodeSet);
  }
}
function Jg(n, e, t, i, r) {
  let s = n[e].to, o = [], l = [], a = t.from + i;
  function h(u, c) {
    for (; c ? u >= s : u > s; ) {
      let f = n[e + 1].from - s;
      i += f, u += f, e++, s = n[e].to;
    }
  }
  for (let u = t.firstChild; u; u = u.nextSibling) {
    h(u.from + i, !0);
    let c = u.from + i, f, d = r.get(u.tree);
    d ? f = d : u.to + i > s ? (f = Jg(n, e, u, i, r), h(u.to + i, !1)) : f = u.toTree(), o.push(f), l.push(c - a);
  }
  return h(t.to + i, !1), new ae(t.type, o, l, t.to + i - a, t.tree ? t.tree.propValues : void 0);
}
class el extends Lh {
  /// @internal
  constructor(e, t, i, r, s, o, l, a, h) {
    super(), this.nodeSet = e, this.blockParsers = t, this.leafBlockParsers = i, this.blockNames = r, this.endLeafBlock = s, this.skipContextMarkup = o, this.inlineParsers = l, this.inlineNames = a, this.wrappers = h, this.nodeTypes = /* @__PURE__ */ Object.create(null);
    for (let u of e.types)
      this.nodeTypes[u.name] = u.id;
  }
  createParse(e, t, i) {
    let r = new EC(this, e, t, i);
    for (let s of this.wrappers)
      r = s(r, e, t, i);
    return r;
  }
  /// Reconfigure the parser.
  configure(e) {
    let t = sh(e);
    if (!t)
      return this;
    let { nodeSet: i, skipContextMarkup: r } = this, s = this.blockParsers.slice(), o = this.leafBlockParsers.slice(), l = this.blockNames.slice(), a = this.inlineParsers.slice(), h = this.inlineNames.slice(), u = this.endLeafBlock.slice(), c = this.wrappers;
    if (er(t.defineNodes)) {
      r = Object.assign({}, r);
      let f = i.types.slice(), d;
      for (let p of t.defineNodes) {
        let { name: m, block: O, composite: g, style: b } = typeof p == "string" ? { name: p } : p;
        if (f.some((P) => P.name == m))
          continue;
        g && (r[f.length] = (P, w, C) => g(w, C, P.value));
        let S = f.length, Q = g ? ["Block", "BlockContext"] : O ? S >= M.ATXHeading1 && S <= M.SetextHeading2 ? ["Block", "LeafBlock", "Heading"] : ["Block", "LeafBlock"] : void 0;
        f.push(ze.define({
          id: S,
          name: m,
          props: Q && [[F.group, Q]]
        })), b && (d || (d = {}), Array.isArray(b) || b instanceof At ? d[m] = b : Object.assign(d, b));
      }
      i = new Nr(f), d && (i = i.extend(Xi(d)));
    }
    if (er(t.props) && (i = i.extend(...t.props)), er(t.remove))
      for (let f of t.remove) {
        let d = this.blockNames.indexOf(f), p = this.inlineNames.indexOf(f);
        d > -1 && (s[d] = o[d] = void 0), p > -1 && (a[p] = void 0);
      }
    if (er(t.parseBlock))
      for (let f of t.parseBlock) {
        let d = l.indexOf(f.name);
        if (d > -1)
          s[d] = f.parse, o[d] = f.leaf;
        else {
          let p = f.before ? $s(l, f.before) : f.after ? $s(l, f.after) + 1 : l.length - 1;
          s.splice(p, 0, f.parse), o.splice(p, 0, f.leaf), l.splice(p, 0, f.name);
        }
        f.endLeaf && u.push(f.endLeaf);
      }
    if (er(t.parseInline))
      for (let f of t.parseInline) {
        let d = h.indexOf(f.name);
        if (d > -1)
          a[d] = f.parse;
        else {
          let p = f.before ? $s(h, f.before) : f.after ? $s(h, f.after) + 1 : h.length - 1;
          a.splice(p, 0, f.parse), h.splice(p, 0, f.name);
        }
      }
    return t.wrap && (c = c.concat(t.wrap)), new el(i, s, o, l, u, r, a, h, c);
  }
  /// @internal
  getNodeType(e) {
    let t = this.nodeTypes[e];
    if (t == null)
      throw new RangeError(`Unknown node type '${e}'`);
    return t;
  }
  /// Parse the given piece of inline text at the given offset,
  /// returning an array of [`Element`](#Element) objects representing
  /// the inline content.
  parseInline(e, t) {
    let i = new XC(this, e, t);
    e:
      for (let r = t; r < i.end; ) {
        let s = i.char(r);
        for (let o of this.inlineParsers)
          if (o) {
            let l = o(i, s, r);
            if (l >= 0) {
              r = l;
              continue e;
            }
          }
        r++;
      }
    return i.resolveMarkers(0);
  }
}
function er(n) {
  return n != null && n.length > 0;
}
function sh(n) {
  if (!Array.isArray(n))
    return n;
  if (n.length == 0)
    return null;
  let e = sh(n[0]);
  if (n.length == 1)
    return e;
  let t = sh(n.slice(1));
  if (!t || !e)
    return e || t;
  let i = (o, l) => (o || Ri).concat(l || Ri), r = e.wrap, s = t.wrap;
  return {
    props: i(e.props, t.props),
    defineNodes: i(e.defineNodes, t.defineNodes),
    parseBlock: i(e.parseBlock, t.parseBlock),
    parseInline: i(e.parseInline, t.parseInline),
    remove: i(e.remove, t.remove),
    wrap: r ? s ? (o, l, a, h) => r(s(o, l, a, h), l, a, h) : r : s
  };
}
function $s(n, e) {
  let t = n.indexOf(e);
  if (t < 0)
    throw new RangeError(`Position specified relative to unknown parser ${e}`);
  return t;
}
let e1 = [ze.none];
for (let n = 1, e; e = M[n]; n++)
  e1[n] = ze.define({
    id: n,
    name: e,
    props: n >= M.Escape ? [] : [[F.group, n in Vg ? ["Block", "BlockContext"] : ["Block", "LeafBlock"]]],
    top: e == "Document"
  });
const Ri = [];
class t1 {
  constructor(e) {
    this.nodeSet = e, this.content = [], this.nodes = [];
  }
  write(e, t, i, r = 0) {
    return this.content.push(e, t, i, 4 + r * 4), this;
  }
  writeElements(e, t = 0) {
    for (let i of e)
      i.writeTo(this, t);
    return this;
  }
  finish(e, t) {
    return ae.build({
      buffer: this.content,
      nodeSet: this.nodeSet,
      reused: this.nodes,
      topID: e,
      length: t
    });
  }
}
let Lr = class {
  /// @internal
  constructor(e, t, i, r = Ri) {
    this.type = e, this.from = t, this.to = i, this.children = r;
  }
  /// @internal
  writeTo(e, t) {
    let i = e.content.length;
    e.writeElements(this.children, t), e.content.push(this.type, this.from + t, this.to + t, e.content.length + 4 - i);
  }
  /// @internal
  toTree(e) {
    return new t1(e).writeElements(this.children, -this.from).finish(this.type, this.to - this.from);
  }
};
class n1 {
  constructor(e, t) {
    this.tree = e, this.from = t;
  }
  get to() {
    return this.from + this.tree.length;
  }
  get type() {
    return this.tree.type.id;
  }
  get children() {
    return Ri;
  }
  writeTo(e, t) {
    e.nodes.push(this.tree), e.content.push(e.nodes.length - 1, this.from + t, this.to + t, -1);
  }
  toTree() {
    return this.tree;
  }
}
function ie(n, e, t, i) {
  return new Lr(n, e, t, i);
}
const i1 = { resolve: "Emphasis", mark: "EmphasisMark" }, r1 = { resolve: "Emphasis", mark: "EmphasisMark" }, ui = {}, oh = {};
class Ot {
  constructor(e, t, i, r) {
    this.type = e, this.from = t, this.to = i, this.side = r;
  }
}
const Vf = "!\"#$%&'()*+,-./:;<=>?@[\\]^_`{|}~";
let Ir = /[!"#$%&'()*+,\-.\/:;<=>?@\[\\\]^_`{|}~\xA1\u2010-\u2027]/;
try {
  Ir = new RegExp("[\\p{Pc}|\\p{Pd}|\\p{Pe}|\\p{Pf}|\\p{Pi}|\\p{Po}|\\p{Ps}]", "u");
} catch {
}
const El = {
  Escape(n, e, t) {
    if (e != 92 || t == n.end - 1)
      return -1;
    let i = n.char(t + 1);
    for (let r = 0; r < Vf.length; r++)
      if (Vf.charCodeAt(r) == i)
        return n.append(ie(M.Escape, t, t + 2));
    return -1;
  },
  Entity(n, e, t) {
    if (e != 38)
      return -1;
    let i = /^(?:#\d+|#x[a-f\d]+|\w+);/i.exec(n.slice(t + 1, t + 31));
    return i ? n.append(ie(M.Entity, t, t + 1 + i[0].length)) : -1;
  },
  InlineCode(n, e, t) {
    if (e != 96 || t && n.char(t - 1) == 96)
      return -1;
    let i = t + 1;
    for (; i < n.end && n.char(i) == 96; )
      i++;
    let r = i - t, s = 0;
    for (; i < n.end; i++)
      if (n.char(i) == 96) {
        if (s++, s == r && n.char(i + 1) != 96)
          return n.append(ie(M.InlineCode, t, i + 1, [
            ie(M.CodeMark, t, t + r),
            ie(M.CodeMark, i + 1 - r, i + 1)
          ]));
      } else
        s = 0;
    return -1;
  },
  HTMLTag(n, e, t) {
    if (e != 60 || t == n.end - 1)
      return -1;
    let i = n.slice(t + 1, n.end), r = /^(?:[a-z][-\w+.]+:[^\s>]+|[a-z\d.!#$%&'*+/=?^_`{|}~-]+@[a-z\d](?:[a-z\d-]{0,61}[a-z\d])?(?:\.[a-z\d](?:[a-z\d-]{0,61}[a-z\d])?)*)>/i.exec(i);
    if (r)
      return n.append(ie(M.Autolink, t, t + 1 + r[0].length, [
        ie(M.LinkMark, t, t + 1),
        // url[0] includes the closing bracket, so exclude it from this slice
        ie(M.URL, t + 1, t + r[0].length),
        ie(M.LinkMark, t + r[0].length, t + 1 + r[0].length)
      ]));
    let s = /^!--[^>](?:-[^-]|[^-])*?-->/i.exec(i);
    if (s)
      return n.append(ie(M.Comment, t, t + 1 + s[0].length));
    let o = /^\?[^]*?\?>/.exec(i);
    if (o)
      return n.append(ie(M.ProcessingInstruction, t, t + 1 + o[0].length));
    let l = /^(?:![A-Z][^]*?>|!\[CDATA\[[^]*?\]\]>|\/\s*[a-zA-Z][\w-]*\s*>|\s*[a-zA-Z][\w-]*(\s+[a-zA-Z:_][\w-.:]*(?:\s*=\s*(?:[^\s"'=<>`]+|'[^']*'|"[^"]*"))?)*\s*(\/\s*)?>)/.exec(i);
    return l ? n.append(ie(M.HTMLTag, t, t + 1 + l[0].length)) : -1;
  },
  Emphasis(n, e, t) {
    if (e != 95 && e != 42)
      return -1;
    let i = t + 1;
    for (; n.char(i) == e; )
      i++;
    let r = n.slice(t - 1, t), s = n.slice(i, i + 1), o = Ir.test(r), l = Ir.test(s), a = /\s|^$/.test(r), h = /\s|^$/.test(s), u = !h && (!l || a || o), c = !a && (!o || h || l), f = u && (e == 42 || !c || o), d = c && (e == 42 || !u || l);
    return n.append(new Ot(e == 95 ? i1 : r1, t, i, (f ? 1 : 0) | (d ? 2 : 0)));
  },
  HardBreak(n, e, t) {
    if (e == 92 && n.char(t + 1) == 10)
      return n.append(ie(M.HardBreak, t, t + 2));
    if (e == 32) {
      let i = t + 1;
      for (; n.char(i) == 32; )
        i++;
      if (n.char(i) == 10 && i >= t + 2)
        return n.append(ie(M.HardBreak, t, i + 1));
    }
    return -1;
  },
  Link(n, e, t) {
    return e == 91 ? n.append(new Ot(
      ui,
      t,
      t + 1,
      1
      /* Mark.Open */
    )) : -1;
  },
  Image(n, e, t) {
    return e == 33 && n.char(t + 1) == 91 ? n.append(new Ot(
      oh,
      t,
      t + 2,
      1
      /* Mark.Open */
    )) : -1;
  },
  LinkEnd(n, e, t) {
    if (e != 93)
      return -1;
    for (let i = n.parts.length - 1; i >= 0; i--) {
      let r = n.parts[i];
      if (r instanceof Ot && (r.type == ui || r.type == oh)) {
        if (!r.side || n.skipSpace(r.to) == t && !/[(\[]/.test(n.slice(t + 1, t + 2)))
          return n.parts[i] = null, -1;
        let s = n.takeContent(i), o = n.parts[i] = zC(n, s, r.type == ui ? M.Link : M.Image, r.from, t + 1);
        if (r.type == ui)
          for (let l = 0; l < i; l++) {
            let a = n.parts[l];
            a instanceof Ot && a.type == ui && (a.side = 0);
          }
        return o.to;
      }
    }
    return -1;
  }
};
function zC(n, e, t, i, r) {
  let { text: s } = n, o = n.char(r), l = r;
  if (e.unshift(ie(M.LinkMark, i, i + (t == M.Image ? 2 : 1))), e.push(ie(M.LinkMark, r - 1, r)), o == 40) {
    let a = n.skipSpace(r + 1), h = s1(s, a - n.offset, n.offset), u;
    h && (a = n.skipSpace(h.to), a != h.to && (u = o1(s, a - n.offset, n.offset), u && (a = n.skipSpace(u.to)))), n.char(a) == 41 && (e.push(ie(M.LinkMark, r, r + 1)), l = a + 1, h && e.push(h), u && e.push(u), e.push(ie(M.LinkMark, a, l)));
  } else if (o == 91) {
    let a = l1(s, r - n.offset, n.offset, !1);
    a && (e.push(a), l = a.to);
  }
  return ie(t, i, l, e);
}
function s1(n, e, t) {
  if (n.charCodeAt(e) == 60) {
    for (let r = e + 1; r < n.length; r++) {
      let s = n.charCodeAt(r);
      if (s == 62)
        return ie(M.URL, e + t, r + 1 + t);
      if (s == 60 || s == 10)
        return !1;
    }
    return null;
  } else {
    let r = 0, s = e;
    for (let o = !1; s < n.length; s++) {
      let l = n.charCodeAt(s);
      if ($t(l))
        break;
      if (o)
        o = !1;
      else if (l == 40)
        r++;
      else if (l == 41) {
        if (!r)
          break;
        r--;
      } else
        l == 92 && (o = !0);
    }
    return s > e ? ie(M.URL, e + t, s + t) : s == n.length ? null : !1;
  }
}
function o1(n, e, t) {
  let i = n.charCodeAt(e);
  if (i != 39 && i != 34 && i != 40)
    return !1;
  let r = i == 40 ? 41 : i;
  for (let s = e + 1, o = !1; s < n.length; s++) {
    let l = n.charCodeAt(s);
    if (o)
      o = !1;
    else {
      if (l == r)
        return ie(M.LinkTitle, e + t, s + 1 + t);
      l == 92 && (o = !0);
    }
  }
  return null;
}
function l1(n, e, t, i) {
  for (let r = !1, s = e + 1, o = Math.min(n.length, s + 999); s < o; s++) {
    let l = n.charCodeAt(s);
    if (r)
      r = !1;
    else {
      if (l == 93)
        return i ? !1 : ie(M.LinkLabel, e + t, s + 1 + t);
      if (i && !$t(l) && (i = !1), l == 91)
        return !1;
      l == 92 && (r = !0);
    }
  }
  return null;
}
class XC {
  /// @internal
  constructor(e, t, i) {
    this.parser = e, this.text = t, this.offset = i, this.parts = [];
  }
  /// Get the character code at the given (document-relative)
  /// position.
  char(e) {
    return e >= this.end ? -1 : this.text.charCodeAt(e - this.offset);
  }
  /// The position of the end of this inline section.
  get end() {
    return this.offset + this.text.length;
  }
  /// Get a substring of this inline section. Again uses
  /// document-relative positions.
  slice(e, t) {
    return this.text.slice(e - this.offset, t - this.offset);
  }
  /// @internal
  append(e) {
    return this.parts.push(e), e.to;
  }
  /// Add a [delimiter](#DelimiterType) at this given position. `open`
  /// and `close` indicate whether this delimiter is opening, closing,
  /// or both. Returns the end of the delimiter, for convenient
  /// returning from [parse functions](#InlineParser.parse).
  addDelimiter(e, t, i, r, s) {
    return this.append(new Ot(e, t, i, (r ? 1 : 0) | (s ? 2 : 0)));
  }
  /// Returns true when there is an unmatched link or image opening
  /// token before the current position.
  get hasOpenLink() {
    for (let e = this.parts.length - 1; e >= 0; e--) {
      let t = this.parts[e];
      if (t instanceof Ot && (t.type == ui || t.type == oh))
        return !0;
    }
    return !1;
  }
  /// Add an inline element. Returns the end of the element.
  addElement(e) {
    return this.append(e);
  }
  /// Resolve markers between this.parts.length and from, wrapping matched markers in the
  /// appropriate node and updating the content of this.parts. @internal
  resolveMarkers(e) {
    for (let i = e; i < this.parts.length; i++) {
      let r = this.parts[i];
      if (!(r instanceof Ot && r.type.resolve && r.side & 2))
        continue;
      let s = r.type == i1 || r.type == r1, o = r.to - r.from, l, a = i - 1;
      for (; a >= e; a--) {
        let m = this.parts[a];
        if (m instanceof Ot && m.side & 1 && m.type == r.type && // Ignore emphasis delimiters where the character count doesn't match
        !(s && (r.side & 1 || m.side & 2) && (m.to - m.from + o) % 3 == 0 && ((m.to - m.from) % 3 || o % 3))) {
          l = m;
          break;
        }
      }
      if (!l)
        continue;
      let h = r.type.resolve, u = [], c = l.from, f = r.to;
      if (s) {
        let m = Math.min(2, l.to - l.from, o);
        c = l.to - m, f = r.from + m, h = m == 1 ? "Emphasis" : "StrongEmphasis";
      }
      l.type.mark && u.push(this.elt(l.type.mark, c, l.to));
      for (let m = a + 1; m < i; m++)
        this.parts[m] instanceof Lr && u.push(this.parts[m]), this.parts[m] = null;
      r.type.mark && u.push(this.elt(r.type.mark, r.from, f));
      let d = this.elt(h, c, f, u);
      this.parts[a] = s && l.from != c ? new Ot(l.type, l.from, c, l.side) : null, (this.parts[i] = s && r.to != f ? new Ot(r.type, f, r.to, r.side) : null) ? this.parts.splice(i, 0, d) : this.parts[i] = d;
    }
    let t = [];
    for (let i = e; i < this.parts.length; i++) {
      let r = this.parts[i];
      r instanceof Lr && t.push(r);
    }
    return t;
  }
  /// Find an opening delimiter of the given type. Returns `null` if
  /// no delimiter is found, or an index that can be passed to
  /// [`takeContent`](#InlineContext.takeContent) otherwise.
  findOpeningDelimiter(e) {
    for (let t = this.parts.length - 1; t >= 0; t--) {
      let i = this.parts[t];
      if (i instanceof Ot && i.type == e)
        return t;
    }
    return null;
  }
  /// Remove all inline elements and delimiters starting from the
  /// given index (which you should get from
  /// [`findOpeningDelimiter`](#InlineContext.findOpeningDelimiter),
  /// resolve delimiters inside of them, and return them as an array
  /// of elements.
  takeContent(e) {
    let t = this.resolveMarkers(e);
    return this.parts.length = e, t;
  }
  /// Skip space after the given (document) position, returning either
  /// the position of the next non-space character or the end of the
  /// section.
  skipSpace(e) {
    return br(this.text, e - this.offset) + this.offset;
  }
  elt(e, t, i, r) {
    return typeof e == "string" ? ie(this.parser.getNodeType(e), t, i, r) : new n1(e, t);
  }
}
function lh(n, e) {
  if (!e.length)
    return n;
  if (!n.length)
    return e;
  let t = n.slice(), i = 0;
  for (let r of e) {
    for (; i < t.length && t[i].to < r.to; )
      i++;
    if (i < t.length && t[i].from < r.from) {
      let s = t[i];
      s instanceof Lr && (t[i] = new Lr(s.type, s.from, s.to, lh(s.children, [r])));
    } else
      t.splice(i++, 0, r);
  }
  return t;
}
const DC = [M.CodeBlock, M.ListItem, M.OrderedList, M.BulletList];
let LC = class {
  constructor(e, t) {
    this.fragments = e, this.input = t, this.i = 0, this.fragment = null, this.fragmentEnd = -1, this.cursor = null, e.length && (this.fragment = e[this.i++]);
  }
  nextFragment() {
    this.fragment = this.i < this.fragments.length ? this.fragments[this.i++] : null, this.cursor = null, this.fragmentEnd = -1;
  }
  moveTo(e, t) {
    for (; this.fragment && this.fragment.to <= e; )
      this.nextFragment();
    if (!this.fragment || this.fragment.from > (e ? e - 1 : 0))
      return !1;
    if (this.fragmentEnd < 0) {
      let s = this.fragment.to;
      for (; s > 0 && this.input.read(s - 1, s) != `
`; )
        s--;
      this.fragmentEnd = s ? s - 1 : 0;
    }
    let i = this.cursor;
    i || (i = this.cursor = this.fragment.tree.cursor(), i.firstChild());
    let r = e + this.fragment.offset;
    for (; i.to <= r; )
      if (!i.parent())
        return !1;
    for (; ; ) {
      if (i.from >= r)
        return this.fragment.from <= t;
      if (!i.childAfter(r))
        return !1;
    }
  }
  matches(e) {
    let t = this.cursor.tree;
    return t && t.prop(F.contextHash) == e;
  }
  takeNodes(e) {
    let t = this.cursor, i = this.fragment.offset, r = this.fragmentEnd - (this.fragment.openEnd ? 1 : 0), s = e.absoluteLineStart, o = s, l = e.block.children.length, a = o, h = l;
    for (; ; ) {
      if (t.to - i > r) {
        if (t.type.isAnonymous && t.firstChild())
          continue;
        break;
      }
      let u = a1(t.from - i, e.ranges);
      if (t.to - i <= e.ranges[e.rangeI].to)
        e.addNode(t.tree, u);
      else {
        let c = new ae(e.parser.nodeSet.types[M.Paragraph], [], [], 0, e.block.hashProp);
        e.reusePlaceholders.set(c, t.tree), e.addNode(c, u);
      }
      if (t.type.is("Block") && (DC.indexOf(t.type.id) < 0 ? (o = t.to - i, l = e.block.children.length) : (o = a, l = h, a = t.to - i, h = e.block.children.length)), !t.nextSibling())
        break;
    }
    for (; e.block.children.length > l; )
      e.block.children.pop(), e.block.positions.pop();
    return o - s;
  }
};
function a1(n, e) {
  let t = n;
  for (let i = 1; i < e.length; i++) {
    let r = e[i - 1].to, s = e[i].from;
    r < n && (t -= s - r);
  }
  return t;
}
const IC = Xi({
  "Blockquote/...": k.quote,
  HorizontalRule: k.contentSeparator,
  "ATXHeading1/... SetextHeading1/...": k.heading1,
  "ATXHeading2/... SetextHeading2/...": k.heading2,
  "ATXHeading3/...": k.heading3,
  "ATXHeading4/...": k.heading4,
  "ATXHeading5/...": k.heading5,
  "ATXHeading6/...": k.heading6,
  "Comment CommentBlock": k.comment,
  Escape: k.escape,
  Entity: k.character,
  "Emphasis/...": k.emphasis,
  "StrongEmphasis/...": k.strong,
  "Link/... Image/...": k.link,
  "OrderedList/... BulletList/...": k.list,
  "BlockQuote/...": k.quote,
  "InlineCode CodeText": k.monospace,
  "URL Autolink": k.url,
  "HeaderMark HardBreak QuoteMark ListMark LinkMark EmphasisMark CodeMark": k.processingInstruction,
  "CodeInfo LinkLabel": k.labelName,
  LinkTitle: k.string,
  Paragraph: k.content
}), _C = new el(new Nr(e1).extend(IC), Object.keys(Qs).map((n) => Qs[n]), Object.keys(Qs).map((n) => RC[n]), Object.keys(Qs), ZC, Vg, Object.keys(El).map((n) => El[n]), Object.keys(El), []);
function qC(n, e, t) {
  let i = [];
  for (let r = n.firstChild, s = e; ; r = r.nextSibling) {
    let o = r ? r.from : t;
    if (o > s && i.push({ from: s, to: o }), !r)
      break;
    s = r.to;
  }
  return i;
}
function WC(n) {
  let { codeParser: e, htmlParser: t } = n;
  return { wrap: Im((r, s) => {
    let o = r.type.id;
    if (e && (o == M.CodeBlock || o == M.FencedCode)) {
      let l = "";
      if (o == M.FencedCode) {
        let h = r.node.getChild(M.CodeInfo);
        h && (l = s.read(h.from, h.to));
      }
      let a = e(l);
      if (a)
        return { parser: a, overlay: (h) => h.type.id == M.CodeText };
    } else if (t && (o == M.HTMLBlock || o == M.HTMLTag))
      return { parser: t, overlay: qC(r.node, r.from, r.to) };
    return null;
  }) };
}
const BC = { resolve: "Strikethrough", mark: "StrikethroughMark" }, VC = {
  defineNodes: [{
    name: "Strikethrough",
    style: { "Strikethrough/...": k.strikethrough }
  }, {
    name: "StrikethroughMark",
    style: k.processingInstruction
  }],
  parseInline: [{
    name: "Strikethrough",
    parse(n, e, t) {
      if (e != 126 || n.char(t + 1) != 126 || n.char(t + 2) == 126)
        return -1;
      let i = n.slice(t - 1, t), r = n.slice(t + 2, t + 3), s = /\s|^$/.test(i), o = /\s|^$/.test(r), l = Ir.test(i), a = Ir.test(r);
      return n.addDelimiter(BC, t, t + 2, !o && (!a || s || l), !s && (!l || o || a));
    },
    after: "Emphasis"
  }]
};
function yr(n, e, t = 0, i, r = 0) {
  let s = 0, o = !0, l = -1, a = -1, h = !1, u = () => {
    i.push(n.elt("TableCell", r + l, r + a, n.parser.parseInline(e.slice(l, a), r + l)));
  };
  for (let c = t; c < e.length; c++) {
    let f = e.charCodeAt(c);
    f == 124 && !h ? ((!o || l > -1) && s++, o = !1, i && (l > -1 && u(), i.push(n.elt("TableDelimiter", c + r, c + r + 1))), l = a = -1) : (h || f != 32 && f != 9) && (l < 0 && (l = c), a = c + 1), h = !h && f == 92;
  }
  return l > -1 && (s++, i && u()), s;
}
function Yf(n, e) {
  for (let t = e; t < n.length; t++) {
    let i = n.charCodeAt(t);
    if (i == 124)
      return !0;
    i == 92 && t++;
  }
  return !1;
}
const h1 = /^\|?(\s*:?-+:?\s*\|)+(\s*:?-+:?\s*)?$/;
class jf {
  constructor() {
    this.rows = null;
  }
  nextLine(e, t, i) {
    if (this.rows == null) {
      this.rows = !1;
      let r;
      if ((t.next == 45 || t.next == 58 || t.next == 124) && h1.test(r = t.text.slice(t.pos))) {
        let s = [];
        yr(e, i.content, 0, s, i.start) == yr(e, r, t.pos) && (this.rows = [
          e.elt("TableHeader", i.start, i.start + i.content.length, s),
          e.elt("TableDelimiter", e.lineStart + t.pos, e.lineStart + t.text.length)
        ]);
      }
    } else if (this.rows) {
      let r = [];
      yr(e, t.text, t.pos, r, e.lineStart), this.rows.push(e.elt("TableRow", e.lineStart + t.pos, e.lineStart + t.text.length, r));
    }
    return !1;
  }
  finish(e, t) {
    return this.rows ? (e.addLeafElement(t, e.elt("Table", t.start, t.start + t.content.length, this.rows)), !0) : !1;
  }
}
const YC = {
  defineNodes: [
    { name: "Table", block: !0 },
    { name: "TableHeader", style: { "TableHeader/...": k.heading } },
    "TableRow",
    { name: "TableCell", style: k.content },
    { name: "TableDelimiter", style: k.processingInstruction }
  ],
  parseBlock: [{
    name: "Table",
    leaf(n, e) {
      return Yf(e.content, 0) ? new jf() : null;
    },
    endLeaf(n, e, t) {
      if (t.parsers.some((r) => r instanceof jf) || !Yf(e.text, e.basePos))
        return !1;
      let i = n.scanLine(n.absoluteLineEnd + 1).text;
      return h1.test(i) && yr(n, e.text, e.basePos) == yr(n, i, e.basePos);
    },
    before: "SetextHeading"
  }]
};
class jC {
  nextLine() {
    return !1;
  }
  finish(e, t) {
    return e.addLeafElement(t, e.elt("Task", t.start, t.start + t.content.length, [
      e.elt("TaskMarker", t.start, t.start + 3),
      ...e.parser.parseInline(t.content.slice(3), t.start + 3)
    ])), !0;
  }
}
const NC = {
  defineNodes: [
    { name: "Task", block: !0, style: k.list },
    { name: "TaskMarker", style: k.atom }
  ],
  parseBlock: [{
    name: "TaskList",
    leaf(n, e) {
      return /^\[[ xX]\][ \t]/.test(e.content) && n.parentType().name == "ListItem" ? new jC() : null;
    },
    after: "SetextHeading"
  }]
}, Nf = /(www\.)|(https?:\/\/)|([\w.+-]+@)|(mailto:|xmpp:)/gy, Uf = /[\w-]+(\.[\w-]+)+(\/[^\s<]*)?/gy, UC = /[\w-]+\.[\w-]+($|\/)/, Ff = /[\w.+-]+@[\w-]+(\.[\w.-]+)+/gy, Gf = /\/[a-zA-Z\d@.]+/gy;
function Hf(n, e, t, i) {
  let r = 0;
  for (let s = e; s < t; s++)
    n[s] == i && r++;
  return r;
}
function FC(n, e) {
  Uf.lastIndex = e;
  let t = Uf.exec(n);
  if (!t || UC.exec(t[0])[0].indexOf("_") > -1)
    return -1;
  let i = e + t[0].length;
  for (; ; ) {
    let r = n[i - 1], s;
    if (/[?!.,:*_~]/.test(r) || r == ")" && Hf(n, e, i, ")") > Hf(n, e, i, "("))
      i--;
    else if (r == ";" && (s = /&(?:#\d+|#x[a-f\d]+|\w+);$/.exec(n.slice(e, i))))
      i = e + s.index;
    else
      break;
  }
  return i;
}
function Kf(n, e) {
  Ff.lastIndex = e;
  let t = Ff.exec(n);
  if (!t)
    return -1;
  let i = t[0][t[0].length - 1];
  return i == "_" || i == "-" ? -1 : e + t[0].length - (i == "." ? 1 : 0);
}
const GC = {
  parseInline: [{
    name: "Autolink",
    parse(n, e, t) {
      let i = t - n.offset;
      Nf.lastIndex = i;
      let r = Nf.exec(n.text), s = -1;
      if (!r)
        return -1;
      if (r[1] || r[2]) {
        if (s = FC(n.text, i + r[0].length), s > -1 && n.hasOpenLink) {
          let o = /([^\[\]]|\[[^\]]*\])*/.exec(n.text.slice(i, s));
          s = i + o[0].length;
        }
      } else
        r[3] ? s = Kf(n.text, i) : (s = Kf(n.text, i + r[0].length), s > -1 && r[0] == "xmpp:" && (Gf.lastIndex = s, r = Gf.exec(n.text), r && (s = r.index + r[0].length)));
      return s < 0 ? -1 : (n.addElement(n.elt("URL", t, s + n.offset)), s + n.offset);
    }
  }]
}, HC = [YC, NC, VC, GC];
function u1(n, e, t) {
  return (i, r, s) => {
    if (r != n || i.char(s + 1) == n)
      return -1;
    let o = [i.elt(t, s, s + 1)];
    for (let l = s + 1; l < i.end; l++) {
      let a = i.char(l);
      if (a == n)
        return i.addElement(i.elt(e, s, l + 1, o.concat(i.elt(t, l, l + 1))));
      if (a == 92 && o.push(i.elt("Escape", l, l++ + 2)), $t(a))
        break;
    }
    return -1;
  };
}
const KC = {
  defineNodes: [
    { name: "Superscript", style: k.special(k.content) },
    { name: "SuperscriptMark", style: k.processingInstruction }
  ],
  parseInline: [{
    name: "Superscript",
    parse: u1(94, "Superscript", "SuperscriptMark")
  }]
}, JC = {
  defineNodes: [
    { name: "Subscript", style: k.special(k.content) },
    { name: "SubscriptMark", style: k.processingInstruction }
  ],
  parseInline: [{
    name: "Subscript",
    parse: u1(126, "Subscript", "SubscriptMark")
  }]
}, e3 = {
  defineNodes: [{ name: "Emoji", style: k.character }],
  parseInline: [{
    name: "Emoji",
    parse(n, e, t) {
      let i;
      return e != 58 || !(i = /^[a-zA-Z_0-9]+:/.exec(n.slice(t + 1, n.end))) ? -1 : n.addElement(n.elt("Emoji", t, t + 1 + i[0].length));
    }
  }]
};
class Po {
  /**
  @internal
  */
  constructor(e, t, i, r, s, o, l, a, h, u = 0, c) {
    this.p = e, this.stack = t, this.state = i, this.reducePos = r, this.pos = s, this.score = o, this.buffer = l, this.bufferBase = a, this.curContext = h, this.lookAhead = u, this.parent = c;
  }
  /**
  @internal
  */
  toString() {
    return `[${this.stack.filter((e, t) => t % 3 == 0).concat(this.state)}]@${this.pos}${this.score ? "!" + this.score : ""}`;
  }
  // Start an empty stack
  /**
  @internal
  */
  static start(e, t, i = 0) {
    let r = e.parser.context;
    return new Po(e, [], t, i, i, 0, [], 0, r ? new Jf(r, r.start) : null, 0, null);
  }
  /**
  The stack's current [context](#lr.ContextTracker) value, if
  any. Its type will depend on the context tracker's type
  parameter, or it will be `null` if there is no context
  tracker.
  */
  get context() {
    return this.curContext ? this.curContext.context : null;
  }
  // Push a state onto the stack, tracking its start position as well
  // as the buffer base at that point.
  /**
  @internal
  */
  pushState(e, t) {
    this.stack.push(this.state, t, this.bufferBase + this.buffer.length), this.state = e;
  }
  // Apply a reduce action
  /**
  @internal
  */
  reduce(e) {
    var t;
    let i = e >> 19, r = e & 65535, { parser: s } = this.p, o = s.dynamicPrecedence(r);
    if (o && (this.score += o), i == 0) {
      this.pushState(s.getGoto(this.state, r, !0), this.reducePos), r < s.minRepeatTerm && this.storeNode(r, this.reducePos, this.reducePos, 4, !0), this.reduceContext(r, this.reducePos);
      return;
    }
    let l = this.stack.length - (i - 1) * 3 - (e & 262144 ? 6 : 0), a = l ? this.stack[l - 2] : this.p.ranges[0].from, h = this.reducePos - a;
    h >= 2e3 && !(!((t = this.p.parser.nodeSet.types[r]) === null || t === void 0) && t.isAnonymous) && (a == this.p.lastBigReductionStart ? (this.p.bigReductionCount++, this.p.lastBigReductionSize = h) : this.p.lastBigReductionSize < h && (this.p.bigReductionCount = 1, this.p.lastBigReductionStart = a, this.p.lastBigReductionSize = h));
    let u = l ? this.stack[l - 1] : 0, c = this.bufferBase + this.buffer.length - u;
    if (r < s.minRepeatTerm || e & 131072) {
      let f = s.stateFlag(
        this.state,
        1
        /* StateFlag.Skipped */
      ) ? this.pos : this.reducePos;
      this.storeNode(r, a, f, c + 4, !0);
    }
    if (e & 262144)
      this.state = this.stack[l];
    else {
      let f = this.stack[l - 3];
      this.state = s.getGoto(f, r, !0);
    }
    for (; this.stack.length > l; )
      this.stack.pop();
    this.reduceContext(r, a);
  }
  // Shift a value into the buffer
  /**
  @internal
  */
  storeNode(e, t, i, r = 4, s = !1) {
    if (e == 0 && (!this.stack.length || this.stack[this.stack.length - 1] < this.buffer.length + this.bufferBase)) {
      let o = this, l = this.buffer.length;
      if (l == 0 && o.parent && (l = o.bufferBase - o.parent.bufferBase, o = o.parent), l > 0 && o.buffer[l - 4] == 0 && o.buffer[l - 1] > -1) {
        if (t == i)
          return;
        if (o.buffer[l - 2] >= t) {
          o.buffer[l - 2] = i;
          return;
        }
      }
    }
    if (!s || this.pos == i)
      this.buffer.push(e, t, i, r);
    else {
      let o = this.buffer.length;
      if (o > 0 && this.buffer[o - 4] != 0)
        for (; o > 0 && this.buffer[o - 2] > i; )
          this.buffer[o] = this.buffer[o - 4], this.buffer[o + 1] = this.buffer[o - 3], this.buffer[o + 2] = this.buffer[o - 2], this.buffer[o + 3] = this.buffer[o - 1], o -= 4, r > 4 && (r -= 4);
      this.buffer[o] = e, this.buffer[o + 1] = t, this.buffer[o + 2] = i, this.buffer[o + 3] = r;
    }
  }
  // Apply a shift action
  /**
  @internal
  */
  shift(e, t, i, r) {
    if (e & 131072)
      this.pushState(e & 65535, this.pos);
    else if (e & 262144)
      this.pos = r, this.shiftContext(t, i), t <= this.p.parser.maxNode && this.buffer.push(t, i, r, 4);
    else {
      let s = e, { parser: o } = this.p;
      (r > this.pos || t <= o.maxNode) && (this.pos = r, o.stateFlag(
        s,
        1
        /* StateFlag.Skipped */
      ) || (this.reducePos = r)), this.pushState(s, i), this.shiftContext(t, i), t <= o.maxNode && this.buffer.push(t, i, r, 4);
    }
  }
  // Apply an action
  /**
  @internal
  */
  apply(e, t, i, r) {
    e & 65536 ? this.reduce(e) : this.shift(e, t, i, r);
  }
  // Add a prebuilt (reused) node into the buffer.
  /**
  @internal
  */
  useNode(e, t) {
    let i = this.p.reused.length - 1;
    (i < 0 || this.p.reused[i] != e) && (this.p.reused.push(e), i++);
    let r = this.pos;
    this.reducePos = this.pos = r + e.length, this.pushState(t, r), this.buffer.push(
      i,
      r,
      this.reducePos,
      -1
      /* size == -1 means this is a reused value */
    ), this.curContext && this.updateContext(this.curContext.tracker.reuse(this.curContext.context, e, this, this.p.stream.reset(this.pos - e.length)));
  }
  // Split the stack. Due to the buffer sharing and the fact
  // that `this.stack` tends to stay quite shallow, this isn't very
  // expensive.
  /**
  @internal
  */
  split() {
    let e = this, t = e.buffer.length;
    for (; t > 0 && e.buffer[t - 2] > e.reducePos; )
      t -= 4;
    let i = e.buffer.slice(t), r = e.bufferBase + t;
    for (; e && r == e.bufferBase; )
      e = e.parent;
    return new Po(this.p, this.stack.slice(), this.state, this.reducePos, this.pos, this.score, i, r, this.curContext, this.lookAhead, e);
  }
  // Try to recover from an error by 'deleting' (ignoring) one token.
  /**
  @internal
  */
  recoverByDelete(e, t) {
    let i = e <= this.p.parser.maxNode;
    i && this.storeNode(e, this.pos, t, 4), this.storeNode(0, this.pos, t, i ? 8 : 4), this.pos = this.reducePos = t, this.score -= 190;
  }
  /**
  Check if the given term would be able to be shifted (optionally
  after some reductions) on this stack. This can be useful for
  external tokenizers that want to make sure they only provide a
  given token when it applies.
  */
  canShift(e) {
    for (let t = new t3(this); ; ) {
      let i = this.p.parser.stateSlot(
        t.state,
        4
        /* ParseState.DefaultReduce */
      ) || this.p.parser.hasAction(t.state, e);
      if (i == 0)
        return !1;
      if (!(i & 65536))
        return !0;
      t.reduce(i);
    }
  }
  // Apply up to Recover.MaxNext recovery actions that conceptually
  // inserts some missing token or rule.
  /**
  @internal
  */
  recoverByInsert(e) {
    if (this.stack.length >= 300)
      return [];
    let t = this.p.parser.nextStates(this.state);
    if (t.length > 8 || this.stack.length >= 120) {
      let r = [];
      for (let s = 0, o; s < t.length; s += 2)
        (o = t[s + 1]) != this.state && this.p.parser.hasAction(o, e) && r.push(t[s], o);
      if (this.stack.length < 120)
        for (let s = 0; r.length < 8 && s < t.length; s += 2) {
          let o = t[s + 1];
          r.some((l, a) => a & 1 && l == o) || r.push(t[s], o);
        }
      t = r;
    }
    let i = [];
    for (let r = 0; r < t.length && i.length < 4; r += 2) {
      let s = t[r + 1];
      if (s == this.state)
        continue;
      let o = this.split();
      o.pushState(s, this.pos), o.storeNode(0, o.pos, o.pos, 4, !0), o.shiftContext(t[r], this.pos), o.reducePos = this.pos, o.score -= 200, i.push(o);
    }
    return i;
  }
  // Force a reduce, if possible. Return false if that can't
  // be done.
  /**
  @internal
  */
  forceReduce() {
    let { parser: e } = this.p, t = e.stateSlot(
      this.state,
      5
      /* ParseState.ForcedReduce */
    );
    if (!(t & 65536))
      return !1;
    if (!e.validAction(this.state, t)) {
      let i = t >> 19, r = t & 65535, s = this.stack.length - i * 3;
      if (s < 0 || e.getGoto(this.stack[s], r, !1) < 0) {
        let o = this.findForcedReduction();
        if (o == null)
          return !1;
        t = o;
      }
      this.storeNode(0, this.pos, this.pos, 4, !0), this.score -= 100;
    }
    return this.reducePos = this.pos, this.reduce(t), !0;
  }
  /**
  Try to scan through the automaton to find some kind of reduction
  that can be applied. Used when the regular ForcedReduce field
  isn't a valid action. @internal
  */
  findForcedReduction() {
    let { parser: e } = this.p, t = [], i = (r, s) => {
      if (!t.includes(r))
        return t.push(r), e.allActions(r, (o) => {
          if (!(o & 393216))
            if (o & 65536) {
              let l = (o >> 19) - s;
              if (l > 1) {
                let a = o & 65535, h = this.stack.length - l * 3;
                if (h >= 0 && e.getGoto(this.stack[h], a, !1) >= 0)
                  return l << 19 | 65536 | a;
              }
            } else {
              let l = i(o, s + 1);
              if (l != null)
                return l;
            }
        });
    };
    return i(this.state, 0);
  }
  /**
  @internal
  */
  forceAll() {
    for (; !this.p.parser.stateFlag(
      this.state,
      2
      /* StateFlag.Accepting */
    ); )
      if (!this.forceReduce()) {
        this.storeNode(0, this.pos, this.pos, 4, !0);
        break;
      }
    return this;
  }
  /**
  Check whether this state has no further actions (assumed to be a direct descendant of the
  top state, since any other states must be able to continue
  somehow). @internal
  */
  get deadEnd() {
    if (this.stack.length != 3)
      return !1;
    let { parser: e } = this.p;
    return e.data[e.stateSlot(
      this.state,
      1
      /* ParseState.Actions */
    )] == 65535 && !e.stateSlot(
      this.state,
      4
      /* ParseState.DefaultReduce */
    );
  }
  /**
  Restart the stack (put it back in its start state). Only safe
  when this.stack.length == 3 (state is directly below the top
  state). @internal
  */
  restart() {
    this.storeNode(0, this.pos, this.pos, 4, !0), this.state = this.stack[0], this.stack.length = 0;
  }
  /**
  @internal
  */
  sameState(e) {
    if (this.state != e.state || this.stack.length != e.stack.length)
      return !1;
    for (let t = 0; t < this.stack.length; t += 3)
      if (this.stack[t] != e.stack[t])
        return !1;
    return !0;
  }
  /**
  Get the parser used by this stack.
  */
  get parser() {
    return this.p.parser;
  }
  /**
  Test whether a given dialect (by numeric ID, as exported from
  the terms file) is enabled.
  */
  dialectEnabled(e) {
    return this.p.parser.dialect.flags[e];
  }
  shiftContext(e, t) {
    this.curContext && this.updateContext(this.curContext.tracker.shift(this.curContext.context, e, this, this.p.stream.reset(t)));
  }
  reduceContext(e, t) {
    this.curContext && this.updateContext(this.curContext.tracker.reduce(this.curContext.context, e, this, this.p.stream.reset(t)));
  }
  /**
  @internal
  */
  emitContext() {
    let e = this.buffer.length - 1;
    (e < 0 || this.buffer[e] != -3) && this.buffer.push(this.curContext.hash, this.pos, this.pos, -3);
  }
  /**
  @internal
  */
  emitLookAhead() {
    let e = this.buffer.length - 1;
    (e < 0 || this.buffer[e] != -4) && this.buffer.push(this.lookAhead, this.pos, this.pos, -4);
  }
  updateContext(e) {
    if (e != this.curContext.context) {
      let t = new Jf(this.curContext.tracker, e);
      t.hash != this.curContext.hash && this.emitContext(), this.curContext = t;
    }
  }
  /**
  @internal
  */
  setLookAhead(e) {
    e > this.lookAhead && (this.emitLookAhead(), this.lookAhead = e);
  }
  /**
  @internal
  */
  close() {
    this.curContext && this.curContext.tracker.strict && this.emitContext(), this.lookAhead > 0 && this.emitLookAhead();
  }
}
class Jf {
  constructor(e, t) {
    this.tracker = e, this.context = t, this.hash = e.strict ? e.hash(t) : 0;
  }
}
class t3 {
  constructor(e) {
    this.start = e, this.state = e.state, this.stack = e.stack, this.base = this.stack.length;
  }
  reduce(e) {
    let t = e & 65535, i = e >> 19;
    i == 0 ? (this.stack == this.start.stack && (this.stack = this.stack.slice()), this.stack.push(this.state, 0, 0), this.base += 3) : this.base -= (i - 1) * 3;
    let r = this.start.p.parser.getGoto(this.stack[this.base - 3], t, !0);
    this.state = r;
  }
}
class Qo {
  constructor(e, t, i) {
    this.stack = e, this.pos = t, this.index = i, this.buffer = e.buffer, this.index == 0 && this.maybeNext();
  }
  static create(e, t = e.bufferBase + e.buffer.length) {
    return new Qo(e, t, t - e.bufferBase);
  }
  maybeNext() {
    let e = this.stack.parent;
    e != null && (this.index = this.stack.bufferBase - e.bufferBase, this.stack = e, this.buffer = e.buffer);
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  next() {
    this.index -= 4, this.pos -= 4, this.index == 0 && this.maybeNext();
  }
  fork() {
    return new Qo(this.stack, this.pos, this.index);
  }
}
function ur(n, e = Uint16Array) {
  if (typeof n != "string")
    return n;
  let t = null;
  for (let i = 0, r = 0; i < n.length; ) {
    let s = 0;
    for (; ; ) {
      let o = n.charCodeAt(i++), l = !1;
      if (o == 126) {
        s = 65535;
        break;
      }
      o >= 92 && o--, o >= 34 && o--;
      let a = o - 32;
      if (a >= 46 && (a -= 46, l = !0), s += a, l)
        break;
      s *= 46;
    }
    t ? t[r++] = s : t = new e(s);
  }
  return t;
}
class js {
  constructor() {
    this.start = -1, this.value = -1, this.end = -1, this.extended = -1, this.lookAhead = 0, this.mask = 0, this.context = 0;
  }
}
const ed = new js();
class n3 {
  /**
  @internal
  */
  constructor(e, t) {
    this.input = e, this.ranges = t, this.chunk = "", this.chunkOff = 0, this.chunk2 = "", this.chunk2Pos = 0, this.next = -1, this.token = ed, this.rangeIndex = 0, this.pos = this.chunkPos = t[0].from, this.range = t[0], this.end = t[t.length - 1].to, this.readNext();
  }
  /**
  @internal
  */
  resolveOffset(e, t) {
    let i = this.range, r = this.rangeIndex, s = this.pos + e;
    for (; s < i.from; ) {
      if (!r)
        return null;
      let o = this.ranges[--r];
      s -= i.from - o.to, i = o;
    }
    for (; t < 0 ? s > i.to : s >= i.to; ) {
      if (r == this.ranges.length - 1)
        return null;
      let o = this.ranges[++r];
      s += o.from - i.to, i = o;
    }
    return s;
  }
  /**
  @internal
  */
  clipPos(e) {
    if (e >= this.range.from && e < this.range.to)
      return e;
    for (let t of this.ranges)
      if (t.to > e)
        return Math.max(e, t.from);
    return this.end;
  }
  /**
  Look at a code unit near the stream position. `.peek(0)` equals
  `.next`, `.peek(-1)` gives you the previous character, and so
  on.
  
  Note that looking around during tokenizing creates dependencies
  on potentially far-away content, which may reduce the
  effectiveness incremental parsing—when looking forward—or even
  cause invalid reparses when looking backward more than 25 code
  units, since the library does not track lookbehind.
  */
  peek(e) {
    let t = this.chunkOff + e, i, r;
    if (t >= 0 && t < this.chunk.length)
      i = this.pos + e, r = this.chunk.charCodeAt(t);
    else {
      let s = this.resolveOffset(e, 1);
      if (s == null)
        return -1;
      if (i = s, i >= this.chunk2Pos && i < this.chunk2Pos + this.chunk2.length)
        r = this.chunk2.charCodeAt(i - this.chunk2Pos);
      else {
        let o = this.rangeIndex, l = this.range;
        for (; l.to <= i; )
          l = this.ranges[++o];
        this.chunk2 = this.input.chunk(this.chunk2Pos = i), i + this.chunk2.length > l.to && (this.chunk2 = this.chunk2.slice(0, l.to - i)), r = this.chunk2.charCodeAt(0);
      }
    }
    return i >= this.token.lookAhead && (this.token.lookAhead = i + 1), r;
  }
  /**
  Accept a token. By default, the end of the token is set to the
  current stream position, but you can pass an offset (relative to
  the stream position) to change that.
  */
  acceptToken(e, t = 0) {
    let i = t ? this.resolveOffset(t, -1) : this.pos;
    if (i == null || i < this.token.start)
      throw new RangeError("Token end out of bounds");
    this.token.value = e, this.token.end = i;
  }
  /**
  Accept a token ending at a specific given position.
  */
  acceptTokenTo(e, t) {
    this.token.value = e, this.token.end = t;
  }
  getChunk() {
    if (this.pos >= this.chunk2Pos && this.pos < this.chunk2Pos + this.chunk2.length) {
      let { chunk: e, chunkPos: t } = this;
      this.chunk = this.chunk2, this.chunkPos = this.chunk2Pos, this.chunk2 = e, this.chunk2Pos = t, this.chunkOff = this.pos - this.chunkPos;
    } else {
      this.chunk2 = this.chunk, this.chunk2Pos = this.chunkPos;
      let e = this.input.chunk(this.pos), t = this.pos + e.length;
      this.chunk = t > this.range.to ? e.slice(0, this.range.to - this.pos) : e, this.chunkPos = this.pos, this.chunkOff = 0;
    }
  }
  readNext() {
    return this.chunkOff >= this.chunk.length && (this.getChunk(), this.chunkOff == this.chunk.length) ? this.next = -1 : this.next = this.chunk.charCodeAt(this.chunkOff);
  }
  /**
  Move the stream forward N (defaults to 1) code units. Returns
  the new value of [`next`](#lr.InputStream.next).
  */
  advance(e = 1) {
    for (this.chunkOff += e; this.pos + e >= this.range.to; ) {
      if (this.rangeIndex == this.ranges.length - 1)
        return this.setDone();
      e -= this.range.to - this.pos, this.range = this.ranges[++this.rangeIndex], this.pos = this.range.from;
    }
    return this.pos += e, this.pos >= this.token.lookAhead && (this.token.lookAhead = this.pos + 1), this.readNext();
  }
  setDone() {
    return this.pos = this.chunkPos = this.end, this.range = this.ranges[this.rangeIndex = this.ranges.length - 1], this.chunk = "", this.next = -1;
  }
  /**
  @internal
  */
  reset(e, t) {
    if (t ? (this.token = t, t.start = e, t.lookAhead = e + 1, t.value = t.extended = -1) : this.token = ed, this.pos != e) {
      if (this.pos = e, e == this.end)
        return this.setDone(), this;
      for (; e < this.range.from; )
        this.range = this.ranges[--this.rangeIndex];
      for (; e >= this.range.to; )
        this.range = this.ranges[++this.rangeIndex];
      e >= this.chunkPos && e < this.chunkPos + this.chunk.length ? this.chunkOff = e - this.chunkPos : (this.chunk = "", this.chunkOff = 0), this.readNext();
    }
    return this;
  }
  /**
  @internal
  */
  read(e, t) {
    if (e >= this.chunkPos && t <= this.chunkPos + this.chunk.length)
      return this.chunk.slice(e - this.chunkPos, t - this.chunkPos);
    if (e >= this.chunk2Pos && t <= this.chunk2Pos + this.chunk2.length)
      return this.chunk2.slice(e - this.chunk2Pos, t - this.chunk2Pos);
    if (e >= this.range.from && t <= this.range.to)
      return this.input.read(e, t);
    let i = "";
    for (let r of this.ranges) {
      if (r.from >= t)
        break;
      r.to > e && (i += this.input.read(Math.max(r.from, e), Math.min(r.to, t)));
    }
    return i;
  }
}
class yi {
  constructor(e, t) {
    this.data = e, this.id = t;
  }
  token(e, t) {
    let { parser: i } = t.p;
    c1(this.data, e, t, this.id, i.data, i.tokenPrecTable);
  }
}
yi.prototype.contextual = yi.prototype.fallback = yi.prototype.extend = !1;
class $o {
  constructor(e, t, i) {
    this.precTable = t, this.elseToken = i, this.data = typeof e == "string" ? ur(e) : e;
  }
  token(e, t) {
    let i = e.pos, r = 0;
    for (; ; ) {
      let s = e.next < 0, o = e.resolveOffset(1, 1);
      if (c1(this.data, e, t, 0, this.data, this.precTable), e.token.value > -1)
        break;
      if (this.elseToken == null)
        return;
      if (s || r++, o == null)
        break;
      e.reset(o, e.token);
    }
    r && (e.reset(i, e.token), e.acceptToken(this.elseToken, r));
  }
}
$o.prototype.contextual = yi.prototype.fallback = yi.prototype.extend = !1;
class Dt {
  /**
  Create a tokenizer. The first argument is the function that,
  given an input stream, scans for the types of tokens it
  recognizes at the stream's position, and calls
  [`acceptToken`](#lr.InputStream.acceptToken) when it finds
  one.
  */
  constructor(e, t = {}) {
    this.token = e, this.contextual = !!t.contextual, this.fallback = !!t.fallback, this.extend = !!t.extend;
  }
}
function c1(n, e, t, i, r, s) {
  let o = 0, l = 1 << i, { dialect: a } = t.p.parser;
  e:
    for (; l & n[o]; ) {
      let h = n[o + 1];
      for (let d = o + 3; d < h; d += 2)
        if ((n[d + 1] & l) > 0) {
          let p = n[d];
          if (a.allows(p) && (e.token.value == -1 || e.token.value == p || i3(p, e.token.value, r, s))) {
            e.acceptToken(p);
            break;
          }
        }
      let u = e.next, c = 0, f = n[o + 2];
      if (e.next < 0 && f > c && n[h + f * 3 - 3] == 65535) {
        o = n[h + f * 3 - 1];
        continue e;
      }
      for (; c < f; ) {
        let d = c + f >> 1, p = h + d + (d << 1), m = n[p], O = n[p + 1] || 65536;
        if (u < m)
          f = d;
        else if (u >= O)
          c = d + 1;
        else {
          o = n[p + 2], e.advance();
          continue e;
        }
      }
      break;
    }
}
function td(n, e, t) {
  for (let i = e, r; (r = n[i]) != 65535; i++)
    if (r == t)
      return i - e;
  return -1;
}
function i3(n, e, t, i) {
  let r = td(t, i, e);
  return r < 0 || td(t, i, n) < r;
}
const at = typeof process < "u" && process.env && /\bparse\b/.test(process.env.LOG);
let zl = null;
function nd(n, e, t) {
  let i = n.cursor(be.IncludeAnonymous);
  for (i.moveTo(e); ; )
    if (!(t < 0 ? i.childBefore(e) : i.childAfter(e)))
      for (; ; ) {
        if ((t < 0 ? i.to < e : i.from > e) && !i.type.isError)
          return t < 0 ? Math.max(0, Math.min(
            i.to - 1,
            e - 25
            /* Safety.Margin */
          )) : Math.min(n.length, Math.max(
            i.from + 1,
            e + 25
            /* Safety.Margin */
          ));
        if (t < 0 ? i.prevSibling() : i.nextSibling())
          break;
        if (!i.parent())
          return t < 0 ? 0 : n.length;
      }
}
class r3 {
  constructor(e, t) {
    this.fragments = e, this.nodeSet = t, this.i = 0, this.fragment = null, this.safeFrom = -1, this.safeTo = -1, this.trees = [], this.start = [], this.index = [], this.nextFragment();
  }
  nextFragment() {
    let e = this.fragment = this.i == this.fragments.length ? null : this.fragments[this.i++];
    if (e) {
      for (this.safeFrom = e.openStart ? nd(e.tree, e.from + e.offset, 1) - e.offset : e.from, this.safeTo = e.openEnd ? nd(e.tree, e.to + e.offset, -1) - e.offset : e.to; this.trees.length; )
        this.trees.pop(), this.start.pop(), this.index.pop();
      this.trees.push(e.tree), this.start.push(-e.offset), this.index.push(0), this.nextStart = this.safeFrom;
    } else
      this.nextStart = 1e9;
  }
  // `pos` must be >= any previously given `pos` for this cursor
  nodeAt(e) {
    if (e < this.nextStart)
      return null;
    for (; this.fragment && this.safeTo <= e; )
      this.nextFragment();
    if (!this.fragment)
      return null;
    for (; ; ) {
      let t = this.trees.length - 1;
      if (t < 0)
        return this.nextFragment(), null;
      let i = this.trees[t], r = this.index[t];
      if (r == i.children.length) {
        this.trees.pop(), this.start.pop(), this.index.pop();
        continue;
      }
      let s = i.children[r], o = this.start[t] + i.positions[r];
      if (o > e)
        return this.nextStart = o, null;
      if (s instanceof ae) {
        if (o == e) {
          if (o < this.safeFrom)
            return null;
          let l = o + s.length;
          if (l <= this.safeTo) {
            let a = s.prop(F.lookAhead);
            if (!a || l + a < this.fragment.to)
              return s;
          }
        }
        this.index[t]++, o + s.length >= Math.max(this.safeFrom, e) && (this.trees.push(s), this.start.push(o), this.index.push(0));
      } else
        this.index[t]++, this.nextStart = o + s.length;
    }
  }
}
class s3 {
  constructor(e, t) {
    this.stream = t, this.tokens = [], this.mainToken = null, this.actions = [], this.tokens = e.tokenizers.map((i) => new js());
  }
  getActions(e) {
    let t = 0, i = null, { parser: r } = e.p, { tokenizers: s } = r, o = r.stateSlot(
      e.state,
      3
      /* ParseState.TokenizerMask */
    ), l = e.curContext ? e.curContext.hash : 0, a = 0;
    for (let h = 0; h < s.length; h++) {
      if (!(1 << h & o))
        continue;
      let u = s[h], c = this.tokens[h];
      if (!(i && !u.fallback) && ((u.contextual || c.start != e.pos || c.mask != o || c.context != l) && (this.updateCachedToken(c, u, e), c.mask = o, c.context = l), c.lookAhead > c.end + 25 && (a = Math.max(c.lookAhead, a)), c.value != 0)) {
        let f = t;
        if (c.extended > -1 && (t = this.addActions(e, c.extended, c.end, t)), t = this.addActions(e, c.value, c.end, t), !u.extend && (i = c, t > f))
          break;
      }
    }
    for (; this.actions.length > t; )
      this.actions.pop();
    return a && e.setLookAhead(a), !i && e.pos == this.stream.end && (i = new js(), i.value = e.p.parser.eofTerm, i.start = i.end = e.pos, t = this.addActions(e, i.value, i.end, t)), this.mainToken = i, this.actions;
  }
  getMainToken(e) {
    if (this.mainToken)
      return this.mainToken;
    let t = new js(), { pos: i, p: r } = e;
    return t.start = i, t.end = Math.min(i + 1, r.stream.end), t.value = i == r.stream.end ? r.parser.eofTerm : 0, t;
  }
  updateCachedToken(e, t, i) {
    let r = this.stream.clipPos(i.pos);
    if (t.token(this.stream.reset(r, e), i), e.value > -1) {
      let { parser: s } = i.p;
      for (let o = 0; o < s.specialized.length; o++)
        if (s.specialized[o] == e.value) {
          let l = s.specializers[o](this.stream.read(e.start, e.end), i);
          if (l >= 0 && i.p.parser.dialect.allows(l >> 1)) {
            l & 1 ? e.extended = l >> 1 : e.value = l >> 1;
            break;
          }
        }
    } else
      e.value = 0, e.end = this.stream.clipPos(r + 1);
  }
  putAction(e, t, i, r) {
    for (let s = 0; s < r; s += 3)
      if (this.actions[s] == e)
        return r;
    return this.actions[r++] = e, this.actions[r++] = t, this.actions[r++] = i, r;
  }
  addActions(e, t, i, r) {
    let { state: s } = e, { parser: o } = e.p, { data: l } = o;
    for (let a = 0; a < 2; a++)
      for (let h = o.stateSlot(
        s,
        a ? 2 : 1
        /* ParseState.Actions */
      ); ; h += 3) {
        if (l[h] == 65535)
          if (l[h + 1] == 1)
            h = rn(l, h + 2);
          else {
            r == 0 && l[h + 1] == 2 && (r = this.putAction(rn(l, h + 2), t, i, r));
            break;
          }
        l[h] == t && (r = this.putAction(rn(l, h + 1), t, i, r));
      }
    return r;
  }
}
class o3 {
  constructor(e, t, i, r) {
    this.parser = e, this.input = t, this.ranges = r, this.recovering = 0, this.nextStackID = 9812, this.minStackPos = 0, this.reused = [], this.stoppedAt = null, this.lastBigReductionStart = -1, this.lastBigReductionSize = 0, this.bigReductionCount = 0, this.stream = new n3(t, r), this.tokens = new s3(e, this.stream), this.topTerm = e.top[1];
    let { from: s } = r[0];
    this.stacks = [Po.start(this, e.top[0], s)], this.fragments = i.length && this.stream.end - s > e.bufferLength * 4 ? new r3(i, e.nodeSet) : null;
  }
  get parsedPos() {
    return this.minStackPos;
  }
  // Move the parser forward. This will process all parse stacks at
  // `this.pos` and try to advance them to a further position. If no
  // stack for such a position is found, it'll start error-recovery.
  //
  // When the parse is finished, this will return a syntax tree. When
  // not, it returns `null`.
  advance() {
    let e = this.stacks, t = this.minStackPos, i = this.stacks = [], r, s;
    if (this.bigReductionCount > 300 && e.length == 1) {
      let [o] = e;
      for (; o.forceReduce() && o.stack.length && o.stack[o.stack.length - 2] >= this.lastBigReductionStart; )
        ;
      this.bigReductionCount = this.lastBigReductionSize = 0;
    }
    for (let o = 0; o < e.length; o++) {
      let l = e[o];
      for (; ; ) {
        if (this.tokens.mainToken = null, l.pos > t)
          i.push(l);
        else {
          if (this.advanceStack(l, i, e))
            continue;
          {
            r || (r = [], s = []), r.push(l);
            let a = this.tokens.getMainToken(l);
            s.push(a.value, a.end);
          }
        }
        break;
      }
    }
    if (!i.length) {
      let o = r && a3(r);
      if (o)
        return at && console.log("Finish with " + this.stackID(o)), this.stackToTree(o);
      if (this.parser.strict)
        throw at && r && console.log("Stuck with token " + (this.tokens.mainToken ? this.parser.getName(this.tokens.mainToken.value) : "none")), new SyntaxError("No parse at " + t);
      this.recovering || (this.recovering = 5);
    }
    if (this.recovering && r) {
      let o = this.stoppedAt != null && r[0].pos > this.stoppedAt ? r[0] : this.runRecovery(r, s, i);
      if (o)
        return at && console.log("Force-finish " + this.stackID(o)), this.stackToTree(o.forceAll());
    }
    if (this.recovering) {
      let o = this.recovering == 1 ? 1 : this.recovering * 3;
      if (i.length > o)
        for (i.sort((l, a) => a.score - l.score); i.length > o; )
          i.pop();
      i.some((l) => l.reducePos > t) && this.recovering--;
    } else if (i.length > 1) {
      e:
        for (let o = 0; o < i.length - 1; o++) {
          let l = i[o];
          for (let a = o + 1; a < i.length; a++) {
            let h = i[a];
            if (l.sameState(h) || l.buffer.length > 500 && h.buffer.length > 500)
              if ((l.score - h.score || l.buffer.length - h.buffer.length) > 0)
                i.splice(a--, 1);
              else {
                i.splice(o--, 1);
                continue e;
              }
          }
        }
      i.length > 12 && i.splice(
        12,
        i.length - 12
        /* Rec.MaxStackCount */
      );
    }
    this.minStackPos = i[0].pos;
    for (let o = 1; o < i.length; o++)
      i[o].pos < this.minStackPos && (this.minStackPos = i[o].pos);
    return null;
  }
  stopAt(e) {
    if (this.stoppedAt != null && this.stoppedAt < e)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = e;
  }
  // Returns an updated version of the given stack, or null if the
  // stack can't advance normally. When `split` and `stacks` are
  // given, stacks split off by ambiguous operations will be pushed to
  // `split`, or added to `stacks` if they move `pos` forward.
  advanceStack(e, t, i) {
    let r = e.pos, { parser: s } = this, o = at ? this.stackID(e) + " -> " : "";
    if (this.stoppedAt != null && r > this.stoppedAt)
      return e.forceReduce() ? e : null;
    if (this.fragments) {
      let h = e.curContext && e.curContext.tracker.strict, u = h ? e.curContext.hash : 0;
      for (let c = this.fragments.nodeAt(r); c; ) {
        let f = this.parser.nodeSet.types[c.type.id] == c.type ? s.getGoto(e.state, c.type.id) : -1;
        if (f > -1 && c.length && (!h || (c.prop(F.contextHash) || 0) == u))
          return e.useNode(c, f), at && console.log(o + this.stackID(e) + ` (via reuse of ${s.getName(c.type.id)})`), !0;
        if (!(c instanceof ae) || c.children.length == 0 || c.positions[0] > 0)
          break;
        let d = c.children[0];
        if (d instanceof ae && c.positions[0] == 0)
          c = d;
        else
          break;
      }
    }
    let l = s.stateSlot(
      e.state,
      4
      /* ParseState.DefaultReduce */
    );
    if (l > 0)
      return e.reduce(l), at && console.log(o + this.stackID(e) + ` (via always-reduce ${s.getName(
        l & 65535
        /* Action.ValueMask */
      )})`), !0;
    if (e.stack.length >= 8400)
      for (; e.stack.length > 6e3 && e.forceReduce(); )
        ;
    let a = this.tokens.getActions(e);
    for (let h = 0; h < a.length; ) {
      let u = a[h++], c = a[h++], f = a[h++], d = h == a.length || !i, p = d ? e : e.split(), m = this.tokens.mainToken;
      if (p.apply(u, c, m ? m.start : p.pos, f), at && console.log(o + this.stackID(p) + ` (via ${u & 65536 ? `reduce of ${s.getName(
        u & 65535
        /* Action.ValueMask */
      )}` : "shift"} for ${s.getName(c)} @ ${r}${p == e ? "" : ", split"})`), d)
        return !0;
      p.pos > r ? t.push(p) : i.push(p);
    }
    return !1;
  }
  // Advance a given stack forward as far as it will go. Returns the
  // (possibly updated) stack if it got stuck, or null if it moved
  // forward and was given to `pushStackDedup`.
  advanceFully(e, t) {
    let i = e.pos;
    for (; ; ) {
      if (!this.advanceStack(e, null, null))
        return !1;
      if (e.pos > i)
        return id(e, t), !0;
    }
  }
  runRecovery(e, t, i) {
    let r = null, s = !1;
    for (let o = 0; o < e.length; o++) {
      let l = e[o], a = t[o << 1], h = t[(o << 1) + 1], u = at ? this.stackID(l) + " -> " : "";
      if (l.deadEnd && (s || (s = !0, l.restart(), at && console.log(u + this.stackID(l) + " (restarted)"), this.advanceFully(l, i))))
        continue;
      let c = l.split(), f = u;
      for (let d = 0; c.forceReduce() && d < 10 && (at && console.log(f + this.stackID(c) + " (via force-reduce)"), !this.advanceFully(c, i)); d++)
        at && (f = this.stackID(c) + " -> ");
      for (let d of l.recoverByInsert(a))
        at && console.log(u + this.stackID(d) + " (via recover-insert)"), this.advanceFully(d, i);
      this.stream.end > l.pos ? (h == l.pos && (h++, a = 0), l.recoverByDelete(a, h), at && console.log(u + this.stackID(l) + ` (via recover-delete ${this.parser.getName(a)})`), id(l, i)) : (!r || r.score < l.score) && (r = l);
    }
    return r;
  }
  // Convert the stack's buffer to a syntax tree.
  stackToTree(e) {
    return e.close(), ae.build({
      buffer: Qo.create(e),
      nodeSet: this.parser.nodeSet,
      topID: this.topTerm,
      maxBufferLength: this.parser.bufferLength,
      reused: this.reused,
      start: this.ranges[0].from,
      length: e.pos - this.ranges[0].from,
      minRepeatType: this.parser.minRepeatTerm
    });
  }
  stackID(e) {
    let t = (zl || (zl = /* @__PURE__ */ new WeakMap())).get(e);
    return t || zl.set(e, t = String.fromCodePoint(this.nextStackID++)), t + e;
  }
}
function id(n, e) {
  for (let t = 0; t < e.length; t++) {
    let i = e[t];
    if (i.pos == n.pos && i.sameState(n)) {
      e[t].score < n.score && (e[t] = n);
      return;
    }
  }
  e.push(n);
}
class l3 {
  constructor(e, t, i) {
    this.source = e, this.flags = t, this.disabled = i;
  }
  allows(e) {
    return !this.disabled || this.disabled[e] == 0;
  }
}
const Xl = (n) => n;
class f1 {
  /**
  Define a context tracker.
  */
  constructor(e) {
    this.start = e.start, this.shift = e.shift || Xl, this.reduce = e.reduce || Xl, this.reuse = e.reuse || Xl, this.hash = e.hash || (() => 0), this.strict = e.strict !== !1;
  }
}
class Zi extends Lh {
  /**
  @internal
  */
  constructor(e) {
    if (super(), this.wrappers = [], e.version != 14)
      throw new RangeError(`Parser version (${e.version}) doesn't match runtime version (14)`);
    let t = e.nodeNames.split(" ");
    this.minRepeatTerm = t.length;
    for (let l = 0; l < e.repeatNodeCount; l++)
      t.push("");
    let i = Object.keys(e.topRules).map((l) => e.topRules[l][1]), r = [];
    for (let l = 0; l < t.length; l++)
      r.push([]);
    function s(l, a, h) {
      r[l].push([a, a.deserialize(String(h))]);
    }
    if (e.nodeProps)
      for (let l of e.nodeProps) {
        let a = l[0];
        typeof a == "string" && (a = F[a]);
        for (let h = 1; h < l.length; ) {
          let u = l[h++];
          if (u >= 0)
            s(u, a, l[h++]);
          else {
            let c = l[h + -u];
            for (let f = -u; f > 0; f--)
              s(l[h++], a, c);
            h++;
          }
        }
      }
    this.nodeSet = new Nr(t.map((l, a) => ze.define({
      name: a >= this.minRepeatTerm ? void 0 : l,
      id: a,
      props: r[a],
      top: i.indexOf(a) > -1,
      error: a == 0,
      skipped: e.skippedNodes && e.skippedNodes.indexOf(a) > -1
    }))), e.propSources && (this.nodeSet = this.nodeSet.extend(...e.propSources)), this.strict = !1, this.bufferLength = Em;
    let o = ur(e.tokenData);
    this.context = e.context, this.specializerSpecs = e.specialized || [], this.specialized = new Uint16Array(this.specializerSpecs.length);
    for (let l = 0; l < this.specializerSpecs.length; l++)
      this.specialized[l] = this.specializerSpecs[l].term;
    this.specializers = this.specializerSpecs.map(rd), this.states = ur(e.states, Uint32Array), this.data = ur(e.stateData), this.goto = ur(e.goto), this.maxTerm = e.maxTerm, this.tokenizers = e.tokenizers.map((l) => typeof l == "number" ? new yi(o, l) : l), this.topRules = e.topRules, this.dialects = e.dialects || {}, this.dynamicPrecedences = e.dynamicPrecedences || null, this.tokenPrecTable = e.tokenPrec, this.termNames = e.termNames || null, this.maxNode = this.nodeSet.types.length - 1, this.dialect = this.parseDialect(), this.top = this.topRules[Object.keys(this.topRules)[0]];
  }
  createParse(e, t, i) {
    let r = new o3(this, e, t, i);
    for (let s of this.wrappers)
      r = s(r, e, t, i);
    return r;
  }
  /**
  Get a goto table entry @internal
  */
  getGoto(e, t, i = !1) {
    let r = this.goto;
    if (t >= r[0])
      return -1;
    for (let s = r[t + 1]; ; ) {
      let o = r[s++], l = o & 1, a = r[s++];
      if (l && i)
        return a;
      for (let h = s + (o >> 1); s < h; s++)
        if (r[s] == e)
          return a;
      if (l)
        return -1;
    }
  }
  /**
  Check if this state has an action for a given terminal @internal
  */
  hasAction(e, t) {
    let i = this.data;
    for (let r = 0; r < 2; r++)
      for (let s = this.stateSlot(
        e,
        r ? 2 : 1
        /* ParseState.Actions */
      ), o; ; s += 3) {
        if ((o = i[s]) == 65535)
          if (i[s + 1] == 1)
            o = i[s = rn(i, s + 2)];
          else {
            if (i[s + 1] == 2)
              return rn(i, s + 2);
            break;
          }
        if (o == t || o == 0)
          return rn(i, s + 1);
      }
    return 0;
  }
  /**
  @internal
  */
  stateSlot(e, t) {
    return this.states[e * 6 + t];
  }
  /**
  @internal
  */
  stateFlag(e, t) {
    return (this.stateSlot(
      e,
      0
      /* ParseState.Flags */
    ) & t) > 0;
  }
  /**
  @internal
  */
  validAction(e, t) {
    return !!this.allActions(e, (i) => i == t ? !0 : null);
  }
  /**
  @internal
  */
  allActions(e, t) {
    let i = this.stateSlot(
      e,
      4
      /* ParseState.DefaultReduce */
    ), r = i ? t(i) : void 0;
    for (let s = this.stateSlot(
      e,
      1
      /* ParseState.Actions */
    ); r == null; s += 3) {
      if (this.data[s] == 65535)
        if (this.data[s + 1] == 1)
          s = rn(this.data, s + 2);
        else
          break;
      r = t(rn(this.data, s + 1));
    }
    return r;
  }
  /**
  Get the states that can follow this one through shift actions or
  goto jumps. @internal
  */
  nextStates(e) {
    let t = [];
    for (let i = this.stateSlot(
      e,
      1
      /* ParseState.Actions */
    ); ; i += 3) {
      if (this.data[i] == 65535)
        if (this.data[i + 1] == 1)
          i = rn(this.data, i + 2);
        else
          break;
      if (!(this.data[i + 2] & 1)) {
        let r = this.data[i + 1];
        t.some((s, o) => o & 1 && s == r) || t.push(this.data[i], r);
      }
    }
    return t;
  }
  /**
  Configure the parser. Returns a new parser instance that has the
  given settings modified. Settings not provided in `config` are
  kept from the original parser.
  */
  configure(e) {
    let t = Object.assign(Object.create(Zi.prototype), this);
    if (e.props && (t.nodeSet = this.nodeSet.extend(...e.props)), e.top) {
      let i = this.topRules[e.top];
      if (!i)
        throw new RangeError(`Invalid top rule name ${e.top}`);
      t.top = i;
    }
    return e.tokenizers && (t.tokenizers = this.tokenizers.map((i) => {
      let r = e.tokenizers.find((s) => s.from == i);
      return r ? r.to : i;
    })), e.specializers && (t.specializers = this.specializers.slice(), t.specializerSpecs = this.specializerSpecs.map((i, r) => {
      let s = e.specializers.find((l) => l.from == i.external);
      if (!s)
        return i;
      let o = Object.assign(Object.assign({}, i), { external: s.to });
      return t.specializers[r] = rd(o), o;
    })), e.contextTracker && (t.context = e.contextTracker), e.dialect && (t.dialect = this.parseDialect(e.dialect)), e.strict != null && (t.strict = e.strict), e.wrap && (t.wrappers = t.wrappers.concat(e.wrap)), e.bufferLength != null && (t.bufferLength = e.bufferLength), t;
  }
  /**
  Tells you whether any [parse wrappers](#lr.ParserConfig.wrap)
  are registered for this parser.
  */
  hasWrappers() {
    return this.wrappers.length > 0;
  }
  /**
  Returns the name associated with a given term. This will only
  work for all terms when the parser was generated with the
  `--names` option. By default, only the names of tagged terms are
  stored.
  */
  getName(e) {
    return this.termNames ? this.termNames[e] : String(e <= this.maxNode && this.nodeSet.types[e].name || e);
  }
  /**
  The eof term id is always allocated directly after the node
  types. @internal
  */
  get eofTerm() {
    return this.maxNode + 1;
  }
  /**
  The type of top node produced by the parser.
  */
  get topNode() {
    return this.nodeSet.types[this.top[1]];
  }
  /**
  @internal
  */
  dynamicPrecedence(e) {
    let t = this.dynamicPrecedences;
    return t == null ? 0 : t[e] || 0;
  }
  /**
  @internal
  */
  parseDialect(e) {
    let t = Object.keys(this.dialects), i = t.map(() => !1);
    if (e)
      for (let s of e.split(" ")) {
        let o = t.indexOf(s);
        o >= 0 && (i[o] = !0);
      }
    let r = null;
    for (let s = 0; s < t.length; s++)
      if (!i[s])
        for (let o = this.dialects[t[s]], l; (l = this.data[o++]) != 65535; )
          (r || (r = new Uint8Array(this.maxTerm + 1)))[l] = 1;
    return new l3(e, i, r);
  }
  /**
  Used by the output of the parser generator. Not available to
  user code. @hide
  */
  static deserialize(e) {
    return new Zi(e);
  }
}
function rn(n, e) {
  return n[e] | n[e + 1] << 16;
}
function a3(n) {
  let e = null;
  for (let t of n) {
    let i = t.p.stoppedAt;
    (t.pos == t.p.stream.end || i != null && t.pos > i) && t.p.parser.stateFlag(
      t.state,
      2
      /* StateFlag.Accepting */
    ) && (!e || e.score < t.score) && (e = t);
  }
  return e;
}
function rd(n) {
  if (n.external) {
    let e = n.extend ? 1 : 0;
    return (t, i) => n.external(t, i) << 1 | e;
  }
  return n.get;
}
const h3 = 54, u3 = 1, c3 = 55, f3 = 2, d3 = 56, p3 = 3, sd = 4, m3 = 5, Co = 6, d1 = 7, p1 = 8, m1 = 9, O1 = 10, O3 = 11, g3 = 12, b3 = 13, Dl = 57, y3 = 14, od = 58, g1 = 20, k3 = 22, b1 = 23, x3 = 24, ah = 26, y1 = 27, w3 = 28, S3 = 31, v3 = 34, P3 = 36, Q3 = 37, $3 = 0, C3 = 1, T3 = {
  area: !0,
  base: !0,
  br: !0,
  col: !0,
  command: !0,
  embed: !0,
  frame: !0,
  hr: !0,
  img: !0,
  input: !0,
  keygen: !0,
  link: !0,
  meta: !0,
  param: !0,
  source: !0,
  track: !0,
  wbr: !0,
  menuitem: !0
}, A3 = {
  dd: !0,
  li: !0,
  optgroup: !0,
  option: !0,
  p: !0,
  rp: !0,
  rt: !0,
  tbody: !0,
  td: !0,
  tfoot: !0,
  th: !0,
  tr: !0
}, ld = {
  dd: { dd: !0, dt: !0 },
  dt: { dd: !0, dt: !0 },
  li: { li: !0 },
  option: { option: !0, optgroup: !0 },
  optgroup: { optgroup: !0 },
  p: {
    address: !0,
    article: !0,
    aside: !0,
    blockquote: !0,
    dir: !0,
    div: !0,
    dl: !0,
    fieldset: !0,
    footer: !0,
    form: !0,
    h1: !0,
    h2: !0,
    h3: !0,
    h4: !0,
    h5: !0,
    h6: !0,
    header: !0,
    hgroup: !0,
    hr: !0,
    menu: !0,
    nav: !0,
    ol: !0,
    p: !0,
    pre: !0,
    section: !0,
    table: !0,
    ul: !0
  },
  rp: { rp: !0, rt: !0 },
  rt: { rp: !0, rt: !0 },
  tbody: { tbody: !0, tfoot: !0 },
  td: { td: !0, th: !0 },
  tfoot: { tbody: !0 },
  th: { td: !0, th: !0 },
  thead: { tbody: !0, tfoot: !0 },
  tr: { tr: !0 }
};
function R3(n) {
  return n == 45 || n == 46 || n == 58 || n >= 65 && n <= 90 || n == 95 || n >= 97 && n <= 122 || n >= 161;
}
function k1(n) {
  return n == 9 || n == 10 || n == 13 || n == 32;
}
let ad = null, hd = null, ud = 0;
function hh(n, e) {
  let t = n.pos + e;
  if (ud == t && hd == n)
    return ad;
  let i = n.peek(e);
  for (; k1(i); )
    i = n.peek(++e);
  let r = "";
  for (; R3(i); )
    r += String.fromCharCode(i), i = n.peek(++e);
  return hd = n, ud = t, ad = r ? r.toLowerCase() : i == Z3 || i == M3 ? void 0 : null;
}
const x1 = 60, To = 62, pu = 47, Z3 = 63, M3 = 33, E3 = 45;
function cd(n, e) {
  this.name = n, this.parent = e, this.hash = e ? e.hash : 0;
  for (let t = 0; t < n.length; t++)
    this.hash += (this.hash << 4) + n.charCodeAt(t) + (n.charCodeAt(t) << 8);
}
const z3 = [Co, O1, d1, p1, m1], X3 = new f1({
  start: null,
  shift(n, e, t, i) {
    return z3.indexOf(e) > -1 ? new cd(hh(i, 1) || "", n) : n;
  },
  reduce(n, e) {
    return e == g1 && n ? n.parent : n;
  },
  reuse(n, e, t, i) {
    let r = e.type.id;
    return r == Co || r == P3 ? new cd(hh(i, 1) || "", n) : n;
  },
  hash(n) {
    return n ? n.hash : 0;
  },
  strict: !1
}), D3 = new Dt((n, e) => {
  if (n.next != x1) {
    n.next < 0 && e.context && n.acceptToken(Dl);
    return;
  }
  n.advance();
  let t = n.next == pu;
  t && n.advance();
  let i = hh(n, 0);
  if (i === void 0)
    return;
  if (!i)
    return n.acceptToken(t ? y3 : Co);
  let r = e.context ? e.context.name : null;
  if (t) {
    if (i == r)
      return n.acceptToken(O3);
    if (r && A3[r])
      return n.acceptToken(Dl, -2);
    if (e.dialectEnabled($3))
      return n.acceptToken(g3);
    for (let s = e.context; s; s = s.parent)
      if (s.name == i)
        return;
    n.acceptToken(b3);
  } else {
    if (i == "script")
      return n.acceptToken(d1);
    if (i == "style")
      return n.acceptToken(p1);
    if (i == "textarea")
      return n.acceptToken(m1);
    if (T3.hasOwnProperty(i))
      return n.acceptToken(O1);
    r && ld[r] && ld[r][i] ? n.acceptToken(Dl, -1) : n.acceptToken(Co);
  }
}, { contextual: !0 }), L3 = new Dt((n) => {
  for (let e = 0, t = 0; ; t++) {
    if (n.next < 0) {
      t && n.acceptToken(od);
      break;
    }
    if (n.next == E3)
      e++;
    else if (n.next == To && e >= 2) {
      t >= 3 && n.acceptToken(od, -2);
      break;
    } else
      e = 0;
    n.advance();
  }
});
function I3(n) {
  for (; n; n = n.parent)
    if (n.name == "svg" || n.name == "math")
      return !0;
  return !1;
}
const _3 = new Dt((n, e) => {
  if (n.next == pu && n.peek(1) == To) {
    let t = e.dialectEnabled(C3) || I3(e.context);
    n.acceptToken(t ? m3 : sd, 2);
  } else
    n.next == To && n.acceptToken(sd, 1);
});
function mu(n, e, t) {
  let i = 2 + n.length;
  return new Dt((r) => {
    for (let s = 0, o = 0, l = 0; ; l++) {
      if (r.next < 0) {
        l && r.acceptToken(e);
        break;
      }
      if (s == 0 && r.next == x1 || s == 1 && r.next == pu || s >= 2 && s < i && r.next == n.charCodeAt(s - 2))
        s++, o++;
      else if ((s == 2 || s == i) && k1(r.next))
        o++;
      else if (s == i && r.next == To) {
        l > o ? r.acceptToken(e, -o) : r.acceptToken(t, -(o - 2));
        break;
      } else if ((r.next == 10 || r.next == 13) && l) {
        r.acceptToken(e, 1);
        break;
      } else
        s = o = 0;
      r.advance();
    }
  });
}
const q3 = mu("script", h3, u3), W3 = mu("style", c3, f3), B3 = mu("textarea", d3, p3), V3 = Xi({
  "Text RawText": k.content,
  "StartTag StartCloseTag SelfClosingEndTag EndTag": k.angleBracket,
  TagName: k.tagName,
  "MismatchedCloseTag/TagName": [k.tagName, k.invalid],
  AttributeName: k.attributeName,
  "AttributeValue UnquotedAttributeValue": k.attributeValue,
  Is: k.definitionOperator,
  "EntityReference CharacterReference": k.character,
  Comment: k.blockComment,
  ProcessingInst: k.processingInstruction,
  DoctypeDecl: k.documentMeta
}), Y3 = Zi.deserialize({
  version: 14,
  states: ",xOVO!rOOO!WQ#tO'#CqO!]Q#tO'#CzO!bQ#tO'#C}O!gQ#tO'#DQO!lQ#tO'#DSO!qOaO'#CpO!|ObO'#CpO#XOdO'#CpO$eO!rO'#CpOOO`'#Cp'#CpO$lO$fO'#DTO$tQ#tO'#DVO$yQ#tO'#DWOOO`'#Dk'#DkOOO`'#DY'#DYQVO!rOOO%OQ&rO,59]O%ZQ&rO,59fO%fQ&rO,59iO%qQ&rO,59lO%|Q&rO,59nOOOa'#D^'#D^O&XOaO'#CxO&dOaO,59[OOOb'#D_'#D_O&lObO'#C{O&wObO,59[OOOd'#D`'#D`O'POdO'#DOO'[OdO,59[OOO`'#Da'#DaO'dO!rO,59[O'kQ#tO'#DROOO`,59[,59[OOOp'#Db'#DbO'pO$fO,59oOOO`,59o,59oO'xQ#|O,59qO'}Q#|O,59rOOO`-E7W-E7WO(SQ&rO'#CsOOQW'#DZ'#DZO(bQ&rO1G.wOOOa1G.w1G.wOOO`1G/Y1G/YO(mQ&rO1G/QOOOb1G/Q1G/QO(xQ&rO1G/TOOOd1G/T1G/TO)TQ&rO1G/WOOO`1G/W1G/WO)`Q&rO1G/YOOOa-E7[-E7[O)kQ#tO'#CyOOO`1G.v1G.vOOOb-E7]-E7]O)pQ#tO'#C|OOOd-E7^-E7^O)uQ#tO'#DPOOO`-E7_-E7_O)zQ#|O,59mOOOp-E7`-E7`OOO`1G/Z1G/ZOOO`1G/]1G/]OOO`1G/^1G/^O*PQ,UO,59_OOQW-E7X-E7XOOOa7+$c7+$cOOO`7+$t7+$tOOOb7+$l7+$lOOOd7+$o7+$oOOO`7+$r7+$rO*[Q#|O,59eO*aQ#|O,59hO*fQ#|O,59kOOO`1G/X1G/XO*kO7[O'#CvO*|OMhO'#CvOOQW1G.y1G.yOOO`1G/P1G/POOO`1G/S1G/SOOO`1G/V1G/VOOOO'#D['#D[O+_O7[O,59bOOQW,59b,59bOOOO'#D]'#D]O+pOMhO,59bOOOO-E7Y-E7YOOQW1G.|1G.|OOOO-E7Z-E7Z",
  stateData: ",]~O!^OS~OUSOVPOWQOXROYTO[]O][O^^O`^Oa^Ob^Oc^Ox^O{_O!dZO~OfaO~OfbO~OfcO~OfdO~OfeO~O!WfOPlP!ZlP~O!XiOQoP!ZoP~O!YlORrP!ZrP~OUSOVPOWQOXROYTOZqO[]O][O^^O`^Oa^Ob^Oc^Ox^O!dZO~O!ZrO~P#dO![sO!euO~OfvO~OfwO~OS|OT}OhyO~OS!POT}OhyO~OS!ROT}OhyO~OS!TOT}OhyO~OS}OT}OhyO~O!WfOPlX!ZlX~OP!WO!Z!XO~O!XiOQoX!ZoX~OQ!ZO!Z!XO~O!YlORrX!ZrX~OR!]O!Z!XO~O!Z!XO~P#dOf!_O~O![sO!e!aO~OS!bO~OS!cO~Oi!dOSgXTgXhgX~OS!fOT!gOhyO~OS!hOT!gOhyO~OS!iOT!gOhyO~OS!jOT!gOhyO~OS!gOT!gOhyO~Of!kO~Of!lO~Of!mO~OS!nO~Ok!qO!`!oO!b!pO~OS!rO~OS!sO~OS!tO~Oa!uOb!uOc!uO!`!wO!a!uO~Oa!xOb!xOc!xO!b!wO!c!xO~Oa!uOb!uOc!uO!`!{O!a!uO~Oa!xOb!xOc!xO!b!{O!c!xO~OT~bac!dx{!d~",
  goto: "%p!`PPPPPPPPPPPPPPPPPPPP!a!gP!mPP!yP!|#P#S#Y#]#`#f#i#l#r#x!aP!a!aP$O$U$l$r$x%O%U%[%bPPPPPPPP%hX^OX`pXUOX`pezabcde{!O!Q!S!UR!q!dRhUR!XhXVOX`pRkVR!XkXWOX`pRnWR!XnXXOX`pQrXR!XpXYOX`pQ`ORx`Q{aQ!ObQ!QcQ!SdQ!UeZ!e{!O!Q!S!UQ!v!oR!z!vQ!y!pR!|!yQgUR!VgQjVR!YjQmWR![mQpXR!^pQtZR!`tS_O`ToXp",
  nodeNames: "⚠ StartCloseTag StartCloseTag StartCloseTag EndTag SelfClosingEndTag StartTag StartTag StartTag StartTag StartTag StartCloseTag StartCloseTag StartCloseTag IncompleteCloseTag Document Text EntityReference CharacterReference InvalidEntity Element OpenTag TagName Attribute AttributeName Is AttributeValue UnquotedAttributeValue ScriptText CloseTag OpenTag StyleText CloseTag OpenTag TextareaText CloseTag OpenTag CloseTag SelfClosingTag Comment ProcessingInst MismatchedCloseTag CloseTag DoctypeDecl",
  maxTerm: 67,
  context: X3,
  nodeProps: [
    ["closedBy", -10, 1, 2, 3, 7, 8, 9, 10, 11, 12, 13, "EndTag", 6, "EndTag SelfClosingEndTag", -4, 21, 30, 33, 36, "CloseTag"],
    ["openedBy", 4, "StartTag StartCloseTag", 5, "StartTag", -4, 29, 32, 35, 37, "OpenTag"],
    ["group", -9, 14, 17, 18, 19, 20, 39, 40, 41, 42, "Entity", 16, "Entity TextContent", -3, 28, 31, 34, "TextContent Entity"],
    ["isolate", -11, 21, 29, 30, 32, 33, 35, 36, 37, 38, 41, 42, "ltr", -3, 26, 27, 39, ""]
  ],
  propSources: [V3],
  skippedNodes: [0],
  repeatNodeCount: 9,
  tokenData: "!<p!aR!YOX$qXY,QYZ,QZ[$q[]&X]^,Q^p$qpq,Qqr-_rs3_sv-_vw3}wxHYx}-_}!OH{!O!P-_!P!Q$q!Q![-_![!]Mz!]!^-_!^!_!$S!_!`!;x!`!a&X!a!c-_!c!}Mz!}#R-_#R#SMz#S#T1k#T#oMz#o#s-_#s$f$q$f%W-_%W%oMz%o%p-_%p&aMz&a&b-_&b1pMz1p4U-_4U4dMz4d4e-_4e$ISMz$IS$I`-_$I`$IbMz$Ib$Kh-_$Kh%#tMz%#t&/x-_&/x&EtMz&Et&FV-_&FV;'SMz;'S;:j!#|;:j;=`3X<%l?&r-_?&r?AhMz?Ah?BY$q?BY?MnMz?MnO$q!Z$|c`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr$qrs&}sv$qvw+Pwx(tx!^$q!^!_*V!_!a&X!a#S$q#S#T&X#T;'S$q;'S;=`+z<%lO$q!R&bX`P!a`!cpOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&Xq'UV`P!cpOv&}wx'kx!^&}!^!_(V!_;'S&};'S;=`(n<%lO&}P'pT`POv'kw!^'k!_;'S'k;'S;=`(P<%lO'kP(SP;=`<%l'kp([S!cpOv(Vx;'S(V;'S;=`(h<%lO(Vp(kP;=`<%l(Vq(qP;=`<%l&}a({W`P!a`Or(trs'ksv(tw!^(t!^!_)e!_;'S(t;'S;=`*P<%lO(t`)jT!a`Or)esv)ew;'S)e;'S;=`)y<%lO)e`)|P;=`<%l)ea*SP;=`<%l(t!Q*^V!a`!cpOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!Q*vP;=`<%l*V!R*|P;=`<%l&XW+UYkWOX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+PW+wP;=`<%l+P!Z+}P;=`<%l$q!a,]``P!a`!cp!^^OX&XXY,QYZ,QZ]&X]^,Q^p&Xpq,Qqr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X!_-ljhS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx!P-_!P!Q$q!Q!^-_!^!_*V!_!a&X!a#S-_#S#T1k#T#s-_#s$f$q$f;'S-_;'S;=`3X<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q[/ebhSkWOX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!a#S/^#S#T0m#T#s/^#s$f+P$f;'S/^;'S;=`1e<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+PS0rXhSqr0msw0mx!P0m!Q!^0m!a#s0m$f;'S0m;'S;=`1_<%l?Ah0m?BY?Mn0mS1bP;=`<%l0m[1hP;=`<%l/^!V1vchS`P!a`!cpOq&Xqr1krs&}sv1kvw0mwx(tx!P1k!P!Q&X!Q!^1k!^!_*V!_!a&X!a#s1k#s$f&X$f;'S1k;'S;=`3R<%l?Ah1k?Ah?BY&X?BY?Mn1k?MnO&X!V3UP;=`<%l1k!_3[P;=`<%l-_!Z3hV!`h`P!cpOv&}wx'kx!^&}!^!_(V!_;'S&};'S;=`(n<%lO&}!_4WihSkWc!ROX5uXZ7SZ[5u[^7S^p5uqr8trs7Sst>]tw8twx7Sx!P8t!P!Q5u!Q!]8t!]!^/^!^!a7S!a#S8t#S#T;{#T#s8t#s$f5u$f;'S8t;'S;=`>V<%l?Ah8t?Ah?BY5u?BY?Mn8t?MnO5u!Z5zbkWOX5uXZ7SZ[5u[^7S^p5uqr5urs7Sst+Ptw5uwx7Sx!]5u!]!^7w!^!a7S!a#S5u#S#T7S#T;'S5u;'S;=`8n<%lO5u!R7VVOp7Sqs7St!]7S!]!^7l!^;'S7S;'S;=`7q<%lO7S!R7qOa!R!R7tP;=`<%l7S!Z8OYkWa!ROX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+P!Z8qP;=`<%l5u!_8{ihSkWOX5uXZ7SZ[5u[^7S^p5uqr8trs7Sst/^tw8twx7Sx!P8t!P!Q5u!Q!]8t!]!^:j!^!a7S!a#S8t#S#T;{#T#s8t#s$f5u$f;'S8t;'S;=`>V<%l?Ah8t?Ah?BY5u?BY?Mn8t?MnO5u!_:sbhSkWa!ROX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!a#S/^#S#T0m#T#s/^#s$f+P$f;'S/^;'S;=`1e<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+P!V<QchSOp7Sqr;{rs7Sst0mtw;{wx7Sx!P;{!P!Q7S!Q!];{!]!^=]!^!a7S!a#s;{#s$f7S$f;'S;{;'S;=`>P<%l?Ah;{?Ah?BY7S?BY?Mn;{?MnO7S!V=dXhSa!Rqr0msw0mx!P0m!Q!^0m!a#s0m$f;'S0m;'S;=`1_<%l?Ah0m?BY?Mn0m!V>SP;=`<%l;{!_>YP;=`<%l8t!_>dhhSkWOX@OXZAYZ[@O[^AY^p@OqrBwrsAYswBwwxAYx!PBw!P!Q@O!Q!]Bw!]!^/^!^!aAY!a#SBw#S#TE{#T#sBw#s$f@O$f;'SBw;'S;=`HS<%l?AhBw?Ah?BY@O?BY?MnBw?MnO@O!Z@TakWOX@OXZAYZ[@O[^AY^p@Oqr@OrsAYsw@OwxAYx!]@O!]!^Az!^!aAY!a#S@O#S#TAY#T;'S@O;'S;=`Bq<%lO@O!RA]UOpAYq!]AY!]!^Ao!^;'SAY;'S;=`At<%lOAY!RAtOb!R!RAwP;=`<%lAY!ZBRYkWb!ROX+PZ[+P^p+Pqr+Psw+Px!^+P!a#S+P#T;'S+P;'S;=`+t<%lO+P!ZBtP;=`<%l@O!_COhhSkWOX@OXZAYZ[@O[^AY^p@OqrBwrsAYswBwwxAYx!PBw!P!Q@O!Q!]Bw!]!^Dj!^!aAY!a#SBw#S#TE{#T#sBw#s$f@O$f;'SBw;'S;=`HS<%l?AhBw?Ah?BY@O?BY?MnBw?MnO@O!_DsbhSkWb!ROX+PZ[+P^p+Pqr/^sw/^x!P/^!P!Q+P!Q!^/^!a#S/^#S#T0m#T#s/^#s$f+P$f;'S/^;'S;=`1e<%l?Ah/^?Ah?BY+P?BY?Mn/^?MnO+P!VFQbhSOpAYqrE{rsAYswE{wxAYx!PE{!P!QAY!Q!]E{!]!^GY!^!aAY!a#sE{#s$fAY$f;'SE{;'S;=`G|<%l?AhE{?Ah?BYAY?BY?MnE{?MnOAY!VGaXhSb!Rqr0msw0mx!P0m!Q!^0m!a#s0m$f;'S0m;'S;=`1_<%l?Ah0m?BY?Mn0m!VHPP;=`<%lE{!_HVP;=`<%lBw!ZHcW!bx`P!a`Or(trs'ksv(tw!^(t!^!_)e!_;'S(t;'S;=`*P<%lO(t!aIYlhS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx}-_}!OKQ!O!P-_!P!Q$q!Q!^-_!^!_*V!_!a&X!a#S-_#S#T1k#T#s-_#s$f$q$f;'S-_;'S;=`3X<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q!aK_khS`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx!P-_!P!Q$q!Q!^-_!^!_*V!_!`&X!`!aMS!a#S-_#S#T1k#T#s-_#s$f$q$f;'S-_;'S;=`3X<%l?Ah-_?Ah?BY$q?BY?Mn-_?MnO$q!TM_X`P!a`!cp!eQOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X!aNZ!ZhSfQ`PkW!a`!cpOX$qXZ&XZ[$q[^&X^p$qpq&Xqr-_rs&}sv-_vw/^wx(tx}-_}!OMz!O!PMz!P!Q$q!Q![Mz![!]Mz!]!^-_!^!_*V!_!a&X!a!c-_!c!}Mz!}#R-_#R#SMz#S#T1k#T#oMz#o#s-_#s$f$q$f$}-_$}%OMz%O%W-_%W%oMz%o%p-_%p&aMz&a&b-_&b1pMz1p4UMz4U4dMz4d4e-_4e$ISMz$IS$I`-_$I`$IbMz$Ib$Je-_$Je$JgMz$Jg$Kh-_$Kh%#tMz%#t&/x-_&/x&EtMz&Et&FV-_&FV;'SMz;'S;:j!#|;:j;=`3X<%l?&r-_?&r?AhMz?Ah?BY$q?BY?MnMz?MnO$q!a!$PP;=`<%lMz!R!$ZY!a`!cpOq*Vqr!$yrs(Vsv*Vwx)ex!a*V!a!b!4t!b;'S*V;'S;=`*s<%lO*V!R!%Q]!a`!cpOr*Vrs(Vsv*Vwx)ex}*V}!O!%y!O!f*V!f!g!']!g#W*V#W#X!0`#X;'S*V;'S;=`*s<%lO*V!R!&QX!a`!cpOr*Vrs(Vsv*Vwx)ex}*V}!O!&m!O;'S*V;'S;=`*s<%lO*V!R!&vV!a`!cp!dPOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!'dX!a`!cpOr*Vrs(Vsv*Vwx)ex!q*V!q!r!(P!r;'S*V;'S;=`*s<%lO*V!R!(WX!a`!cpOr*Vrs(Vsv*Vwx)ex!e*V!e!f!(s!f;'S*V;'S;=`*s<%lO*V!R!(zX!a`!cpOr*Vrs(Vsv*Vwx)ex!v*V!v!w!)g!w;'S*V;'S;=`*s<%lO*V!R!)nX!a`!cpOr*Vrs(Vsv*Vwx)ex!{*V!{!|!*Z!|;'S*V;'S;=`*s<%lO*V!R!*bX!a`!cpOr*Vrs(Vsv*Vwx)ex!r*V!r!s!*}!s;'S*V;'S;=`*s<%lO*V!R!+UX!a`!cpOr*Vrs(Vsv*Vwx)ex!g*V!g!h!+q!h;'S*V;'S;=`*s<%lO*V!R!+xY!a`!cpOr!+qrs!,hsv!+qvw!-Swx!.[x!`!+q!`!a!/j!a;'S!+q;'S;=`!0Y<%lO!+qq!,mV!cpOv!,hvx!-Sx!`!,h!`!a!-q!a;'S!,h;'S;=`!.U<%lO!,hP!-VTO!`!-S!`!a!-f!a;'S!-S;'S;=`!-k<%lO!-SP!-kO{PP!-nP;=`<%l!-Sq!-xS!cp{POv(Vx;'S(V;'S;=`(h<%lO(Vq!.XP;=`<%l!,ha!.aX!a`Or!.[rs!-Ssv!.[vw!-Sw!`!.[!`!a!.|!a;'S!.[;'S;=`!/d<%lO!.[a!/TT!a`{POr)esv)ew;'S)e;'S;=`)y<%lO)ea!/gP;=`<%l!.[!R!/sV!a`!cp{POr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!0]P;=`<%l!+q!R!0gX!a`!cpOr*Vrs(Vsv*Vwx)ex#c*V#c#d!1S#d;'S*V;'S;=`*s<%lO*V!R!1ZX!a`!cpOr*Vrs(Vsv*Vwx)ex#V*V#V#W!1v#W;'S*V;'S;=`*s<%lO*V!R!1}X!a`!cpOr*Vrs(Vsv*Vwx)ex#h*V#h#i!2j#i;'S*V;'S;=`*s<%lO*V!R!2qX!a`!cpOr*Vrs(Vsv*Vwx)ex#m*V#m#n!3^#n;'S*V;'S;=`*s<%lO*V!R!3eX!a`!cpOr*Vrs(Vsv*Vwx)ex#d*V#d#e!4Q#e;'S*V;'S;=`*s<%lO*V!R!4XX!a`!cpOr*Vrs(Vsv*Vwx)ex#X*V#X#Y!+q#Y;'S*V;'S;=`*s<%lO*V!R!4{Y!a`!cpOr!4trs!5ksv!4tvw!6Vwx!8]x!a!4t!a!b!:]!b;'S!4t;'S;=`!;r<%lO!4tq!5pV!cpOv!5kvx!6Vx!a!5k!a!b!7W!b;'S!5k;'S;=`!8V<%lO!5kP!6YTO!a!6V!a!b!6i!b;'S!6V;'S;=`!7Q<%lO!6VP!6lTO!`!6V!`!a!6{!a;'S!6V;'S;=`!7Q<%lO!6VP!7QOxPP!7TP;=`<%l!6Vq!7]V!cpOv!5kvx!6Vx!`!5k!`!a!7r!a;'S!5k;'S;=`!8V<%lO!5kq!7yS!cpxPOv(Vx;'S(V;'S;=`(h<%lO(Vq!8YP;=`<%l!5ka!8bX!a`Or!8]rs!6Vsv!8]vw!6Vw!a!8]!a!b!8}!b;'S!8];'S;=`!:V<%lO!8]a!9SX!a`Or!8]rs!6Vsv!8]vw!6Vw!`!8]!`!a!9o!a;'S!8];'S;=`!:V<%lO!8]a!9vT!a`xPOr)esv)ew;'S)e;'S;=`)y<%lO)ea!:YP;=`<%l!8]!R!:dY!a`!cpOr!4trs!5ksv!4tvw!6Vwx!8]x!`!4t!`!a!;S!a;'S!4t;'S;=`!;r<%lO!4t!R!;]V!a`!cpxPOr*Vrs(Vsv*Vwx)ex;'S*V;'S;=`*s<%lO*V!R!;uP;=`<%l!4t!V!<TXiS`P!a`!cpOr&Xrs&}sv&Xwx(tx!^&X!^!_*V!_;'S&X;'S;=`*y<%lO&X",
  tokenizers: [q3, W3, B3, _3, D3, L3, 0, 1, 2, 3, 4, 5],
  topRules: { Document: [0, 15] },
  dialects: { noMatch: 0, selfClosing: 509 },
  tokenPrec: 511
});
function w1(n, e) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let i of n.getChildren(b1)) {
    let r = i.getChild(x3), s = i.getChild(ah) || i.getChild(y1);
    r && (t[e.read(r.from, r.to)] = s ? s.type.id == ah ? e.read(s.from + 1, s.to - 1) : e.read(s.from, s.to) : "");
  }
  return t;
}
function fd(n, e) {
  let t = n.getChild(k3);
  return t ? e.read(t.from, t.to) : " ";
}
function Ll(n, e, t) {
  let i;
  for (let r of t)
    if (!r.attrs || r.attrs(i || (i = w1(n.node.parent.firstChild, e))))
      return { parser: r.parser };
  return null;
}
function S1(n = [], e = []) {
  let t = [], i = [], r = [], s = [];
  for (let l of n)
    (l.tag == "script" ? t : l.tag == "style" ? i : l.tag == "textarea" ? r : s).push(l);
  let o = e.length ? /* @__PURE__ */ Object.create(null) : null;
  for (let l of e)
    (o[l.name] || (o[l.name] = [])).push(l);
  return Im((l, a) => {
    let h = l.type.id;
    if (h == w3)
      return Ll(l, a, t);
    if (h == S3)
      return Ll(l, a, i);
    if (h == v3)
      return Ll(l, a, r);
    if (h == g1 && s.length) {
      let u = l.node, c = u.firstChild, f = c && fd(c, a), d;
      if (f) {
        for (let p of s)
          if (p.tag == f && (!p.attrs || p.attrs(d || (d = w1(u, a))))) {
            let m = u.lastChild, O = m.type.id == Q3 ? m.from : u.to;
            if (O > c.to)
              return { parser: p.parser, overlay: [{ from: c.to, to: O }] };
          }
      }
    }
    if (o && h == b1) {
      let u = l.node, c;
      if (c = u.firstChild) {
        let f = o[a.read(c.from, c.to)];
        if (f)
          for (let d of f) {
            if (d.tagName && d.tagName != fd(u.parent, a))
              continue;
            let p = u.lastChild;
            if (p.type.id == ah) {
              let m = p.from + 1, O = p.lastChild, g = p.to - (O && O.isError ? 0 : 1);
              if (g > m)
                return { parser: d.parser, overlay: [{ from: m, to: g }] };
            } else if (p.type.id == y1)
              return { parser: d.parser, overlay: [{ from: p.from, to: p.to }] };
          }
      }
    }
    return null;
  });
}
const j3 = 99, dd = 1, N3 = 100, U3 = 101, pd = 2, v1 = [
  9,
  10,
  11,
  12,
  13,
  32,
  133,
  160,
  5760,
  8192,
  8193,
  8194,
  8195,
  8196,
  8197,
  8198,
  8199,
  8200,
  8201,
  8202,
  8232,
  8233,
  8239,
  8287,
  12288
], F3 = 58, G3 = 40, P1 = 95, H3 = 91, Ns = 45, K3 = 46, J3 = 35, e5 = 37, t5 = 38, n5 = 92, i5 = 10;
function _r(n) {
  return n >= 65 && n <= 90 || n >= 97 && n <= 122 || n >= 161;
}
function Q1(n) {
  return n >= 48 && n <= 57;
}
const r5 = new Dt((n, e) => {
  for (let t = !1, i = 0, r = 0; ; r++) {
    let { next: s } = n;
    if (_r(s) || s == Ns || s == P1 || t && Q1(s))
      !t && (s != Ns || r > 0) && (t = !0), i === r && s == Ns && i++, n.advance();
    else if (s == n5 && n.peek(1) != i5)
      n.advance(), n.next > -1 && n.advance(), t = !0;
    else {
      t && n.acceptToken(s == G3 ? N3 : i == 2 && e.canShift(pd) ? pd : U3);
      break;
    }
  }
}), s5 = new Dt((n) => {
  if (v1.includes(n.peek(-1))) {
    let { next: e } = n;
    (_r(e) || e == P1 || e == J3 || e == K3 || e == H3 || e == F3 && _r(n.peek(1)) || e == Ns || e == t5) && n.acceptToken(j3);
  }
}), o5 = new Dt((n) => {
  if (!v1.includes(n.peek(-1))) {
    let { next: e } = n;
    if (e == e5 && (n.advance(), n.acceptToken(dd)), _r(e)) {
      do
        n.advance();
      while (_r(n.next) || Q1(n.next));
      n.acceptToken(dd);
    }
  }
}), l5 = Xi({
  "AtKeyword import charset namespace keyframes media supports": k.definitionKeyword,
  "from to selector": k.keyword,
  NamespaceName: k.namespace,
  KeyframeName: k.labelName,
  KeyframeRangeName: k.operatorKeyword,
  TagName: k.tagName,
  ClassName: k.className,
  PseudoClassName: k.constant(k.className),
  IdName: k.labelName,
  "FeatureName PropertyName": k.propertyName,
  AttributeName: k.attributeName,
  NumberLiteral: k.number,
  KeywordQuery: k.keyword,
  UnaryQueryOp: k.operatorKeyword,
  "CallTag ValueName": k.atom,
  VariableName: k.variableName,
  Callee: k.operatorKeyword,
  Unit: k.unit,
  "UniversalSelector NestingSelector": k.definitionOperator,
  MatchOp: k.compareOperator,
  "ChildOp SiblingOp, LogicOp": k.logicOperator,
  BinOp: k.arithmeticOperator,
  Important: k.modifier,
  Comment: k.blockComment,
  ColorLiteral: k.color,
  "ParenthesizedContent StringLiteral": k.string,
  ":": k.punctuation,
  "PseudoOp #": k.derefOperator,
  "; ,": k.separator,
  "( )": k.paren,
  "[ ]": k.squareBracket,
  "{ }": k.brace
}), a5 = { __proto__: null, lang: 32, "nth-child": 32, "nth-last-child": 32, "nth-of-type": 32, "nth-last-of-type": 32, dir: 32, "host-context": 32, url: 60, "url-prefix": 60, domain: 60, regexp: 60, selector: 138 }, h5 = { __proto__: null, "@import": 118, "@media": 142, "@charset": 146, "@namespace": 150, "@keyframes": 156, "@supports": 168 }, u5 = { __proto__: null, not: 132, only: 132 }, c5 = Zi.deserialize({
  version: 14,
  states: ":^QYQ[OOO#_Q[OOP#fOWOOOOQP'#Cd'#CdOOQP'#Cc'#CcO#kQ[O'#CfO$_QXO'#CaO$fQ[O'#ChO$qQ[O'#DTO$vQ[O'#DWOOQP'#Em'#EmO${QdO'#DgO%jQ[O'#DtO${QdO'#DvO%{Q[O'#DxO&WQ[O'#D{O&`Q[O'#ERO&nQ[O'#ETOOQS'#El'#ElOOQS'#EW'#EWQYQ[OOO&uQXO'#CdO'jQWO'#DcO'oQWO'#EsO'zQ[O'#EsQOQWOOP(UO#tO'#C_POOO)C@[)C@[OOQP'#Cg'#CgOOQP,59Q,59QO#kQ[O,59QO(aQ[O'#E[O({QWO,58{O)TQ[O,59SO$qQ[O,59oO$vQ[O,59rO(aQ[O,59uO(aQ[O,59wO(aQ[O,59xO)`Q[O'#DbOOQS,58{,58{OOQP'#Ck'#CkOOQO'#DR'#DROOQP,59S,59SO)gQWO,59SO)lQWO,59SOOQP'#DV'#DVOOQP,59o,59oOOQO'#DX'#DXO)qQ`O,59rOOQS'#Cp'#CpO${QdO'#CqO)yQvO'#CsO+ZQtO,5:ROOQO'#Cx'#CxO)lQWO'#CwO+oQWO'#CyO+tQ[O'#DOOOQS'#Ep'#EpOOQO'#Dj'#DjO+|Q[O'#DqO,[QWO'#EtO&`Q[O'#DoO,jQWO'#DrOOQO'#Eu'#EuO)OQWO,5:`O,oQpO,5:bOOQS'#Dz'#DzO,wQWO,5:dO,|Q[O,5:dOOQO'#D}'#D}O-UQWO,5:gO-ZQWO,5:mO-cQWO,5:oOOQS-E8U-E8UO${QdO,59}O-kQ[O'#E^O-xQWO,5;_O-xQWO,5;_POOO'#EV'#EVP.TO#tO,58yPOOO,58y,58yOOQP1G.l1G.lO.zQXO,5:vOOQO-E8Y-E8YOOQS1G.g1G.gOOQP1G.n1G.nO)gQWO1G.nO)lQWO1G.nOOQP1G/Z1G/ZO/XQ`O1G/^O/rQXO1G/aO0YQXO1G/cO0pQXO1G/dO1WQWO,59|O1]Q[O'#DSO1dQdO'#CoOOQP1G/^1G/^O${QdO1G/^O1kQpO,59]OOQS,59_,59_O${QdO,59aO1sQWO1G/mOOQS,59c,59cO1xQ!bO,59eOOQS'#DP'#DPOOQS'#EY'#EYO2QQ[O,59jOOQS,59j,59jO2YQWO'#DjO2eQWO,5:VO2jQWO,5:]O&`Q[O,5:XO&`Q[O'#E_O2rQWO,5;`O2}QWO,5:ZO(aQ[O,5:^OOQS1G/z1G/zOOQS1G/|1G/|OOQS1G0O1G0OO3`QWO1G0OO3eQdO'#EOOOQS1G0R1G0ROOQS1G0X1G0XOOQS1G0Z1G0ZO3pQtO1G/iOOQO,5:x,5:xO4WQ[O,5:xOOQO-E8[-E8[O4eQWO1G0yPOOO-E8T-E8TPOOO1G.e1G.eOOQP7+$Y7+$YOOQP7+$x7+$xO${QdO7+$xOOQS1G/h1G/hO4pQXO'#ErO4wQWO,59nO4|QtO'#EXO5tQdO'#EoO6OQWO,59ZO6TQpO7+$xOOQS1G.w1G.wOOQS1G.{1G.{OOQS7+%X7+%XO6]QWO1G/POOQS-E8W-E8WOOQS1G/U1G/UO${QdO1G/qOOQO1G/w1G/wOOQO1G/s1G/sO6bQWO,5:yOOQO-E8]-E8]O6pQXO1G/xOOQS7+%j7+%jO6wQYO'#CsOOQO'#EQ'#EQO7SQ`O'#EPOOQO'#EP'#EPO7_QWO'#E`O7gQdO,5:jOOQS,5:j,5:jO7rQtO'#E]O${QdO'#E]O8sQdO7+%TOOQO7+%T7+%TOOQO1G0d1G0dO9WQpO<<HdO9`QWO,5;^OOQP1G/Y1G/YOOQS-E8V-E8VO${QdO'#EZO9hQWO,5;ZOOQT1G.u1G.uOOQP<<Hd<<HdOOQS7+$k7+$kO9pQdO7+%]OOQO7+%d7+%dOOQO,5:k,5:kO3hQdO'#EaO7_QWO,5:zOOQS,5:z,5:zOOQS-E8^-E8^OOQS1G0U1G0UO9wQtO,5:wOOQS-E8Z-E8ZOOQO<<Ho<<HoOOQPAN>OAN>OO:xQdO,5:uOOQO-E8X-E8XOOQO<<Hw<<HwOOQO,5:{,5:{OOQO-E8_-E8_OOQS1G0f1G0f",
  stateData: ";[~O#ZOS#[QQ~OUYOXYO]VO^VOqXOxWO![aO!]ZO!i[O!k]O!m^O!p_O!v`O#XRO#bTO~OQfOUYOXYO]VO^VOqXOxWO![aO!]ZO!i[O!k]O!m^O!p_O!v`O#XeO#bTO~O#U#gP~P!ZO#[jO~O#XlO~O]qO^qOqsOtoOxrO!OtO!RvO#VuO#bnO~O!TwO~P#pO`}O#WzO#XyO~O#X!OO~O#X!QO~OQ![Ob!TOf![Oh![On!YOq!ZO#W!WO#X!SO#e!UO~Ob!^O!d!`O!g!aO#X!]O!T#hP~Oh!fOn!YO#X!eO~Oh!hO#X!hO~Ob!^O!d!`O!g!aO#X!]O~O!Y#hP~P%jO]WX]!WX^WXqWXtWXxWX!OWX!RWX!TWX#VWX#bWX~O]!mO~O!Y!nO#U#gX!S#gX~O#U#gX!S#gX~P!ZO#]!qO#^!qO#_!sO~OUYOXYO]VO^VOqXOxWO#XRO#bTO~OtoO!TwO~O`!zO#WzO#XyO~O!S#gP~P!ZOb#RO~Ob#SO~Op#TO|#UO~OP#WObgXjgX!YgX!dgX!ggX#XgXagXQgXfgXhgXngXqgXtgX!XgX#UgX#WgX#egXpgX!SgX~Ob!^Oj#XO!d!`O!g!aO#X!]O!Y#hP~Ob#[O~Op#`O#X#]O~Ob!^O!d!`O!g!aO#X#aO~Ot#eO!b#dO!T#hX!Y#hX~Ob#hO~Oj#XO!Y#jO~O!Y#kO~Oh#lOn!YO~O!T#mO~O!TwO!b#dO~O!TwO!Y#pO~O!Y#QX#U#QX!S#QX~P!ZO!Y!nO#U#ga!S#ga~O#]!qO#^!qO#_#wO~O]qO^qOqsOxrO!OtO!RvO#VuO#bnO~Ot#Oa!T#Oaa#Oa~P.`Op#yO|#zO~O]qO^qOqsOxrO#bnO~Ot}i!O}i!R}i!T}i#V}ia}i~P/aOt!Pi!O!Pi!R!Pi!T!Pi#V!Pia!Pi~P/aOt!Qi!O!Qi!R!Qi!T!Qi#V!Qia!Qi~P/aO!S#{O~Oa#fP~P(aOa#cP~P${Oa$SOj#XO~O!Y$UO~Oh$VOo$VO~Op$XO#X#]O~O]!`Xa!^X!b!^X~O]$YO~Oa$ZO!b#dO~Ot#eO!T#ha!Y#ha~O!b#dOt!ca!T!ca!Y!caa!ca~O!Y$`O~O!S$gO#X$bO#e$aO~Oj#XOt$iO!X$kO!Y!Vi#U!Vi!S!Vi~P${O!Y#Qa#U#Qa!S#Qa~P!ZO!Y!nO#U#gi!S#gi~Oa#fX~P#pOa$oO~Oj#XOQ!{Xa!{Xb!{Xf!{Xh!{Xn!{Xq!{Xt!{X#W!{X#X!{X#e!{X~Ot$qOa#cX~P${Oa$sO~Oj#XOp$tO~Oa$uO~O!b#dOt#Ra!T#Ra!Y#Ra~Oa$wO~P.`OP#WOtgX!TgX~O#e$aOt!sX!T!sX~Ot$yO!TwO~O!S$}O#X$bO#e$aO~Oj#XOQ#PXb#PXf#PXh#PXn#PXq#PXt#PX!X#PX!Y#PX#U#PX#W#PX#X#PX#e#PX!S#PX~Ot$iO!X%QO!Y!Vq#U!Vq!S!Vq~P${Oj#XOp%RO~OtoOa#fa~Ot$qOa#ca~Oa%UO~P${Oj#XOQ#Pab#Paf#Pah#Pan#Paq#Pat#Pa!X#Pa!Y#Pa#U#Pa#W#Pa#X#Pa#e#Pa!S#Pa~Oa!}at!}a~P${O#Zo#[#ej!R#e~",
  goto: "-g#jPPP#kP#nP#w$WP#w$g#wPP$mPPP$s$|$|P%`P$|P$|%z&^PPPP$|&vP&z'Q#wP'W#w'^P#wP#w#wPPP'd'y(WPP#nPP(_(_(i(_P(_P(_(_P#nP#nP#nP(l#nP(o(r(u(|#nP#nP)R)X)h)v)|*S*^*d*n*t*zPPPPPPPPPP+Q+ZP+v+yP,o,r,x-RRkQ_bOPdhw!n#skYOPdhotuvw!n#R#h#skSOPdhotuvw!n#R#h#sQmTR!tnQ{VR!xqQ!x}Q#Z!XR#x!zq![Z]!T!m#S#U#X#q#z$P$Y$i$j$q$v%Sp![Z]!T!m#S#U#X#q#z$P$Y$i$j$q$v%SU$d#m$f$yR$x$cq!XZ]!T!m#S#U#X#q#z$P$Y$i$j$q$v%Sp![Z]!T!m#S#U#X#q#z$P$Y$i$j$q$v%SQ!f^R#l!gT#^!Z#_Q|VR!yqQ!x|R#x!yQ!PWR!{rQ!RXR!|sQxUQ!wpQ#i!cQ#o!jQ#p!kQ${$eR%X$zSgPwQ!phQ#r!nR$l#sZfPhw!n#sa!b[`a!V!^!`#d#eR#b!^R!g^R!i_R#n!iS$e#m$fR%V$yV$c#m$f$yQ!rjR#v!rQdOShPwU!ldh#sR#s!nQ$P#SU$p$P$v%SQ$v$YR%S$qQ#_!ZR$W#_Q$r$PR%T$rQpUS!vp$nR$n#|Q$j#qR%P$jQ!ogS#t!o#uR#u!pQ#f!_R$^#fQ$f#mR$|$fQ$z$eR%W$z_cOPdhw!n#s^UOPdhw!n#sQ!uoQ!}tQ#OuQ#PvQ#|#RR$_#hR$Q#SQ!VZQ!d]Q#V!TQ#q!m[$O#S$P$Y$q$v%SQ$R#UQ$T#XS$h#q$jQ$m#zR%O$iR#}#RQiPR#QwQ!c[Q!kaR#Y!VU!_[a!VQ!j`Q#c!^Q#g!`Q$[#dR$]#e",
  nodeNames: "⚠ Unit VariableName Comment StyleSheet RuleSet UniversalSelector TagSelector TagName NestingSelector ClassSelector ClassName PseudoClassSelector : :: PseudoClassName PseudoClassName ) ( ArgList ValueName ParenthesizedValue ColorLiteral NumberLiteral StringLiteral BinaryExpression BinOp CallExpression Callee CallLiteral CallTag ParenthesizedContent ] [ LineNames LineName , PseudoClassName ArgList IdSelector # IdName AttributeSelector AttributeName MatchOp ChildSelector ChildOp DescendantSelector SiblingSelector SiblingOp } { Block Declaration PropertyName Important ; ImportStatement AtKeyword import KeywordQuery FeatureQuery FeatureName BinaryQuery LogicOp UnaryQuery UnaryQueryOp ParenthesizedQuery SelectorQuery selector MediaStatement media CharsetStatement charset NamespaceStatement namespace NamespaceName KeyframesStatement keyframes KeyframeName KeyframeList KeyframeSelector KeyframeRangeName SupportsStatement supports AtRule Styles",
  maxTerm: 117,
  nodeProps: [
    ["isolate", -2, 3, 24, ""],
    ["openedBy", 17, "(", 32, "[", 50, "{"],
    ["closedBy", 18, ")", 33, "]", 51, "}"]
  ],
  propSources: [l5],
  skippedNodes: [0, 3, 87],
  repeatNodeCount: 11,
  tokenData: "J^~R!^OX$}X^%u^p$}pq%uqr)Xrs.Rst/utu6duv$}vw7^wx7oxy9^yz9oz{9t{|:_|}?Q}!O?c!O!P@Q!P!Q@i!Q![Ab![!]B]!]!^CX!^!_$}!_!`Cj!`!aC{!a!b$}!b!cDw!c!}$}!}#OFa#O#P$}#P#QFr#Q#R6d#R#T$}#T#UGT#U#c$}#c#dHf#d#o$}#o#pH{#p#q6d#q#rI^#r#sIo#s#y$}#y#z%u#z$f$}$f$g%u$g#BY$}#BY#BZ%u#BZ$IS$}$IS$I_%u$I_$I|$}$I|$JO%u$JO$JT$}$JT$JU%u$JU$KV$}$KV$KW%u$KW&FU$}&FU&FV%u&FV;'S$};'S;=`JW<%lO$}`%QSOy%^z;'S%^;'S;=`%o<%lO%^`%cSo`Oy%^z;'S%^;'S;=`%o<%lO%^`%rP;=`<%l%^~%zh#Z~OX%^X^'f^p%^pq'fqy%^z#y%^#y#z'f#z$f%^$f$g'f$g#BY%^#BY#BZ'f#BZ$IS%^$IS$I_'f$I_$I|%^$I|$JO'f$JO$JT%^$JT$JU'f$JU$KV%^$KV$KW'f$KW&FU%^&FU&FV'f&FV;'S%^;'S;=`%o<%lO%^~'mh#Z~o`OX%^X^'f^p%^pq'fqy%^z#y%^#y#z'f#z$f%^$f$g'f$g#BY%^#BY#BZ'f#BZ$IS%^$IS$I_'f$I_$I|%^$I|$JO'f$JO$JT%^$JT$JU'f$JU$KV%^$KV$KW'f$KW&FU%^&FU&FV'f&FV;'S%^;'S;=`%o<%lO%^l)[UOy%^z#]%^#]#^)n#^;'S%^;'S;=`%o<%lO%^l)sUo`Oy%^z#a%^#a#b*V#b;'S%^;'S;=`%o<%lO%^l*[Uo`Oy%^z#d%^#d#e*n#e;'S%^;'S;=`%o<%lO%^l*sUo`Oy%^z#c%^#c#d+V#d;'S%^;'S;=`%o<%lO%^l+[Uo`Oy%^z#f%^#f#g+n#g;'S%^;'S;=`%o<%lO%^l+sUo`Oy%^z#h%^#h#i,V#i;'S%^;'S;=`%o<%lO%^l,[Uo`Oy%^z#T%^#T#U,n#U;'S%^;'S;=`%o<%lO%^l,sUo`Oy%^z#b%^#b#c-V#c;'S%^;'S;=`%o<%lO%^l-[Uo`Oy%^z#h%^#h#i-n#i;'S%^;'S;=`%o<%lO%^l-uS!X[o`Oy%^z;'S%^;'S;=`%o<%lO%^~.UWOY.RZr.Rrs.ns#O.R#O#P.s#P;'S.R;'S;=`/o<%lO.R~.sOh~~.vRO;'S.R;'S;=`/P;=`O.R~/SXOY.RZr.Rrs.ns#O.R#O#P.s#P;'S.R;'S;=`/o;=`<%l.R<%lO.R~/rP;=`<%l.Rn/zYxQOy%^z!Q%^!Q![0j![!c%^!c!i0j!i#T%^#T#Z0j#Z;'S%^;'S;=`%o<%lO%^l0oYo`Oy%^z!Q%^!Q![1_![!c%^!c!i1_!i#T%^#T#Z1_#Z;'S%^;'S;=`%o<%lO%^l1dYo`Oy%^z!Q%^!Q![2S![!c%^!c!i2S!i#T%^#T#Z2S#Z;'S%^;'S;=`%o<%lO%^l2ZYf[o`Oy%^z!Q%^!Q![2y![!c%^!c!i2y!i#T%^#T#Z2y#Z;'S%^;'S;=`%o<%lO%^l3QYf[o`Oy%^z!Q%^!Q![3p![!c%^!c!i3p!i#T%^#T#Z3p#Z;'S%^;'S;=`%o<%lO%^l3uYo`Oy%^z!Q%^!Q![4e![!c%^!c!i4e!i#T%^#T#Z4e#Z;'S%^;'S;=`%o<%lO%^l4lYf[o`Oy%^z!Q%^!Q![5[![!c%^!c!i5[!i#T%^#T#Z5[#Z;'S%^;'S;=`%o<%lO%^l5aYo`Oy%^z!Q%^!Q![6P![!c%^!c!i6P!i#T%^#T#Z6P#Z;'S%^;'S;=`%o<%lO%^l6WSf[o`Oy%^z;'S%^;'S;=`%o<%lO%^d6gUOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^d7QS|So`Oy%^z;'S%^;'S;=`%o<%lO%^b7cSXQOy%^z;'S%^;'S;=`%o<%lO%^~7rWOY7oZw7owx.nx#O7o#O#P8[#P;'S7o;'S;=`9W<%lO7o~8_RO;'S7o;'S;=`8h;=`O7o~8kXOY7oZw7owx.nx#O7o#O#P8[#P;'S7o;'S;=`9W;=`<%l7o<%lO7o~9ZP;=`<%l7on9cSb^Oy%^z;'S%^;'S;=`%o<%lO%^~9tOa~n9{UUQjWOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^n:fWjW!RQOy%^z!O%^!O!P;O!P!Q%^!Q![>T![;'S%^;'S;=`%o<%lO%^l;TUo`Oy%^z!Q%^!Q![;g![;'S%^;'S;=`%o<%lO%^l;nYo`#e[Oy%^z!Q%^!Q![;g![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^l<cYo`Oy%^z{%^{|=R|}%^}!O=R!O!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^l=WUo`Oy%^z!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^l=qUo`#e[Oy%^z!Q%^!Q![=j![;'S%^;'S;=`%o<%lO%^l>[[o`#e[Oy%^z!O%^!O!P;g!P!Q%^!Q![>T![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^n?VSt^Oy%^z;'S%^;'S;=`%o<%lO%^l?hWjWOy%^z!O%^!O!P;O!P!Q%^!Q![>T![;'S%^;'S;=`%o<%lO%^n@VU#bQOy%^z!Q%^!Q![;g![;'S%^;'S;=`%o<%lO%^~@nTjWOy%^z{@}{;'S%^;'S;=`%o<%lO%^~AUSo`#[~Oy%^z;'S%^;'S;=`%o<%lO%^lAg[#e[Oy%^z!O%^!O!P;g!P!Q%^!Q![>T![!g%^!g!h<^!h#X%^#X#Y<^#Y;'S%^;'S;=`%o<%lO%^bBbU]QOy%^z![%^![!]Bt!];'S%^;'S;=`%o<%lO%^bB{S^Qo`Oy%^z;'S%^;'S;=`%o<%lO%^nC^S!Y^Oy%^z;'S%^;'S;=`%o<%lO%^dCoS|SOy%^z;'S%^;'S;=`%o<%lO%^bDQU!OQOy%^z!`%^!`!aDd!a;'S%^;'S;=`%o<%lO%^bDkS!OQo`Oy%^z;'S%^;'S;=`%o<%lO%^bDzWOy%^z!c%^!c!}Ed!}#T%^#T#oEd#o;'S%^;'S;=`%o<%lO%^bEk[![Qo`Oy%^z}%^}!OEd!O!Q%^!Q![Ed![!c%^!c!}Ed!}#T%^#T#oEd#o;'S%^;'S;=`%o<%lO%^nFfSq^Oy%^z;'S%^;'S;=`%o<%lO%^nFwSp^Oy%^z;'S%^;'S;=`%o<%lO%^bGWUOy%^z#b%^#b#cGj#c;'S%^;'S;=`%o<%lO%^bGoUo`Oy%^z#W%^#W#XHR#X;'S%^;'S;=`%o<%lO%^bHYS!bQo`Oy%^z;'S%^;'S;=`%o<%lO%^bHiUOy%^z#f%^#f#gHR#g;'S%^;'S;=`%o<%lO%^fIQS!TUOy%^z;'S%^;'S;=`%o<%lO%^nIcS!S^Oy%^z;'S%^;'S;=`%o<%lO%^fItU!RQOy%^z!_%^!_!`6y!`;'S%^;'S;=`%o<%lO%^`JZP;=`<%l$}",
  tokenizers: [s5, o5, r5, 1, 2, 3, 4, new $o("m~RRYZ[z{a~~g~aO#^~~dP!P!Qg~lO#_~~", 28, 105)],
  topRules: { StyleSheet: [0, 4], Styles: [1, 86] },
  specialized: [{ term: 100, get: (n) => a5[n] || -1 }, { term: 58, get: (n) => h5[n] || -1 }, { term: 101, get: (n) => u5[n] || -1 }],
  tokenPrec: 1200
});
let Il = null;
function _l() {
  if (!Il && typeof document == "object" && document.body) {
    let { style: n } = document.body, e = [], t = /* @__PURE__ */ new Set();
    for (let i in n)
      i != "cssText" && i != "cssFloat" && typeof n[i] == "string" && (/[A-Z]/.test(i) && (i = i.replace(/[A-Z]/g, (r) => "-" + r.toLowerCase())), t.has(i) || (e.push(i), t.add(i)));
    Il = e.sort().map((i) => ({ type: "property", label: i }));
  }
  return Il || [];
}
const md = /* @__PURE__ */ [
  "active",
  "after",
  "any-link",
  "autofill",
  "backdrop",
  "before",
  "checked",
  "cue",
  "default",
  "defined",
  "disabled",
  "empty",
  "enabled",
  "file-selector-button",
  "first",
  "first-child",
  "first-letter",
  "first-line",
  "first-of-type",
  "focus",
  "focus-visible",
  "focus-within",
  "fullscreen",
  "has",
  "host",
  "host-context",
  "hover",
  "in-range",
  "indeterminate",
  "invalid",
  "is",
  "lang",
  "last-child",
  "last-of-type",
  "left",
  "link",
  "marker",
  "modal",
  "not",
  "nth-child",
  "nth-last-child",
  "nth-last-of-type",
  "nth-of-type",
  "only-child",
  "only-of-type",
  "optional",
  "out-of-range",
  "part",
  "placeholder",
  "placeholder-shown",
  "read-only",
  "read-write",
  "required",
  "right",
  "root",
  "scope",
  "selection",
  "slotted",
  "target",
  "target-text",
  "valid",
  "visited",
  "where"
].map((n) => ({ type: "class", label: n })), Od = /* @__PURE__ */ [
  "above",
  "absolute",
  "activeborder",
  "additive",
  "activecaption",
  "after-white-space",
  "ahead",
  "alias",
  "all",
  "all-scroll",
  "alphabetic",
  "alternate",
  "always",
  "antialiased",
  "appworkspace",
  "asterisks",
  "attr",
  "auto",
  "auto-flow",
  "avoid",
  "avoid-column",
  "avoid-page",
  "avoid-region",
  "axis-pan",
  "background",
  "backwards",
  "baseline",
  "below",
  "bidi-override",
  "blink",
  "block",
  "block-axis",
  "bold",
  "bolder",
  "border",
  "border-box",
  "both",
  "bottom",
  "break",
  "break-all",
  "break-word",
  "bullets",
  "button",
  "button-bevel",
  "buttonface",
  "buttonhighlight",
  "buttonshadow",
  "buttontext",
  "calc",
  "capitalize",
  "caps-lock-indicator",
  "caption",
  "captiontext",
  "caret",
  "cell",
  "center",
  "checkbox",
  "circle",
  "cjk-decimal",
  "clear",
  "clip",
  "close-quote",
  "col-resize",
  "collapse",
  "color",
  "color-burn",
  "color-dodge",
  "column",
  "column-reverse",
  "compact",
  "condensed",
  "contain",
  "content",
  "contents",
  "content-box",
  "context-menu",
  "continuous",
  "copy",
  "counter",
  "counters",
  "cover",
  "crop",
  "cross",
  "crosshair",
  "currentcolor",
  "cursive",
  "cyclic",
  "darken",
  "dashed",
  "decimal",
  "decimal-leading-zero",
  "default",
  "default-button",
  "dense",
  "destination-atop",
  "destination-in",
  "destination-out",
  "destination-over",
  "difference",
  "disc",
  "discard",
  "disclosure-closed",
  "disclosure-open",
  "document",
  "dot-dash",
  "dot-dot-dash",
  "dotted",
  "double",
  "down",
  "e-resize",
  "ease",
  "ease-in",
  "ease-in-out",
  "ease-out",
  "element",
  "ellipse",
  "ellipsis",
  "embed",
  "end",
  "ethiopic-abegede-gez",
  "ethiopic-halehame-aa-er",
  "ethiopic-halehame-gez",
  "ew-resize",
  "exclusion",
  "expanded",
  "extends",
  "extra-condensed",
  "extra-expanded",
  "fantasy",
  "fast",
  "fill",
  "fill-box",
  "fixed",
  "flat",
  "flex",
  "flex-end",
  "flex-start",
  "footnotes",
  "forwards",
  "from",
  "geometricPrecision",
  "graytext",
  "grid",
  "groove",
  "hand",
  "hard-light",
  "help",
  "hidden",
  "hide",
  "higher",
  "highlight",
  "highlighttext",
  "horizontal",
  "hsl",
  "hsla",
  "hue",
  "icon",
  "ignore",
  "inactiveborder",
  "inactivecaption",
  "inactivecaptiontext",
  "infinite",
  "infobackground",
  "infotext",
  "inherit",
  "initial",
  "inline",
  "inline-axis",
  "inline-block",
  "inline-flex",
  "inline-grid",
  "inline-table",
  "inset",
  "inside",
  "intrinsic",
  "invert",
  "italic",
  "justify",
  "keep-all",
  "landscape",
  "large",
  "larger",
  "left",
  "level",
  "lighter",
  "lighten",
  "line-through",
  "linear",
  "linear-gradient",
  "lines",
  "list-item",
  "listbox",
  "listitem",
  "local",
  "logical",
  "loud",
  "lower",
  "lower-hexadecimal",
  "lower-latin",
  "lower-norwegian",
  "lowercase",
  "ltr",
  "luminosity",
  "manipulation",
  "match",
  "matrix",
  "matrix3d",
  "medium",
  "menu",
  "menutext",
  "message-box",
  "middle",
  "min-intrinsic",
  "mix",
  "monospace",
  "move",
  "multiple",
  "multiple_mask_images",
  "multiply",
  "n-resize",
  "narrower",
  "ne-resize",
  "nesw-resize",
  "no-close-quote",
  "no-drop",
  "no-open-quote",
  "no-repeat",
  "none",
  "normal",
  "not-allowed",
  "nowrap",
  "ns-resize",
  "numbers",
  "numeric",
  "nw-resize",
  "nwse-resize",
  "oblique",
  "opacity",
  "open-quote",
  "optimizeLegibility",
  "optimizeSpeed",
  "outset",
  "outside",
  "outside-shape",
  "overlay",
  "overline",
  "padding",
  "padding-box",
  "painted",
  "page",
  "paused",
  "perspective",
  "pinch-zoom",
  "plus-darker",
  "plus-lighter",
  "pointer",
  "polygon",
  "portrait",
  "pre",
  "pre-line",
  "pre-wrap",
  "preserve-3d",
  "progress",
  "push-button",
  "radial-gradient",
  "radio",
  "read-only",
  "read-write",
  "read-write-plaintext-only",
  "rectangle",
  "region",
  "relative",
  "repeat",
  "repeating-linear-gradient",
  "repeating-radial-gradient",
  "repeat-x",
  "repeat-y",
  "reset",
  "reverse",
  "rgb",
  "rgba",
  "ridge",
  "right",
  "rotate",
  "rotate3d",
  "rotateX",
  "rotateY",
  "rotateZ",
  "round",
  "row",
  "row-resize",
  "row-reverse",
  "rtl",
  "run-in",
  "running",
  "s-resize",
  "sans-serif",
  "saturation",
  "scale",
  "scale3d",
  "scaleX",
  "scaleY",
  "scaleZ",
  "screen",
  "scroll",
  "scrollbar",
  "scroll-position",
  "se-resize",
  "self-start",
  "self-end",
  "semi-condensed",
  "semi-expanded",
  "separate",
  "serif",
  "show",
  "single",
  "skew",
  "skewX",
  "skewY",
  "skip-white-space",
  "slide",
  "slider-horizontal",
  "slider-vertical",
  "sliderthumb-horizontal",
  "sliderthumb-vertical",
  "slow",
  "small",
  "small-caps",
  "small-caption",
  "smaller",
  "soft-light",
  "solid",
  "source-atop",
  "source-in",
  "source-out",
  "source-over",
  "space",
  "space-around",
  "space-between",
  "space-evenly",
  "spell-out",
  "square",
  "start",
  "static",
  "status-bar",
  "stretch",
  "stroke",
  "stroke-box",
  "sub",
  "subpixel-antialiased",
  "svg_masks",
  "super",
  "sw-resize",
  "symbolic",
  "symbols",
  "system-ui",
  "table",
  "table-caption",
  "table-cell",
  "table-column",
  "table-column-group",
  "table-footer-group",
  "table-header-group",
  "table-row",
  "table-row-group",
  "text",
  "text-bottom",
  "text-top",
  "textarea",
  "textfield",
  "thick",
  "thin",
  "threeddarkshadow",
  "threedface",
  "threedhighlight",
  "threedlightshadow",
  "threedshadow",
  "to",
  "top",
  "transform",
  "translate",
  "translate3d",
  "translateX",
  "translateY",
  "translateZ",
  "transparent",
  "ultra-condensed",
  "ultra-expanded",
  "underline",
  "unidirectional-pan",
  "unset",
  "up",
  "upper-latin",
  "uppercase",
  "url",
  "var",
  "vertical",
  "vertical-text",
  "view-box",
  "visible",
  "visibleFill",
  "visiblePainted",
  "visibleStroke",
  "visual",
  "w-resize",
  "wait",
  "wave",
  "wider",
  "window",
  "windowframe",
  "windowtext",
  "words",
  "wrap",
  "wrap-reverse",
  "x-large",
  "x-small",
  "xor",
  "xx-large",
  "xx-small"
].map((n) => ({ type: "keyword", label: n })).concat(/* @__PURE__ */ [
  "aliceblue",
  "antiquewhite",
  "aqua",
  "aquamarine",
  "azure",
  "beige",
  "bisque",
  "black",
  "blanchedalmond",
  "blue",
  "blueviolet",
  "brown",
  "burlywood",
  "cadetblue",
  "chartreuse",
  "chocolate",
  "coral",
  "cornflowerblue",
  "cornsilk",
  "crimson",
  "cyan",
  "darkblue",
  "darkcyan",
  "darkgoldenrod",
  "darkgray",
  "darkgreen",
  "darkkhaki",
  "darkmagenta",
  "darkolivegreen",
  "darkorange",
  "darkorchid",
  "darkred",
  "darksalmon",
  "darkseagreen",
  "darkslateblue",
  "darkslategray",
  "darkturquoise",
  "darkviolet",
  "deeppink",
  "deepskyblue",
  "dimgray",
  "dodgerblue",
  "firebrick",
  "floralwhite",
  "forestgreen",
  "fuchsia",
  "gainsboro",
  "ghostwhite",
  "gold",
  "goldenrod",
  "gray",
  "grey",
  "green",
  "greenyellow",
  "honeydew",
  "hotpink",
  "indianred",
  "indigo",
  "ivory",
  "khaki",
  "lavender",
  "lavenderblush",
  "lawngreen",
  "lemonchiffon",
  "lightblue",
  "lightcoral",
  "lightcyan",
  "lightgoldenrodyellow",
  "lightgray",
  "lightgreen",
  "lightpink",
  "lightsalmon",
  "lightseagreen",
  "lightskyblue",
  "lightslategray",
  "lightsteelblue",
  "lightyellow",
  "lime",
  "limegreen",
  "linen",
  "magenta",
  "maroon",
  "mediumaquamarine",
  "mediumblue",
  "mediumorchid",
  "mediumpurple",
  "mediumseagreen",
  "mediumslateblue",
  "mediumspringgreen",
  "mediumturquoise",
  "mediumvioletred",
  "midnightblue",
  "mintcream",
  "mistyrose",
  "moccasin",
  "navajowhite",
  "navy",
  "oldlace",
  "olive",
  "olivedrab",
  "orange",
  "orangered",
  "orchid",
  "palegoldenrod",
  "palegreen",
  "paleturquoise",
  "palevioletred",
  "papayawhip",
  "peachpuff",
  "peru",
  "pink",
  "plum",
  "powderblue",
  "purple",
  "rebeccapurple",
  "red",
  "rosybrown",
  "royalblue",
  "saddlebrown",
  "salmon",
  "sandybrown",
  "seagreen",
  "seashell",
  "sienna",
  "silver",
  "skyblue",
  "slateblue",
  "slategray",
  "snow",
  "springgreen",
  "steelblue",
  "tan",
  "teal",
  "thistle",
  "tomato",
  "turquoise",
  "violet",
  "wheat",
  "white",
  "whitesmoke",
  "yellow",
  "yellowgreen"
].map((n) => ({ type: "constant", label: n }))), f5 = /* @__PURE__ */ [
  "a",
  "abbr",
  "address",
  "article",
  "aside",
  "b",
  "bdi",
  "bdo",
  "blockquote",
  "body",
  "br",
  "button",
  "canvas",
  "caption",
  "cite",
  "code",
  "col",
  "colgroup",
  "dd",
  "del",
  "details",
  "dfn",
  "dialog",
  "div",
  "dl",
  "dt",
  "em",
  "figcaption",
  "figure",
  "footer",
  "form",
  "header",
  "hgroup",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "hr",
  "html",
  "i",
  "iframe",
  "img",
  "input",
  "ins",
  "kbd",
  "label",
  "legend",
  "li",
  "main",
  "meter",
  "nav",
  "ol",
  "output",
  "p",
  "pre",
  "ruby",
  "section",
  "select",
  "small",
  "source",
  "span",
  "strong",
  "sub",
  "summary",
  "sup",
  "table",
  "tbody",
  "td",
  "template",
  "textarea",
  "tfoot",
  "th",
  "thead",
  "tr",
  "u",
  "ul"
].map((n) => ({ type: "type", label: n })), pn = /^(\w[\w-]*|-\w[\w-]*|)$/, d5 = /^-(-[\w-]*)?$/;
function p5(n, e) {
  var t;
  if ((n.name == "(" || n.type.isError) && (n = n.parent || n), n.name != "ArgList")
    return !1;
  let i = (t = n.parent) === null || t === void 0 ? void 0 : t.firstChild;
  return (i == null ? void 0 : i.name) != "Callee" ? !1 : e.sliceString(i.from, i.to) == "var";
}
const gd = /* @__PURE__ */ new Lm(), m5 = ["Declaration"];
function O5(n) {
  for (let e = n; ; ) {
    if (e.type.isTop)
      return e;
    if (!(e = e.parent))
      return n;
  }
}
function $1(n, e, t) {
  if (e.to - e.from > 4096) {
    let i = gd.get(e);
    if (i)
      return i;
    let r = [], s = /* @__PURE__ */ new Set(), o = e.cursor(be.IncludeAnonymous);
    if (o.firstChild())
      do
        for (let l of $1(n, o.node, t))
          s.has(l.label) || (s.add(l.label), r.push(l));
      while (o.nextSibling());
    return gd.set(e, r), r;
  } else {
    let i = [], r = /* @__PURE__ */ new Set();
    return e.cursor().iterate((s) => {
      var o;
      if (t(s) && s.matchContext(m5) && ((o = s.node.nextSibling) === null || o === void 0 ? void 0 : o.name) == ":") {
        let l = n.sliceString(s.from, s.to);
        r.has(l) || (r.add(l), i.push({ label: l, type: "variable" }));
      }
    }), i;
  }
}
const g5 = (n) => (e) => {
  let { state: t, pos: i } = e, r = ye(t).resolveInner(i, -1), s = r.type.isError && r.from == r.to - 1 && t.doc.sliceString(r.from, r.to) == "-";
  if (r.name == "PropertyName" || (s || r.name == "TagName") && /^(Block|Styles)$/.test(r.resolve(r.to).name))
    return { from: r.from, options: _l(), validFor: pn };
  if (r.name == "ValueName")
    return { from: r.from, options: Od, validFor: pn };
  if (r.name == "PseudoClassName")
    return { from: r.from, options: md, validFor: pn };
  if (n(r) || (e.explicit || s) && p5(r, t.doc))
    return {
      from: n(r) || s ? r.from : i,
      options: $1(t.doc, O5(r), n),
      validFor: d5
    };
  if (r.name == "TagName") {
    for (let { parent: a } = r; a; a = a.parent)
      if (a.name == "Block")
        return { from: r.from, options: _l(), validFor: pn };
    return { from: r.from, options: f5, validFor: pn };
  }
  if (!e.explicit)
    return null;
  let o = r.resolve(i), l = o.childBefore(i);
  return l && l.name == ":" && o.name == "PseudoClassSelector" ? { from: i, options: md, validFor: pn } : l && l.name == ":" && o.name == "Declaration" || o.name == "ArgList" ? { from: i, options: Od, validFor: pn } : o.name == "Block" || o.name == "Styles" ? { from: i, options: _l(), validFor: pn } : null;
}, b5 = /* @__PURE__ */ g5((n) => n.name == "VariableName"), Ao = /* @__PURE__ */ $i.define({
  name: "css",
  parser: /* @__PURE__ */ c5.configure({
    props: [
      /* @__PURE__ */ Ur.add({
        Declaration: /* @__PURE__ */ Vs()
      }),
      /* @__PURE__ */ Li.add({
        "Block KeyframeList": jm
      })
    ]
  }),
  languageData: {
    commentTokens: { block: { open: "/*", close: "*/" } },
    indentOnInput: /^\s*\}$/,
    wordChars: "-"
  }
});
function y5() {
  return new Zr(Ao, Ao.data.of({ autocomplete: b5 }));
}
const k5 = 312, bd = 1, x5 = 2, w5 = 3, S5 = 4, v5 = 313, P5 = 315, Q5 = 316, $5 = 5, C5 = 6, T5 = 0, uh = [
  9,
  10,
  11,
  12,
  13,
  32,
  133,
  160,
  5760,
  8192,
  8193,
  8194,
  8195,
  8196,
  8197,
  8198,
  8199,
  8200,
  8201,
  8202,
  8232,
  8233,
  8239,
  8287,
  12288
], C1 = 125, A5 = 59, ch = 47, R5 = 42, Z5 = 43, M5 = 45, E5 = 60, z5 = 44, X5 = 63, D5 = 46, L5 = new f1({
  start: !1,
  shift(n, e) {
    return e == $5 || e == C5 || e == P5 ? n : e == Q5;
  },
  strict: !1
}), I5 = new Dt((n, e) => {
  let { next: t } = n;
  (t == C1 || t == -1 || e.context) && n.acceptToken(v5);
}, { contextual: !0, fallback: !0 }), _5 = new Dt((n, e) => {
  let { next: t } = n, i;
  uh.indexOf(t) > -1 || t == ch && ((i = n.peek(1)) == ch || i == R5) || t != C1 && t != A5 && t != -1 && !e.context && n.acceptToken(k5);
}, { contextual: !0 }), q5 = new Dt((n, e) => {
  let { next: t } = n;
  if (t == Z5 || t == M5) {
    if (n.advance(), t == n.next) {
      n.advance();
      let i = !e.context && e.canShift(bd);
      n.acceptToken(i ? bd : x5);
    }
  } else
    t == X5 && n.peek(1) == D5 && (n.advance(), n.advance(), (n.next < 48 || n.next > 57) && n.acceptToken(w5));
}, { contextual: !0 });
function ql(n, e) {
  return n >= 65 && n <= 90 || n >= 97 && n <= 122 || n == 95 || n >= 192 || !e && n >= 48 && n <= 57;
}
const W5 = new Dt((n, e) => {
  if (n.next != E5 || !e.dialectEnabled(T5) || (n.advance(), n.next == ch))
    return;
  let t = 0;
  for (; uh.indexOf(n.next) > -1; )
    n.advance(), t++;
  if (ql(n.next, !0)) {
    for (n.advance(), t++; ql(n.next, !1); )
      n.advance(), t++;
    for (; uh.indexOf(n.next) > -1; )
      n.advance(), t++;
    if (n.next == z5)
      return;
    for (let i = 0; ; i++) {
      if (i == 7) {
        if (!ql(n.next, !0))
          return;
        break;
      }
      if (n.next != "extends".charCodeAt(i))
        break;
      n.advance(), t++;
    }
  }
  n.acceptToken(S5, -t);
}), B5 = Xi({
  "get set async static": k.modifier,
  "for while do if else switch try catch finally return throw break continue default case": k.controlKeyword,
  "in of await yield void typeof delete instanceof": k.operatorKeyword,
  "let var const using function class extends": k.definitionKeyword,
  "import export from": k.moduleKeyword,
  "with debugger as new": k.keyword,
  TemplateString: k.special(k.string),
  super: k.atom,
  BooleanLiteral: k.bool,
  this: k.self,
  null: k.null,
  Star: k.modifier,
  VariableName: k.variableName,
  "CallExpression/VariableName TaggedTemplateExpression/VariableName": k.function(k.variableName),
  VariableDefinition: k.definition(k.variableName),
  Label: k.labelName,
  PropertyName: k.propertyName,
  PrivatePropertyName: k.special(k.propertyName),
  "CallExpression/MemberExpression/PropertyName": k.function(k.propertyName),
  "FunctionDeclaration/VariableDefinition": k.function(k.definition(k.variableName)),
  "ClassDeclaration/VariableDefinition": k.definition(k.className),
  PropertyDefinition: k.definition(k.propertyName),
  PrivatePropertyDefinition: k.definition(k.special(k.propertyName)),
  UpdateOp: k.updateOperator,
  "LineComment Hashbang": k.lineComment,
  BlockComment: k.blockComment,
  Number: k.number,
  String: k.string,
  Escape: k.escape,
  ArithOp: k.arithmeticOperator,
  LogicOp: k.logicOperator,
  BitOp: k.bitwiseOperator,
  CompareOp: k.compareOperator,
  RegExp: k.regexp,
  Equals: k.definitionOperator,
  Arrow: k.function(k.punctuation),
  ": Spread": k.punctuation,
  "( )": k.paren,
  "[ ]": k.squareBracket,
  "{ }": k.brace,
  "InterpolationStart InterpolationEnd": k.special(k.brace),
  ".": k.derefOperator,
  ", ;": k.separator,
  "@": k.meta,
  TypeName: k.typeName,
  TypeDefinition: k.definition(k.typeName),
  "type enum interface implements namespace module declare": k.definitionKeyword,
  "abstract global Privacy readonly override": k.modifier,
  "is keyof unique infer": k.operatorKeyword,
  JSXAttributeValue: k.attributeValue,
  JSXText: k.content,
  "JSXStartTag JSXStartCloseTag JSXSelfCloseEndTag JSXEndTag": k.angleBracket,
  "JSXIdentifier JSXNameSpacedName": k.tagName,
  "JSXAttribute/JSXIdentifier JSXAttribute/JSXNameSpacedName": k.attributeName,
  "JSXBuiltin/JSXIdentifier": k.standard(k.tagName)
}), V5 = { __proto__: null, export: 20, as: 25, from: 33, default: 36, async: 41, function: 42, extends: 54, this: 58, true: 66, false: 66, null: 78, void: 82, typeof: 86, super: 102, new: 136, delete: 148, yield: 157, await: 161, class: 166, public: 229, private: 229, protected: 229, readonly: 231, instanceof: 250, satisfies: 253, in: 254, const: 256, import: 290, keyof: 345, unique: 349, infer: 355, is: 391, abstract: 411, implements: 413, type: 415, let: 418, var: 420, using: 423, interface: 429, enum: 433, namespace: 439, module: 441, declare: 445, global: 449, for: 468, of: 477, while: 480, with: 484, do: 488, if: 492, else: 494, switch: 498, case: 504, try: 510, catch: 514, finally: 518, return: 522, throw: 526, break: 530, continue: 534, debugger: 538 }, Y5 = { __proto__: null, async: 123, get: 125, set: 127, declare: 189, public: 191, private: 191, protected: 191, static: 193, abstract: 195, override: 197, readonly: 203, accessor: 205, new: 395 }, j5 = { __proto__: null, "<": 187 }, N5 = Zi.deserialize({
  version: 14,
  states: "$=dO%TQ^OOO%[Q^OOO'_Q`OOP(lOWOOO*zQ?NdO'#CiO+RO!bO'#CjO+aO#tO'#CjO+oO!0LbO'#D^O.QQ^O'#DdO.bQ^O'#DoO%[Q^O'#DwO0fQ^O'#EPOOQ?Mr'#EX'#EXO1PQWO'#EUOOQO'#Em'#EmOOQO'#Ih'#IhO1XQWO'#GpO1dQWO'#ElO1iQWO'#ElO3hQ?NdO'#JmO6[Q?NdO'#JnO6uQWO'#F[O6zQ&jO'#FsOOQ?Mr'#Fe'#FeO7VO,YO'#FeO7eQ7[O'#FzO9RQWO'#FyOOQ?Mr'#Jn'#JnOOQ?Mp'#Jm'#JmO9WQWO'#GtOOQU'#KZ'#KZO9cQWO'#IUO9hQ?MxO'#IVOOQU'#JZ'#JZOOQU'#IZ'#IZQ`Q^OOO`Q^OOO9pQMnO'#DsO9wQ^O'#D{O:OQ^O'#D}O9^QWO'#GpO:VQ7[O'#CoO:eQWO'#EkO:pQWO'#EvO:uQ7[O'#FdO;dQWO'#GpOOQO'#K['#K[O;iQWO'#K[O;wQWO'#GxO;wQWO'#GyO;wQWO'#G{O9^QWO'#HOO<nQWO'#HRO>VQWO'#CeO>gQWO'#H_O>oQWO'#HeO>oQWO'#HgO`Q^O'#HiO>oQWO'#HkO>oQWO'#HnO>tQWO'#HtO>yQ?MyO'#HzO%[Q^O'#H|O?UQ?MyO'#IOO?aQ?MyO'#IQO9hQ?MxO'#ISO?lQ?NdO'#CiO@nQ`O'#DiQOQWOOO%[Q^O'#D}OAUQWO'#EQO:VQ7[O'#EkOAaQWO'#EkOAlQpO'#FdOOQU'#Cg'#CgOOQ?Mp'#Dn'#DnOOQ?Mp'#Jq'#JqO%[Q^O'#JqOOQO'#Jt'#JtOOQO'#Id'#IdOBlQ`O'#EdOOQ?Mp'#Ec'#EcOOQ?Mp'#Jx'#JxOChQ?NQO'#EdOCrQ`O'#ETOOQO'#Js'#JsODWQ`O'#JtOEeQ`O'#ETOCrQ`O'#EdPErO#@ItO'#CbPOOO)CDx)CDxOOOO'#I['#I[OE}O!bO,59UOOQ?Mr,59U,59UOOOO'#I]'#I]OF]O#tO,59UO%[Q^O'#D`OOOO'#I_'#I_OFkO!0LbO,59xOOQ?Mr,59x,59xOFyQ^O'#I`OG^QWO'#JoOI]QrO'#JoO+}Q^O'#JoOIdQWO,5:OOIzQWO'#EmOJXQWO'#KOOJdQWO'#J}OJdQWO'#J}OJlQWO,5;ZOJqQWO'#J|OOQ?Mv,5:Z,5:ZOJxQ^O,5:ZOLvQ?NdO,5:cOMgQWO,5:kONQQ?MxO'#J{ONXQWO'#JzO9WQWO'#JzONmQWO'#JzONuQWO,5;YONzQWO'#JzO!#PQrO'#JnOOQ?Mr'#Ci'#CiO%[Q^O'#EPO!#oQrO,5:pOOQQ'#Ju'#JuOOQO-E<f-E<fO9^QWO,5=[O!$VQWO,5=[O!$[Q^O,5;WO!&_Q7[O'#EhO!'xQWO,5;WO!'}Q^O'#DvO!(XQ`O,5;aO!(aQ`O,5;aO%[Q^O,5;aOOQU'#FS'#FSOOQU'#FU'#FUO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bO%[Q^O,5;bOOQU'#FY'#FYO!(oQ^O,5;sOOQ?Mr,5;x,5;xOOQ?Mr,5;y,5;yOOQ?Mr,5;{,5;{O%[Q^O'#IlO!*rQ?MxO,5<gO!&_Q7[O,5;bO!+aQ7[O,5;bO!-RQ7[O'#EZO%[Q^O,5;vOOQ?Mr,5;z,5;zO!-YQ&jO'#FiO!.VQ&jO'#KSO!-qQ&jO'#KSO!.^Q&jO'#KSOOQO'#KS'#KSO!.rQ&jO,5<ROOOS,5<_,5<_O!/TQ^O'#FuOOOS'#Ik'#IkO7VO,YO,5<PO!/[Q&jO'#FwOOQ?Mr,5<P,5<PO!/{Q!LQO'#CvOOQ?Mr'#Cz'#CzO!0`QWO'#CzO!0eO!0LbO'#DOO!1RQ7[O,5<dO!1YQWO,5<fO!2uQ$ISO'#GVO!3SQWO'#GWO!3XQWO'#GWO!4wQ$ISO'#G[O!5sQ`O'#G`OOQO'#Gk'#GkO!+hQ7[O'#GjOOQO'#Gm'#GmO!+hQ7[O'#GlO!6fQ!LQO'#JgOOQ?Mr'#Jg'#JgO!6pQWO'#JfO!7OQWO'#JeO!7WQWO'#CuOOQ?Mr'#Cx'#CxOOQ?Mr'#DS'#DSOOQ?Mr'#DU'#DUO1SQWO'#DWO!+hQ7[O'#F}O!+hQ7[O'#GPO!7`QWO'#GRO!7eQWO'#GSO!3XQWO'#GYO!+hQ7[O'#G_O!7jQWO'#EnO!8XQWO,5<eOOQ?Mp'#Cr'#CrO!8aQWO'#EoO!9ZQ`O'#EpOOQ?Mp'#J|'#J|O!9bQ?MxO'#K]O9hQ?MxO,5=`O`Q^O,5>pOOQU'#Jc'#JcOOQU,5>q,5>qOOQU-E<X-E<XO!;aQ?NdO,5:_O!9UQ`O,5:]O!=zQ?NdO,5:gO%[Q^O,5:gO!@bQ?NdO,5:iOOQO,5@v,5@vO!ARQ7[O,5=[O!AaQ?MxO'#JdO9RQWO'#JdO!ArQ?MxO,59ZO!A}Q`O,59ZO!BVQ7[O,59ZO:VQ7[O,59ZO!BbQWO,5;WO!BjQWO'#H^O!COQWO'#K`O%[Q^O,5;|O!9UQ`O,5<OO!CWQWO,5=wO!C]QWO,5=wO!CbQWO,5=wO9hQ?MxO,5=wO;wQWO,5=gOOQO'#Cv'#CvO!CpQ`O,5=dO!CxQ7[O,5=eO!DTQWO,5=gO!DYQpO,5=jO!DbQWO'#K[O>tQWO'#HTO9^QWO'#HVO!DgQWO'#HVO:VQ7[O'#HXO!DlQWO'#HXOOQU,5=m,5=mO!DqQWO'#HYO!ESQWO'#CoO!EXQWO,59PO!EcQWO,59PO!GhQ^O,59POOQU,59P,59PO!GxQ?MxO,59PO%[Q^O,59PO!JTQ^O'#HaOOQU'#Hb'#HbOOQU'#Hc'#HcO`Q^O,5=yO!JkQWO,5=yO`Q^O,5>PO`Q^O,5>RO!JpQWO,5>TO`Q^O,5>VO!JuQWO,5>YO!JzQ^O,5>`OOQU,5>f,5>fO%[Q^O,5>fO9hQ?MxO,5>hOOQU,5>j,5>jO# UQWO,5>jOOQU,5>l,5>lO# UQWO,5>lOOQU,5>n,5>nO# rQ`O'#D[O%[Q^O'#JqO# |Q`O'#JqO#!kQ`O'#DjO#!|Q`O'#DjO#%_Q^O'#DjO#%fQWO'#JpO#%nQWO,5:TO#%sQWO'#EqO#&RQWO'#KPO#&ZQWO,5;[O#&`Q`O'#DjO#&mQ`O'#ESOOQ?Mr,5:l,5:lO%[Q^O,5:lO#&tQWO,5:lO>tQWO,5;VO!A}Q`O,5;VO!BVQ7[O,5;VO:VQ7[O,5;VO#&|QWO,5@]O#'RQ(CYO,5:pOOQO-E<b-E<bO#(XQ?NQO,5;OOCrQ`O,5:oO#(cQ`O,5:oOCrQ`O,5;OO!ArQ?MxO,5:oOOQ?Mp'#Eg'#EgOOQO,5;O,5;OO%[Q^O,5;OO#(pQ?MxO,5;OO#({Q?MxO,5;OO!A}Q`O,5:oOOQO,5;U,5;UO#)ZQ?MxO,5;OPOOO'#IY'#IYP#)oO#@ItO,58|POOO,58|,58|OOOO-E<Y-E<YOOQ?Mr1G.p1G.pOOOO-E<Z-E<ZO#)zQpO,59zOOOO-E<]-E<]OOQ?Mr1G/d1G/dO#*PQrO,5>zO+}Q^O,5>zOOQO,5?Q,5?QO#*ZQ^O'#I`OOQO-E<^-E<^O#*hQWO,5@ZO#*pQrO,5@ZO#*wQWO,5@iOOQ?Mr1G/j1G/jO%[Q^O,5@jO#+PQWO'#IfOOQO-E<d-E<dO#*wQWO,5@iOOQ?Mp1G0u1G0uOOQ?Mv1G/u1G/uOOQ?Mv1G0V1G0VO%[Q^O,5@gO#+eQ?MxO,5@gO#+vQ?MxO,5@gO#+}QWO,5@fO9WQWO,5@fO#,VQWO,5@fO#,eQWO'#IiO#+}QWO,5@fOOQ?Mp1G0t1G0tO!(XQ`O,5:rO!(dQ`O,5:rOOQQ,5:t,5:tO#-VQYO,5:tO#-_Q7[O1G2vO9^QWO1G2vOOQ?Mr1G0r1G0rO#-mQ?NdO1G0rO#.rQ?NbO,5;SOOQ?Mr'#GU'#GUO#/`Q?NdO'#JgO!$[Q^O1G0rO#1hQrO'#JrO%[Q^O'#JrO#1rQWO,5:bOOQ?Mr'#D['#D[OOQ?Mr1G0{1G0{O%[Q^O1G0{OOQ?Mr1G1e1G1eO#1wQWO1G0{O#4]Q?NdO1G0|O#4dQ?NdO1G0|O#6zQ?NdO1G0|O#7RQ?NdO1G0|O#9YQ?NdO1G0|O#9pQ?NdO1G0|O#<gQ?NdO1G0|O#<nQ?NdO1G0|O#?OQ?NdO1G0|O#?]Q?NdO1G0|O#AWQ?NdO1G0|O#DWQ07bO'#CiO#FRQ07bO1G1_O#FYQ07bO'#JnO#FmQ?NdO,5?WOOQ?Mp-E<j-E<jO#GaQ?NdO1G0|OOQ?Mr1G0|1G0|O#IiQ7[O'#JwO#IsQWO,5:uO#IxQ?NdO1G1bO#JlQ&jO,5<VO#JtQ&jO,5<WO#J|Q&jO'#FnO#KeQWO'#FmOOQO'#KT'#KTOOQO'#Ij'#IjO#KjQ&jO1G1mOOQ?Mr1G1m1G1mOOOS1G1x1G1xO#K{Q07bO'#JmO#LVQWO,5<aO!(oQ^O,5<aOOOS-E<i-E<iOOQ?Mr1G1k1G1kO#L[Q`O'#KSOOQ?Mr,5<c,5<cO#LdQ`O,5<cOOQ?Mr,59f,59fO!&_Q7[O'#DQOOOO'#I^'#I^O#LiO!0LbO,59jOOQ?Mr,59j,59jO%[Q^O1G2OO!7eQWO'#InO#LtQ7[O,5<xOOQ?Mr,5<u,5<uO!+hQ7[O'#IqO#MdQ7[O,5=UO!+hQ7[O'#IsO#NVQ7[O,5=WO!&_Q7[O,5=YOOQO1G2Q1G2QO#NaQpO'#CrO#NtQ$ISO'#EoO$ sQ`O'#G`O$!aQpO,5<qO$!hQWO'#KWO9WQWO'#KWO$!vQWO,5<sO!+hQ7[O,5<rO$!{QWO'#GXO$#^QWO,5<rO$#cQpO'#GUO$#pQpO'#KXO$#zQWO'#KXO!&_Q7[O'#KXO$$PQWO,5<vO$$UQ`O'#GaO!5nQ`O'#GaO$$gQWO'#GcO$$lQWO'#GeO!3XQWO'#GhO$$qQ?MxO'#IpO$$|Q`O,5<zOOQ?Mv,5<z,5<zO$%TQ`O'#GaO$%cQ`O'#GbO$%kQ`O'#GbO$%pQ7[O,5=UO$&QQ7[O,5=WOOQ?Mr,5=Z,5=ZO!+hQ7[O,5@QO!+hQ7[O,5@QO$&bQWO'#IuO$&mQWO,5@PO$&uQWO,59aO$'iQ!LSO,59rOOQ?Mr'#Jk'#JkO$([Q7[O,5<iO$(}Q7[O,5<kO@fQWO,5<mOOQ?Mr,5<n,5<nO$)XQWO,5<tO$)^Q7[O,5<yO$)nQWO'#JzO!$[Q^O1G2PO$)sQWO1G2PO9WQWO'#J}O9WQWO'#EqO%[Q^O'#EqO9WQWO'#IwO$)xQ?MxO,5@wOOQU1G2z1G2zOOQU1G4[1G4[OOQ?Mr1G/y1G/yOOQ?Mr1G/w1G/wO$+zQ?NdO1G0ROOQU1G2v1G2vO!&_Q7[O1G2vO%[Q^O1G2vO#-bQWO1G2vO$.OQ7[O'#EhOOQ?Mp,5@O,5@OO$.YQ?MxO,5@OOOQU1G.u1G.uO!ArQ?MxO1G.uO!A}Q`O1G.uO!BVQ7[O1G.uO$.kQWO1G0rO$.pQWO'#CiO$.{QWO'#KaO$/TQWO,5=xO$/YQWO'#KaO$/_QWO'#KaO$/mQWO'#I}O$/{QWO,5@zO$0TQrO1G1hOOQ?Mr1G1j1G1jO9^QWO1G3cO@fQWO1G3cO$0[QWO1G3cO$0aQWO1G3cOOQU1G3c1G3cO!DTQWO1G3RO!&_Q7[O1G3OO$0fQWO1G3OOOQU1G3P1G3PO!&_Q7[O1G3PO$0kQWO1G3PO$0sQ`O'#G}OOQU1G3R1G3RO!5nQ`O'#IyO!DYQpO1G3UOOQU1G3U1G3UOOQU,5=o,5=oO$0{Q7[O,5=qO9^QWO,5=qO$$lQWO,5=sO9RQWO,5=sO!A}Q`O,5=sO!BVQ7[O,5=sO:VQ7[O,5=sO$1ZQWO'#K_O$1fQWO,5=tOOQU1G.k1G.kO$1kQ?MxO1G.kO@fQWO1G.kO$1vQWO1G.kO9hQ?MxO1G.kO$4OQrO,5@|O$4]QWO,5@|O9WQWO,5@|O$4hQ^O,5={O$4oQWO,5={OOQU1G3e1G3eO`Q^O1G3eOOQU1G3k1G3kOOQU1G3m1G3mO>oQWO1G3oO$4tQ^O1G3qO$8xQ^O'#HpOOQU1G3t1G3tO$9VQWO'#HvO>tQWO'#HxOOQU1G3z1G3zO$9_Q^O1G3zO9hQ?MxO1G4QOOQU1G4S1G4SOOQ?Mp'#G]'#G]O9hQ?MxO1G4UO9hQ?MxO1G4WO$=fQWO,5@]O!(oQ^O,5;]O9WQWO,5;]O>tQWO,5:UO!(oQ^O,5:UO!A}Q`O,5:UO$=kQ07bO,5:UOOQO,5;],5;]O$=uQ`O'#IaO$>]QWO,5@[OOQ?Mr1G/o1G/oO$>eQ`O'#IgO$>oQWO,5@kOOQ?Mp1G0v1G0vO#!|Q`O,5:UOOQO'#Ic'#IcO$>wQ`O,5:nOOQ?Mv,5:n,5:nO#&wQWO1G0WOOQ?Mr1G0W1G0WO%[Q^O1G0WOOQ?Mr1G0q1G0qO>tQWO1G0qO!A}Q`O1G0qO!BVQ7[O1G0qOOQ?Mp1G5w1G5wO!ArQ?MxO1G0ZOOQO1G0j1G0jO%[Q^O1G0jO$?OQ?MxO1G0jO$?ZQ?MxO1G0jO!A}Q`O1G0ZOCrQ`O1G0ZO$?iQ?MxO1G0jOOQO1G0Z1G0ZO$?}Q?NdO1G0jPOOO-E<W-E<WPOOO1G.h1G.hOOOO1G/f1G/fO$@XQpO,5<gO$@aQrO1G4fOOQO1G4l1G4lO%[Q^O,5>zO$@kQWO1G5uO$@sQWO1G6TO$@{QrO1G6UO9WQWO,5?QO$AVQ?NdO1G6RO%[Q^O1G6RO$AgQ?MxO1G6RO$AxQWO1G6QO$AxQWO1G6QO9WQWO1G6QO$BQQWO,5?TO9WQWO,5?TOOQO,5?T,5?TO$BfQWO,5?TO$)nQWO,5?TOOQO-E<g-E<gOOQQ1G0^1G0^OOQQ1G0`1G0`O#-YQWO1G0`OOQU7+(b7+(bO!&_Q7[O7+(bO%[Q^O7+(bO$BtQWO7+(bO$CPQ7[O7+(bO$C_Q?NdO,5=UO$EgQ?NdO,5=WO$GoQ?NdO,5=UO$I}Q?NdO,5=WO$L]Q?NdO,59rO$NbQ?NdO,5<iO%!jQ?NdO,5<kO%$rQ?NdO,5<yOOQ?Mr7+&^7+&^O%'QQ?NdO7+&^O%'tQ^O'#IbO%(RQWO,5@^O%(ZQrO,5@^OOQ?Mr1G/|1G/|O%(eQWO7+&gOOQ?Mr7+&g7+&gO%(jQ07bO,5:cO%[Q^O7+&yO%(tQ07bO,5:_O%)RQ07bO,5:gO%)]Q07bO,5:iO%)gQ7[O'#IeO%)qQWO,5@cOOQ?Mr1G0a1G0aOOQO1G1q1G1qOOQO1G1r1G1rO%)yQtO,5<YO!(oQ^O,5<XOOQO-E<h-E<hOOQ?Mr7+'X7+'XOOOS7+'d7+'dOOOS1G1{1G1{O%*UQWO1G1{OOQ?Mr1G1}1G1}O%*ZQpO,59lOOOO-E<[-E<[OOQ?Mr1G/U1G/UO%*bQ?NdO7+'jOOQ?Mr,5?Y,5?YO%+UQpO,5?YOOQ?Mr1G2d1G2dP!&_Q7[O'#InPOQ?Mr-E<l-E<lO%+tQ7[O,5?]OOQ?Mr-E<o-E<oO%,gQ7[O,5?_OOQ?Mr-E<q-E<qO%,qQpO1G2tO%,xQpO'#CrO%-`Q7[O'#J}O%-gQ^O'#EqOOQ?Mr1G2]1G2]O%-qQWO'#ImO%.VQWO,5@rO%.VQWO,5@rO%._QWO,5@rO%.jQWO,5@rOOQO1G2_1G2_O%.xQ7[O1G2^O!+hQ7[O1G2^O%/YQ$ISO'#IoO%/gQWO,5@sO!&_Q7[O,5@sO%/oQpO,5@sOOQ?Mr1G2b1G2bOOQ?Mp,5<{,5<{OOQ?Mp,5<|,5<|O$)nQWO,5<|OCcQWO,5<|O!A}Q`O,5<{OOQO'#Gd'#GdO%/yQWO,5<}OOQ?Mp,5=P,5=PO$)nQWO,5=SOOQO,5?[,5?[OOQO-E<n-E<nOOQ?Mv1G2f1G2fO!5nQ`O,5<{O%0RQWO,5<|O$$gQWO,5<}O!5nQ`O,5<|O!+hQ7[O'#IqO%0uQ7[O1G2pO!+hQ7[O'#IsO%1hQ7[O1G2rO%1rQ7[O1G5lO%1|Q7[O1G5lOOQO,5?a,5?aOOQO-E<s-E<sOOQO1G.{1G.{O!9UQ`O,59tO%[Q^O,59tOOQ?Mr,5<h,5<hO%2ZQWO1G2XO!+hQ7[O1G2`O%2`Q?NdO7+'kOOQ?Mr7+'k7+'kO!$[Q^O7+'kO%3SQWO,5;]OOQ?Mp,5?c,5?cOOQ?Mp-E<u-E<uO%3XQpO'#KYO#&wQWO7+(bO4UQrO7+(bO$BwQWO7+(bO%3cQ?NbO'#CiO%3vQ?NbO,5=QO%4hQWO,5=QOOQ?Mp1G5j1G5jOOQU7+$a7+$aO!ArQ?MxO7+$aO!A}Q`O7+$aO!$[Q^O7+&^O%4mQWO'#I|O%5UQWO,5@{OOQO1G3d1G3dO9^QWO,5@{O%5UQWO,5@{O%5^QWO,5@{OOQO,5?i,5?iOOQO-E<{-E<{OOQ?Mr7+'S7+'SO%5cQWO7+(}O9hQ?MxO7+(}O9^QWO7+(}O@fQWO7+(}OOQU7+(m7+(mO%5hQ?NbO7+(jO!&_Q7[O7+(jO%5rQpO7+(kOOQU7+(k7+(kO!&_Q7[O7+(kO%5yQWO'#K^O%6UQWO,5=iOOQO,5?e,5?eOOQO-E<w-E<wOOQU7+(p7+(pO%7eQ`O'#HWOOQU1G3]1G3]O!&_Q7[O1G3]O%[Q^O1G3]O%7lQWO1G3]O%7wQ7[O1G3]O9hQ?MxO1G3_O$$lQWO1G3_O9RQWO1G3_O!A}Q`O1G3_O!BVQ7[O1G3_O%8VQWO'#I{O%8kQWO,5@yO%8sQ`O,5@yOOQ?Mp1G3`1G3`OOQU7+$V7+$VO@fQWO7+$VO9hQ?MxO7+$VO%9OQWO7+$VO%[Q^O1G6hO%[Q^O1G6iO%9TQ?MxO1G6hO%9_Q^O1G3gO%9fQWO1G3gO%9kQ^O1G3gOOQU7+)P7+)PO9hQ?MxO7+)ZO`Q^O7+)]OOQU'#Kd'#KdOOQU'#JO'#JOO%9rQ^O,5>[OOQU,5>[,5>[O%[Q^O'#HqO%:PQWO'#HsOOQU,5>b,5>bO9WQWO,5>bOOQU,5>d,5>dOOQU7+)f7+)fOOQU7+)l7+)lOOQU7+)p7+)pOOQU7+)r7+)rO%:UQ`O1G5wO%:jQ07bO1G0wO%:tQWO1G0wOOQO1G/p1G/pO%;PQ07bO1G/pO>tQWO1G/pO!(oQ^O'#DjOOQO,5>{,5>{OOQO-E<_-E<_OOQO,5?R,5?ROOQO-E<e-E<eO!A}Q`O1G/pOOQO-E<a-E<aOOQ?Mv1G0Y1G0YOOQ?Mr7+%r7+%rO#&wQWO7+%rOOQ?Mr7+&]7+&]O>tQWO7+&]O!A}Q`O7+&]OOQO7+%u7+%uO$?}Q?NdO7+&UOOQO7+&U7+&UO%[Q^O7+&UO%;ZQ?MxO7+&UO!ArQ?MxO7+%uO!A}Q`O7+%uO%;fQ?MxO7+&UO%;tQ?NdO7++mO%[Q^O7++mO%<UQWO7++lO%<UQWO7++lOOQO1G4o1G4oO9WQWO1G4oO%<^QWO1G4oOOQQ7+%z7+%zO#&wQWO<<K|O4UQrO<<K|O%<lQWO<<K|OOQU<<K|<<K|O!&_Q7[O<<K|O%[Q^O<<K|O%<tQWO<<K|O%=PQ?NdO,5?]O%?XQ?NdO,5?_O%AaQ?NdO1G2^O%CoQ?NdO1G2pO%EwQ?NdO1G2rO%HPQrO,5>|O%[Q^O,5>|OOQO-E<`-E<`O%HZQWO1G5xOOQ?Mr<<JR<<JRO%HcQ07bO1G0rO%JjQ07bO1G0|O%JqQ07bO1G0|O%LrQ07bO1G0|O%LyQ07bO1G0|O%NkQ07bO1G0|O& RQ07bO1G0|O&#cQ07bO1G0|O&#jQ07bO1G0|O&%eQ07bO1G0|O&%rQ07bO1G0|O&'mQ07bO1G0|O&(QQ?NdO<<JeO&)VQ07bO1G0|O&*xQ07bO'#JgO&,{Q07bO1G1bO&-YQ07bO1G0RO&-dQ7[O,5?POOQO-E<c-E<cO!(oQ^O'#FpOOQO'#KU'#KUOOQO1G1t1G1tO&-nQWO1G1sO&-sQ07bO,5?WOOOS7+'g7+'gOOOO1G/W1G/WOOQ?Mr1G4t1G4tO!+hQ7[O7+(`O&0TQrO'#CiO&0_QWO,5?XO9WQWO,5?XOOQO-E<k-E<kO&0mQWO1G6^O&0mQWO1G6^O&0uQWO1G6^O&1QQ7[O7+'xO&1bQpO,5?ZO&1lQWO,5?ZO!&_Q7[O,5?ZOOQO-E<m-E<mO&1qQpO1G6_O&1{QWO1G6_OOQ?Mp1G2h1G2hO$)nQWO1G2hOOQ?Mp1G2g1G2gO&2TQWO1G2iO!&_Q7[O1G2iOOQ?Mp1G2n1G2nO!A}Q`O1G2gOCcQWO1G2hO&2YQWO1G2iO&2bQWO1G2hO&3UQ7[O,5?]OOQ?Mr-E<p-E<pO&3wQ7[O,5?_OOQ?Mr-E<r-E<rO!+hQ7[O7++WOOQ?Mr1G/`1G/`O&4RQWO1G/`OOQ?Mr7+'s7+'sO&4WQ7[O7+'zO&4hQ?NdO<<KVOOQ?Mr<<KV<<KVO&5[QWO1G0wO!&_Q7[O'#IvO&5aQWO,5@tO&7cQrO<<K|O!&_Q7[O1G2lOOQU<<G{<<G{O!ArQ?MxO<<G{O&7jQ?NdO<<IxOOQ?Mr<<Ix<<IxOOQO,5?h,5?hO&8^QWO,5?hO&8cQWO,5?hOOQO-E<z-E<zO&8qQWO1G6gO&8qQWO1G6gO9^QWO1G6gO@fQWO<<LiOOQU<<Li<<LiO&8yQWO<<LiO9hQ?MxO<<LiOOQU<<LU<<LUO%5hQ?NbO<<LUOOQU<<LV<<LVO%5rQpO<<LVO&9OQ`O'#IxO&9ZQWO,5@xO!(oQ^O,5@xOOQU1G3T1G3TO%-gQ^O'#JqOOQO'#Iz'#IzO9hQ?MxO'#IzO&9cQ`O,5=rOOQU,5=r,5=rO&9jQ`O'#EdO&:OQWO7+(wO&:TQWO7+(wOOQU7+(w7+(wO!&_Q7[O7+(wO%[Q^O7+(wO&:]QWO7+(wOOQU7+(y7+(yO9hQ?MxO7+(yO$$lQWO7+(yO9RQWO7+(yO!A}Q`O7+(yO&:hQWO,5?gOOQO-E<y-E<yOOQO'#HZ'#HZO&:sQWO1G6eO9hQ?MxO<<GqOOQU<<Gq<<GqO@fQWO<<GqO&:{QWO7+,SO&;QQWO7+,TO%[Q^O7+,SO%[Q^O7+,TOOQU7+)R7+)RO&;VQWO7+)RO&;[Q^O7+)RO&;cQWO7+)ROOQU<<Lu<<LuOOQU<<Lw<<LwOOQU-E<|-E<|OOQU1G3v1G3vO&;hQWO,5>]OOQU,5>_,5>_O&;mQWO1G3|O9WQWO7+&cO!(oQ^O7+&cOOQO7+%[7+%[O&;rQ07bO1G6UO>tQWO7+%[OOQ?Mr<<I^<<I^OOQ?Mr<<Iw<<IwO>tQWO<<IwOOQO<<Ip<<IpO$?}Q?NdO<<IpO%[Q^O<<IpOOQO<<Ia<<IaO!ArQ?MxO<<IaO&;|Q?MxO<<IpO&<XQ?NdO<= XO&<iQWO<= WOOQO7+*Z7+*ZO9WQWO7+*ZOOQUANAhANAhO&<qQrOANAhO!&_Q7[OANAhO#&wQWOANAhO4UQrOANAhO&<xQWOANAhO%[Q^OANAhO&=QQ?NdO7+'xO&?`Q?NdO,5?]O&AhQ?NdO,5?_O&CpQ?NdO7+'zO&FOQrO1G4hO&FYQ07bO7+&^O&HZQ07bO,5=UO&J_Q07bO,5=WO&JoQ07bO,5=UO&KPQ07bO,5=WO&KaQ07bO,59rO&MdQ07bO,5<iO' dQ07bO,5<kO'#dQ07bO,5<yO'%VQ07bO7+'jO'%dQ07bO7+'kO'%qQWO,5<[OOQO7+'_7+'_O'%vQ7[O<<KzOOQO1G4s1G4sO'%}QWO1G4sO'&YQWO1G4sO'&hQWO7++xO'&hQWO7++xO!&_Q7[O1G4uO'&pQpO1G4uO'&zQWO7++yOOQ?Mp7+(S7+(SO$)nQWO7+(TO''SQpO7+(TOOQ?Mp7+(R7+(RO$)nQWO7+(SO''ZQWO7+(TO!&_Q7[O7+(TOCcQWO7+(SO''`Q7[O<<NrOOQ?Mr7+$z7+$zO''jQpO,5?bOOQO-E<t-E<tO''tQ?NbO7+(WOOQUAN=gAN=gO9^QWO1G5SOOQO1G5S1G5SO'(UQWO1G5SO'(ZQWO7+,RO'(ZQWO7+,RO9hQ?MxOANBTO@fQWOANBTOOQUANBTANBTOOQUANApANApOOQUANAqANAqO'(cQWO,5?dOOQO-E<v-E<vO'(nQ07bO1G6dOOQO,5?f,5?fOOQO-E<x-E<xOOQU1G3^1G3^O%-gQ^O,5<}OOQU<<Lc<<LcO!&_Q7[O<<LcO&:OQWO<<LcO'(xQWO<<LcO%[Q^O<<LcOOQU<<Le<<LeO9hQ?MxO<<LeO$$lQWO<<LeO9RQWO<<LeO')QQ`O1G5RO')]QWO7+,POOQUAN=]AN=]O9hQ?MxOAN=]OOQU<= n<= nOOQU<= o<= oO')eQWO<= nO')jQWO<= oOOQU<<Lm<<LmO')oQWO<<LmO')tQ^O<<LmOOQU1G3w1G3wO>tQWO7+)hO'){QWO<<I}O'*WQ07bO<<I}OOQO<<Hv<<HvOOQ?MrAN?cAN?cOOQOAN?[AN?[O$?}Q?NdOAN?[OOQOAN>{AN>{O%[Q^OAN?[OOQO<<Mu<<MuOOQUG27SG27SO!&_Q7[OG27SO#&wQWOG27SO'*bQrOG27SO4UQrOG27SO'*iQWOG27SO'*qQ07bO<<JeO'+OQ07bO1G2^O',qQ07bO,5?]O'.qQ07bO,5?_O'0qQ07bO1G2pO'2qQ07bO1G2rO'4qQ07bO<<KVO'5OQ07bO<<IxOOQO1G1v1G1vO!+hQ7[OANAfOOQO7+*_7+*_O'5]QWO7+*_O'5hQWO<= dO'5pQpO7+*aOOQ?Mp<<Ko<<KoO$)nQWO<<KoOOQ?Mp<<Kn<<KnO'5zQpO<<KoO$)nQWO<<KnOOQO7+*n7+*nO9^QWO7+*nO'6RQWO<= mOOQUG27oG27oO9hQ?MxOG27oO!(oQ^O1G5OO'6ZQWO7+,OO&:OQWOANA}OOQUANA}ANA}O!&_Q7[OANA}O'6cQWOANA}OOQUANBPANBPO9hQ?MxOANBPO$$lQWOANBPOOQO'#H['#H[OOQO7+*m7+*mOOQUG22wG22wOOQUANEYANEYOOQUANEZANEZOOQUANBXANBXO'6kQWOANBXOOQU<<MS<<MSO!(oQ^OAN?iOOQOG24vG24vO$?}Q?NdOG24vO#&wQWOLD,nOOQULD,nLD,nO!&_Q7[OLD,nO'6pQrOLD,nO'6wQ07bO7+'xO'8jQ07bO,5?]O':jQ07bO,5?_O'<jQ07bO7+'zO'>]Q7[OG27QOOQO<<My<<MyOOQ?MpANAZANAZO$)nQWOANAZOOQ?MpANAYANAYOOQO<<NY<<NYOOQULD-ZLD-ZO'>mQ07bO7+*jOOQUG27iG27iO&:OQWOG27iO!&_Q7[OG27iOOQUG27kG27kO9hQ?MxOG27kOOQUG27sG27sO'>wQ07bOG25TOOQOLD*bLD*bOOQU!$(!Y!$(!YO#&wQWO!$(!YO!&_Q7[O!$(!YO'?RQ?NdOG27QOOQ?MpG26uG26uOOQULD-TLD-TO&:OQWOLD-TOOQULD-VLD-VOOQU!)9Et!)9EtO#&wQWO!)9EtOOQU!$(!o!$(!oOOQU!.K;`!.K;`O'AaQ07bOG27QO!(oQ^O'#DwO1PQWO'#EUO'CSQrO'#JmO'CZQMnO'#DsO'CbQ^O'#D{O'CiQrO'#CiO'FPQrO'#CiO!(oQ^O'#D}O'FaQ^O,5;WO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O,5;bO!(oQ^O'#IlO'HdQWO,5<gO'HlQ7[O,5;bO'JVQ7[O,5;bO!(oQ^O,5;vO!&_Q7[O'#GjO'HlQ7[O'#GjO!&_Q7[O'#GlO'HlQ7[O'#GlO1SQWO'#DWO1SQWO'#DWO!&_Q7[O'#F}O'HlQ7[O'#F}O!&_Q7[O'#GPO'HlQ7[O'#GPO!&_Q7[O'#G_O'HlQ7[O'#G_O!(oQ^O,5:gO'J^Q`O'#D[O!(oQ^O,5@jO'FaQ^O1G0rO'JhQ07bO'#CiO!(oQ^O1G2OO!&_Q7[O'#IqO'HlQ7[O'#IqO!&_Q7[O'#IsO'HlQ7[O'#IsO'JrQpO'#CrO!&_Q7[O,5<rO'HlQ7[O,5<rO'FaQ^O1G2PO!(oQ^O7+&yO!&_Q7[O1G2^O'HlQ7[O1G2^O!&_Q7[O'#IqO'HlQ7[O'#IqO!&_Q7[O'#IsO'HlQ7[O'#IsO!&_Q7[O1G2`O'HlQ7[O1G2`O'FaQ^O7+'kO'FaQ^O7+&^O!&_Q7[OANAfO'HlQ7[OANAfO'KVQWO'#ElO'K[QWO'#ElO'KdQWO'#F[O'KiQWO'#EvO'KnQWO'#KOO'KyQWO'#J|O'LUQWO,5;WO'LZQ7[O,5<dO'LbQWO'#GWO'LgQWO'#GWO'LlQWO,5<eO'LtQWO,5;WO'L|Q07bO1G1_O'MTQWO,5<rO'MYQWO,5<rO'M_QWO,5<tO'MdQWO,5<tO'MiQWO1G2PO'MnQWO1G0rO'MsQ7[O<<KzO'MzQ7[O<<KzO7eQ7[O'#FzO9RQWO'#FyOAaQWO'#EkO!(oQ^O,5;sO!3XQWO'#GWO!3XQWO'#GWO!3XQWO'#GYO!3XQWO'#GYO!+hQ7[O7+(`O!+hQ7[O7+(`O%,qQpO1G2tO%,qQpO1G2tO!&_Q7[O,5=YO!&_Q7[O,5=Y",
  stateData: "( O~O'wOS'xOSTOS'yRQ~OPYOQYOSfOY!VOaqOdzOeyOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![XO!fuO!iZO!lYO!mYO!nYO!pvO!rwO!uxO!y]O#t!PO$V|O%e}O%g!QO%i!OO%j!OO%k!OO%n!RO%p!SO%s!TO%t!TO%v!UO&S!WO&Y!XO&[!YO&^!ZO&`![O&c!]O&i!^O&o!_O&q!`O&s!aO&u!bO&w!cO(OSO(QTO(TUO([VO(j[O(yiO~OWtO~P`OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(O!dO(QTO(TUO([VO(j[O(yiO~Oa!wOp!nO!P!oO!_!yO!`!vO!a!vO!y:lO#Q!pO#R!pO#S!xO#T!pO#U!pO#X!zO#Y!zO(P!lO(QTO(TUO(`!mO(j!sO~O'y!{O~OP]XR]X[]Xa]Xo]X}]X!P]X!Y]X!i]X!m]X#O]X#P]X#]]X#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X'u]X([]X(m]X(t]X(u]X~O!d%PX~P(qO_!}O(Q#PO(R!}O(S#PO~O_#QO(S#PO(T#PO(U#QO~Ou#SO!R#TO(]#TO(^#VO~OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(O:pO(QTO(TUO([VO(j[O(yiO~O!X#ZO!Y#WO!V(cP!V(qP~P+}O!Z#cO~P`OPYOQYOSfOd!jOe!iOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(QTO(TUO([VO(j[O(yiO~Om#mO!X#iO!y]O#f#lO#g#iO(O:qO!h(nP~P.iO!i#oO(O#nO~O!u#sO!y]O%e#tO~O#h#uO~O!d#vO#h#uO~OP$]OR#zO[$cOo$QO}#yO!P#{O!Y$`O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO#z$YO([VO(m$ZO(t#|O(u#}O~Oa(aX'u(aX's(aX!h(aX!V(aX![(aX%f(aX!d(aX~P1qO#P$dO#]$eO$P$eOP(bXR(bX[(bXo(bX}(bX!P(bX!Y(bX!i(bX!m(bX#O(bX#k(bX#l(bX#m(bX#n(bX#o(bX#p(bX#q(bX#r(bX#s(bX#u(bX#w(bX#y(bX#z(bX([(bX(m(bX(t(bX(u(bX![(bX%f(bX~Oa(bX'u(bX's(bX!V(bX!h(bXs(bX!d(bX~P4UO#]$eO~O$[$hO$^$gO$e$mO~OSfO![$nO$h$oO$j$qO~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{%[O!P$|O![$}O!f%aO!i$yO#g%bO$V%_O$r%]O$t%^O$w%`O(O$sO(QTO(TUO([$vO(t%OO(u%QOg(XP~O!i%cO~O!P%fO![%gO(O%eO~O!d%kO~Oa%lO'u%lO~O}%pO~P%[O(P!lO~P%[O%k%tO~P%[Oh%WO!i%cO(O%eO(P!lO~Oe%{O!i%cO(O%eO~O#s$SO~O}&QO![%}O!i&PO%g&TO(O%eO(P!lO(QTO(TUO`)SP~O!u#sO~O%p&VO!P)OX![)OX(O)OX~O(O&WO~O!r&]O#t!PO%g!QO%i!OO%j!OO%k!OO%n!RO%p!SO%s!TO%t!TO~Od&bOe&aO!u&_O%e&`O%x&^O~P;|Od&eOeyO![&dO!r&]O!uxO!y]O#t!PO%e}O%i!OO%j!OO%k!OO%n!RO%p!SO%s!TO%t!TO%v!UO~Ob&hO#]&kO%g&fO(P!lO~P=RO!i&lO!r&pO~O!i#oO~O![XO~Oa%lO't&xO'u%lO~Oa%lO't&{O'u%lO~Oa%lO't&}O'u%lO~O's]X!V]Xs]X!h]X&W]X![]X%f]X!d]X~P(qO!_'[O!`'TO!a'TO(P!lO(QTO(TUO~Op'RO!P'QO!X'UO(`'PO!Z(dP!Z(sP~P@YOk'_O![']O(O%eO~Oe'dO!i%cO(O%eO~O}&QO!i&PO~Op!nO!P!oO!y:lO#Q!pO#R!pO#T!pO#U!pO(P!lO(QTO(TUO(`!mO(j!sO~O!_'jO!`'iO!a'iO#S!pO#X'kO#Y'kO~PAtOa%lOh%WO!d#vO!i%cO'u%lO(m'mO~O!m'qO#]'oO~PCSOp!nO!P!oO(QTO(TUO(`!mO(j!sO~O![XOp(hX!P(hX!_(hX!`(hX!a(hX!y(hX#Q(hX#R(hX#S(hX#T(hX#U(hX#X(hX#Y(hX(P(hX(Q(hX(T(hX(`(hX(j(hX~O!`'iO!a'iO(P!lO~PCrO'z'uO'{'uO'|'wO~O_!}O(Q'yO(R!}O(S'yO~O_#QO(S'yO(T'yO(U#QO~Ou#SO!R#TO(]#TO(^'}O~O!X(PO!V'SX!V'YX!Y'SX!Y'YX~P+}O!Y(RO!V(cX~OP$]OR#zO[$cOo$QO}#yO!P#{O!Y(RO!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO#z$YO([VO(m$ZO(t#|O(u#}O~O!V(cX~PGfO!V(WO~O!V(pX!Y(pX!d(pX!h(pX(m(pX~O#](pX#h#aX!Z(pX~PIiO#](XO!V(rX!Y(rX~O!Y(YO!V(qX~O!V(]O~O#]$eO~PIiO!Z(^O~P`OR#zO}#yO!P#{O!i#xO([VOP!ka[!kao!ka!Y!ka!m!ka#O!ka#k!ka#l!ka#m!ka#n!ka#o!ka#p!ka#q!ka#r!ka#s!ka#u!ka#w!ka#y!ka#z!ka(m!ka(t!ka(u!ka~Oa!ka'u!ka's!ka!V!ka!h!kas!ka![!ka%f!ka!d!ka~PKPO!h(_O~O!d#vO#](`O(m'mO!Y(oXa(oX'u(oX~O!h(oX~PMlO!P%fO![%gO!y]O#f(eO#g(dO(O%eO~O!Y(fO!h(nX~O!h(hO~O!P%fO![%gO#g(dO(O%eO~OP(bXR(bX[(bXo(bX}(bX!P(bX!Y(bX!i(bX!m(bX#O(bX#k(bX#l(bX#m(bX#n(bX#o(bX#p(bX#q(bX#r(bX#s(bX#u(bX#w(bX#y(bX#z(bX([(bX(m(bX(t(bX(u(bX~O!d#vO!h(bX~P! YOR(jO}(iO!i#xO#P$dO!y!xa!P!xa~O!u!xa%e!xa![!xa#f!xa#g!xa(O!xa~P!#ZO!u(nO~OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![XO!fuO!iZO!lYO!mYO!nYO!pvO!r!gO!u!hO$V!kO(O!dO(QTO(TUO([VO(j[O(yiO~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;YO!P$|O![$}O!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(O(rO(QTO(TUO([$vO(t%OO(u%QO~O#h(tO~O!X(vO!h(fP~P%[O(`(xO(j[O~O!P(zO!i#xO(`(xO(j[O~OP:kOQ:kOSfOd<fOe!iOmkOo:kOpkOqkOwkOy:kO{:kO!PWO!TkO!UkO![!eO!f:nO!iZO!l:kO!m:kO!n:kO!p:oO!r:rO!u!hO$V!kO(O)YO(QTO(TUO([VO(j[O(y<dO~O!Y$`Oa$oa'u$oa's$oa!h$oa!V$oa![$oa%f$oa!d$oa~O#t)`O~P!&_Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{%[O!P$|O![$}O!f%aO!i$yO#g%bO$V%_O$r%]O$t%^O$w%`O(O(rO(QTO(TUO([$vO(t%OO(u%QO~Og(kP~P!+hO})eO!d)dO![$]X$Y$]X$[$]X$^$]X$e$]X~O!d)dO![(vX$Y(vX$[(vX$^(vX$e(vX~O})eO~P!-qO})eO![(vX$Y(vX$[(vX$^(vX$e(vX~O![)gO$Y)kO$[)fO$^)fO$e)lO~O!X)oO~P!(oO$[$hO$^$gO$e)sO~Ok$xX}$xX!P$xX#P$xX(t$xX(u$xX~OgjXg$xXkjX!YjX#]jX~P!/gOp)uO~Ou)vO(])wO(^)yO~Ok*SO}){O!P)|O(t%OO(u%QO~Og)zO~P!0pOg*TO~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;YO!P*VO![*WO!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(QTO(TUO([$vO(t%OO(u%QO~O!X*ZO(O*UO!h(zP~P!1_O#h*]O~O!i*^O~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;YO!P$|O![$}O!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(O*`O(QTO(TUO([$vO(t%OO(u%QO~O!X*cO!V({P~P!3^Oo*oO!P*gO!_*mO!`*fO!a*fO!i*^O#X*nO%]*iO(P!lO(`!mO~O!Z*lO~P!5RO#P$dOk(ZX}(ZX!P(ZX(t(ZX(u(ZX!Y(ZX#](ZX~Og(ZX#}(ZX~P!5zOk*tO#]*sOg(YX!Y(YX~O!Y*uOg(XX~O(O&WOg(XP~O!i*|O~O(O(rO~Om+QO!P%fO!X#iO![%gO!y]O#f#lO#g#iO(O%eO!h(nP~O!d#vO#h+RO~O!P%fO!X+TO!Y(YO![%gO(O%eO!V(qP~Op'XO!P+VO!X+UO(QTO(TUO(`(xO~O!Z(sP~P!8uO!Y+WOa)PX'u)PX~OP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO#z$YO([VO(m$ZO(t#|O(u#}O~Oa!ga!Y!ga'u!ga's!ga!V!ga!h!gas!ga![!ga%f!ga!d!ga~P!9mOR#zO}#yO!P#{O!i#xO([VOP!oa[!oao!oa!Y!oa!m!oa#O!oa#k!oa#l!oa#m!oa#n!oa#o!oa#p!oa#q!oa#r!oa#s!oa#u!oa#w!oa#y!oa#z!oa(m!oa(t!oa(u!oa~Oa!oa'u!oa's!oa!V!oa!h!oas!oa![!oa%f!oa!d!oa~P!<TOR#zO}#yO!P#{O!i#xO([VOP!qa[!qao!qa!Y!qa!m!qa#O!qa#k!qa#l!qa#m!qa#n!qa#o!qa#p!qa#q!qa#r!qa#s!qa#u!qa#w!qa#y!qa#z!qa(m!qa(t!qa(u!qa~Oa!qa'u!qa's!qa!V!qa!h!qas!qa![!qa%f!qa!d!qa~P!>kOh%WOk+aO![']O%f+`O~O!d+cOa(WX![(WX'u(WX!Y(WX~Oa%lO![XO'u%lO~Oh%WO!i%cO~Oh%WO!i%cO(O%eO~O!d#vO#h(tO~Ob+nO%g+oO(O+kO(QTO(TUO!Z)TP~O!Y+pO`)SX~O[+tO~O`+uO~O![%}O(O%eO(P!lO`)SP~Oh%WO#]+zO~Oh%WOk+}O![$}O~O![,PO~O},RO![XO~O%k%tO~O!u,WO~Oe,]O~Ob,^O(O#nO(QTO(TUO!Z)RP~Oe%{O~O%g!QO(O&WO~P=RO[,cO`,bO~OPYOQYOSfOdzOeyOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO!fuO!iZO!lYO!mYO!nYO!pvO!uxO!y]O%e}O(QTO(TUO([VO(j[O(yiO~O![!eO!r!gO$V!kO(O!dO~P!EkO`,bOa%lO'u%lO~OPYOQYOSfOd!jOe!iOmkOoYOpkOqkOwkOyYO{YO!PWO!TkO!UkO![!eO!fuO!iZO!lYO!mYO!nYO!pvO!u!hO$V!kO(O!dO(QTO(TUO([VO(j[O(yiO~Oa,hO!rwO#t!OO%i!OO%j!OO%k!OO~P!HTO!i&lO~O&Y,nO~O![,pO~O&k,rO&m,sOP&haQ&haS&haY&haa&had&hae&ham&hao&hap&haq&haw&hay&ha{&ha!P&ha!T&ha!U&ha![&ha!f&ha!i&ha!l&ha!m&ha!n&ha!p&ha!r&ha!u&ha!y&ha#t&ha$V&ha%e&ha%g&ha%i&ha%j&ha%k&ha%n&ha%p&ha%s&ha%t&ha%v&ha&S&ha&Y&ha&[&ha&^&ha&`&ha&c&ha&i&ha&o&ha&q&ha&s&ha&u&ha&w&ha's&ha(O&ha(Q&ha(T&ha([&ha(j&ha(y&ha!Z&ha&a&hab&ha&f&ha~O(O,xO~Oh!bX!Y!OX!Z!OX!d!OX!d!bX!i!bX#]!OX~O!Y!bX!Z!bX~P# ZO!d,}O#],|Oh(eX!Y#eX!Y(eX!Z#eX!Z(eX!d(eX!i(eX~Oh%WO!d-PO!i%cO!Y!^X!Z!^X~Op!nO!P!oO(QTO(TUO(`!mO~OP:kOQ:kOSfOd<fOe!iOmkOo:kOpkOqkOwkOy:kO{:kO!PWO!TkO!UkO![!eO!f:nO!iZO!l:kO!m:kO!n:kO!p:oO!r:rO!u!hO$V!kO(QTO(TUO([VO(j[O(y<dO~O(O;fO~P##_O!Y-TO!Z(dX~O!Z-VO~O!d,}O#],|O!Y#eX!Z#eX~O!Y-WO!Z(sX~O!Z-YO~O!`-ZO!a-ZO(P!lO~P#!|O!Z-^O~P'_Ok-aO![']O~O!V-fO~Op!xa!_!xa!`!xa!a!xa#Q!xa#R!xa#S!xa#T!xa#U!xa#X!xa#Y!xa(P!xa(Q!xa(T!xa(`!xa(j!xa~P!#ZO!m-kO#]-iO~PCSO!`-mO!a-mO(P!lO~PCrOa%lO#]-iO'u%lO~Oa%lO!d#vO#]-iO'u%lO~Oa%lO!d#vO!m-kO#]-iO'u%lO(m'mO~O'z'uO'{'uO'|-rO~Os-sO~O!V'Sa!Y'Sa~P!9mO!X-wO!V'SX!Y'SX~P%[O!Y(RO!V(ca~O!V(ca~PGfO!Y(YO!V(qa~O!P%fO!X-{O![%gO(O%eO!V'YX!Y'YX~O#]-}O!Y(oa!h(oaa(oa'u(oa~O!d#vO~P#+eO!Y(fO!h(na~O!P%fO![%gO#g.RO(O%eO~Om.WO!P%fO!X.TO![%gO!y]O#f.VO#g.TO(O%eO!Y']X!h']X~OR.[O!i#xO~Oh%WOk._O![']O%f.^O~Oa#`i!Y#`i'u#`i's#`i!V#`i!h#`is#`i![#`i%f#`i!d#`i~P!9mOk<pO}){O!P)|O(t%OO(u%QO~O#h#[aa#[a#]#[a'u#[a!Y#[a!h#[a![#[a!V#[a~P#.aO#h(ZXP(ZXR(ZX[(ZXa(ZXo(ZX!i(ZX!m(ZX#O(ZX#k(ZX#l(ZX#m(ZX#n(ZX#o(ZX#p(ZX#q(ZX#r(ZX#s(ZX#u(ZX#w(ZX#y(ZX#z(ZX'u(ZX([(ZX(m(ZX!h(ZX!V(ZX's(ZXs(ZX![(ZX%f(ZX!d(ZX~P!5zO!Y.lO!h(fX~P!9mO!h.oO~O!V.qO~OP$]OR#zO}#yO!P#{O!i#xO!m$]O([VO[#jia#jio#ji!Y#ji#O#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji'u#ji(m#ji(t#ji(u#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O#k#ji~P#1|O#k$OO~P#1|OP$]OR#zO}#yO!P#{O!i#xO!m$]O#k$OO#l$PO#m$PO#n$PO([VO[#jia#ji!Y#ji#O#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji'u#ji(m#ji(t#ji(u#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~Oo#ji~P#4kOo$QO~P#4kOP$]OR#zOo$QO}#yO!P#{O!i#xO!m$]O#k$OO#l$PO#m$PO#n$PO#o$RO([VOa#ji!Y#ji#u#ji#w#ji#y#ji#z#ji'u#ji(m#ji(t#ji(u#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O[#ji#O#ji#p#ji#q#ji#r#ji#s#ji~P#7YO[$cO#O$SO#p$SO#q$SO#r$bO#s$SO~P#7YOP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO([VO(u#}Oa#ji!Y#ji#y#ji#z#ji'u#ji(m#ji(t#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O#w$VO~P#:WO#w#ji~P#:WOP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO([VOa#ji!Y#ji#y#ji#z#ji'u#ji(m#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~O#w#ji(t#ji(u#ji~P#<uO#w$VO(t#|O(u#}O~P#<uOP$]OR#zO[$cOo$QO}#yO!P#{O!i#xO!m$]O#O$SO#k$OO#l$PO#m$PO#n$PO#o$RO#p$SO#q$SO#r$bO#s$SO#u$TO#w$VO#y$XO([VO(t#|O(u#}O~Oa#ji!Y#ji#z#ji'u#ji(m#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~P#?jOP]XR]X[]Xo]X}]X!P]X!i]X!m]X#O]X#P]X#]]X#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X([]X(m]X(t]X(u]X!Y]X!Z]X~O#}]X~P#BQOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO#w:{O#y:}O#z;OO([VO(m$ZO(t#|O(u#}O~O#}.sO~P#D_O#P$dO#];TO$P;TO#}(bX!Z(bX~P! YOa'`a!Y'`a'u'`a's'`a!h'`a!V'`as'`a!['`a%f'`a!d'`a~P!9mOP#jiR#ji[#jia#jio#ji!Y#ji!i#ji!m#ji#O#ji#k#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji'u#ji([#ji(m#ji's#ji!V#ji!h#jis#ji![#ji%f#ji!d#ji~P#.aO!Y.wOg(kX~P!0pOg.yO~Oa$Oi!Y$Oi'u$Oi's$Oi!V$Oi!h$Ois$Oi![$Oi%f$Oi!d$Oi~P!9mO$[.zO$^.zO~O$[.{O$^.{O~O!d)dO#].|O![$bX$Y$bX$[$bX$^$bX$e$bX~O!X.}O~O![)gO$Y/PO$[)fO$^)fO$e/QO~O!Y;PO!Z(aX~P#D_O!Z/RO~O!d)dO$e(vX~O$e/TO~Ou)vO(])wO(^/WO~O!V/[O~P!&_O(t%OOk%^a}%^a!P%^a(u%^a!Y%^a#]%^a~Og%^a#}%^a~P#L{O(u%QOk%`a}%`a!P%`a(t%`a!Y%`a#]%`a~Og%`a#}%`a~P#MnO!YfX!dfX!hfX!h$xX(mfX~P!/gO!X/eO!Y(YO(O/dO!V(qP!V({P~P!1_Oo*oO!_*mO!`*fO!a*fO!i*^O#X*nO%]*iO(P!lO~Op'XO!P/fO!X+UO!Z*lO(QTO(TUO(`;cO!Z(sP~P$ XO!h/gO~P#.aO!Y/hO!d#vO(m'mO!h(zX~O!h/mO~O!P%fO!X*ZO![%gO(O%eO!h(zP~O#h/oO~O!V$xX!Y$xX!d%PX~P!/gO!Y/pO!V({X~P#.aO!d/rO~O!V/tO~Oh%WOo/xO!d#vO!i%cO(m'mO~O(O/zO~O!d+cO~Oa%lO!Y0OO'u%lO~O!Z0QO~P!5RO!`0RO!a0RO(P!lO(`!mO~O!P0TO(`!mO~O#X0UO~Og%^a!Y%^a#]%^a#}%^a~P!0pOg%`a!Y%`a#]%`a#}%`a~P!0pO(O&WOg'iX!Y'iX~O!Y*uOg(Xa~Og0_O~OR0`O}0`O!P0aO#P$dOkza(tza(uza!Yza#]za~Ogza#}za~P$&zO}){O!P)|Ok$qa(t$qa(u$qa!Y$qa#]$qa~Og$qa#}$qa~P$'sO}){O!P)|Ok$sa(t$sa(u$sa!Y$sa#]$sa~Og$sa#}$sa~P$(fO#h0dO~Og%Ra!Y%Ra#]%Ra#}%Ra~P!0pO!d#vO~O#h0gO~O!Y+WOa)Pa'u)Pa~OR#zO}#yO!P#{O!i#xO([VOP!oi[!oio!oi!Y!oi!m!oi#O!oi#k!oi#l!oi#m!oi#n!oi#o!oi#p!oi#q!oi#r!oi#s!oi#u!oi#w!oi#y!oi#z!oi(m!oi(t!oi(u!oi~Oa!oi'u!oi's!oi!V!oi!h!ois!oi![!oi%f!oi!d!oi~P$*TOh%WOo$uOp$tOq$tOw%YOy%ZO{;YO!P$|O![$}O!f<jO!i$yO#g;`O$V%_O$r;[O$t;^O$w%`O(QTO(TUO([$vO(t%OO(u%QO~Om0pO(O0oO~P$,kO!d+cOa(Wa![(Wa'u(Wa!Y(Wa~O#h0vO~O[]X!YfX!ZfX~O!Y0wO!Z)TX~O!Z0yO~O[0zO~Ob0|O(O+kO(QTO(TUO~O![%}O(O%eO`'qX!Y'qX~O!Y+pO`)Sa~O!h1PO~P!9mO[1SO~O`1TO~O#]1WO~Ok1ZO![$}O~O(`(xO!Z)QP~Oh%WOk1dO![1aO%f1cO~O[1nO!Y1lO!Z)RX~O!Z1oO~O`1qOa%lO'u%lO~O(O#nO(QTO(TUO~O#P$dO#]$eO$P$eOP(bXR(bX[(bXo(bX}(bX!P(bX!Y(bX!i(bX!m(bX#O(bX#k(bX#l(bX#m(bX#n(bX#o(bX#p(bX#q(bX#r(bX#u(bX#w(bX#y(bX#z(bX([(bX(m(bX(t(bX(u(bX~O#s1tO&W1uOa(bX~P$2RO#]$eO#s1tO&W1uO~Oa1wO~P%[Oa1yO~O&a1|OP&_iQ&_iS&_iY&_ia&_id&_ie&_im&_io&_ip&_iq&_iw&_iy&_i{&_i!P&_i!T&_i!U&_i![&_i!f&_i!i&_i!l&_i!m&_i!n&_i!p&_i!r&_i!u&_i!y&_i#t&_i$V&_i%e&_i%g&_i%i&_i%j&_i%k&_i%n&_i%p&_i%s&_i%t&_i%v&_i&S&_i&Y&_i&[&_i&^&_i&`&_i&c&_i&i&_i&o&_i&q&_i&s&_i&u&_i&w&_i's&_i(O&_i(Q&_i(T&_i([&_i(j&_i(y&_i!Z&_ib&_i&f&_i~Ob2SO!Z2QO&f2RO~P`O![XO!i2UO~O&m,sOP&hiQ&hiS&hiY&hia&hid&hie&him&hio&hip&hiq&hiw&hiy&hi{&hi!P&hi!T&hi!U&hi![&hi!f&hi!i&hi!l&hi!m&hi!n&hi!p&hi!r&hi!u&hi!y&hi#t&hi$V&hi%e&hi%g&hi%i&hi%j&hi%k&hi%n&hi%p&hi%s&hi%t&hi%v&hi&S&hi&Y&hi&[&hi&^&hi&`&hi&c&hi&i&hi&o&hi&q&hi&s&hi&u&hi&w&hi's&hi(O&hi(Q&hi(T&hi([&hi(j&hi(y&hi!Z&hi&a&hib&hi&f&hi~O!V2[O~O!Y!^a!Z!^a~P#D_Op!nO!P!oO!X2bO(`!mO!Y'TX!Z'TX~P@YO!Y-TO!Z(da~O!Y'ZX!Z'ZX~P!8uO!Y-WO!Z(sa~O!Z2iO~P'_Oa%lO#]2rO'u%lO~Oa%lO!d#vO#]2rO'u%lO~Oa%lO!d#vO!m2vO#]2rO'u%lO(m'mO~Oa%lO'u%lO~P!9mO!Y$`Os$oa~O!V'Si!Y'Si~P!9mO!Y(RO!V(ci~O!Y(YO!V(qi~O!V(ri!Y(ri~P!9mO!Y(oi!h(oia(oi'u(oi~P!9mO#]2xO!Y(oi!h(oia(oi'u(oi~O!Y(fO!h(ni~O!P%fO![%gO!y]O#f2}O#g2|O(O%eO~O!P%fO![%gO#g2|O(O%eO~Ok3UO![']O%f3TO~Oh%WOk3UO![']O%f3TO~O#h%^aP%^aR%^a[%^aa%^ao%^a!i%^a!m%^a#O%^a#k%^a#l%^a#m%^a#n%^a#o%^a#p%^a#q%^a#r%^a#s%^a#u%^a#w%^a#y%^a#z%^a'u%^a([%^a(m%^a!h%^a!V%^a's%^as%^a![%^a%f%^a!d%^a~P#L{O#h%`aP%`aR%`a[%`aa%`ao%`a!i%`a!m%`a#O%`a#k%`a#l%`a#m%`a#n%`a#o%`a#p%`a#q%`a#r%`a#s%`a#u%`a#w%`a#y%`a#z%`a'u%`a([%`a(m%`a!h%`a!V%`a's%`as%`a![%`a%f%`a!d%`a~P#MnO#h%^aP%^aR%^a[%^aa%^ao%^a!Y%^a!i%^a!m%^a#O%^a#k%^a#l%^a#m%^a#n%^a#o%^a#p%^a#q%^a#r%^a#s%^a#u%^a#w%^a#y%^a#z%^a'u%^a([%^a(m%^a!h%^a!V%^a's%^a#]%^as%^a![%^a%f%^a!d%^a~P#.aO#h%`aP%`aR%`a[%`aa%`ao%`a!Y%`a!i%`a!m%`a#O%`a#k%`a#l%`a#m%`a#n%`a#o%`a#p%`a#q%`a#r%`a#s%`a#u%`a#w%`a#y%`a#z%`a'u%`a([%`a(m%`a!h%`a!V%`a's%`a#]%`as%`a![%`a%f%`a!d%`a~P#.aO#hzaPza[zaazaoza!iza!mza#Oza#kza#lza#mza#nza#oza#pza#qza#rza#sza#uza#wza#yza#zza'uza([za(mza!hza!Vza'szasza![za%fza!dza~P$&zO#h$qaP$qaR$qa[$qaa$qao$qa!i$qa!m$qa#O$qa#k$qa#l$qa#m$qa#n$qa#o$qa#p$qa#q$qa#r$qa#s$qa#u$qa#w$qa#y$qa#z$qa'u$qa([$qa(m$qa!h$qa!V$qa's$qas$qa![$qa%f$qa!d$qa~P$'sO#h$saP$saR$sa[$saa$sao$sa!i$sa!m$sa#O$sa#k$sa#l$sa#m$sa#n$sa#o$sa#p$sa#q$sa#r$sa#s$sa#u$sa#w$sa#y$sa#z$sa'u$sa([$sa(m$sa!h$sa!V$sa's$sas$sa![$sa%f$sa!d$sa~P$(fO#h%RaP%RaR%Ra[%Raa%Rao%Ra!Y%Ra!i%Ra!m%Ra#O%Ra#k%Ra#l%Ra#m%Ra#n%Ra#o%Ra#p%Ra#q%Ra#r%Ra#s%Ra#u%Ra#w%Ra#y%Ra#z%Ra'u%Ra([%Ra(m%Ra!h%Ra!V%Ra's%Ra#]%Ras%Ra![%Ra%f%Ra!d%Ra~P#.aOa#`q!Y#`q'u#`q's#`q!V#`q!h#`qs#`q![#`q%f#`q!d#`q~P!9mO!X3^O!Y'UX!h'UX~P%[O!Y.lO!h(fa~O!Y.lO!h(fa~P!9mO!V3aO~O#}!ka!Z!ka~PKPO#}!ga!Y!ga!Z!ga~P#D_O#}!oa!Z!oa~P!<TO#}!qa!Z!qa~P!>kOg'XX!Y'XX~P!+hO!Y.wOg(ka~OSfO![3uO$c3vO~O!Z3zO~Os3{O~P#.aOa$lq!Y$lq'u$lq's$lq!V$lq!h$lqs$lq![$lq%f$lq!d$lq~P!9mO!V3|O~P#.aO}){O!P)|O(u%QOk'ea(t'ea!Y'ea#]'ea~Og'ea#}'ea~P%+]O}){O!P)|Ok'ga(t'ga(u'ga!Y'ga#]'ga~Og'ga#}'ga~P%,OO(m$ZO~P#.aO!VfX!V$xX!YfX!Y$xX!d%PX#]fX~P!/gO(O;lO~P!1_OmkO(O4OO~P.iO!P%fO!X4QO![%gO(O%eO!Y'aX!h'aX~O!Y/hO!h(za~O!Y/hO!d#vO!h(za~O!Y/hO!d#vO(m'mO!h(za~Og$zi!Y$zi#]$zi#}$zi~P!0pO!X4YO!V'cX!Y'cX~P!3^O!Y/pO!V({a~O!Y/pO!V({a~P#.aO!d#vO#s4bO~Oo4eO!d#vO(m'mO~O(t%OOk%^i}%^i!P%^i(u%^i!Y%^i#]%^i~Og%^i#}%^i~P%0^O(u%QOk%`i}%`i!P%`i(t%`i!Y%`i#]%`i~Og%`i#}%`i~P%1POg(Yi!Y(Yi~P!0pO#]4lOg(Yi!Y(Yi~P!0pO!h4oO~Oa$mq!Y$mq'u$mq's$mq!V$mq!h$mqs$mq![$mq%f$mq!d$mq~P!9mO!V4sO~O!Y4tO![(|X~P#.aOa$xX![$xX%Z]X'u$xX!Y$xX~P!/gO%Z4wOalXklX}lX!PlX![lX'ulX(tlX(ulX!YlX~O%Z4wO~Ob4}O%g5OO(O+kO(QTO(TUO!Y'pX!Z'pX~O!Y0wO!Z)Ta~O[5SO~O`5TO~Oa%lO'u%lO~P#.aO![$}O~P#.aO!Y5]O#]5_O!Z)QX~O!Z5`O~Op!nO!P5aO!_!yO!`!vO!a!vO!y:lO#Q!pO#R!pO#S!pO#T!pO#U!pO#X5fO#Y!zO(P!lO(QTO(TUO(`!mO(j!sO~O!Z5eO~P%6ZOk5kO![1aO%f5jO~Oh%WOk5kO![1aO%f5jO~Ob5rO(O#nO(QTO(TUO!Y'oX!Z'oX~O!Y1lO!Z)Ra~O(QTO(TUO(`5tO~O`5xO~O#s5{O&W5|O~PMlO!h5}O~P%[Oa6PO~Oa6PO~P%[Ob2SO!Z6UO&f2RO~P`O!d6WO~O!d6YOh(ei!Y(ei!Z(ei!d(ei!i(ei~O!Y#ei!Z#ei~P#D_O#]6ZO!Y#ei!Z#ei~O!Y!^i!Z!^i~P#D_Oa%lO#]6dO'u%lO~Oa%lO!d#vO#]6dO'u%lO~O!Y(oq!h(oqa(oq'u(oq~P!9mO!Y(fO!h(nq~O!P%fO![%gO#g6kO(O%eO~O![']O%f6nO~Ok6rO![']O%f6nO~O#h'eaP'eaR'ea['eaa'eao'ea!i'ea!m'ea#O'ea#k'ea#l'ea#m'ea#n'ea#o'ea#p'ea#q'ea#r'ea#s'ea#u'ea#w'ea#y'ea#z'ea'u'ea(['ea(m'ea!h'ea!V'ea's'eas'ea!['ea%f'ea!d'ea~P%+]O#h'gaP'gaR'ga['gaa'gao'ga!i'ga!m'ga#O'ga#k'ga#l'ga#m'ga#n'ga#o'ga#p'ga#q'ga#r'ga#s'ga#u'ga#w'ga#y'ga#z'ga'u'ga(['ga(m'ga!h'ga!V'ga's'gas'ga!['ga%f'ga!d'ga~P%,OO#h$ziP$ziR$zi[$zia$zio$zi!Y$zi!i$zi!m$zi#O$zi#k$zi#l$zi#m$zi#n$zi#o$zi#p$zi#q$zi#r$zi#s$zi#u$zi#w$zi#y$zi#z$zi'u$zi([$zi(m$zi!h$zi!V$zi's$zi#]$zis$zi![$zi%f$zi!d$zi~P#.aO#h%^iP%^iR%^i[%^ia%^io%^i!i%^i!m%^i#O%^i#k%^i#l%^i#m%^i#n%^i#o%^i#p%^i#q%^i#r%^i#s%^i#u%^i#w%^i#y%^i#z%^i'u%^i([%^i(m%^i!h%^i!V%^i's%^is%^i![%^i%f%^i!d%^i~P%0^O#h%`iP%`iR%`i[%`ia%`io%`i!i%`i!m%`i#O%`i#k%`i#l%`i#m%`i#n%`i#o%`i#p%`i#q%`i#r%`i#s%`i#u%`i#w%`i#y%`i#z%`i'u%`i([%`i(m%`i!h%`i!V%`i's%`is%`i![%`i%f%`i!d%`i~P%1PO!Y'Ua!h'Ua~P!9mO!Y.lO!h(fi~O#}#`i!Y#`i!Z#`i~P#D_OP$]OR#zO}#yO!P#{O!i#xO!m$]O([VO[#jio#ji#O#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji#}#ji(m#ji(t#ji(u#ji!Y#ji!Z#ji~O#k#ji~P%HpO#k:tO~P%HpOP$]OR#zO}#yO!P#{O!i#xO!m$]O#k:tO#l:uO#m:uO#n:uO([VO[#ji#O#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji#}#ji(m#ji(t#ji(u#ji!Y#ji!Z#ji~Oo#ji~P%JxOo:vO~P%JxOP$]OR#zOo:vO}#yO!P#{O!i#xO!m$]O#k:tO#l:uO#m:uO#n:uO#o:wO([VO#u#ji#w#ji#y#ji#z#ji#}#ji(m#ji(t#ji(u#ji!Y#ji!Z#ji~O[#ji#O#ji#p#ji#q#ji#r#ji#s#ji~P%MQO[;SO#O:xO#p:xO#q:xO#r;RO#s:xO~P%MQOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO([VO(u#}O#y#ji#z#ji#}#ji(m#ji(t#ji!Y#ji!Z#ji~O#w:{O~P& iO#w#ji~P& iOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO([VO#y#ji#z#ji#}#ji(m#ji!Y#ji!Z#ji~O#w#ji(t#ji(u#ji~P&#qO#w:{O(t#|O(u#}O~P&#qOP$]OR#zO[;SOo:vO}#yO!P#{O!i#xO!m$]O#O:xO#k:tO#l:uO#m:uO#n:uO#o:wO#p:xO#q:xO#r;RO#s:xO#u:yO#w:{O#y:}O([VO(t#|O(u#}O~O#z#ji#}#ji(m#ji!Y#ji!Z#ji~P&&POa#{y!Y#{y'u#{y's#{y!V#{y!h#{ys#{y![#{y%f#{y!d#{y~P!9mOk<qO}){O!P)|O(t%OO(u%QO~OP#jiR#ji[#jio#ji!i#ji!m#ji#O#ji#k#ji#l#ji#m#ji#n#ji#o#ji#p#ji#q#ji#r#ji#s#ji#u#ji#w#ji#y#ji#z#ji#}#ji([#ji(m#ji!Y#ji!Z#ji~P&(tO#P$dOP(ZXR(ZX[(ZXk(ZXo(ZX}(ZX!P(ZX!i(ZX!m(ZX#O(ZX#k(ZX#l(ZX#m(ZX#n(ZX#o(ZX#p(ZX#q(ZX#r(ZX#s(ZX#u(ZX#w(ZX#y(ZX#z(ZX#}(ZX([(ZX(m(ZX(t(ZX(u(ZX!Y(ZX!Z(ZX~O#}$Oi!Y$Oi!Z$Oi~P#D_O#}!oi!Z!oi~P$*TOg'Xa!Y'Xa~P!0pO!Z7UO~O!Y'`a!Z'`a~P#D_OP]XR]X[]Xo]X}]X!P]X!V]X!Y]X!i]X!m]X#O]X#P]X#]]X#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X([]X(m]X(t]X(u]X~O!d%WX#s%WX~P&-}O!d#vO(m'mO!Y'aa!h'aa~O!Y/hO!h(zi~O!Y/hO!d#vO!h(zi~Og$zq!Y$zq#]$zq#}$zq~P!0pO!V'ca!Y'ca~P#.aO!d7]O~O!Y/pO!V({i~P#.aO!Y/pO!V({i~O!V7aO~O!d#vO#s7fO~Oo7gO!d#vO(m'mO~O}){O!P)|O(u%QOk'fa(t'fa!Y'fa#]'fa~Og'fa#}'fa~P&2mO}){O!P)|Ok'ha(t'ha(u'ha!Y'ha#]'ha~Og'ha#}'ha~P&3`O!V7iO~Og$|q!Y$|q#]$|q#}$|q~P!0pOa$my!Y$my'u$my's$my!V$my!h$mys$my![$my%f$my!d$my~P!9mO!d6YO~O!Y4tO![(|a~O![']OP$SaR$Sa[$Sao$Sa}$Sa!P$Sa!Y$Sa!i$Sa!m$Sa#O$Sa#k$Sa#l$Sa#m$Sa#n$Sa#o$Sa#p$Sa#q$Sa#r$Sa#s$Sa#u$Sa#w$Sa#y$Sa#z$Sa([$Sa(m$Sa(t$Sa(u$Sa~O%f6nO~P&5iOa#`y!Y#`y'u#`y's#`y!V#`y!h#`ys#`y![#`y%f#`y!d#`y~P!9mO[7nO~Ob7pO(O+kO(QTO(TUO~O!Y0wO!Z)Ti~O`7tO~O(`(xO!Y'lX!Z'lX~O!Y5]O!Z)Qa~O!Z7}O~P%6ZOp!nO!P8OO(QTO(TUO(`!mO(j!sO~O![1aO~O![1aO%f8QO~Ok8TO![1aO%f8QO~O[8YO!Y'oa!Z'oa~O!Y1lO!Z)Ri~O!h8^O~O!h8_O~O!h8bO~O!h8bO~P%[Oa8dO~O!d8eO~O!h8fO~O!Y(ri!Z(ri~P#D_Oa%lO#]8nO'u%lO~O!Y(oy!h(oya(oy'u(oy~P!9mO!Y(fO!h(ny~O%f8qO~P&5iO![']O%f8qO~O#h$zqP$zqR$zq[$zqa$zqo$zq!Y$zq!i$zq!m$zq#O$zq#k$zq#l$zq#m$zq#n$zq#o$zq#p$zq#q$zq#r$zq#s$zq#u$zq#w$zq#y$zq#z$zq'u$zq([$zq(m$zq!h$zq!V$zq's$zq#]$zqs$zq![$zq%f$zq!d$zq~P#.aO#h'faP'faR'fa['faa'fao'fa!i'fa!m'fa#O'fa#k'fa#l'fa#m'fa#n'fa#o'fa#p'fa#q'fa#r'fa#s'fa#u'fa#w'fa#y'fa#z'fa'u'fa(['fa(m'fa!h'fa!V'fa's'fas'fa!['fa%f'fa!d'fa~P&2mO#h'haP'haR'ha['haa'hao'ha!i'ha!m'ha#O'ha#k'ha#l'ha#m'ha#n'ha#o'ha#p'ha#q'ha#r'ha#s'ha#u'ha#w'ha#y'ha#z'ha'u'ha(['ha(m'ha!h'ha!V'ha's'has'ha!['ha%f'ha!d'ha~P&3`O#h$|qP$|qR$|q[$|qa$|qo$|q!Y$|q!i$|q!m$|q#O$|q#k$|q#l$|q#m$|q#n$|q#o$|q#p$|q#q$|q#r$|q#s$|q#u$|q#w$|q#y$|q#z$|q'u$|q([$|q(m$|q!h$|q!V$|q's$|q#]$|qs$|q![$|q%f$|q!d$|q~P#.aO!Y'Ui!h'Ui~P!9mO#}#`q!Y#`q!Z#`q~P#D_O(t%OOP%^aR%^a[%^ao%^a!i%^a!m%^a#O%^a#k%^a#l%^a#m%^a#n%^a#o%^a#p%^a#q%^a#r%^a#s%^a#u%^a#w%^a#y%^a#z%^a#}%^a([%^a(m%^a!Y%^a!Z%^a~Ok%^a}%^a!P%^a(u%^a~P&FgO(u%QOP%`aR%`a[%`ao%`a!i%`a!m%`a#O%`a#k%`a#l%`a#m%`a#n%`a#o%`a#p%`a#q%`a#r%`a#s%`a#u%`a#w%`a#y%`a#z%`a#}%`a([%`a(m%`a!Y%`a!Z%`a~Ok%`a}%`a!P%`a(t%`a~P&HkOk<qO}){O!P)|O(u%QO~P&FgOk<qO}){O!P)|O(t%OO~P&HkOR0`O}0`O!P0aO#P$dOPza[zakzaoza!iza!mza#Oza#kza#lza#mza#nza#oza#pza#qza#rza#sza#uza#wza#yza#zza#}za([za(mza(tza(uza!Yza!Zza~O}){O!P)|OP$qaR$qa[$qak$qao$qa!i$qa!m$qa#O$qa#k$qa#l$qa#m$qa#n$qa#o$qa#p$qa#q$qa#r$qa#s$qa#u$qa#w$qa#y$qa#z$qa#}$qa([$qa(m$qa(t$qa(u$qa!Y$qa!Z$qa~O}){O!P)|OP$saR$sa[$sak$sao$sa!i$sa!m$sa#O$sa#k$sa#l$sa#m$sa#n$sa#o$sa#p$sa#q$sa#r$sa#s$sa#u$sa#w$sa#y$sa#z$sa#}$sa([$sa(m$sa(t$sa(u$sa!Y$sa!Z$sa~OP%RaR%Ra[%Rao%Ra!i%Ra!m%Ra#O%Ra#k%Ra#l%Ra#m%Ra#n%Ra#o%Ra#p%Ra#q%Ra#r%Ra#s%Ra#u%Ra#w%Ra#y%Ra#z%Ra#}%Ra([%Ra(m%Ra!Y%Ra!Z%Ra~P&(tO#}$lq!Y$lq!Z$lq~P#D_O#}$mq!Y$mq!Z$mq~P#D_O!Z9OO~O#}9PO~P!0pO!d#vO!Y'ai!h'ai~O!d#vO(m'mO!Y'ai!h'ai~O!Y/hO!h(zq~O!V'ci!Y'ci~P#.aO!Y/pO!V({q~O!V9VO~P#.aO!V9VO~Og(Yy!Y(Yy~P!0pO!Y'ja!['ja~P#.aOa%Yq![%Yq'u%Yq!Y%Yq~P#.aO[9[O~O!Y0wO!Z)Tq~O#]9`O!Y'la!Z'la~O!Y5]O!Z)Qi~P#D_O![1aO%f9dO~O(QTO(TUO(`9iO~O!Y1lO!Z)Rq~O!h9lO~O!h9mO~O!h9nO~O!h9nO~P%[O#]9qO!Y#ey!Z#ey~O!Y#ey!Z#ey~P#D_O%f9vO~P&5iO![']O%f9vO~O#}#{y!Y#{y!Z#{y~P#D_OP$ziR$zi[$zio$zi!i$zi!m$zi#O$zi#k$zi#l$zi#m$zi#n$zi#o$zi#p$zi#q$zi#r$zi#s$zi#u$zi#w$zi#y$zi#z$zi#}$zi([$zi(m$zi!Y$zi!Z$zi~P&(tO}){O!P)|O(u%QOP'eaR'ea['eak'eao'ea!i'ea!m'ea#O'ea#k'ea#l'ea#m'ea#n'ea#o'ea#p'ea#q'ea#r'ea#s'ea#u'ea#w'ea#y'ea#z'ea#}'ea(['ea(m'ea(t'ea!Y'ea!Z'ea~O}){O!P)|OP'gaR'ga['gak'gao'ga!i'ga!m'ga#O'ga#k'ga#l'ga#m'ga#n'ga#o'ga#p'ga#q'ga#r'ga#s'ga#u'ga#w'ga#y'ga#z'ga#}'ga(['ga(m'ga(t'ga(u'ga!Y'ga!Z'ga~O(t%OOP%^iR%^i[%^ik%^io%^i}%^i!P%^i!i%^i!m%^i#O%^i#k%^i#l%^i#m%^i#n%^i#o%^i#p%^i#q%^i#r%^i#s%^i#u%^i#w%^i#y%^i#z%^i#}%^i([%^i(m%^i(u%^i!Y%^i!Z%^i~O(u%QOP%`iR%`i[%`ik%`io%`i}%`i!P%`i!i%`i!m%`i#O%`i#k%`i#l%`i#m%`i#n%`i#o%`i#p%`i#q%`i#r%`i#s%`i#u%`i#w%`i#y%`i#z%`i#}%`i([%`i(m%`i(t%`i!Y%`i!Z%`i~O#}$my!Y$my!Z$my~P#D_O#}#`y!Y#`y!Z#`y~P#D_O!d#vO!Y'aq!h'aq~O!Y/hO!h(zy~O!V'cq!Y'cq~P#.aO!V:PO~P#.aO!Y0wO!Z)Ty~O!Y5]O!Z)Qq~O![1aO%f:WO~O!h:ZO~O%f:`O~P&5iOP$zqR$zq[$zqo$zq!i$zq!m$zq#O$zq#k$zq#l$zq#m$zq#n$zq#o$zq#p$zq#q$zq#r$zq#s$zq#u$zq#w$zq#y$zq#z$zq#}$zq([$zq(m$zq!Y$zq!Z$zq~P&(tO}){O!P)|O(u%QOP'faR'fa['fak'fao'fa!i'fa!m'fa#O'fa#k'fa#l'fa#m'fa#n'fa#o'fa#p'fa#q'fa#r'fa#s'fa#u'fa#w'fa#y'fa#z'fa#}'fa(['fa(m'fa(t'fa!Y'fa!Z'fa~O}){O!P)|OP'haR'ha['hak'hao'ha!i'ha!m'ha#O'ha#k'ha#l'ha#m'ha#n'ha#o'ha#p'ha#q'ha#r'ha#s'ha#u'ha#w'ha#y'ha#z'ha#}'ha(['ha(m'ha(t'ha(u'ha!Y'ha!Z'ha~OP$|qR$|q[$|qo$|q!i$|q!m$|q#O$|q#k$|q#l$|q#m$|q#n$|q#o$|q#p$|q#q$|q#r$|q#s$|q#u$|q#w$|q#y$|q#z$|q#}$|q([$|q(m$|q!Y$|q!Z$|q~P&(tOg%b!Z!Y%b!Z#]%b!Z#}%b!Z~P!0pO!Y'lq!Z'lq~P#D_O!Y#e!Z!Z#e!Z~P#D_O#h%b!ZP%b!ZR%b!Z[%b!Za%b!Zo%b!Z!Y%b!Z!i%b!Z!m%b!Z#O%b!Z#k%b!Z#l%b!Z#m%b!Z#n%b!Z#o%b!Z#p%b!Z#q%b!Z#r%b!Z#s%b!Z#u%b!Z#w%b!Z#y%b!Z#z%b!Z'u%b!Z([%b!Z(m%b!Z!h%b!Z!V%b!Z's%b!Z#]%b!Zs%b!Z![%b!Z%f%b!Z!d%b!Z~P#.aOP%b!ZR%b!Z[%b!Zo%b!Z!i%b!Z!m%b!Z#O%b!Z#k%b!Z#l%b!Z#m%b!Z#n%b!Z#o%b!Z#p%b!Z#q%b!Z#r%b!Z#s%b!Z#u%b!Z#w%b!Z#y%b!Z#z%b!Z#}%b!Z([%b!Z(m%b!Z!Y%b!Z!Z%b!Z~P&(tOs(aX~P1qO}%pO~P!(oO(P!lO~P!(oO!VfX!YfX#]fX~P&-}OP]XR]X[]Xo]X}]X!P]X!Y]X!YfX!i]X!m]X#O]X#P]X#]]X#]fX#hfX#k]X#l]X#m]X#n]X#o]X#p]X#q]X#r]X#s]X#u]X#w]X#y]X#z]X$P]X([]X(m]X(t]X(u]X~O!dfX!h]X!hfX(mfX~P'CvOP:kOQ:kOSfOd<fOe!iOmkOo:kOpkOqkOwkOy:kO{:kO!PWO!TkO!UkO![XO!f:nO!iZO!l:kO!m:kO!n:kO!p:oO!r:rO!u!hO$V!kO(O)YO(QTO(TUO([VO(j[O(y<dO~O!Y;PO!Z$oa~Oh%WOm%XOo$uOp$tOq$tOw%YOy%ZO{;ZO!P$|O![$}O!f<kO!i$yO#g;aO$V%_O$r;]O$t;_O$w%`O(O(rO(QTO(TUO([$vO(t%OO(u%QO~O#t)`O~P'HlOo!bX(m!bX~P# ZO!Z]X!ZfX~P'CvO!VfX!V$xX!YfX!Y$xX#]fX~P!/gO#h:sO~O!d#vO#h:sO~O#];TO~O#s:xO~O#];dO!Y(rX!Z(rX~O#];TO!Y(pX!Z(pX~O#h;eO~Og;gO~P!0pO#h;mO~O#h;nO~O!d#vO#h;oO~O!d#vO#h;eO~O#};pO~P#D_O#h;qO~O#h;rO~O#h;wO~O#h;xO~O#h;yO~O#h;zO~O#};{O~P!0pO#};|O~P!0pO#P#Q#R#T#U#X#f#g#r(y$r$t$w%Z%e%f%g%n%p%s%t%v%x~'yT#l!U'w(P#mp#k#no}'x$['x(O$^(`~",
  goto: "$2y)XPPPPPP)YPP)]P)nP+O/PPPPP5wPP6_PP<U?kP@OP@OPPP@OPBOP@OP@OP@OPBSPBXPBvPGoPPPGsPPPPGsJuPPPJ{KwPGsPGsPPNVGsPPPGsPGsP!!^GsP!%s!&x!'RP!'u!'y!'u!+VPPPPPPP!+v!&xPP!,W!-QP!/tGsGs!/y!3U!7l!7l!;jPPP!;rGsPPPPPPPPPPP!?QP!@_PPGs!ApPGsPGsGsGsGsGsPGs!CSP!F]P!IbP!If!Ip!It!ItP!FYP!Ix!IxP!L}P!MRGsGs!MX#!]BS@OP@OP@O@OP##i@O@O#%s@O#(c@O#*g@O@O#+V#-c#-c#-h#-q#-c#-zP#-cP@O#.d@O#2T@O@O5wPPP#5zPPP#6e#6eP#6eP#6{#6ePP#7RP#6xP#6x#7f#6x#8Q#8W5t)]#8Z)]P#8b#8b#8bP)]P)]P)]P)]PP)]P#8h#8kP#8k)]P#8oP#8rP)]P)]P)]P)]P)]P)])]PP#8x#9O#9Z#9a#9g#9m#9s#:R#:X#:c#:i#:s#:y#;Z#;a#<R#<e#<k#<q#=P#=f#?T#?c#?j#AO#A^#Bx#CW#C^#Cd#Cj#Ct#Cz#DQ#D[#Dn#DtPPPPPPPPPP#DzPPPPPPP#Eo#Hv#JV#J^#JfPPP$ lP$ u$$m$+V$+Y$+]$+x$+{$,S$,[P$,b$,eP$-R$-V$-}$/]$/b$/xPP$/}$0T$0XP$0[$0`$0d$1Y$1q$2Y$2^$2a$2d$2j$2m$2q$2uR!|RoqOXst!Z#d%k&o&q&r&t,k,p1|2PY!vQ']-]1a5dQ%rvQ%zyQ&R|Q&g!VS'T!e-TQ'c!iS'i!r!yU*f$}*W*kQ+i%{Q+v&TQ,[&aQ-Z'[Q-e'dQ-m'jQ0R*mQ1k,]R;b:o%QdOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V,h,k,p-a-i-w-}.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3^5a5k5{5|6P6d8O8T8d8nS#q]:l!r)[$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gU*y%[;Y;ZQ+n%}Q,^&dQ,e&lQ0m+aQ0q+cQ0|+oQ1s,cQ3Q._Q4}0wQ5r1lQ6p3UQ7p5OR8t6r'OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gt!nQ!r!v!y!z'T'[']'i'j'k-T-Z-]-m1a5d5f$z$ti#v$b$c$d$y$|%P%R%]%^%b)v)|*O*Q*S*V*]*c*s*t+`+c+z+}.^.w/]/e/o/p/r0V0X0d1W1Z1c3T3}4Y4b4l4t4w5j6n7]7f8Q8q9P9d9v:W:`;R;S;U;V;W;X;[;];^;_;`;a;h;i;j;k;m;n;q;r;s;t;u;v;w;x;{;|<d<l<m<p<qQ&U|Q'R!eU'X%g*W-WQ+n%}Q,^&dQ0c*|Q0|+oQ1R+uQ1r,bQ1s,cQ4}0wQ5W1TQ5r1lQ5u1nQ5v1qQ7p5OQ7s5TQ8]5xQ9_7tR9j8YrnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PR,`&h&x^OPXYstuvwz!Z!`!g!j!o#S#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<f<g[#]WZ#W#Z'U(P!b%hm#h#i#l$y%c%f(Y(d(e(f*V*Z*^+T+U+W,g,}-{.R.S.T.V/e/h2U2|2}4Q6Y6kQ%uxQ%yyS&O|&TQ&[!TQ'`!hQ'b!iQ(m#sS+h%z%{Q+l%}Q,V&_Q,Z&aS-d'c'dQ.a(nQ0u+iQ0{+oQ0}+pQ1Q+tQ1f,WS1j,[,]Q2n-eQ4|0wQ5Q0zQ5V1SQ5q1kQ7o5OQ7r5SQ9Z7nR:R9[!O${i$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<m!S%wy!i!u%y%z%{'S'b'c'd'h'r*e+h+i-Q-d-e-l/y0u2g2n2u4dQ+b%uQ+{&XQ,O&YQ,Y&aQ.`(mQ1e,VU1i,Z,[,]Q3V.aQ5l1fS5p1j1kQ8X5q#[<h#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qo<i;R;S;V;X;];_;a;i;k;n;r;t;v;x;|W%Ui%W*u<dS&X!Q&fQ&Y!RQ&Z!SR+y&V${%Ti#v$b$c$d$y$|%P%R%]%^%b)v)|*O*Q*S*V*]*c*s*t+`+c+z+}.^.w/]/e/o/p/r0V0X0d1W1Z1c3T3}4Y4b4l4t4w5j6n7]7f8Q8q9P9d9v:W:`;R;S;U;V;W;X;[;];^;_;`;a;h;i;j;k;m;n;q;r;s;t;u;v;w;x;{;|<d<l<m<p<qT)w$v)xV*y%[;Y;ZW'X!e%g*W-WS(y#y#zQ+]%pQ+s&QS.Y(i(jQ1[,PQ4m0`R7x5]'OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<g$i$_c#Y#e%o%q%s(O(U(p(u(})O)P)Q)R)S)T)U)V)W)X)Z)])c)m+^+r-R-p-u-z-|.k.n.r.t.u.v/X0e2]2`2p2w3]3b3c3d3e3f3g3h3i3j3k3l3m3n3q3r3y4q4z6]6c6h6w6x7R7S7z8h8l8v8|8}9s:T:[:m<ZT#TV#U'PkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gQ'V!eR2c-Tv!nQ!e!r!v!y!z'T'[']'i'j'k-T-Z-]-m1a5d5fU*e$}*W*kS/y*f*mQ0S*nQ1^,RQ4d0RR4g0UnqOXst!Z#d%k&o&q&r&t,k,p1|2PQ&v!^Q's!xS(o#u:sQ+f%xQ,T&[Q,U&^Q-b'aQ-o'lS.j(t;eS0f+R;oQ0s+gQ1`,SQ2T,rQ2V,sQ2_-OQ2l-cQ2o-gS4r0g;yQ4x0tS4{0v;zQ6[2aQ6`2mQ6e2tQ7m4yQ8i6^Q8j6aQ8m6fR9p8f$d$^c#Y#e%q%s(O(U(p(u(})O)P)Q)R)S)T)U)V)W)X)Z)])c)m+^+r-R-p-u-z-|.k.n.r.u.v/X0e2]2`2p2w3]3b3c3d3e3f3g3h3i3j3k3l3m3n3q3r3y4q4z6]6c6h6w6x7R7S7z8h8l8v8|8}9s:T:[:m<ZS(k#p'fQ({#zS+[%o.tS.Z(j(lR3O.['OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gS#q]:lQ&q!XQ&r!YQ&t![Q&u!]R1{,nQ'^!hQ+_%uQ-`'`S.](m+bQ2j-_W3S.`.a0l0nQ6_2kW6l3P3R3V4vU8p6m6o6qU9u8r8s8uS:^9t9wQ:f:_R:i:gU!wQ']-]T5b1a5d!Q_OXZ`st!V!Z#d#h%c%k&f&h&o&q&r&t(f,k,p.S1|2P]!pQ!r']-]1a5dT#q]:l%[{OPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nS(y#y#zS.Y(i(j!s<Q$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gU$fd)[,eS(l#p'fU*r%S(s3pU0b*x.f6}Q4v0mQ6m3QQ8s6pR9w8tm!tQ!r!v!y!z']'i'j'k-]-m1a5d5fQ'q!uS(b#g1vS-k'h'tQ/k*YQ/w*eQ2v-nQ4U/lS4_/x0SQ7X4PS7d4e4gQ9R7YR9Y7gQ#wbQ'p!uS(a#g1vS(c#m+QQ+S%dQ+d%vQ+j%|U-j'h'q'tQ.O(bQ/j*YQ/v*eQ/|*hQ0r+eQ1g,XS2s-k-nQ2{.WS4T/k/lS4^/w0SQ4a/{Q4c/}Q5n1hQ6g2vQ7W4PQ7[4US7`4_4gQ7e4fQ8V5oS9Q7X7YQ9U7aQ9W7dQ9g8WQ9}9RQ:O9VQ:Q9YQ:Y9hQ:b:PQ<T<OQ<`<XR<a<YV!wQ']-]%[aOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nS#wz!j!r;}$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gR<T<f%[bOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nQ%dj!S%vy!i!u%y%z%{'S'b'c'd'h'r*e+h+i-Q-d-e-l/y0u2g2n2u4dS%|z!jQ+e%wQ,X&aW1h,Y,Z,[,]U5o1i1j1kS8W5p5qQ9h8X!r<O$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gQ<X<eR<Y<f%OeOPXYstuvw!Z!`!g!o#S#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&o&q&r&t&x'Q'_'o(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8nY#bWZ#W#Z(P!b%hm#h#i#l$y%c%f(Y(d(e(f*V*Z*^+T+U+W,g,}-{.R.S.T.V/e/h2U2|2}4Q6Y6kQ,f&l!p<P$[$n)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gR<S'UU'Y!e%g*WR2e-W%QdOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V,h,k,p-a-i-w-}.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3^5a5k5{5|6P6d8O8T8d8n!r)[$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gQ,e&lQ0m+aQ3Q._Q6p3UR8t6r!b$Uc#Y%o(O(U(p(u)W)X)])c+r-p-u-z-|.k.n/X0e2p2w3]3n4q4z6c6h6w8l9s:m!P:z)Z)m-R.t2]2`3b3l3m3q3y6]6x7R7S7z8h8v8|8}:T:[<Z!f$Wc#Y%o(O(U(p(u)T)U)W)X)])c+r-p-u-z-|.k.n/X0e2p2w3]3n4q4z6c6h6w8l9s:m!T:|)Z)m-R.t2]2`3b3i3j3l3m3q3y6]6x7R7S7z8h8v8|8}:T:[<Z!^$[c#Y%o(O(U(p(u)])c+r-p-u-z-|.k.n/X0e2p2w3]3n4q4z6c6h6w8l9s:mQ3}/cz<g)Z)m-R.t2]2`3b3q3y6]6x7R7S7z8h8v8|8}:T:[<ZQ<l<nR<m<o'OkOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gS$oh$pR3v.|'VgOPWXYZhstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n$p%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.|.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gT$kf$qQ$ifS)f$l)jR)r$qT$jf$qT)h$l)j'VhOPWXYZhstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$[$`$e$n$p%k%r&P&h&k&l&o&q&r&t&x'Q'U'_'o(P(R(X(`(t(v(z)o)z+R+V+a,h,k,p,|-P-a-i-w-}._.l.s.|.}/f0a0g0v1d1t1u1w1y1|2P2R2b2r2x3U3^3u5_5a5k5{5|6P6Z6d6r8O8T8d8n9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<gT$oh$pQ$rhR)q$p%[jOPWXYZstuvw!Z!`!g!o#S#W#Z#d#o#u#x#{$O$P$Q$R$S$T$U$V$W$X$Y$`$e%k%r&P&h&k&l&o&q&r&t&x'Q'_'o(P(R(X(`(t(v(z)z+R+V+a,h,k,p-a-i-w-}._.l.s/f0a0g0v1d1t1u1w1y1|2P2R2r2x3U3^5a5k5{5|6P6d6r8O8T8d8n!s<e$[$n'U)o,|-P.}2b3u5_6Z9`9q:k:n:o:r:s:t:u:v:w:x:y:z:{:|:};O;P;T;b;d;e;g;o;p;y;z<g#elOPXZst!Z!`!o#S#d#o#{$n%k&h&k&l&o&q&r&t&x'Q'_(z)o+V+a,h,k,p-a._.}/f0a1d1t1u1w1y1|2P2R3U3u5a5k5{5|6P6r8O8T8d!O%Si$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<m#[(s#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qQ*}%`Q/Y){o3p;R;S;V;X;];_;a;i;k;n;r;t;v;x;|!O$zi$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<mQ*_${U*h$}*W*kQ+O%aQ/}*i#[<V#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qn<W;R;S;V;X;];_;a;i;k;n;r;t;v;x;|Q<[<hQ<]<iQ<^<jR<_<k!O%Si$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<m#[(s#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qo3p;R;S;V;X;];_;a;i;k;n;r;t;v;x;|noOXst!Z#d%k&o&q&r&t,k,p1|2PS*b$|*VQ,y&{Q,z&}R4X/p$z%Ti#v$b$c$d$y$|%P%R%]%^%b)v)|*O*Q*S*V*]*c*s*t+`+c+z+}.^.w/]/e/o/p/r0V0X0d1W1Z1c3T3}4Y4b4l4t4w5j6n7]7f8Q8q9P9d9v:W:`;R;S;U;V;W;X;[;];^;_;`;a;h;i;j;k;m;n;q;r;s;t;u;v;w;x;{;|<d<l<m<p<qQ+|&YQ1Y,OQ5Z1XR7w5[V*j$}*W*kU*j$}*W*kT5c1a5dU/{*g/f5aT4f0T8OQ+d%vQ/|*hQ0r+eQ1g,XQ5n1hQ8V5oQ9g8WR:Y9h!O%Pi$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<mr*O$w)a*P*q+P/n0Z0[3s4V4p7V7h9|<U<b<cS0V*p0W#[;U#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qn;V;R;S;V;X;];_;a;i;k;n;r;t;v;x;|!^;h(q)_*X*a.b.e.i/U/Z/c/s0k1V1X3Y4W4[5Y5[6s6v7^7b7j7l9T9X:a<n<o`;i3o6y6|7Q8w9x9{:jS;s.d3ZT;t6{8z!O%Ri$d%P%R%]%^%b*O*Q*]*s*t.w/o0V0X0d3}4l9P<d<l<mv*Q$w)a*R*p+P/_/n0Z0[3s4V4h4p7V7h9|<U<b<cS0X*q0Y#[;W#v$b$c$y$|)v)|*S*V*c+`+c+z+}.^/]/e/p/r1W1Z1c3T4Y4b4t4w5j6n7]7f8Q8q9d9v:W:`;U;W;[;^;`;h;j;m;q;s;u;w;{<p<qn;X;R;S;V;X;];_;a;i;k;n;r;t;v;x;|!b;j(q)_*X*a.c.d.i/U/Z/c/s0k1V1X3W3Y4W4[5Y5[6s6t6v7^7b7j7l9T9X:a<n<od;k3o6z6{7Q8w8x9x9y9{:jS;u.e3[T;v6|8{rnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PQ&c!UR,h&lrnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PR&c!UQ,Q&ZR1U+ysnOXst!V!Z#d%k&f&o&q&r&t,k,p1|2PQ1b,VS5i1e1fU8P5g5h5lS9c8R8SS:U9b9eQ:c:VR:h:dQ&j!VR,a&fR5u1nS&O|&TR0}+pQ&o!WR,k&pR,q&uT1},p2PR,u&vQ,t&vR2W,uQ'v!{R-q'vSsOtQ#dXT%ns#dQ#OTR'x#OQ#RUR'z#RQ)x$vR/V)xQ#UVR'|#UQ#XWU(S#X(T-xQ(T#YR-x(UQ-U'VR2d-UQ.m(uS3_.m3`R3`.nQ-]']R2h-]Y!rQ']-]1a5dR'g!rQ.x)aR3t.xU#_W%f*VU(Z#_([-yQ([#`R-y(VQ-X'YR2f-Xt`OXst!V!Z#d%k&f&h&o&q&r&t,k,p1|2PS#hZ%cU#r`#h.SR.S(fQ(g#jQ.P(cW.X(g.P2y6iQ2y.QR6i2zQ)j$lR/O)jQ$phR)p$pQ$acU)^$a-t;QQ-t:mR;Q)mQ/i*YW4R/i4S7Z9SU4S/j/k/lS7Z4T4UR9S7[$X)}$w(q)_)a*X*a*p*q*z*{+P.d.e.g.h.i/U/Z/_/a/c/n/s0Z0[0k1V1X3W3X3Y3o3s4V4W4[4h4j4p5Y5[6s6t6u6v6{6|7O7P7Q7V7^7b7h7j7l8w8x8y9T9X9x9y9z9{9|:a:j<U<b<c<n<oQ/q*aU4Z/q4]7_Q4]/sR7_4[S*k$}*WR0P*kr*P$w)a*p*q+P/n0Z0[3s4V4p7V7h9|<U<b<c!^.b(q)_*X*a.d.e.i/U/Z/c/s0k1V1X3Y4W4[5Y5[6s6v7^7b7j7l9T9X:a<n<oU/`*P.b6ya6y3o6{6|7Q8w9x9{:jQ0W*pQ3Z.dU4i0W3Z8zR8z6{v*R$w)a*p*q+P/_/n0Z0[3s4V4h4p7V7h9|<U<b<c!b.c(q)_*X*a.d.e.i/U/Z/c/s0k1V1X3W3Y4W4[5Y5[6s6t6v7^7b7j7l9T9X:a<n<oU/b*R.c6ze6z3o6{6|7Q8w8x9x9y9{:jQ0Y*qQ3[.eU4k0Y3[8{R8{6|Q*v%VR0^*vQ4u0kR7k4uQ+X%iR0j+XQ5^1[S7y5^9aR9a7zQ,S&[R1_,SQ5d1aR7|5dQ1m,^S5s1m8ZR8Z5uQ0x+lW5P0x5R7q9]Q5R0{Q7q5QR9]7rQ+q&OR1O+qQ2P,pR6T2PYrOXst#dQ&s!ZQ+Z%kQ,j&oQ,l&qQ,m&rQ,o&tQ1z,kS1},p2PR6S1|Q%mpQ&w!_Q&z!aQ&|!bQ'O!cQ'n!uQ+Y%jQ+f%xQ+x&UQ,`&jQ,w&yW-h'h'p'q'tQ-o'lQ0O*jQ0s+gS1p,a,dQ2X,vQ2Y,yQ2Z,zQ2o-gW2q-j-k-n-pQ4x0tQ5U1RQ5X1VQ5m1gQ5w1rQ6R1{U6b2p2s2vQ6e2tQ7m4yQ7u5WQ7v5YQ7{5cQ8U5nQ8[5vS8k6c6gQ8m6fQ9^7sQ9f8VQ9k8]Q9r8lQ:S9_Q:X9gQ:]9sR:e:YQ%xyQ'a!iQ'l!uU+g%y%z%{Q-O'SU-c'b'c'dS-g'h'rQ/u*eS0t+h+iQ2a-QS2m-d-eQ2t-lQ4`/yQ4y0uQ6^2gQ6a2nQ6f2uR7c4dS$xi<dR*w%WU%Vi%W<dR0]*uQ$wiS(q#v+cS)_$b$cQ)a$dQ*X$yS*a$|*VQ*p%PQ*q%RQ*z%]Q*{%^Q+P%bQ.d;UQ.e;WQ.g;[Q.h;^Q.i;`Q/U)vS/Z)|/]Q/_*OQ/a*QQ/c*SQ/n*]S/s*c/eQ0Z*sQ0[*th0k+`.^1c3T5j6n8Q8q9d9v:W:`Q1V+zQ1X+}Q3W;hQ3X;jQ3Y;mS3o;R;SQ3s.wQ4V/oQ4W/pQ4[/rQ4h0VQ4j0XQ4p0dQ5Y1WQ5[1ZQ6s;qQ6t;sQ6u;uQ6v;wQ6{;VQ6|;XQ7O;]Q7P;_Q7Q;aQ7V3}Q7^4YQ7b4bQ7h4lQ7j4tQ7l4wQ8w;nQ8x;iQ8y;kQ9T7]Q9X7fQ9x;rQ9y;tQ9z;vQ9{;xQ9|9PQ:a;{Q:j;|Q<U<dQ<b<lQ<c<mQ<n<pR<o<qQ*x%[Q.f;YR6};ZnpOXst!Z#d%k&o&q&r&t,k,p1|2PQ!fPS#fZ#oQ&y!`U'e!o5a8OQ'{#SQ(|#{Q)n$nS,d&h&kQ,i&lQ,v&xQ,{'QQ-_'_Q.p(zQ/S)oS0h+V/fQ0n+aQ1x,hQ2k-aQ3R._Q3x.}Q4n0aQ5h1dQ5y1tQ5z1uQ6O1wQ6Q1yQ6V2RQ6q3UQ7T3uQ8S5kQ8`5{Q8a5|Q8c6PQ8u6rQ9e8TR9o8d#YcOPXZst!Z!`!o#d#o#{%k&h&k&l&o&q&r&t&x'Q'_(z+V+a,h,k,p-a._/f0a1d1t1u1w1y1|2P2R3U5a5k5{5|6P6r8O8T8dQ#YWQ#eYQ%ouQ%qvS%sw!gS(O#W(RQ(U#ZQ(p#uQ(u#xQ(}$OQ)O$PQ)P$QQ)Q$RQ)R$SQ)S$TQ)T$UQ)U$VQ)V$WQ)W$XQ)X$YQ)Z$[Q)]$`Q)c$eW)m$n)o.}3uQ+^%rQ+r&PS-R'U2bQ-p'oS-u(P-wQ-z(XQ-|(`Q.k(tQ.n(vQ.r:kQ.t:nQ.u:oQ.v:rQ/X)zQ0e+RQ2],|Q2`-PQ2p-iQ2w-}Q3].lQ3b:sQ3c:tQ3d:uQ3e:vQ3f:wQ3g:xQ3h:yQ3i:zQ3j:{Q3k:|Q3l:}Q3m;OQ3n.sQ3q;TQ3r;bQ3y;PQ4q0gQ4z0vQ6];dQ6c2rQ6h2xQ6w3^Q6x;eQ7R;gQ7S;oQ7z5_Q8h6ZQ8l6dQ8v;pQ8|;yQ8};zQ9s8nQ:T9`Q:[9qQ:m#SR<Z<gR#[WR'W!el!tQ!r!v!y!z']'i'j'k-]-m1a5d5fS'S!e-TS-Q'T'[R2g-ZR(w#xQ!fQT-[']-]]!qQ!r']-]1a5dQ#p]R'f:lR)b$dY!uQ']-]1a5dQ'h!rS'r!v!yS't!z5fS-l'i'jQ-n'kR2u-mT#kZ%cS#jZ%cS%im,gU(c#h#i#lS.Q(d(eQ.U(fQ0i+WQ2z.RU2{.S.T.VS6j2|2}R8o6kd#^W#W#Z%f(P(Y*V+T-{/er#gZm#h#i#l%c(d(e(f+W.R.S.T.V2|2}6kS*Y$y*^Q/l*ZQ1v,gQ2^,}Q4P/hQ6X2UQ7Y4QQ8g6YT<R'U+UV#aW%f*VU#`W%f*VS(Q#W(YU(V#Z+T/eS-S'U+UT-v(P-{V'Z!e%g*WQ$lfR)t$qT)i$l)jR3w.|T*[$y*^T*d$|*VQ0l+`Q3P.^Q5g1cQ6o3TQ8R5jQ8r6nQ9b8QQ9t8qQ:V9dQ:_9vQ:d:WR:g:`nqOXst!Z#d%k&o&q&r&t,k,p1|2PQ&i!VR,`&ftmOXst!U!V!Z#d%k&f&o&q&r&t,k,p1|2PR,g&lT%jm,gR1],PR,_&dQ&S|R+w&TR+m%}T&m!W&pT&n!W&pT2O,p2P",
  nodeNames: "⚠ ArithOp ArithOp ?. JSXStartTag LineComment BlockComment Script Hashbang ExportDeclaration export Star as VariableName String Escape from ; default FunctionDeclaration async function VariableDefinition > < TypeParamList TypeDefinition extends ThisType this LiteralType ArithOp Number BooleanLiteral TemplateType InterpolationEnd Interpolation InterpolationStart NullType null VoidType void TypeofType typeof MemberExpression . PropertyName [ TemplateString Escape Interpolation super RegExp ] ArrayExpression Spread , } { ObjectExpression Property async get set PropertyDefinition Block : NewTarget new NewExpression ) ( ArgList UnaryExpression delete LogicOp BitOp YieldExpression yield AwaitExpression await ParenthesizedExpression ClassExpression class ClassBody MethodDeclaration Decorator @ MemberExpression PrivatePropertyName CallExpression TypeArgList CompareOp < declare Privacy static abstract override PrivatePropertyDefinition PropertyDeclaration readonly accessor Optional TypeAnnotation Equals StaticBlock FunctionExpression ArrowFunction ParamList ParamList ArrayPattern ObjectPattern PatternProperty Privacy readonly Arrow MemberExpression BinaryExpression ArithOp ArithOp ArithOp ArithOp BitOp CompareOp instanceof satisfies in const CompareOp BitOp BitOp BitOp LogicOp LogicOp ConditionalExpression LogicOp LogicOp AssignmentExpression UpdateOp PostfixExpression CallExpression InstantiationExpression TaggedTemplateExpression DynamicImport import ImportMeta JSXElement JSXSelfCloseEndTag JSXSelfClosingTag JSXIdentifier JSXBuiltin JSXIdentifier JSXNamespacedName JSXMemberExpression JSXSpreadAttribute JSXAttribute JSXAttributeValue JSXEscape JSXEndTag JSXOpenTag JSXFragmentTag JSXText JSXEscape JSXStartCloseTag JSXCloseTag PrefixCast ArrowFunction TypeParamList SequenceExpression InstantiationExpression KeyofType keyof UniqueType unique ImportType InferredType infer TypeName ParenthesizedType FunctionSignature ParamList NewSignature IndexedType TupleType Label ArrayType ReadonlyType ObjectType MethodType PropertyType IndexSignature PropertyDefinition CallSignature TypePredicate is NewSignature new UnionType LogicOp IntersectionType LogicOp ConditionalType ParameterizedType ClassDeclaration abstract implements type VariableDeclaration let var using TypeAliasDeclaration InterfaceDeclaration interface EnumDeclaration enum EnumBody NamespaceDeclaration namespace module AmbientDeclaration declare GlobalDeclaration global ClassDeclaration ClassBody AmbientFunctionDeclaration ExportGroup VariableName VariableName ImportDeclaration ImportGroup ForStatement for ForSpec ForInSpec ForOfSpec of WhileStatement while WithStatement with DoStatement do IfStatement if else SwitchStatement switch SwitchBody CaseLabel case DefaultLabel TryStatement try CatchClause catch FinallyClause finally ReturnStatement return ThrowStatement throw BreakStatement break ContinueStatement continue DebuggerStatement debugger LabeledStatement ExpressionStatement SingleExpression SingleClassItem",
  maxTerm: 376,
  context: L5,
  nodeProps: [
    ["isolate", -8, 5, 6, 14, 34, 36, 48, 50, 52, ""],
    ["group", -26, 9, 17, 19, 65, 204, 208, 212, 213, 215, 218, 221, 231, 233, 239, 241, 243, 245, 248, 254, 260, 262, 264, 266, 268, 270, 271, "Statement", -34, 13, 14, 29, 32, 33, 39, 48, 51, 52, 54, 59, 67, 69, 73, 77, 79, 81, 82, 107, 108, 117, 118, 135, 138, 140, 141, 142, 143, 144, 146, 147, 166, 167, 169, "Expression", -23, 28, 30, 34, 38, 40, 42, 171, 173, 175, 176, 178, 179, 180, 182, 183, 184, 186, 187, 188, 198, 200, 202, 203, "Type", -3, 85, 100, 106, "ClassItem"],
    ["openedBy", 23, "<", 35, "InterpolationStart", 53, "[", 57, "{", 70, "(", 159, "JSXStartCloseTag"],
    ["closedBy", 24, ">", 37, "InterpolationEnd", 47, "]", 58, "}", 71, ")", 164, "JSXEndTag"]
  ],
  propSources: [B5],
  skippedNodes: [0, 5, 6, 274],
  repeatNodeCount: 37,
  tokenData: "$Fq07[R!bOX%ZXY+gYZ-yZ[+g[]%Z]^.c^p%Zpq+gqr/mrs3cst:_tuEruvJSvwLkwx! Yxy!'iyz!(sz{!)}{|!,q|}!.O}!O!,q!O!P!/Y!P!Q!9j!Q!R#:O!R![#<_![!]#I_!]!^#Jk!^!_#Ku!_!`$![!`!a$$v!a!b$*T!b!c$,r!c!}Er!}#O$-|#O#P$/W#P#Q$4o#Q#R$5y#R#SEr#S#T$7W#T#o$8b#o#p$<r#p#q$=h#q#r$>x#r#s$@U#s$f%Z$f$g+g$g#BYEr#BY#BZ$A`#BZ$ISEr$IS$I_$A`$I_$I|Er$I|$I}$Dk$I}$JO$Dk$JO$JTEr$JT$JU$A`$JU$KVEr$KV$KW$A`$KW&FUEr&FU&FV$A`&FV;'SEr;'S;=`I|<%l?HTEr?HT?HU$A`?HUOEr(n%d_$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z&j&hT$h&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c&j&zP;=`<%l&c'|'U]$h&j(U!bOY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}!b(SU(U!bOY'}Zw'}x#O'}#P;'S'};'S;=`(f<%lO'}!b(iP;=`<%l'}'|(oP;=`<%l&}'[(y]$h&j(RpOY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(rp)wU(RpOY)rZr)rs#O)r#P;'S)r;'S;=`*Z<%lO)rp*^P;=`<%l)r'[*dP;=`<%l(r#S*nX(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g#S+^P;=`<%l*g(n+dP;=`<%l%Z07[+rq$h&j(Rp(U!b'w0/lOX%ZXY+gYZ&cZ[+g[p%Zpq+gqr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p$f%Z$f$g+g$g#BY%Z#BY#BZ+g#BZ$IS%Z$IS$I_+g$I_$JT%Z$JT$JU+g$JU$KV%Z$KV$KW+g$KW&FU%Z&FU&FV+g&FV;'S%Z;'S;=`+a<%l?HT%Z?HT?HU+g?HUO%Z07[.ST(S#S$h&j'x0/lO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c07[.n_$h&j(Rp(U!b'x0/lOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z)3p/x`$h&j!m),Q(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`0z!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW1V`#u(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`2X!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW2d_#u(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'At3l_(Q':f$h&j(U!bOY4kYZ5qZr4krs7nsw4kwx5qx!^4k!^!_8p!_#O4k#O#P5q#P#o4k#o#p8p#p;'S4k;'S;=`:X<%lO4k(^4r_$h&j(U!bOY4kYZ5qZr4krs7nsw4kwx5qx!^4k!^!_8p!_#O4k#O#P5q#P#o4k#o#p8p#p;'S4k;'S;=`:X<%lO4k&z5vX$h&jOr5qrs6cs!^5q!^!_6y!_#o5q#o#p6y#p;'S5q;'S;=`7h<%lO5q&z6jT$c`$h&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c`6|TOr6yrs7]s;'S6y;'S;=`7b<%lO6y`7bO$c``7eP;=`<%l6y&z7kP;=`<%l5q(^7w]$c`$h&j(U!bOY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}!r8uZ(U!bOY8pYZ6yZr8prs9hsw8pwx6yx#O8p#O#P6y#P;'S8p;'S;=`:R<%lO8p!r9oU$c`(U!bOY'}Zw'}x#O'}#P;'S'};'S;=`(f<%lO'}!r:UP;=`<%l8p(^:[P;=`<%l4k%9[:hh$h&j(Rp(U!bOY%ZYZ&cZq%Zqr<Srs&}st%ZtuCruw%Zwx(rx!^%Z!^!_*g!_!c%Z!c!}Cr!}#O%Z#O#P&c#P#R%Z#R#SCr#S#T%Z#T#oCr#o#p*g#p$g%Z$g;'SCr;'S;=`El<%lOCr(r<__WS$h&j(Rp(U!bOY<SYZ&cZr<Srs=^sw<Swx@nx!^<S!^!_Bm!_#O<S#O#P>`#P#o<S#o#pBm#p;'S<S;'S;=`Cl<%lO<S(Q=g]WS$h&j(U!bOY=^YZ&cZw=^wx>`x!^=^!^!_?q!_#O=^#O#P>`#P#o=^#o#p?q#p;'S=^;'S;=`@h<%lO=^&n>gXWS$h&jOY>`YZ&cZ!^>`!^!_?S!_#o>`#o#p?S#p;'S>`;'S;=`?k<%lO>`S?XSWSOY?SZ;'S?S;'S;=`?e<%lO?SS?hP;=`<%l?S&n?nP;=`<%l>`!f?xWWS(U!bOY?qZw?qwx?Sx#O?q#O#P?S#P;'S?q;'S;=`@b<%lO?q!f@eP;=`<%l?q(Q@kP;=`<%l=^'`@w]WS$h&j(RpOY@nYZ&cZr@nrs>`s!^@n!^!_Ap!_#O@n#O#P>`#P#o@n#o#pAp#p;'S@n;'S;=`Bg<%lO@ntAwWWS(RpOYApZrAprs?Ss#OAp#O#P?S#P;'SAp;'S;=`Ba<%lOAptBdP;=`<%lAp'`BjP;=`<%l@n#WBvYWS(Rp(U!bOYBmZrBmrs?qswBmwxApx#OBm#O#P?S#P;'SBm;'S;=`Cf<%lOBm#WCiP;=`<%lBm(rCoP;=`<%l<S%9[C}i$h&j(j%1l(Rp(U!bOY%ZYZ&cZr%Zrs&}st%ZtuCruw%Zwx(rx!Q%Z!Q![Cr![!^%Z!^!_*g!_!c%Z!c!}Cr!}#O%Z#O#P&c#P#R%Z#R#SCr#S#T%Z#T#oCr#o#p*g#p$g%Z$g;'SCr;'S;=`El<%lOCr%9[EoP;=`<%lCr07[FRk$h&j(Rp(U!b$[#t(O,2j(`$I[OY%ZYZ&cZr%Zrs&}st%ZtuEruw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Er![!^%Z!^!_*g!_!c%Z!c!}Er!}#O%Z#O#P&c#P#R%Z#R#SEr#S#T%Z#T#oEr#o#p*g#p$g%Z$g;'SEr;'S;=`I|<%lOEr+dHRk$h&j(Rp(U!b$[#tOY%ZYZ&cZr%Zrs&}st%ZtuGvuw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Gv![!^%Z!^!_*g!_!c%Z!c!}Gv!}#O%Z#O#P&c#P#R%Z#R#SGv#S#T%Z#T#oGv#o#p*g#p$g%Z$g;'SGv;'S;=`Iv<%lOGv+dIyP;=`<%lGv07[JPP;=`<%lEr(KWJ_`$h&j(Rp(U!b#m(ChOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KWKl_$h&j$P(Ch(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z,#xLva(u+JY$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sv%ZvwM{wx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KWNW`$h&j#y(Ch(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'At! c_(T';W$h&j(RpOY!!bYZ!#hZr!!brs!#hsw!!bwx!$xx!^!!b!^!_!%z!_#O!!b#O#P!#h#P#o!!b#o#p!%z#p;'S!!b;'S;=`!'c<%lO!!b'l!!i_$h&j(RpOY!!bYZ!#hZr!!brs!#hsw!!bwx!$xx!^!!b!^!_!%z!_#O!!b#O#P!#h#P#o!!b#o#p!%z#p;'S!!b;'S;=`!'c<%lO!!b&z!#mX$h&jOw!#hwx6cx!^!#h!^!_!$Y!_#o!#h#o#p!$Y#p;'S!#h;'S;=`!$r<%lO!#h`!$]TOw!$Ywx7]x;'S!$Y;'S;=`!$l<%lO!$Y`!$oP;=`<%l!$Y&z!$uP;=`<%l!#h'l!%R]$c`$h&j(RpOY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(r!Q!&PZ(RpOY!%zYZ!$YZr!%zrs!$Ysw!%zwx!&rx#O!%z#O#P!$Y#P;'S!%z;'S;=`!']<%lO!%z!Q!&yU$c`(RpOY)rZr)rs#O)r#P;'S)r;'S;=`*Z<%lO)r!Q!'`P;=`<%l!%z'l!'fP;=`<%l!!b/5|!'t_!i/.^$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#&U!)O_!h!Lf$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z-!n!*[b$h&j(Rp(U!b(P%&f#n(ChOY%ZYZ&cZr%Zrs&}sw%Zwx(rxz%Zz{!+d{!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW!+o`$h&j(Rp(U!b#k(ChOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z+;x!,|`$h&j(Rp(U!bo+4YOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z,$U!.Z_!Y+Jf$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[!/ec$h&j(Rp(U!b}.2^OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!0p!P!Q%Z!Q![!3Y![!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#%|!0ya$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!2O!P!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z#%|!2Z_!X!L^$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!3eg$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!3Y![!^%Z!^!_*g!_!g%Z!g!h!4|!h#O%Z#O#P&c#P#R%Z#R#S!3Y#S#X%Z#X#Y!4|#Y#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!5Vg$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx{%Z{|!6n|}%Z}!O!6n!O!Q%Z!Q![!8S![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!8S#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!6wc$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!8S![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!8S#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad!8_c$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![!8S![!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S!8S#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[!9uf$h&j(Rp(U!b#l(ChOY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcxz!;Zz{#-}{!P!;Z!P!Q#/d!Q!^!;Z!^!_#(i!_!`#7S!`!a#8i!a!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z?O!;fb$h&j(Rp(U!b!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z>^!<w`$h&j(U!b!U7`OY!<nYZ&cZw!<nwx!=yx!P!<n!P!Q!Eq!Q!^!<n!^!_!Gr!_!}!<n!}#O!KS#O#P!Dy#P#o!<n#o#p!Gr#p;'S!<n;'S;=`!L]<%lO!<n<z!>Q^$h&j!U7`OY!=yYZ&cZ!P!=y!P!Q!>|!Q!^!=y!^!_!@c!_!}!=y!}#O!CW#O#P!Dy#P#o!=y#o#p!@c#p;'S!=y;'S;=`!Ek<%lO!=y<z!?Td$h&j!U7`O!^&c!_#W&c#W#X!>|#X#Z&c#Z#[!>|#[#]&c#]#^!>|#^#a&c#a#b!>|#b#g&c#g#h!>|#h#i&c#i#j!>|#j#k!>|#k#m&c#m#n!>|#n#o&c#p;'S&c;'S;=`&w<%lO&c7`!@hX!U7`OY!@cZ!P!@c!P!Q!AT!Q!}!@c!}#O!Ar#O#P!Bq#P;'S!@c;'S;=`!CQ<%lO!@c7`!AYW!U7`#W#X!AT#Z#[!AT#]#^!AT#a#b!AT#g#h!AT#i#j!AT#j#k!AT#m#n!AT7`!AuVOY!ArZ#O!Ar#O#P!B[#P#Q!@c#Q;'S!Ar;'S;=`!Bk<%lO!Ar7`!B_SOY!ArZ;'S!Ar;'S;=`!Bk<%lO!Ar7`!BnP;=`<%l!Ar7`!BtSOY!@cZ;'S!@c;'S;=`!CQ<%lO!@c7`!CTP;=`<%l!@c<z!C][$h&jOY!CWYZ&cZ!^!CW!^!_!Ar!_#O!CW#O#P!DR#P#Q!=y#Q#o!CW#o#p!Ar#p;'S!CW;'S;=`!Ds<%lO!CW<z!DWX$h&jOY!CWYZ&cZ!^!CW!^!_!Ar!_#o!CW#o#p!Ar#p;'S!CW;'S;=`!Ds<%lO!CW<z!DvP;=`<%l!CW<z!EOX$h&jOY!=yYZ&cZ!^!=y!^!_!@c!_#o!=y#o#p!@c#p;'S!=y;'S;=`!Ek<%lO!=y<z!EnP;=`<%l!=y>^!Ezl$h&j(U!b!U7`OY&}YZ&cZw&}wx&cx!^&}!^!_'}!_#O&}#O#P&c#P#W&}#W#X!Eq#X#Z&}#Z#[!Eq#[#]&}#]#^!Eq#^#a&}#a#b!Eq#b#g&}#g#h!Eq#h#i&}#i#j!Eq#j#k!Eq#k#m&}#m#n!Eq#n#o&}#o#p'}#p;'S&};'S;=`(l<%lO&}8r!GyZ(U!b!U7`OY!GrZw!Grwx!@cx!P!Gr!P!Q!Hl!Q!}!Gr!}#O!JU#O#P!Bq#P;'S!Gr;'S;=`!J|<%lO!Gr8r!Hse(U!b!U7`OY'}Zw'}x#O'}#P#W'}#W#X!Hl#X#Z'}#Z#[!Hl#[#]'}#]#^!Hl#^#a'}#a#b!Hl#b#g'}#g#h!Hl#h#i'}#i#j!Hl#j#k!Hl#k#m'}#m#n!Hl#n;'S'};'S;=`(f<%lO'}8r!JZX(U!bOY!JUZw!JUwx!Arx#O!JU#O#P!B[#P#Q!Gr#Q;'S!JU;'S;=`!Jv<%lO!JU8r!JyP;=`<%l!JU8r!KPP;=`<%l!Gr>^!KZ^$h&j(U!bOY!KSYZ&cZw!KSwx!CWx!^!KS!^!_!JU!_#O!KS#O#P!DR#P#Q!<n#Q#o!KS#o#p!JU#p;'S!KS;'S;=`!LV<%lO!KS>^!LYP;=`<%l!KS>^!L`P;=`<%l!<n=l!Ll`$h&j(Rp!U7`OY!LcYZ&cZr!Lcrs!=ys!P!Lc!P!Q!Mn!Q!^!Lc!^!_# o!_!}!Lc!}#O#%P#O#P!Dy#P#o!Lc#o#p# o#p;'S!Lc;'S;=`#&Y<%lO!Lc=l!Mwl$h&j(Rp!U7`OY(rYZ&cZr(rrs&cs!^(r!^!_)r!_#O(r#O#P&c#P#W(r#W#X!Mn#X#Z(r#Z#[!Mn#[#](r#]#^!Mn#^#a(r#a#b!Mn#b#g(r#g#h!Mn#h#i(r#i#j!Mn#j#k!Mn#k#m(r#m#n!Mn#n#o(r#o#p)r#p;'S(r;'S;=`*a<%lO(r8Q# vZ(Rp!U7`OY# oZr# ors!@cs!P# o!P!Q#!i!Q!}# o!}#O#$R#O#P!Bq#P;'S# o;'S;=`#$y<%lO# o8Q#!pe(Rp!U7`OY)rZr)rs#O)r#P#W)r#W#X#!i#X#Z)r#Z#[#!i#[#])r#]#^#!i#^#a)r#a#b#!i#b#g)r#g#h#!i#h#i)r#i#j#!i#j#k#!i#k#m)r#m#n#!i#n;'S)r;'S;=`*Z<%lO)r8Q#$WX(RpOY#$RZr#$Rrs!Ars#O#$R#O#P!B[#P#Q# o#Q;'S#$R;'S;=`#$s<%lO#$R8Q#$vP;=`<%l#$R8Q#$|P;=`<%l# o=l#%W^$h&j(RpOY#%PYZ&cZr#%Prs!CWs!^#%P!^!_#$R!_#O#%P#O#P!DR#P#Q!Lc#Q#o#%P#o#p#$R#p;'S#%P;'S;=`#&S<%lO#%P=l#&VP;=`<%l#%P=l#&]P;=`<%l!Lc?O#&kn$h&j(Rp(U!b!U7`OY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#W%Z#W#X#&`#X#Z%Z#Z#[#&`#[#]%Z#]#^#&`#^#a%Z#a#b#&`#b#g%Z#g#h#&`#h#i%Z#i#j#&`#j#k#&`#k#m%Z#m#n#&`#n#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z9d#(r](Rp(U!b!U7`OY#(iZr#(irs!Grsw#(iwx# ox!P#(i!P!Q#)k!Q!}#(i!}#O#+`#O#P!Bq#P;'S#(i;'S;=`#,`<%lO#(i9d#)th(Rp(U!b!U7`OY*gZr*grs'}sw*gwx)rx#O*g#P#W*g#W#X#)k#X#Z*g#Z#[#)k#[#]*g#]#^#)k#^#a*g#a#b#)k#b#g*g#g#h#)k#h#i*g#i#j#)k#j#k#)k#k#m*g#m#n#)k#n;'S*g;'S;=`+Z<%lO*g9d#+gZ(Rp(U!bOY#+`Zr#+`rs!JUsw#+`wx#$Rx#O#+`#O#P!B[#P#Q#(i#Q;'S#+`;'S;=`#,Y<%lO#+`9d#,]P;=`<%l#+`9d#,cP;=`<%l#(i?O#,o`$h&j(Rp(U!bOY#,fYZ&cZr#,frs!KSsw#,fwx#%Px!^#,f!^!_#+`!_#O#,f#O#P!DR#P#Q!;Z#Q#o#,f#o#p#+`#p;'S#,f;'S;=`#-q<%lO#,f?O#-tP;=`<%l#,f?O#-zP;=`<%l!;Z07[#.[b$h&j(Rp(U!b'y0/l!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z07[#/o_$h&j(Rp(U!bT0/lOY#/dYZ&cZr#/drs#0nsw#/dwx#4Ox!^#/d!^!_#5}!_#O#/d#O#P#1p#P#o#/d#o#p#5}#p;'S#/d;'S;=`#6|<%lO#/d06j#0w]$h&j(U!bT0/lOY#0nYZ&cZw#0nwx#1px!^#0n!^!_#3R!_#O#0n#O#P#1p#P#o#0n#o#p#3R#p;'S#0n;'S;=`#3x<%lO#0n05W#1wX$h&jT0/lOY#1pYZ&cZ!^#1p!^!_#2d!_#o#1p#o#p#2d#p;'S#1p;'S;=`#2{<%lO#1p0/l#2iST0/lOY#2dZ;'S#2d;'S;=`#2u<%lO#2d0/l#2xP;=`<%l#2d05W#3OP;=`<%l#1p01O#3YW(U!bT0/lOY#3RZw#3Rwx#2dx#O#3R#O#P#2d#P;'S#3R;'S;=`#3r<%lO#3R01O#3uP;=`<%l#3R06j#3{P;=`<%l#0n05x#4X]$h&j(RpT0/lOY#4OYZ&cZr#4Ors#1ps!^#4O!^!_#5Q!_#O#4O#O#P#1p#P#o#4O#o#p#5Q#p;'S#4O;'S;=`#5w<%lO#4O00^#5XW(RpT0/lOY#5QZr#5Qrs#2ds#O#5Q#O#P#2d#P;'S#5Q;'S;=`#5q<%lO#5Q00^#5tP;=`<%l#5Q05x#5zP;=`<%l#4O01p#6WY(Rp(U!bT0/lOY#5}Zr#5}rs#3Rsw#5}wx#5Qx#O#5}#O#P#2d#P;'S#5};'S;=`#6v<%lO#5}01p#6yP;=`<%l#5}07[#7PP;=`<%l#/d)3h#7ab$h&j$P(Ch(Rp(U!b!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;ZAt#8vb$Y#t$h&j(Rp(U!b!U7`OY!;ZYZ&cZr!;Zrs!<nsw!;Zwx!Lcx!P!;Z!P!Q#&`!Q!^!;Z!^!_#(i!_!}!;Z!}#O#,f#O#P!Dy#P#o!;Z#o#p#(i#p;'S!;Z;'S;=`#-w<%lO!;Z'Ad#:Zp$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!3Y!P!Q%Z!Q![#<_![!^%Z!^!_*g!_!g%Z!g!h!4|!h#O%Z#O#P&c#P#R%Z#R#S#<_#S#U%Z#U#V#?i#V#X%Z#X#Y!4|#Y#b%Z#b#c#>_#c#d#Bq#d#l%Z#l#m#Es#m#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#<jk$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!O%Z!O!P!3Y!P!Q%Z!Q![#<_![!^%Z!^!_*g!_!g%Z!g!h!4|!h#O%Z#O#P&c#P#R%Z#R#S#<_#S#X%Z#X#Y!4|#Y#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#>j_$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#?rd$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!R#AQ!R!S#AQ!S!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#AQ#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#A]f$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!R#AQ!R!S#AQ!S!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#AQ#S#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#Bzc$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!Y#DV!Y!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#DV#S#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#Dbe$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q!Y#DV!Y!^%Z!^!_*g!_#O%Z#O#P&c#P#R%Z#R#S#DV#S#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#E|g$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![#Ge![!^%Z!^!_*g!_!c%Z!c!i#Ge!i#O%Z#O#P&c#P#R%Z#R#S#Ge#S#T%Z#T#Z#Ge#Z#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z'Ad#Gpi$h&j(Rp(U!bp'9tOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!Q%Z!Q![#Ge![!^%Z!^!_*g!_!c%Z!c!i#Ge!i#O%Z#O#P&c#P#R%Z#R#S#Ge#S#T%Z#T#Z#Ge#Z#b%Z#b#c#>_#c#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z*)x#Il_!d$b$h&j#})Lv(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z)[#Jv_al$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z04f#LS^h#)`#O-<U(Rp(U!b(y7`OY*gZr*grs'}sw*gwx)rx!P*g!P!Q#MO!Q!^*g!^!_#Mt!_!`$ f!`#O*g#P;'S*g;'S;=`+Z<%lO*g(n#MXX$j&j(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g(El#M}Z#o(Ch(Rp(U!bOY*gZr*grs'}sw*gwx)rx!_*g!_!`#Np!`#O*g#P;'S*g;'S;=`+Z<%lO*g(El#NyX$P(Ch(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g(El$ oX#p(Ch(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g*)x$!ga#]*!Y$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`0z!`!a$#l!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(K[$#w_#h(Cl$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z*)x$%Vag!*r#p(Ch$e#|$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`$&[!`!a$'f!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$&g_#p(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$'qa#o(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`!a$(v!a#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$)R`#o(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(Kd$*`a(m(Ct$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!a%Z!a!b$+e!b#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$+p`$h&j#z(Ch(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z%#`$,}_!y$Ip$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z04f$.X_!P0,v$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(n$/]Z$h&jO!^$0O!^!_$0f!_#i$0O#i#j$0k#j#l$0O#l#m$2^#m#o$0O#o#p$0f#p;'S$0O;'S;=`$4i<%lO$0O(n$0VT_#S$h&jO!^&c!_#o&c#p;'S&c;'S;=`&w<%lO&c#S$0kO_#S(n$0p[$h&jO!Q&c!Q![$1f![!^&c!_!c&c!c!i$1f!i#T&c#T#Z$1f#Z#o&c#o#p$3|#p;'S&c;'S;=`&w<%lO&c(n$1kZ$h&jO!Q&c!Q![$2^![!^&c!_!c&c!c!i$2^!i#T&c#T#Z$2^#Z#o&c#p;'S&c;'S;=`&w<%lO&c(n$2cZ$h&jO!Q&c!Q![$3U![!^&c!_!c&c!c!i$3U!i#T&c#T#Z$3U#Z#o&c#p;'S&c;'S;=`&w<%lO&c(n$3ZZ$h&jO!Q&c!Q![$0O![!^&c!_!c&c!c!i$0O!i#T&c#T#Z$0O#Z#o&c#p;'S&c;'S;=`&w<%lO&c#S$4PR!Q![$4Y!c!i$4Y#T#Z$4Y#S$4]S!Q![$4Y!c!i$4Y#T#Z$4Y#q#r$0f(n$4lP;=`<%l$0O#1[$4z_!V#)l$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z(KW$6U`#w(Ch$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z+;p$7c_$h&j(Rp(U!b([+4QOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[$8qk$h&j(Rp(U!b(O,2j$^#t(`$I[OY%ZYZ&cZr%Zrs&}st%Ztu$8buw%Zwx(rx}%Z}!O$:f!O!Q%Z!Q![$8b![!^%Z!^!_*g!_!c%Z!c!}$8b!}#O%Z#O#P&c#P#R%Z#R#S$8b#S#T%Z#T#o$8b#o#p*g#p$g%Z$g;'S$8b;'S;=`$<l<%lO$8b+d$:qk$h&j(Rp(U!b$^#tOY%ZYZ&cZr%Zrs&}st%Ztu$:fuw%Zwx(rx}%Z}!O$:f!O!Q%Z!Q![$:f![!^%Z!^!_*g!_!c%Z!c!}$:f!}#O%Z#O#P&c#P#R%Z#R#S$:f#S#T%Z#T#o$:f#o#p*g#p$g%Z$g;'S$:f;'S;=`$<f<%lO$:f+d$<iP;=`<%l$:f07[$<oP;=`<%l$8b#Jf$<{X![#Hb(Rp(U!bOY*gZr*grs'}sw*gwx)rx#O*g#P;'S*g;'S;=`+Z<%lO*g,#x$=sa(t+JY$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_!`Ka!`#O%Z#O#P&c#P#o%Z#o#p*g#p#q$+e#q;'S%Z;'S;=`+a<%lO%Z(Kd$?V_!Z(Cds`$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z?O$@a_!n7`$h&j(Rp(U!bOY%ZYZ&cZr%Zrs&}sw%Zwx(rx!^%Z!^!_*g!_#O%Z#O#P&c#P#o%Z#o#p*g#p;'S%Z;'S;=`+a<%lO%Z07[$Aq|$h&j(Rp(U!b'w0/l$[#t(O,2j(`$I[OX%ZXY+gYZ&cZ[+g[p%Zpq+gqr%Zrs&}st%ZtuEruw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Er![!^%Z!^!_*g!_!c%Z!c!}Er!}#O%Z#O#P&c#P#R%Z#R#SEr#S#T%Z#T#oEr#o#p*g#p$f%Z$f$g+g$g#BYEr#BY#BZ$A`#BZ$ISEr$IS$I_$A`$I_$JTEr$JT$JU$A`$JU$KVEr$KV$KW$A`$KW&FUEr&FU&FV$A`&FV;'SEr;'S;=`I|<%l?HTEr?HT?HU$A`?HUOEr07[$D|k$h&j(Rp(U!b'x0/l$[#t(O,2j(`$I[OY%ZYZ&cZr%Zrs&}st%ZtuEruw%Zwx(rx}%Z}!OGv!O!Q%Z!Q![Er![!^%Z!^!_*g!_!c%Z!c!}Er!}#O%Z#O#P&c#P#R%Z#R#SEr#S#T%Z#T#oEr#o#p*g#p$g%Z$g;'SEr;'S;=`I|<%lOEr",
  tokenizers: [_5, q5, W5, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, I5, new $o("$S~RRtu[#O#Pg#S#T#|~_P#o#pb~gOu~~jVO#i!P#i#j!U#j#l!P#l#m!q#m;'S!P;'S;=`#v<%lO!P~!UO!R~~!XS!Q![!e!c!i!e#T#Z!e#o#p#Z~!hR!Q![!q!c!i!q#T#Z!q~!tR!Q![!}!c!i!}#T#Z!}~#QR!Q![!P!c!i!P#T#Z!P~#^R!Q![#g!c!i#g#T#Z#g~#jS!Q![#g!c!i#g#T#Z#g#q#r!P~#yP;=`<%l!P~$RO(^~~", 141, 335), new $o("j~RQYZXz{^~^O'{~~aP!P!Qd~iO'|~~", 25, 318)],
  topRules: { Script: [0, 7], SingleExpression: [1, 272], SingleClassItem: [2, 273] },
  dialects: { jsx: 0, ts: 14769 },
  dynamicPrecedences: { 77: 1, 79: 1, 91: 1, 167: 1, 196: 1 },
  specialized: [{ term: 322, get: (n) => V5[n] || -1 }, { term: 338, get: (n) => Y5[n] || -1 }, { term: 92, get: (n) => j5[n] || -1 }],
  tokenPrec: 14793
}), T1 = [
  /* @__PURE__ */ tt("function ${name}(${params}) {\n	${}\n}", {
    label: "function",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ tt("for (let ${index} = 0; ${index} < ${bound}; ${index}++) {\n	${}\n}", {
    label: "for",
    detail: "loop",
    type: "keyword"
  }),
  /* @__PURE__ */ tt("for (let ${name} of ${collection}) {\n	${}\n}", {
    label: "for",
    detail: "of loop",
    type: "keyword"
  }),
  /* @__PURE__ */ tt("do {\n	${}\n} while (${})", {
    label: "do",
    detail: "loop",
    type: "keyword"
  }),
  /* @__PURE__ */ tt("while (${}) {\n	${}\n}", {
    label: "while",
    detail: "loop",
    type: "keyword"
  }),
  /* @__PURE__ */ tt(`try {
	\${}
} catch (\${error}) {
	\${}
}`, {
    label: "try",
    detail: "/ catch block",
    type: "keyword"
  }),
  /* @__PURE__ */ tt("if (${}) {\n	${}\n}", {
    label: "if",
    detail: "block",
    type: "keyword"
  }),
  /* @__PURE__ */ tt(`if (\${}) {
	\${}
} else {
	\${}
}`, {
    label: "if",
    detail: "/ else block",
    type: "keyword"
  }),
  /* @__PURE__ */ tt(`class \${name} {
	constructor(\${params}) {
		\${}
	}
}`, {
    label: "class",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ tt('import {${names}} from "${module}"\n${}', {
    label: "import",
    detail: "named",
    type: "keyword"
  }),
  /* @__PURE__ */ tt('import ${name} from "${module}"\n${}', {
    label: "import",
    detail: "default",
    type: "keyword"
  })
], U5 = /* @__PURE__ */ T1.concat([
  /* @__PURE__ */ tt("interface ${name} {\n	${}\n}", {
    label: "interface",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ tt("type ${name} = ${type}", {
    label: "type",
    detail: "definition",
    type: "keyword"
  }),
  /* @__PURE__ */ tt("enum ${name} {\n	${}\n}", {
    label: "enum",
    detail: "definition",
    type: "keyword"
  })
]), yd = /* @__PURE__ */ new Lm(), A1 = /* @__PURE__ */ new Set([
  "Script",
  "Block",
  "FunctionExpression",
  "FunctionDeclaration",
  "ArrowFunction",
  "MethodDeclaration",
  "ForStatement"
]);
function tr(n) {
  return (e, t) => {
    let i = e.node.getChild("VariableDefinition");
    return i && t(i, n), !0;
  };
}
const F5 = ["FunctionDeclaration"], G5 = {
  FunctionDeclaration: /* @__PURE__ */ tr("function"),
  ClassDeclaration: /* @__PURE__ */ tr("class"),
  ClassExpression: () => !0,
  EnumDeclaration: /* @__PURE__ */ tr("constant"),
  TypeAliasDeclaration: /* @__PURE__ */ tr("type"),
  NamespaceDeclaration: /* @__PURE__ */ tr("namespace"),
  VariableDefinition(n, e) {
    n.matchContext(F5) || e(n, "variable");
  },
  TypeDefinition(n, e) {
    e(n, "type");
  },
  __proto__: null
};
function R1(n, e) {
  let t = yd.get(e);
  if (t)
    return t;
  let i = [], r = !0;
  function s(o, l) {
    let a = n.sliceString(o.from, o.to);
    i.push({ label: a, type: l });
  }
  return e.cursor(be.IncludeAnonymous).iterate((o) => {
    if (r)
      r = !1;
    else if (o.name) {
      let l = G5[o.name];
      if (l && l(o, s) || A1.has(o.name))
        return !1;
    } else if (o.to - o.from > 8192) {
      for (let l of R1(n, o.node))
        i.push(l);
      return !1;
    }
  }), yd.set(e, i), i;
}
const kd = /^[\w$\xa1-\uffff][\w$\d\xa1-\uffff]*$/, Z1 = [
  "TemplateString",
  "String",
  "RegExp",
  "LineComment",
  "BlockComment",
  "VariableDefinition",
  "TypeDefinition",
  "Label",
  "PropertyDefinition",
  "PropertyName",
  "PrivatePropertyDefinition",
  "PrivatePropertyName",
  ".",
  "?."
];
function H5(n) {
  let e = ye(n.state).resolveInner(n.pos, -1);
  if (Z1.indexOf(e.name) > -1)
    return null;
  let t = e.name == "VariableName" || e.to - e.from < 20 && kd.test(n.state.sliceDoc(e.from, e.to));
  if (!t && !n.explicit)
    return null;
  let i = [];
  for (let r = e; r; r = r.parent)
    A1.has(r.name) && (i = i.concat(R1(n.state.doc, r)));
  return {
    options: i,
    from: t ? e.from : n.pos,
    validFor: kd
  };
}
const Ft = /* @__PURE__ */ $i.define({
  name: "javascript",
  parser: /* @__PURE__ */ N5.configure({
    props: [
      /* @__PURE__ */ Ur.add({
        IfStatement: /* @__PURE__ */ Vs({ except: /^\s*({|else\b)/ }),
        TryStatement: /* @__PURE__ */ Vs({ except: /^\s*({|catch\b|finally\b)/ }),
        LabeledStatement: mx,
        SwitchBody: (n) => {
          let e = n.textAfter, t = /^\s*\}/.test(e), i = /^\s*(case|default)\b/.test(e);
          return n.baseIndent + (t ? 0 : i ? 1 : 2) * n.unit;
        },
        Block: /* @__PURE__ */ px({ closing: "}" }),
        ArrowFunction: (n) => n.baseIndent + n.unit,
        "TemplateString BlockComment": () => null,
        "Statement Property": /* @__PURE__ */ Vs({ except: /^{/ }),
        JSXElement(n) {
          let e = /^\s*<\//.test(n.textAfter);
          return n.lineIndent(n.node.from) + (e ? 0 : n.unit);
        },
        JSXEscape(n) {
          let e = /\s*\}/.test(n.textAfter);
          return n.lineIndent(n.node.from) + (e ? 0 : n.unit);
        },
        "JSXOpenTag JSXSelfClosingTag"(n) {
          return n.column(n.node.from) + n.unit;
        }
      }),
      /* @__PURE__ */ Li.add({
        "Block ClassBody SwitchBody EnumBody ObjectExpression ArrayExpression ObjectType": jm,
        BlockComment(n) {
          return { from: n.from + 2, to: n.to - 2 };
        }
      })
    ]
  }),
  languageData: {
    closeBrackets: { brackets: ["(", "[", "{", "'", '"', "`"] },
    commentTokens: { line: "//", block: { open: "/*", close: "*/" } },
    indentOnInput: /^\s*(?:case |default:|\{|\}|<\/)$/,
    wordChars: "$"
  }
}), M1 = {
  test: (n) => /^JSX/.test(n.name),
  facet: /* @__PURE__ */ Ih({ commentTokens: { block: { open: "{/*", close: "*/}" } } })
}, E1 = /* @__PURE__ */ Ft.configure({ dialect: "ts" }, "typescript"), z1 = /* @__PURE__ */ Ft.configure({
  dialect: "jsx",
  props: [/* @__PURE__ */ _h.add((n) => n.isTop ? [M1] : void 0)]
}), X1 = /* @__PURE__ */ Ft.configure({
  dialect: "jsx ts",
  props: [/* @__PURE__ */ _h.add((n) => n.isTop ? [M1] : void 0)]
}, "typescript");
let D1 = (n) => ({ label: n, type: "keyword" });
const L1 = /* @__PURE__ */ "break case const continue default delete export extends false finally in instanceof let new return static super switch this throw true typeof var yield".split(" ").map(D1), K5 = /* @__PURE__ */ L1.concat(/* @__PURE__ */ ["declare", "implements", "private", "protected", "public"].map(D1));
function J5(n = {}) {
  let e = n.jsx ? n.typescript ? X1 : z1 : n.typescript ? E1 : Ft, t = n.typescript ? U5.concat(K5) : T1.concat(L1);
  return new Zr(e, [
    Ft.data.of({
      autocomplete: MS(Z1, NO(t))
    }),
    Ft.data.of({
      autocomplete: H5
    }),
    n.jsx ? nT : []
  ]);
}
function eT(n) {
  for (; ; ) {
    if (n.name == "JSXOpenTag" || n.name == "JSXSelfClosingTag" || n.name == "JSXFragmentTag")
      return n;
    if (n.name == "JSXEscape" || !n.parent)
      return null;
    n = n.parent;
  }
}
function xd(n, e, t = n.length) {
  for (let i = e == null ? void 0 : e.firstChild; i; i = i.nextSibling)
    if (i.name == "JSXIdentifier" || i.name == "JSXBuiltin" || i.name == "JSXNamespacedName" || i.name == "JSXMemberExpression")
      return n.sliceString(i.from, Math.min(i.to, t));
  return "";
}
const tT = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), nT = /* @__PURE__ */ I.inputHandler.of((n, e, t, i, r) => {
  if ((tT ? n.composing : n.compositionStarted) || n.state.readOnly || e != t || i != ">" && i != "/" || !Ft.isActiveAt(n.state, e, -1))
    return !1;
  let s = r(), { state: o } = s, l = o.changeByRange((a) => {
    var h;
    let { head: u } = a, c = ye(o).resolveInner(u - 1, -1), f;
    if (c.name == "JSXStartTag" && (c = c.parent), !(o.doc.sliceString(u - 1, u) != i || c.name == "JSXAttributeValue" && c.to > u)) {
      if (i == ">" && c.name == "JSXFragmentTag")
        return { range: a, changes: { from: u, insert: "</>" } };
      if (i == "/" && c.name == "JSXStartCloseTag") {
        let d = c.parent, p = d.parent;
        if (p && d.from == u - 2 && ((f = xd(o.doc, p.firstChild, u)) || ((h = p.firstChild) === null || h === void 0 ? void 0 : h.name) == "JSXFragmentTag")) {
          let m = `${f}>`;
          return { range: $.cursor(u + m.length, -1), changes: { from: u, insert: m } };
        }
      } else if (i == ">") {
        let d = eT(c);
        if (d && d.name == "JSXOpenTag" && !/^\/?>|^<\//.test(o.doc.sliceString(u, u + 2)) && (f = xd(o.doc, d, u)))
          return { range: a, changes: { from: u, insert: `</${f}>` } };
      }
    }
    return { range: a };
  });
  return l.changes.empty ? !1 : (n.dispatch([
    s,
    o.update(l, { userEvent: "input.complete", scrollIntoView: !0 })
  ]), !0);
}), nr = ["_blank", "_self", "_top", "_parent"], Wl = ["ascii", "utf-8", "utf-16", "latin1", "latin1"], Bl = ["get", "post", "put", "delete"], Vl = ["application/x-www-form-urlencoded", "multipart/form-data", "text/plain"], ht = ["true", "false"], Y = {}, iT = {
  a: {
    attrs: {
      href: null,
      ping: null,
      type: null,
      media: null,
      target: nr,
      hreflang: null
    }
  },
  abbr: Y,
  address: Y,
  area: {
    attrs: {
      alt: null,
      coords: null,
      href: null,
      target: null,
      ping: null,
      media: null,
      hreflang: null,
      type: null,
      shape: ["default", "rect", "circle", "poly"]
    }
  },
  article: Y,
  aside: Y,
  audio: {
    attrs: {
      src: null,
      mediagroup: null,
      crossorigin: ["anonymous", "use-credentials"],
      preload: ["none", "metadata", "auto"],
      autoplay: ["autoplay"],
      loop: ["loop"],
      controls: ["controls"]
    }
  },
  b: Y,
  base: { attrs: { href: null, target: nr } },
  bdi: Y,
  bdo: Y,
  blockquote: { attrs: { cite: null } },
  body: Y,
  br: Y,
  button: {
    attrs: {
      form: null,
      formaction: null,
      name: null,
      value: null,
      autofocus: ["autofocus"],
      disabled: ["autofocus"],
      formenctype: Vl,
      formmethod: Bl,
      formnovalidate: ["novalidate"],
      formtarget: nr,
      type: ["submit", "reset", "button"]
    }
  },
  canvas: { attrs: { width: null, height: null } },
  caption: Y,
  center: Y,
  cite: Y,
  code: Y,
  col: { attrs: { span: null } },
  colgroup: { attrs: { span: null } },
  command: {
    attrs: {
      type: ["command", "checkbox", "radio"],
      label: null,
      icon: null,
      radiogroup: null,
      command: null,
      title: null,
      disabled: ["disabled"],
      checked: ["checked"]
    }
  },
  data: { attrs: { value: null } },
  datagrid: { attrs: { disabled: ["disabled"], multiple: ["multiple"] } },
  datalist: { attrs: { data: null } },
  dd: Y,
  del: { attrs: { cite: null, datetime: null } },
  details: { attrs: { open: ["open"] } },
  dfn: Y,
  div: Y,
  dl: Y,
  dt: Y,
  em: Y,
  embed: { attrs: { src: null, type: null, width: null, height: null } },
  eventsource: { attrs: { src: null } },
  fieldset: { attrs: { disabled: ["disabled"], form: null, name: null } },
  figcaption: Y,
  figure: Y,
  footer: Y,
  form: {
    attrs: {
      action: null,
      name: null,
      "accept-charset": Wl,
      autocomplete: ["on", "off"],
      enctype: Vl,
      method: Bl,
      novalidate: ["novalidate"],
      target: nr
    }
  },
  h1: Y,
  h2: Y,
  h3: Y,
  h4: Y,
  h5: Y,
  h6: Y,
  head: {
    children: ["title", "base", "link", "style", "meta", "script", "noscript", "command"]
  },
  header: Y,
  hgroup: Y,
  hr: Y,
  html: {
    attrs: { manifest: null }
  },
  i: Y,
  iframe: {
    attrs: {
      src: null,
      srcdoc: null,
      name: null,
      width: null,
      height: null,
      sandbox: ["allow-top-navigation", "allow-same-origin", "allow-forms", "allow-scripts"],
      seamless: ["seamless"]
    }
  },
  img: {
    attrs: {
      alt: null,
      src: null,
      ismap: null,
      usemap: null,
      width: null,
      height: null,
      crossorigin: ["anonymous", "use-credentials"]
    }
  },
  input: {
    attrs: {
      alt: null,
      dirname: null,
      form: null,
      formaction: null,
      height: null,
      list: null,
      max: null,
      maxlength: null,
      min: null,
      name: null,
      pattern: null,
      placeholder: null,
      size: null,
      src: null,
      step: null,
      value: null,
      width: null,
      accept: ["audio/*", "video/*", "image/*"],
      autocomplete: ["on", "off"],
      autofocus: ["autofocus"],
      checked: ["checked"],
      disabled: ["disabled"],
      formenctype: Vl,
      formmethod: Bl,
      formnovalidate: ["novalidate"],
      formtarget: nr,
      multiple: ["multiple"],
      readonly: ["readonly"],
      required: ["required"],
      type: [
        "hidden",
        "text",
        "search",
        "tel",
        "url",
        "email",
        "password",
        "datetime",
        "date",
        "month",
        "week",
        "time",
        "datetime-local",
        "number",
        "range",
        "color",
        "checkbox",
        "radio",
        "file",
        "submit",
        "image",
        "reset",
        "button"
      ]
    }
  },
  ins: { attrs: { cite: null, datetime: null } },
  kbd: Y,
  keygen: {
    attrs: {
      challenge: null,
      form: null,
      name: null,
      autofocus: ["autofocus"],
      disabled: ["disabled"],
      keytype: ["RSA"]
    }
  },
  label: { attrs: { for: null, form: null } },
  legend: Y,
  li: { attrs: { value: null } },
  link: {
    attrs: {
      href: null,
      type: null,
      hreflang: null,
      media: null,
      sizes: ["all", "16x16", "16x16 32x32", "16x16 32x32 64x64"]
    }
  },
  map: { attrs: { name: null } },
  mark: Y,
  menu: { attrs: { label: null, type: ["list", "context", "toolbar"] } },
  meta: {
    attrs: {
      content: null,
      charset: Wl,
      name: ["viewport", "application-name", "author", "description", "generator", "keywords"],
      "http-equiv": ["content-language", "content-type", "default-style", "refresh"]
    }
  },
  meter: { attrs: { value: null, min: null, low: null, high: null, max: null, optimum: null } },
  nav: Y,
  noscript: Y,
  object: {
    attrs: {
      data: null,
      type: null,
      name: null,
      usemap: null,
      form: null,
      width: null,
      height: null,
      typemustmatch: ["typemustmatch"]
    }
  },
  ol: {
    attrs: { reversed: ["reversed"], start: null, type: ["1", "a", "A", "i", "I"] },
    children: ["li", "script", "template", "ul", "ol"]
  },
  optgroup: { attrs: { disabled: ["disabled"], label: null } },
  option: { attrs: { disabled: ["disabled"], label: null, selected: ["selected"], value: null } },
  output: { attrs: { for: null, form: null, name: null } },
  p: Y,
  param: { attrs: { name: null, value: null } },
  pre: Y,
  progress: { attrs: { value: null, max: null } },
  q: { attrs: { cite: null } },
  rp: Y,
  rt: Y,
  ruby: Y,
  samp: Y,
  script: {
    attrs: {
      type: ["text/javascript"],
      src: null,
      async: ["async"],
      defer: ["defer"],
      charset: Wl
    }
  },
  section: Y,
  select: {
    attrs: {
      form: null,
      name: null,
      size: null,
      autofocus: ["autofocus"],
      disabled: ["disabled"],
      multiple: ["multiple"]
    }
  },
  slot: { attrs: { name: null } },
  small: Y,
  source: { attrs: { src: null, type: null, media: null } },
  span: Y,
  strong: Y,
  style: {
    attrs: {
      type: ["text/css"],
      media: null,
      scoped: null
    }
  },
  sub: Y,
  summary: Y,
  sup: Y,
  table: Y,
  tbody: Y,
  td: { attrs: { colspan: null, rowspan: null, headers: null } },
  template: Y,
  textarea: {
    attrs: {
      dirname: null,
      form: null,
      maxlength: null,
      name: null,
      placeholder: null,
      rows: null,
      cols: null,
      autofocus: ["autofocus"],
      disabled: ["disabled"],
      readonly: ["readonly"],
      required: ["required"],
      wrap: ["soft", "hard"]
    }
  },
  tfoot: Y,
  th: { attrs: { colspan: null, rowspan: null, headers: null, scope: ["row", "col", "rowgroup", "colgroup"] } },
  thead: Y,
  time: { attrs: { datetime: null } },
  title: Y,
  tr: Y,
  track: {
    attrs: {
      src: null,
      label: null,
      default: null,
      kind: ["subtitles", "captions", "descriptions", "chapters", "metadata"],
      srclang: null
    }
  },
  ul: { children: ["li", "script", "template", "ul", "ol"] },
  var: Y,
  video: {
    attrs: {
      src: null,
      poster: null,
      width: null,
      height: null,
      crossorigin: ["anonymous", "use-credentials"],
      preload: ["auto", "metadata", "none"],
      autoplay: ["autoplay"],
      mediagroup: ["movie"],
      muted: ["muted"],
      controls: ["controls"]
    }
  },
  wbr: Y
}, I1 = {
  accesskey: null,
  class: null,
  contenteditable: ht,
  contextmenu: null,
  dir: ["ltr", "rtl", "auto"],
  draggable: ["true", "false", "auto"],
  dropzone: ["copy", "move", "link", "string:", "file:"],
  hidden: ["hidden"],
  id: null,
  inert: ["inert"],
  itemid: null,
  itemprop: null,
  itemref: null,
  itemscope: ["itemscope"],
  itemtype: null,
  lang: ["ar", "bn", "de", "en-GB", "en-US", "es", "fr", "hi", "id", "ja", "pa", "pt", "ru", "tr", "zh"],
  spellcheck: ht,
  autocorrect: ht,
  autocapitalize: ht,
  style: null,
  tabindex: null,
  title: null,
  translate: ["yes", "no"],
  rel: ["stylesheet", "alternate", "author", "bookmark", "help", "license", "next", "nofollow", "noreferrer", "prefetch", "prev", "search", "tag"],
  role: /* @__PURE__ */ "alert application article banner button cell checkbox complementary contentinfo dialog document feed figure form grid gridcell heading img list listbox listitem main navigation region row rowgroup search switch tab table tabpanel textbox timer".split(" "),
  "aria-activedescendant": null,
  "aria-atomic": ht,
  "aria-autocomplete": ["inline", "list", "both", "none"],
  "aria-busy": ht,
  "aria-checked": ["true", "false", "mixed", "undefined"],
  "aria-controls": null,
  "aria-describedby": null,
  "aria-disabled": ht,
  "aria-dropeffect": null,
  "aria-expanded": ["true", "false", "undefined"],
  "aria-flowto": null,
  "aria-grabbed": ["true", "false", "undefined"],
  "aria-haspopup": ht,
  "aria-hidden": ht,
  "aria-invalid": ["true", "false", "grammar", "spelling"],
  "aria-label": null,
  "aria-labelledby": null,
  "aria-level": null,
  "aria-live": ["off", "polite", "assertive"],
  "aria-multiline": ht,
  "aria-multiselectable": ht,
  "aria-owns": null,
  "aria-posinset": null,
  "aria-pressed": ["true", "false", "mixed", "undefined"],
  "aria-readonly": ht,
  "aria-relevant": null,
  "aria-required": ht,
  "aria-selected": ["true", "false", "undefined"],
  "aria-setsize": null,
  "aria-sort": ["ascending", "descending", "none", "other"],
  "aria-valuemax": null,
  "aria-valuemin": null,
  "aria-valuenow": null,
  "aria-valuetext": null
}, _1 = /* @__PURE__ */ "beforeunload copy cut dragstart dragover dragleave dragenter dragend drag paste focus blur change click load mousedown mouseenter mouseleave mouseup keydown keyup resize scroll unload".split(" ").map((n) => "on" + n);
for (let n of _1)
  I1[n] = null;
let qr = class {
  constructor(e, t) {
    this.tags = Object.assign(Object.assign({}, iT), e), this.globalAttrs = Object.assign(Object.assign({}, I1), t), this.allTags = Object.keys(this.tags), this.globalAttrNames = Object.keys(this.globalAttrs);
  }
};
qr.default = /* @__PURE__ */ new qr();
function Mi(n, e, t = n.length) {
  if (!e)
    return "";
  let i = e.firstChild, r = i && i.getChild("TagName");
  return r ? n.sliceString(r.from, Math.min(r.to, t)) : "";
}
function Ei(n, e = !1) {
  for (; n; n = n.parent)
    if (n.name == "Element")
      if (e)
        e = !1;
      else
        return n;
  return null;
}
function q1(n, e, t) {
  let i = t.tags[Mi(n, Ei(e))];
  return (i == null ? void 0 : i.children) || t.allTags;
}
function Ou(n, e) {
  let t = [];
  for (let i = Ei(e); i && !i.type.isTop; i = Ei(i.parent)) {
    let r = Mi(n, i);
    if (r && i.lastChild.name == "CloseTag")
      break;
    r && t.indexOf(r) < 0 && (e.name == "EndTag" || e.from >= i.firstChild.to) && t.push(r);
  }
  return t;
}
const W1 = /^[:\-\.\w\u00b7-\uffff]*$/;
function wd(n, e, t, i, r) {
  let s = /\s*>/.test(n.sliceDoc(r, r + 5)) ? "" : ">", o = Ei(t, !0);
  return {
    from: i,
    to: r,
    options: q1(n.doc, o, e).map((l) => ({ label: l, type: "type" })).concat(Ou(n.doc, t).map((l, a) => ({
      label: "/" + l,
      apply: "/" + l + s,
      type: "type",
      boost: 99 - a
    }))),
    validFor: /^\/?[:\-\.\w\u00b7-\uffff]*$/
  };
}
function Sd(n, e, t, i) {
  let r = /\s*>/.test(n.sliceDoc(i, i + 5)) ? "" : ">";
  return {
    from: t,
    to: i,
    options: Ou(n.doc, e).map((s, o) => ({ label: s, apply: s + r, type: "type", boost: 99 - o })),
    validFor: W1
  };
}
function rT(n, e, t, i) {
  let r = [], s = 0;
  for (let o of q1(n.doc, t, e))
    r.push({ label: "<" + o, type: "type" });
  for (let o of Ou(n.doc, t))
    r.push({ label: "</" + o + ">", type: "type", boost: 99 - s++ });
  return { from: i, to: i, options: r, validFor: /^<\/?[:\-\.\w\u00b7-\uffff]*$/ };
}
function sT(n, e, t, i, r) {
  let s = Ei(t), o = s ? e.tags[Mi(n.doc, s)] : null, l = o && o.attrs ? Object.keys(o.attrs) : [], a = o && o.globalAttrs === !1 ? l : l.length ? l.concat(e.globalAttrNames) : e.globalAttrNames;
  return {
    from: i,
    to: r,
    options: a.map((h) => ({ label: h, type: "property" })),
    validFor: W1
  };
}
function oT(n, e, t, i, r) {
  var s;
  let o = (s = t.parent) === null || s === void 0 ? void 0 : s.getChild("AttributeName"), l = [], a;
  if (o) {
    let h = n.sliceDoc(o.from, o.to), u = e.globalAttrs[h];
    if (!u) {
      let c = Ei(t), f = c ? e.tags[Mi(n.doc, c)] : null;
      u = (f == null ? void 0 : f.attrs) && f.attrs[h];
    }
    if (u) {
      let c = n.sliceDoc(i, r).toLowerCase(), f = '"', d = '"';
      /^['"]/.test(c) ? (a = c[0] == '"' ? /^[^"]*$/ : /^[^']*$/, f = "", d = n.sliceDoc(r, r + 1) == c[0] ? "" : c[0], c = c.slice(1), i++) : a = /^[^\s<>='"]*$/;
      for (let p of u)
        l.push({ label: p, apply: f + p + d, type: "constant" });
    }
  }
  return { from: i, to: r, options: l, validFor: a };
}
function B1(n, e) {
  let { state: t, pos: i } = e, r = ye(t).resolveInner(i, -1), s = r.resolve(i);
  for (let o = i, l; s == r && (l = r.childBefore(o)); ) {
    let a = l.lastChild;
    if (!a || !a.type.isError || a.from < a.to)
      break;
    s = r = l, o = a.from;
  }
  return r.name == "TagName" ? r.parent && /CloseTag$/.test(r.parent.name) ? Sd(t, r, r.from, i) : wd(t, n, r, r.from, i) : r.name == "StartTag" ? wd(t, n, r, i, i) : r.name == "StartCloseTag" || r.name == "IncompleteCloseTag" ? Sd(t, r, i, i) : r.name == "OpenTag" || r.name == "SelfClosingTag" || r.name == "AttributeName" ? sT(t, n, r, r.name == "AttributeName" ? r.from : i, i) : r.name == "Is" || r.name == "AttributeValue" || r.name == "UnquotedAttributeValue" ? oT(t, n, r, r.name == "Is" ? i : r.from, i) : e.explicit && (s.name == "Element" || s.name == "Text" || s.name == "Document") ? rT(t, n, r, i) : null;
}
function lT(n) {
  return B1(qr.default, n);
}
function aT(n) {
  let { extraTags: e, extraGlobalAttributes: t } = n, i = t || e ? new qr(e, t) : qr.default;
  return (r) => B1(i, r);
}
const hT = /* @__PURE__ */ Ft.parser.configure({ top: "SingleExpression" }), V1 = [
  {
    tag: "script",
    attrs: (n) => n.type == "text/typescript" || n.lang == "ts",
    parser: E1.parser
  },
  {
    tag: "script",
    attrs: (n) => n.type == "text/babel" || n.type == "text/jsx",
    parser: z1.parser
  },
  {
    tag: "script",
    attrs: (n) => n.type == "text/typescript-jsx",
    parser: X1.parser
  },
  {
    tag: "script",
    attrs(n) {
      return /^(importmap|speculationrules|application\/(.+\+)?json)$/i.test(n.type);
    },
    parser: hT
  },
  {
    tag: "script",
    attrs(n) {
      return !n.type || /^(?:text|application)\/(?:x-)?(?:java|ecma)script$|^module$|^$/i.test(n.type);
    },
    parser: Ft.parser
  },
  {
    tag: "style",
    attrs(n) {
      return (!n.lang || n.lang == "css") && (!n.type || /^(text\/)?(x-)?(stylesheet|css)$/i.test(n.type));
    },
    parser: Ao.parser
  }
], Y1 = /* @__PURE__ */ [
  {
    name: "style",
    parser: /* @__PURE__ */ Ao.parser.configure({ top: "Styles" })
  }
].concat(/* @__PURE__ */ _1.map((n) => ({ name: n, parser: Ft.parser }))), j1 = /* @__PURE__ */ $i.define({
  name: "html",
  parser: /* @__PURE__ */ Y3.configure({
    props: [
      /* @__PURE__ */ Ur.add({
        Element(n) {
          let e = /^(\s*)(<\/)?/.exec(n.textAfter);
          return n.node.to <= n.pos + e[0].length ? n.continue() : n.lineIndent(n.node.from) + (e[2] ? 0 : n.unit);
        },
        "OpenTag CloseTag SelfClosingTag"(n) {
          return n.column(n.node.from) + n.unit;
        },
        Document(n) {
          if (n.pos + /\s*/.exec(n.textAfter)[0].length < n.node.to)
            return n.continue();
          let e = null, t;
          for (let i = n.node; ; ) {
            let r = i.lastChild;
            if (!r || r.name != "Element" || r.to != i.to)
              break;
            e = i = r;
          }
          return e && !((t = e.lastChild) && (t.name == "CloseTag" || t.name == "SelfClosingTag")) ? n.lineIndent(e.from) + n.unit : null;
        }
      }),
      /* @__PURE__ */ Li.add({
        Element(n) {
          let e = n.firstChild, t = n.lastChild;
          return !e || e.name != "OpenTag" ? null : { from: e.to, to: t.name == "CloseTag" ? t.from : n.to };
        }
      }),
      /* @__PURE__ */ rO.add({
        "OpenTag CloseTag": (n) => n.getChild("TagName")
      })
    ]
  }),
  languageData: {
    commentTokens: { block: { open: "<!--", close: "-->" } },
    indentOnInput: /^\s*<\/\w+\W$/,
    wordChars: "-._"
  }
}), Us = /* @__PURE__ */ j1.configure({
  wrap: /* @__PURE__ */ S1(V1, Y1)
});
function uT(n = {}) {
  let e = "", t;
  n.matchClosingTags === !1 && (e = "noMatch"), n.selfClosingTags === !0 && (e = (e ? e + " " : "") + "selfClosing"), (n.nestedLanguages && n.nestedLanguages.length || n.nestedAttributes && n.nestedAttributes.length) && (t = S1((n.nestedLanguages || []).concat(V1), (n.nestedAttributes || []).concat(Y1)));
  let i = t ? j1.configure({ wrap: t, dialect: e }) : e ? Us.configure({ dialect: e }) : Us;
  return new Zr(i, [
    Us.data.of({ autocomplete: aT(n) }),
    n.autoCloseTags !== !1 ? cT : [],
    J5().support,
    y5().support
  ]);
}
const vd = /* @__PURE__ */ new Set(/* @__PURE__ */ "area base br col command embed frame hr img input keygen link meta param source track wbr menuitem".split(" ")), cT = /* @__PURE__ */ I.inputHandler.of((n, e, t, i, r) => {
  if (n.composing || n.state.readOnly || e != t || i != ">" && i != "/" || !Us.isActiveAt(n.state, e, -1))
    return !1;
  let s = r(), { state: o } = s, l = o.changeByRange((a) => {
    var h, u, c;
    let f = o.doc.sliceString(a.from - 1, a.to) == i, { head: d } = a, p = ye(o).resolveInner(d, -1), m;
    if (f && i == ">" && p.name == "EndTag") {
      let O = p.parent;
      if (((u = (h = O.parent) === null || h === void 0 ? void 0 : h.lastChild) === null || u === void 0 ? void 0 : u.name) != "CloseTag" && (m = Mi(o.doc, O.parent, d)) && !vd.has(m)) {
        let g = d + (o.doc.sliceString(d, d + 1) === ">" ? 1 : 0), b = `</${m}>`;
        return { range: a, changes: { from: d, to: g, insert: b } };
      }
    } else if (f && i == "/" && p.name == "IncompleteCloseTag") {
      let O = p.parent;
      if (p.from == d - 2 && ((c = O.lastChild) === null || c === void 0 ? void 0 : c.name) != "CloseTag" && (m = Mi(o.doc, O, d)) && !vd.has(m)) {
        let g = d + (o.doc.sliceString(d, d + 1) === ">" ? 1 : 0), b = `${m}>`;
        return {
          range: $.cursor(d + b.length, -1),
          changes: { from: d, to: g, insert: b }
        };
      }
    }
    return { range: a };
  });
  return l.changes.empty ? !1 : (n.dispatch([
    s,
    o.update(l, {
      userEvent: "input.complete",
      scrollIntoView: !0
    })
  ]), !0);
}), N1 = /* @__PURE__ */ Ih({ commentTokens: { block: { open: "<!--", close: "-->" } } }), U1 = /* @__PURE__ */ new F(), F1 = /* @__PURE__ */ _C.configure({
  props: [
    /* @__PURE__ */ Li.add((n) => !n.is("Block") || n.is("Document") || fh(n) != null || fT(n) ? void 0 : (e, t) => ({ from: t.doc.lineAt(e.from).to, to: e.to })),
    /* @__PURE__ */ U1.add(fh),
    /* @__PURE__ */ Ur.add({
      Document: () => null
    }),
    /* @__PURE__ */ jn.add({
      Document: N1
    })
  ]
});
function fh(n) {
  let e = /^(?:ATX|Setext)Heading(\d)$/.exec(n.name);
  return e ? +e[1] : void 0;
}
function fT(n) {
  return n.name == "OrderedList" || n.name == "BulletList";
}
function dT(n, e) {
  let t = n;
  for (; ; ) {
    let i = t.nextSibling, r;
    if (!i || (r = fh(i.type)) != null && r <= e)
      break;
    t = i;
  }
  return t.to;
}
const pT = /* @__PURE__ */ Ym.of((n, e, t) => {
  for (let i = ye(n).resolveInner(t, -1); i && !(i.from < e); i = i.parent) {
    let r = i.type.prop(U1);
    if (r == null)
      continue;
    let s = dT(i, r);
    if (s > t)
      return { from: t, to: s };
  }
  return null;
});
function gu(n) {
  return new kt(N1, n, [pT], "markdown");
}
const mT = /* @__PURE__ */ gu(F1), OT = /* @__PURE__ */ F1.configure([HC, JC, KC, e3, {
  props: [
    /* @__PURE__ */ Li.add({
      Table: (n, e) => ({ from: e.doc.lineAt(n.from).to, to: n.to })
    })
  ]
}]), bu = /* @__PURE__ */ gu(OT);
function gT(n, e) {
  return (t) => {
    if (t && n) {
      let i = null;
      if (t = /\S*/.exec(t)[0], typeof n == "function" ? i = n(t) : i = lo.matchLanguageName(n, t, !0), i instanceof lo)
        return i.support ? i.support.language.parser : Rr.getSkippingParser(i.load());
      if (i)
        return i.parser;
    }
    return e ? e.parser : null;
  };
}
class Cs {
  constructor(e, t, i, r, s, o, l) {
    this.node = e, this.from = t, this.to = i, this.spaceBefore = r, this.spaceAfter = s, this.type = o, this.item = l;
  }
  blank(e, t = !0) {
    let i = this.spaceBefore + (this.node.name == "Blockquote" ? ">" : "");
    if (e != null) {
      for (; i.length < e; )
        i += " ";
      return i;
    } else {
      for (let r = this.to - this.from - i.length - this.spaceAfter.length; r > 0; r--)
        i += " ";
      return i + (t ? this.spaceAfter : "");
    }
  }
  marker(e, t) {
    let i = this.node.name == "OrderedList" ? String(+H1(this.item, e)[2] + t) : "";
    return this.spaceBefore + i + this.type + this.spaceAfter;
  }
}
function G1(n, e) {
  let t = [];
  for (let r = n; r && r.name != "Document"; r = r.parent)
    (r.name == "ListItem" || r.name == "Blockquote" || r.name == "FencedCode") && t.push(r);
  let i = [];
  for (let r = t.length - 1; r >= 0; r--) {
    let s = t[r], o, l = e.lineAt(s.from), a = s.from - l.from;
    if (s.name == "FencedCode")
      i.push(new Cs(s, a, a, "", "", "", null));
    else if (s.name == "Blockquote" && (o = /^ *>( ?)/.exec(l.text.slice(a))))
      i.push(new Cs(s, a, a + o[0].length, "", o[1], ">", null));
    else if (s.name == "ListItem" && s.parent.name == "OrderedList" && (o = /^( *)\d+([.)])( *)/.exec(l.text.slice(a)))) {
      let h = o[3], u = o[0].length;
      h.length >= 4 && (h = h.slice(0, h.length - 4), u -= 4), i.push(new Cs(s.parent, a, a + u, o[1], h, o[2], s));
    } else if (s.name == "ListItem" && s.parent.name == "BulletList" && (o = /^( *)([-+*])( {1,4}\[[ xX]\])?( +)/.exec(l.text.slice(a)))) {
      let h = o[4], u = o[0].length;
      h.length > 4 && (h = h.slice(0, h.length - 4), u -= 4);
      let c = o[2];
      o[3] && (c += o[3].replace(/[xX]/, " ")), i.push(new Cs(s.parent, a, a + u, o[1], h, c, s));
    }
  }
  return i;
}
function H1(n, e) {
  return /^(\s*)(\d+)(?=[.)])/.exec(e.sliceString(n.from, n.from + 10));
}
function Yl(n, e, t, i = 0) {
  for (let r = -1, s = n; ; ) {
    if (s.name == "ListItem") {
      let l = H1(s, e), a = +l[2];
      if (r >= 0) {
        if (a != r + 1)
          return;
        t.push({ from: s.from + l[1].length, to: s.from + l[0].length, insert: String(r + 2 + i) });
      }
      r = a;
    }
    let o = s.nextSibling;
    if (!o)
      break;
    s = o;
  }
}
function yu(n, e) {
  let t = /^[ \t]*/.exec(n)[0].length;
  if (!t || e.facet(Di) != "	")
    return n;
  let i = Mt(n, 4, t), r = "";
  for (let s = i; s > 0; )
    s >= 4 ? (r += "	", s -= 4) : (r += " ", s--);
  return r + n.slice(t);
}
const bT = ({ state: n, dispatch: e }) => {
  let t = ye(n), { doc: i } = n, r = null, s = n.changeByRange((o) => {
    if (!o.empty || !bu.isActiveAt(n, o.from))
      return r = { range: o };
    let l = o.from, a = i.lineAt(l), h = G1(t.resolveInner(l, -1), i);
    for (; h.length && h[h.length - 1].from > l - a.from; )
      h.pop();
    if (!h.length)
      return r = { range: o };
    let u = h[h.length - 1];
    if (u.to - u.spaceAfter.length > l - a.from)
      return r = { range: o };
    let c = l >= u.to - u.spaceAfter.length && !/\S/.test(a.text.slice(u.to));
    if (u.item && c) {
      let O = u.node.firstChild, g = u.node.getChild("ListItem", "ListItem");
      if (O.to >= l || g && g.to < l || a.from > 0 && !/[^\s>]/.test(i.lineAt(a.from - 1).text)) {
        let b = h.length > 1 ? h[h.length - 2] : null, S, Q = "";
        b && b.item ? (S = a.from + b.from, Q = b.marker(i, 1)) : S = a.from + (b ? b.to : 0);
        let P = [{ from: S, to: l, insert: Q }];
        return u.node.name == "OrderedList" && Yl(u.item, i, P, -2), b && b.node.name == "OrderedList" && Yl(b.item, i, P), { range: $.cursor(S + Q.length), changes: P };
      } else {
        let b = Qd(h, n, a);
        return {
          range: $.cursor(l + b.length + 1),
          changes: { from: a.from, insert: b + n.lineBreak }
        };
      }
    }
    if (u.node.name == "Blockquote" && c && a.from) {
      let O = i.lineAt(a.from - 1), g = />\s*$/.exec(O.text);
      if (g && g.index == u.from) {
        let b = n.changes([
          { from: O.from + g.index, to: O.to },
          { from: a.from + u.from, to: a.to }
        ]);
        return { range: o.map(b), changes: b };
      }
    }
    let f = [];
    u.node.name == "OrderedList" && Yl(u.item, i, f);
    let d = u.item && u.item.from < a.from, p = "";
    if (!d || /^[\s\d.)\-+*>]*/.exec(a.text)[0].length >= u.to)
      for (let O = 0, g = h.length - 1; O <= g; O++)
        p += O == g && !d ? h[O].marker(i, 1) : h[O].blank(O < g ? Mt(a.text, 4, h[O + 1].from) - p.length : null);
    let m = l;
    for (; m > a.from && /\s/.test(a.text.charAt(m - a.from - 1)); )
      m--;
    return p = yu(p, n), yT(u.node, n.doc) && (p = Qd(h, n, a) + n.lineBreak + p), f.push({ from: m, to: l, insert: n.lineBreak + p }), { range: $.cursor(m + p.length + 1), changes: f };
  });
  return r ? !1 : (e(n.update(s, { scrollIntoView: !0, userEvent: "input" })), !0);
};
function Pd(n) {
  return n.name == "QuoteMark" || n.name == "ListMark";
}
function yT(n, e) {
  if (n.name != "OrderedList" && n.name != "BulletList")
    return !1;
  let t = n.firstChild, i = n.getChild("ListItem", "ListItem");
  if (!i)
    return !1;
  let r = e.lineAt(t.to), s = e.lineAt(i.from), o = /^[\s>]*$/.test(r.text);
  return r.number + (o ? 0 : 1) < s.number;
}
function Qd(n, e, t) {
  let i = "";
  for (let r = 0, s = n.length - 2; r <= s; r++)
    i += n[r].blank(r < s ? Mt(t.text, 4, n[r + 1].from) - i.length : null, r < s);
  return yu(i, e);
}
function kT(n, e) {
  let t = n.resolveInner(e, -1), i = e;
  Pd(t) && (i = t.from, t = t.parent);
  for (let r; r = t.childBefore(i); )
    if (Pd(r))
      i = r.from;
    else if (r.name == "OrderedList" || r.name == "BulletList")
      t = r.lastChild, i = t.to;
    else
      break;
  return t;
}
const xT = ({ state: n, dispatch: e }) => {
  let t = ye(n), i = null, r = n.changeByRange((s) => {
    let o = s.from, { doc: l } = n;
    if (s.empty && bu.isActiveAt(n, s.from)) {
      let a = l.lineAt(o), h = G1(kT(t, o), l);
      if (h.length) {
        let u = h[h.length - 1], c = u.to - u.spaceAfter.length + (u.spaceAfter ? 1 : 0);
        if (o - a.from > c && !/\S/.test(a.text.slice(c, o - a.from)))
          return {
            range: $.cursor(a.from + c),
            changes: { from: a.from + c, to: o }
          };
        if (o - a.from == c && // Only apply this if we're on the line that has the
        // construct's syntax, or there's only indentation in the
        // target range
        (!u.item || a.from <= u.item.from || !/\S/.test(a.text.slice(0, u.to)))) {
          let f = a.from + u.from;
          if (u.item && u.node.from < u.item.from && /\S/.test(a.text.slice(u.from, u.to))) {
            let d = u.blank(Mt(a.text, 4, u.to) - Mt(a.text, 4, u.from));
            return f == a.from && (d = yu(d, n)), {
              range: $.cursor(f + d.length),
              changes: { from: f, to: a.from + u.to, insert: d }
            };
          }
          if (f < o)
            return { range: $.cursor(f), changes: { from: f, to: o } };
        }
      }
    }
    return i = { range: s };
  });
  return i ? !1 : (e(n.update(r, { scrollIntoView: !0, userEvent: "delete" })), !0);
}, wT = [
  { key: "Enter", run: bT },
  { key: "Backspace", run: xT }
], dh = /* @__PURE__ */ uT({ matchClosingTags: !1 });
function ST(n = {}) {
  let { codeLanguages: e, defaultCodeLanguage: t, addKeymap: i = !0, base: { parser: r } = mT, completeHTMLTags: s = !0 } = n;
  if (!(r instanceof el))
    throw new RangeError("Base parser provided to `markdown` should be a Markdown parser");
  let o = n.extensions ? [n.extensions] : [], l = [dh.support], a;
  t instanceof Zr ? (l.push(t.support), a = t.language) : t && (a = t);
  let h = e || a ? gT(e, a) : void 0;
  o.push(WC({ codeParser: h, htmlParser: dh.language.parser })), i && l.push(un.high(zi.of(wT)));
  let u = gu(r.configure(o));
  return s && l.push(u.data.of({ autocomplete: vT })), new Zr(u, l);
}
function vT(n) {
  let { state: e, pos: t } = n, i = /<[:\-\.\w\u00b7-\uffff]*$/.exec(e.sliceDoc(t - 25, t));
  if (!i)
    return null;
  let r = ye(e).resolveInner(t, -1);
  for (; r && !r.type.isTop; ) {
    if (r.name == "CodeBlock" || r.name == "FencedCode" || r.name == "ProcessingInstructionBlock" || r.name == "CommentBlock" || r.name == "Link" || r.name == "Image")
      return null;
    r = r.parent;
  }
  return {
    from: t - i[0].length,
    to: t,
    options: PT(),
    validFor: /^<[:\-\.\w\u00b7-\uffff]*$/
  };
}
let jl = null;
function PT() {
  if (jl)
    return jl;
  let n = lT(new Gh(ee.create({ extensions: dh }), 0, !0));
  return jl = n ? n.options : [];
}
function QT() {
  const e = this.data();
  (e.micromarkExtensions || (e.micromarkExtensions = [])).push({ disable: { null: ["htmlText", "htmlFlow"] } });
}
function ku() {
  return {
    remark: [
      _$,
      QT
    ],
    rehype: [],
    remarkRehypeOptions: {},
    codemirror: [
      ST({
        base: bu,
        extensions: [
          { remove: ["HTMLBlock", "HTMLTag"] }
        ],
        completeHTMLTags: !1
      })
    ]
  };
}
const $T = {
  name: "increase-level",
  icon: Ze.headingup,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let h = r; h <= s; h++) {
        const u = e.doc.line(h), c = u.text;
        console.log(u.text);
        let f = 0, d = 0, p = 0;
        const m = c.length;
        for (; f < m && c[f] === " "; )
          f++;
        for (d = f; d < m && c[d] === "#"; )
          d++;
        for (p = d; p < m && c[p] === " "; )
          p++;
        const O = d - f, g = Math.min(O + 1, 6), b = g === 0 ? "" : "#".repeat(g) + " ";
        o.push({
          from: u.from,
          to: u.from + p,
          insert: b
        }), h === r && (l = u.from), a = a + u.length + b.length - p + 1;
      }
      return a--, {
        changes: o,
        range: $.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, CT = {
  name: "decrease-level",
  icon: Ze.headingdown,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let h = r; h <= s; h++) {
        const u = e.doc.line(h), c = u.text;
        console.log(u.text);
        let f = 0, d = 0, p = 0;
        const m = c.length;
        for (; f < m && c[f] === " "; )
          f++;
        for (d = f; d < m && c[d] === "#"; )
          d++;
        for (p = d; p < m && c[p] === " "; )
          p++;
        const O = d - f, g = Math.max(O - 1, 0), b = g === 0 ? "" : "#".repeat(g) + " ";
        o.push({
          from: u.from,
          to: u.from + p,
          insert: b
        }), h === r && (l = u.from), a = a + u.length + b.length - p + 1;
      }
      return a--, {
        changes: o,
        range: $.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, TT = {
  name: "horizontal",
  icon: Ze.line,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = `

---

`;
      return {
        changes: [
          { from: i.from, to: i.to },
          { from: i.from, insert: r }
        ],
        range: $.range(i.from + r.length, i.from + r.length)
      };
    }));
    n.update([t]), n.focus();
  }
}, AT = {
  name: "bold",
  icon: Ze.bold,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: "**" },
        { from: i.to, insert: "**" }
      ],
      range: $.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, RT = {
  name: "italic",
  icon: Ze.italic,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: " _" },
        { from: i.to, insert: "_ " }
      ],
      range: $.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, ZT = {
  name: "strikethrough",
  icon: Ze.strikethrough,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: "~~" },
        { from: i.to, insert: "~~" }
      ],
      range: $.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, MT = {
  name: "link",
  icon: Ze.link,
  func: (n, e, t) => {
    function i(s, o) {
      const l = n.state, a = l.update(l.changeByRange((h) => {
        const u = `[${o}](${s})`;
        return {
          changes: [
            { from: h.from, to: h.to },
            { from: h.from, insert: u }
          ],
          range: $.range(h.from + u.length, h.from + u.length)
        };
      }));
      n.update([a]), n.focus();
    }
    const r = Sn(
      vC,
      {
        confirm: i,
        container: t
      }
    );
    Gt(r, t);
  }
}, ET = {
  name: "picture",
  icon: Ze.picture,
  func: (n, e, t) => {
    function i(s, o) {
      const l = n.state, a = l.update(l.changeByRange((h) => {
        const u = `![${o}](${s})`;
        return {
          changes: [
            { from: h.from, to: h.to },
            { from: h.from, insert: u }
          ],
          range: $.range(h.from + u.length, h.from + u.length)
        };
      }));
      n.update([a]), n.focus();
    }
    const r = Sn(
      nC,
      {
        confirm: i,
        container: t
      }
    );
    Gt(r, t);
  }
}, zT = {
  name: "code",
  icon: Ze.code,
  func: (n, e, t) => {
    function i(s, o) {
      const l = n.state, a = l.update(l.changeByRange((h) => {
        const u = `
\`\`\`${s}
${o}
\`\`\`
`;
        return {
          changes: [
            { from: h.from, to: h.to },
            { from: h.from, insert: u }
          ],
          range: $.range(h.from + u.length, h.from + u.length)
        };
      }));
      n.update([a]), n.focus();
    }
    const r = Sn(
      F$,
      {
        confirm: i,
        container: t
      }
    );
    Gt(r, t);
  }
}, XT = {
  name: "table",
  icon: Ze.table,
  func: (n, e, t) => {
    function i(s, o, l) {
      const a = n.state, h = a.update(a.changeByRange((u) => {
        let c = `

`;
        for (let f = 0; f < s; f++) {
          for (let d = 0; d < o; d++)
            c += "|" + l[f][d];
          if (c += `|
`, f === 0) {
            for (let d = 0; d < o; d++)
              c += "|:-:";
            c += `|
`;
          }
        }
        return c += `
`, {
          changes: [
            { from: u.from, to: u.to },
            { from: u.from, insert: c }
          ],
          range: $.range(u.from + c.length, u.from + c.length)
        };
      }));
      n.update([h]), n.focus();
    }
    const r = Sn(
      bC,
      {
        confirm: i,
        container: t
      }
    );
    Gt(r, t);
  }
}, DT = {
  name: "quote",
  icon: Ze.quote,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let h = r; h <= s; h++) {
        const u = e.doc.line(h), c = "> ";
        o.push({
          from: u.from,
          insert: c
        }), h === r && (l = u.from), a = a + u.length + c.length + 1;
      }
      return a--, {
        changes: o,
        range: $.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, LT = {
  name: "unordered-list",
  icon: Ze.listul,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let h = r; h <= s; h++) {
        const u = e.doc.line(h), c = "- ";
        o.push({
          from: u.from,
          insert: c
        }), h === r && (l = u.from), a = a + u.length + c.length + 1;
      }
      return a--, {
        changes: o,
        range: $.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, IT = {
  name: "ordered-list",
  icon: Ze.listol,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let h = r; h <= s; h++) {
        const u = e.doc.line(h), c = "1. ";
        o.push({
          from: u.from,
          insert: c
        }), h === r && (l = u.from), a = a + u.length + c.length + 1;
      }
      return a--, {
        changes: o,
        range: $.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, _T = {
  name: "task-list",
  icon: Ze.listtask,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let h = r; h <= s; h++) {
        const u = e.doc.line(h), c = "- [ ] ";
        o.push({
          from: u.from,
          insert: c
        }), h === r && (l = u.from), a = a + u.length + c.length + 1;
      }
      return a--, {
        changes: o,
        range: $.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, qT = {
  name: "only-editor",
  icon: Ze.editor,
  func: (n, e, t) => {
    e.showViewer ? (e.showEditor = !0, e.showViewer = !1) : e.showViewer = !0;
  }
}, WT = {
  name: "only-viewer",
  icon: Ze.viewer,
  func: (n, e, t) => {
    e.showEditor ? (e.showViewer = !0, e.showEditor = !1) : e.showEditor = !0;
  }
}, BT = {
  name: "full-screen",
  icon: Ze.expand,
  func: (n, e, t) => {
    e.fullScreen = !e.fullScreen;
  }
}, VT = {
  name: "help",
  icon: Ze.help,
  func: (n, e, t) => {
    const i = Sn(
      QC,
      {
        container: t
      }
    );
    Gt(i, t);
  }
}, YT = [$T, CT, TT], jT = [AT, RT, ZT], NT = [MT, ET, zT, XT], UT = [DT, LT, IT, _T], FT = [qT, WT, BT], GT = [VT];
function HT() {
  return [
    YT,
    jT,
    NT,
    UT
  ];
}
function KT() {
  return [
    FT,
    GT
  ];
}
const JT = /* @__PURE__ */ Pt({
  __name: "MEditor",
  props: /* @__PURE__ */ Gs({
    plugins: { default: ku }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const e = n, t = wh(n, "modelValue"), i = lp(() => {
      const r = [
        I.lineWrapping,
        I.theme({
          "&.cm-focused": {
            outline: "none"
          },
          "&.cm-editor": {
            height: "100%"
          },
          "&.cm-scroller": {
            "z-index": "auto"
          }
        }),
        e.plugins.codemirror || []
      ];
      return console.log(r), r;
    });
    return (r, s) => (fe(), ei(xr(G2), {
      modelValue: t.value,
      "onUpdate:modelValue": s[0] || (s[0] = (o) => t.value = o),
      extensions: i.value
    }, null, 8, ["modelValue", "extensions"]));
  }
});
function $d(n) {
  if (n)
    throw n;
}
function e4(n) {
  return n && n.__esModule && Object.prototype.hasOwnProperty.call(n, "default") ? n.default : n;
}
var Fs = Object.prototype.hasOwnProperty, K1 = Object.prototype.toString, Cd = Object.defineProperty, Td = Object.getOwnPropertyDescriptor, Ad = function(e) {
  return typeof Array.isArray == "function" ? Array.isArray(e) : K1.call(e) === "[object Array]";
}, Rd = function(e) {
  if (!e || K1.call(e) !== "[object Object]")
    return !1;
  var t = Fs.call(e, "constructor"), i = e.constructor && e.constructor.prototype && Fs.call(e.constructor.prototype, "isPrototypeOf");
  if (e.constructor && !t && !i)
    return !1;
  var r;
  for (r in e)
    ;
  return typeof r > "u" || Fs.call(e, r);
}, Zd = function(e, t) {
  Cd && t.name === "__proto__" ? Cd(e, t.name, {
    enumerable: !0,
    configurable: !0,
    value: t.newValue,
    writable: !0
  }) : e[t.name] = t.newValue;
}, Md = function(e, t) {
  if (t === "__proto__")
    if (Fs.call(e, t)) {
      if (Td)
        return Td(e, t).value;
    } else
      return;
  return e[t];
}, t4 = function n() {
  var e, t, i, r, s, o, l = arguments[0], a = 1, h = arguments.length, u = !1;
  for (typeof l == "boolean" && (u = l, l = arguments[1] || {}, a = 2), (l == null || typeof l != "object" && typeof l != "function") && (l = {}); a < h; ++a)
    if (e = arguments[a], e != null)
      for (t in e)
        i = Md(l, t), r = Md(e, t), l !== r && (u && r && (Rd(r) || (s = Ad(r))) ? (s ? (s = !1, o = i && Ad(i) ? i : []) : o = i && Rd(i) ? i : {}, Zd(l, { name: t, newValue: n(u, o, r) })) : typeof r < "u" && Zd(l, { name: t, newValue: r }));
  return l;
};
const Nl = /* @__PURE__ */ e4(t4);
function ph(n) {
  if (typeof n != "object" || n === null)
    return !1;
  const e = Object.getPrototypeOf(n);
  return (e === null || e === Object.prototype || Object.getPrototypeOf(e) === null) && !(Symbol.toStringTag in n) && !(Symbol.iterator in n);
}
function n4() {
  const n = [], e = { run: t, use: i };
  return e;
  function t(...r) {
    let s = -1;
    const o = r.pop();
    if (typeof o != "function")
      throw new TypeError("Expected function as last argument, not " + o);
    l(null, ...r);
    function l(a, ...h) {
      const u = n[++s];
      let c = -1;
      if (a) {
        o(a);
        return;
      }
      for (; ++c < r.length; )
        (h[c] === null || h[c] === void 0) && (h[c] = r[c]);
      r = h, u ? i4(u, l)(...h) : o(null, ...h);
    }
  }
  function i(r) {
    if (typeof r != "function")
      throw new TypeError(
        "Expected `middelware` to be a function, not " + r
      );
    return n.push(r), e;
  }
}
function i4(n, e) {
  let t;
  return i;
  function i(...o) {
    const l = n.length > o.length;
    let a;
    l && o.push(r);
    try {
      a = n.apply(this, o);
    } catch (h) {
      const u = (
        /** @type {Error} */
        h
      );
      if (l && t)
        throw u;
      return r(u);
    }
    l || (a && a.then && typeof a.then == "function" ? a.then(s, r) : a instanceof Error ? r(a) : s(a));
  }
  function r(o, ...l) {
    t || (t = !0, e(o, ...l));
  }
  function s(o) {
    r(null, o);
  }
}
function kr(n) {
  return !n || typeof n != "object" ? "" : "position" in n || "type" in n ? Ed(n.position) : "start" in n || "end" in n ? Ed(n) : "line" in n || "column" in n ? mh(n) : "";
}
function mh(n) {
  return zd(n && n.line) + ":" + zd(n && n.column);
}
function Ed(n) {
  return mh(n && n.start) + "-" + mh(n && n.end);
}
function zd(n) {
  return n && typeof n == "number" ? n : 1;
}
class st extends Error {
  /**
   * Create a message for `reason`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {Options | null | undefined} [options]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | Options | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns
   *   Instance of `VFileMessage`.
   */
  // eslint-disable-next-line complexity
  constructor(e, t, i) {
    super(), typeof t == "string" && (i = t, t = void 0);
    let r = "", s = {}, o = !1;
    if (t && ("line" in t && "column" in t ? s = { place: t } : "start" in t && "end" in t ? s = { place: t } : "type" in t ? s = {
      ancestors: [t],
      place: t.position
    } : s = { ...t }), typeof e == "string" ? r = e : !s.cause && e && (o = !0, r = e.message, s.cause = e), !s.ruleId && !s.source && typeof i == "string") {
      const a = i.indexOf(":");
      a === -1 ? s.ruleId = i : (s.source = i.slice(0, a), s.ruleId = i.slice(a + 1));
    }
    if (!s.place && s.ancestors && s.ancestors) {
      const a = s.ancestors[s.ancestors.length - 1];
      a && (s.place = a.position);
    }
    const l = s.place && "start" in s.place ? s.place.start : s.place;
    this.ancestors = s.ancestors || void 0, this.cause = s.cause || void 0, this.column = l ? l.column : void 0, this.fatal = void 0, this.file, this.message = r, this.line = l ? l.line : void 0, this.name = kr(s.place) || "1:1", this.place = s.place || void 0, this.reason = this.message, this.ruleId = s.ruleId || void 0, this.source = s.source || void 0, this.stack = o && s.cause && typeof s.cause.stack == "string" ? s.cause.stack : "", this.actual, this.expected, this.note, this.url;
  }
}
st.prototype.file = "";
st.prototype.name = "";
st.prototype.reason = "";
st.prototype.message = "";
st.prototype.stack = "";
st.prototype.column = void 0;
st.prototype.line = void 0;
st.prototype.ancestors = void 0;
st.prototype.cause = void 0;
st.prototype.fatal = void 0;
st.prototype.place = void 0;
st.prototype.ruleId = void 0;
st.prototype.source = void 0;
const Wt = { basename: r4, dirname: s4, extname: o4, join: l4, sep: "/" };
function r4(n, e) {
  if (e !== void 0 && typeof e != "string")
    throw new TypeError('"ext" argument must be a string');
  es(n);
  let t = 0, i = -1, r = n.length, s;
  if (e === void 0 || e.length === 0 || e.length > n.length) {
    for (; r--; )
      if (n.codePointAt(r) === 47) {
        if (s) {
          t = r + 1;
          break;
        }
      } else
        i < 0 && (s = !0, i = r + 1);
    return i < 0 ? "" : n.slice(t, i);
  }
  if (e === n)
    return "";
  let o = -1, l = e.length - 1;
  for (; r--; )
    if (n.codePointAt(r) === 47) {
      if (s) {
        t = r + 1;
        break;
      }
    } else
      o < 0 && (s = !0, o = r + 1), l > -1 && (n.codePointAt(r) === e.codePointAt(l--) ? l < 0 && (i = r) : (l = -1, i = o));
  return t === i ? i = o : i < 0 && (i = n.length), n.slice(t, i);
}
function s4(n) {
  if (es(n), n.length === 0)
    return ".";
  let e = -1, t = n.length, i;
  for (; --t; )
    if (n.codePointAt(t) === 47) {
      if (i) {
        e = t;
        break;
      }
    } else
      i || (i = !0);
  return e < 0 ? n.codePointAt(0) === 47 ? "/" : "." : e === 1 && n.codePointAt(0) === 47 ? "//" : n.slice(0, e);
}
function o4(n) {
  es(n);
  let e = n.length, t = -1, i = 0, r = -1, s = 0, o;
  for (; e--; ) {
    const l = n.codePointAt(e);
    if (l === 47) {
      if (o) {
        i = e + 1;
        break;
      }
      continue;
    }
    t < 0 && (o = !0, t = e + 1), l === 46 ? r < 0 ? r = e : s !== 1 && (s = 1) : r > -1 && (s = -1);
  }
  return r < 0 || t < 0 || // We saw a non-dot character immediately before the dot.
  s === 0 || // The (right-most) trimmed path component is exactly `..`.
  s === 1 && r === t - 1 && r === i + 1 ? "" : n.slice(r, t);
}
function l4(...n) {
  let e = -1, t;
  for (; ++e < n.length; )
    es(n[e]), n[e] && (t = t === void 0 ? n[e] : t + "/" + n[e]);
  return t === void 0 ? "." : a4(t);
}
function a4(n) {
  es(n);
  const e = n.codePointAt(0) === 47;
  let t = h4(n, !e);
  return t.length === 0 && !e && (t = "."), t.length > 0 && n.codePointAt(n.length - 1) === 47 && (t += "/"), e ? "/" + t : t;
}
function h4(n, e) {
  let t = "", i = 0, r = -1, s = 0, o = -1, l, a;
  for (; ++o <= n.length; ) {
    if (o < n.length)
      l = n.codePointAt(o);
    else {
      if (l === 47)
        break;
      l = 47;
    }
    if (l === 47) {
      if (!(r === o - 1 || s === 1))
        if (r !== o - 1 && s === 2) {
          if (t.length < 2 || i !== 2 || t.codePointAt(t.length - 1) !== 46 || t.codePointAt(t.length - 2) !== 46) {
            if (t.length > 2) {
              if (a = t.lastIndexOf("/"), a !== t.length - 1) {
                a < 0 ? (t = "", i = 0) : (t = t.slice(0, a), i = t.length - 1 - t.lastIndexOf("/")), r = o, s = 0;
                continue;
              }
            } else if (t.length > 0) {
              t = "", i = 0, r = o, s = 0;
              continue;
            }
          }
          e && (t = t.length > 0 ? t + "/.." : "..", i = 2);
        } else
          t.length > 0 ? t += "/" + n.slice(r + 1, o) : t = n.slice(r + 1, o), i = o - r - 1;
      r = o, s = 0;
    } else
      l === 46 && s > -1 ? s++ : s = -1;
  }
  return t;
}
function es(n) {
  if (typeof n != "string")
    throw new TypeError(
      "Path must be a string. Received " + JSON.stringify(n)
    );
}
const u4 = { cwd: c4 };
function c4() {
  return "/";
}
function Oh(n) {
  return !!(n !== null && typeof n == "object" && "href" in n && n.href && "protocol" in n && n.protocol && // @ts-expect-error: indexing is fine.
  n.auth === void 0);
}
function f4(n) {
  if (typeof n == "string")
    n = new URL(n);
  else if (!Oh(n)) {
    const e = new TypeError(
      'The "path" argument must be of type string or an instance of URL. Received `' + n + "`"
    );
    throw e.code = "ERR_INVALID_ARG_TYPE", e;
  }
  if (n.protocol !== "file:") {
    const e = new TypeError("The URL must be of scheme file");
    throw e.code = "ERR_INVALID_URL_SCHEME", e;
  }
  return d4(n);
}
function d4(n) {
  if (n.hostname !== "") {
    const i = new TypeError(
      'File URL host must be "localhost" or empty on darwin'
    );
    throw i.code = "ERR_INVALID_FILE_URL_HOST", i;
  }
  const e = n.pathname;
  let t = -1;
  for (; ++t < e.length; )
    if (e.codePointAt(t) === 37 && e.codePointAt(t + 1) === 50) {
      const i = e.codePointAt(t + 2);
      if (i === 70 || i === 102) {
        const r = new TypeError(
          "File URL path must not include encoded / characters"
        );
        throw r.code = "ERR_INVALID_FILE_URL_PATH", r;
      }
    }
  return decodeURIComponent(e);
}
const Ul = (
  /** @type {const} */
  [
    "history",
    "path",
    "basename",
    "stem",
    "extname",
    "dirname"
  ]
);
class p4 {
  /**
   * Create a new virtual file.
   *
   * `options` is treated as:
   *
   * *   `string` or `Uint8Array` — `{value: options}`
   * *   `URL` — `{path: options}`
   * *   `VFile` — shallow copies its data over to the new file
   * *   `object` — all fields are shallow copied over to the new file
   *
   * Path related fields are set in the following order (least specific to
   * most specific): `history`, `path`, `basename`, `stem`, `extname`,
   * `dirname`.
   *
   * You cannot set `dirname` or `extname` without setting either `history`,
   * `path`, `basename`, or `stem` too.
   *
   * @param {Compatible | null | undefined} [value]
   *   File value.
   * @returns
   *   New instance.
   */
  constructor(e) {
    let t;
    e ? Oh(e) ? t = { path: e } : typeof e == "string" || m4(e) ? t = { value: e } : t = e : t = {}, this.cwd = u4.cwd(), this.data = {}, this.history = [], this.messages = [], this.value, this.map, this.result, this.stored;
    let i = -1;
    for (; ++i < Ul.length; ) {
      const s = Ul[i];
      s in t && t[s] !== void 0 && t[s] !== null && (this[s] = s === "history" ? [...t[s]] : t[s]);
    }
    let r;
    for (r in t)
      Ul.includes(r) || (this[r] = t[r]);
  }
  /**
   * Get the basename (including extname) (example: `'index.min.js'`).
   *
   * @returns {string | undefined}
   *   Basename.
   */
  get basename() {
    return typeof this.path == "string" ? Wt.basename(this.path) : void 0;
  }
  /**
   * Set basename (including extname) (`'index.min.js'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be nullified (use `file.path = file.dirname` instead).
   *
   * @param {string} basename
   *   Basename.
   * @returns {undefined}
   *   Nothing.
   */
  set basename(e) {
    Gl(e, "basename"), Fl(e, "basename"), this.path = Wt.join(this.dirname || "", e);
  }
  /**
   * Get the parent path (example: `'~'`).
   *
   * @returns {string | undefined}
   *   Dirname.
   */
  get dirname() {
    return typeof this.path == "string" ? Wt.dirname(this.path) : void 0;
  }
  /**
   * Set the parent path (example: `'~'`).
   *
   * Cannot be set if there’s no `path` yet.
   *
   * @param {string | undefined} dirname
   *   Dirname.
   * @returns {undefined}
   *   Nothing.
   */
  set dirname(e) {
    Xd(this.basename, "dirname"), this.path = Wt.join(e || "", this.basename);
  }
  /**
   * Get the extname (including dot) (example: `'.js'`).
   *
   * @returns {string | undefined}
   *   Extname.
   */
  get extname() {
    return typeof this.path == "string" ? Wt.extname(this.path) : void 0;
  }
  /**
   * Set the extname (including dot) (example: `'.js'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be set if there’s no `path` yet.
   *
   * @param {string | undefined} extname
   *   Extname.
   * @returns {undefined}
   *   Nothing.
   */
  set extname(e) {
    if (Fl(e, "extname"), Xd(this.dirname, "extname"), e) {
      if (e.codePointAt(0) !== 46)
        throw new Error("`extname` must start with `.`");
      if (e.includes(".", 1))
        throw new Error("`extname` cannot contain multiple dots");
    }
    this.path = Wt.join(this.dirname, this.stem + (e || ""));
  }
  /**
   * Get the full path (example: `'~/index.min.js'`).
   *
   * @returns {string}
   *   Path.
   */
  get path() {
    return this.history[this.history.length - 1];
  }
  /**
   * Set the full path (example: `'~/index.min.js'`).
   *
   * Cannot be nullified.
   * You can set a file URL (a `URL` object with a `file:` protocol) which will
   * be turned into a path with `url.fileURLToPath`.
   *
   * @param {URL | string} path
   *   Path.
   * @returns {undefined}
   *   Nothing.
   */
  set path(e) {
    Oh(e) && (e = f4(e)), Gl(e, "path"), this.path !== e && this.history.push(e);
  }
  /**
   * Get the stem (basename w/o extname) (example: `'index.min'`).
   *
   * @returns {string | undefined}
   *   Stem.
   */
  get stem() {
    return typeof this.path == "string" ? Wt.basename(this.path, this.extname) : void 0;
  }
  /**
   * Set the stem (basename w/o extname) (example: `'index.min'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be nullified (use `file.path = file.dirname` instead).
   *
   * @param {string} stem
   *   Stem.
   * @returns {undefined}
   *   Nothing.
   */
  set stem(e) {
    Gl(e, "stem"), Fl(e, "stem"), this.path = Wt.join(this.dirname || "", e + (this.extname || ""));
  }
  // Normal prototypal methods.
  /**
   * Create a fatal message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `true` (error; file not usable)
   * and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {never}
   *   Never.
   * @throws {VFileMessage}
   *   Message.
   */
  fail(e, t, i) {
    const r = this.message(e, t, i);
    throw r.fatal = !0, r;
  }
  /**
   * Create an info message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `undefined` (info; change
   * likely not needed) and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {VFileMessage}
   *   Message.
   */
  info(e, t, i) {
    const r = this.message(e, t, i);
    return r.fatal = void 0, r;
  }
  /**
   * Create a message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `false` (warning; change may be
   * needed) and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {VFileMessage}
   *   Message.
   */
  message(e, t, i) {
    const r = new st(
      // @ts-expect-error: the overloads are fine.
      e,
      t,
      i
    );
    return this.path && (r.name = this.path + ":" + r.name, r.file = this.path), r.fatal = !1, this.messages.push(r), r;
  }
  /**
   * Serialize the file.
   *
   * > **Note**: which encodings are supported depends on the engine.
   * > For info on Node.js, see:
   * > <https://nodejs.org/api/util.html#whatwg-supported-encodings>.
   *
   * @param {string | null | undefined} [encoding='utf8']
   *   Character encoding to understand `value` as when it’s a `Uint8Array`
   *   (default: `'utf-8'`).
   * @returns {string}
   *   Serialized file.
   */
  toString(e) {
    return this.value === void 0 ? "" : typeof this.value == "string" ? this.value : new TextDecoder(e || void 0).decode(this.value);
  }
}
function Fl(n, e) {
  if (n && n.includes(Wt.sep))
    throw new Error(
      "`" + e + "` cannot be a path: did not expect `" + Wt.sep + "`"
    );
}
function Gl(n, e) {
  if (!n)
    throw new Error("`" + e + "` cannot be empty");
}
function Xd(n, e) {
  if (!n)
    throw new Error("Setting `" + e + "` requires `path` to be set too");
}
function m4(n) {
  return !!(n && typeof n == "object" && "byteLength" in n && "byteOffset" in n);
}
const O4 = (
  /**
   * @type {new <Parameters extends Array<unknown>, Result>(property: string | symbol) => (...parameters: Parameters) => Result}
   */
  /** @type {unknown} */
  /**
   * @this {Function}
   * @param {string | symbol} property
   * @returns {(...parameters: Array<unknown>) => unknown}
   */
  function(n) {
    const i = (
      /** @type {Record<string | symbol, Function>} */
      // Prototypes do exist.
      // type-coverage:ignore-next-line
      this.constructor.prototype
    ), r = i[n], s = function() {
      return r.apply(s, arguments);
    };
    Object.setPrototypeOf(s, i);
    const o = Object.getOwnPropertyNames(r);
    for (const l of o) {
      const a = Object.getOwnPropertyDescriptor(r, l);
      a && Object.defineProperty(s, l, a);
    }
    return s;
  }
), g4 = {}.hasOwnProperty;
class xu extends O4 {
  /**
   * Create a processor.
   */
  constructor() {
    super("copy"), this.Compiler = void 0, this.Parser = void 0, this.attachers = [], this.compiler = void 0, this.freezeIndex = -1, this.frozen = void 0, this.namespace = {}, this.parser = void 0, this.transformers = n4();
  }
  /**
   * Copy a processor.
   *
   * @deprecated
   *   This is a private internal method and should not be used.
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   New *unfrozen* processor ({@link Processor `Processor`}) that is
   *   configured to work the same as its ancestor.
   *   When the descendant processor is configured in the future it does not
   *   affect the ancestral processor.
   */
  copy() {
    const e = (
      /** @type {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>} */
      new xu()
    );
    let t = -1;
    for (; ++t < this.attachers.length; ) {
      const i = this.attachers[t];
      e.use(...i);
    }
    return e.data(Nl(!0, {}, this.namespace)), e;
  }
  /**
   * Configure the processor with info available to all plugins.
   * Information is stored in an object.
   *
   * Typically, options can be given to a specific plugin, but sometimes it
   * makes sense to have information shared with several plugins.
   * For example, a list of HTML elements that are self-closing, which is
   * needed during all phases.
   *
   * > 👉 **Note**: setting information cannot occur on *frozen* processors.
   * > Call the processor first to create a new unfrozen processor.
   *
   * > 👉 **Note**: to register custom data in TypeScript, augment the
   * > {@link Data `Data`} interface.
   *
   * @example
   *   This example show how to get and set info:
   *
   *   ```js
   *   import {unified} from 'unified'
   *
   *   const processor = unified().data('alpha', 'bravo')
   *
   *   processor.data('alpha') // => 'bravo'
   *
   *   processor.data() // => {alpha: 'bravo'}
   *
   *   processor.data({charlie: 'delta'})
   *
   *   processor.data() // => {charlie: 'delta'}
   *   ```
   *
   * @template {keyof Data} Key
   *
   * @overload
   * @returns {Data}
   *
   * @overload
   * @param {Data} dataset
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {Key} key
   * @returns {Data[Key]}
   *
   * @overload
   * @param {Key} key
   * @param {Data[Key]} value
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @param {Data | Key} [key]
   *   Key to get or set, or entire dataset to set, or nothing to get the
   *   entire dataset (optional).
   * @param {Data[Key]} [value]
   *   Value to set (optional).
   * @returns {unknown}
   *   The current processor when setting, the value at `key` when getting, or
   *   the entire dataset when getting without key.
   */
  data(e, t) {
    return typeof e == "string" ? arguments.length === 2 ? (Jl("data", this.frozen), this.namespace[e] = t, this) : g4.call(this.namespace, e) && this.namespace[e] || void 0 : e ? (Jl("data", this.frozen), this.namespace = e, this) : this.namespace;
  }
  /**
   * Freeze a processor.
   *
   * Frozen processors are meant to be extended and not to be configured
   * directly.
   *
   * When a processor is frozen it cannot be unfrozen.
   * New processors working the same way can be created by calling the
   * processor.
   *
   * It’s possible to freeze processors explicitly by calling `.freeze()`.
   * Processors freeze automatically when `.parse()`, `.run()`, `.runSync()`,
   * `.stringify()`, `.process()`, or `.processSync()` are called.
   *
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   The current processor.
   */
  freeze() {
    if (this.frozen)
      return this;
    const e = (
      /** @type {Processor} */
      /** @type {unknown} */
      this
    );
    for (; ++this.freezeIndex < this.attachers.length; ) {
      const [t, ...i] = this.attachers[this.freezeIndex];
      if (i[0] === !1)
        continue;
      i[0] === !0 && (i[0] = void 0);
      const r = t.call(e, ...i);
      typeof r == "function" && this.transformers.use(r);
    }
    return this.frozen = !0, this.freezeIndex = Number.POSITIVE_INFINITY, this;
  }
  /**
   * Parse text to a syntax tree.
   *
   * > 👉 **Note**: `parse` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `parse` performs the parse phase, not the run phase or other
   * > phases.
   *
   * @param {Compatible | undefined} [file]
   *   file to parse (optional); typically `string` or `VFile`; any value
   *   accepted as `x` in `new VFile(x)`.
   * @returns {ParseTree extends undefined ? Node : ParseTree}
   *   Syntax tree representing `file`.
   */
  parse(e) {
    this.freeze();
    const t = Ts(e), i = this.parser || this.Parser;
    return Hl("parse", i), i(String(t), t);
  }
  /**
   * Process the given file as configured on the processor.
   *
   * > 👉 **Note**: `process` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `process` performs the parse, run, and stringify phases.
   *
   * @overload
   * @param {Compatible | undefined} file
   * @param {ProcessCallback<VFileWithOutput<CompileResult>>} done
   * @returns {undefined}
   *
   * @overload
   * @param {Compatible | undefined} [file]
   * @returns {Promise<VFileWithOutput<CompileResult>>}
   *
   * @param {Compatible | undefined} [file]
   *   File (optional); typically `string` or `VFile`]; any value accepted as
   *   `x` in `new VFile(x)`.
   * @param {ProcessCallback<VFileWithOutput<CompileResult>> | undefined} [done]
   *   Callback (optional).
   * @returns {Promise<VFile> | undefined}
   *   Nothing if `done` is given.
   *   Otherwise a promise, rejected with a fatal error or resolved with the
   *   processed file.
   *
   *   The parsed, transformed, and compiled value is available at
   *   `file.value` (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most
   *   > compilers return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  process(e, t) {
    const i = this;
    return this.freeze(), Hl("process", this.parser || this.Parser), Kl("process", this.compiler || this.Compiler), t ? r(void 0, t) : new Promise(r);
    function r(s, o) {
      const l = Ts(e), a = (
        /** @type {HeadTree extends undefined ? Node : HeadTree} */
        /** @type {unknown} */
        i.parse(l)
      );
      i.run(a, l, function(u, c, f) {
        if (u || !c || !f)
          return h(u);
        const d = (
          /** @type {CompileTree extends undefined ? Node : CompileTree} */
          /** @type {unknown} */
          c
        ), p = i.stringify(d, f);
        k4(p) ? f.value = p : f.result = p, h(
          u,
          /** @type {VFileWithOutput<CompileResult>} */
          f
        );
      });
      function h(u, c) {
        u || !c ? o(u) : s ? s(c) : t(void 0, c);
      }
    }
  }
  /**
   * Process the given file as configured on the processor.
   *
   * An error is thrown if asynchronous transforms are configured.
   *
   * > 👉 **Note**: `processSync` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `processSync` performs the parse, run, and stringify phases.
   *
   * @param {Compatible | undefined} [file]
   *   File (optional); typically `string` or `VFile`; any value accepted as
   *   `x` in `new VFile(x)`.
   * @returns {VFileWithOutput<CompileResult>}
   *   The processed file.
   *
   *   The parsed, transformed, and compiled value is available at
   *   `file.value` (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most
   *   > compilers return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  processSync(e) {
    let t = !1, i;
    return this.freeze(), Hl("processSync", this.parser || this.Parser), Kl("processSync", this.compiler || this.Compiler), this.process(e, r), Ld("processSync", "process", t), i;
    function r(s, o) {
      t = !0, $d(s), i = o;
    }
  }
  /**
   * Run *transformers* on a syntax tree.
   *
   * > 👉 **Note**: `run` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `run` performs the run phase, not other phases.
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} done
   * @returns {undefined}
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {Compatible | undefined} file
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} done
   * @returns {undefined}
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {Compatible | undefined} [file]
   * @returns {Promise<TailTree extends undefined ? Node : TailTree>}
   *
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   *   Tree to transform and inspect.
   * @param {(
   *   RunCallback<TailTree extends undefined ? Node : TailTree> |
   *   Compatible
   * )} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} [done]
   *   Callback (optional).
   * @returns {Promise<TailTree extends undefined ? Node : TailTree> | undefined}
   *   Nothing if `done` is given.
   *   Otherwise, a promise rejected with a fatal error or resolved with the
   *   transformed tree.
   */
  run(e, t, i) {
    Dd(e), this.freeze();
    const r = this.transformers;
    return !i && typeof t == "function" && (i = t, t = void 0), i ? s(void 0, i) : new Promise(s);
    function s(o, l) {
      const a = Ts(t);
      r.run(e, a, h);
      function h(u, c, f) {
        const d = (
          /** @type {TailTree extends undefined ? Node : TailTree} */
          c || e
        );
        u ? l(u) : o ? o(d) : i(void 0, d, f);
      }
    }
  }
  /**
   * Run *transformers* on a syntax tree.
   *
   * An error is thrown if asynchronous transforms are configured.
   *
   * > 👉 **Note**: `runSync` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `runSync` performs the run phase, not other phases.
   *
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   *   Tree to transform and inspect.
   * @param {Compatible | undefined} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @returns {TailTree extends undefined ? Node : TailTree}
   *   Transformed tree.
   */
  runSync(e, t) {
    let i = !1, r;
    return this.run(e, t, s), Ld("runSync", "run", i), r;
    function s(o, l) {
      $d(o), r = l, i = !0;
    }
  }
  /**
   * Compile a syntax tree.
   *
   * > 👉 **Note**: `stringify` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `stringify` performs the stringify phase, not the run phase
   * > or other phases.
   *
   * @param {CompileTree extends undefined ? Node : CompileTree} tree
   *   Tree to compile.
   * @param {Compatible | undefined} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @returns {CompileResult extends undefined ? Value : CompileResult}
   *   Textual representation of the tree (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most compilers
   *   > return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  stringify(e, t) {
    this.freeze();
    const i = Ts(t), r = this.compiler || this.Compiler;
    return Kl("stringify", r), Dd(e), r(e, i);
  }
  /**
   * Configure the processor to use a plugin, a list of usable values, or a
   * preset.
   *
   * If the processor is already using a plugin, the previous plugin
   * configuration is changed based on the options that are passed in.
   * In other words, the plugin is not added a second time.
   *
   * > 👉 **Note**: `use` cannot be called on *frozen* processors.
   * > Call the processor first to create a new unfrozen processor.
   *
   * @example
   *   There are many ways to pass plugins to `.use()`.
   *   This example gives an overview:
   *
   *   ```js
   *   import {unified} from 'unified'
   *
   *   unified()
   *     // Plugin with options:
   *     .use(pluginA, {x: true, y: true})
   *     // Passing the same plugin again merges configuration (to `{x: true, y: false, z: true}`):
   *     .use(pluginA, {y: false, z: true})
   *     // Plugins:
   *     .use([pluginB, pluginC])
   *     // Two plugins, the second with options:
   *     .use([pluginD, [pluginE, {}]])
   *     // Preset with plugins and settings:
   *     .use({plugins: [pluginF, [pluginG, {}]], settings: {position: false}})
   *     // Settings only:
   *     .use({settings: {position: false}})
   *   ```
   *
   * @template {Array<unknown>} [Parameters=[]]
   * @template {Node | string | undefined} [Input=undefined]
   * @template [Output=Input]
   *
   * @overload
   * @param {Preset | null | undefined} [preset]
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {PluggableList} list
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {Plugin<Parameters, Input, Output>} plugin
   * @param {...(Parameters | [boolean])} parameters
   * @returns {UsePlugin<ParseTree, HeadTree, TailTree, CompileTree, CompileResult, Input, Output>}
   *
   * @param {PluggableList | Plugin | Preset | null | undefined} value
   *   Usable value.
   * @param {...unknown} parameters
   *   Parameters, when a plugin is given as a usable value.
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   Current processor.
   */
  use(e, ...t) {
    const i = this.attachers, r = this.namespace;
    if (Jl("use", this.frozen), e != null)
      if (typeof e == "function")
        a(e, t);
      else if (typeof e == "object")
        Array.isArray(e) ? l(e) : o(e);
      else
        throw new TypeError("Expected usable value, not `" + e + "`");
    return this;
    function s(h) {
      if (typeof h == "function")
        a(h, []);
      else if (typeof h == "object")
        if (Array.isArray(h)) {
          const [u, ...c] = (
            /** @type {PluginTuple<Array<unknown>>} */
            h
          );
          a(u, c);
        } else
          o(h);
      else
        throw new TypeError("Expected usable value, not `" + h + "`");
    }
    function o(h) {
      if (!("plugins" in h) && !("settings" in h))
        throw new Error(
          "Expected usable value but received an empty preset, which is probably a mistake: presets typically come with `plugins` and sometimes with `settings`, but this has neither"
        );
      l(h.plugins), h.settings && (r.settings = Nl(!0, r.settings, h.settings));
    }
    function l(h) {
      let u = -1;
      if (h != null)
        if (Array.isArray(h))
          for (; ++u < h.length; ) {
            const c = h[u];
            s(c);
          }
        else
          throw new TypeError("Expected a list of plugins, not `" + h + "`");
    }
    function a(h, u) {
      let c = -1, f = -1;
      for (; ++c < i.length; )
        if (i[c][0] === h) {
          f = c;
          break;
        }
      if (f === -1)
        i.push([h, ...u]);
      else if (u.length > 0) {
        let [d, ...p] = u;
        const m = i[f][1];
        ph(m) && ph(d) && (d = Nl(!0, m, d)), i[f] = [h, d, ...p];
      }
    }
  }
}
const b4 = new xu().freeze();
function Hl(n, e) {
  if (typeof e != "function")
    throw new TypeError("Cannot `" + n + "` without `parser`");
}
function Kl(n, e) {
  if (typeof e != "function")
    throw new TypeError("Cannot `" + n + "` without `compiler`");
}
function Jl(n, e) {
  if (e)
    throw new Error(
      "Cannot call `" + n + "` on a frozen processor.\nCreate a new processor first, by calling it: use `processor()` instead of `processor`."
    );
}
function Dd(n) {
  if (!ph(n) || typeof n.type != "string")
    throw new TypeError("Expected node, got `" + n + "`");
}
function Ld(n, e, t) {
  if (!t)
    throw new Error(
      "`" + n + "` finished async. Use `" + e + "` instead"
    );
}
function Ts(n) {
  return y4(n) ? n : new p4(n);
}
function y4(n) {
  return !!(n && typeof n == "object" && "message" in n && "messages" in n);
}
function k4(n) {
  return typeof n == "string" || x4(n);
}
function x4(n) {
  return !!(n && typeof n == "object" && "byteLength" in n && "byteOffset" in n);
}
const w4 = {
  tokenize: S4
};
function S4(n) {
  const e = n.attempt(
    this.parser.constructs.contentInitial,
    i,
    r
  );
  let t;
  return e;
  function i(l) {
    if (l === null) {
      n.consume(l);
      return;
    }
    return n.enter("lineEnding"), n.consume(l), n.exit("lineEnding"), re(n, e, "linePrefix");
  }
  function r(l) {
    return n.enter("paragraph"), s(l);
  }
  function s(l) {
    const a = n.enter("chunkText", {
      contentType: "text",
      previous: t
    });
    return t && (t.next = a), t = a, o(l);
  }
  function o(l) {
    if (l === null) {
      n.exit("chunkText"), n.exit("paragraph"), n.consume(l);
      return;
    }
    return N(l) ? (n.consume(l), n.exit("chunkText"), s) : (n.consume(l), o);
  }
}
const v4 = {
  tokenize: P4
}, Id = {
  tokenize: Q4
};
function P4(n) {
  const e = this, t = [];
  let i = 0, r, s, o;
  return l;
  function l(S) {
    if (i < t.length) {
      const Q = t[i];
      return e.containerState = Q[1], n.attempt(
        Q[0].continuation,
        a,
        h
      )(S);
    }
    return h(S);
  }
  function a(S) {
    if (i++, e.containerState._closeFlow) {
      e.containerState._closeFlow = void 0, r && b();
      const Q = e.events.length;
      let P = Q, w;
      for (; P--; )
        if (e.events[P][0] === "exit" && e.events[P][1].type === "chunkFlow") {
          w = e.events[P][1].end;
          break;
        }
      g(i);
      let C = Q;
      for (; C < e.events.length; )
        e.events[C][1].end = Object.assign({}, w), C++;
      return St(
        e.events,
        P + 1,
        0,
        e.events.slice(Q)
      ), e.events.length = C, h(S);
    }
    return l(S);
  }
  function h(S) {
    if (i === t.length) {
      if (!r)
        return f(S);
      if (r.currentConstruct && r.currentConstruct.concrete)
        return p(S);
      e.interrupt = !!(r.currentConstruct && !r._gfmTableDynamicInterruptHack);
    }
    return e.containerState = {}, n.check(
      Id,
      u,
      c
    )(S);
  }
  function u(S) {
    return r && b(), g(i), f(S);
  }
  function c(S) {
    return e.parser.lazy[e.now().line] = i !== t.length, o = e.now().offset, p(S);
  }
  function f(S) {
    return e.containerState = {}, n.attempt(
      Id,
      d,
      p
    )(S);
  }
  function d(S) {
    return i++, t.push([e.currentConstruct, e.containerState]), f(S);
  }
  function p(S) {
    if (S === null) {
      r && b(), g(0), n.consume(S);
      return;
    }
    return r = r || e.parser.flow(e.now()), n.enter("chunkFlow", {
      contentType: "flow",
      previous: s,
      _tokenizer: r
    }), m(S);
  }
  function m(S) {
    if (S === null) {
      O(n.exit("chunkFlow"), !0), g(0), n.consume(S);
      return;
    }
    return N(S) ? (n.consume(S), O(n.exit("chunkFlow")), i = 0, e.interrupt = void 0, l) : (n.consume(S), m);
  }
  function O(S, Q) {
    const P = e.sliceStream(S);
    if (Q && P.push(null), S.previous = s, s && (s.next = S), s = S, r.defineSkip(S.start), r.write(P), e.parser.lazy[S.start.line]) {
      let w = r.events.length;
      for (; w--; )
        if (
          // The token starts before the line ending…
          r.events[w][1].start.offset < o && // …and either is not ended yet…
          (!r.events[w][1].end || // …or ends after it.
          r.events[w][1].end.offset > o)
        )
          return;
      const C = e.events.length;
      let L = C, q, v;
      for (; L--; )
        if (e.events[L][0] === "exit" && e.events[L][1].type === "chunkFlow") {
          if (q) {
            v = e.events[L][1].end;
            break;
          }
          q = !0;
        }
      for (g(i), w = C; w < e.events.length; )
        e.events[w][1].end = Object.assign({}, v), w++;
      St(
        e.events,
        L + 1,
        0,
        e.events.slice(C)
      ), e.events.length = w;
    }
  }
  function g(S) {
    let Q = t.length;
    for (; Q-- > S; ) {
      const P = t[Q];
      e.containerState = P[1], P[0].exit.call(e, n);
    }
    t.length = S;
  }
  function b() {
    r.write([null]), s = void 0, r = void 0, e.containerState._closeFlow = void 0;
  }
}
function Q4(n, e, t) {
  return re(
    n,
    n.attempt(this.parser.constructs.document, e, t),
    "linePrefix",
    this.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
  );
}
const $4 = {
  tokenize: C4
};
function C4(n) {
  const e = this, t = n.attempt(
    // Try to parse a blank line.
    Jr,
    i,
    // Try to parse initial flow (essentially, only code).
    n.attempt(
      this.parser.constructs.flowInitial,
      r,
      re(
        n,
        n.attempt(
          this.parser.constructs.flow,
          r,
          n.attempt(vQ, r)
        ),
        "linePrefix"
      )
    )
  );
  return t;
  function i(s) {
    if (s === null) {
      n.consume(s);
      return;
    }
    return n.enter("lineEndingBlank"), n.consume(s), n.exit("lineEndingBlank"), e.currentConstruct = void 0, t;
  }
  function r(s) {
    if (s === null) {
      n.consume(s);
      return;
    }
    return n.enter("lineEnding"), n.consume(s), n.exit("lineEnding"), e.currentConstruct = void 0, t;
  }
}
const T4 = {
  resolveAll: e0()
}, A4 = J1("string"), R4 = J1("text");
function J1(n) {
  return {
    tokenize: e,
    resolveAll: e0(
      n === "text" ? Z4 : void 0
    )
  };
  function e(t) {
    const i = this, r = this.parser.constructs[n], s = t.attempt(r, o, l);
    return o;
    function o(u) {
      return h(u) ? s(u) : l(u);
    }
    function l(u) {
      if (u === null) {
        t.consume(u);
        return;
      }
      return t.enter("data"), t.consume(u), a;
    }
    function a(u) {
      return h(u) ? (t.exit("data"), s(u)) : (t.consume(u), a);
    }
    function h(u) {
      if (u === null)
        return !0;
      const c = r[u];
      let f = -1;
      if (c)
        for (; ++f < c.length; ) {
          const d = c[f];
          if (!d.previous || d.previous.call(i, i.previous))
            return !0;
        }
      return !1;
    }
  }
}
function e0(n) {
  return e;
  function e(t, i) {
    let r = -1, s;
    for (; ++r <= t.length; )
      s === void 0 ? t[r] && t[r][1].type === "data" && (s = r, r++) : (!t[r] || t[r][1].type !== "data") && (r !== s + 2 && (t[s][1].end = t[r - 1][1].end, t.splice(s + 2, r - s - 2), r = s + 2), s = void 0);
    return n ? n(t, i) : t;
  }
}
function Z4(n, e) {
  let t = 0;
  for (; ++t <= n.length; )
    if ((t === n.length || n[t][1].type === "lineEnding") && n[t - 1][1].type === "data") {
      const i = n[t - 1][1], r = e.sliceStream(i);
      let s = r.length, o = -1, l = 0, a;
      for (; s--; ) {
        const h = r[s];
        if (typeof h == "string") {
          for (o = h.length; h.charCodeAt(o - 1) === 32; )
            l++, o--;
          if (o)
            break;
          o = -1;
        } else if (h === -2)
          a = !0, l++;
        else if (h !== -1) {
          s++;
          break;
        }
      }
      if (l) {
        const h = {
          type: t === n.length || a || l < 2 ? "lineSuffix" : "hardBreakTrailing",
          start: {
            line: i.end.line,
            column: i.end.column - l,
            offset: i.end.offset - l,
            _index: i.start._index + s,
            _bufferIndex: s ? o : i.start._bufferIndex + o
          },
          end: Object.assign({}, i.end)
        };
        i.end = Object.assign({}, h.start), i.start.offset === i.end.offset ? Object.assign(i, h) : (n.splice(
          t,
          0,
          ["enter", h, e],
          ["exit", h, e]
        ), t += 2);
      }
      t++;
    }
  return n;
}
function M4(n, e, t) {
  let i = Object.assign(
    t ? Object.assign({}, t) : {
      line: 1,
      column: 1,
      offset: 0
    },
    {
      _index: 0,
      _bufferIndex: -1
    }
  );
  const r = {}, s = [];
  let o = [], l = [];
  const a = {
    consume: b,
    enter: S,
    exit: Q,
    attempt: C(P),
    check: C(w),
    interrupt: C(w, {
      interrupt: !0
    })
  }, h = {
    previous: null,
    code: null,
    containerState: {},
    events: [],
    parser: n,
    sliceStream: d,
    sliceSerialize: f,
    now: p,
    defineSkip: m,
    write: c
  };
  let u = e.tokenize.call(h, a);
  return e.resolveAll && s.push(e), h;
  function c(R) {
    return o = gt(o, R), O(), o[o.length - 1] !== null ? [] : (L(e, 0), h.events = Ko(s, h.events, h), h.events);
  }
  function f(R, A) {
    return z4(d(R), A);
  }
  function d(R) {
    return E4(o, R);
  }
  function p() {
    const { line: R, column: A, offset: E, _index: W, _bufferIndex: _ } = i;
    return {
      line: R,
      column: A,
      offset: E,
      _index: W,
      _bufferIndex: _
    };
  }
  function m(R) {
    r[R.line] = R.column, v();
  }
  function O() {
    let R;
    for (; i._index < o.length; ) {
      const A = o[i._index];
      if (typeof A == "string")
        for (R = i._index, i._bufferIndex < 0 && (i._bufferIndex = 0); i._index === R && i._bufferIndex < A.length; )
          g(A.charCodeAt(i._bufferIndex));
      else
        g(A);
    }
  }
  function g(R) {
    u = u(R);
  }
  function b(R) {
    N(R) ? (i.line++, i.column = 1, i.offset += R === -3 ? 2 : 1, v()) : R !== -1 && (i.column++, i.offset++), i._bufferIndex < 0 ? i._index++ : (i._bufferIndex++, i._bufferIndex === o[i._index].length && (i._bufferIndex = -1, i._index++)), h.previous = R;
  }
  function S(R, A) {
    const E = A || {};
    return E.type = R, E.start = p(), h.events.push(["enter", E, h]), l.push(E), E;
  }
  function Q(R) {
    const A = l.pop();
    return A.end = p(), h.events.push(["exit", A, h]), A;
  }
  function P(R, A) {
    L(R, A.from);
  }
  function w(R, A) {
    A.restore();
  }
  function C(R, A) {
    return E;
    function E(W, _, G) {
      let U, se, ce, y;
      return Array.isArray(W) ? ke(W) : "tokenize" in W ? (
        // @ts-expect-error Looks like a construct.
        ke([W])
      ) : he(W);
      function he(Ce) {
        return Vi;
        function Vi(dn) {
          const ni = dn !== null && Ce[dn], zn = dn !== null && Ce.null, nl = [
            // To do: add more extension tests.
            /* c8 ignore next 2 */
            ...Array.isArray(ni) ? ni : ni ? [ni] : [],
            ...Array.isArray(zn) ? zn : zn ? [zn] : []
          ];
          return ke(nl)(dn);
        }
      }
      function ke(Ce) {
        return U = Ce, se = 0, Ce.length === 0 ? G : x(Ce[se]);
      }
      function x(Ce) {
        return Vi;
        function Vi(dn) {
          return y = q(), ce = Ce, Ce.partial || (h.currentConstruct = Ce), Ce.name && h.parser.constructs.disable.null.includes(Ce.name) ? pt() : Ce.tokenize.call(
            // If we do have fields, create an object w/ `context` as its
            // prototype.
            // This allows a “live binding”, which is needed for `interrupt`.
            A ? Object.assign(Object.create(h), A) : h,
            a,
            $e,
            pt
          )(dn);
        }
      }
      function $e(Ce) {
        return R(ce, y), _;
      }
      function pt(Ce) {
        return y.restore(), ++se < U.length ? x(U[se]) : G;
      }
    }
  }
  function L(R, A) {
    R.resolveAll && !s.includes(R) && s.push(R), R.resolve && St(
      h.events,
      A,
      h.events.length - A,
      R.resolve(h.events.slice(A), h)
    ), R.resolveTo && (h.events = R.resolveTo(h.events, h));
  }
  function q() {
    const R = p(), A = h.previous, E = h.currentConstruct, W = h.events.length, _ = Array.from(l);
    return {
      restore: G,
      from: W
    };
    function G() {
      i = R, h.previous = A, h.currentConstruct = E, h.events.length = W, l = _, v();
    }
  }
  function v() {
    i.line in r && i.column < 2 && (i.column = r[i.line], i.offset += r[i.line] - 1);
  }
}
function E4(n, e) {
  const t = e.start._index, i = e.start._bufferIndex, r = e.end._index, s = e.end._bufferIndex;
  let o;
  if (t === r)
    o = [n[t].slice(i, s)];
  else {
    if (o = n.slice(t, r), i > -1) {
      const l = o[0];
      typeof l == "string" ? o[0] = l.slice(i) : o.shift();
    }
    s > 0 && o.push(n[r].slice(0, s));
  }
  return o;
}
function z4(n, e) {
  let t = -1;
  const i = [];
  let r;
  for (; ++t < n.length; ) {
    const s = n[t];
    let o;
    if (typeof s == "string")
      o = s;
    else
      switch (s) {
        case -5: {
          o = "\r";
          break;
        }
        case -4: {
          o = `
`;
          break;
        }
        case -3: {
          o = `\r
`;
          break;
        }
        case -2: {
          o = e ? " " : "	";
          break;
        }
        case -1: {
          if (!e && r)
            continue;
          o = " ";
          break;
        }
        default:
          o = String.fromCharCode(s);
      }
    r = s === -2, i.push(o);
  }
  return i.join("");
}
const X4 = {
  42: et,
  43: et,
  45: et,
  48: et,
  49: et,
  50: et,
  51: et,
  52: et,
  53: et,
  54: et,
  55: et,
  56: et,
  57: et,
  62: Dg
}, D4 = {
  91: TQ
}, L4 = {
  [-2]: Rl,
  [-1]: Rl,
  32: Rl
}, I4 = {
  35: zQ,
  42: Ys,
  45: [If, Ys],
  60: IQ,
  61: If,
  95: Ys,
  96: Df,
  126: Df
}, _4 = {
  38: Ig,
  92: Lg
}, q4 = {
  [-5]: Zl,
  [-4]: Zl,
  [-3]: Zl,
  33: i$,
  38: Ig,
  42: nh,
  60: [sQ, jQ],
  91: s$,
  92: [MQ, Lg],
  93: uu,
  95: nh,
  96: bQ
}, W4 = {
  null: [nh, T4]
}, B4 = {
  null: [42, 95]
}, V4 = {
  null: []
}, Y4 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  attentionMarkers: B4,
  contentInitial: D4,
  disable: V4,
  document: X4,
  flow: I4,
  flowInitial: L4,
  insideSpan: W4,
  string: _4,
  text: q4
}, Symbol.toStringTag, { value: "Module" }));
function j4(n) {
  const t = (
    /** @type {FullNormalizedExtension} */
    Cg([Y4, ...(n || {}).extensions || []])
  ), i = {
    defined: [],
    lazy: {},
    constructs: t,
    content: r(w4),
    document: r(v4),
    flow: r($4),
    string: r(A4),
    text: r(R4)
  };
  return i;
  function r(s) {
    return o;
    function o(l) {
      return M4(i, s, l);
    }
  }
}
function N4(n) {
  for (; !_g(n); )
    ;
  return n;
}
const _d = /[\0\t\n\r]/g;
function U4() {
  let n = 1, e = "", t = !0, i;
  return r;
  function r(s, o, l) {
    const a = [];
    let h, u, c, f, d;
    for (s = e + (typeof s == "string" ? s.toString() : new TextDecoder(o || void 0).decode(s)), c = 0, e = "", t && (s.charCodeAt(0) === 65279 && c++, t = void 0); c < s.length; ) {
      if (_d.lastIndex = c, h = _d.exec(s), f = h && h.index !== void 0 ? h.index : s.length, d = s.charCodeAt(f), !h) {
        e = s.slice(c);
        break;
      }
      if (d === 10 && c === f && i)
        a.push(-3), i = void 0;
      else
        switch (i && (a.push(-5), i = void 0), c < f && (a.push(s.slice(c, f)), n += f - c), d) {
          case 0: {
            a.push(65533), n++;
            break;
          }
          case 9: {
            for (u = Math.ceil(n / 4) * 4, a.push(-2); n++ < u; )
              a.push(-1);
            break;
          }
          case 10: {
            a.push(-4), n = 1;
            break;
          }
          default:
            i = !0, n = 1;
        }
      c = f + 1;
    }
    return l && (i && a.push(-5), e && a.push(e), a.push(null)), a;
  }
}
const t0 = {}.hasOwnProperty;
function F4(n, e, t) {
  return typeof e != "string" && (t = e, e = void 0), G4(t)(
    N4(
      j4(t).document().write(U4()(n, e, !0))
    )
  );
}
function G4(n) {
  const e = {
    transforms: [],
    canContainEols: ["emphasis", "fragment", "heading", "paragraph", "strong"],
    enter: {
      autolink: s(Zu),
      autolinkProtocol: q,
      autolinkEmail: q,
      atxHeading: s(Tu),
      blockQuote: s(ni),
      characterEscape: q,
      characterReference: q,
      codeFenced: s(zn),
      codeFencedFenceInfo: o,
      codeFencedFenceMeta: o,
      codeIndented: s(zn, o),
      codeText: s(nl, o),
      codeTextData: q,
      data: q,
      codeFlowValue: q,
      definition: s(C0),
      definitionDestinationString: o,
      definitionLabelString: o,
      definitionTitleString: o,
      emphasis: s(T0),
      hardBreakEscape: s(Au),
      hardBreakTrailing: s(Au),
      htmlFlow: s(Ru, o),
      htmlFlowData: q,
      htmlText: s(Ru, o),
      htmlTextData: q,
      image: s(A0),
      label: o,
      link: s(Zu),
      listItem: s(R0),
      listItemValue: f,
      listOrdered: s(Mu, c),
      listUnordered: s(Mu),
      paragraph: s(Z0),
      reference: x,
      referenceString: o,
      resourceDestinationString: o,
      resourceTitleString: o,
      setextHeading: s(Tu),
      strong: s(M0),
      thematicBreak: s(z0)
    },
    exit: {
      atxHeading: a(),
      atxHeadingSequence: P,
      autolink: a(),
      autolinkEmail: dn,
      autolinkProtocol: Vi,
      blockQuote: a(),
      characterEscapeValue: v,
      characterReferenceMarkerHexadecimal: pt,
      characterReferenceMarkerNumeric: pt,
      characterReferenceValue: Ce,
      codeFenced: a(O),
      codeFencedFence: m,
      codeFencedFenceInfo: d,
      codeFencedFenceMeta: p,
      codeFlowValue: v,
      codeIndented: a(g),
      codeText: a(_),
      codeTextData: v,
      data: v,
      definition: a(),
      definitionDestinationString: Q,
      definitionLabelString: b,
      definitionTitleString: S,
      emphasis: a(),
      hardBreakEscape: a(A),
      hardBreakTrailing: a(A),
      htmlFlow: a(E),
      htmlFlowData: v,
      htmlText: a(W),
      htmlTextData: v,
      image: a(U),
      label: ce,
      labelText: se,
      lineEnding: R,
      link: a(G),
      listItem: a(),
      listOrdered: a(),
      listUnordered: a(),
      paragraph: a(),
      referenceString: $e,
      resourceDestinationString: y,
      resourceTitleString: he,
      resource: ke,
      setextHeading: a(L),
      setextHeadingLineSequence: C,
      setextHeadingText: w,
      strong: a(),
      thematicBreak: a()
    }
  };
  n0(e, (n || {}).mdastExtensions || []);
  const t = {};
  return i;
  function i(T) {
    let X = {
      type: "root",
      children: []
    };
    const H = {
      stack: [X],
      tokenStack: [],
      config: e,
      enter: l,
      exit: h,
      buffer: o,
      resume: u,
      data: t
    }, ne = [];
    let ue = -1;
    for (; ++ue < T.length; )
      if (T[ue][1].type === "listOrdered" || T[ue][1].type === "listUnordered")
        if (T[ue][0] === "enter")
          ne.push(ue);
        else {
          const Tt = ne.pop();
          ue = r(T, Tt, ue);
        }
    for (ue = -1; ++ue < T.length; ) {
      const Tt = e[T[ue][0]];
      t0.call(Tt, T[ue][1].type) && Tt[T[ue][1].type].call(
        Object.assign(
          {
            sliceSerialize: T[ue][2].sliceSerialize
          },
          H
        ),
        T[ue][1]
      );
    }
    if (H.tokenStack.length > 0) {
      const Tt = H.tokenStack[H.tokenStack.length - 1];
      (Tt[1] || qd).call(H, void 0, Tt[0]);
    }
    for (X.position = {
      start: mn(
        T.length > 0 ? T[0][1].start : {
          line: 1,
          column: 1,
          offset: 0
        }
      ),
      end: mn(
        T.length > 0 ? T[T.length - 2][1].end : {
          line: 1,
          column: 1,
          offset: 0
        }
      )
    }, ue = -1; ++ue < e.transforms.length; )
      X = e.transforms[ue](X) || X;
    return X;
  }
  function r(T, X, H) {
    let ne = X - 1, ue = -1, Tt = !1, Xn, tn, Yi, ji;
    for (; ++ne <= H; ) {
      const ot = T[ne];
      switch (ot[1].type) {
        case "listUnordered":
        case "listOrdered":
        case "blockQuote": {
          ot[0] === "enter" ? ue++ : ue--, ji = void 0;
          break;
        }
        case "lineEndingBlank": {
          ot[0] === "enter" && (Xn && !ji && !ue && !Yi && (Yi = ne), ji = void 0);
          break;
        }
        case "linePrefix":
        case "listItemValue":
        case "listItemMarker":
        case "listItemPrefix":
        case "listItemPrefixWhitespace":
          break;
        default:
          ji = void 0;
      }
      if (!ue && ot[0] === "enter" && ot[1].type === "listItemPrefix" || ue === -1 && ot[0] === "exit" && (ot[1].type === "listUnordered" || ot[1].type === "listOrdered")) {
        if (Xn) {
          let ii = ne;
          for (tn = void 0; ii--; ) {
            const nn = T[ii];
            if (nn[1].type === "lineEnding" || nn[1].type === "lineEndingBlank") {
              if (nn[0] === "exit")
                continue;
              tn && (T[tn][1].type = "lineEndingBlank", Tt = !0), nn[1].type = "lineEnding", tn = ii;
            } else if (!(nn[1].type === "linePrefix" || nn[1].type === "blockQuotePrefix" || nn[1].type === "blockQuotePrefixWhitespace" || nn[1].type === "blockQuoteMarker" || nn[1].type === "listItemIndent"))
              break;
          }
          Yi && (!tn || Yi < tn) && (Xn._spread = !0), Xn.end = Object.assign(
            {},
            tn ? T[tn][1].start : ot[1].end
          ), T.splice(tn || ne, 0, ["exit", Xn, ot[2]]), ne++, H++;
        }
        if (ot[1].type === "listItemPrefix") {
          const ii = {
            type: "listItem",
            _spread: !1,
            start: Object.assign({}, ot[1].start),
            // @ts-expect-error: we’ll add `end` in a second.
            end: void 0
          };
          Xn = ii, T.splice(ne, 0, ["enter", ii, ot[2]]), ne++, H++, Yi = void 0, ji = !0;
        }
      }
    }
    return T[X][1]._spread = Tt, H;
  }
  function s(T, X) {
    return H;
    function H(ne) {
      l.call(this, T(ne), ne), X && X.call(this, ne);
    }
  }
  function o() {
    this.stack.push({
      type: "fragment",
      children: []
    });
  }
  function l(T, X, H) {
    this.stack[this.stack.length - 1].children.push(T), this.stack.push(T), this.tokenStack.push([X, H]), T.position = {
      start: mn(X.start),
      // @ts-expect-error: `end` will be patched later.
      end: void 0
    };
  }
  function a(T) {
    return X;
    function X(H) {
      T && T.call(this, H), h.call(this, H);
    }
  }
  function h(T, X) {
    const H = this.stack.pop(), ne = this.tokenStack.pop();
    if (ne)
      ne[0].type !== T.type && (X ? X.call(this, T, ne[0]) : (ne[1] || qd).call(this, T, ne[0]));
    else
      throw new Error(
        "Cannot close `" + T.type + "` (" + kr({
          start: T.start,
          end: T.end
        }) + "): it’s not open"
      );
    H.position.end = mn(T.end);
  }
  function u() {
    return ou(this.stack.pop());
  }
  function c() {
    this.data.expectingFirstListItemValue = !0;
  }
  function f(T) {
    if (this.data.expectingFirstListItemValue) {
      const X = this.stack[this.stack.length - 2];
      X.start = Number.parseInt(this.sliceSerialize(T), 10), this.data.expectingFirstListItemValue = void 0;
    }
  }
  function d() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.lang = T;
  }
  function p() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.meta = T;
  }
  function m() {
    this.data.flowCodeInside || (this.buffer(), this.data.flowCodeInside = !0);
  }
  function O() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.value = T.replace(/^(\r?\n|\r)|(\r?\n|\r)$/g, ""), this.data.flowCodeInside = void 0;
  }
  function g() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.value = T.replace(/(\r?\n|\r)$/g, "");
  }
  function b(T) {
    const X = this.resume(), H = this.stack[this.stack.length - 1];
    H.label = X, H.identifier = Zt(
      this.sliceSerialize(T)
    ).toLowerCase();
  }
  function S() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.title = T;
  }
  function Q() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.url = T;
  }
  function P(T) {
    const X = this.stack[this.stack.length - 1];
    if (!X.depth) {
      const H = this.sliceSerialize(T).length;
      X.depth = H;
    }
  }
  function w() {
    this.data.setextHeadingSlurpLineEnding = !0;
  }
  function C(T) {
    const X = this.stack[this.stack.length - 1];
    X.depth = this.sliceSerialize(T).codePointAt(0) === 61 ? 1 : 2;
  }
  function L() {
    this.data.setextHeadingSlurpLineEnding = void 0;
  }
  function q(T) {
    const H = this.stack[this.stack.length - 1].children;
    let ne = H[H.length - 1];
    (!ne || ne.type !== "text") && (ne = E0(), ne.position = {
      start: mn(T.start),
      // @ts-expect-error: we’ll add `end` later.
      end: void 0
    }, H.push(ne)), this.stack.push(ne);
  }
  function v(T) {
    const X = this.stack.pop();
    X.value += this.sliceSerialize(T), X.position.end = mn(T.end);
  }
  function R(T) {
    const X = this.stack[this.stack.length - 1];
    if (this.data.atHardBreak) {
      const H = X.children[X.children.length - 1];
      H.position.end = mn(T.end), this.data.atHardBreak = void 0;
      return;
    }
    !this.data.setextHeadingSlurpLineEnding && e.canContainEols.includes(X.type) && (q.call(this, T), v.call(this, T));
  }
  function A() {
    this.data.atHardBreak = !0;
  }
  function E() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.value = T;
  }
  function W() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.value = T;
  }
  function _() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.value = T;
  }
  function G() {
    const T = this.stack[this.stack.length - 1];
    if (this.data.inReference) {
      const X = this.data.referenceType || "shortcut";
      T.type += "Reference", T.referenceType = X, delete T.url, delete T.title;
    } else
      delete T.identifier, delete T.label;
    this.data.referenceType = void 0;
  }
  function U() {
    const T = this.stack[this.stack.length - 1];
    if (this.data.inReference) {
      const X = this.data.referenceType || "shortcut";
      T.type += "Reference", T.referenceType = X, delete T.url, delete T.title;
    } else
      delete T.identifier, delete T.label;
    this.data.referenceType = void 0;
  }
  function se(T) {
    const X = this.sliceSerialize(T), H = this.stack[this.stack.length - 2];
    H.label = TP(X), H.identifier = Zt(X).toLowerCase();
  }
  function ce() {
    const T = this.stack[this.stack.length - 1], X = this.resume(), H = this.stack[this.stack.length - 1];
    if (this.data.inReference = !0, H.type === "link") {
      const ne = T.children;
      H.children = ne;
    } else
      H.alt = X;
  }
  function y() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.url = T;
  }
  function he() {
    const T = this.resume(), X = this.stack[this.stack.length - 1];
    X.title = T;
  }
  function ke() {
    this.data.inReference = void 0;
  }
  function x() {
    this.data.referenceType = "collapsed";
  }
  function $e(T) {
    const X = this.resume(), H = this.stack[this.stack.length - 1];
    H.label = X, H.identifier = Zt(
      this.sliceSerialize(T)
    ).toLowerCase(), this.data.referenceType = "full";
  }
  function pt(T) {
    this.data.characterReferenceType = T.type;
  }
  function Ce(T) {
    const X = this.sliceSerialize(T), H = this.data.characterReferenceType;
    let ne;
    H ? (ne = $g(
      X,
      H === "characterReferenceMarkerNumeric" ? 10 : 16
    ), this.data.characterReferenceType = void 0) : ne = au(X);
    const ue = this.stack.pop();
    ue.value += ne, ue.position.end = mn(T.end);
  }
  function Vi(T) {
    v.call(this, T);
    const X = this.stack[this.stack.length - 1];
    X.url = this.sliceSerialize(T);
  }
  function dn(T) {
    v.call(this, T);
    const X = this.stack[this.stack.length - 1];
    X.url = "mailto:" + this.sliceSerialize(T);
  }
  function ni() {
    return {
      type: "blockquote",
      children: []
    };
  }
  function zn() {
    return {
      type: "code",
      lang: null,
      meta: null,
      value: ""
    };
  }
  function nl() {
    return {
      type: "inlineCode",
      value: ""
    };
  }
  function C0() {
    return {
      type: "definition",
      identifier: "",
      label: null,
      title: null,
      url: ""
    };
  }
  function T0() {
    return {
      type: "emphasis",
      children: []
    };
  }
  function Tu() {
    return {
      type: "heading",
      // @ts-expect-error `depth` will be set later.
      depth: 0,
      children: []
    };
  }
  function Au() {
    return {
      type: "break"
    };
  }
  function Ru() {
    return {
      type: "html",
      value: ""
    };
  }
  function A0() {
    return {
      type: "image",
      title: null,
      url: "",
      alt: null
    };
  }
  function Zu() {
    return {
      type: "link",
      title: null,
      url: "",
      children: []
    };
  }
  function Mu(T) {
    return {
      type: "list",
      ordered: T.type === "listOrdered",
      start: null,
      spread: T._spread,
      children: []
    };
  }
  function R0(T) {
    return {
      type: "listItem",
      spread: T._spread,
      checked: null,
      children: []
    };
  }
  function Z0() {
    return {
      type: "paragraph",
      children: []
    };
  }
  function M0() {
    return {
      type: "strong",
      children: []
    };
  }
  function E0() {
    return {
      type: "text",
      value: ""
    };
  }
  function z0() {
    return {
      type: "thematicBreak"
    };
  }
}
function mn(n) {
  return {
    line: n.line,
    column: n.column,
    offset: n.offset
  };
}
function n0(n, e) {
  let t = -1;
  for (; ++t < e.length; ) {
    const i = e[t];
    Array.isArray(i) ? n0(n, i) : H4(n, i);
  }
}
function H4(n, e) {
  let t;
  for (t in e)
    if (t0.call(e, t))
      switch (t) {
        case "canContainEols": {
          const i = e[t];
          i && n[t].push(...i);
          break;
        }
        case "transforms": {
          const i = e[t];
          i && n[t].push(...i);
          break;
        }
        case "enter":
        case "exit": {
          const i = e[t];
          i && Object.assign(n[t], i);
          break;
        }
      }
}
function qd(n, e) {
  throw n ? new Error(
    "Cannot close `" + n.type + "` (" + kr({
      start: n.start,
      end: n.end
    }) + "): a different token (`" + e.type + "`, " + kr({
      start: e.start,
      end: e.end
    }) + ") is open"
  ) : new Error(
    "Cannot close document, a token (`" + e.type + "`, " + kr({
      start: e.start,
      end: e.end
    }) + ") is still open"
  );
}
function K4(n) {
  const e = this;
  e.parser = t;
  function t(i) {
    return F4(i, {
      ...e.data("settings"),
      ...n,
      // Note: these options are not in the readme.
      // The goal is for them to be set by plugins on `data` instead of being
      // passed by users.
      extensions: e.data("micromarkExtensions") || [],
      mdastExtensions: e.data("fromMarkdownExtensions") || []
    });
  }
}
function J4(n, e) {
  const t = {
    type: "element",
    tagName: "blockquote",
    properties: {},
    children: n.wrap(n.all(e), !0)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function eA(n, e) {
  const t = { type: "element", tagName: "br", properties: {}, children: [] };
  return n.patch(e, t), [n.applyData(e, t), { type: "text", value: `
` }];
}
function tA(n, e) {
  const t = e.value ? e.value + `
` : "", i = {};
  e.lang && (i.className = ["language-" + e.lang]);
  let r = {
    type: "element",
    tagName: "code",
    properties: i,
    children: [{ type: "text", value: t }]
  };
  return e.meta && (r.data = { meta: e.meta }), n.patch(e, r), r = n.applyData(e, r), r = { type: "element", tagName: "pre", properties: {}, children: [r] }, n.patch(e, r), r;
}
function nA(n, e) {
  const t = {
    type: "element",
    tagName: "del",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function iA(n, e) {
  const t = {
    type: "element",
    tagName: "em",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function rA(n, e) {
  const t = typeof n.options.clobberPrefix == "string" ? n.options.clobberPrefix : "user-content-", i = String(e.identifier).toUpperCase(), r = Wi(i.toLowerCase()), s = n.footnoteOrder.indexOf(i);
  let o, l = n.footnoteCounts.get(i);
  l === void 0 ? (l = 0, n.footnoteOrder.push(i), o = n.footnoteOrder.length) : o = s + 1, l += 1, n.footnoteCounts.set(i, l);
  const a = {
    type: "element",
    tagName: "a",
    properties: {
      href: "#" + t + "fn-" + r,
      id: t + "fnref-" + r + (l > 1 ? "-" + l : ""),
      dataFootnoteRef: !0,
      ariaDescribedBy: ["footnote-label"]
    },
    children: [{ type: "text", value: String(o) }]
  };
  n.patch(e, a);
  const h = {
    type: "element",
    tagName: "sup",
    properties: {},
    children: [a]
  };
  return n.patch(e, h), n.applyData(e, h);
}
function sA(n, e) {
  const t = {
    type: "element",
    tagName: "h" + e.depth,
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function oA(n, e) {
  if (n.options.allowDangerousHtml) {
    const t = { type: "raw", value: e.value };
    return n.patch(e, t), n.applyData(e, t);
  }
}
function i0(n, e) {
  const t = e.referenceType;
  let i = "]";
  if (t === "collapsed" ? i += "[]" : t === "full" && (i += "[" + (e.label || e.identifier) + "]"), e.type === "imageReference")
    return [{ type: "text", value: "![" + e.alt + i }];
  const r = n.all(e), s = r[0];
  s && s.type === "text" ? s.value = "[" + s.value : r.unshift({ type: "text", value: "[" });
  const o = r[r.length - 1];
  return o && o.type === "text" ? o.value += i : r.push({ type: "text", value: i }), r;
}
function lA(n, e) {
  const t = String(e.identifier).toUpperCase(), i = n.definitionById.get(t);
  if (!i)
    return i0(n, e);
  const r = { src: Wi(i.url || ""), alt: e.alt };
  i.title !== null && i.title !== void 0 && (r.title = i.title);
  const s = { type: "element", tagName: "img", properties: r, children: [] };
  return n.patch(e, s), n.applyData(e, s);
}
function aA(n, e) {
  const t = { src: Wi(e.url) };
  e.alt !== null && e.alt !== void 0 && (t.alt = e.alt), e.title !== null && e.title !== void 0 && (t.title = e.title);
  const i = { type: "element", tagName: "img", properties: t, children: [] };
  return n.patch(e, i), n.applyData(e, i);
}
function hA(n, e) {
  const t = { type: "text", value: e.value.replace(/\r?\n|\r/g, " ") };
  n.patch(e, t);
  const i = {
    type: "element",
    tagName: "code",
    properties: {},
    children: [t]
  };
  return n.patch(e, i), n.applyData(e, i);
}
function uA(n, e) {
  const t = String(e.identifier).toUpperCase(), i = n.definitionById.get(t);
  if (!i)
    return i0(n, e);
  const r = { href: Wi(i.url || "") };
  i.title !== null && i.title !== void 0 && (r.title = i.title);
  const s = {
    type: "element",
    tagName: "a",
    properties: r,
    children: n.all(e)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function cA(n, e) {
  const t = { href: Wi(e.url) };
  e.title !== null && e.title !== void 0 && (t.title = e.title);
  const i = {
    type: "element",
    tagName: "a",
    properties: t,
    children: n.all(e)
  };
  return n.patch(e, i), n.applyData(e, i);
}
function fA(n, e, t) {
  const i = n.all(e), r = t ? dA(t) : r0(e), s = {}, o = [];
  if (typeof e.checked == "boolean") {
    const u = i[0];
    let c;
    u && u.type === "element" && u.tagName === "p" ? c = u : (c = { type: "element", tagName: "p", properties: {}, children: [] }, i.unshift(c)), c.children.length > 0 && c.children.unshift({ type: "text", value: " " }), c.children.unshift({
      type: "element",
      tagName: "input",
      properties: { type: "checkbox", checked: e.checked, disabled: !0 },
      children: []
    }), s.className = ["task-list-item"];
  }
  let l = -1;
  for (; ++l < i.length; ) {
    const u = i[l];
    (r || l !== 0 || u.type !== "element" || u.tagName !== "p") && o.push({ type: "text", value: `
` }), u.type === "element" && u.tagName === "p" && !r ? o.push(...u.children) : o.push(u);
  }
  const a = i[i.length - 1];
  a && (r || a.type !== "element" || a.tagName !== "p") && o.push({ type: "text", value: `
` });
  const h = { type: "element", tagName: "li", properties: s, children: o };
  return n.patch(e, h), n.applyData(e, h);
}
function dA(n) {
  let e = !1;
  if (n.type === "list") {
    e = n.spread || !1;
    const t = n.children;
    let i = -1;
    for (; !e && ++i < t.length; )
      e = r0(t[i]);
  }
  return e;
}
function r0(n) {
  const e = n.spread;
  return e ?? n.children.length > 1;
}
function pA(n, e) {
  const t = {}, i = n.all(e);
  let r = -1;
  for (typeof e.start == "number" && e.start !== 1 && (t.start = e.start); ++r < i.length; ) {
    const o = i[r];
    if (o.type === "element" && o.tagName === "li" && o.properties && Array.isArray(o.properties.className) && o.properties.className.includes("task-list-item")) {
      t.className = ["contains-task-list"];
      break;
    }
  }
  const s = {
    type: "element",
    tagName: e.ordered ? "ol" : "ul",
    properties: t,
    children: n.wrap(i, !0)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function mA(n, e) {
  const t = {
    type: "element",
    tagName: "p",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function OA(n, e) {
  const t = { type: "root", children: n.wrap(n.all(e)) };
  return n.patch(e, t), n.applyData(e, t);
}
function gA(n, e) {
  const t = {
    type: "element",
    tagName: "strong",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
const s0 = l0("end"), o0 = l0("start");
function l0(n) {
  return e;
  function e(t) {
    const i = t && t.position && t.position[n] || {};
    if (typeof i.line == "number" && i.line > 0 && typeof i.column == "number" && i.column > 0)
      return {
        line: i.line,
        column: i.column,
        offset: typeof i.offset == "number" && i.offset > -1 ? i.offset : void 0
      };
  }
}
function bA(n) {
  const e = o0(n), t = s0(n);
  if (e && t)
    return { start: e, end: t };
}
function yA(n, e) {
  const t = n.all(e), i = t.shift(), r = [];
  if (i) {
    const o = {
      type: "element",
      tagName: "thead",
      properties: {},
      children: n.wrap([i], !0)
    };
    n.patch(e.children[0], o), r.push(o);
  }
  if (t.length > 0) {
    const o = {
      type: "element",
      tagName: "tbody",
      properties: {},
      children: n.wrap(t, !0)
    }, l = o0(e.children[1]), a = s0(e.children[e.children.length - 1]);
    l && a && (o.position = { start: l, end: a }), r.push(o);
  }
  const s = {
    type: "element",
    tagName: "table",
    properties: {},
    children: n.wrap(r, !0)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function kA(n, e, t) {
  const i = t ? t.children : void 0, s = (i ? i.indexOf(e) : 1) === 0 ? "th" : "td", o = t && t.type === "table" ? t.align : void 0, l = o ? o.length : e.children.length;
  let a = -1;
  const h = [];
  for (; ++a < l; ) {
    const c = e.children[a], f = {}, d = o ? o[a] : void 0;
    d && (f.align = d);
    let p = { type: "element", tagName: s, properties: f, children: [] };
    c && (p.children = n.all(c), n.patch(c, p), p = n.applyData(c, p)), h.push(p);
  }
  const u = {
    type: "element",
    tagName: "tr",
    properties: {},
    children: n.wrap(h, !0)
  };
  return n.patch(e, u), n.applyData(e, u);
}
function xA(n, e) {
  const t = {
    type: "element",
    tagName: "td",
    // Assume body cell.
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
const Wd = 9, Bd = 32;
function wA(n) {
  const e = String(n), t = /\r?\n|\r/g;
  let i = t.exec(e), r = 0;
  const s = [];
  for (; i; )
    s.push(
      Vd(e.slice(r, i.index), r > 0, !0),
      i[0]
    ), r = i.index + i[0].length, i = t.exec(e);
  return s.push(Vd(e.slice(r), r > 0, !1)), s.join("");
}
function Vd(n, e, t) {
  let i = 0, r = n.length;
  if (e) {
    let s = n.codePointAt(i);
    for (; s === Wd || s === Bd; )
      i++, s = n.codePointAt(i);
  }
  if (t) {
    let s = n.codePointAt(r - 1);
    for (; s === Wd || s === Bd; )
      r--, s = n.codePointAt(r - 1);
  }
  return r > i ? n.slice(i, r) : "";
}
function SA(n, e) {
  const t = { type: "text", value: wA(String(e.value)) };
  return n.patch(e, t), n.applyData(e, t);
}
function vA(n, e) {
  const t = {
    type: "element",
    tagName: "hr",
    properties: {},
    children: []
  };
  return n.patch(e, t), n.applyData(e, t);
}
const PA = {
  blockquote: J4,
  break: eA,
  code: tA,
  delete: nA,
  emphasis: iA,
  footnoteReference: rA,
  heading: sA,
  html: oA,
  imageReference: lA,
  image: aA,
  inlineCode: hA,
  linkReference: uA,
  link: cA,
  listItem: fA,
  list: pA,
  paragraph: mA,
  // @ts-expect-error: root is different, but hard to type.
  root: OA,
  strong: gA,
  table: yA,
  tableCell: xA,
  tableRow: kA,
  text: SA,
  thematicBreak: vA,
  toml: As,
  yaml: As,
  definition: As,
  footnoteDefinition: As
};
function As() {
}
const a0 = -1, tl = 0, Ro = 1, Zo = 2, wu = 3, Su = 4, vu = 5, Pu = 6, h0 = 7, u0 = 8, Yd = typeof self == "object" ? self : globalThis, QA = (n, e) => {
  const t = (r, s) => (n.set(s, r), r), i = (r) => {
    if (n.has(r))
      return n.get(r);
    const [s, o] = e[r];
    switch (s) {
      case tl:
      case a0:
        return t(o, r);
      case Ro: {
        const l = t([], r);
        for (const a of o)
          l.push(i(a));
        return l;
      }
      case Zo: {
        const l = t({}, r);
        for (const [a, h] of o)
          l[i(a)] = i(h);
        return l;
      }
      case wu:
        return t(new Date(o), r);
      case Su: {
        const { source: l, flags: a } = o;
        return t(new RegExp(l, a), r);
      }
      case vu: {
        const l = t(/* @__PURE__ */ new Map(), r);
        for (const [a, h] of o)
          l.set(i(a), i(h));
        return l;
      }
      case Pu: {
        const l = t(/* @__PURE__ */ new Set(), r);
        for (const a of o)
          l.add(i(a));
        return l;
      }
      case h0: {
        const { name: l, message: a } = o;
        return t(new Yd[l](a), r);
      }
      case u0:
        return t(BigInt(o), r);
      case "BigInt":
        return t(Object(BigInt(o)), r);
    }
    return t(new Yd[s](o), r);
  };
  return i;
}, jd = (n) => QA(/* @__PURE__ */ new Map(), n)(0), si = "", { toString: $A } = {}, { keys: CA } = Object, ir = (n) => {
  const e = typeof n;
  if (e !== "object" || !n)
    return [tl, e];
  const t = $A.call(n).slice(8, -1);
  switch (t) {
    case "Array":
      return [Ro, si];
    case "Object":
      return [Zo, si];
    case "Date":
      return [wu, si];
    case "RegExp":
      return [Su, si];
    case "Map":
      return [vu, si];
    case "Set":
      return [Pu, si];
  }
  return t.includes("Array") ? [Ro, t] : t.includes("Error") ? [h0, t] : [Zo, t];
}, Rs = ([n, e]) => n === tl && (e === "function" || e === "symbol"), TA = (n, e, t, i) => {
  const r = (o, l) => {
    const a = i.push(o) - 1;
    return t.set(l, a), a;
  }, s = (o) => {
    if (t.has(o))
      return t.get(o);
    let [l, a] = ir(o);
    switch (l) {
      case tl: {
        let u = o;
        switch (a) {
          case "bigint":
            l = u0, u = o.toString();
            break;
          case "function":
          case "symbol":
            if (n)
              throw new TypeError("unable to serialize " + a);
            u = null;
            break;
          case "undefined":
            return r([a0], o);
        }
        return r([l, u], o);
      }
      case Ro: {
        if (a)
          return r([a, [...o]], o);
        const u = [], c = r([l, u], o);
        for (const f of o)
          u.push(s(f));
        return c;
      }
      case Zo: {
        if (a)
          switch (a) {
            case "BigInt":
              return r([a, o.toString()], o);
            case "Boolean":
            case "Number":
            case "String":
              return r([a, o.valueOf()], o);
          }
        if (e && "toJSON" in o)
          return s(o.toJSON());
        const u = [], c = r([l, u], o);
        for (const f of CA(o))
          (n || !Rs(ir(o[f]))) && u.push([s(f), s(o[f])]);
        return c;
      }
      case wu:
        return r([l, o.toISOString()], o);
      case Su: {
        const { source: u, flags: c } = o;
        return r([l, { source: u, flags: c }], o);
      }
      case vu: {
        const u = [], c = r([l, u], o);
        for (const [f, d] of o)
          (n || !(Rs(ir(f)) || Rs(ir(d)))) && u.push([s(f), s(d)]);
        return c;
      }
      case Pu: {
        const u = [], c = r([l, u], o);
        for (const f of o)
          (n || !Rs(ir(f))) && u.push(s(f));
        return c;
      }
    }
    const { message: h } = o;
    return r([l, { name: a, message: h }], o);
  };
  return s;
}, Nd = (n, { json: e, lossy: t } = {}) => {
  const i = [];
  return TA(!(e || t), !!e, /* @__PURE__ */ new Map(), i)(n), i;
}, Mo = typeof structuredClone == "function" ? (
  /* c8 ignore start */
  (n, e) => e && ("json" in e || "lossy" in e) ? jd(Nd(n, e)) : structuredClone(n)
) : (n, e) => jd(Nd(n, e));
function AA(n, e) {
  const t = [{ type: "text", value: "↩" }];
  return e > 1 && t.push({
    type: "element",
    tagName: "sup",
    properties: {},
    children: [{ type: "text", value: String(e) }]
  }), t;
}
function RA(n, e) {
  return "Back to reference " + (n + 1) + (e > 1 ? "-" + e : "");
}
function ZA(n) {
  const e = typeof n.options.clobberPrefix == "string" ? n.options.clobberPrefix : "user-content-", t = n.options.footnoteBackContent || AA, i = n.options.footnoteBackLabel || RA, r = n.options.footnoteLabel || "Footnotes", s = n.options.footnoteLabelTagName || "h2", o = n.options.footnoteLabelProperties || {
    className: ["sr-only"]
  }, l = [];
  let a = -1;
  for (; ++a < n.footnoteOrder.length; ) {
    const h = n.footnoteById.get(n.footnoteOrder[a]);
    if (!h)
      continue;
    const u = n.all(h), c = String(h.identifier).toUpperCase(), f = Wi(c.toLowerCase());
    let d = 0;
    const p = [], m = n.footnoteCounts.get(c);
    for (; m !== void 0 && ++d <= m; ) {
      p.length > 0 && p.push({ type: "text", value: " " });
      let b = typeof t == "string" ? t : t(a, d);
      typeof b == "string" && (b = { type: "text", value: b }), p.push({
        type: "element",
        tagName: "a",
        properties: {
          href: "#" + e + "fnref-" + f + (d > 1 ? "-" + d : ""),
          dataFootnoteBackref: "",
          ariaLabel: typeof i == "string" ? i : i(a, d),
          className: ["data-footnote-backref"]
        },
        children: Array.isArray(b) ? b : [b]
      });
    }
    const O = u[u.length - 1];
    if (O && O.type === "element" && O.tagName === "p") {
      const b = O.children[O.children.length - 1];
      b && b.type === "text" ? b.value += " " : O.children.push({ type: "text", value: " " }), O.children.push(...p);
    } else
      u.push(...p);
    const g = {
      type: "element",
      tagName: "li",
      properties: { id: e + "fn-" + f },
      children: n.wrap(u, !0)
    };
    n.patch(h, g), l.push(g);
  }
  if (l.length !== 0)
    return {
      type: "element",
      tagName: "section",
      properties: { dataFootnotes: !0, className: ["footnotes"] },
      children: [
        {
          type: "element",
          tagName: s,
          properties: {
            ...Mo(o),
            id: "footnote-label"
          },
          children: [{ type: "text", value: r }]
        },
        { type: "text", value: `
` },
        {
          type: "element",
          tagName: "ol",
          properties: {},
          children: n.wrap(l, !0)
        },
        { type: "text", value: `
` }
      ]
    };
}
const gh = {}.hasOwnProperty, MA = {};
function EA(n, e) {
  const t = e || MA, i = /* @__PURE__ */ new Map(), r = /* @__PURE__ */ new Map(), s = /* @__PURE__ */ new Map(), o = { ...PA, ...t.handlers }, l = {
    all: h,
    applyData: XA,
    definitionById: i,
    footnoteById: r,
    footnoteCounts: s,
    footnoteOrder: [],
    handlers: o,
    one: a,
    options: t,
    patch: zA,
    wrap: LA
  };
  return mg(n, function(u) {
    if (u.type === "definition" || u.type === "footnoteDefinition") {
      const c = u.type === "definition" ? i : r, f = String(u.identifier).toUpperCase();
      c.has(f) || c.set(f, u);
    }
  }), l;
  function a(u, c) {
    const f = u.type, d = l.handlers[f];
    if (gh.call(l.handlers, f) && d)
      return d(l, u, c);
    if (l.options.passThrough && l.options.passThrough.includes(f)) {
      if ("children" in u) {
        const { children: m, ...O } = u, g = Mo(O);
        return g.children = l.all(u), g;
      }
      return Mo(u);
    }
    return (l.options.unknownHandler || DA)(l, u, c);
  }
  function h(u) {
    const c = [];
    if ("children" in u) {
      const f = u.children;
      let d = -1;
      for (; ++d < f.length; ) {
        const p = l.one(f[d], u);
        if (p) {
          if (d && f[d - 1].type === "break" && (!Array.isArray(p) && p.type === "text" && (p.value = Ud(p.value)), !Array.isArray(p) && p.type === "element")) {
            const m = p.children[0];
            m && m.type === "text" && (m.value = Ud(m.value));
          }
          Array.isArray(p) ? c.push(...p) : c.push(p);
        }
      }
    }
    return c;
  }
}
function zA(n, e) {
  n.position && (e.position = bA(n));
}
function XA(n, e) {
  let t = e;
  if (n && n.data) {
    const i = n.data.hName, r = n.data.hChildren, s = n.data.hProperties;
    if (typeof i == "string")
      if (t.type === "element")
        t.tagName = i;
      else {
        const o = "children" in t ? t.children : [t];
        t = { type: "element", tagName: i, properties: {}, children: o };
      }
    t.type === "element" && s && Object.assign(t.properties, Mo(s)), "children" in t && t.children && r !== null && r !== void 0 && (t.children = r);
  }
  return t;
}
function DA(n, e) {
  const t = e.data || {}, i = "value" in e && !(gh.call(t, "hProperties") || gh.call(t, "hChildren")) ? { type: "text", value: e.value } : {
    type: "element",
    tagName: "div",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, i), n.applyData(e, i);
}
function LA(n, e) {
  const t = [];
  let i = -1;
  for (e && t.push({ type: "text", value: `
` }); ++i < n.length; )
    i && t.push({ type: "text", value: `
` }), t.push(n[i]);
  return e && n.length > 0 && t.push({ type: "text", value: `
` }), t;
}
function Ud(n) {
  let e = 0, t = n.charCodeAt(e);
  for (; t === 9 || t === 32; )
    e++, t = n.charCodeAt(e);
  return n.slice(e);
}
function Fd(n, e) {
  const t = EA(n, e), i = t.one(n, void 0), r = ZA(t), s = Array.isArray(i) ? { type: "root", children: i } : i || { type: "root", children: [] };
  return r && s.children.push({ type: "text", value: `
` }, r), s;
}
function IA(n, e) {
  return n && "run" in n ? async function(t, i) {
    const r = (
      /** @type {HastRoot} */
      Fd(t, { file: i, ...e })
    );
    await n.run(r, i);
  } : function(t, i) {
    return (
      /** @type {HastRoot} */
      Fd(t, { file: i, ...e || n })
    );
  };
}
const _A = [
  "area",
  "base",
  "basefont",
  "bgsound",
  "br",
  "col",
  "command",
  "embed",
  "frame",
  "hr",
  "image",
  "img",
  "input",
  "keygen",
  "link",
  "meta",
  "param",
  "source",
  "track",
  "wbr"
];
class ts {
  /**
   * @constructor
   * @param {Properties} property
   * @param {Normal} normal
   * @param {string} [space]
   */
  constructor(e, t, i) {
    this.property = e, this.normal = t, i && (this.space = i);
  }
}
ts.prototype.property = {};
ts.prototype.normal = {};
ts.prototype.space = null;
function c0(n, e) {
  const t = {}, i = {};
  let r = -1;
  for (; ++r < n.length; )
    Object.assign(t, n[r].property), Object.assign(i, n[r].normal);
  return new ts(t, i, e);
}
function bh(n) {
  return n.toLowerCase();
}
class Ct {
  /**
   * @constructor
   * @param {string} property
   * @param {string} attribute
   */
  constructor(e, t) {
    this.property = e, this.attribute = t;
  }
}
Ct.prototype.space = null;
Ct.prototype.boolean = !1;
Ct.prototype.booleanish = !1;
Ct.prototype.overloadedBoolean = !1;
Ct.prototype.number = !1;
Ct.prototype.commaSeparated = !1;
Ct.prototype.spaceSeparated = !1;
Ct.prototype.commaOrSpaceSeparated = !1;
Ct.prototype.mustUseProperty = !1;
Ct.prototype.defined = !1;
let qA = 0;
const J = ti(), Te = ti(), f0 = ti(), Z = ti(), Oe = ti(), ki = ti(), ut = ti();
function ti() {
  return 2 ** ++qA;
}
const yh = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  boolean: J,
  booleanish: Te,
  commaOrSpaceSeparated: ut,
  commaSeparated: ki,
  number: Z,
  overloadedBoolean: f0,
  spaceSeparated: Oe
}, Symbol.toStringTag, { value: "Module" })), ea = Object.keys(yh);
class Qu extends Ct {
  /**
   * @constructor
   * @param {string} property
   * @param {string} attribute
   * @param {number|null} [mask]
   * @param {string} [space]
   */
  constructor(e, t, i, r) {
    let s = -1;
    if (super(e, t), Gd(this, "space", r), typeof i == "number")
      for (; ++s < ea.length; ) {
        const o = ea[s];
        Gd(this, ea[s], (i & yh[o]) === yh[o]);
      }
  }
}
Qu.prototype.defined = !0;
function Gd(n, e, t) {
  t && (n[e] = t);
}
const WA = {}.hasOwnProperty;
function Bi(n) {
  const e = {}, t = {};
  let i;
  for (i in n.properties)
    if (WA.call(n.properties, i)) {
      const r = n.properties[i], s = new Qu(
        i,
        n.transform(n.attributes || {}, i),
        r,
        n.space
      );
      n.mustUseProperty && n.mustUseProperty.includes(i) && (s.mustUseProperty = !0), e[i] = s, t[bh(i)] = i, t[bh(s.attribute)] = i;
    }
  return new ts(e, t, n.space);
}
const d0 = Bi({
  space: "xlink",
  transform(n, e) {
    return "xlink:" + e.slice(5).toLowerCase();
  },
  properties: {
    xLinkActuate: null,
    xLinkArcRole: null,
    xLinkHref: null,
    xLinkRole: null,
    xLinkShow: null,
    xLinkTitle: null,
    xLinkType: null
  }
}), p0 = Bi({
  space: "xml",
  transform(n, e) {
    return "xml:" + e.slice(3).toLowerCase();
  },
  properties: { xmlLang: null, xmlBase: null, xmlSpace: null }
});
function m0(n, e) {
  return e in n ? n[e] : e;
}
function O0(n, e) {
  return m0(n, e.toLowerCase());
}
const g0 = Bi({
  space: "xmlns",
  attributes: { xmlnsxlink: "xmlns:xlink" },
  transform: O0,
  properties: { xmlns: null, xmlnsXLink: null }
}), b0 = Bi({
  transform(n, e) {
    return e === "role" ? e : "aria-" + e.slice(4).toLowerCase();
  },
  properties: {
    ariaActiveDescendant: null,
    ariaAtomic: Te,
    ariaAutoComplete: null,
    ariaBusy: Te,
    ariaChecked: Te,
    ariaColCount: Z,
    ariaColIndex: Z,
    ariaColSpan: Z,
    ariaControls: Oe,
    ariaCurrent: null,
    ariaDescribedBy: Oe,
    ariaDetails: null,
    ariaDisabled: Te,
    ariaDropEffect: Oe,
    ariaErrorMessage: null,
    ariaExpanded: Te,
    ariaFlowTo: Oe,
    ariaGrabbed: Te,
    ariaHasPopup: null,
    ariaHidden: Te,
    ariaInvalid: null,
    ariaKeyShortcuts: null,
    ariaLabel: null,
    ariaLabelledBy: Oe,
    ariaLevel: Z,
    ariaLive: null,
    ariaModal: Te,
    ariaMultiLine: Te,
    ariaMultiSelectable: Te,
    ariaOrientation: null,
    ariaOwns: Oe,
    ariaPlaceholder: null,
    ariaPosInSet: Z,
    ariaPressed: Te,
    ariaReadOnly: Te,
    ariaRelevant: null,
    ariaRequired: Te,
    ariaRoleDescription: Oe,
    ariaRowCount: Z,
    ariaRowIndex: Z,
    ariaRowSpan: Z,
    ariaSelected: Te,
    ariaSetSize: Z,
    ariaSort: null,
    ariaValueMax: Z,
    ariaValueMin: Z,
    ariaValueNow: Z,
    ariaValueText: null,
    role: null
  }
}), BA = Bi({
  space: "html",
  attributes: {
    acceptcharset: "accept-charset",
    classname: "class",
    htmlfor: "for",
    httpequiv: "http-equiv"
  },
  transform: O0,
  mustUseProperty: ["checked", "multiple", "muted", "selected"],
  properties: {
    // Standard Properties.
    abbr: null,
    accept: ki,
    acceptCharset: Oe,
    accessKey: Oe,
    action: null,
    allow: null,
    allowFullScreen: J,
    allowPaymentRequest: J,
    allowUserMedia: J,
    alt: null,
    as: null,
    async: J,
    autoCapitalize: null,
    autoComplete: Oe,
    autoFocus: J,
    autoPlay: J,
    blocking: Oe,
    capture: null,
    charSet: null,
    checked: J,
    cite: null,
    className: Oe,
    cols: Z,
    colSpan: null,
    content: null,
    contentEditable: Te,
    controls: J,
    controlsList: Oe,
    coords: Z | ki,
    crossOrigin: null,
    data: null,
    dateTime: null,
    decoding: null,
    default: J,
    defer: J,
    dir: null,
    dirName: null,
    disabled: J,
    download: f0,
    draggable: Te,
    encType: null,
    enterKeyHint: null,
    fetchPriority: null,
    form: null,
    formAction: null,
    formEncType: null,
    formMethod: null,
    formNoValidate: J,
    formTarget: null,
    headers: Oe,
    height: Z,
    hidden: J,
    high: Z,
    href: null,
    hrefLang: null,
    htmlFor: Oe,
    httpEquiv: Oe,
    id: null,
    imageSizes: null,
    imageSrcSet: null,
    inert: J,
    inputMode: null,
    integrity: null,
    is: null,
    isMap: J,
    itemId: null,
    itemProp: Oe,
    itemRef: Oe,
    itemScope: J,
    itemType: Oe,
    kind: null,
    label: null,
    lang: null,
    language: null,
    list: null,
    loading: null,
    loop: J,
    low: Z,
    manifest: null,
    max: null,
    maxLength: Z,
    media: null,
    method: null,
    min: null,
    minLength: Z,
    multiple: J,
    muted: J,
    name: null,
    nonce: null,
    noModule: J,
    noValidate: J,
    onAbort: null,
    onAfterPrint: null,
    onAuxClick: null,
    onBeforeMatch: null,
    onBeforePrint: null,
    onBeforeToggle: null,
    onBeforeUnload: null,
    onBlur: null,
    onCancel: null,
    onCanPlay: null,
    onCanPlayThrough: null,
    onChange: null,
    onClick: null,
    onClose: null,
    onContextLost: null,
    onContextMenu: null,
    onContextRestored: null,
    onCopy: null,
    onCueChange: null,
    onCut: null,
    onDblClick: null,
    onDrag: null,
    onDragEnd: null,
    onDragEnter: null,
    onDragExit: null,
    onDragLeave: null,
    onDragOver: null,
    onDragStart: null,
    onDrop: null,
    onDurationChange: null,
    onEmptied: null,
    onEnded: null,
    onError: null,
    onFocus: null,
    onFormData: null,
    onHashChange: null,
    onInput: null,
    onInvalid: null,
    onKeyDown: null,
    onKeyPress: null,
    onKeyUp: null,
    onLanguageChange: null,
    onLoad: null,
    onLoadedData: null,
    onLoadedMetadata: null,
    onLoadEnd: null,
    onLoadStart: null,
    onMessage: null,
    onMessageError: null,
    onMouseDown: null,
    onMouseEnter: null,
    onMouseLeave: null,
    onMouseMove: null,
    onMouseOut: null,
    onMouseOver: null,
    onMouseUp: null,
    onOffline: null,
    onOnline: null,
    onPageHide: null,
    onPageShow: null,
    onPaste: null,
    onPause: null,
    onPlay: null,
    onPlaying: null,
    onPopState: null,
    onProgress: null,
    onRateChange: null,
    onRejectionHandled: null,
    onReset: null,
    onResize: null,
    onScroll: null,
    onScrollEnd: null,
    onSecurityPolicyViolation: null,
    onSeeked: null,
    onSeeking: null,
    onSelect: null,
    onSlotChange: null,
    onStalled: null,
    onStorage: null,
    onSubmit: null,
    onSuspend: null,
    onTimeUpdate: null,
    onToggle: null,
    onUnhandledRejection: null,
    onUnload: null,
    onVolumeChange: null,
    onWaiting: null,
    onWheel: null,
    open: J,
    optimum: Z,
    pattern: null,
    ping: Oe,
    placeholder: null,
    playsInline: J,
    popover: null,
    popoverTarget: null,
    popoverTargetAction: null,
    poster: null,
    preload: null,
    readOnly: J,
    referrerPolicy: null,
    rel: Oe,
    required: J,
    reversed: J,
    rows: Z,
    rowSpan: Z,
    sandbox: Oe,
    scope: null,
    scoped: J,
    seamless: J,
    selected: J,
    shadowRootClonable: J,
    shadowRootDelegatesFocus: J,
    shadowRootMode: null,
    shape: null,
    size: Z,
    sizes: null,
    slot: null,
    span: Z,
    spellCheck: Te,
    src: null,
    srcDoc: null,
    srcLang: null,
    srcSet: null,
    start: Z,
    step: null,
    style: null,
    tabIndex: Z,
    target: null,
    title: null,
    translate: null,
    type: null,
    typeMustMatch: J,
    useMap: null,
    value: Te,
    width: Z,
    wrap: null,
    writingSuggestions: null,
    // Legacy.
    // See: https://html.spec.whatwg.org/#other-elements,-attributes-and-apis
    align: null,
    // Several. Use CSS `text-align` instead,
    aLink: null,
    // `<body>`. Use CSS `a:active {color}` instead
    archive: Oe,
    // `<object>`. List of URIs to archives
    axis: null,
    // `<td>` and `<th>`. Use `scope` on `<th>`
    background: null,
    // `<body>`. Use CSS `background-image` instead
    bgColor: null,
    // `<body>` and table elements. Use CSS `background-color` instead
    border: Z,
    // `<table>`. Use CSS `border-width` instead,
    borderColor: null,
    // `<table>`. Use CSS `border-color` instead,
    bottomMargin: Z,
    // `<body>`
    cellPadding: null,
    // `<table>`
    cellSpacing: null,
    // `<table>`
    char: null,
    // Several table elements. When `align=char`, sets the character to align on
    charOff: null,
    // Several table elements. When `char`, offsets the alignment
    classId: null,
    // `<object>`
    clear: null,
    // `<br>`. Use CSS `clear` instead
    code: null,
    // `<object>`
    codeBase: null,
    // `<object>`
    codeType: null,
    // `<object>`
    color: null,
    // `<font>` and `<hr>`. Use CSS instead
    compact: J,
    // Lists. Use CSS to reduce space between items instead
    declare: J,
    // `<object>`
    event: null,
    // `<script>`
    face: null,
    // `<font>`. Use CSS instead
    frame: null,
    // `<table>`
    frameBorder: null,
    // `<iframe>`. Use CSS `border` instead
    hSpace: Z,
    // `<img>` and `<object>`
    leftMargin: Z,
    // `<body>`
    link: null,
    // `<body>`. Use CSS `a:link {color: *}` instead
    longDesc: null,
    // `<frame>`, `<iframe>`, and `<img>`. Use an `<a>`
    lowSrc: null,
    // `<img>`. Use a `<picture>`
    marginHeight: Z,
    // `<body>`
    marginWidth: Z,
    // `<body>`
    noResize: J,
    // `<frame>`
    noHref: J,
    // `<area>`. Use no href instead of an explicit `nohref`
    noShade: J,
    // `<hr>`. Use background-color and height instead of borders
    noWrap: J,
    // `<td>` and `<th>`
    object: null,
    // `<applet>`
    profile: null,
    // `<head>`
    prompt: null,
    // `<isindex>`
    rev: null,
    // `<link>`
    rightMargin: Z,
    // `<body>`
    rules: null,
    // `<table>`
    scheme: null,
    // `<meta>`
    scrolling: Te,
    // `<frame>`. Use overflow in the child context
    standby: null,
    // `<object>`
    summary: null,
    // `<table>`
    text: null,
    // `<body>`. Use CSS `color` instead
    topMargin: Z,
    // `<body>`
    valueType: null,
    // `<param>`
    version: null,
    // `<html>`. Use a doctype.
    vAlign: null,
    // Several. Use CSS `vertical-align` instead
    vLink: null,
    // `<body>`. Use CSS `a:visited {color}` instead
    vSpace: Z,
    // `<img>` and `<object>`
    // Non-standard Properties.
    allowTransparency: null,
    autoCorrect: null,
    autoSave: null,
    disablePictureInPicture: J,
    disableRemotePlayback: J,
    prefix: null,
    property: null,
    results: Z,
    security: null,
    unselectable: null
  }
}), VA = Bi({
  space: "svg",
  attributes: {
    accentHeight: "accent-height",
    alignmentBaseline: "alignment-baseline",
    arabicForm: "arabic-form",
    baselineShift: "baseline-shift",
    capHeight: "cap-height",
    className: "class",
    clipPath: "clip-path",
    clipRule: "clip-rule",
    colorInterpolation: "color-interpolation",
    colorInterpolationFilters: "color-interpolation-filters",
    colorProfile: "color-profile",
    colorRendering: "color-rendering",
    crossOrigin: "crossorigin",
    dataType: "datatype",
    dominantBaseline: "dominant-baseline",
    enableBackground: "enable-background",
    fillOpacity: "fill-opacity",
    fillRule: "fill-rule",
    floodColor: "flood-color",
    floodOpacity: "flood-opacity",
    fontFamily: "font-family",
    fontSize: "font-size",
    fontSizeAdjust: "font-size-adjust",
    fontStretch: "font-stretch",
    fontStyle: "font-style",
    fontVariant: "font-variant",
    fontWeight: "font-weight",
    glyphName: "glyph-name",
    glyphOrientationHorizontal: "glyph-orientation-horizontal",
    glyphOrientationVertical: "glyph-orientation-vertical",
    hrefLang: "hreflang",
    horizAdvX: "horiz-adv-x",
    horizOriginX: "horiz-origin-x",
    horizOriginY: "horiz-origin-y",
    imageRendering: "image-rendering",
    letterSpacing: "letter-spacing",
    lightingColor: "lighting-color",
    markerEnd: "marker-end",
    markerMid: "marker-mid",
    markerStart: "marker-start",
    navDown: "nav-down",
    navDownLeft: "nav-down-left",
    navDownRight: "nav-down-right",
    navLeft: "nav-left",
    navNext: "nav-next",
    navPrev: "nav-prev",
    navRight: "nav-right",
    navUp: "nav-up",
    navUpLeft: "nav-up-left",
    navUpRight: "nav-up-right",
    onAbort: "onabort",
    onActivate: "onactivate",
    onAfterPrint: "onafterprint",
    onBeforePrint: "onbeforeprint",
    onBegin: "onbegin",
    onCancel: "oncancel",
    onCanPlay: "oncanplay",
    onCanPlayThrough: "oncanplaythrough",
    onChange: "onchange",
    onClick: "onclick",
    onClose: "onclose",
    onCopy: "oncopy",
    onCueChange: "oncuechange",
    onCut: "oncut",
    onDblClick: "ondblclick",
    onDrag: "ondrag",
    onDragEnd: "ondragend",
    onDragEnter: "ondragenter",
    onDragExit: "ondragexit",
    onDragLeave: "ondragleave",
    onDragOver: "ondragover",
    onDragStart: "ondragstart",
    onDrop: "ondrop",
    onDurationChange: "ondurationchange",
    onEmptied: "onemptied",
    onEnd: "onend",
    onEnded: "onended",
    onError: "onerror",
    onFocus: "onfocus",
    onFocusIn: "onfocusin",
    onFocusOut: "onfocusout",
    onHashChange: "onhashchange",
    onInput: "oninput",
    onInvalid: "oninvalid",
    onKeyDown: "onkeydown",
    onKeyPress: "onkeypress",
    onKeyUp: "onkeyup",
    onLoad: "onload",
    onLoadedData: "onloadeddata",
    onLoadedMetadata: "onloadedmetadata",
    onLoadStart: "onloadstart",
    onMessage: "onmessage",
    onMouseDown: "onmousedown",
    onMouseEnter: "onmouseenter",
    onMouseLeave: "onmouseleave",
    onMouseMove: "onmousemove",
    onMouseOut: "onmouseout",
    onMouseOver: "onmouseover",
    onMouseUp: "onmouseup",
    onMouseWheel: "onmousewheel",
    onOffline: "onoffline",
    onOnline: "ononline",
    onPageHide: "onpagehide",
    onPageShow: "onpageshow",
    onPaste: "onpaste",
    onPause: "onpause",
    onPlay: "onplay",
    onPlaying: "onplaying",
    onPopState: "onpopstate",
    onProgress: "onprogress",
    onRateChange: "onratechange",
    onRepeat: "onrepeat",
    onReset: "onreset",
    onResize: "onresize",
    onScroll: "onscroll",
    onSeeked: "onseeked",
    onSeeking: "onseeking",
    onSelect: "onselect",
    onShow: "onshow",
    onStalled: "onstalled",
    onStorage: "onstorage",
    onSubmit: "onsubmit",
    onSuspend: "onsuspend",
    onTimeUpdate: "ontimeupdate",
    onToggle: "ontoggle",
    onUnload: "onunload",
    onVolumeChange: "onvolumechange",
    onWaiting: "onwaiting",
    onZoom: "onzoom",
    overlinePosition: "overline-position",
    overlineThickness: "overline-thickness",
    paintOrder: "paint-order",
    panose1: "panose-1",
    pointerEvents: "pointer-events",
    referrerPolicy: "referrerpolicy",
    renderingIntent: "rendering-intent",
    shapeRendering: "shape-rendering",
    stopColor: "stop-color",
    stopOpacity: "stop-opacity",
    strikethroughPosition: "strikethrough-position",
    strikethroughThickness: "strikethrough-thickness",
    strokeDashArray: "stroke-dasharray",
    strokeDashOffset: "stroke-dashoffset",
    strokeLineCap: "stroke-linecap",
    strokeLineJoin: "stroke-linejoin",
    strokeMiterLimit: "stroke-miterlimit",
    strokeOpacity: "stroke-opacity",
    strokeWidth: "stroke-width",
    tabIndex: "tabindex",
    textAnchor: "text-anchor",
    textDecoration: "text-decoration",
    textRendering: "text-rendering",
    transformOrigin: "transform-origin",
    typeOf: "typeof",
    underlinePosition: "underline-position",
    underlineThickness: "underline-thickness",
    unicodeBidi: "unicode-bidi",
    unicodeRange: "unicode-range",
    unitsPerEm: "units-per-em",
    vAlphabetic: "v-alphabetic",
    vHanging: "v-hanging",
    vIdeographic: "v-ideographic",
    vMathematical: "v-mathematical",
    vectorEffect: "vector-effect",
    vertAdvY: "vert-adv-y",
    vertOriginX: "vert-origin-x",
    vertOriginY: "vert-origin-y",
    wordSpacing: "word-spacing",
    writingMode: "writing-mode",
    xHeight: "x-height",
    // These were camelcased in Tiny. Now lowercased in SVG 2
    playbackOrder: "playbackorder",
    timelineBegin: "timelinebegin"
  },
  transform: m0,
  properties: {
    about: ut,
    accentHeight: Z,
    accumulate: null,
    additive: null,
    alignmentBaseline: null,
    alphabetic: Z,
    amplitude: Z,
    arabicForm: null,
    ascent: Z,
    attributeName: null,
    attributeType: null,
    azimuth: Z,
    bandwidth: null,
    baselineShift: null,
    baseFrequency: null,
    baseProfile: null,
    bbox: null,
    begin: null,
    bias: Z,
    by: null,
    calcMode: null,
    capHeight: Z,
    className: Oe,
    clip: null,
    clipPath: null,
    clipPathUnits: null,
    clipRule: null,
    color: null,
    colorInterpolation: null,
    colorInterpolationFilters: null,
    colorProfile: null,
    colorRendering: null,
    content: null,
    contentScriptType: null,
    contentStyleType: null,
    crossOrigin: null,
    cursor: null,
    cx: null,
    cy: null,
    d: null,
    dataType: null,
    defaultAction: null,
    descent: Z,
    diffuseConstant: Z,
    direction: null,
    display: null,
    dur: null,
    divisor: Z,
    dominantBaseline: null,
    download: J,
    dx: null,
    dy: null,
    edgeMode: null,
    editable: null,
    elevation: Z,
    enableBackground: null,
    end: null,
    event: null,
    exponent: Z,
    externalResourcesRequired: null,
    fill: null,
    fillOpacity: Z,
    fillRule: null,
    filter: null,
    filterRes: null,
    filterUnits: null,
    floodColor: null,
    floodOpacity: null,
    focusable: null,
    focusHighlight: null,
    fontFamily: null,
    fontSize: null,
    fontSizeAdjust: null,
    fontStretch: null,
    fontStyle: null,
    fontVariant: null,
    fontWeight: null,
    format: null,
    fr: null,
    from: null,
    fx: null,
    fy: null,
    g1: ki,
    g2: ki,
    glyphName: ki,
    glyphOrientationHorizontal: null,
    glyphOrientationVertical: null,
    glyphRef: null,
    gradientTransform: null,
    gradientUnits: null,
    handler: null,
    hanging: Z,
    hatchContentUnits: null,
    hatchUnits: null,
    height: null,
    href: null,
    hrefLang: null,
    horizAdvX: Z,
    horizOriginX: Z,
    horizOriginY: Z,
    id: null,
    ideographic: Z,
    imageRendering: null,
    initialVisibility: null,
    in: null,
    in2: null,
    intercept: Z,
    k: Z,
    k1: Z,
    k2: Z,
    k3: Z,
    k4: Z,
    kernelMatrix: ut,
    kernelUnitLength: null,
    keyPoints: null,
    // SEMI_COLON_SEPARATED
    keySplines: null,
    // SEMI_COLON_SEPARATED
    keyTimes: null,
    // SEMI_COLON_SEPARATED
    kerning: null,
    lang: null,
    lengthAdjust: null,
    letterSpacing: null,
    lightingColor: null,
    limitingConeAngle: Z,
    local: null,
    markerEnd: null,
    markerMid: null,
    markerStart: null,
    markerHeight: null,
    markerUnits: null,
    markerWidth: null,
    mask: null,
    maskContentUnits: null,
    maskUnits: null,
    mathematical: null,
    max: null,
    media: null,
    mediaCharacterEncoding: null,
    mediaContentEncodings: null,
    mediaSize: Z,
    mediaTime: null,
    method: null,
    min: null,
    mode: null,
    name: null,
    navDown: null,
    navDownLeft: null,
    navDownRight: null,
    navLeft: null,
    navNext: null,
    navPrev: null,
    navRight: null,
    navUp: null,
    navUpLeft: null,
    navUpRight: null,
    numOctaves: null,
    observer: null,
    offset: null,
    onAbort: null,
    onActivate: null,
    onAfterPrint: null,
    onBeforePrint: null,
    onBegin: null,
    onCancel: null,
    onCanPlay: null,
    onCanPlayThrough: null,
    onChange: null,
    onClick: null,
    onClose: null,
    onCopy: null,
    onCueChange: null,
    onCut: null,
    onDblClick: null,
    onDrag: null,
    onDragEnd: null,
    onDragEnter: null,
    onDragExit: null,
    onDragLeave: null,
    onDragOver: null,
    onDragStart: null,
    onDrop: null,
    onDurationChange: null,
    onEmptied: null,
    onEnd: null,
    onEnded: null,
    onError: null,
    onFocus: null,
    onFocusIn: null,
    onFocusOut: null,
    onHashChange: null,
    onInput: null,
    onInvalid: null,
    onKeyDown: null,
    onKeyPress: null,
    onKeyUp: null,
    onLoad: null,
    onLoadedData: null,
    onLoadedMetadata: null,
    onLoadStart: null,
    onMessage: null,
    onMouseDown: null,
    onMouseEnter: null,
    onMouseLeave: null,
    onMouseMove: null,
    onMouseOut: null,
    onMouseOver: null,
    onMouseUp: null,
    onMouseWheel: null,
    onOffline: null,
    onOnline: null,
    onPageHide: null,
    onPageShow: null,
    onPaste: null,
    onPause: null,
    onPlay: null,
    onPlaying: null,
    onPopState: null,
    onProgress: null,
    onRateChange: null,
    onRepeat: null,
    onReset: null,
    onResize: null,
    onScroll: null,
    onSeeked: null,
    onSeeking: null,
    onSelect: null,
    onShow: null,
    onStalled: null,
    onStorage: null,
    onSubmit: null,
    onSuspend: null,
    onTimeUpdate: null,
    onToggle: null,
    onUnload: null,
    onVolumeChange: null,
    onWaiting: null,
    onZoom: null,
    opacity: null,
    operator: null,
    order: null,
    orient: null,
    orientation: null,
    origin: null,
    overflow: null,
    overlay: null,
    overlinePosition: Z,
    overlineThickness: Z,
    paintOrder: null,
    panose1: null,
    path: null,
    pathLength: Z,
    patternContentUnits: null,
    patternTransform: null,
    patternUnits: null,
    phase: null,
    ping: Oe,
    pitch: null,
    playbackOrder: null,
    pointerEvents: null,
    points: null,
    pointsAtX: Z,
    pointsAtY: Z,
    pointsAtZ: Z,
    preserveAlpha: null,
    preserveAspectRatio: null,
    primitiveUnits: null,
    propagate: null,
    property: ut,
    r: null,
    radius: null,
    referrerPolicy: null,
    refX: null,
    refY: null,
    rel: ut,
    rev: ut,
    renderingIntent: null,
    repeatCount: null,
    repeatDur: null,
    requiredExtensions: ut,
    requiredFeatures: ut,
    requiredFonts: ut,
    requiredFormats: ut,
    resource: null,
    restart: null,
    result: null,
    rotate: null,
    rx: null,
    ry: null,
    scale: null,
    seed: null,
    shapeRendering: null,
    side: null,
    slope: null,
    snapshotTime: null,
    specularConstant: Z,
    specularExponent: Z,
    spreadMethod: null,
    spacing: null,
    startOffset: null,
    stdDeviation: null,
    stemh: null,
    stemv: null,
    stitchTiles: null,
    stopColor: null,
    stopOpacity: null,
    strikethroughPosition: Z,
    strikethroughThickness: Z,
    string: null,
    stroke: null,
    strokeDashArray: ut,
    strokeDashOffset: null,
    strokeLineCap: null,
    strokeLineJoin: null,
    strokeMiterLimit: Z,
    strokeOpacity: Z,
    strokeWidth: null,
    style: null,
    surfaceScale: Z,
    syncBehavior: null,
    syncBehaviorDefault: null,
    syncMaster: null,
    syncTolerance: null,
    syncToleranceDefault: null,
    systemLanguage: ut,
    tabIndex: Z,
    tableValues: null,
    target: null,
    targetX: Z,
    targetY: Z,
    textAnchor: null,
    textDecoration: null,
    textRendering: null,
    textLength: null,
    timelineBegin: null,
    title: null,
    transformBehavior: null,
    type: null,
    typeOf: ut,
    to: null,
    transform: null,
    transformOrigin: null,
    u1: null,
    u2: null,
    underlinePosition: Z,
    underlineThickness: Z,
    unicode: null,
    unicodeBidi: null,
    unicodeRange: null,
    unitsPerEm: Z,
    values: null,
    vAlphabetic: Z,
    vMathematical: Z,
    vectorEffect: null,
    vHanging: Z,
    vIdeographic: Z,
    version: null,
    vertAdvY: Z,
    vertOriginX: Z,
    vertOriginY: Z,
    viewBox: null,
    viewTarget: null,
    visibility: null,
    width: null,
    widths: null,
    wordSpacing: null,
    writingMode: null,
    x: null,
    x1: null,
    x2: null,
    xChannelSelector: null,
    xHeight: Z,
    y: null,
    y1: null,
    y2: null,
    yChannelSelector: null,
    z: null,
    zoomAndPan: null
  }
}), YA = /^data[-\w.:]+$/i, Hd = /-[a-z]/g, jA = /[A-Z]/g;
function NA(n, e) {
  const t = bh(e);
  let i = e, r = Ct;
  if (t in n.normal)
    return n.property[n.normal[t]];
  if (t.length > 4 && t.slice(0, 4) === "data" && YA.test(e)) {
    if (e.charAt(4) === "-") {
      const s = e.slice(5).replace(Hd, FA);
      i = "data" + s.charAt(0).toUpperCase() + s.slice(1);
    } else {
      const s = e.slice(4);
      if (!Hd.test(s)) {
        let o = s.replace(jA, UA);
        o.charAt(0) !== "-" && (o = "-" + o), e = "data" + o;
      }
    }
    r = Qu;
  }
  return new r(i, e);
}
function UA(n) {
  return "-" + n.toLowerCase();
}
function FA(n) {
  return n.charAt(1).toUpperCase();
}
const GA = c0([p0, d0, g0, b0, BA], "html"), y0 = c0([p0, d0, g0, b0, VA], "svg"), HA = /["&'<>`]/g, KA = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, JA = (
  // eslint-disable-next-line no-control-regex, unicorn/no-hex-escape
  /[\x01-\t\v\f\x0E-\x1F\x7F\x81\x8D\x8F\x90\x9D\xA0-\uFFFF]/g
), eR = /[|\\{}()[\]^$+*?.]/g, Kd = /* @__PURE__ */ new WeakMap();
function tR(n, e) {
  if (n = n.replace(
    e.subset ? nR(e.subset) : HA,
    i
  ), e.subset || e.escapeOnly)
    return n;
  return n.replace(KA, t).replace(JA, i);
  function t(r, s, o) {
    return e.format(
      (r.charCodeAt(0) - 55296) * 1024 + r.charCodeAt(1) - 56320 + 65536,
      o.charCodeAt(s + 2),
      e
    );
  }
  function i(r, s, o) {
    return e.format(
      r.charCodeAt(0),
      o.charCodeAt(s + 1),
      e
    );
  }
}
function nR(n) {
  let e = Kd.get(n);
  return e || (e = iR(n), Kd.set(n, e)), e;
}
function iR(n) {
  const e = [];
  let t = -1;
  for (; ++t < n.length; )
    e.push(n[t].replace(eR, "\\$&"));
  return new RegExp("(?:" + e.join("|") + ")", "g");
}
const rR = /[\dA-Fa-f]/;
function sR(n, e, t) {
  const i = "&#x" + n.toString(16).toUpperCase();
  return t && e && !rR.test(String.fromCharCode(e)) ? i : i + ";";
}
const oR = /\d/;
function lR(n, e, t) {
  const i = "&#" + String(n);
  return t && e && !oR.test(String.fromCharCode(e)) ? i : i + ";";
}
const aR = [
  "AElig",
  "AMP",
  "Aacute",
  "Acirc",
  "Agrave",
  "Aring",
  "Atilde",
  "Auml",
  "COPY",
  "Ccedil",
  "ETH",
  "Eacute",
  "Ecirc",
  "Egrave",
  "Euml",
  "GT",
  "Iacute",
  "Icirc",
  "Igrave",
  "Iuml",
  "LT",
  "Ntilde",
  "Oacute",
  "Ocirc",
  "Ograve",
  "Oslash",
  "Otilde",
  "Ouml",
  "QUOT",
  "REG",
  "THORN",
  "Uacute",
  "Ucirc",
  "Ugrave",
  "Uuml",
  "Yacute",
  "aacute",
  "acirc",
  "acute",
  "aelig",
  "agrave",
  "amp",
  "aring",
  "atilde",
  "auml",
  "brvbar",
  "ccedil",
  "cedil",
  "cent",
  "copy",
  "curren",
  "deg",
  "divide",
  "eacute",
  "ecirc",
  "egrave",
  "eth",
  "euml",
  "frac12",
  "frac14",
  "frac34",
  "gt",
  "iacute",
  "icirc",
  "iexcl",
  "igrave",
  "iquest",
  "iuml",
  "laquo",
  "lt",
  "macr",
  "micro",
  "middot",
  "nbsp",
  "not",
  "ntilde",
  "oacute",
  "ocirc",
  "ograve",
  "ordf",
  "ordm",
  "oslash",
  "otilde",
  "ouml",
  "para",
  "plusmn",
  "pound",
  "quot",
  "raquo",
  "reg",
  "sect",
  "shy",
  "sup1",
  "sup2",
  "sup3",
  "szlig",
  "thorn",
  "times",
  "uacute",
  "ucirc",
  "ugrave",
  "uml",
  "uuml",
  "yacute",
  "yen",
  "yuml"
], ta = {
  nbsp: " ",
  iexcl: "¡",
  cent: "¢",
  pound: "£",
  curren: "¤",
  yen: "¥",
  brvbar: "¦",
  sect: "§",
  uml: "¨",
  copy: "©",
  ordf: "ª",
  laquo: "«",
  not: "¬",
  shy: "­",
  reg: "®",
  macr: "¯",
  deg: "°",
  plusmn: "±",
  sup2: "²",
  sup3: "³",
  acute: "´",
  micro: "µ",
  para: "¶",
  middot: "·",
  cedil: "¸",
  sup1: "¹",
  ordm: "º",
  raquo: "»",
  frac14: "¼",
  frac12: "½",
  frac34: "¾",
  iquest: "¿",
  Agrave: "À",
  Aacute: "Á",
  Acirc: "Â",
  Atilde: "Ã",
  Auml: "Ä",
  Aring: "Å",
  AElig: "Æ",
  Ccedil: "Ç",
  Egrave: "È",
  Eacute: "É",
  Ecirc: "Ê",
  Euml: "Ë",
  Igrave: "Ì",
  Iacute: "Í",
  Icirc: "Î",
  Iuml: "Ï",
  ETH: "Ð",
  Ntilde: "Ñ",
  Ograve: "Ò",
  Oacute: "Ó",
  Ocirc: "Ô",
  Otilde: "Õ",
  Ouml: "Ö",
  times: "×",
  Oslash: "Ø",
  Ugrave: "Ù",
  Uacute: "Ú",
  Ucirc: "Û",
  Uuml: "Ü",
  Yacute: "Ý",
  THORN: "Þ",
  szlig: "ß",
  agrave: "à",
  aacute: "á",
  acirc: "â",
  atilde: "ã",
  auml: "ä",
  aring: "å",
  aelig: "æ",
  ccedil: "ç",
  egrave: "è",
  eacute: "é",
  ecirc: "ê",
  euml: "ë",
  igrave: "ì",
  iacute: "í",
  icirc: "î",
  iuml: "ï",
  eth: "ð",
  ntilde: "ñ",
  ograve: "ò",
  oacute: "ó",
  ocirc: "ô",
  otilde: "õ",
  ouml: "ö",
  divide: "÷",
  oslash: "ø",
  ugrave: "ù",
  uacute: "ú",
  ucirc: "û",
  uuml: "ü",
  yacute: "ý",
  thorn: "þ",
  yuml: "ÿ",
  fnof: "ƒ",
  Alpha: "Α",
  Beta: "Β",
  Gamma: "Γ",
  Delta: "Δ",
  Epsilon: "Ε",
  Zeta: "Ζ",
  Eta: "Η",
  Theta: "Θ",
  Iota: "Ι",
  Kappa: "Κ",
  Lambda: "Λ",
  Mu: "Μ",
  Nu: "Ν",
  Xi: "Ξ",
  Omicron: "Ο",
  Pi: "Π",
  Rho: "Ρ",
  Sigma: "Σ",
  Tau: "Τ",
  Upsilon: "Υ",
  Phi: "Φ",
  Chi: "Χ",
  Psi: "Ψ",
  Omega: "Ω",
  alpha: "α",
  beta: "β",
  gamma: "γ",
  delta: "δ",
  epsilon: "ε",
  zeta: "ζ",
  eta: "η",
  theta: "θ",
  iota: "ι",
  kappa: "κ",
  lambda: "λ",
  mu: "μ",
  nu: "ν",
  xi: "ξ",
  omicron: "ο",
  pi: "π",
  rho: "ρ",
  sigmaf: "ς",
  sigma: "σ",
  tau: "τ",
  upsilon: "υ",
  phi: "φ",
  chi: "χ",
  psi: "ψ",
  omega: "ω",
  thetasym: "ϑ",
  upsih: "ϒ",
  piv: "ϖ",
  bull: "•",
  hellip: "…",
  prime: "′",
  Prime: "″",
  oline: "‾",
  frasl: "⁄",
  weierp: "℘",
  image: "ℑ",
  real: "ℜ",
  trade: "™",
  alefsym: "ℵ",
  larr: "←",
  uarr: "↑",
  rarr: "→",
  darr: "↓",
  harr: "↔",
  crarr: "↵",
  lArr: "⇐",
  uArr: "⇑",
  rArr: "⇒",
  dArr: "⇓",
  hArr: "⇔",
  forall: "∀",
  part: "∂",
  exist: "∃",
  empty: "∅",
  nabla: "∇",
  isin: "∈",
  notin: "∉",
  ni: "∋",
  prod: "∏",
  sum: "∑",
  minus: "−",
  lowast: "∗",
  radic: "√",
  prop: "∝",
  infin: "∞",
  ang: "∠",
  and: "∧",
  or: "∨",
  cap: "∩",
  cup: "∪",
  int: "∫",
  there4: "∴",
  sim: "∼",
  cong: "≅",
  asymp: "≈",
  ne: "≠",
  equiv: "≡",
  le: "≤",
  ge: "≥",
  sub: "⊂",
  sup: "⊃",
  nsub: "⊄",
  sube: "⊆",
  supe: "⊇",
  oplus: "⊕",
  otimes: "⊗",
  perp: "⊥",
  sdot: "⋅",
  lceil: "⌈",
  rceil: "⌉",
  lfloor: "⌊",
  rfloor: "⌋",
  lang: "〈",
  rang: "〉",
  loz: "◊",
  spades: "♠",
  clubs: "♣",
  hearts: "♥",
  diams: "♦",
  quot: '"',
  amp: "&",
  lt: "<",
  gt: ">",
  OElig: "Œ",
  oelig: "œ",
  Scaron: "Š",
  scaron: "š",
  Yuml: "Ÿ",
  circ: "ˆ",
  tilde: "˜",
  ensp: " ",
  emsp: " ",
  thinsp: " ",
  zwnj: "‌",
  zwj: "‍",
  lrm: "‎",
  rlm: "‏",
  ndash: "–",
  mdash: "—",
  lsquo: "‘",
  rsquo: "’",
  sbquo: "‚",
  ldquo: "“",
  rdquo: "”",
  bdquo: "„",
  dagger: "†",
  Dagger: "‡",
  permil: "‰",
  lsaquo: "‹",
  rsaquo: "›",
  euro: "€"
}, hR = [
  "cent",
  "copy",
  "divide",
  "gt",
  "lt",
  "not",
  "para",
  "times"
], k0 = {}.hasOwnProperty, kh = {};
let Zs;
for (Zs in ta)
  k0.call(ta, Zs) && (kh[ta[Zs]] = Zs);
const uR = /[^\dA-Za-z]/;
function cR(n, e, t, i) {
  const r = String.fromCharCode(n);
  if (k0.call(kh, r)) {
    const s = kh[r], o = "&" + s;
    return t && aR.includes(s) && !hR.includes(s) && (!i || e && e !== 61 && uR.test(String.fromCharCode(e))) ? o : o + ";";
  }
  return "";
}
function fR(n, e, t) {
  let i = sR(n, e, t.omitOptionalSemicolons), r;
  if ((t.useNamedReferences || t.useShortestReferences) && (r = cR(
    n,
    e,
    t.omitOptionalSemicolons,
    t.attribute
  )), (t.useShortestReferences || !r) && t.useShortestReferences) {
    const s = lR(n, e, t.omitOptionalSemicolons);
    s.length < i.length && (i = s);
  }
  return r && (!t.useShortestReferences || r.length < i.length) ? r : i;
}
function xi(n, e) {
  return tR(n, Object.assign({ format: fR }, e));
}
const dR = /^>|^->|<!--|-->|--!>|<!-$/g, pR = [">"], mR = ["<", ">"];
function OR(n, e, t, i) {
  return i.settings.bogusComments ? "<?" + xi(
    n.value,
    Object.assign({}, i.settings.characterReferences, {
      subset: pR
    })
  ) + ">" : "<!--" + n.value.replace(dR, r) + "-->";
  function r(s) {
    return xi(
      s,
      Object.assign({}, i.settings.characterReferences, {
        subset: mR
      })
    );
  }
}
function gR(n, e, t, i) {
  return "<!" + (i.settings.upperDoctype ? "DOCTYPE" : "doctype") + (i.settings.tightDoctype ? "" : " ") + "html>";
}
function bR(n, e) {
  const t = e || {};
  return (n[n.length - 1] === "" ? [...n, ""] : n).join(
    (t.padRight ? " " : "") + "," + (t.padLeft === !1 ? "" : " ")
  ).trim();
}
function yR(n) {
  return n.join(" ").trim();
}
const kR = /[ \t\n\f\r]/g;
function $u(n) {
  return typeof n == "object" ? n.type === "text" ? Jd(n.value) : !1 : Jd(n);
}
function Jd(n) {
  return n.replace(kR, "") === "";
}
const Xe = w0(1), x0 = w0(-1), xR = [];
function w0(n) {
  return e;
  function e(t, i, r) {
    const s = t ? t.children : xR;
    let o = (i || 0) + n, l = s[o];
    if (!r)
      for (; l && $u(l); )
        o += n, l = s[o];
    return l;
  }
}
const wR = {}.hasOwnProperty;
function S0(n) {
  return e;
  function e(t, i, r) {
    return wR.call(n, t.tagName) && n[t.tagName](t, i, r);
  }
}
const Cu = S0({
  body: vR,
  caption: na,
  colgroup: na,
  dd: CR,
  dt: $R,
  head: na,
  html: SR,
  li: QR,
  optgroup: TR,
  option: AR,
  p: PR,
  rp: ep,
  rt: ep,
  tbody: ZR,
  td: tp,
  tfoot: MR,
  th: tp,
  thead: RR,
  tr: ER
});
function na(n, e, t) {
  const i = Xe(t, e, !0);
  return !i || i.type !== "comment" && !(i.type === "text" && $u(i.value.charAt(0)));
}
function SR(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type !== "comment";
}
function vR(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type !== "comment";
}
function PR(n, e, t) {
  const i = Xe(t, e);
  return i ? i.type === "element" && (i.tagName === "address" || i.tagName === "article" || i.tagName === "aside" || i.tagName === "blockquote" || i.tagName === "details" || i.tagName === "div" || i.tagName === "dl" || i.tagName === "fieldset" || i.tagName === "figcaption" || i.tagName === "figure" || i.tagName === "footer" || i.tagName === "form" || i.tagName === "h1" || i.tagName === "h2" || i.tagName === "h3" || i.tagName === "h4" || i.tagName === "h5" || i.tagName === "h6" || i.tagName === "header" || i.tagName === "hgroup" || i.tagName === "hr" || i.tagName === "main" || i.tagName === "menu" || i.tagName === "nav" || i.tagName === "ol" || i.tagName === "p" || i.tagName === "pre" || i.tagName === "section" || i.tagName === "table" || i.tagName === "ul") : !t || // Confusing parent.
  !(t.type === "element" && (t.tagName === "a" || t.tagName === "audio" || t.tagName === "del" || t.tagName === "ins" || t.tagName === "map" || t.tagName === "noscript" || t.tagName === "video"));
}
function QR(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && i.tagName === "li";
}
function $R(n, e, t) {
  const i = Xe(t, e);
  return !!(i && i.type === "element" && (i.tagName === "dt" || i.tagName === "dd"));
}
function CR(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && (i.tagName === "dt" || i.tagName === "dd");
}
function ep(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && (i.tagName === "rp" || i.tagName === "rt");
}
function TR(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && i.tagName === "optgroup";
}
function AR(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && (i.tagName === "option" || i.tagName === "optgroup");
}
function RR(n, e, t) {
  const i = Xe(t, e);
  return !!(i && i.type === "element" && (i.tagName === "tbody" || i.tagName === "tfoot"));
}
function ZR(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && (i.tagName === "tbody" || i.tagName === "tfoot");
}
function MR(n, e, t) {
  return !Xe(t, e);
}
function ER(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && i.tagName === "tr";
}
function tp(n, e, t) {
  const i = Xe(t, e);
  return !i || i.type === "element" && (i.tagName === "td" || i.tagName === "th");
}
const zR = S0({
  body: LR,
  colgroup: IR,
  head: DR,
  html: XR,
  tbody: _R
});
function XR(n) {
  const e = Xe(n, -1);
  return !e || e.type !== "comment";
}
function DR(n) {
  const e = n.children, t = [];
  let i = -1;
  for (; ++i < e.length; ) {
    const r = e[i];
    if (r.type === "element" && (r.tagName === "title" || r.tagName === "base")) {
      if (t.includes(r.tagName))
        return !1;
      t.push(r.tagName);
    }
  }
  return e.length > 0;
}
function LR(n) {
  const e = Xe(n, -1, !0);
  return !e || e.type !== "comment" && !(e.type === "text" && $u(e.value.charAt(0))) && !(e.type === "element" && (e.tagName === "meta" || e.tagName === "link" || e.tagName === "script" || e.tagName === "style" || e.tagName === "template"));
}
function IR(n, e, t) {
  const i = x0(t, e), r = Xe(n, -1, !0);
  return t && i && i.type === "element" && i.tagName === "colgroup" && Cu(i, t.children.indexOf(i), t) ? !1 : !!(r && r.type === "element" && r.tagName === "col");
}
function _R(n, e, t) {
  const i = x0(t, e), r = Xe(n, -1);
  return t && i && i.type === "element" && (i.tagName === "thead" || i.tagName === "tbody") && Cu(i, t.children.indexOf(i), t) ? !1 : !!(r && r.type === "element" && r.tagName === "tr");
}
const Ms = {
  // See: <https://html.spec.whatwg.org/#attribute-name-state>.
  name: [
    [`	
\f\r &/=>`.split(""), `	
\f\r "&'/=>\``.split("")],
    [`\0	
\f\r "&'/<=>`.split(""), `\0	
\f\r "&'/<=>\``.split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(unquoted)-state>.
  unquoted: [
    [`	
\f\r &>`.split(""), `\0	
\f\r "&'<=>\``.split("")],
    [`\0	
\f\r "&'<=>\``.split(""), `\0	
\f\r "&'<=>\``.split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(single-quoted)-state>.
  single: [
    ["&'".split(""), "\"&'`".split("")],
    ["\0&'".split(""), "\0\"&'`".split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(double-quoted)-state>.
  double: [
    ['"&'.split(""), "\"&'`".split("")],
    ['\0"&'.split(""), "\0\"&'`".split("")]
  ]
};
function qR(n, e, t, i) {
  const r = i.schema, s = r.space === "svg" ? !1 : i.settings.omitOptionalTags;
  let o = r.space === "svg" ? i.settings.closeEmptyElements : i.settings.voids.includes(n.tagName.toLowerCase());
  const l = [];
  let a;
  r.space === "html" && n.tagName === "svg" && (i.schema = y0);
  const h = WR(i, n.properties), u = i.all(
    r.space === "html" && n.tagName === "template" ? n.content : n
  );
  return i.schema = r, u && (o = !1), (h || !s || !zR(n, e, t)) && (l.push("<", n.tagName, h ? " " + h : ""), o && (r.space === "svg" || i.settings.closeSelfClosing) && (a = h.charAt(h.length - 1), (!i.settings.tightSelfClosing || a === "/" || a && a !== '"' && a !== "'") && l.push(" "), l.push("/")), l.push(">")), l.push(u), !o && (!s || !Cu(n, e, t)) && l.push("</" + n.tagName + ">"), l.join("");
}
function WR(n, e) {
  const t = [];
  let i = -1, r;
  if (e) {
    for (r in e)
      if (e[r] !== null && e[r] !== void 0) {
        const s = BR(n, r, e[r]);
        s && t.push(s);
      }
  }
  for (; ++i < t.length; ) {
    const s = n.settings.tightAttributes ? t[i].charAt(t[i].length - 1) : void 0;
    i !== t.length - 1 && s !== '"' && s !== "'" && (t[i] += " ");
  }
  return t.join("");
}
function BR(n, e, t) {
  const i = NA(n.schema, e), r = n.settings.allowParseErrors && n.schema.space === "html" ? 0 : 1, s = n.settings.allowDangerousCharacters ? 0 : 1;
  let o = n.quote, l;
  if (i.overloadedBoolean && (t === i.attribute || t === "") ? t = !0 : (i.boolean || i.overloadedBoolean && typeof t != "string") && (t = !!t), t == null || t === !1 || typeof t == "number" && Number.isNaN(t))
    return "";
  const a = xi(
    i.attribute,
    Object.assign({}, n.settings.characterReferences, {
      // Always encode without parse errors in non-HTML.
      subset: Ms.name[r][s]
    })
  );
  return t === !0 || (t = Array.isArray(t) ? (i.commaSeparated ? bR : yR)(t, {
    padLeft: !n.settings.tightCommaSeparatedLists
  }) : String(t), n.settings.collapseEmptyAttributes && !t) ? a : (n.settings.preferUnquoted && (l = xi(
    t,
    Object.assign({}, n.settings.characterReferences, {
      attribute: !0,
      subset: Ms.unquoted[r][s]
    })
  )), l !== t && (n.settings.quoteSmart && xo(t, o) > xo(t, n.alternative) && (o = n.alternative), l = o + xi(
    t,
    Object.assign({}, n.settings.characterReferences, {
      // Always encode without parse errors in non-HTML.
      subset: (o === "'" ? Ms.single : Ms.double)[r][s],
      attribute: !0
    })
  ) + o), a + (l && "=" + l));
}
const VR = ["<", "&"];
function v0(n, e, t, i) {
  return t && t.type === "element" && (t.tagName === "script" || t.tagName === "style") ? n.value : xi(
    n.value,
    Object.assign({}, i.settings.characterReferences, {
      subset: VR
    })
  );
}
function YR(n, e, t, i) {
  return i.settings.allowDangerousHtml ? n.value : v0(n, e, t, i);
}
function jR(n, e, t, i) {
  return i.all(n);
}
const NR = Nv("type", {
  invalid: UR,
  unknown: FR,
  handlers: { comment: OR, doctype: gR, element: qR, raw: YR, root: jR, text: v0 }
});
function UR(n) {
  throw new Error("Expected node, not `" + n + "`");
}
function FR(n) {
  const e = (
    /** @type {Nodes} */
    n
  );
  throw new Error("Cannot compile unknown node `" + e.type + "`");
}
const GR = {}, HR = {}, KR = [];
function JR(n, e) {
  const t = e || GR, i = t.quote || '"', r = i === '"' ? "'" : '"';
  if (i !== '"' && i !== "'")
    throw new Error("Invalid quote `" + i + "`, expected `'` or `\"`");
  return {
    one: eZ,
    all: tZ,
    settings: {
      omitOptionalTags: t.omitOptionalTags || !1,
      allowParseErrors: t.allowParseErrors || !1,
      allowDangerousCharacters: t.allowDangerousCharacters || !1,
      quoteSmart: t.quoteSmart || !1,
      preferUnquoted: t.preferUnquoted || !1,
      tightAttributes: t.tightAttributes || !1,
      upperDoctype: t.upperDoctype || !1,
      tightDoctype: t.tightDoctype || !1,
      bogusComments: t.bogusComments || !1,
      tightCommaSeparatedLists: t.tightCommaSeparatedLists || !1,
      tightSelfClosing: t.tightSelfClosing || !1,
      collapseEmptyAttributes: t.collapseEmptyAttributes || !1,
      allowDangerousHtml: t.allowDangerousHtml || !1,
      voids: t.voids || _A,
      characterReferences: t.characterReferences || HR,
      closeSelfClosing: t.closeSelfClosing || !1,
      closeEmptyElements: t.closeEmptyElements || !1
    },
    schema: t.space === "svg" ? y0 : GA,
    quote: i,
    alternative: r
  }.one(
    Array.isArray(n) ? { type: "root", children: n } : n,
    void 0,
    void 0
  );
}
function eZ(n, e, t) {
  return NR(n, e, t, this);
}
function tZ(n) {
  const e = [], t = n && n.children || KR;
  let i = -1;
  for (; ++i < t.length; )
    e[i] = this.one(t[i], i, n);
  return e.join("");
}
function nZ(n) {
  const e = this, t = { ...e.data("settings"), ...n };
  e.compiler = i;
  function i(r) {
    return JR(r, t);
  }
}
var iZ = typeof global == "object" && global && global.Object === Object && global, rZ = typeof self == "object" && self && self.Object === Object && self, P0 = iZ || rZ || Function("return this")(), Eo = P0.Symbol, Q0 = Object.prototype, sZ = Q0.hasOwnProperty, oZ = Q0.toString, rr = Eo ? Eo.toStringTag : void 0;
function lZ(n) {
  var e = sZ.call(n, rr), t = n[rr];
  try {
    n[rr] = void 0;
    var i = !0;
  } catch {
  }
  var r = oZ.call(n);
  return i && (e ? n[rr] = t : delete n[rr]), r;
}
var aZ = Object.prototype, hZ = aZ.toString;
function uZ(n) {
  return hZ.call(n);
}
var cZ = "[object Null]", fZ = "[object Undefined]", np = Eo ? Eo.toStringTag : void 0;
function dZ(n) {
  return n == null ? n === void 0 ? fZ : cZ : np && np in Object(n) ? lZ(n) : uZ(n);
}
function pZ(n) {
  return n != null && typeof n == "object";
}
var mZ = "[object Symbol]";
function OZ(n) {
  return typeof n == "symbol" || pZ(n) && dZ(n) == mZ;
}
var gZ = /\s/;
function bZ(n) {
  for (var e = n.length; e-- && gZ.test(n.charAt(e)); )
    ;
  return e;
}
var yZ = /^\s+/;
function kZ(n) {
  return n && n.slice(0, bZ(n) + 1).replace(yZ, "");
}
function zo(n) {
  var e = typeof n;
  return n != null && (e == "object" || e == "function");
}
var ip = NaN, xZ = /^[-+]0x[0-9a-f]+$/i, wZ = /^0b[01]+$/i, SZ = /^0o[0-7]+$/i, vZ = parseInt;
function rp(n) {
  if (typeof n == "number")
    return n;
  if (OZ(n))
    return ip;
  if (zo(n)) {
    var e = typeof n.valueOf == "function" ? n.valueOf() : n;
    n = zo(e) ? e + "" : e;
  }
  if (typeof n != "string")
    return n === 0 ? n : +n;
  n = kZ(n);
  var t = wZ.test(n);
  return t || SZ.test(n) ? vZ(n.slice(2), t ? 2 : 8) : xZ.test(n) ? ip : +n;
}
var ia = function() {
  return P0.Date.now();
}, PZ = "Expected a function", QZ = Math.max, $Z = Math.min;
function $0(n, e, t) {
  var i, r, s, o, l, a, h = 0, u = !1, c = !1, f = !0;
  if (typeof n != "function")
    throw new TypeError(PZ);
  e = rp(e) || 0, zo(t) && (u = !!t.leading, c = "maxWait" in t, s = c ? QZ(rp(t.maxWait) || 0, e) : s, f = "trailing" in t ? !!t.trailing : f);
  function d(w) {
    var C = i, L = r;
    return i = r = void 0, h = w, o = n.apply(L, C), o;
  }
  function p(w) {
    return h = w, l = setTimeout(g, e), u ? d(w) : o;
  }
  function m(w) {
    var C = w - a, L = w - h, q = e - C;
    return c ? $Z(q, s - L) : q;
  }
  function O(w) {
    var C = w - a, L = w - h;
    return a === void 0 || C >= e || C < 0 || c && L >= s;
  }
  function g() {
    var w = ia();
    if (O(w))
      return b(w);
    l = setTimeout(g, m(w));
  }
  function b(w) {
    return l = void 0, f && i ? d(w) : (i = r = void 0, o);
  }
  function S() {
    l !== void 0 && clearTimeout(l), h = 0, i = a = r = l = void 0;
  }
  function Q() {
    return l === void 0 ? o : b(ia());
  }
  function P() {
    var w = ia(), C = O(w);
    if (i = arguments, r = this, a = w, C) {
      if (l === void 0)
        return p(a);
      if (c)
        return clearTimeout(l), l = setTimeout(g, e), d(a);
    }
    return l === void 0 && (l = setTimeout(g, e)), o;
  }
  return P.cancel = S, P.flush = Q, P;
}
var CZ = "Expected a function";
function TZ(n, e, t) {
  var i = !0, r = !0;
  if (typeof n != "function")
    throw new TypeError(CZ);
  return zo(t) && (i = "leading" in t ? !!t.leading : i, r = "trailing" in t ? !!t.trailing : r), $0(n, e, {
    leading: i,
    maxWait: e,
    trailing: r
  });
}
const AZ = ["innerHTML"], RZ = /* @__PURE__ */ Pt({
  __name: "MViewer",
  props: /* @__PURE__ */ Gs({
    plugins: { default: ku },
    interval: { default: 0 }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: /* @__PURE__ */ Gs(["update"], ["update:modelValue"]),
  setup(n, { emit: e }) {
    const t = n, i = wh(n, "modelValue"), r = Se(null), s = Se(null), o = Se(""), l = e, a = function() {
      return (d) => {
        s.value = d;
      };
    };
    function h() {
      const d = b4();
      if (d.use(K4), t.plugins.remark)
        for (const p of t.plugins.remark)
          Array.isArray(p) ? d.use(p[0], p[1]) : d.use(p);
      if (d.use(IA, t.plugins.remarkRehypeOptions), t.plugins.rehype)
        for (const p of t.plugins.rehype)
          Array.isArray(p) ? d.use(p[0], p[1]) : d.use(p);
      return d.use(a), d.use(nZ), d.freeze(), d;
    }
    const u = h();
    async function c(d) {
      return u.process(d);
    }
    const f = TZ(() => {
      try {
        c(i.value).then((d) => {
          o.value = d.toString(), _0().then(() => {
            l("update", s.value, r.value);
          });
        });
      } catch (d) {
        console.log(d);
      }
    }, t.interval);
    return mt(i, () => {
      f();
    }), xh(() => {
      f();
    }), (d, p) => (fe(), Ae("div", {
      class: "markdown",
      innerHTML: o.value,
      ref_key: "real",
      ref: r
    }, null, 8, AZ));
  }
}), ZZ = { class: "cs-toolbar" }, MZ = { class: "cs-toolbar-group" }, EZ = ["onClick"], zZ = ["innerHTML"], XZ = { class: "cs-tooltip" }, DZ = { class: "cs-toolbar-group" }, LZ = ["onClick"], IZ = ["innerHTML"], _Z = { class: "cs-tooltip" }, qZ = /* @__PURE__ */ Pt({
  __name: "MToolbar",
  props: {
    toolbarl: {},
    toolbarr: {},
    getCodemirror: { type: Function },
    getCasketstar: { type: Function },
    dialog: {}
  },
  setup(n) {
    const e = op("i18n"), t = n;
    function i(r) {
      const s = t.getCodemirror(), o = t.getCasketstar();
      s && o && r.func(s, o, t.dialog);
    }
    return (r, s) => (fe(), Ae("div", ZZ, [
      D("div", null, [
        (fe(!0), Ae(Bn, null, Vn(t.toolbarl, (o) => (fe(), Ae("span", MZ, [
          (fe(!0), Ae(Bn, null, Vn(o, (l) => (fe(), Ae("span", {
            class: "cs-toolbar-tool",
            onClick: (a) => i(l)
          }, [
            D("span", {
              class: "cs-toolbar-tool-button",
              innerHTML: l.icon
            }, null, 8, zZ),
            D("span", XZ, wi(xr(e)(l.name)), 1)
          ], 8, EZ))), 256))
        ]))), 256))
      ]),
      D("div", null, [
        (fe(!0), Ae(Bn, null, Vn(t.toolbarr, (o) => (fe(), Ae("span", DZ, [
          (fe(!0), Ae(Bn, null, Vn(o, (l) => (fe(), Ae("span", {
            class: "cs-toolbar-tool",
            onClick: (a) => i(l)
          }, [
            D("span", {
              class: "cs-toolbar-tool-button",
              innerHTML: l.icon
            }, null, 8, IZ),
            D("span", _Z, wi(xr(e)(l.name)), 1)
          ], 8, LZ))), 256))
        ]))), 256))
      ])
    ]));
  }
}), WZ = "水平线", BZ = "粗体", VZ = "斜体", YZ = "删除线", jZ = "链接", NZ = "图片", UZ = "代码", FZ = "表格", GZ = "块体", HZ = "引用", KZ = "帮助", JZ = {
  "increase-level": "提升一级",
  "decrease-level": "降低一级",
  horizontal: WZ,
  bold: BZ,
  italic: VZ,
  strikethrough: YZ,
  link: jZ,
  picture: NZ,
  code: UZ,
  table: FZ,
  block: GZ,
  quote: HZ,
  "unordered-list": "无序列表",
  "ordered-list": "有序列表",
  "task-list": "任务列表",
  "only-editor": "仅编辑",
  "only-viewer": "仅预览",
  "full-screen": "全屏",
  help: KZ
}, eM = "horizontal", tM = "bold", nM = "italic", iM = "strikethrough", rM = "link", sM = "picture", oM = "code", lM = "table", aM = "block", hM = "quote", uM = "help", sp = {
  "increase-level": "increase level",
  "decrease-level": "decrease level",
  horizontal: eM,
  bold: tM,
  italic: nM,
  strikethrough: iM,
  link: rM,
  picture: sM,
  code: oM,
  table: lM,
  block: aM,
  quote: hM,
  "unordered-list": "unordered list",
  "ordered-list": "ordered list",
  "task-list": "task list",
  "only-editor": "only editor",
  "only-viewer": "only viewer",
  "full-screen": "full screen",
  help: uM
};
function ra(n) {
  return (e) => n[e] || e;
}
function cM(n) {
  switch (n.toLowerCase()) {
    case "zh_cn":
      return ra(JZ);
    case "en_us":
      return ra(sp);
    default:
      return ra(sp);
  }
}
const fM = { class: "cs-header" }, dM = { class: "cs-content" }, pM = { class: "cs-footer" }, mM = { class: "cs-footer-left" }, OM = { class: "cs-footer-right" }, PM = /* @__PURE__ */ Pt({
  __name: "CasketStar",
  props: /* @__PURE__ */ Gs({
    plugins: { default: () => ku() },
    toolbarl: { default: () => HT() },
    toolbarr: { default: () => KT() },
    lang: { default: "en_US" }
  }, {
    modelValue: { required: !0 },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const e = Se(0);
    let t;
    const i = Se({
      showEditor: !0,
      showViewer: !0,
      fullScreen: !1
    });
    mt(i.value, () => {
      S();
    });
    const r = n, s = wh(n, "modelValue"), o = cM(r.lang);
    q0("i18n", o);
    function l(A) {
      t = A.view, c.value = t.scrollDOM, c.value.onscroll = L;
    }
    let a = [], h = [];
    const u = Se(!0), c = Se(null), f = Se(null), d = Se(null);
    let p = null, m = null;
    function O() {
      return c.value ? c.value.scrollHeight - c.value.getBoundingClientRect().height : 0;
    }
    function g() {
      return f.value ? f.value.scrollHeight - f.value.getBoundingClientRect().height : 0;
    }
    function b() {
      var W;
      if (!t || !c.value || !f.value || !u.value || !p || !m)
        return;
      a = [0], h = [0];
      for (const _ of p.children)
        ((W = _.position) == null ? void 0 : W.start.offset) !== void 0 && a.push(_.position.start.offset);
      const A = f.value.scrollTop - f.value.getBoundingClientRect().top;
      let E = 0;
      for (const [_, G] of Object.entries(m.children))
        if (!G.classList.contains("katex-display")) {
          const { top: U, bottom: se } = G.getBoundingClientRect();
          h.push(U + A), E = se + A;
        }
      a.push(t.state.doc.length), h.push(E);
    }
    const S = $0(b, 200);
    function Q(A, E) {
      p = A, m = E, S();
    }
    function P() {
      return t;
    }
    function w() {
      return i.value;
    }
    let C = "editor";
    function L(A) {
      var _, G;
      if (C !== "editor" || !t || !u.value)
        return;
      const E = A.target.scrollTop, W = t.lineBlockAtHeight(E).from;
      if (E + 1 >= O()) {
        (_ = f.value) == null || _.scrollTo({ top: g() + 10 });
        return;
      }
      for (let U = 0; U + 1 < a.length; U++) {
        const se = a[U], ce = a[U + 1], y = t.lineBlockAt(se).top, he = t.lineBlockAt(ce).top;
        if (se <= W && W < ce) {
          const ke = (E - y) / (he - y), x = h[U] + ke * (h[U + 1] - h[U]);
          (G = f.value) == null || G.scrollTo({ top: x });
          return;
        }
      }
    }
    function q(A) {
      var W, _;
      if (C !== "viewer" || !t || !u.value)
        return;
      const E = A.target.scrollTop;
      if (E + 1 >= g()) {
        (W = c.value) == null || W.scrollTo({ top: O() + 10 });
        return;
      }
      for (let G = 0; G + 1 < a.length; G++) {
        const U = h[G], se = h[G + 1], ce = (E - U) / (se - U);
        if (U <= E && E < se) {
          const y = a[G], he = a[G + 1], ke = t.lineBlockAt(y).top, x = t.lineBlockAt(he).top, $e = ce * (x - ke);
          (_ = c.value) == null || _.scrollTo({ top: ke + $e });
          return;
        }
      }
    }
    function v() {
      u.value ? u.value = !1 : (u.value = !0, S());
    }
    function R() {
      c.value && c.value.scrollTo({ top: 0 }), f.value && f.value.scrollTo({ top: 0 });
    }
    return xh(() => {
      addEventListener("resize", S);
    }), W0(() => {
      t == null || t.dispatch();
    }), (A, E) => {
      var W;
      return fe(), Ae("div", {
        class: Es(["casket cs-main", { "cs-full-screen": i.value.fullScreen }])
      }, [
        D("div", fM, [
          Sn(qZ, {
            toolbarl: r.toolbarl,
            toolbarr: r.toolbarr,
            "get-codemirror": P,
            "get-casketstar": w,
            dialog: d.value
          }, null, 8, ["toolbarl", "toolbarr", "dialog"])
        ]),
        D("div", dM, [
          i.value.showEditor ? (fe(), Ae("div", {
            key: 0,
            class: Es(["cs-editor", {
              "cs-midline": i.value.showViewer,
              "cs-zone-half": i.value.showViewer,
              "cs-zone-full": !i.value.showViewer
            }]),
            onMouseover: E[1] || (E[1] = (_) => Eu(C) ? C.value = "editor" : C = "editor")
          }, [
            Sn(JT, {
              modelValue: s.value,
              "onUpdate:modelValue": E[0] || (E[0] = (_) => s.value = _),
              plugins: A.plugins,
              onReady: l
            }, null, 8, ["modelValue", "plugins"])
          ], 34)) : zu("", !0),
          i.value.showViewer ? (fe(), Ae("div", {
            key: 1,
            class: Es(["cs-viewer", {
              "cs-zone-half": i.value.showEditor,
              "cs-zone-full": !i.value.showEditor
            }]),
            ref_key: "viewer",
            ref: f,
            onScroll: q,
            onMouseover: E[3] || (E[3] = (_) => Eu(C) ? C.value = "viewer" : C = "viewer")
          }, [
            Sn(RZ, {
              modelValue: s.value,
              "onUpdate:modelValue": E[2] || (E[2] = (_) => s.value = _),
              plugins: A.plugins,
              onUpdate: Q,
              interval: e.value
            }, null, 8, ["modelValue", "plugins", "interval"])
          ], 34)) : zu("", !0)
        ]),
        D("div", pM, [
          D("div", mM, " 字数统计：" + wi(((W = P()) == null ? void 0 : W.state.doc.length) || 0) + " 字符 ", 1),
          D("div", OM, [
            D("span", {
              class: "cs-footer-button",
              onClick: v
            }, wi(u.value ? "禁用滚动" : "启用滚动"), 1),
            D("span", {
              class: "cs-footer-button",
              onClick: R
            }, "回到顶部")
          ])
        ]),
        (fe(), ei(B0, { to: "body" }, [
          D("div", {
            class: "casket",
            ref_key: "dialog",
            ref: d
          }, null, 512)
        ]))
      ], 2);
    };
  }
});
export {
  JT as CasketEditor,
  PM as CasketStar,
  RZ as CasketViewer,
  ra as I18nBuilder,
  Jo as MDialog,
  aC as MDialogExtra,
  AT as ToolBold,
  zT as ToolCode,
  CT as ToolDecrease,
  BT as ToolFullScreen,
  UT as ToolGroupBlock,
  FT as ToolGroupCasket,
  GT as ToolGroupHelp,
  jT as ToolGroupInline,
  NT as ToolGroupInterline,
  YT as ToolGroupTitle,
  VT as ToolHelp,
  TT as ToolHorizontal,
  $T as ToolIncrease,
  RT as ToolItalic,
  MT as ToolLink,
  IT as ToolOList,
  qT as ToolOnlyEdit,
  WT as ToolOnlyView,
  ET as ToolPicture,
  DT as ToolQuote,
  ZT as ToolStrikethrough,
  XT as ToolTable,
  _T as ToolTaskList,
  LT as ToolUList,
  mT as commonmarkLanguage,
  Ze as defaultIcons,
  ku as getDefaultPlugins,
  HT as getDefaultToolbarL,
  KT as getDefaultToolbarR,
  cM as getI18n,
  ST as markdown,
  bu as markdownLanguage,
  QT as remarkNoHtml
};
